// Object Viewer Qt GUI Editor plugin <http://dev.ryzom.com/projects/ryzom/>
// Copyright (C) 2010  Winch Gate Property Limited
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as
// published by the Free Software Foundation, either version 3 of the
// License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
//
// You should have received a copy of the GNU Affero General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.


#ifndef PRJ_F_SERIALIZER
#define PRJ_F_SERIALIZER

#include "project_files.h"
#include <fstream>

namespace GUIEditor
{
	class CProjectFileSerializer
	{
	public:
		CProjectFileSerializer(){}
		~CProjectFileSerializer(){}

		void setFile( const std::string &name ){ fileName = name; }
		bool serialize( const SProjectFiles &project );

	private:
		bool serializeHeader( const SProjectFiles &project );
		bool serializeGUIFiles( const SProjectFiles &project );
		bool serializeMapFiles( const SProjectFiles &project );

		std::string fileName;
		std::ofstream out;
	};
}

#endif
