// Ryzom - MMORPG Framework <http://dev.ryzom.com/projects/ryzom/>
// Copyright (C) 2010  Winch Gate Property Limited
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as
// published by the Free Software Foundation, either version 3 of the
// License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
//
// You should have received a copy of the GNU Affero General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.



#ifndef RY_MP_CATEGORY_H
#define RY_MP_CATEGORY_H

#include "nel/misc/types_nl.h"

namespace MP_CATEGORY
{
	enum TMPCategory
	{
		Exotic = 0,
		Faber,
		Upgrade,

		NbCategories,

		Undefined = NbCategories,
	};


	/**
	 * get the right mp category from the input string
	 * \param str the input string
	 * \return the TMPCategory associated to this string (UNDEFINED if the string cannot be interpreted)
	 */
	TMPCategory stringToMPCategory(const std::string &str);

	/**
	 * get the TMPCategory type as a string
	 * \param cat the TMPCategory cat
	 * \return the string associated to this TMPCategory
	 */
	const std::string & mpCategoryToString(TMPCategory cat);

} // MP_CATEGORY

#endif // RY_MP_CATEGORY_H
/* End of mp_category.h */
