// Ryzom - MMORPG Framework <http://dev.ryzom.com/projects/ryzom/>
// Copyright (C) 2010  Winch Gate Property Limited
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as
// published by the Free Software Foundation, either version 3 of the
// License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
//
// You should have received a copy of the GNU Affero General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.



#ifndef	RY_RANGE_WEAPON_TYPE_H
#define RY_RANGE_WEAPON_TYPE_H

namespace RANGE_WEAPON_TYPE
{


enum TRangeWeaponType
{
	Generic = 0,
	Gatlin,
	Missile,
	RangeWeaponTypeCount,
	Unknown = RangeWeaponTypeCount
};


/**
  * get the right range weapon type from the input string
  * \param str the input string
  * \return the TRangeWeaponType associated to this string (UNKNOWN if the string cannot be interpreted)
  */
TRangeWeaponType stringToRangeWeaponType(const std::string &str);

std::string toString(TRangeWeaponType type);



} // RANGE_WEAPON_TYPE


#endif
