
-- tmp for nico's tests
local function formatLevel(level)
	local result = tostring(level)
	while string.len(result) ~= 3 do
		result = "0" .. result
	end
	return result		
end

local function formatSelectionTextName(level, ecosystem)
	return "palette.selection_test.level_" .. formatLevel(level) .. "_" .. tostring(ecosystem)
end

local levelStep = 10
local ecosystemTable = { "", "Desert", "Forest", "Jungle", "Lacustre", "PrimeRoots", "Goo" }

r2.loadPalette = function()
	local entries = {}

--	 test entries  for levels & ecosystems
	if r2.Config.TestPaletteSelection then
		for ecosystem = 1, 4 do
			for level = 1,250, levelStep do
				local npc = 
				{
					Name="Npc",
					Equipment="",
					IsStuck=0,
					SheetClient="fyros_race_stats",
					Level=level,
					Ecosystem = ecosystemTable[ecosystem],
					AiMovement="stand_on_start_point",
					Profile="no_change",
					Angle=0,
					Position={x=0, y=0, z=0}
				}
				r2.addPaletteElement(formatSelectionTextName(level, ecosystem), npc)
			end
		end
	end

--	 base class
	entries.npc = 
	{
		Name="",
		Equipment="",
		SheetClient="undef",
		Level=1,
		AiMovement="stand_on_start_point",
--		AiActivity="guard", user Profile instead
		IsStuck=0,
		IsBotObject = 0,
		IsNamed=0,
		IsNpc = 1, -- Bandit, Cuthroat, Guard, Civil
		Category="Npc",

		GabaritHeight = 0,
		GabaritTorsoWidth = 0,
		GabaritArmsWidth = 0,
		GabaritLegsWidth = 0,
		GabaritBreastSize = 0,

		HairType = 0,
		HairColor = 0,
		Tattoo = 0,
		EyesColor = 0,

		MorphTarget1 = 0,
		MorphTarget2 = 0,
		MorphTarget3 = 0,
		MorphTarget4 = 0,
		MorphTarget5 = 0,
		MorphTarget6 = 0,
		MorphTarget7 = 0,
		MorphTarget8 = 0,

		Sex = 0,
		JacketModel = 0,
		TrouserModel = 0,
		FeetModel = 0,
		HandsModel = 0,
		ArmModel = 0,
		WeaponRightHand = 0,
		WeaponLeftHand = 0,

		JacketColor = 0,
		ArmColor = 0,
		HandsColor = 0,
		TrouserColor = 0,
		FeetColor =0, 

		Function = "",
		Level = 1,
		Profile = "civil",		
		Speed = "walk",
		Aggro = 15,
		PlayerAttackable = 1,
		BotAttackable = 1,
		AutoSpawn = 1,
		RingAccess = "a1",
		BoxSelection=0,
--		Angle=0,
--		Position={x=0, y=0, z=0},
	}

	r2.addPaletteElement("palette.entities.npc", entries.npc) 


-- creature types

	entries.creature =
	{
		Base="palette.entities.npc",
		IsNpc = 0,
		
	}
	r2.addPaletteElement("palette.entities.creature", entries.creature)

	entries.creature_passive =
	{
		Base="palette.entities.creature",
		IsHerbivore = 1,
		IsFauna = 1,
		Category = "Herbivore",		
	}
	r2.addPaletteElement("palette.entities.creatures.passive", entries.creature_passive)

	entries.creature_named_passive =
	{
		Base="palette.entities.creatures.passive",
		IsNamed = 1,		
	}
	r2.addPaletteElement("palette.entities.creatures.named_passive", entries.creature_named_passive)

	entries.creature_predator =
	{
		Base="palette.entities.creature",
		Profile="faction",
		IsHerbivore = 0,
		
		IsFauna = 1,
		Category = "Carnivore",
	}
	r2.addPaletteElement("palette.entities.creatures.predator", entries.creature_predator)

	entries.creature_named_predator =
	{
		Base="palette.entities.creatures.predator",
		IsNamed = 1,
	
	}
	r2.addPaletteElement("palette.entities.creatures.named_predator", entries.creature_named_predator)


	entries.creature_plant =
	{
		Base="palette.entities.creature",
		Profile="faction",
		Category = "Plant",		
		IsPlant = 1,
	}
	r2.addPaletteElement("palette.entities.creatures.plant", entries.creature_plant)

	entries.creature_degen =
	{
		Base="palette.entities.creature",
		Profile="faction",
		Category = "Degen",		
	}
	r2.addPaletteElement("palette.entities.creatures.degen", entries.creature_degen)

	entries.creature_kitin =
	{
		Base="palette.entities.creature",
		Profile="faction",
		IsHerbivore = 0,		
		IsFauna = 1,
		IsKitin = 1,
		Category = "SoldierKitin",		
	}
	r2.addPaletteElement("palette.entities.creatures.kitin", entries.creature_kitin)


	entries.creature_kitin_worker =
	{
		Base="palette.entities.creatures.kitin",
		IsHerbivore=1,
		Category = "WorkerKitin",		
	}
	r2.addPaletteElement("palette.entities.creatures.kitin_worker", entries.creature_kitin_worker)


-- npc types

	entries.cuthroat =
	{
		Base="palette.entities.npc",
		Name="Cut Throat",
		Level=1,
		Profile="bandit",
		PlayerAttackable = 1,
		BotAttackable = 1,
		SubCategory = "Bandit",
	}
	r2.addPaletteElement("palette.entities.cuthroat", entries.cuthroat)

	entries.guard=
	{
		Base="palette.entities.npc",
		Level=1,
		Profile="guard",
		PlayerAttackable = 0,
		BotAttackable = 1,
		SubCategory = "Guard",
	}
	r2.addPaletteElement("palette.entities.guard", entries.guard)

	
   	 entries.bandit =
	{
		Base="palette.entities.npc",
		Name="Bandit",
		Level=1,
		Profile="bandit",
		PlayerAttackable = 1,
		BotAttackable = 1,
		SubCategory = "Bandit",

	}
	r2.addPaletteElement("palette.entities.bandit", entries.bandit)

	
	entries.civil =
	{
		Base="palette.entities.npc",
		Name="Civil",
		Level=1,
		Profile="civil",
		Aggro = 0,
		PlayerAttackable = 0,
		BotAttackable = 0,
		SubCategory = "Civil",
	}
	r2.addPaletteElement("palette.entities.civil", entries.civil)

	
	entries.fyros_male = 
	{
	--	Customization="toto",
		Name="Fyros Male",
		Class="NpcCustom",
		Type="base",
		Base="palette.entities.npc",
		Equipment="fyros_equipment",
		SheetClient="basic_fyros_male.creature"

	}
	r2.addPaletteElement("palette.entities.players.fyros_male", entries.fyros_male)

	entries.fyros_equipment =
	{
		helmet = 
		{
			["heavy helmet"] = "icfahh.sitem"
		},

		chest_plate = 
		{
			["refugee vest"] =	"icravr.sitem",
			["civilian vest"] =	"icfacv_3.sitem",
			["light vest"] =	"icfalv.sitem",
			["light vest II"] =	"icfalv_3.sitem",
			["medium vest"] =	"icfamv.sitem",
			["medium vest II"] =	"icfamv_3.sitem",
			["heavy vest"] =	"icfahv.sitem",
			["heavy vest II"] =	"icfahv_3.sitem"
		},

		legs = 
		{
			["light pants"] = "icfalp.sitem",
			["medium pants"] = "icfamp.sitem",
			["heavy pants"] = "icfahp.sitem",
			["pants 4"] = "icfacp_3.sitem",
			["pants 5"] = "icfahp_3.sitem",
			["pants 6"] = "icfamp_3.sitem",
			["pants 7"] = "icfalp_3.sitem"
		},

		boots = 
		{
			["light boots"] = "icfalb.sitem",
			["medium boots"] = "icfamb.sitem",
			["heavy boots"] = "icfahb.sitem",
			["boots 4"] = "icfacb_3.sitem",
			["boots 5"] = "icfahb_3.sitem",
			["boots 6"] = "icfamb_3.sitem",
			["boots 7"] = "icfalb_3.sitem"
		},

		gloves = 
		{
			["light gloves"] = "icfalg.sitem",
			["medium gloves"] = "icfamg.sitem",
			["heavy gloves"] = "icfahg.sitem"
		},

		arms_guard = 
		{
			["light sleeves"] = "icfals.sitem",
			["medium sleeves"] = "icfams.sitem",
			["heavy sleeves"] = "icfahs.sitem",
			["sleeves 4"] = "icfacs_3.sitem",
			["sleeves 5"] = "icfahs_3.sitem",
			["sleeves 6"] = "icfams_3.sitem",
			["sleeves 7"] = "icfals_3.sitem"
		},

		right_hand = 
		{
			["dagger"] = "iccm1pd.sitem",
			["mace"] = "iccm1bm.sitem",
			["dagger"] = "iccm1pd.sitem",
			["axe"] = "iccm1sa.sitem",
			["sword"] = "iccm1ss.sitem"
		},

		left_hand = 
		{
			["dagger"] = "iccm1pd.sitem"
		}
	}
	r2.addR2PlayerEquipment(entries.fyros_male, entries.fyros_equipment)

	entries.fyros_female = 
	{
		Name="Fyros Female",
		Class="NpcCustom",
		Type="base",
		Equipment="fyros_equipment",
		Base="palette.entities.npc",
		SheetClient="basic_fyros_female.creature"
	}
	r2.addPaletteElement("palette.entities.players.fyros_female", entries.fyros_female)
	r2.addR2PlayerEquipment(entries.fyros_female, entries.fyros_equipment)


	entries.matis_male = 
	{
		Name="Matis Male",
		Class="NpcCustom",
		Type="base",
		Equipment="fyros_equipment",
		Base="palette.entities.npc",
		SheetClient="basic_matis_male.creature"
		
	}
	r2.addPaletteElement("palette.entities.players.matis_male", entries.matis_male)

	entries.matis_equipment =
	{
		helmet = 
		{
		
		},

		chest_plate = 
		{
			["vest 1"] = "icmacv_3.sitem",
			["vest 2"] = "icmahv_3.sitem",
			["vest 3"] = "icmamv_3.sitem",
			["vest 4"] = "icmalv_3.sitem",
			["vest 5"] = "icravr.sitem"
		},

		legs = 
		{
			["pants 1"] = "icmacp_3.sitem",
			["pants 2"] = "icmahp_3.sitem",
			["pants 3"] = "icmamp_3.sitem",
			["pants 4"] = "icmalp_3.sitem"
		},

		boots = 
		{
			["boots 1"] = "icmacb_3.sitem",
			["boots 2"] = "icmahb_3.sitem",
			["boots 3"] = "icmamb_3.sitem",
			["boots 4"] = "icmalb_3.sitem"
		},

		gloves = 
		{
		
		},

		arms_guard = 
		{
			["sleeves 1"] = "icmacs_3.sitem",
			["sleeves 2"] = "icmahs_3.sitem",
			["sleeves 3"] = "icmams_3.sitem",
			["sleeves 4"] = "icmals_3.sitem"
		},

		right_hand = 
		{
			["dagger"] = "iccm1pd.sitem",
			["mace"] = "iccm1bm.sitem",
			["dagger"] = "iccm1pd.sitem",
			["axe"] = "iccm1sa.sitem",
			["sword"] = "iccm1ss.sitem"
		},

		left_hand = 
		{
			["dagger"] = "iccm1pd.sitem"
		}
	}
--	r2.addR2PlayerEquipment(entries.matis_male, entries.matis_equipment)
	r2.addR2PlayerEquipment(entries.matis_male, entries.fyros_equipment)

	entries.matis_female = 
	{
		Name="Matis Female",
		Class="NpcCustom",
		Type="base",
		Base="palette.entities.npc",
		Equipment="matis_equipment",
		SheetClient="basic_matis_female.creature",

	}
	r2.addPaletteElement("palette.entities.players.matis_female", entries.matis_female)
	r2.addR2PlayerEquipment(entries.matis_female, entries.matis_equipment)

	entries.tryker_male = 
	{
		Name="Tryker Male",
		Class="NpcCustom",
		Type="base",
		Base="palette.entities.npc",
		Equipment="tryker_equipment",
		SheetClient="basic_tryker_male.creature",
	}
	r2.addPaletteElement("palette.entities.players.tryker_male", entries.tryker_male)

	entries.tryker_equipment =
	{
		helmet = 
		{
			
		},

		chest_plate = 
		{
			["vest 1"] = "ictacv_3.sitem",
			["vest 2"] = "ictahv_3.sitem",
			["vest 3"] = "ictamv_3.sitem",
			["vest 4"] = "ictalv_3.sitem",
		},

		legs = 
		{
			["pants 1"] = "ictacp_3.sitem",
			["pants 2"] = "ictahp_3.sitem",
			["pants 3"] = "ictamp_3.sitem",
			["pants 4"] = "ictalp_3.sitem"
		},

		boots = 
		{
			["boots 1"] = "ictacb_3.sitem",
			["boots 2"] = "ictahb_3.sitem",
			["boots 3"] = "ictamb_3.sitem",
			["boots 4"] = "ictalb_3.sitem"
		},

		gloves = 
		{
			
		},

		arms_guard = 
		{
			["sleeves 1"] = "ictacs_3.sitem",
			["sleeves 2"] = "ictahs_3.sitem",
			["sleeves 3"] = "ictams_3.sitem",
			["sleeves 4"] = "ictals_3.sitem"
		},

		right_hand = 
		{
			["dagger"] = "iccm1pd.sitem",
			["mace"] = "iccm1bm.sitem",
			["dagger"] = "iccm1pd.sitem",
			["axe"] = "iccm1sa.sitem",
			["sword"] = "iccm1ss.sitem"
		},

		left_hand = 
		{
			["dagger"] = "iccm1pd.sitem"
		}
	}
	r2.addR2PlayerEquipment(entries.tryker_male, entries.tryker_equipment)

	entries.tryker_female = 
	{
		Name="Tryker Female",
		Class="NpcCustom",
		Type="base",
		Base="palette.entities.npc",
		Equipment="tryker_equipment",
		SheetClient="basic_tryker_female.creature"				
	}
	r2.addPaletteElement("palette.entities.players.tryker_female", entries.tryker_female)
	r2.addR2PlayerEquipment(entries.tryker_female, entries.tryker_equipment)

	entries.zorai_male = 
	{
		Name="Zorai Male",
		Class="NpcCustom",
		Type="base",
		Base="palette.entities.npc",
		Equipment="zorai_equipment",
		SheetClient="basic_zorai_male.creature"
	}
	r2.addPaletteElement("palette.entities.players.zorai_male", entries.zorai_male)

	entries.zorai_equipment =
	{
		helmet = 
		{
			
		},

		chest_plate = 
		{
			["vest 1"] = "icmacv_3.sitem",
			["vest 2"] = "icmahv_3.sitem",
			["vest 3"] = "icmamv_3.sitem",
			["vest 4"] = "icmalv_3.sitem",
		},

		legs = 
		{
			["pants 1"] = "icmacp_3.sitem",
			["pants 2"] = "icmahp_3.sitem",
			["pants 3"] = "icmamp_3.sitem",
			["pants 4"] = "icmalp_3.sitem"
		},

		boots = 
		{
			["boots 1"] = "icmacb_3.sitem",
			["boots 2"] = "icmahb_3.sitem",
			["boots 3"] = "icmamb_3.sitem",
			["boots 4"] = "icmalb_3.sitem"
		},

		gloves = 
		{
		},

		arms_guard = 
		{
			["sleeves 1"] = "icmacs_3.sitem",
			["sleeves 2"] = "icmahs_3.sitem",
			["sleeves 3"] = "icmams_3.sitem",
			["sleeves 4"] = "icmals_3.sitem"
		},

		right_hand = 
		{
			["dagger"] = "iccm1pd.sitem",
			["mace"] = "iccm1bm.sitem",
			["dagger"] = "iccm1pd.sitem",
			["axe"] = "iccm1sa.sitem",
			["sword"] = "iccm1ss.sitem"
		},

		left_hand = 
		{
			["dagger"] = "iccm1pd.sitem"
		}
	}
	r2.addR2PlayerEquipment(entries.zorai_male, entries.zorai_equipment)

	entries.zorai_female = 
	{
		Name="Zorai Female",
		Class="NpcCustom",
		Type="base",
		Base="palette.entities.npc",
		Equipment="zorai_equipment",
		SheetClient="basic_zorai_female.creature"
	}
	r2.addPaletteElement("palette.entities.players.zorai_female", entries.zorai_female)
	r2.addR2PlayerEquipment(entries.zorai_female, entries.zorai_equipment)


--	


--	 obsolete	
	entries.guard1 = 
	{
		Base="palette.entities.npc",
		Name="guard Matis 1",
		SheetClient="fyros.race_stats",
		Level=1,
	--	SheetClient="matis_guard_m_f.creature",
	}
	r2.addPaletteElement("palette.entities.npcs.guards.guard1", entries.guard1)
--	 obsolete
	entries.fire4 =
	{
		Base="palette.entities.npc",
		Name="Fire 4",
		SheetClient="object_campfire.creature",
		Level=1,
		IsStuck=1
	}
	r2.addPaletteElement("palette.entities.botobjects.fires.fire4", entries.fire4);

--	 obsolete
	entries.bandit1 =
	{
		Base="palette.entities.npc",
		Name="Le bandit",
		SheetClient="zorai_guard_l_b_f.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.bandits.bandit1", entries.bandit1)

-- NPCs added by Sadge start here -- 


-- fyros cutthroats

	entries.cuthroat_b_melee_a_f_f =
	{
		Base="palette.entities.cuthroat",
		SheetClient="cuthroat_b_melee_a_f_f.creature",
		Level=1
	}
	r2.addPaletteElement("palette.entities.npcs.cuthroats.cuthroat_b_melee_a_f_f", entries.cuthroat_b_melee_a_f_f)

	entries.cuthroat_b_melee_b_f_f =
	{
		Base="palette.entities.cuthroat",
		SheetClient="cuthroat_b_melee_b_f_f.creature",
		Level=1
	}
	r2.addPaletteElement("palette.entities.npcs.cuthroats.cuthroat_b_melee_b_f_f", entries.cuthroat_b_melee_b_f_f)

	entries.cuthroat_b_melee_c_f_f =
	{
		Base="palette.entities.cuthroat",
		SheetClient="cuthroat_b_melee_c_f_f.creature",
		Level=1
	}
	r2.addPaletteElement("palette.entities.npcs.cuthroats.cuthroat_b_melee_c_f_f", entries.cuthroat_b_melee_c_f_f)

	entries.cuthroat_b_range_a_f_f =
	{
		Base="palette.entities.cuthroat",
		SheetClient="cuthroat_b_range_a_f_f.creature",
		Level=1
	}
	r2.addPaletteElement("palette.entities.npcs.cuthroats.cuthroat_b_range_a_f_f", entries.cuthroat_b_range_a_f_f)

	entries.cuthroat_b_range_b_f_f =
	{
		Base="palette.entities.cuthroat",
		SheetClient="cuthroat_b_range_b_f_f.creature",
		Level=1
	}
	r2.addPaletteElement("palette.entities.npcs.cuthroats.cuthroat_b_range_b_f_f", entries.cuthroat_b_range_b_f_f)

	entries.cuthroat_b_range_c_f_f =
	{
		Base="palette.entities.cuthroat",
		SheetClient="cuthroat_b_range_c_f_f.creature",
		Level=1

	}
	r2.addPaletteElement("palette.entities.npcs.cuthroats.cuthroat_b_range_c_f_f", entries.cuthroat_b_range_c_f_f)

	entries.cuthroat_b_range_c_f_h =
	{
		Base="palette.entities.cuthroat",
		SheetClient="cuthroat_b_range_c_f_h.creature",
		Level=1
	}
	r2.addPaletteElement("palette.entities.npcs.cuthroats.cuthroat_b_range_c_f_h", entries.cuthroat_b_range_c_f_h)

	entries.cuthroat_b_melee_b_f_h =
	{
		Base="palette.entities.cuthroat",
		SheetClient="cuthroat_b_melee_b_f_h.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.cuthroats.cuthroat_b_melee_b_f_h", entries.cuthroat_b_melee_b_f_h)

	entries.cuthroat_b_melee_c_f_h =
	{
		Base="palette.entities.cuthroat",
		SheetClient="cuthroat_b_melee_c_f_h.creature",
		Level=1
	}
	r2.addPaletteElement("palette.entities.npcs.cuthroats.cuthroat_b_melee_c_f_h", entries.cuthroat_b_melee_c_f_h)

	entries.cuthroat_b_melee_a_f_h =
	{
		Base="palette.entities.cuthroat",
		SheetClient="cuthroat_b_melee_a_f_h.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.cuthroats.cuthroat_b_melee_a_f_h", entries.cuthroat_b_melee_a_f_h)

	entries.cuthroat_b_range_a_f_h =
	{
		Base="palette.entities.cuthroat",
		SheetClient="cuthroat_b_range_a_f_h.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.cuthroats.cuthroat_b_range_a_f_h", entries.cuthroat_b_range_a_f_h)

	entries.cuthroat_b_range_b_f_h =
	{
		Base="palette.entities.cuthroat",
		SheetClient="cuthroat_b_range_b_f_h.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.cuthroats.cuthroat_b_range_b_f_h", entries.cuthroat_b_range_b_f_h)


-- matis cutthroats

	entries.cuthroat_b_melee_c_m_f =
	{
		Base="palette.entities.cuthroat",
		SheetClient="cuthroat_b_melee_c_m_f.creature",
		Level=51,
	}
	r2.addPaletteElement("palette.entities.npcs.cuthroats.cuthroat_b_melee_c_m_f", entries.cuthroat_b_melee_c_m_f)

	entries.cuthroat_b_range_b_m_f =
	{
		Base="palette.entities.cuthroat",
		SheetClient="cuthroat_b_range_b_m_f.creature",
		Level=51,
	}
	r2.addPaletteElement("palette.entities.npcs.cuthroats.cuthroat_b_range_b_m_f", entries.cuthroat_b_range_b_m_f)

	entries.cuthroat_b_melee_a_m_f =
	{
		Base="palette.entities.cuthroat",
		SheetClient="cuthroat_b_melee_a_m_f.creature",
		Level=51,
	}
	r2.addPaletteElement("palette.entities.npcs.cuthroats.cuthroat_b_melee_a_m_f", entries.cuthroat_b_melee_a_m_f)

	entries.cuthroat_b_melee_b_m_f =
	{
		Base="palette.entities.cuthroat",
		SheetClient="cuthroat_b_melee_b_m_f.creature",
		Level=51,
	}
	r2.addPaletteElement("palette.entities.npcs.cuthroats.cuthroat_b_melee_b_m_f", entries.cuthroat_b_melee_b_m_f)

	entries.cuthroat_b_range_c_m_f =
	{
		Base="palette.entities.cuthroat",
		SheetClient="cuthroat_b_range_c_m_f.creature",
		Level=51,
	}
	r2.addPaletteElement("palette.entities.npcs.cuthroats.cuthroat_b_range_c_m_f", entries.cuthroat_b_range_c_m_f)

	entries.cuthroat_b_range_a_m_f =
	{
		Base="palette.entities.cuthroat",
		SheetClient="cuthroat_b_range_a_m_f.creature",
		Level=51,
	}
	r2.addPaletteElement("palette.entities.npcs.cuthroats.cuthroat_b_range_a_m_f", entries.cuthroat_b_range_a_m_f)

	entries.cuthroat_b_melee_b_m_h =
	{
		Base="palette.entities.cuthroat",
		SheetClient="cuthroat_b_melee_b_m_h.creature",
		Level=51,
	}
	r2.addPaletteElement("palette.entities.npcs.cuthroats.cuthroat_b_melee_b_m_h", entries.cuthroat_b_melee_b_m_h)

	entries.cuthroat_b_range_a_m_h =
	{
		Base="palette.entities.cuthroat",
		SheetClient="cuthroat_b_range_a_m_h.creature",
		Level=51,
	}
	r2.addPaletteElement("palette.entities.npcs.cuthroats.cuthroat_b_range_a_m_h", entries.cuthroat_b_range_a_m_h)

	entries.cuthroat_b_range_c_m_h =
	{
		Base="palette.entities.cuthroat",
		SheetClient="cuthroat_b_range_c_m_h.creature",
		Level=51,
	}
	r2.addPaletteElement("palette.entities.npcs.cuthroats.cuthroat_b_range_c_m_h", entries.cuthroat_b_range_c_m_h)

	entries.cuthroat_b_melee_a_m_h =
	{
		Base="palette.entities.cuthroat",
		SheetClient="cuthroat_b_melee_a_m_h.creature",
		Level=51,
	}
	r2.addPaletteElement("palette.entities.npcs.cuthroats.cuthroat_b_melee_a_m_h", entries.cuthroat_b_melee_a_m_h)

	entries.cuthroat_b_range_b_m_h =
	{
		Base="palette.entities.cuthroat",
		SheetClient="cuthroat_b_range_b_m_h.creature",
		Level=51,
	}
	r2.addPaletteElement("palette.entities.npcs.cuthroats.cuthroat_b_range_b_m_h", entries.cuthroat_b_range_b_m_h)

	entries.cuthroat_b_melee_c_m_h =
	{
		Base="palette.entities.cuthroat",
		SheetClient="cuthroat_b_melee_c_m_h.creature",
		Level=51,
	}
	r2.addPaletteElement("palette.entities.npcs.cuthroats.cuthroat_b_melee_c_m_h", entries.cuthroat_b_melee_c_m_h)


-- tryker cutthroats

	entries.cuthroat_b_melee_b_t_f =
	{
		Base="palette.entities.cuthroat",
		SheetClient="cuthroat_b_melee_b_t_f.creature",
		Level=101,
	}
	r2.addPaletteElement("palette.entities.npcs.cuthroats.cuthroat_b_melee_b_t_f", entries.cuthroat_b_melee_b_t_f)

	entries.cuthroat_b_range_b_t_f =
	{
		Base="palette.entities.cuthroat",
		SheetClient="cuthroat_b_range_b_t_f.creature",
		Level=101,
	}
	r2.addPaletteElement("palette.entities.npcs.cuthroats.cuthroat_b_range_b_t_f", entries.cuthroat_b_range_b_t_f)

	entries.cuthroat_b_melee_a_t_f =
	{
		Base="palette.entities.cuthroat",
		SheetClient="cuthroat_b_melee_a_t_f.creature",
		Level=101,
	}
	r2.addPaletteElement("palette.entities.npcs.cuthroats.cuthroat_b_melee_a_t_f", entries.cuthroat_b_melee_a_t_f)

	entries.cuthroat_b_melee_c_t_f =
	{
		Base="palette.entities.cuthroat",
		SheetClient="cuthroat_b_melee_c_t_f.creature",
		Level=101,
	}
	r2.addPaletteElement("palette.entities.npcs.cuthroats.cuthroat_b_melee_c_t_f", entries.cuthroat_b_melee_c_t_f)

	entries.cuthroat_b_range_c_t_f =
	{
		Base="palette.entities.cuthroat",
		SheetClient="cuthroat_b_range_c_t_f.creature",
		Level=101,
	}
	r2.addPaletteElement("palette.entities.npcs.cuthroats.cuthroat_b_range_c_t_f", entries.cuthroat_b_range_c_t_f)

	entries.cuthroat_b_range_a_t_f =
	{
		Base="palette.entities.cuthroat",
		SheetClient="cuthroat_b_range_a_t_f.creature",
		Level=101,
	}
	r2.addPaletteElement("palette.entities.npcs.cuthroats.cuthroat_b_range_a_t_f", entries.cuthroat_b_range_a_t_f)

	entries.cuthroat_b_range_c_t_h =
	{
		Base="palette.entities.cuthroat",
		SheetClient="cuthroat_b_range_c_t_h.creature",
		Level=101,
	}
	r2.addPaletteElement("palette.entities.npcs.cuthroats.cuthroat_b_range_c_t_h", entries.cuthroat_b_range_c_t_h)

	entries.cuthroat_b_range_a_t_h =
	{
		Base="palette.entities.cuthroat",
		SheetClient="cuthroat_b_range_a_t_h.creature",
		Level=101,
	}
	r2.addPaletteElement("palette.entities.npcs.cuthroats.cuthroat_b_range_a_t_h", entries.cuthroat_b_range_a_t_h)

	entries.cuthroat_b_range_b_t_h =
	{
		Base="palette.entities.cuthroat",
		SheetClient="cuthroat_b_range_b_t_h.creature",
		Level=101,
	}
	r2.addPaletteElement("palette.entities.npcs.cuthroats.cuthroat_b_range_b_t_h", entries.cuthroat_b_range_b_t_h)

	entries.cuthroat_b_melee_a_t_h =
	{
		Base="palette.entities.cuthroat",
		SheetClient="cuthroat_b_melee_a_t_h.creature",
		Level=101,
	}
	r2.addPaletteElement("palette.entities.npcs.cuthroats.cuthroat_b_melee_a_t_h", entries.cuthroat_b_melee_a_t_h)

	entries.cuthroat_b_melee_b_t_h =
	{
		Base="palette.entities.cuthroat",
		SheetClient="cuthroat_b_melee_b_t_h.creature",
		Level=101,
	}
	r2.addPaletteElement("palette.entities.npcs.cuthroats.cuthroat_b_melee_b_t_h", entries.cuthroat_b_melee_b_t_h)

	entries.cuthroat_b_melee_c_t_h =
	{
		Base="palette.entities.cuthroat",
		SheetClient="cuthroat_b_melee_c_t_h.creature",
		Level=101,
	}
	r2.addPaletteElement("palette.entities.npcs.cuthroats.cuthroat_b_melee_c_t_h", entries.cuthroat_b_melee_c_t_h)


-- zorai cutthroats

	entries.cuthroat_b_melee_b_z_f =
	{
		Base="palette.entities.cuthroat",
		SheetClient="cuthroat_b_melee_b_z_f.creature",
		Level=151,
		RingAccess="p1",
		Ecosystem="PrimeRoots",
	}
	r2.addPaletteElement("palette.entities.npcs.cuthroats.cuthroat_b_melee_b_z_f", entries.cuthroat_b_melee_b_z_f)

	entries.cuthroat_b_melee_c_z_f =
	{
		Base="palette.entities.cuthroat",
		SheetClient="cuthroat_b_melee_c_z_f.creature",
		Level=151,
	}
	r2.addPaletteElement("palette.entities.npcs.cuthroats.cuthroat_b_melee_c_z_f", entries.cuthroat_b_melee_c_z_f)

	entries.cuthroat_b_range_a_z_f =
	{
		Base="palette.entities.cuthroat",
		SheetClient="cuthroat_b_range_a_z_f.creature",
		Level=151,
	}
	r2.addPaletteElement("palette.entities.npcs.cuthroats.cuthroat_b_range_a_z_f", entries.cuthroat_b_range_a_z_f)

	entries.cuthroat_b_range_c_z_f =
	{
		Base="palette.entities.cuthroat",
		SheetClient="cuthroat_b_range_c_z_f.creature",
		Level=151,
	}
	r2.addPaletteElement("palette.entities.npcs.cuthroats.cuthroat_b_range_c_z_f", entries.cuthroat_b_range_c_z_f)

	entries.cuthroat_b_range_b_z_f =
	{
		Base="palette.entities.cuthroat",
		SheetClient="cuthroat_b_range_b_z_f.creature",
		Level=151,
	}
	r2.addPaletteElement("palette.entities.npcs.cuthroats.cuthroat_b_range_b_z_f", entries.cuthroat_b_range_b_z_f)

	entries.cuthroat_b_melee_a_z_f =
	{
		Base="palette.entities.cuthroat",
		SheetClient="cuthroat_b_melee_a_z_f.creature",
		Level=151,
	}
	r2.addPaletteElement("palette.entities.npcs.cuthroats.cuthroat_b_melee_a_z_f", entries.cuthroat_b_melee_a_z_f)

	entries.cuthroat_b_melee_a_z_h =
	{
		Base="palette.entities.cuthroat",
		SheetClient="cuthroat_b_melee_a_z_h.creature",
		Level=151,
	}
	r2.addPaletteElement("palette.entities.npcs.cuthroats.cuthroat_b_melee_a_z_h", entries.cuthroat_b_melee_a_z_h)

	entries.cuthroat_b_range_a_z_h =
	{
		Base="palette.entities.cuthroat",
		SheetClient="cuthroat_b_range_a_z_h.creature",
		Level=151,
	}
	r2.addPaletteElement("palette.entities.npcs.cuthroats.cuthroat_b_range_a_z_h", entries.cuthroat_b_range_a_z_h)

	entries.cuthroat_b_melee_b_z_h =
	{
		Base="palette.entities.cuthroat",
		SheetClient="cuthroat_b_melee_b_z_h.creature",
		Level=151,
	}
	r2.addPaletteElement("palette.entities.npcs.cuthroats.cuthroat_b_melee_b_z_h", entries.cuthroat_b_melee_b_z_h)

	entries.cuthroat_b_melee_c_z_h =
	{
		Base="palette.entities.cuthroat",
		SheetClient="cuthroat_b_melee_c_z_h.creature",
		Level=151,
	}
	r2.addPaletteElement("palette.entities.npcs.cuthroats.cuthroat_b_melee_c_z_h", entries.cuthroat_b_melee_c_z_h)

	entries.cuthroat_b_range_b_z_h =
	{
		Base="palette.entities.cuthroat",
		SheetClient="cuthroat_b_range_b_z_h.creature",
		Level=151,
	}
	r2.addPaletteElement("palette.entities.npcs.cuthroats.cuthroat_b_range_b_z_h", entries.cuthroat_b_range_b_z_h)

	entries.cuthroat_b_range_c_z_h =
	{
		Base="palette.entities.npc",
		SheetClient="cuthroat_b_range_c_z_h.creature",
		Level=151,
	}
	r2.addPaletteElement("palette.entities.npcs.cuthroats.cuthroat_b_range_c_z_h", entries.cuthroat_b_range_c_z_h)




-- fyros guards

	entries.fyros_guard_l_b_f =
	{
		Base="palette.entities.guard",
		SheetClient="fyros_guard_l_b_f.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.guards.fyros_guard_l_b_f", entries.fyros_guard_l_b_f)

	entries.fyros_guard_l_b_h =
	{
		Base="palette.entities.guard",
		SheetClient="fyros_guard_l_b_h.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.guards.fyros_guard_l_b_h", entries.fyros_guard_l_b_h)

	entries.fyros_guard_l_c_f =
	{
		Base="palette.entities.guard",
		SheetClient="fyros_guard_l_c_f.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.guards.fyros_guard_l_c_f", entries.fyros_guard_l_c_f)

	entries.fyros_guard_l_c_h =
	{
		Base="palette.entities.guard",
		SheetClient="fyros_guard_l_c_h.creature",
		Level=1,
	}
	
	r2.addPaletteElement("palette.entities.npcs.guards.fyros_guard_l_c_h", entries.fyros_guard_l_c_h)
	
	entries.fyros_guard_l_d_f =
	{
		Base="palette.entities.guard",
		SheetClient="fyros_guard_l_d_f.creature",
		Level=1,
	}

	r2.addPaletteElement("palette.entities.npcs.guards.fyros_guard_l_d_f", entries.fyros_guard_l_d_f)

	entries.fyros_guard_l_d_h =
	{
		Base="palette.entities.guard",
		SheetClient="fyros_guard_l_d_h.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.guards.fyros_guard_l_d_h", entries.fyros_guard_l_d_h)

	entries.fyros_guard_l_e_f =
	{
		Base="palette.entities.guard",
		SheetClient="fyros_guard_l_e_f.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.guards.fyros_guard_l_e_f", entries.fyros_guard_l_e_f)

	entries.fyros_guard_l_e_h =
	{
		Base="palette.entities.guard",
		SheetClient="fyros_guard_l_e_h.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.guards.fyros_guard_l_e_h", entries.fyros_guard_l_e_h)

	entries.fyros_guard_l_f_f =
	{
		Base="palette.entities.guard",
		SheetClient="fyros_guard_l_f_f.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.guards.fyros_guard_l_f_f", entries.fyros_guard_l_f_f)

	entries.fyros_guard_l_f_h =
	{
		Base="palette.entities.guard",
		SheetClient="fyros_guard_l_f_h.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.guards.fyros_guard_l_f_h", entries.fyros_guard_l_f_h)


-- matis guards

	entries.matis_guard_l_b_f =
	{
		Base="palette.entities.guard",
		SheetClient="matis_guard_l_b_f.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.guards.matis_guard_l_b_f", entries.matis_guard_l_b_f)

		entries.matis_guard_l_b_h =
	{
		Base="palette.entities.guard",
		SheetClient="matis_guard_l_b_h.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.guards.matis_guard_l_b_h", entries.matis_guard_l_b_h)


	entries.matis_guard_l_c_f =
	{
		Base="palette.entities.guard",
		SheetClient="matis_guard_l_c_f.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.guards.matis_guard_l_c_f", entries.matis_guard_l_c_f)

	entries.matis_guard_l_c_h =
	{
		Base="palette.entities.guard",
		SheetClient="matis_guard_l_c_h.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.guards.matis_guard_l_c_h", entries.matis_guard_l_c_h)

	entries.matis_guard_l_d_f =
	{
		Base="palette.entities.guard",
		SheetClient="matis_guard_l_d_f.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.guards.matis_guard_l_d_f", entries.matis_guard_l_d_f)

	entries.matis_guard_l_d_h =
	{
		Base="palette.entities.guard",
		SheetClient="matis_guard_l_d_h.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.guards.matis_guard_l_d_h", entries.matis_guard_l_d_h)

	entries.matis_guard_l_e_f =
	{
		Base="palette.entities.guard",
		SheetClient="matis_guard_l_e_f.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.guards.matis_guard_l_e_f", entries.matis_guard_l_e_f)

	entries.matis_guard_l_e_h =
	{
		Base="palette.entities.guard",
		SheetClient="matis_guard_l_e_h.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.guards.matis_guard_l_e_h", entries.matis_guard_l_e_h)

	entries.matis_guard_l_f_f =
	{
		Base="palette.entities.guard",
		SheetClient="matis_guard_l_f_f.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.guards.matis_guard_l_f_f", entries.matis_guard_l_f_f)

	entries.matis_guard_l_f_h =
	{
		Base="palette.entities.guard",
		SheetClient="matis_guard_l_f_h.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.guards.matis_guard_l_f_h", entries.matis_guard_l_f_h)


-- tryker guards

	entries.tryker_guard_l_b_f =
	{
		Base="palette.entities.guard",
		SheetClient="tryker_guard_l_b_f.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.guards.tryker_guard_l_b_f", entries.tryker_guard_l_b_f)

	entries.tryker_guard_l_b_h =
	{
		Base="palette.entities.guard",
		SheetClient="tryker_guard_l_b_h.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.guards.tryker_guard_l_b_h", entries.tryker_guard_l_b_h)

	entries.tryker_guard_l_c_f =
	{
		Base="palette.entities.guard",
		SheetClient="tryker_guard_l_c_f.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.guards.tryker_guard_l_c_f", entries.tryker_guard_l_c_f)

	entries.tryker_guard_l_c_h =
	{
		Base="palette.entities.guard",
		SheetClient="tryker_guard_l_c_h.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.guards.tryker_guard_l_c_h", entries.tryker_guard_l_c_h)

	entries.tryker_guard_l_d_f =
	{
		Base="palette.entities.guard",
		SheetClient="tryker_guard_l_d_f.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.guards.tryker_guard_l_d_f", entries.tryker_guard_l_d_f)

	entries.tryker_guard_l_d_h =
	{
		Base="palette.entities.guard",
		SheetClient="tryker_guard_l_d_h.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.guards.tryker_guard_l_d_h", entries.tryker_guard_l_d_h)

	entries.tryker_guard_l_e_f =
	{
		Base="palette.entities.guard",
		SheetClient="tryker_guard_l_e_f.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.guards.tryker_guard_l_e_f", entries.tryker_guard_l_e_f)

	entries.tryker_guard_l_e_h =
	{
		Base="palette.entities.guard",
		SheetClient="tryker_guard_l_e_h.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.guards.tryker_guard_l_e_h", entries.tryker_guard_l_e_h)

	entries.tryker_guard_l_f_f =
	{
		Base="palette.entities.guard",
		SheetClient="tryker_guard_l_f_f.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.guards.tryker_guard_l_f_f", entries.tryker_guard_l_f_f)

	entries.tryker_guard_l_f_h =
	{
		Base="palette.entities.guard",
		SheetClient="tryker_guard_l_f_h.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.guards.tryker_guard_l_f_h", entries.tryker_guard_l_f_h)


-- zorai guards

	entries.zorai_guard_l_b_f =
	{
		Base="palette.entities.guard",
		SheetClient="zorai_guard_l_b_f.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.guards.zorai_guard_l_b_f", entries.zorai_guard_l_b_f)

	entries.zorai_guard_l_b_h =
	{
		Base="palette.entities.guard",
		SheetClient="zorai_guard_l_b_h.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.guards.zorai_guard_l_b_h", entries.zorai_guard_l_b_h)

	entries.zorai_guard_l_c_f =
	{
		Base="palette.entities.guard",
		SheetClient="zorai_guard_l_c_f.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.guards.zorai_guard_l_c_f", entries.zorai_guard_l_c_f)

	entries.zorai_guard_l_c_h =
	{
		Base="palette.entities.guard",
		SheetClient="zorai_guard_l_c_h.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.guards.zorai_guard_l_c_h", entries.zorai_guard_l_c_h)

	entries.zorai_guard_l_d_f =
	{
		Base="palette.entities.guard",
		SheetClient="zorai_guard_l_d_f.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.guards.zorai_guard_l_d_f", entries.zorai_guard_l_d_f)

	entries.zorai_guard_l_d_h =
	{
		Base="palette.entities.guard",
		SheetClient="zorai_guard_l_d_h.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.guards.zorai_guard_l_d_h", entries.zorai_guard_l_d_h)

	entries.zorai_guard_l_e_f =
	{
		Base="palette.entities.guard",
		SheetClient="zorai_guard_l_e_f.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.guards.zorai_guard_l_e_f", entries.zorai_guard_l_e_f)

	entries.zorai_guard_l_e_h =
	{
		Base="palette.entities.guard",
		SheetClient="zorai_guard_l_e_h.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.guards.zorai_guard_l_e_h", entries.zorai_guard_l_e_h)

	entries.zorai_guard_l_f_f =
	{
		Base="palette.entities.guard",
		SheetClient="zorai_guard_l_f_f.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.guards.zorai_guard_l_f_f", entries.zorai_guard_l_f_f)

	entries.zorai_guard_l_f_h =
	{
		Base="palette.entities.guard",
		SheetClient="zorai_guard_l_f_h.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.guards.zorai_guard_l_f_h", entries.zorai_guard_l_f_h)



-- cute

	entries.npc_cute_mature_b =
	{
		Base="palette.entities.npc",
		Name="Cute",
		SheetClient="npc_cute_mature_b.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.cute.npc_cute_mature_b", entries.npc_cute_mature_b)

	entries.npc_cute_mature_c =
	{
		Base="palette.entities.npc",
		Name="Cute",
		SheetClient="npc_cute_mature_c.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.cute.npc_cute_mature_c", entries.npc_cute_mature_c)

	entries.npc_cute_mature_d =
	{
		Base="palette.entities.npc",
		Name="Cute",
		SheetClient="npc_cute_mature_d.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.cute.npc_cute_mature_d", entries.npc_cute_mature_d)

	entries.npc_cute_mature_e =
	{
		Base="palette.entities.npc",
		Name="Cute",
		SheetClient="npc_cute_mature_e.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.cute.npc_cute_mature_e", entries.npc_cute_mature_e)

	entries.npc_cute_mature_f =
	{
		Base="palette.entities.npc",
		Name="Cute",
		SheetClient="npc_cute_mature_f.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.cute.npc_cute_mature_f", entries.npc_cute_mature_f)

	entries.npc_cute_venerable_b =
	{
		Base="palette.entities.npc",
		Name="Cute",
		SheetClient="npc_cute_venerable_b.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.cute.npc_cute_venerable_b", entries.npc_cute_venerable_b)

	entries.npc_cute_venerable_c =
	{
		Base="palette.entities.npc",
		Name="Cute",
		SheetClient="npc_cute_venerable_c.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.cute.npc_cute_venerable_c", entries.npc_cute_venerable_c)

	entries.npc_cute_venerable_d =
	{
		Base="palette.entities.npc",
		Name="Cute",
		SheetClient="npc_cute_venerable_d.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.cute.npc_cute_venerable_d", entries.npc_cute_venerable_d)

	entries.npc_cute_venerable_e =
	{
		Base="palette.entities.npc",
		Name="Cute",
		SheetClient="npc_cute_venerable_e.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.cute.npc_cute_venerable_e", entries.npc_cute_venerable_e)

	entries.npc_cute_venerable_f =
	{
		Base="palette.entities.npc",
		Name="Cute",
		SheetClient="npc_cute_venerable_f.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.cute.npc_cute_venerable_f", entries.npc_cute_venerable_f)

	entries.npc_cute_weapon_b =
	{
		Base="palette.entities.npc",
		Name="Cute",
		SheetClient="npc_cute_weapon_b.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.cute.npc_cute_weapon_b", entries.npc_cute_weapon_b)

	entries.npc_cute_weapon_c =
	{
		Base="palette.entities.npc",
		Name="Cute",
		SheetClient="npc_cute_weapon_c.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.cute.npc_cute_weapon_c", entries.npc_cute_weapon_c)

	entries.npc_cute_weapon_d =
	{
		Base="palette.entities.npc",
		Name="Cute",
		SheetClient="npc_cute_weapon_d.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.cute.npc_cute_weapon_d", entries.npc_cute_weapon_d)

	entries.npc_cute_weapon_e =
	{
		Base="palette.entities.npc",
		Name="Cute",
		SheetClient="npc_cute_weapon_e.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.cute.npc_cute_weapon_e", entries.npc_cute_weapon_e)

	entries.npc_cute_weapon_f =
	{
		Base="palette.entities.npc",
		Name="Cute",
		SheetClient="npc_cute_weapon_f.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.cute.npc_cute_weapon_f", entries.npc_cute_weapon_f)


-- frahar

	entries.npc_frahar_ancient_b =
	{
		Base="palette.entities.npc",
		Name="Frahar",
		SheetClient="npc_frahar_ancient_b.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.frahar.npc_frahar_ancient_b", entries.npc_frahar_ancient_b)

	entries.npc_frahar_ancient_c =
	{
		Base="palette.entities.npc",
		Name="Frahar",
		SheetClient="npc_frahar_ancient_c.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.frahar.npc_frahar_ancient_c", entries.npc_frahar_ancient_c)

	entries.npc_frahar_ancient_d =
	{
		Base="palette.entities.npc",
		Name="Frahar",
		SheetClient="npc_frahar_ancient_d.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.frahar.npc_frahar_ancient_d", entries.npc_frahar_ancient_d)

	entries.npc_frahar_ancient_e =
	{
		Base="palette.entities.npc",
		Name="Frahar",
		SheetClient="npc_frahar_ancient_e.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.frahar.npc_frahar_ancient_e", entries.npc_frahar_ancient_e)

	entries.npc_frahar_ancient_f =
	{
		Base="palette.entities.npc",
		Name="Frahar",
		SheetClient="npc_frahar_ancient_f.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.frahar.npc_frahar_ancient_f", entries.npc_frahar_ancient_f)

	entries.npc_frahar_patriarchal_b =
	{


		Base="palette.entities.npc",
		Name="Frahar",
		SheetClient="npc_frahar_patriarchal_b.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.frahar.npc_frahar_patriarchal_b", entries.npc_frahar_patriarchal_b)

	entries.npc_frahar_patriarchal_c =
	{
		Base="palette.entities.npc",
		Name="Frahar",
		SheetClient="npc_frahar_patriarchal_c.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.frahar.npc_frahar_patriarchal_c", entries.npc_frahar_patriarchal_c)

	entries.npc_frahar_patriarchal_d =
	{
		Base="palette.entities.npc",
		Name="Frahar",
		SheetClient="npc_frahar_patriarchal_d.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.frahar.npc_frahar_patriarchal_d", entries.npc_frahar_patriarchal_d)

	entries.npc_frahar_patriarchal_e =
	{
		Base="palette.entities.npc",
		Name="Frahar",
		SheetClient="npc_frahar_patriarchal_e.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.frahar.npc_frahar_patriarchal_e", entries.npc_frahar_patriarchal_e)

	entries.npc_frahar_patriarchal_f =
	{
		Base="palette.entities.npc",
		Name="Frahar",
		SheetClient="npc_frahar_patriarchal_f.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.frahar.npc_frahar_patriarchal_f", entries.npc_frahar_patriarchal_f)

	entries.npc_frahar_weapon_b =
	{
		Base="palette.entities.npc",
		Name="Frahar",
		SheetClient="npc_frahar_weapon_b.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.frahar.npc_frahar_weapon_b", entries.npc_frahar_weapon_b)

	entries.npc_frahar_weapon_c =
	{
		Base="palette.entities.npc",
		Name="Frahar",
		SheetClient="npc_frahar_weapon_c.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.frahar.npc_frahar_weapon_c", entries.npc_frahar_weapon_c)

	entries.npc_frahar_weapon_d =
	{
		Base="palette.entities.npc",
		Name="Frahar",
		SheetClient="npc_frahar_weapon_d.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.frahar.npc_frahar_weapon_d", entries.npc_frahar_weapon_d)

	entries.npc_frahar_weapon_e =
	{
		Base="palette.entities.npc",
		Name="Frahar",
		SheetClient="npc_frahar_weapon_e.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.frahar.npc_frahar_weapon_e", entries.npc_frahar_weapon_e)

	entries.npc_frahar_weapon_f =
	{
		Base="palette.entities.npc",
		Name="Frahar",
		SheetClient="npc_frahar_weapon_f.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.npcs.frahar.npc_frahar_weapon_f", entries.npc_frahar_weapon_f)


-- gibbai

	entries.npc_gibbay_old_b =
	{
		Base="palette.entities.npc",
		Name="Gibbai",
		SheetClient="npc_gibbay_old_b.creature",
		Level=1
	}
	r2.addPaletteElement("palette.entities.npcs.gibbai.npc_gibbay_old_b", entries.npc_gibbay_old_b)

	entries.npc_gibbay_old_c =
	{
		Base="palette.entities.npc",
		Name="Gibbai",
		SheetClient="npc_gibbay_old_c.creature",
		Level=1		
	}
	r2.addPaletteElement("palette.entities.npcs.gibbai.npc_gibbay_old_c", entries.npc_gibbay_old_c)

	entries.npc_gibbay_old_d =
	{
		Base="palette.entities.npc",
		Name="Gibbai",
		SheetClient="npc_gibbay_old_d.creature",
		Level=1		
	}
	r2.addPaletteElement("palette.entities.npcs.gibbai.npc_gibbay_old_d", entries.npc_gibbay_old_d)

	entries.npc_gibbay_old_e =
	{
		Base="palette.entities.npc",
		Name="Gibbai",
		SheetClient="npc_gibbay_old_e.creature",
		Level=1		
	}
	r2.addPaletteElement("palette.entities.npcs.gibbai.npc_gibbay_old_e", entries.npc_gibbay_old_e)

	entries.npc_gibbay_old_f =
	{
		Base="palette.entities.npc",
		Name="Gibbai",
		SheetClient="npc_gibbay_old_f.creature",
		Level=1		
	}
	r2.addPaletteElement("palette.entities.npcs.gibbai.npc_gibbay_old_f", entries.npc_gibbay_old_f)

	entries.npc_gibbay_weapon_b =
	{
		Base="palette.entities.npc",
		Name="Gibbai",
		SheetClient="npc_gibbay_weapon_b.creature",
		Level=1		
	}
	r2.addPaletteElement("palette.entities.npcs.gibbai.npc_gibbay_weapon_b", entries.npc_gibbay_weapon_b)


	entries.npc_gibbay_weapon_c =
	{
		Base="palette.entities.npc",
		Name="Gibbai",
		SheetClient="npc_gibbay_weapon_c.creature",
		Level=1		
	}
	r2.addPaletteElement("palette.entities.npcs.gibbai.npc_gibbay_weapon_c", entries.npc_gibbay_weapon_c)

	entries.npc_gibbay_weapon_d =
	{
		Base="palette.entities.npc",
		Name="Gibbai",
		SheetClient="npc_gibbay_weapon_d.creature",
		Level=1		
	}
	r2.addPaletteElement("palette.entities.npcs.gibbai.npc_gibbay_weapon_d", entries.npc_gibbay_weapon_d)

	entries.npc_gibbay_weapon_e =
	{
		Base="palette.entities.npc",
		Name="Gibbai",
		SheetClient="npc_gibbay_weapon_e.creature",
		Level=1		
	}
	r2.addPaletteElement("palette.entities.npcs.gibbai.npc_gibbay_weapon_e", entries.npc_gibbay_weapon_e)

	entries.npc_gibbay_weapon_f =
	{
		Base="palette.entities.npc",
		Name="Gibbai",
		SheetClient="npc_gibbay_weapon_f.creature",
		Level=1		
	}
	r2.addPaletteElement("palette.entities.npcs.gibbai.npc_gibbay_weapon_f", entries.npc_gibbay_weapon_f)

	entries.npc_gibbay_wise_b =
	{
		Base="palette.entities.npc",
		Name="Gibbai",
		SheetClient="npc_gibbay_wise_b.creature",
		Level=1		
	}
	r2.addPaletteElement("palette.entities.npcs.gibbai.npc_gibbay_wise_b", entries.npc_gibbay_wise_b)

	entries.npc_gibbay_wise_c =
	{
		Base="palette.entities.npc",
		Name="Gibbai",
		SheetClient="npc_gibbay_wise_c.creature",
		Level=1		
	}
	r2.addPaletteElement("palette.entities.npcs.gibbai.npc_gibbay_wise_c", entries.npc_gibbay_wise_c)

	entries.npc_gibbay_wise_d =
	{
		Base="palette.entities.npc",
		Name="Gibbai",
		SheetClient="npc_gibbay_wise_d.creature",
		Level=1		
	}
	r2.addPaletteElement("palette.entities.npcs.gibbai.npc_gibbay_wise_d", entries.npc_gibbay_wise_d)

	entries.npc_gibbay_wise_e =
	{
		Base="palette.entities.npc",
		Name="Gibbai",
		SheetClient="npc_gibbay_wise_e.creature",
		Level=1		
	}
	r2.addPaletteElement("palette.entities.npcs.gibbai.npc_gibbay_wise_e", entries.npc_gibbay_wise_e)

	entries.npc_gibbay_wise_f =
	{
		Base="palette.entities.npc",
		Name="Gibbai",
		SheetClient="npc_gibbay_wise_f.creature",
		Level=1		
	}
	r2.addPaletteElement("palette.entities.npcs.gibbai.npc_gibbay_wise_f", entries.npc_gibbay_wise_f)


-- kami
-- 	-- abstract class
	entries.kami = 
	{
		Base="palette.entities.guard",
		Name="Kami Guardian",
		CanUpdatePlayerAttackable = 0,
		PlayerAttackable = 0,
		Profile = "guard",
		SubCategory = "Kami",
		Fame="kami",

	}
	r2.addPaletteElement("palette.entities.kami", entries.kami)
	-- concret class

	entries.kami_guardian_2_b =
	{
		Base="palette.entities.kami",	
		SheetClient="kami_guardian_2_b.creature",
		Level=1,
		RingAccess="a1",
	}
	r2.addPaletteElement("palette.entities.npcs.kami.kami_guardian_2_b", entries.kami_guardian_2_b)

	entries.kami_guardian_2_c =
	{
		Base="palette.entities.kami",
		SheetClient="kami_guardian_2_c.creature",
		Level=51,
		RingAccess="p1",
	}
	r2.addPaletteElement("palette.entities.npcs.kami.kami_guardian_2_c", entries.kami_guardian_2_c)

	entries.kami_guardian_2_d =
	{
		Base="palette.entities.kami",
		SheetClient="kami_guardian_2_d.creature",
		Level=101,
		RingAccess="p1",
	}
	r2.addPaletteElement("palette.entities.npcs.kami.kami_guardian_2_d", entries.kami_guardian_2_d)

	entries.kami_guardian_2_e =
	{
		Base="palette.entities.kami",
		SheetClient="kami_guardian_2_e.creature",
		Level=151,
		RingAccess="p4",
	}
	r2.addPaletteElement("palette.entities.npcs.kami.kami_guardian_2_e", entries.kami_guardian_2_e)

	entries.kami_guardian_2_f =
	{
		Base="palette.entities.kami",
		SheetClient="kami_guardian_2_f.creature",
		Level=201,
		RingAccess="p10",
	}
	r2.addPaletteElement("palette.entities.npcs.kami.kami_guardian_2_f", entries.kami_guardian_2_f)

	entries.kami_guardian_2_g =
	{
		Base="palette.entities.kami",
		SheetClient="kami_guardian_2_g.creature",
		Level=1,
		RingAccess="p10",
	}
	r2.addPaletteElement("palette.entities.npcs.kami.kami_guardian_2_g", entries.kami_guardian_2_g)

	entries.kami_guardian_3_b =
	{
		Base="palette.entities.kami",
		SheetClient="kami_guardian_3_b.creature",
		Level=1,
		RingAccess="a1",
	}

	r2.addPaletteElement("palette.entities.npcs.kami.kami_guardian_3_b", entries.kami_guardian_3_b)

	entries.kami_guardian_3_c =
	{
		Base="palette.entities.kami",
		SheetClient="kami_guardian_3_c.creature",
		Level=51,
		RingAccess="p1",
	}
	r2.addPaletteElement("palette.entities.npcs.kami.kami_guardian_3_c", entries.kami_guardian_3_c)

	entries.kami_guardian_3_d =
	{
		Base="palette.entities.kami",
		SheetClient="kami_guardian_3_d.creature",
		Level=101,
		RingAccess="p1",
	}
	r2.addPaletteElement("palette.entities.npcs.kami.kami_guardian_3_d", entries.kami_guardian_3_d)

	entries.kami_guardian_3_e =
	{
		Base="palette.entities.kami",
		SheetClient="kami_guardian_3_e.creature",
		Level=151,
		RingAccess="p4",
	}
	r2.addPaletteElement("palette.entities.npcs.kami.kami_guardian_3_e", entries.kami_guardian_3_e)

	entries.kami_guardian_3_f =
	{
		Base="palette.entities.kami",
		SheetClient="kami_guardian_3_f.creature",
		Level=201,
		RingAccess="p10",
	}
	r2.addPaletteElement("palette.entities.npcs.kami.kami_guardian_3_f", entries.kami_guardian_3_f)

	entries.kami_guardian_3_g =
	{
		Base="palette.entities.kami",
		SheetClient="kami_guardian_3_g.creature",
		Level=1,
		RingAccess="p10",
	}
	r2.addPaletteElement("palette.entities.npcs.kami.kami_guardian_3_g", entries.kami_guardian_3_g)

	entries.kami_guardian_4_b =
	{
		Base="palette.entities.kami",
		SheetClient="kami_guardian_4_b.creature",
		Level=1,
		RingAccess="a1",
	}
	r2.addPaletteElement("palette.entities.npcs.kami.kami_guardian_4_b", entries.kami_guardian_4_b)

	entries.kami_guardian_4_c =
	{
		Base="palette.entities.kami",
		SheetClient="kami_guardian_4_c.creature",
		Level=51,
		RingAccess="p1",
	}
	r2.addPaletteElement("palette.entities.npcs.kami.kami_guardian_4_c", entries.kami_guardian_4_c)

	entries.kami_guardian_4_d =
	{
		Base="palette.entities.kami",
		SheetClient="kami_guardian_4_d.creature",
		Level=101,
		RingAccess="p1",
	}
	r2.addPaletteElement("palette.entities.npcs.kami.kami_guardian_4_d", entries.kami_guardian_4_d)

	entries.kami_guardian_4_e =
	{
		Base="palette.entities.kami",
		SheetClient="kami_guardian_4_e.creature",
		Level=151,
		RingAccess="p4",
	}
	r2.addPaletteElement("palette.entities.npcs.kami.kami_guardian_4_e", entries.kami_guardian_4_e)

	entries.kami_guardian_4_f =
	{
		Base="palette.entities.kami",
		SheetClient="kami_guardian_4_f.creature",
		Level=201,
		RingAccess="p10",
	}
	r2.addPaletteElement("palette.entities.npcs.kami.kami_guardian_4_f", entries.kami_guardian_4_f)

	entries.kami_guardian_4_g =
	{
		Base="palette.entities.kami",
		SheetClient="kami_guardian_4_g.creature",
		Level=1,
		RingAccess="p10",
	}
	r2.addPaletteElement("palette.entities.npcs.kami.kami_guardian_4_g", entries.kami_guardian_4_g)

	entries.kami_guardian_b =
	{
		Base="palette.entities.kami",
		SheetClient="kami_guardian_b.creature",
		Level=1,
		RingAccess="a1",
	}
	r2.addPaletteElement("palette.entities.npcs.kami.kami_guardian_b", entries.kami_guardian_b)

	entries.kami_guardian_c =
	{
		Base="palette.entities.kami",
		SheetClient="kami_guardian_c.creature",
		Level=51,
		RingAccess="p1",
	}
	r2.addPaletteElement("palette.entities.npcs.kami.kami_guardian_c", entries.kami_guardian_c)

	entries.kami_guardian_d =
	{
		Base="palette.entities.kami",
		SheetClient="kami_guardian_d.creature",
		Level=101,
		RingAccess="p1",			
	}
	r2.addPaletteElement("palette.entities.npcs.kami.kami_guardian_d", entries.kami_guardian_d)

	entries.kami_guardian_e =
	{
		Base="palette.entities.kami",
		SheetClient="kami_guardian_e.creature",
		Level=151,
		RingAccess="p4",
	}
	r2.addPaletteElement("palette.entities.npcs.kami.kami_guardian_e", entries.kami_guardian_e)

	entries.kami_guardian_f =
	{
		Base="palette.entities.kami",
		SheetClient="kami_guardian_f.creature",
		Level=201,
		RingAccess="p10",
	}
	r2.addPaletteElement("palette.entities.npcs.kami.kami_guardian_f", entries.kami_guardian_f)

	entries.kami_guardian_k_g =
	{
		Base="palette.entities.kami",
		SheetClient="kami_guardian_k_g.creature",
		Level=1,
		RingAccess="p10",
	}
	r2.addPaletteElement("palette.entities.npcs.kami.kami_guardian_k_g", entries.kami_guardian_k_g)

	entries.kami_guide_k_g =
	{
		Base="palette.entities.kami",
		Name="Kami Guide",
		SheetClient="kami_guide_k_g.creature",
		Level=1,
		RingAccess="p10",
	}
	r2.addPaletteElement("palette.entities.npcs.kami.kami_guide_k_g", entries.kami_guide_k_g)

	entries.kami_preacher_2_b =
	{
		Base="palette.entities.kami",
		SheetClient="kami_preacher_2_b.creature",
		Level=1,
		RingAccess="a1",
	}
	r2.addPaletteElement("palette.entities.npcs.kami.kami_preacher_2_b", entries.kami_preacher_2_b)

	entries.kami_preacher_2_c =
	{
		Base="palette.entities.kami",
		SheetClient="kami_preacher_2_c.creature",
		Level=51,
		RingAccess="p1",
	}
	r2.addPaletteElement("palette.entities.npcs.kami.kami_preacher_2_c", entries.kami_preacher_2_c)

	entries.kami_preacher_2_d =
	{
		Base="palette.entities.kami",
		SheetClient="kami_preacher_2_d.creature",
		Level=101,
		RingAccess="p1",
	}
	r2.addPaletteElement("palette.entities.npcs.kami.kami_preacher_2_d", entries.kami_preacher_2_d)

	entries.kami_preacher_2_e =
	{
		Base="palette.entities.kami",
		SheetClient="kami_preacher_2_e.creature",
		Level=151,
		RingAccess="p4",
	}
	r2.addPaletteElement("palette.entities.npcs.kami.kami_preacher_2_e", entries.kami_preacher_2_e)

	entries.kami_preacher_2_f =
	{
		Base="palette.entities.kami",
		SheetClient="kami_preacher_2_f.creature",
		Level=201,
		RingAccess="p10",
	}
	r2.addPaletteElement("palette.entities.npcs.kami.kami_preacher_2_f", entries.kami_preacher_2_f)

	entries.kami_preacher_2_g =
	{
		Base="palette.entities.kami",
		SheetClient="kami_preacher_2_g.creature",
		Level=1,
		RingAccess="p10",
	}
	r2.addPaletteElement("palette.entities.npcs.kami.kami_preacher_2_g", entries.kami_preacher_2_g)

	entries.kami_preacher_3_b =
	{
		Base="palette.entities.kami",
		SheetClient="kami_preacher_3_b.creature",
		Level=1,
		RingAccess="a1",
	}
	r2.addPaletteElement("palette.entities.npcs.kami.kami_preacher_3_b", entries.kami_preacher_3_b)

	entries.kami_preacher_3_c =
	{
		Base="palette.entities.kami",
		SheetClient="kami_preacher_3_c.creature",
		Level=51,
		RingAccess="p1",
	}
	r2.addPaletteElement("palette.entities.npcs.kami.kami_preacher_3_c", entries.kami_preacher_3_c)

	entries.kami_preacher_3_d =
	{
		Base="palette.entities.kami",
		SheetClient="kami_preacher_3_d.creature",
		Level=101,
		RingAccess="p1",
	}
	r2.addPaletteElement("palette.entities.npcs.kami.kami_preacher_3_d", entries.kami_preacher_3_d)

	entries.kami_preacher_3_e =
	{
		Base="palette.entities.kami",
		SheetClient="kami_preacher_3_e.creature",
		Level=151,
		RingAccess="p4",
	}
	r2.addPaletteElement("palette.entities.npcs.kami.kami_preacher_3_e", entries.kami_preacher_3_e)

	entries.kami_preacher_3_f =
	{
		Base="palette.entities.kami",
		SheetClient="kami_preacher_3_f.creature",
		Level=201,
		RingAccess="p10",
	}
	r2.addPaletteElement("palette.entities.npcs.kami.kami_preacher_3_f", entries.kami_preacher_3_f)

	entries.kami_preacher_3_g =
	{
		Base="palette.entities.kami",
		SheetClient="kami_preacher_3_g.creature",
		Level=1,
		RingAccess="p10",
	}
	r2.addPaletteElement("palette.entities.npcs.kami.kami_preacher_3_g", entries.kami_preacher_3_g)

	entries.kami_preacher_4_b =
	{
		Base="palette.entities.kami",
		SheetClient="kami_preacher_4_b.creature",
		Level=1,
		RingAccess="a1",
	}
	r2.addPaletteElement("palette.entities.npcs.kami.kami_preacher_4_b", entries.kami_preacher_4_b)

	entries.kami_preacher_4_c =
	{
		Base="palette.entities.kami",
		SheetClient="kami_preacher_4_c.creature",
		Level=51,
		RingAccess="p1",
	}
	r2.addPaletteElement("palette.entities.npcs.kami.kami_preacher_4_c", entries.kami_preacher_4_c)

	entries.kami_preacher_4_d =
	{
		Base="palette.entities.kami",
		SheetClient="kami_preacher_4_d.creature",
		Level=101,
		RingAccess="p1",
	}
	r2.addPaletteElement("palette.entities.npcs.kami.kami_preacher_4_d", entries.kami_preacher_4_d)

	entries.kami_preacher_4_e =
	{
		Base="palette.entities.kami",
		SheetClient="kami_preacher_4_e.creature",
		Level=151,
		RingAccess="p4",
	}
	r2.addPaletteElement("palette.entities.npcs.kami.kami_preacher_4_e", entries.kami_preacher_4_e)

	entries.kami_preacher_4_f =
	{
		Base="palette.entities.kami",
		SheetClient="kami_preacher_4_f.creature",
		Level=201,
		RingAccess="p10",
	}
	r2.addPaletteElement("palette.entities.npcs.kami.kami_preacher_4_f", entries.kami_preacher_4_f)

	entries.kami_preacher_4_g =
	{
		Base="palette.entities.kami",
		SheetClient="kami_preacher_4_g.creature",
		Level=1,
		RingAccess="p10",
	}
	r2.addPaletteElement("palette.entities.npcs.kami.kami_preacher_4_g", entries.kami_preacher_4_g)

	entries.kami_preacher_b =
	{
		Base="palette.entities.kami",
		SheetClient="kami_preacher_b.creature",
		Level=1,
		RingAccess="a1",
	}
	r2.addPaletteElement("palette.entities.npcs.kami.kami_preacher_b", entries.kami_preacher_b)

	entries.kami_preacher_c =
	{
		Base="palette.entities.kami",
		SheetClient="kami_preacher_c.creature",
		Level=51,
		RingAccess="p1",
	}
	r2.addPaletteElement("palette.entities.npcs.kami.kami_preacher_c", entries.kami_preacher_c)

	entries.kami_preacher_d =
	{
		Base="palette.entities.kami",
		SheetClient="kami_preacher_d.creature",
		Level=101,
		RingAccess="p1",
	}
	r2.addPaletteElement("palette.entities.npcs.kami.kami_preacher_d", entries.kami_preacher_d)

	entries.kami_preacher_e =
	{
		Base="palette.entities.kami",
		SheetClient="kami_preacher_e.creature",
		Level=151,
		RingAccess="p4",
	}
	r2.addPaletteElement("palette.entities.npcs.kami.kami_preacher_e", entries.kami_preacher_e)

	entries.kami_preacher_f =
	{
		Base="palette.entities.kami",
		SheetClient="kami_preacher_f.creature",
		Level=201,
		RingAccess="p10",
	}
	r2.addPaletteElement("palette.entities.npcs.kami.kami_preacher_f", entries.kami_preacher_f)


-- karavan
--  class abstraite
 	entries.karavan =
	{
		Base="palette.entities.npc",
		Name="Karavan",
		CanUpdatePlayerAttackable = 0,
		PlayerAttackable = 0,
		Profile = "guard",
		SubCategory = "Karavan",
		Fame="karavan",
	}
	r2.addPaletteElement("palette.entities.karavan", entries.karavan)

--  class concretes
-- karavan emissary
	entries.karavan_guard_k_f =
	{
		Base="palette.entities.karavan",
		SheetClient="karavan_guard_k_f.creature",
		Level=201,
		RingAccess="p10",
	}
	r2.addPaletteElement("palette.entities.npcs.karavan.karavan_guard_k_f", entries.karavan_guard_k_f)

	entries.karavan_guard_k_f_b =
	{
		Base="palette.entities.karavan",
		SheetClient="karavan_guard_k_f_b.creature",
		Level=1,
		RingAccess="a1",
	}
	r2.addPaletteElement("palette.entities.npcs.karavan.karavan_guard_k_f_b", entries.karavan_guard_k_f_b)

	entries.karavan_guard_k_f_c =
	{
		Base="palette.entities.karavan",
		SheetClient="karavan_guard_k_f_c.creature",
		Level=51,
		RingAccess="p1",
	}
	r2.addPaletteElement("palette.entities.npcs.karavan.karavan_guard_k_f_c", entries.karavan_guard_k_f_c)

	entries.karavan_guard_k_f_d =
	{
		Base="palette.entities.karavan",
		SheetClient="karavan_guard_k_f_d.creature",
		Level=101,
		RingAccess="p1",
	}
	r2.addPaletteElement("palette.entities.npcs.karavan.karavan_guard_k_f_d", entries.karavan_guard_k_f_d)

	entries.karavan_guard_k_f_e =
	{
		Base="palette.entities.karavan",
		SheetClient="karavan_guard_k_f_e.creature",
		Level=151,
		RingAccess="p4",
	}
	r2.addPaletteElement("palette.entities.npcs.karavan.karavan_guard_k_f_e", entries.karavan_guard_k_f_e)

	entries.karavan_guard_k_f_f =
	{
		Base="palette.entities.karavan",
		SheetClient="karavan_guard_k_f_f.creature",
		Level=201,
		RingAccess="p10",
	}
	r2.addPaletteElement("palette.entities.npcs.karavan.karavan_guard_k_f_f", entries.karavan_guard_k_f_f)

	entries.karavan_guard_k_h =
	{
		Base="palette.entities.karavan",
		SheetClient="karavan_guard_k_h.creature",
		Level=1,
		RingAccess="p10",
	}
	r2.addPaletteElement("palette.entities.npcs.karavan.karavan_guard_k_h", entries.karavan_guard_k_h)

	entries.karavan_guard_k_h_b =
	{
		Base="palette.entities.karavan",
		SheetClient="karavan_guard_k_h_b.creature",
		Level=1,
		RingAccess="a1",
	}
	r2.addPaletteElement("palette.entities.npcs.karavan.karavan_guard_k_h_b", entries.karavan_guard_k_h_b)

	entries.karavan_guard_k_h_c =
	{
		Base="palette.entities.karavan",
		SheetClient="karavan_guard_k_h_c.creature",
		Level=51,
		RingAccess="p1",
	}
	r2.addPaletteElement("palette.entities.npcs.karavan.karavan_guard_k_h_c", entries.karavan_guard_k_h_c)

	entries.karavan_guard_k_h_d =
	{
		Base="palette.entities.karavan",
		SheetClient="karavan_guard_k_h_d.creature",
		Level=101,
		RingAccess="p1",
	}
	r2.addPaletteElement("palette.entities.npcs.karavan.karavan_guard_k_h_d", entries.karavan_guard_k_h_d)

	entries.karavan_guard_k_h_e =
	{
		Base="palette.entities.karavan",
		SheetClient="karavan_guard_k_h_e.creature",
		Level=151,
		RingAccess="p4",
	}
	r2.addPaletteElement("palette.entities.npcs.karavan.karavan_guard_k_h_e", entries.karavan_guard_k_h_e)

	entries.karavan_guard_k_h_f =
	{
		Base="palette.entities.karavan",
		SheetClient="karavan_guard_k_h_f.creature",
		Level=201,
		RingAccess="p10",
	}
	r2.addPaletteElement("palette.entities.npcs.karavan.karavan_guard_k_h_f", entries.karavan_guard_k_h_f)
-- karavan emissary
	entries.karavan_emissary_f =
	{
		Base="palette.entities.karavan",
		SheetClient="karavan_emissary_f.creature",
		Level=201,
		RingAccess="p10",
	}
	r2.addPaletteElement("palette.entities.npcs.karavan.karavan_emissary_f", entries.karavan_emissary_f)

	entries.karavan_emissary_f_b =
	{
		Base="palette.entities.karavan",
		SheetClient="karavan_emissary_f_b.creature",
		Level=1,
		RingAccess="a1",
	}
	r2.addPaletteElement("palette.entities.npcs.karavan.karavan_emissary_f_b", entries.karavan_emissary_f_b)

	entries.karavan_emissary_f_c =
	{
		Base="palette.entities.karavan",
		SheetClient="karavan_emissary_f_c.creature",
		Level=51,
		RingAccess="p1",
	}
	r2.addPaletteElement("palette.entities.npcs.karavan.karavan_emissary_f_c", entries.karavan_emissary_f_c)

	entries.karavan_emissary_f_d =
	{
		Base="palette.entities.karavan",
		SheetClient="karavan_emissary_f_d.creature",
		Level=101,
		RingAccess="p1",
	}
	r2.addPaletteElement("palette.entities.npcs.karavan.karavan_emissary_f_d", entries.karavan_emissary_f_d)

	entries.karavan_emissary_f_e =
	{
		Base="palette.entities.karavan",
		SheetClient="karavan_emissary_f_e.creature",
		Level=151,
		RingAccess="p4",
	}
	r2.addPaletteElement("palette.entities.npcs.karavan.karavan_emissary_f_e", entries.karavan_emissary_f_e)

	entries.karavan_emissary_f_f =
	{
		Base="palette.entities.karavan",
		SheetClient="karavan_emissary_f_f.creature",
		Level=201,
		RingAccess="p10",
	}
	r2.addPaletteElement("palette.entities.npcs.karavan.karavan_emissary_f_f", entries.karavan_emissary_f_f)

	entries.karavan_emissary_h =
	{
		Base="palette.entities.karavan",
		SheetClient="karavan_emissary_h.creature",
		Level=1,
		RingAccess="p10",
	}
	r2.addPaletteElement("palette.entities.npcs.karavan.karavan_emissary_h", entries.karavan_emissary_h)

	entries.karavan_emissary_h_b =
	{
		Base="palette.entities.karavan",
		SheetClient="karavan_emissary_h_b.creature",
		Level=1,
		RingAccess="a1",
	}
	r2.addPaletteElement("palette.entities.npcs.karavan.karavan_emissary_h_b", entries.karavan_emissary_h_b)

	entries.karavan_emissary_h_c =
	{
		Base="palette.entities.karavan",
		SheetClient="karavan_emissary_h_c.creature",
		Level=51,
		RingAccess="p1",
	}
	r2.addPaletteElement("palette.entities.npcs.karavan.karavan_emissary_h_c", entries.karavan_emissary_h_c)

	entries.karavan_emissary_h_d =
	{
		Base="palette.entities.karavan",
		SheetClient="karavan_emissary_h_d.creature",
		Level=101,
		RingAccess="p1",
	}
	r2.addPaletteElement("palette.entities.npcs.karavan.karavan_emissary_h_d", entries.karavan_emissary_h_d)

	entries.karavan_emissary_h_e =
	{
		Base="palette.entities.karavan",
		SheetClient="karavan_emissary_h_e.creature",
		Level=151,
		RingAccess="p4",
	}
	r2.addPaletteElement("palette.entities.npcs.karavan.karavan_emissary_h_e", entries.karavan_emissary_h_e)

	entries.karavan_emissary_h_f =
	{
		Base="palette.entities.karavan",
		SheetClient="karavan_emissary_h_f.creature",
		Level=201,
		RingAccess="p10",
	}
	r2.addPaletteElement("palette.entities.npcs.karavan.karavan_emissary_h_f", entries.karavan_emissary_h_f)


-- bot objects start here -- 
--	 parent of all bot object (like palette.entities.npc for npcs)
--	 abstract element(cannot be instanciated)
	entries.botobject =
	{
		BoxSelection=0,
		IsStuck=1,			
		AiMovement="stand_on_start_point", 
		Profile="no_change",
		IsBotObject = 1,
		RingAccess = "a1", -- global by default
	}
	r2.addPaletteElement("palette.entities.botobject", entries.botobject);



	entries.barrel1 =
	{
		Base="palette.entities.botobject",
		Name="Barrel 1",
		SheetClient="object_1_barrel.creature",				
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.barrel1", entries.barrel1);

	entries.barrels3 =
	{
		Base="palette.entities.botobject",
		Name="Barrels 3",
		SheetClient="object_3_barrels.creature",				
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.barrels_3", entries.barrels3);
	entries.barrelsBroken =
	{
		Base="palette.entities.botobject",
		Name="barrelsBroken",
		SheetClient="object_1_barrel_broken.creature",				
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.barrel_broken_1", entries.barrelsBroken);

	entries.jar1 =
	{
		Base="palette.entities.botobject",
		Name="Jar 1",
		SheetClient="object_jar.creature",				
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.jar1", entries.jar1);
	
	entries.jar2 =
	{
		Base="palette.entities.botobject",
		Name = "Jar 2",
		SheetClient="object_jar_fallen.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.jar2", entries.jar2);

	entries.crate1 =
	{
		Base="palette.entities.botobject",
		Name="Crate 1",
		SheetClient="object_1_crate.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.crate1",entries.crate1)

	entries.crate2 =
	{
		Base="palette.entities.botobject",
		Name="Crate 2",
		SheetClient="object_3_crate.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.crate2",entries.crate2)

	entries.bones1 =
	{
		Base="palette.entities.botobject",
		Name="Bones 1",
		SheetClient="object_bones.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.bones1",entries.bones1)
	
	entries.tent1 =
	{
		Base="palette.entities.botobject",
		Name="Tent 1",
		SheetClient="object_tent.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.tent1",entries.tent1)

	entries.pack1 =
	{
		Base="palette.entities.botobject",
		Name="Pack 1",
		SheetClient="object_pack_1.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.pack1",entries.pack1)

-- test Bot-object

	entries.jar=
	{
		Base="palette.entities.botobject",
		Name = "jar",
		SheetClient="object_jar.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.jar", entries.jar);
	entries.jar_3=
	{
		Base="palette.entities.botobject",
		Name = "jar_3",
		SheetClient="object_jar_3.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.jar_3", entries.jar_3);
	entries.jar_fallen=
	{
		Base="palette.entities.botobject",
		Name = "jar_fallen",
		SheetClient="object_jar_fallen.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.jar_fallen", entries.jar_fallen);
	entries.hut=
	{
		Base="palette.entities.botobject",
		Name = "hut",
		SheetClient="object_hut.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.hut", entries.hut);
	entries.paddock=
	{
		Base="palette.entities.botobject",
		Name = "paddock",
		SheetClient="object_paddock.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.paddock", entries.paddock);
	entries.totem_kami=
	{
		Base="palette.entities.botobject",
		Name = "totem_kami",
		SheetClient="object_totem_kami.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.totem_kami", entries.totem_kami);
	entries.totem_pachyderm=
	{
		Base="palette.entities.botobject",
		Name = "totem_pachyderm",
		SheetClient="object_totem_pachyderm.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.totem_pachyderm", entries.totem_pachyderm);
	entries.tent=
	{
		Base="palette.entities.botobject",
		Name = "tent",
		SheetClient="object_tent.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.tent", entries.tent);
	entries.tent_fyros=
	{
		Base="palette.entities.botobject",
		Name = "tent_fyros",
		SheetClient="object_tent_fyros.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.tent_fyros", entries.tent_fyros);
	entries.tent_matis=
	{
		Base="palette.entities.botobject",
		Name = "tent_matis",
		SheetClient="object_tent_matis.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.tent_matis", entries.tent_matis);
	entries.tent_tryker=
	{
		Base="palette.entities.botobject",
		Name = "tent_tryker",
		SheetClient="object_tent_tryker.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.tent_tryker", entries.tent_tryker);
	entries.tent_zorai=
	{
		Base="palette.entities.botobject",
		Name = "tent_zorai",
		SheetClient="object_tent_zorai.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.tent_zorai", entries.tent_zorai);
	entries.totem_kitin=
	{
		Base="palette.entities.botobject",
		Name = "totem_kitin",
		SheetClient="object_totem_kitin.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.totem_kitin", entries.totem_kitin);
	entries.totem_bird=
	{
		Base="palette.entities.botobject",
		Name = "totem_bird",
		SheetClient="object_totem_bird.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.totem_bird", entries.totem_bird);
	entries.tower_ruin=
	{
		Base="palette.entities.botobject",
		Name = "tower_ruin",
		SheetClient="object_tower_ruin.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.tower_ruin", entries.tower_ruin);
	entries.stele=
	{
		Base="palette.entities.botobject",
		Name = "stele",
		SheetClient="object_stele.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.stele", entries.stele);
	entries.chariot=
	{
		Base="palette.entities.botobject",
		Name = "chariot",
		SheetClient="object_chariot.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.chariot", entries.chariot);
	entries.chariot_working=
	{
		Base="palette.entities.botobject",
		Name = "chariot_working",
		SheetClient="object_chariot_working.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.chariot_working", entries.chariot_working);
	entries.wind_turbine=
	{
		Base="palette.entities.botobject",
		Name = "wind_turbine",
		SheetClient="object_wind_turbine.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.wind_turbine", entries.wind_turbine);
	entries.street_lamp=
	{
		Base="palette.entities.botobject",
		Name = "street_lamp",
		SheetClient="object_street_lamp.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.street_lamp", entries.street_lamp);
	entries.street_lamp_off=
	{
		Base="palette.entities.botobject",
		Name = "street_lamp_off",
		SheetClient="object_street_lamp_off.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.street_lamp_off", entries.street_lamp_off);
	entries.tomb_1=
	{
		Base="palette.entities.botobject",
		Name = "tomb_1",
		SheetClient="object_tomb_1.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.tomb_1", entries.tomb_1);
	entries.tomb_2=
	{
		Base="palette.entities.botobject",
		Name = "tomb_2",
		SheetClient="object_tomb_2.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.tomb_2", entries.tomb_2);
	entries.tomb_3=
	{
		Base="palette.entities.botobject",
		Name = "tomb_3",
		SheetClient="object_tomb_3.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.tomb_3", entries.tomb_3);
	entries.tomb_4=
	{
		Base="palette.entities.botobject",
		Name = "tomb_4",
		SheetClient="object_tomb_4.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.tomb_4", entries.tomb_4);
	entries.tomb_5=
	{
		Base="palette.entities.botobject",
		Name = "tomb_5",
		SheetClient="object_tomb_5.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.tomb_5", entries.tomb_5);
	entries.campfire=
	{
		Base="palette.entities.botobject",
		Name = "campfire",
		SheetClient="object_campfire.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.campfire", entries.campfire);
	entries.campfire_out=
	{
		Base="palette.entities.botobject",
		Name = "campfire_out",
		SheetClient="object_campfire_out.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.campfire_out", entries.campfire_out);
	entries.fire_base=
	{
		Base="palette.entities.botobject",
		Name = "fire_base",
		SheetClient="object_fire_base.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fire_base", entries.fire_base);
	entries.chest=
	{
		Base="palette.entities.botobject",
		Name = "chest",
		SheetClient="object_chest.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.chest", entries.chest);
	entries.chest_old=
	{
		Base="palette.entities.botobject",
		Name = "chest_old",
		SheetClient="object_chest_old.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.chest_old", entries.chest_old);
	entries.stump=
	{
		Base="palette.entities.botobject",
		Name = "stump",
		SheetClient="object_stump.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.stump", entries.stump);
	entries.carrion_mammal=
	{
		Base="palette.entities.botobject",
		Name = "carrion_mammal",
		SheetClient="object_carrion_mammal.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.carrion_mammal", entries.carrion_mammal);
	entries.carrion_insect=
	{
		Base="palette.entities.botobject",
		Name = "carrion_insect",
		SheetClient="object_carrion_insect.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.carrion_insect", entries.carrion_insect);
	entries.bones=
	{
		Base="palette.entities.botobject",
		Name = "bones",
		SheetClient="object_bones.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.bones", entries.bones);
	entries.bones_b=
	{
		Base="palette.entities.botobject",
		Name = "bones_b",
		SheetClient="object_bones_b.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.bones_b", entries.bones_b);
	entries.barrier=
	{
		Base="palette.entities.botobject",
		Name = "barrier",
		SheetClient="object_barrier.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.barrier", entries.barrier);
	entries.barrier_T=
	{
		Base="palette.entities.botobject",
		Name = "barrier_T",
		SheetClient="object_barrier_T.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.barrier_T", entries.barrier_T);
	entries.house_ruin=
	{
		Base="palette.entities.botobject",
		Name = "house_ruin",
		SheetClient="object_house_ruin.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.house_ruin", entries.house_ruin);
	entries.roadsign=
	{
		Base="palette.entities.botobject",
		Name = "roadsign",
		SheetClient="object_roadsign.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.roadsign", entries.roadsign);
	entries.watch_tower=
	{
		Base="palette.entities.botobject",
		Name = "watch_tower",
		SheetClient="object_watch_tower.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.watch_tower", entries.watch_tower);
	entries.landslide_desert=
	{
		Base="palette.entities.botobject",
		Name = "landslide_desert",
		SheetClient="object_landslide_desert.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.landslide_desert", entries.landslide_desert);
	entries.tent_cosmetics=
	{
		Base="palette.entities.botobject",
		Name = "tent_cosmetics",
		SheetClient="object_tent_cosmetics.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.tent_cosmetics", entries.tent_cosmetics);
	entries.landslide_jungle=
	{
		Base="palette.entities.botobject",
		Name = "landslide_jungle",
		SheetClient="object_landslide_jungle.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.landslide_jungle", entries.landslide_jungle);
	entries.landslide_lake=
	{
		Base="palette.entities.botobject",
		Name = "landslide_lake",
		SheetClient="object_landslide_lake.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.landslide_lake", entries.landslide_lake);
	entries.carapace_bul=
	{
		Base="palette.entities.botobject",
		Name = "carapace_bul",
		SheetClient="object_carapace_bul.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.carapace_bul", entries.carapace_bul);
	entries.carapace_2=
	{
		Base="palette.entities.botobject",
		Name = "carapace_2",
		SheetClient="object_carapace_2.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.carapace_2", entries.carapace_2);
	entries.giant_skull=
	{
		Base="palette.entities.botobject",
		Name = "giant_skull",
		SheetClient="object_giant_skull.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.giant_skull", entries.giant_skull);
	entries.ruin_wall=
	{
		Base="palette.entities.botobject",
		Name = "ruin_wall",
		SheetClient="object_ruin_wall.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.ruin_wall", entries.ruin_wall);
	entries.ruin_wall_b=
	{
		Base="palette.entities.botobject",
		Name = "ruin_wall_b",
		SheetClient="object_ruin_wall_b.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.ruin_wall_b", entries.ruin_wall_b);
	entries.karavan_altar=
	{
		Base="palette.entities.botobject",
		Name = "karavan_altar",
		SheetClient="object_karavan_altar.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.karavan_altar", entries.karavan_altar);
	entries.kami_altar=
	{
		Base="palette.entities.botobject",
		Name = "kami_altar",
		SheetClient="object_kami_altar.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.kami_altar", entries.kami_altar);
	entries.milestone=
	{
		Base="palette.entities.botobject",
		Name = "milestone",
		SheetClient="object_milestone.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.milestone", entries.milestone);
	entries.bag_a=
	{
		Base="palette.entities.botobject",
		Name = "bag_a",
		SheetClient="object_bag_a.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.bag_a", entries.bag_a);
	entries.bag_b=
	{
		Base="palette.entities.botobject",
		Name = "bag_b",
		SheetClient="object_bag_b.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.bag_b", entries.bag_b);
	entries.pack_1=
	{
		Base="palette.entities.botobject",
		Name = "pack_1",
		SheetClient="object_pack_1.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.pack_1", entries.pack_1);
	entries.pack_2=
	{
		Base="palette.entities.botobject",
		Name = "pack_2",
		SheetClient="object_pack_2.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.pack_2", entries.pack_2);
	entries.pack_3=
	{
		Base="palette.entities.botobject",
		Name = "pack_3",
		SheetClient="object_pack_3.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.pack_3", entries.pack_3);
	entries.pack_4=
	{
		Base="palette.entities.botobject",
		Name = "pack_4",
		SheetClient="object_pack_4.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.pack_4", entries.pack_4);
	entries.pack_5=
	{
		Base="palette.entities.botobject",
		Name = "pack_5",
		SheetClient="object_pack_5.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.pack_5", entries.pack_5);
	entries.runic_circle=
	{
		Base="palette.entities.botobject",
		Name = "runic_circle",
		SheetClient="object_runic_circle.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.runic_circle", entries.runic_circle);
	entries.karavan_device=
	{
		Base="palette.entities.botobject",
		Name = "karavan_device",
		SheetClient="object_karavan_device.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.karavan_device", entries.karavan_device);
	entries.kitin_egg=
	{
		Base="palette.entities.botobject",
		Name = "kitin_egg",
		SheetClient="object_kitin_egg.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.kitin_egg", entries.kitin_egg);
	entries.bones_homin_a=
	{
		Base="palette.entities.botobject",
		Name = "bones_homin_a",
		SheetClient="object_bones_homin_a.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.bones_homin_a", entries.bones_homin_a);
	entries.bones_homin_b=
	{
		Base="palette.entities.botobject",
		Name = "bones_homin_b",
		SheetClient="object_bones_homin_b.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.bones_homin_b", entries.bones_homin_b);
	entries.spot_kitin=
	{
		Base="palette.entities.botobject",
		Name = "spot_kitin",
		SheetClient="object_spot_kitin.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.spot_kitin", entries.spot_kitin);
	entries.spot_goo=
	{
		Base="palette.entities.botobject",
		Name = "spot_goo",
		SheetClient="object_spot_goo.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.spot_goo", entries.spot_goo);
	entries.merchant_melee_fyros=
	{
		Base="palette.entities.botobject",
		Name = "merchant_melee_fyros",
		SheetClient="object_merchant_melee_fyros.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.merchant_melee_fyros", entries.merchant_melee_fyros);
	entries.merchant_melee_matis=
	{
		Base="palette.entities.botobject",
		Name = "merchant_melee_matis",
		SheetClient="object_merchant_melee_matis.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.merchant_melee_matis", entries.merchant_melee_matis);
	entries.merchant_melee_tryker=
	{
		Base="palette.entities.botobject",
		Name = "merchant_melee_tryker",
		SheetClient="object_merchant_melee_tryker.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.merchant_melee_tryker", entries.merchant_melee_tryker);



	entries.merchant_melee_zorai=
	{
		Base="palette.entities.botobject",
		Name = "merchant_melee_zorai",
		SheetClient="object_merchant_melee_zorai.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.merchant_melee_zorai", entries.merchant_melee_zorai);
	entries.merchant_range_fyros=
	{
		Base="palette.entities.botobject",
		Name = "merchant_range_fyros",
		SheetClient="object_merchant_range_fyros.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.merchant_range_fyros", entries.merchant_range_fyros);
	entries.merchant_range_matis=
	{
		Base="palette.entities.botobject",
		Name = "merchant_range_matis",
		SheetClient="object_merchant_range_matis.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.merchant_range_matis", entries.merchant_range_matis);
	entries.merchant_range_tryker=
	{
		Base="palette.entities.botobject",
		Name = "merchant_range_tryker",
		SheetClient="object_merchant_range_tryker.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.merchant_range_tryker", entries.merchant_range_tryker);
	entries.merchant_range_zorai=
	{
		Base="palette.entities.botobject",
		Name = "merchant_range_zorai",
		SheetClient="object_merchant_range_zorai.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.merchant_range_zorai", entries.merchant_range_zorai);
	entries.merchant_armor_fyros=
	{
		Base="palette.entities.botobject",
		Name = "merchant_armor_fyros",
		SheetClient="object_merchant_armor_fyros.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.merchant_armor_fyros", entries.merchant_armor_fyros);
	entries.merchant_armor_matis=
	{
		Base="palette.entities.botobject",
		Name = "merchant_armor_matis",
		SheetClient="object_merchant_armor_matis.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.merchant_armor_matis", entries.merchant_armor_matis);
	entries.merchant_armor_tryker=
	{
		Base="palette.entities.botobject",
		Name = "merchant_armor_tryker",
		SheetClient="object_merchant_armor_tryker.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.merchant_armor_tryker", entries.merchant_armor_tryker);
	entries.merchant_armor_zorai=
	{
		Base="palette.entities.botobject",
		Name = "merchant_armor_zorai",
		SheetClient="object_merchant_armor_zorai.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.merchant_armor_zorai", entries.merchant_armor_zorai);
	entries.merchant_RM_fyros=
	{
		Base="palette.entities.botobject",
		Name = "merchant_RM_fyros",
		SheetClient="object_merchant_RM_fyros.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.merchant_RM_fyros", entries.merchant_RM_fyros);
	entries.merchant_RM_matis=
	{
		Base="palette.entities.botobject",
		Name = "merchant_RM_matis",
		SheetClient="object_merchant_RM_matis.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.merchant_RM_matis", entries.merchant_RM_matis);
	entries.merchant_RM_tryker=
	{
		Base="palette.entities.botobject",
		Name = "merchant_RM_tryker",
		SheetClient="object_merchant_RM_tryker.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.merchant_RM_tryker", entries.merchant_RM_tryker);
	entries.merchant_RM_zorai=
	{
		Base="palette.entities.botobject",
		Name = "merchant_RM_zorai",
		SheetClient="object_merchant_RM_zorai.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.merchant_RM_zorai", entries.merchant_RM_zorai);
	entries.merchant_tool_fyros=
	{
		Base="palette.entities.botobject",
		Name = "merchant_tool_fyros",
		SheetClient="object_merchant_tool_fyros.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.merchant_tool_fyros", entries.merchant_tool_fyros);
	entries.merchant_tool_matis=
	{
		Base="palette.entities.botobject",
		Name = "merchant_tool_matis",
		SheetClient="object_merchant_tool_matis.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.merchant_tool_matis", entries.merchant_tool_matis);
	entries.merchant_tool_tryker=
	{
		Base="palette.entities.botobject",
		Name = "merchant_tool_tryker",
		SheetClient="object_merchant_tool_tryker.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.merchant_tool_tryker", entries.merchant_tool_tryker);
	entries.merchant_tool_zorai=
	{
		Base="palette.entities.botobject",
		Name = "merchant_tool_zorai",
		SheetClient="object_merchant_tool_zorai.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.merchant_tool_zorai", entries.merchant_tool_zorai);
	entries.merchant_focus_fyros=
	{
		Base="palette.entities.botobject",
		Name = "merchant_focus_fyros",
		SheetClient="object_merchant_focus_fyros.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.merchant_focus_fyros", entries.merchant_focus_fyros);
	entries.merchant_focus_matis=
	{
		Base="palette.entities.botobject",
		Name = "merchant_focus_matis",
		SheetClient="object_merchant_focus_matis.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.merchant_focus_matis", entries.merchant_focus_matis);
	entries.merchant_focus_tryker=
	{
		Base="palette.entities.botobject",
		Name = "merchant_focus_tryker",
		SheetClient="object_merchant_focus_tryker.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.merchant_focus_tryker", entries.merchant_focus_tryker);
	entries.merchant_focus_zorai=
	{
		Base="palette.entities.botobject",
		Name = "merchant_focus_zorai",
		SheetClient="object_merchant_focus_zorai.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.merchant_focus_zorai", entries.merchant_focus_zorai);
	entries.merchant_haircut_fyros=
	{
		Base="palette.entities.botobject",
		Name = "merchant_haircut_fyros",
		SheetClient="object_merchant_haircut_fyros.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.merchant_haircut_fyros", entries.merchant_haircut_fyros);
	entries.merchant_haircut_matis=
	{
		Base="palette.entities.botobject",
		Name = "merchant_haircut_matis",
		SheetClient="object_merchant_haircut_matis.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.merchant_haircut_matis", entries.merchant_haircut_matis);
	entries.merchant_haircut_tryker=
	{
		Base="palette.entities.botobject",
		Name = "merchant_haircut_tryker",
		SheetClient="object_merchant_haircut_tryker.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.merchant_haircut_tryker", entries.merchant_haircut_tryker);
	entries.merchant_haircut_zorai=
	{
		Base="palette.entities.botobject",
		Name = "merchant_haircut_zorai",
		SheetClient="object_merchant_haircut_zorai.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.merchant_haircut_zorai", entries.merchant_haircut_zorai);
	entries.merchant_tatoo_fyros=
	{
		Base="palette.entities.botobject",
		Name = "merchant_tatoo_fyros",
		SheetClient="object_merchant_tatoo_fyros.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.merchant_tatoo_fyros", entries.merchant_tatoo_fyros);
	entries.merchant_tatoo_matis=
	{
		Base="palette.entities.botobject",
		Name = "merchant_tatoo_matis",
		SheetClient="object_merchant_tatoo_matis.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.merchant_tatoo_matis", entries.merchant_tatoo_matis);
	entries.merchant_tatoo_tryker=
	{
		Base="palette.entities.botobject",
		Name = "merchant_tatoo_tryker",
		SheetClient="object_merchant_tatoo_tryker.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.merchant_tatoo_tryker", entries.merchant_tatoo_tryker);
	entries.merchant_tatoo_zorai=
	{
		Base="palette.entities.botobject",
		Name = "merchant_tatoo_zorai",
		SheetClient="object_merchant_tatoo_zorai.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.merchant_tatoo_zorai", entries.merchant_tatoo_zorai);
	entries.merchant_bijoux_fyros=
	{
		Base="palette.entities.botobject",
		Name = "merchant_bijoux_fyros",
		SheetClient="object_merchant_bijoux_fyros.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.merchant_bijoux_fyros", entries.merchant_bijoux_fyros);
	entries.merchant_bijoux_matis=
	{
		Base="palette.entities.botobject",
		Name = "merchant_bijoux_matis",
		SheetClient="object_merchant_bijoux_matis.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.merchant_bijoux_matis", entries.merchant_bijoux_matis);
	entries.merchant_bijoux_tryker=
	{
		Base="palette.entities.botobject",
		Name = "merchant_bijoux_tryker",
		SheetClient="object_merchant_bijoux_tryker.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.merchant_bijoux_tryker", entries.merchant_bijoux_tryker);
	entries.merchant_bijoux_zorai=
	{
		Base="palette.entities.botobject",
		Name = "merchant_bijoux_zorai",
		SheetClient="object_merchant_bijoux_zorai.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.merchant_bijoux_zorai", entries.merchant_bijoux_zorai);
	entries.merchant_bar_matis=
	{
		Base="palette.entities.botobject",
		Name = "merchant_bar_matis",
		SheetClient="object_merchant_bar_matis.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.merchant_bar_matis", entries.merchant_bar_matis);
	entries.merchant_bar_zorai=
	{
		Base="palette.entities.botobject",
		Name = "merchant_bar_zorai",
		SheetClient="object_merchant_bar_zorai.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.merchant_bar_zorai", entries.merchant_bar_zorai);
	entries.roadsign=
	{
		Base="palette.entities.botobject",
		Name = "roadsign",
		SheetClient="object_roadsign.creature",
		Level=1,
	}
--	r2.addPaletteElement("palette.entities.botobjects.roadsign", entries.roadsign);
	entries.roadsign_fyros=
	{
		Base="palette.entities.botobject",
		Name = "roadsign_fyros",
		SheetClient="object_roadsign_fyros.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.roadsign_fyros", entries.roadsign_fyros);
	entries.roadsign_zorai=
	{
		Base="palette.entities.botobject",
		Name = "roadsign_zorai",
		SheetClient="object_roadsign_zorai.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.roadsign_zorai", entries.roadsign_zorai);
	entries.roadsign_tryker=
	{
		Base="palette.entities.botobject",
		Name = "roadsign_tryker",
		SheetClient="object_roadsign_tryker.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.roadsign_tryker", entries.roadsign_tryker);
	entries.banner_kami=
	{
		Base="palette.entities.botobject",
		Name = "banner_kami",
		SheetClient="object_banner_kami.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.banner_kami", entries.banner_kami);
	entries.banner_karavan=
	{
		Base="palette.entities.botobject",
		Name = "banner_karavan",
		SheetClient="object_banner_karavan.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.banner_karavan", entries.banner_karavan);
	entries.counter=
	{
		Base="palette.entities.botobject",
		Name = "counter",
		SheetClient="object_counter.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.counter", entries.counter);
	entries.homin_body_fyros_H=
	{
		Base="palette.entities.botobject",
		Name = "homin_body_fyros_H",
		SheetClient="object_homin_body_fyros_H.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.homin_body_fyros_H", entries.homin_body_fyros_H);
	entries.homin_body_fyros_F=
	{
		Base="palette.entities.botobject",
		Name = "homin_body_fyros_F",
		SheetClient="object_homin_body_fyros_F.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.homin_body_fyros_F", entries.homin_body_fyros_F);
	entries.homin_body_matis_H=
	{
		Base="palette.entities.botobject",
		Name = "homin_body_matis_H",
		SheetClient="object_homin_body_matis_H.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.homin_body_matis_H", entries.homin_body_matis_H);
	entries.homin_body_matis_F=
	{
		Base="palette.entities.botobject",
		Name = "homin_body_matis_F",
		SheetClient="object_homin_body_matis_F.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.homin_body_matis_F", entries.homin_body_matis_F);
	entries.homin_body_tryker_H=
	{
		Base="palette.entities.botobject",
		Name = "homin_body_tryker_H",
		SheetClient="object_homin_body_tryker_H.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.homin_body_tryker_H", entries.homin_body_tryker_H);
	entries.homin_body_tryker_F=
	{
		Base="palette.entities.botobject",
		Name = "homin_body_tryker_F",
		SheetClient="object_homin_body_tryker_F.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.homin_body_tryker_F", entries.homin_body_tryker_F);
	entries.homin_body_zorai_H=
	{
		Base="palette.entities.botobject",
		Name = "homin_body_zorai_H",
		SheetClient="object_homin_body_zorai_H.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.homin_body_zorai_H", entries.homin_body_zorai_H);
	entries.homin_body_zorai_F=
	{
		Base="palette.entities.botobject",
		Name = "homin_body_zorai_F",
		SheetClient="object_homin_body_zorai_F.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.homin_body_zorai_F", entries.homin_body_zorai_F);
	entries.karavan_standard=
	{
		Base="palette.entities.botobject",
		Name = "karavan_standard",
		SheetClient="object_karavan_standard.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.karavan_standard", entries.karavan_standard);
	entries.karavan_tent=
	{
		Base="palette.entities.botobject",
		Name = "karavan_tent",
		SheetClient="object_karavan_tent.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.karavan_tent", entries.karavan_tent);
	entries.karavan_big_wall=
	{
		Base="palette.entities.botobject",
		Name = "karavan_big_wall",
		SheetClient="object_karavan_big_wall.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.karavan_big_wall", entries.karavan_big_wall);
	entries.construction_site=
	{
		Base="palette.entities.botobject",
		Name = "construction_site",
		SheetClient="object_construction_site.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.construction_site", entries.construction_site);
		entries.statue_maduk=
	{
		Base="palette.entities.botobject",
		Name = "statue_maduk",
		SheetClient="object_statue_maduk.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.statue_maduk", entries.statue_maduk);
	entries.statue_jena=
	{
		Base="palette.entities.botobject",
		Name = "statue_jena",
		SheetClient="object_statue_jena.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.statue_jena", entries.statue_jena);
	entries.hall_of_fame=
	{
		Base="palette.entities.botobject",
		Name = "hall_of_fame",
		SheetClient="object_stele_hall_of_fame.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.hall_of_fame", entries.hall_of_fame);
	entries.kami_watchtower_off=
	{
		Base="palette.entities.botobject",
		Name = "kami_watchtower_off",
		SheetClient="object_kami_watchtower_off.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.kami_watchtower_off", entries.kami_watchtower_off);
	entries.spot_goo_off=
	{
		Base="palette.entities.botobject",
		Name = "spot_goo_off",
		SheetClient="object_spot_goo_off.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.spot_goo_off", entries.spot_goo_off);
	entries.campfire_off=
	{
		Base="palette.entities.botobject",
		Name = "campfire_off",
		SheetClient="object_campfire_off.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.campfire_off", entries.campfire_off);
	entries.karavan_wall=
	{
		Base="palette.entities.botobject",
		Name = "karavan_wall",
		SheetClient="object_karavan_wall.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.karavan_wall", entries.karavan_wall);
	entries.karavan_mirador=
	{
		Base="palette.entities.botobject",
		Name = "karavan_mirador",
		SheetClient="object_karavan_mirador.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.karavan_mirador", entries.karavan_mirador);
	entries.karavan_watchtower_off=
	{
		Base="palette.entities.botobject",
		Name = "karavan_watchtower_off",
		SheetClient="object_karavan_watchtower_off.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.karavan_watchtower_off", entries.karavan_watchtower_off);
	entries.karavan_gateway=
	{
		Base="palette.entities.botobject",
		Name = "karavan_gateway",
		SheetClient="object_karavan_gateway.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.karavan_gateway", entries.karavan_gateway);
	entries.kami_standard=
	{
		Base="palette.entities.botobject",
		Name = "kami_standard",
		SheetClient="object_kami_standard.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.kami_standard", entries.kami_standard);
	entries.kami_hut=
	{
		Base="palette.entities.botobject",
		Name = "kami_hut",
		SheetClient="object_kami_hut.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.kami_hut", entries.kami_hut);
	entries.vegetable_wall=
	{
		Base="palette.entities.botobject",
		Name = "vegetable_wall",
		SheetClient="object_vegetable_wall.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.vegetable_wall", entries.vegetable_wall);
	entries.kami_watchtower=
	{
		Base="palette.entities.botobject",
		Name = "kami_watchtower",
		SheetClient="object_kami_watchtower.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.kami_watchtower", entries.kami_watchtower);
	entries.vegetable_gateway=
	{
		Base="palette.entities.botobject",
		Name = "vegetable_gateway",
		SheetClient="object_vegetable_gateway.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.vegetable_gateway", entries.vegetable_gateway);

	entries.fo_milestone=
	{
		Base="palette.entities.botobject",
		Name = "fo_milestone",
		SheetClient="object_fo_milestone.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fo_milestone", entries.fo_milestone);
	
	entries.flame_courage=
	{
		Base="palette.entities.botobject",
		Name = "flame_courage",
		SheetClient="object_flame_courage.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.flame_courage", entries.flame_courage);

	entries.flame_justice=
	{
		Base="palette.entities.botobject",
		Name = "flame_justice",
		SheetClient="object_flame_justice.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.flame_justice", entries.flame_justice);

	entries.flame_discipline=
	{
		Base="palette.entities.botobject",
		Name = "flame_discipline",
		SheetClient="object_flame_discipline.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.flame_discipline", entries.flame_discipline);

	entries.flame_verite=
	{
		Base="palette.entities.botobject",
		Name = "flame_verite",
		SheetClient="object_flame_verite.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.flame_verite", entries.flame_verite);
	entries.generic_hall=
	{
		Base="palette.entities.botobject",
		Name = "generic_hall",
		SheetClient="object_generic_hall.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.generic_hall", entries.generic_hall);
-- Dbut Dclaration composants et easter eggs
	entries.user_event=
	{
		Base="palette.entities.botobject",
		Name = "user_event",
		SheetClient="object_component_user_event.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.user_event", entries.user_event);
	entries.time_trigger=
	{
		Base="palette.entities.botobject",
		Name = "time_trigger",
		SheetClient="object_component_time_trigger.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.time_trigger", entries.time_trigger);
	entries.bot_request_item=
	{
		Base="palette.entities.botobject",
		Name = "bot_request_item",
		SheetClient="object_component_bot_request_item.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.bot_request_item", entries.bot_request_item);
	entries.timer=
	{
		Base="palette.entities.botobject",
		Name = "timer",
		SheetClient="object_component_timer.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.timer", entries.timer);
	entries.trigger_zone=
	{
		Base="palette.entities.botobject",
		Name = "trigger_zone",
		SheetClient="object_component_trigger_zone.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.trigger_zone", entries.trigger_zone);
	entries.bot_chat=
	{
		Base="palette.entities.botobject",
		Name = "bot_chat",
		SheetClient="object_component_bot_chat.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.bot_chat", entries.bot_chat);
	entries.dialog=
	{
		Base="palette.entities.botobject",
		Name = "dialog",
		SheetClient="object_component_dialog.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.dialog", entries.dialog);
	entries.chest_wisdom_fyros_sel=
	{
		Base="palette.entities.botobject",
		Name = "chest_wisdom_fyros_sel",
		SheetClient="object_chest_wisdom_fyros_sel.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.chest_wisdom_fyros_sel", entries.chest_wisdom_fyros_sel);
	entries.chest_wisdom_matis_sel=
	{
		Base="palette.entities.botobject",
		Name = "chest_wisdom_matis_sel",
		SheetClient="object_chest_wisdom_matis_sel.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.chest_wisdom_matis_sel", entries.chest_wisdom_matis_sel);
	entries.chest_wisdom_std_sel=
	{
		Base="palette.entities.botobject",
		Name = "chest_wisdom_std_sel",
		SheetClient="object_chest_wisdom_std_sel.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.chest_wisdom_std_sel", entries.chest_wisdom_std_sel);
	entries.chest_wisdom_tryker_sel=
	{
		Base="palette.entities.botobject",
		Name = "chest_wisdom_tryker_sel",
		SheetClient="object_chest_wisdom_tryker_sel.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.chest_wisdom_tryker_sel", entries.chest_wisdom_tryker_sel);
	entries.chest_wisdom_zorai_sel=
	{
		Base="palette.entities.botobject",
		Name = "chest_wisdom_zorai_sel",
		SheetClient="object_chest_wisdom_zorai_sel.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.chest_wisdom_zorai_sel", entries.chest_wisdom_zorai_sel);
	entries.backpack_loot_player_r2=
	{
		Base="palette.entities.botobject",
		Name = "backpack_loot_player_r2",
		SheetClient="object_backpack_loot_player_r2.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.backpack_loot_player_r2", entries.backpack_loot_player_r2);
-- Fin dclaration composants et easter eggs


-- Bot Object Trees

	entries.fy_s1_baobab_a=
	{
		Base="palette.entities.botobject",
		Name = "fy_s1_baobab_a",
		SheetClient="object_fy_s1_baobab_a.creature",
		Level=1,
		-- RingAccess="d1",
		Ecosystem="Desert",
	}
	r2.addPaletteElement("palette.entities.botobjects.fy_s1_baobab_a", entries.fy_s1_baobab_a);

	entries.fy_s1_baobab_b=
	{
		Base="palette.entities.botobject",
		Name = "fy_s1_baobab_b",
		SheetClient="object_fy_s1_baobab_b.creature",
		Level=1,
		-- RingAccess="d1",
		Ecosystem="Desert",
	}
	r2.addPaletteElement("palette.entities.botobjects.fy_s1_baobab_b", entries.fy_s1_baobab_b);
	
	entries.fy_s1_baobab_c=
	{
		Base="palette.entities.botobject",
		Name = "fy_s1_baobab_c",
		SheetClient="object_fy_s1_baobab_c.creature",
		Level=1,
		-- RingAccess="d1",
		Ecosystem="Desert",
	}
	r2.addPaletteElement("palette.entities.botobjects.fy_s1_baobab_c", entries.fy_s1_baobab_c);


	entries.fy_s1_burnedtree_a=
	{
		Base="palette.entities.botobject",
		Name = "fy_s1_burnedtree_a",
		SheetClient="object_fy_s1_burnedtree_a.creature",
		Level=1,
		-- RingAccess="d1",
		Ecosystem="Desert",
	}
	r2.addPaletteElement("palette.entities.botobjects.fy_s1_burnedtree_a", entries.fy_s1_burnedtree_a);

	entries.fy_s1_burnedtree_b=
	{
		Base="palette.entities.botobject",
		Name = "fy_s1_burnedtree_b",
		SheetClient="object_fy_s1_burnedtree_b.creature",
		Level=1,
		-- RingAccess="d1",
		Ecosystem="Desert",
	}
	r2.addPaletteElement("palette.entities.botobjects.fy_s1_burnedtree_b", entries.fy_s1_burnedtree_b);

	entries.fy_s1_burnedtree_c=
	{
		Base="palette.entities.botobject",
		Name = "fy_s1_burnedtree_c",
		SheetClient="object_fy_s1_burnedtree_c.creature",
		Level=1,
		-- RingAccess="d1",
		Ecosystem="Desert",
	}
	r2.addPaletteElement("palette.entities.botobjects.fy_s1_burnedtree_c", entries.fy_s1_burnedtree_c);

	entries.fy_s1_burnedtree_d=
	{
		Base="palette.entities.botobject",
		Name = "fy_s1_burnedtree_d",
		SheetClient="object_fy_s1_burnedtree_d.creature",
		Level=1,
		-- RingAccess="d1",
		Ecosystem="Desert",
	}
	r2.addPaletteElement("palette.entities.botobjects.fy_s1_burnedtree_d", entries.fy_s1_burnedtree_d);

	entries.fy_s1_burnedtree_growth_a=
	{
		Base="palette.entities.botobject",
		Name = "fy_s1_burnedtree_growth_a",
		SheetClient="object_fy_s1_burnedtree_growth_a.creature",
		Level=1,
		-- RingAccess="d1",
		Ecosystem="Desert",
	}
	r2.addPaletteElement("palette.entities.botobjects.fy_s1_burnedtree_growth_a", entries.fy_s1_burnedtree_growth_a);

	entries.fy_s1_burnedtree_growth_b=
	{
		Base="palette.entities.botobject",
		Name = "fy_s1_burnedtree_growth_b",
		SheetClient="object_fy_s1_burnedtree_growth_b.creature",
		Level=1,
		-- RingAccess="d1",
		Ecosystem="Desert",
	}
	r2.addPaletteElement("palette.entities.botobjects.fy_s1_burnedtree_growth_b", entries.fy_s1_burnedtree_growth_b);

	entries.fy_s2_coconuts_a=
	{
		Base="palette.entities.botobject",
		Name = "fy_s2_coconuts_a",
		SheetClient="object_fy_s2_coconuts_a.creature",
		Level=1,
		-- RingAccess="d1",
		Ecosystem="Desert",
	}
	r2.addPaletteElement("palette.entities.botobjects.fy_s2_coconuts_a", entries.fy_s2_coconuts_a);

	entries.fy_s2_coconuts_b=
	{
		Base="palette.entities.botobject",
		Name = "fy_s2_coconuts_b",
		SheetClient="object_fy_s2_coconuts_b.creature",
		Level=1,
		-- RingAccess="d1",
		Ecosystem="Desert",
	}
	r2.addPaletteElement("palette.entities.botobjects.fy_s2_coconuts_b", entries.fy_s2_coconuts_b);

	entries.fy_s2_lovejail_a=
	{
		Base="palette.entities.botobject",
		Name = "fy_s2_lovejail_a",
		SheetClient="object_fy_s2_lovejail_a.creature",
		Level=1,
		-- RingAccess="d1",
		Ecosystem="Desert",
	}
	r2.addPaletteElement("palette.entities.botobjects.fy_s2_lovejail_a", entries.fy_s2_lovejail_a);

	entries.fy_s2_lovejail_b=
	{
		Base="palette.entities.botobject",
		Name = "fy_s2_lovejail_b",
		SheetClient="object_fy_s2_lovejail_b.creature",
		Level=1,
		-- RingAccess="d1",
		Ecosystem="Desert",
	}
	r2.addPaletteElement("palette.entities.botobjects.fy_s2_lovejail_b", entries.fy_s2_lovejail_b);

	entries.fy_s2_lovejail_c=
	{
		Base="palette.entities.botobject",
		Name = "fy_s2_lovejail_c",
		SheetClient="object_fy_s2_lovejail_c.creature",
		Level=1,
		-- RingAccess="d1",
		Ecosystem="Desert",
	}
	r2.addPaletteElement("palette.entities.botobjects.fy_s2_lovejail_c", entries.fy_s2_lovejail_c);

	entries.fy_s2_palmtree_a=
	{
		Base="palette.entities.botobject",
		Name = "fy_s2_palmtree_a",
		SheetClient="object_fy_s2_palmtree_a.creature",
		Level=1,
		-- RingAccess="d1",
		Ecosystem="Desert",
	}
	r2.addPaletteElement("palette.entities.botobjects.fy_s2_palmtree_a", entries.fy_s2_palmtree_a);

	entries.fy_s2_palmtree_b=
	{
		Base="palette.entities.botobject",
		Name = "fy_s2_palmtree_b",
		SheetClient="object_fy_s2_palmtree_b.creature",
		Level=1,
		-- RingAccess="d1",
		Ecosystem="Desert",
	}
	r2.addPaletteElement("palette.entities.botobjects.fy_s2_palmtree_b", entries.fy_s2_palmtree_b);

	entries.fy_s2_palmtree_c=
	{
		Base="palette.entities.botobject",
		Name = "fy_s2_palmtree_c",
		SheetClient="object_fy_s2_palmtree_c.creature",
		Level=1,
		-- RingAccess="d1",
		Ecosystem="Desert",
	}
	r2.addPaletteElement("palette.entities.botobjects.fy_s2_palmtree_c", entries.fy_s2_palmtree_c);

	entries.fy_s2_palmtree_d=
	{
		Base="palette.entities.botobject",
		Name = "fy_s2_palmtree_d",
		SheetClient="object_fy_s2_palmtree_d.creature",
		Level=1,
		-- RingAccess="d1",
		Ecosystem="Desert",
	}
	r2.addPaletteElement("palette.entities.botobjects.fy_s2_palmtree_d", entries.fy_s2_palmtree_d);

	entries.fy_s2_palmtree_e=
	{
		Base="palette.entities.botobject",
		Name = "fy_s2_palmtree_e",
		SheetClient="object_fy_s2_palmtree_e.creature",
		Level=1,
		-- RingAccess="d1",
		Ecosystem="Desert",
	}
	r2.addPaletteElement("palette.entities.botobjects.fy_s2_palmtree_e", entries.fy_s2_palmtree_e);

	entries.fy_s2_papaleaf_a=
	{
		Base="palette.entities.botobject",
		Name = "fy_s2_papaleaf_a",
		SheetClient="object_fy_s2_papaleaf_a.creature",
		Level=1,
		-- RingAccess="d1",
		Ecosystem="Desert",
	}
	r2.addPaletteElement("palette.entities.botobjects.fy_s2_papaleaf_a", entries.fy_s2_papaleaf_a);

	entries.fy_s2_papaleaf_b=
	{
		Base="palette.entities.botobject",
		Name = "fy_s2_papaleaf_b",
		SheetClient="object_fy_s2_papaleaf_b.creature",
		Level=1,
		-- RingAccess="d1",
		Ecosystem="Desert",
	}
	r2.addPaletteElement("palette.entities.botobjects.fy_s2_papaleaf_b", entries.fy_s2_papaleaf_b);

	entries.fy_s2_savantree_a=
	{
		Base="palette.entities.botobject",
		Name = "fy_s2_savantree_a",
		SheetClient="object_fy_s2_savantree_a.creature",
		Level=1,
		-- RingAccess="d1",
		Ecosystem="Desert",
	}
	r2.addPaletteElement("palette.entities.botobjects.fy_s2_savantree_a", entries.fy_s2_savantree_a);

	entries.fy_s2_savantree_b=
	{
		Base="palette.entities.botobject",
		Name = "fy_s2_savantree_b",
		SheetClient="object_fy_s2_savantree_b.creature",
		Level=1,
		-- RingAccess="d1",
		Ecosystem="Desert",
	}
	r2.addPaletteElement("palette.entities.botobjects.fy_s2_savantree_b", entries.fy_s2_savantree_b);

	entries.fy_s2_savantree_c=
	{
		Base="palette.entities.botobject",
		Name = "fy_s2_savantree_c",
		SheetClient="object_fy_s2_savantree_c.creature",
		Level=1,
		-- RingAccess="d1",
		Ecosystem="Desert",
	}
	r2.addPaletteElement("palette.entities.botobjects.fy_s2_savantree_c", entries.fy_s2_savantree_c);

	entries.fy_s3_termitiere_a=
	{
		Base="palette.entities.botobject",
		Name = "fy_s3_termitiere_a",
		SheetClient="object_fy_s3_termitiere_a.creature",
		Level=1,
		-- RingAccess="d1",
		Ecosystem="Desert",
	}
	r2.addPaletteElement("palette.entities.botobjects.fy_s3_termitiere_a", entries.fy_s3_termitiere_a);

	entries.fy_s3_termitiere_b=
	{
		Base="palette.entities.botobject",
		Name = "fy_s3_termitiere_b",
		SheetClient="object_fy_s3_termitiere_b.creature",
		Level=1,
		-- RingAccess="d1",
		Ecosystem="Desert",
	}
	r2.addPaletteElement("palette.entities.botobjects.fy_s3_termitiere_b", entries.fy_s3_termitiere_b);

	entries.fy_s3_termitiere_c=
	{
		Base="palette.entities.botobject",
		Name = "fy_s3_termitiere_c",
		SheetClient="object_fy_s3_termitiere_c.creature",
		Level=1,
		-- RingAccess="d1",
		Ecosystem="Desert",
	}
	r2.addPaletteElement("palette.entities.botobjects.fy_s3_termitiere_c", entries.fy_s3_termitiere_c);

	entries.fy_s3_termitiere_d=
	{
		Base="palette.entities.botobject",
		Name = "fy_s3_termitiere_d",
		SheetClient="object_fy_s3_termitiere_d.creature",
		Level=1,
		-- RingAccess="d1",
		Ecosystem="Desert",
	}
	r2.addPaletteElement("palette.entities.botobjects.fy_s3_termitiere_d", entries.fy_s3_termitiere_d);

	entries.fo_s1_arbragrelot=
	{
		Base="palette.entities.botobject",
		Name = "fo_s1_arbragrelot",
		SheetClient="object_fo_s1_arbragrelot.creature",
		Level=1,
		-- RingAccess="f1",
		Ecosystem="Forest",
	}
	r2.addPaletteElement("palette.entities.botobjects.fo_s1_arbragrelot", entries.fo_s1_arbragrelot);

	entries.fo_s1_arbreagrelot=
	{
		Base="palette.entities.botobject",
		Name = "fo_s1_arbreagrelot",
		SheetClient="object_fo_s1_arbreagrelot.creature",
		Level=1,
		-- RingAccess="f1",
		Ecosystem="Forest",
	}
	r2.addPaletteElement("palette.entities.botobjects.fo_s1_arbreagrelot", entries.fo_s1_arbreagrelot);

	entries.fo_s1_giant_tree=
	{
		Base="palette.entities.botobject",
		Name = "fo_s1_giant_tree",
		SheetClient="object_fo_s1_giant_tree.creature",
		Level=1,
		-- RingAccess="f1",
		Ecosystem="Forest",
	}
	r2.addPaletteElement("palette.entities.botobjects.fo_s1_giant_tree", entries.fo_s1_giant_tree);

	entries.fo_s1_giant_trunk=
	{
		Base="palette.entities.botobject",
		Name = "fo_s1_giant_trunk",
		SheetClient="object_fo_s1_giant_trunk.creature",
		Level=1,
		-- RingAccess="f1",
		Ecosystem="Forest",
	}
	r2.addPaletteElement("palette.entities.botobjects.fo_s1_giant_trunk", entries.fo_s1_giant_trunk);

	entries.fo_s2_arbragrelot=
	{
		Base="palette.entities.botobject",
		Name = "fo_s2_arbragrelot",
		SheetClient="object_fo_s2_arbragrelot.creature",
		Level=1,
		-- RingAccess="f1",
		Ecosystem="Forest",
	}
	r2.addPaletteElement("palette.entities.botobjects.fo_s2_arbragrelot", entries.fo_s2_arbragrelot);

	entries.fo_s2_bigroot_a=
	{
		Base="palette.entities.botobject",
		Name = "fo_s2_bigroot_a",
		SheetClient="object_fo_s2_bigroot_a.creature",
		Level=1,
		-- RingAccess="f1",
		Ecosystem="Forest",
	}
	r2.addPaletteElement("palette.entities.botobjects.fo_s2_bigroot_a", entries.fo_s2_bigroot_a);

	entries.fo_s2_bigroot_b=
	{
		Base="palette.entities.botobject",
		Name = "fo_s2_bigroot_b",
		SheetClient="object_fo_s2_bigroot_b.creature",
		Level=1,
		-- RingAccess="f1",
		Ecosystem="Forest",
	}
	r2.addPaletteElement("palette.entities.botobjects.fo_s2_bigroot_b", entries.fo_s2_bigroot_b);

	entries.fo_s2_bigroot_c=
	{
		Base="palette.entities.botobject",
		Name = "fo_s2_bigroot_c",
		SheetClient="object_fo_s2_bigroot_c.creature",
		Level=1,
		-- RingAccess="f1",
		Ecosystem="Forest",
	}
	r2.addPaletteElement("palette.entities.botobjects.fo_s2_bigroot_c", entries.fo_s2_bigroot_c);

	entries.fo_s2_big_tree=
	{
		Base="palette.entities.botobject",
		Name = "fo_s2_big_tree",
		SheetClient="object_fo_s2_big_tree.creature",
		Level=1,
		-- RingAccess="f1",
		Ecosystem="Forest",
	}
	r2.addPaletteElement("palette.entities.botobjects.fo_s2_big_tree", entries.fo_s2_big_tree);

	entries.fo_s2_birch=
	{
		Base="palette.entities.botobject",
		Name = "fo_s2_birch",
		SheetClient="object_fo_s2_birch.creature",
		Level=1,
		-- RingAccess="f1",
		Ecosystem="Forest",
	}
	r2.addPaletteElement("palette.entities.botobjects.fo_s2_birch", entries.fo_s2_birch);

	entries.fo_s3_birch=
	{
		Base="palette.entities.botobject",
		Name = "fo_s3_birch",
		SheetClient="object_fo_s3_birch.creature",
		Level=1,
		-- RingAccess="f1",
		Ecosystem="Forest",
	}
	r2.addPaletteElement("palette.entities.botobjects.fo_s3_birch", entries.fo_s3_birch);

	entries.fo_s2_spiketree=
	{
		Base="palette.entities.botobject",
		Name = "fo_s2_spiketree",
		SheetClient="object_fo_s2_spiketree.creature",
		Level=1,
		-- RingAccess="f1",
		Ecosystem="Forest",
	}
	r2.addPaletteElement("palette.entities.botobjects.fo_s2_spiketree", entries.fo_s2_spiketree);


	entries.fo_s3_buissonaepine=
	{
		Base="palette.entities.botobject",
		Name = "fo_s3_buissonaepine",
		SheetClient="object_fo_s3_buissonaepine.creature",
		Level=1,
		-- RingAccess="f1",
		Ecosystem="Forest",
	}
	r2.addPaletteElement("palette.entities.botobjects.fo_s3_buissonaepine", entries.fo_s3_buissonaepine);

	entries.fo_s3_champignou_a=
	{
		Base="palette.entities.botobject",
		Name = "fo_s3_champignou_a",
		SheetClient="object_fo_s3_champignou_a.creature",
		Level=1,
		-- RingAccess="f1",
		Ecosystem="Forest",
	}
	r2.addPaletteElement("palette.entities.botobjects.fo_s3_champignou_a", entries.fo_s3_champignou_a);

	entries.fo_s3_champignou_b=
	{
		Base="palette.entities.botobject",
		Name = "fo_s3_champignou_b",
		SheetClient="object_fo_s3_champignou_b.creature",
		Level=1,
		-- RingAccess="f1",
		Ecosystem="Forest",
	}
	r2.addPaletteElement("palette.entities.botobjects.fo_s3_champignou_b", entries.fo_s3_champignou_b);

	entries.fo_s3_fougere=
	{
		Base="palette.entities.botobject",
		Name = "fo_s3_fougere",
		SheetClient="object_fo_s3_fougere.creature",
		Level=1,
		-- RingAccess="f1",
		Ecosystem="Forest",
	}
	r2.addPaletteElement("palette.entities.botobjects.fo_s3_fougere", entries.fo_s3_fougere);

	entries.fo_s3_tree=
	{
		Base="palette.entities.botobject",
		Name = "fo_s3_tree",
		SheetClient="object_fo_s3_tree.creature",
		Level=1,
		-- RingAccess="f1",
		Ecosystem="Forest",
	}
	r2.addPaletteElement("palette.entities.botobjects.fo_s3_tree", entries.fo_s3_tree);

	entries.ju_s1_bamboo=
	{
		Base="palette.entities.botobject",
		Name = "ju_s1_bamboo",
		SheetClient="object_ju_s1_bamboo.creature",
		Level=1,
		-- RingAccess="j1",
		Ecosystem="Jungle",
	}
	r2.addPaletteElement("palette.entities.botobjects.ju_s1_bamboo", entries.ju_s1_bamboo);

	entries.ju_s1_canopy_tree=
	{
		Base="palette.entities.botobject",
		Name = "ju_s1_canopy_tree",
		SheetClient="object_ju_s1_canopy_tree.creature",
		Level=1,
		-- RingAccess="j1",
		Ecosystem="Jungle",
	}
	r2.addPaletteElement("palette.entities.botobjects.ju_s1_canopy_tree", entries.ju_s1_canopy_tree);

	entries.ju_s2_big_tree=
	{
		Base="palette.entities.botobject",
		Name = "ju_s2_big_tree",
		SheetClient="object_ju_s2_big_tree.creature",
		Level=1,
		-- RingAccess="j1",
		Ecosystem="Jungle",
	}
	r2.addPaletteElement("palette.entities.botobjects.ju_s2_big_tree", entries.ju_s2_big_tree);

	entries.ju_s2_young_tree=
	{
		Base="palette.entities.botobject",
		Name = "ju_s2_young_tree",
		SheetClient="object_ju_s2_young_tree.creature",
		Level=1,
		-- RingAccess="j1",
		Ecosystem="Jungle",
	}
	r2.addPaletteElement("palette.entities.botobjects.ju_s2_young_tree", entries.ju_s2_young_tree);

	entries.ju_s3_bamboo=
	{
		Base="palette.entities.botobject",
		Name = "ju_s3_bamboo",
		SheetClient="object_ju_s3_bamboo.creature",
		Level=1,
		-- RingAccess="j1",
		Ecosystem="Jungle",
	}
	r2.addPaletteElement("palette.entities.botobjects.ju_s3_bamboo", entries.ju_s3_bamboo);

	entries.ju_s3_banana_tree=
	{
		Base="palette.entities.botobject",
		Name = "ju_s3_banana_tree",
		SheetClient="object_ju_s3_banana_tree.creature",
		Level=1,
		-- RingAccess="j1",
		Ecosystem="Jungle",
	}
	r2.addPaletteElement("palette.entities.botobjects.ju_s3_banana_tree", entries.ju_s3_banana_tree);

	entries.ju_s3_bush_tree=
	{
		Base="palette.entities.botobject",
		Name = "ju_s3_bush_tree",
		SheetClient="object_ju_s3_bush_tree.creature",
		Level=1,
		-- RingAccess="j1",
		Ecosystem="Jungle",
	}
	r2.addPaletteElement("palette.entities.botobjects.ju_s3_bush_tree", entries.ju_s3_bush_tree);

	entries.ju_s3_dead_tree=
	{
		Base="palette.entities.botobject",
		Name = "ju_s3_dead_tree",
		SheetClient="object_ju_s3_dead_tree.creature",
		Level=1,
		-- RingAccess="j1",
		Ecosystem="Jungle",
	}
	r2.addPaletteElement("palette.entities.botobjects.ju_s3_dead_tree", entries.ju_s3_dead_tree);

	entries.ju_s3_fantree=
	{
		Base="palette.entities.botobject",
		Name = "ju_s3_fantree",
		SheetClient="object_ju_s3_fantree.creature",
		Level=1,
		-- RingAccess="j1",
		Ecosystem="Jungle",
	}
	r2.addPaletteElement("palette.entities.botobjects.ju_s3_fantree", entries.ju_s3_fantree);

	entries.ju_s3_fougere=
	{
		Base="palette.entities.botobject",
		Name = "ju_s3_fougere",
		SheetClient="object_ju_s3_fougere.creature",
		Level=1,
		-- RingAccess="j1",
		Ecosystem="Jungle",
	}
	r2.addPaletteElement("palette.entities.botobjects.ju_s3_fougere", entries.ju_s3_fougere);

	entries.ju_s3_plante=
	{
		Base="palette.entities.botobject",
		Name = "ju_s3_plante",
		SheetClient="object_ju_s3_plante.creature",
		Level=1,
		-- RingAccess="j1",
		Ecosystem="Jungle",
	}
	r2.addPaletteElement("palette.entities.botobjects.ju_s3_plante", entries.ju_s3_plante);

	entries.ju_s3_plantegrasse=
	{
		Base="palette.entities.botobject",
		Name = "ju_s3_plantegrasse",
		SheetClient="object_ju_s3_plantegrasse.creature",
		Level=1,
		-- RingAccess="j1",
		Ecosystem="Jungle",
	}
	r2.addPaletteElement("palette.entities.botobjects.ju_s3_plantegrasse", entries.ju_s3_plantegrasse);

	entries.ju_s3_tree=
	{
		Base="palette.entities.botobject",
		Name = "ju_s3_tree",
		SheetClient="object_ju_s3_tree.creature",
		Level=1,
		-- RingAccess="j1",
		Ecosystem="Jungle",
	}
	r2.addPaletteElement("palette.entities.botobjects.ju_s3_tree", entries.ju_s3_tree);

	entries.tr_s1_bamboo_a=
	{
		Base="palette.entities.botobject",
		Name = "tr_s1_bamboo_a",
		SheetClient="object_tr_s1_bamboo_a.creature",
		Level=1,
		-- RingAccess="l1",
		Ecosystem="Lacustre",
	}
	r2.addPaletteElement("palette.entities.botobjects.tr_s1_bamboo_a", entries.tr_s1_bamboo_a);

	entries.tr_s1_kelp_a=
	{
		Base="palette.entities.botobject",
		Name = "tr_s1_kelp_a",
		SheetClient="object_tr_s1_kelp_a.creature",
		Level=1,
		-- RingAccess="l1",
		Ecosystem="Lacustre",
	}
	r2.addPaletteElement("palette.entities.botobjects.tr_s1_kelp_a", entries.tr_s1_kelp_a);

	entries.tr_s1_kelp_b=
	{
		Base="palette.entities.botobject",
		Name = "tr_s1_kelp_b",
		SheetClient="object_tr_s1_kelp_b.creature",
		Level=1,
		-- RingAccess="l1",
		Ecosystem="Lacustre",
	}
	r2.addPaletteElement("palette.entities.botobjects.tr_s1_kelp_b", entries.tr_s1_kelp_b);

	entries.tr_s2_bamboo_a=
	{
		Base="palette.entities.botobject",
		Name = "tr_s2_bamboo_a",
		SheetClient="object_tr_s2_bamboo_a.creature",
		Level=1,
		-- RingAccess="l1",
		Ecosystem="Lacustre",
	}
	r2.addPaletteElement("palette.entities.botobjects.tr_s2_bamboo_a", entries.tr_s2_bamboo_a);

	entries.tr_s2_champiflot_a=
	{
		Base="palette.entities.botobject",
		Name = "tr_s2_champiflot_a",
		SheetClient="object_tr_s2_champiflot_a.creature",
		Level=1,
		-- RingAccess="l1",
		Ecosystem="Lacustre",
	}
	r2.addPaletteElement("palette.entities.botobjects.tr_s2_champiflot_a", entries.tr_s2_champiflot_a);

	entries.tr_s2_lokness_a=
	{
		Base="palette.entities.botobject",
		Name = "tr_s2_lokness_a",
		SheetClient="object_tr_s2_lokness_a.creature",
		Level=1,
		-- RingAccess="l1",
		Ecosystem="Lacustre",
	}
	r2.addPaletteElement("palette.entities.botobjects.tr_s2_lokness_a", entries.tr_s2_lokness_a);

	entries.tr_s2_lokness_b=
	{
		Base="palette.entities.botobject",
		Name = "tr_s2_lokness_b",
		SheetClient="object_tr_s2_lokness_b.creature",
		Level=1,
		-- RingAccess="l1",
		Ecosystem="Lacustre",
	}
	r2.addPaletteElement("palette.entities.botobjects.tr_s2_lokness_b", entries.tr_s2_lokness_b);

	entries.tr_s2_lokness_c=
	{
		Base="palette.entities.botobject",
		Name = "tr_s2_lokness_c",
		SheetClient="object_tr_s2_lokness_c.creature",
		Level=1,
		-- RingAccess="l1",
		Ecosystem="Lacustre",
	}
	r2.addPaletteElement("palette.entities.botobjects.tr_s2_lokness_c", entries.tr_s2_lokness_c);

	entries.tr_s2_mangrove_a=
	{
		Base="palette.entities.botobject",
		Name = "tr_s2_mangrove_a",
		SheetClient="object_tr_s2_mangrove_a.creature",
		Level=1,
		-- RingAccess="l1",
		Ecosystem="Lacustre",
	}
	r2.addPaletteElement("palette.entities.botobjects.tr_s2_mangrove_a", entries.tr_s2_mangrove_a);

	entries.tr_s2_mangrove_b=
	{
		Base="palette.entities.botobject",
		Name = "tr_s2_mangrove_b",
		SheetClient="object_tr_s2_mangrove_b.creature",
		Level=1,
		-- RingAccess="l1",
		Ecosystem="Lacustre",
	}
	r2.addPaletteElement("palette.entities.botobjects.tr_s2_mangrove_b", entries.tr_s2_mangrove_b);

	entries.tr_s2_nenufly_a=
	{
		Base="palette.entities.botobject",
		Name = "tr_s2_nenufly_a",
		SheetClient="object_tr_s2_nenufly_a.creature",
		Level=1,
		-- RingAccess="l1",
		Ecosystem="Lacustre",
	}
	r2.addPaletteElement("palette.entities.botobjects.tr_s2_nenufly_a", entries.tr_s2_nenufly_a);

	entries.tr_s2_palmtree_a=
	{
		Base="palette.entities.botobject",
		Name = "tr_s2_palmtree_a",
		SheetClient="object_tr_s2_palmtree_a.creature",
		Level=1,
		-- RingAccess="l1",
		Ecosystem="Lacustre",
	}
	r2.addPaletteElement("palette.entities.botobjects.tr_s2_palmtree_a", entries.tr_s2_palmtree_a);

	entries.tr_s2_palmtree_b=
	{
		Base="palette.entities.botobject",
		Name = "tr_s2_palmtree_b",
		SheetClient="object_tr_s2_palmtree_b.creature",
		Level=1,
		-- RingAccess="l1",
		Ecosystem="Lacustre",
	}
	r2.addPaletteElement("palette.entities.botobjects.tr_s2_palmtree_b", entries.tr_s2_palmtree_b);

	entries.tr_s2_palmtree_c=
	{
		Base="palette.entities.botobject",
		Name = "tr_s2_palmtree_c",
		SheetClient="object_tr_s2_palmtree_c.creature",
		Level=1,
		-- RingAccess="l1",
		Ecosystem="Lacustre",
	}
	r2.addPaletteElement("palette.entities.botobjects.tr_s2_palmtree_c", entries.tr_s2_palmtree_c);

	entries.tr_s2_palmtree_d=
	{
		Base="palette.entities.botobject",
		Name = "tr_s2_palmtree_d",
		SheetClient="object_tr_s2_palmtree_d.creature",
		Level=1,
		-- RingAccess="l1",
		Ecosystem="Lacustre",
	}
	r2.addPaletteElement("palette.entities.botobjects.tr_s2_palmtree_d", entries.tr_s2_palmtree_d);

	entries.tr_s2_palmtree_e=
	{
		Base="palette.entities.botobject",
		Name = "tr_s2_palmtree_e",
		SheetClient="object_tr_s2_palmtree_e.creature",
		Level=1,
		-- RingAccess="l1",
		Ecosystem="Lacustre",
	}
	r2.addPaletteElement("palette.entities.botobjects.tr_s2_palmtree_e", entries.tr_s2_palmtree_e);

	entries.tr_s2_palmtree_f=
	{
		Base="palette.entities.botobject",
		Name = "tr_s2_palmtree_f",
		SheetClient="object_tr_s2_palmtree_f.creature",
		Level=1,
		-- RingAccess="l1",
		Ecosystem="Lacustre",
	}
	r2.addPaletteElement("palette.entities.botobjects.tr_s2_palmtree_f", entries.tr_s2_palmtree_f);

	entries.tr_s2_sailtree_a=
	{
		Base="palette.entities.botobject",
		Name = "tr_s2_sailtree_a",
		SheetClient="object_tr_s2_sailtree_a.creature",
		Level=1,
		-- RingAccess="l1",
		Ecosystem="Lacustre",
	}
	r2.addPaletteElement("palette.entities.botobjects.tr_s2_sailtree_a", entries.tr_s2_sailtree_a);

	entries.tr_s2_wigweed_a=
	{
		Base="palette.entities.botobject",
		Name = "tr_s2_wigweed_a",
		SheetClient="object_tr_s2_wigweed_a.creature",
		Level=1,
		-- RingAccess="l1",
		Ecosystem="Lacustre",
	}
	r2.addPaletteElement("palette.entities.botobjects.tr_s2_wigweed_a", entries.tr_s2_wigweed_a);

	entries.tr_s3_aquabole_a=
	{
		Base="palette.entities.botobject",
		Name = "tr_s3_aquabole_a",
		SheetClient="object_tr_s3_aquabole_a.creature",
		Level=1,
		-- RingAccess="l1",
		Ecosystem="Lacustre",
	}
	r2.addPaletteElement("palette.entities.botobjects.tr_s3_aquabole_a", entries.tr_s3_aquabole_a);

	entries.tr_s3_aquabole_b=
	{
		Base="palette.entities.botobject",
		Name = "tr_s3_aquabole_b",
		SheetClient="object_tr_s3_aquabole_b.creature",
		Level=1,
		-- RingAccess="l1",
		Ecosystem="Lacustre",
	}
	r2.addPaletteElement("palette.entities.botobjects.tr_s3_aquabole_b", entries.tr_s3_aquabole_b);

	entries.tr_s3_aquafeather_a=
	{
		Base="palette.entities.botobject",
		Name = "tr_s3_aquafeather_a",
		SheetClient="object_tr_s3_aquafeather_a.creature",
		Level=1,
		-- RingAccess="l1",
		Ecosystem="Lacustre",
	}
	r2.addPaletteElement("palette.entities.botobjects.tr_s3_aquafeather_a", entries.tr_s3_aquafeather_a);

	entries.tr_s3_aquafeather_b=
	{
		Base="palette.entities.botobject",
		Name = "tr_s3_aquafeather_b",
		SheetClient="object_tr_s3_aquafeather_b.creature",
		Level=1,
		-- RingAccess="l1",
		Ecosystem="Lacustre",
	}
	r2.addPaletteElement("palette.entities.botobjects.tr_s3_aquafeather_b", entries.tr_s3_aquafeather_b);

	entries.tr_s3_aquafeather_c=
	{
		Base="palette.entities.botobject",
		Name = "tr_s3_aquafeather_c",
		SheetClient="object_tr_s3_aquafeather_c.creature",
		Level=1,
		-- RingAccess="l1",
		Ecosystem="Lacustre",
	}
	r2.addPaletteElement("palette.entities.botobjects.tr_s3_aquafeather_c", entries.tr_s3_aquafeather_c);

	entries.tr_s3_flower_a=
	{
		Base="palette.entities.botobject",
		Name = "tr_s3_flower_a",
		SheetClient="object_tr_s3_flower_a.creature",
		Level=1,
		-- RingAccess="l1",
		Ecosystem="Lacustre",
	}
	r2.addPaletteElement("palette.entities.botobjects.tr_s3_flower_a", entries.tr_s3_flower_a);

	entries.tr_s3_flower_b=
	{
		Base="palette.entities.botobject",
		Name = "tr_s3_flower_b",
		SheetClient="object_tr_s3_flower_b.creature",
		Level=1,
		-- RingAccess="l1",
		Ecosystem="Lacustre",
	}
	r2.addPaletteElement("palette.entities.botobjects.tr_s3_flower_b", entries.tr_s3_flower_b);

	entries.tr_s3_flower_c=
	{
		Base="palette.entities.botobject",
		Name = "tr_s3_flower_c",
		SheetClient="object_tr_s3_flower_c.creature",
		Level=1,
		-- RingAccess="l1",
		Ecosystem="Lacustre",
	}
	r2.addPaletteElement("palette.entities.botobjects.tr_s3_flower_c", entries.tr_s3_flower_c);

	entries.tr_s3_nenufly_b=
	{
		Base="palette.entities.botobject",
		Name = "tr_s3_nenufly_b",
		SheetClient="object_tr_s3_nenufly_b.creature",
		Level=1,
		-- RingAccess="l1",
		Ecosystem="Lacustre",
	}
	r2.addPaletteElement("palette.entities.botobjects.tr_s3_nenufly_b", entries.tr_s3_nenufly_b);

	entries.tr_s3_trumpet_a=
	{
		Base="palette.entities.botobject",
		Name = "tr_s3_trumpet_a",
		SheetClient="object_tr_s3_trumpet_a.creature",
		Level=1,
		-- RingAccess="l1",
		Ecosystem="Lacustre",
	}
	r2.addPaletteElement("palette.entities.botobjects.tr_s3_trumpet_a", entries.tr_s3_trumpet_a);

	entries.tr_s3_trumpet_b=
	{
		Base="palette.entities.botobject",
		Name = "tr_s3_trumpet_b",
		SheetClient="object_tr_s3_trumpet_b.creature",
		Level=1,
		-- RingAccess="l1",
		Ecosystem="Lacustre",
	}
	r2.addPaletteElement("palette.entities.botobjects.tr_s3_trumpet_b", entries.tr_s3_trumpet_b);

	entries.tr_s3_trumpet_c=
	{
		Base="palette.entities.botobject",
		Name = "tr_s3_trumpet_c",
		SheetClient="object_tr_s3_trumpet_c.creature",
		Level=1,
		-- RingAccess="l1",
		Ecosystem="Lacustre",
	}
	r2.addPaletteElement("palette.entities.botobjects.tr_s3_trumpet_c", entries.tr_s3_trumpet_c);

	entries.tr_s3_trumpet_d=
	{
		Base="palette.entities.botobject",
		Name = "tr_s3_trumpet_d",
		SheetClient="object_tr_s3_trumpet_d.creature",
		Level=1,
		-- RingAccess="l1",
		Ecosystem="Lacustre",
	}
	r2.addPaletteElement("palette.entities.botobjects.tr_s3_trumpet_d", entries.tr_s3_trumpet_d);

	entries.pr_s1_lumiseed_a=
	{
		Base="palette.entities.botobject",
		Name = "pr_s1_lumiseed_a",
		SheetClient="object_pr_s1_lumiseed_a.creature",
		Level=1,
		-- RingAccess="p1", Ecosystem="PrimeRoots",
	}
	r2.addPaletteElement("palette.entities.botobjects.pr_s1_lumiseed_a", entries.pr_s1_lumiseed_a);

	entries.pr_s1_lumiseed_b=
	{
		Base="palette.entities.botobject",
		Name = "pr_s1_lumiseed_b",
		SheetClient="object_pr_s1_lumiseed_b.creature",
		Level=1,
		-- RingAccess="p1", Ecosystem="PrimeRoots",
	}
	r2.addPaletteElement("palette.entities.botobjects.pr_s1_lumiseed_b", entries.pr_s1_lumiseed_b);

	entries.pr_s1_lumiseed_c=
	{
		Base="palette.entities.botobject",
		Name = "pr_s1_lumiseed_c",
		SheetClient="object_pr_s1_lumiseed_c.creature",
		Level=1,
		-- RingAccess="p1", Ecosystem="PrimeRoots",
	}
	r2.addPaletteElement("palette.entities.botobjects.pr_s1_lumiseed_c", entries.pr_s1_lumiseed_c);

	entries.pr_s1_lumiseed_d=
	{
		Base="palette.entities.botobject",
		Name = "pr_s1_lumiseed_d",
		SheetClient="object_pr_s1_lumiseed_d.creature",
		Level=1,
		-- RingAccess="p1", Ecosystem="PrimeRoots",
	}
	r2.addPaletteElement("palette.entities.botobjects.pr_s1_lumiseed_d", entries.pr_s1_lumiseed_d);

	entries.pr_s1_rotaflore_a=
	{
		Base="palette.entities.botobject",
		Name = "pr_s1_rotaflore_a",
		SheetClient="object_pr_s1_rotaflore_a.creature",
		Level=1,
		-- RingAccess="p1", Ecosystem="PrimeRoots",
	}
	r2.addPaletteElement("palette.entities.botobjects.pr_s1_rotaflore_a", entries.pr_s1_rotaflore_a);

	entries.pr_s1_rotaflore_b=
	{
		Base="palette.entities.botobject",
		Name = "pr_s1_rotaflore_b",
		SheetClient="object_pr_s1_rotaflore_b.creature",
		Level=1,
		-- RingAccess="p1", Ecosystem="PrimeRoots",
	}
	r2.addPaletteElement("palette.entities.botobjects.pr_s1_rotaflore_b", entries.pr_s1_rotaflore_b);

	entries.pr_s1_rotaflore_c=
	{
		Base="palette.entities.botobject",
		Name = "pr_s1_rotaflore_c",
		SheetClient="object_pr_s1_rotaflore_c.creature",
		Level=1,
		-- RingAccess="p1", Ecosystem="PrimeRoots",
	}
	r2.addPaletteElement("palette.entities.botobjects.pr_s1_rotaflore_c", entries.pr_s1_rotaflore_c);

	entries.pr_s2_mycotree_a=
	{
		Base="palette.entities.botobject",
		Name = "pr_s2_mycotree_a",
		SheetClient="object_pr_s2_mycotree_a.creature",
		Level=1,
		-- RingAccess="p1", Ecosystem="PrimeRoots",
	}
	r2.addPaletteElement("palette.entities.botobjects.pr_s2_mycotree_a", entries.pr_s2_mycotree_a);

	entries.pr_s2_mycotree_b=
	{
		Base="palette.entities.botobject",
		Name = "pr_s2_mycotree_b",
		SheetClient="object_pr_s2_mycotree_b.creature",
		Level=1,
		-- RingAccess="p1", Ecosystem="PrimeRoots",
	}
	r2.addPaletteElement("palette.entities.botobjects.pr_s2_mycotree_b", entries.pr_s2_mycotree_b);

	entries.pr_s2_planipushes_a=
	{
		Base="palette.entities.botobject",
		Name = "pr_s2_planipushes_a",
		SheetClient="object_pr_s2_planipushes_a.creature",
		Level=1,
		-- RingAccess="p1", Ecosystem="PrimeRoots",
	}
	r2.addPaletteElement("palette.entities.botobjects.pr_s2_planipushes_a", entries.pr_s2_planipushes_a);

	entries.pr_s2_planipushes_b=
	{
		Base="palette.entities.botobject",
		Name = "pr_s2_planipushes_b",
		SheetClient="object_pr_s2_planipushes_b.creature",
		Level=1,
		-- RingAccess="p1", Ecosystem="PrimeRoots",
	}
	r2.addPaletteElement("palette.entities.botobjects.pr_s2_planipushes_b", entries.pr_s2_planipushes_b);

	entries.pr_s2_planipushes_c=
	{
		Base="palette.entities.botobject",
		Name = "pr_s2_planipushes_c",
		SheetClient="object_pr_s2_planipushes_c.creature",
		Level=1,
		-- RingAccess="p1", Ecosystem="PrimeRoots",
	}
	r2.addPaletteElement("palette.entities.botobjects.pr_s2_planipushes_c", entries.pr_s2_planipushes_c);

	entries.pr_s2_planipushes_d=
	{
		Base="palette.entities.botobject",
		Name = "pr_s2_planipushes_d",
		SheetClient="object_pr_s2_planipushes_d.creature",
		Level=1,
		-- RingAccess="p1", Ecosystem="PrimeRoots",
	}
	r2.addPaletteElement("palette.entities.botobjects.pr_s2_planipushes_d", entries.pr_s2_planipushes_d);

	entries.pr_s2_toopetz_a=
	{
		Base="palette.entities.botobject",
		Name = "pr_s2_toopetz_a",
		SheetClient="object_pr_s2_toopetz_a.creature",
		Level=1,
		-- RingAccess="p1", Ecosystem="PrimeRoots",
	}
	r2.addPaletteElement("palette.entities.botobjects.pr_s2_toopetz_a", entries.pr_s2_toopetz_a);

	entries.pr_s2_toopetz_b=
	{
		Base="palette.entities.botobject",
		Name = "pr_s2_toopetz_b",
		SheetClient="object_pr_s2_toopetz_b.creature",
		Level=1,
		-- RingAccess="p1", Ecosystem="PrimeRoots",
	}
	r2.addPaletteElement("palette.entities.botobjects.pr_s2_toopetz_b", entries.pr_s2_toopetz_b);

	entries.pr_s2_toopetz_c=
	{
		Base="palette.entities.botobject",
		Name = "pr_s2_toopetz_c",
		SheetClient="object_pr_s2_toopetz_c.creature",
		Level=1,
		-- RingAccess="p1", Ecosystem="PrimeRoots",
	}
	r2.addPaletteElement("palette.entities.botobjects.pr_s2_toopetz_c", entries.pr_s2_toopetz_c);

	entries.pr_s3_amoeba_a=
	{
		Base="palette.entities.botobject",
		Name = "pr_s3_amoeba_a",
		SheetClient="object_pr_s3_amoeba_a.creature",
		Level=1,
		-- RingAccess="p1", Ecosystem="PrimeRoots",
	}
	r2.addPaletteElement("palette.entities.botobjects.pr_s3_amoeba_a", entries.pr_s3_amoeba_a);

	entries.pr_s3_amoeba_b=
	{
		Base="palette.entities.botobject",
		Name = "pr_s3_amoeba_b",
		SheetClient="object_pr_s3_amoeba_b.creature",
		Level=1,
		-- RingAccess="p1", Ecosystem="PrimeRoots",
	}
	r2.addPaletteElement("palette.entities.botobjects.pr_s3_amoeba_b", entries.pr_s3_amoeba_b);

	entries.pr_s3_amoeba_c=
	{
		Base="palette.entities.botobject",
		Name = "pr_s3_amoeba_c",
		SheetClient="object_pr_s3_amoeba_c.creature",
		Level=1,
		-- RingAccess="p1", Ecosystem="PrimeRoots",
	}
	r2.addPaletteElement("palette.entities.botobjects.pr_s3_amoeba_c", entries.pr_s3_amoeba_c);

	entries.pr_s3_cokamool_a=
	{
		Base="palette.entities.botobject",
		Name = "pr_s3_cokamool_a",
		SheetClient="object_pr_s3_cokamool_a.creature",
		Level=1,
		-- RingAccess="p1", Ecosystem="PrimeRoots",
	}
	r2.addPaletteElement("palette.entities.botobjects.pr_s3_cokamool_a", entries.pr_s3_cokamool_a);

	entries.pr_s3_cokamool_b=
	{
		Base="palette.entities.botobject",
		Name = "pr_s3_cokamool_b",
		SheetClient="object_pr_s3_cokamool_b.creature",
		Level=1,
		-- RingAccess="p1", Ecosystem="PrimeRoots",
	}
	r2.addPaletteElement("palette.entities.botobjects.pr_s3_cokamool_b", entries.pr_s3_cokamool_b);

	entries.pr_s3_cokamool_c=
	{
		Base="palette.entities.botobject",
		Name = "pr_s3_cokamool_c",
		SheetClient="object_pr_s3_cokamool_c.creature",
		Level=1,
		-- RingAccess="p1", Ecosystem="PrimeRoots",
	}
	r2.addPaletteElement("palette.entities.botobjects.pr_s3_cokamool_c", entries.pr_s3_cokamool_c);

	entries.pr_s3_ploomweed_a=
	{
		Base="palette.entities.botobject",
		Name = "pr_s3_ploomweed_a",
		SheetClient="object_pr_s3_ploomweed_a.creature",
		Level=1,
		-- RingAccess="p1", Ecosystem="PrimeRoots",
	}
	r2.addPaletteElement("palette.entities.botobjects.pr_s3_ploomweed_a", entries.pr_s3_ploomweed_a);

	entries.pr_s3_ploomweed_b=
	{
		Base="palette.entities.botobject",
		Name = "pr_s3_ploomweed_b",
		SheetClient="object_pr_s3_ploomweed_b.creature",
		Level=1,
		-- RingAccess="p1", Ecosystem="PrimeRoots",
	}
	r2.addPaletteElement("palette.entities.botobjects.pr_s3_ploomweed_b", entries.pr_s3_ploomweed_b);

	entries.pr_s3_small_lumiseed_a=
	{
		Base="palette.entities.botobject",
		Name = "pr_s3_small_lumiseed_a",
		SheetClient="object_pr_s3_small_lumiseed_a.creature",
		Level=1,
		-- RingAccess="p1", Ecosystem="PrimeRoots",
	}
	r2.addPaletteElement("palette.entities.botobjects.pr_s3_small_lumiseed_a", entries.pr_s3_small_lumiseed_a);

	entries.pr_s3_small_lumiseed_b=
	{
		Base="palette.entities.botobject",
		Name = "pr_s3_small_lumiseed_b",
		SheetClient="object_pr_s3_small_lumiseed_b.creature",
		Level=1,
		-- RingAccess="p1", Ecosystem="PrimeRoots",
	}
	r2.addPaletteElement("palette.entities.botobjects.pr_s3_small_lumiseed_b", entries.pr_s3_small_lumiseed_b);


-- Bot Object FX


	entries.fx_base=
	{
		Base="palette.entities.botobject",
		BoxSelection=1
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_base", entries.fx_base);
	
	entries.fx_fishe=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_fishe",
		Ecosystem="",
		SheetClient="object_fx-fishe.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_fishe", entries.fx_fishe);

	entries.fxy_canyon=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fxy_canyon",
		-- RingAccess="d1",
		Ecosystem="Desert",
		SheetClient="object_fxy-canyon.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fxy_canyon", entries.fxy_canyon);

	entries.fxy_cricketa=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fxy_cricketa",
		-- RingAccess="d1",
		Ecosystem="Desert",
		SheetClient="object_fxy-cricketa.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fxy_cricketa", entries.fxy_cricketa);

	entries.fx_desert_sandblasta=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_desert_sandblasta",
		-- RingAccess="d1",
		Ecosystem="Desert",
		SheetClient="object_fx_desert-sandblasta.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_desert_sandblasta", entries.fx_desert_sandblasta);

	entries.fx_desert_sandblastb=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_desert_sandblastb",
		-- RingAccess="d1",
		Ecosystem="Desert",
		SheetClient="object_fx_desert-sandblastb.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_desert_sandblastb", entries.fx_desert_sandblastb);

	entries.fx_de_birda=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_de_birda",
		-- RingAccess="d1",
		Ecosystem="Desert",
		SheetClient="object_fx_de_birda.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_de_birda", entries.fx_de_birda);

	entries.fx_de_firewave=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_de_firewave",
		-- RingAccess="d1",
		Ecosystem="Desert",
		SheetClient="object_fx_de_firewave.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_de_firewave", entries.fx_de_firewave);

	entries.fx_de_fishes=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_de_fishes",
		-- RingAccess="d1",
		Ecosystem="Desert",
		SheetClient="object_fx_de_fishes.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_de_fishes", entries.fx_de_fishes);

	entries.fx_de_geyser=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_de_geyser",
		-- RingAccess="d1",
		Ecosystem="Desert",
		SheetClient="object_fx_de_geyser.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_de_geyser", entries.fx_de_geyser);

	entries.fx_de_geyser_fumee=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_de_geyser_fumee",
		-- RingAccess="d1",
		Ecosystem="Desert",
		SheetClient="object_fx_de_geyser_fumee.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_de_geyser_fumee", entries.fx_de_geyser_fumee);

	entries.fx_de_krevette=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_de_krevette",
		-- RingAccess="d1",
		Ecosystem="Desert",
		SheetClient="object_fx_de_krevette.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_de_krevette", entries.fx_de_krevette);

	entries.fx_de_scorpion2=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_de_scorpion2",
		-- RingAccess="d1",
		Ecosystem="Desert",
		SheetClient="object_fx_de_scorpion2.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_de_scorpion2", entries.fx_de_scorpion2);

	entries.fx_de_serpent=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_de_serpent",
		-- RingAccess="d1",
		Ecosystem="Desert",
		SheetClient="object_fx_de_serpent.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_de_serpent", entries.fx_de_serpent);

	entries.fx_de_vapeurs=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_de_vapeurs",
		-- RingAccess="d1",
		Ecosystem="Desert",
		SheetClient="object_fx_de_vapeurs.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_de_vapeurs", entries.fx_de_vapeurs);

	entries.fx_de_ver=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_de_ver",
		-- RingAccess="d1",
		Ecosystem="Desert",
		SheetClient="object_fx_de_ver.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_de_ver", entries.fx_de_ver);

	entries.fx_de_waterserpent=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_de_waterserpent",
		-- RingAccess="d1",
		Ecosystem="Desert",
		SheetClient="object_fx_de_waterserpent.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_de_waterserpent", entries.fx_de_waterserpent);

	entries.fx_fo_bugsa=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_fo_bugsa",
		-- RingAccess="f1",
		Ecosystem="Forest",
		SheetClient="object_fx_fo-bugsa.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_fo_bugsa", entries.fx_fo_bugsa);

	entries.fx_fo_bugsb=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_fo_bugsb",
		-- RingAccess="f1",
		Ecosystem="Forest",
		SheetClient="object_fx_fo-bugsb.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_fo_bugsb", entries.fx_fo_bugsb);

	entries.fx_fo_bugsc=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_fo_bugsc",
		-- RingAccess="f1",
		Ecosystem="Forest",
		SheetClient="object_fx_fo-bugsc.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_fo_bugsc", entries.fx_fo_bugsc);

	entries.fx_fo_colibrisb=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_fo_colibrisb",
		-- RingAccess="f1",
		Ecosystem="Forest",
		SheetClient="object_fx_fo-ju-colibrisb.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_fo_colibrisb", entries.fx_fo_colibrisb);

    entries.fx_ju_colibrisb=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_ju_colibrisb",
		-- RingAccess="j1",
		Ecosystem="Jungle",
		SheetClient="object_fx_fo-ju-colibrisb.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_ju_colibrisb", entries.fx_ju_colibrisb);

	entries.fx_fo_pollen2=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_fo_pollen2",
		-- RingAccess="f1",
		Ecosystem="Forest",
		SheetClient="object_fx_fo-pollen.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_fo_pollen2", entries.fx_fo_pollen2);

	entries.fx_fo_solbirtha=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_fo_solbirtha",
		-- RingAccess="f1",
		Ecosystem="Forest",
		SheetClient="object_fx_fo-solbirtha.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_fo_solbirtha", entries.fx_fo_solbirtha);

	entries.fx_fo_solbirthb=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_fo_solbirthb",
		-- RingAccess="f1",
		Ecosystem="Forest",
		SheetClient="object_fx_fo-solbirthb.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_fo_solbirthb", entries.fx_fo_solbirthb);

	entries.fx_fo_solbirthc=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_fo_solbirthc",
		-- RingAccess="f1",
		Ecosystem="Forest",
		SheetClient="object_fx_fo-solbirthc.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_fo_solbirthc", entries.fx_fo_solbirthc);

	entries.fx_fo_treefalla=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_fo_treefalla",
		-- RingAccess="f1",
		Ecosystem="Forest",
		SheetClient="object_fx_fo-treefalla.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_fo_treefalla", entries.fx_fo_treefalla);

	entries.fx_fo_treefallb=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_fo_treefallb",
		-- RingAccess="f1",
		Ecosystem="Forest",
		SheetClient="object_fx_fo-treefallb.creature",
		Level=1,

	}

	r2.addPaletteElement("palette.entities.botobjects.fx_fo_treefallb", entries.fx_fo_treefallb);

	entries.fx_fo_treefallc=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_fo_treefallc",
		-- RingAccess="f1",
		Ecosystem="Forest",
		SheetClient="object_fx_fo-treefallc.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_fo_treefallc", entries.fx_fo_treefallc);

	entries.fx_fo_treefalld=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_fo_treefalld",
		-- RingAccess="f1",
		Ecosystem="Forest",
		SheetClient="object_fx_fo-treefalld.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_fo_treefalld", entries.fx_fo_treefalld);

	entries.fx_fo_treefalle=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_fo_treefalle",
		-- RingAccess="f1",
		Ecosystem="Forest",
		SheetClient="object_fx_fo-treefalle.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_fo_treefalle", entries.fx_fo_treefalle);

	entries.fx_fo_fishes=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_fo_fishes",
		-- RingAccess="f1",
		Ecosystem="Forest",
		SheetClient="object_fx_fo_fishes.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_fo_fishes", entries.fx_fo_fishes);

	entries.fx_fo_flower=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_fo_flower",
		-- RingAccess="f1",
		Ecosystem="Forest",
		SheetClient="object_fx_fo_flower.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_fo_flower", entries.fx_fo_flower);

	entries.fx_fo_serpent=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_fo_serpent",
		Ecosystem="",
		SheetClient="object_fx_fo_ju_serpent.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_fo_serpent", entries.fx_fo_serpent);

    entries.fx_ju_serpent=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_ju_serpent",
		Ecosystem="",
		SheetClient="object_fx_fo_ju_serpent.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_ju_serpent", entries.fx_ju_serpent);

	entries.fx_fo_pollen=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_fo_pollen",
		-- RingAccess="f1",
		Ecosystem="Forest",
		SheetClient="object_fx_fo_pollen.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_fo_pollen", entries.fx_fo_pollen);

	entries.fx_fy_sandblastadesert=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_fy_sandblastadesert",
		-- RingAccess="d1",
		Ecosystem="Desert",
		SheetClient="object_fx_fy-sandblastadesert.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_fy_sandblastadesert", entries.fx_fy_sandblastadesert);

	entries.fx_fy_sandblastdesert=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_fy_sandblastdesert",
		-- RingAccess="d1",
		Ecosystem="Desert",
		SheetClient="object_fx_fy-sandblastdesert.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_fy_sandblastdesert", entries.fx_fy_sandblastdesert);

	entries.fx_fyros_de_scorpion=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_fyros_de_scorpion",
		-- RingAccess="d1",
		Ecosystem="Desert",
		SheetClient="object_fx_fyros_de_scorpion.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_fyros_de_scorpion", entries.fx_fyros_de_scorpion);

	entries.fx_fy_feu_foret=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_fy_feu_foret",
		-- RingAccess="d1",
		Ecosystem="Desert",
		SheetClient="object_fx_fy_feu_foret.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_fy_feu_foret", entries.fx_fy_feu_foret);

	entries.fx_fy_flower=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_fy_flower",
		-- RingAccess="d1",
		Ecosystem="Desert",
		SheetClient="object_fx_fy_flower.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_fy_flower", entries.fx_fy_flower);

	entries.fx_goo_insect=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_goo_insect",
		Ecosystem="",
		SheetClient="object_fx_goo_insect.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_goo_insect", entries.fx_goo_insect);

	entries.fx_goo_mamal=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_goo_mamal",
		Ecosystem="",
		SheetClient="object_fx_goo_mamal.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_goo_mamal", entries.fx_goo_mamal);

	entries.fx_goo_smoke=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_goo_smoke",
		Ecosystem="",
		SheetClient="object_fx_goo_smoke.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_goo_smoke", entries.fx_goo_smoke);

	entries.fx_ju_bata=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_ju_bata",
		-- RingAccess="j1",
		Ecosystem="Jungle",
		SheetClient="object_fx_ju-bata.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_ju_bata", entries.fx_ju_bata);

	entries.fx_ju_bugsa=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_ju_bugsa",
		-- RingAccess="j1",
		Ecosystem="Jungle",
		SheetClient="object_fx_ju-bugsa.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_ju_bugsa", entries.fx_ju_bugsa);

	entries.fx_ju_bugsb=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_ju_bugsb",
		-- RingAccess="j1",
		Ecosystem="Jungle",
		SheetClient="object_fx_ju-bugsb.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_ju_bugsb", entries.fx_ju_bugsb);

	entries.fx_ju_dragonflya=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_ju_dragonflya",
		-- RingAccess="j1",
		Ecosystem="Jungle",
		SheetClient="object_fx_ju-dragonflya.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_ju_dragonflya", entries.fx_ju_dragonflya);

	entries.fx_ju_ghosta=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_ju_ghosta",
		-- RingAccess="j1",
		Ecosystem="Jungle",
		SheetClient="object_fx_ju-ghosta.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_ju_ghosta", entries.fx_ju_ghosta);

	entries.fx_ju_ghostb=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_ju_ghostb",
		-- RingAccess="j1",
		Ecosystem="Jungle",
		SheetClient="object_fx_ju-ghostb.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_ju_ghostb", entries.fx_ju_ghostb);

	entries.fx_ju_solbirtha=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_ju_solbirtha",
		-- RingAccess="j1",
		Ecosystem="Jungle",
		SheetClient="object_fx_ju-solbirtha.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_ju_solbirtha", entries.fx_ju_solbirtha);

	entries.fx_ju_solbirthb=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_ju_solbirthb",
		-- RingAccess="j1",
		Ecosystem="Jungle",
		SheetClient="object_fx_ju-solbirthb.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_ju_solbirthb", entries.fx_ju_solbirthb);

	entries.fx_ju_solbirthc=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_ju_solbirthc",
		-- RingAccess="j1",
		Ecosystem="Jungle",
		SheetClient="object_fx_ju-solbirthc.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_ju_solbirthc", entries.fx_ju_solbirthc);

	entries.fx_ju_solbirthd=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_ju_solbirthd",
		-- RingAccess="j1",
		Ecosystem="Jungle",
		SheetClient="object_fx_ju-solbirthd.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_ju_solbirthd", entries.fx_ju_solbirthd);

	entries.fx_ju_treefalla=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_ju_treefalla",
		-- RingAccess="j1",
		Ecosystem="Jungle",
		SheetClient="object_fx_ju-treefalla.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_ju_treefalla", entries.fx_ju_treefalla);

	entries.fx_ju_treefallb=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_ju_treefallb",
		-- RingAccess="j1",
		Ecosystem="Jungle",
		SheetClient="object_fx_ju-treefallb.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_ju_treefallb", entries.fx_ju_treefallb);

	entries.fx_ju_treefallc=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_ju_treefallc",
		-- RingAccess="j1",
		Ecosystem="Jungle",
		SheetClient="object_fx_ju-treefallc.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_ju_treefallc", entries.fx_ju_treefallc);

	entries.fx_ju_treefalld=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_ju_treefalld",
		-- RingAccess="j1",
		Ecosystem="Jungle",
		SheetClient="object_fx_ju-treefalld.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_ju_treefalld", entries.fx_ju_treefalld);

	entries.fx_ju_bibubirdb=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_ju_bibubirdb",
		-- RingAccess="j1",
		Ecosystem="Jungle",
		SheetClient="object_fx_ju_fo_bibubirdb.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_ju_bibubirdb", entries.fx_ju_bibubirdb);

    entries.fx_fo_bibubirdb=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_fo_bibubirdb",
		-- RingAccess="f1",
		Ecosystem="Forest",
		SheetClient="object_fx_ju_fo_bibubirdb.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_fo_bibubirdb", entries.fx_fo_bibubirdb);

	entries.fx_ju_birds=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_ju_birds",
		-- RingAccess="j1",
		Ecosystem="Jungle",
		SheetClient="object_fx_ju_fo_birds.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_ju_birds", entries.fx_ju_birds);

    entries.fx_fo_birds=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_fo_birds",
		-- RingAccess="f1",
		Ecosystem="Forest",
		SheetClient="object_fx_ju_fo_birds.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_fo_birds", entries.fx_fo_birds);

	entries.fx_ju_birdsb=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_ju_birdsb",
		-- RingAccess="j1",
		Ecosystem="Jungle",
		SheetClient="object_fx_ju_fo_birdsb.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_ju_birdsb", entries.fx_ju_birdsb);

    entries.fx_fo_birdsb=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_fo_birdsb",
		-- RingAccess="f1",
		Ecosystem="Forest",
		SheetClient="object_fx_ju_fo_birdsb.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_fo_birdsb", entries.fx_fo_birdsb);

	entries.fx_ju_birdsc=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_ju_birdsc",
		-- RingAccess="j1",
		Ecosystem="Jungle",
		SheetClient="object_fx_ju_fo_birdsc.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_ju_birdsc", entries.fx_ju_birdsc);

    entries.fx_fo_birdsc=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_fo_birdsc",
		-- RingAccess="f1",
		Ecosystem="Forest",
		SheetClient="object_fx_ju_fo_birdsc.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_fo_birdsc", entries.fx_fo_birdsc);

	entries.fx_ju_brumes=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_ju_brumes",
		-- RingAccess="j1",
		Ecosystem="Jungle",
		SheetClient="object_fx_ju_fo_brumes.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_ju_brumes", entries.fx_ju_brumes);

    entries.fx_fo_brumes=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_fo_brumes",
		-- RingAccess="f1",
		Ecosystem="Forest",
		SheetClient="object_fx_ju_fo_brumes.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_fo_brumes", entries.fx_fo_brumes);

	entries.fx_ju_brumesb=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_ju_brumesb",
		-- RingAccess="j1",
		Ecosystem="Jungle",
		SheetClient="object_fx_ju_fo_brumesb.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_ju_brumesb", entries.fx_ju_brumesb);

    entries.fx_fo_brumesb=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_fo_brumesb",
		-- RingAccess="f1",
		Ecosystem="Forest",
		SheetClient="object_fx_ju_fo_brumesb.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_fo_brumesb", entries.fx_fo_brumesb);

	entries.fx_ju_fee=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_ju_fee",
		-- RingAccess="j1",
		Ecosystem="Jungle",
		SheetClient="object_fx_ju_fo_fee.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_ju_fee", entries.fx_ju_fee);

    entries.fx_fo_fee=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_fo_fee",
		-- RingAccess="f1",
		Ecosystem="Forest",
		SheetClient="object_fx_ju_fo_fee.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_fo_fee", entries.fx_fo_fee);

	entries.fx_ju_geyser4a=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_ju_geyser4a",
		-- RingAccess="j1",
		Ecosystem="Jungle",
		SheetClient="object_fx_ju_fo_geyser4a.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_ju_geyser4a", entries.fx_ju_geyser4a);

	entries.fx_fo_geyser4a=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_fo_geyser4a",
		-- RingAccess="f1",
		Ecosystem="Forest",
		SheetClient="object_fx_ju_fo_geyser4a.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_fo_geyser4a", entries.fx_fo_geyser4a);

	entries.fx_ju_geyser4b=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_ju_geyser4b",
		-- RingAccess="j1",
		Ecosystem="Jungle",
		SheetClient="object_fx_ju_fo_geyser4b.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_ju_geyser4b", entries.fx_ju_geyser4b);

    entries.fx_fo_geyser4b=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_fo_geyser4b",
		-- RingAccess="f1",
		Ecosystem="Forest",
		SheetClient="object_fx_ju_fo_geyser4b.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_fo_geyser4b", entries.fx_fo_geyser4b);

	entries.fx_ju_geyser4c=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_ju_geyser4c",
		-- RingAccess="j1",
		Ecosystem="Jungle",
		SheetClient="object_fx_ju_fo_geyser4c.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_ju_geyser4c", entries.fx_ju_geyser4c);

    entries.fx_fo_geyser4c=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_fo_geyser4c",
		-- RingAccess="f1",
		Ecosystem="Forest",
		SheetClient="object_fx_ju_fo_geyser4c.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_fo_geyser4c", entries.fx_fo_geyser4c);

	entries.fx_ju_grenouille3=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_ju_grenouille3",
		-- RingAccess="j1",
		Ecosystem="Jungle",
		SheetClient="object_fx_ju_fo_grenouille3.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_ju_grenouille3", entries.fx_ju_grenouille3);

    entries.fx_fo_grenouille3=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_fo_grenouille3",
		-- RingAccess="f1",
		Ecosystem="Forest",
		SheetClient="object_fx_ju_fo_grenouille3.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_fo_grenouille3", entries.fx_fo_grenouille3);

	entries.fx_ju_grenouilleb3=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_ju_grenouilleb3",
		-- RingAccess="j1",
		Ecosystem="Jungle",
		SheetClient="object_fx_ju_fo_grenouilleb3.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_ju_grenouilleb3", entries.fx_ju_grenouilleb3);

    entries.fx_fo_grenouilleb3=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_fo_grenouilleb3",
		-- RingAccess="f1",
		Ecosystem="Forest",
		SheetClient="object_fx_ju_fo_grenouilleb3.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_fo_grenouilleb3", entries.fx_fo_grenouilleb3);

	entries.fx_ju_grenouillec3=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_ju_grenouillec3",
		-- RingAccess="j1",
		Ecosystem="Jungle",
		SheetClient="object_fx_ju_fo_grenouillec3.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_ju_grenouillec3", entries.fx_ju_grenouillec3);

    entries.fx_fo_grenouillec3=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_fo_grenouillec3",
		-- RingAccess="f1",
		Ecosystem="Forest",
		SheetClient="object_fx_ju_fo_grenouillec3.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_fo_grenouillec3", entries.fx_fo_grenouillec3);

	entries.fx_ju_ratsc=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_ju_ratsc",
		-- RingAccess="j1",
		Ecosystem="Jungle",
		SheetClient="object_fx_ju_fo_ratsc.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_ju_ratsc", entries.fx_ju_ratsc);

    entries.fx_fo_ratsc=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_fo_ratsc",
		-- RingAccess="f1",
		Ecosystem="Forest",
		SheetClient="object_fx_ju_fo_ratsc.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_fo_ratsc", entries.fx_fo_ratsc);

	entries.fx_ju_rotasecte=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_ju_rotasecte",
		-- RingAccess="j1",
		Ecosystem="Jungle",
		SheetClient="object_fx_ju_fo_rotasecte.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_ju_rotasecte", entries.fx_ju_rotasecte);

    entries.fx_fo_rotasecte=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_fo_rotasecte",
		-- RingAccess="f1",
		Ecosystem="Forest",
		SheetClient="object_fx_ju_fo_rotasecte.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_fo_rotasecte", entries.fx_fo_rotasecte);

	entries.fx_ju_rotasecteb=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_ju_rotasecteb",
		-- RingAccess="j1",
		Ecosystem="Jungle",
		SheetClient="object_fx_ju_fo_rotasecteb.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_ju_rotasecteb", entries.fx_ju_rotasecteb);

    entries.fx_fo_rotasecteb=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_fo_rotasecteb",
		-- RingAccess="f1",
		Ecosystem="Forest",
		SheetClient="object_fx_ju_fo_rotasecteb.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_fo_rotasecteb", entries.fx_fo_rotasecteb);

	entries.fx_ju_scorpion2=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_ju_scorpion2",
		-- RingAccess="j1",
		Ecosystem="Jungle",
		SheetClient="object_fx_ju_fo_scorpion2.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_ju_scorpion2", entries.fx_ju_scorpion2);

    entries.fx_fo_scorpion2=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_fo_scorpion2",
		-- RingAccess="f1",
		Ecosystem="Forest",
		SheetClient="object_fx_ju_fo_scorpion2.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_fo_scorpion2", entries.fx_fo_scorpion2);

	entries.fx_ju_taupe=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_ju_taupe",
		-- RingAccess="j1",
		Ecosystem="Jungle",
		SheetClient="object_fx_ju_fo_taupe.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_ju_taupe", entries.fx_ju_taupe);

    entries.fx_fo_taupe=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_fo_taupe",
		-- RingAccess="f1",
		Ecosystem="Forest",
		SheetClient="object_fx_ju_fo_taupe.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_fo_taupe", entries.fx_fo_taupe);

	entries.fx_ju_vent=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_ju_vent",
		-- RingAccess="j1",
		Ecosystem="Jungle",
		SheetClient="object_fx_ju_fo_vent.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_ju_vent", entries.fx_ju_vent);

    entries.fx_fo_vent=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_fo_vent",
		-- RingAccess="f1",
		Ecosystem="Forest",
		SheetClient="object_fx_ju_fo_vent.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_fo_vent", entries.fx_fo_vent);

	entries.fx_la_birds=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_la_birds",
		-- RingAccess="l1",
		Ecosystem="Lacustre",
		SheetClient="object_fx_la_birds.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_la_birds", entries.fx_la_birds);

	entries.fx_la_birdsb=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_la_birdsb",
		-- RingAccess="l1",
		Ecosystem="Lacustre",
		SheetClient="object_fx_la_birdsb.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_la_birdsb", entries.fx_la_birdsb);

	entries.fx_la_serpent=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_la_serpent",
		-- RingAccess="l1",
		Ecosystem="Lacustre",
		SheetClient="object_fx_la_serpent.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_la_serpent", entries.fx_la_serpent);

	entries.fx_la_serpent_sub=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_la_serpent_sub",
		-- RingAccess="l1",
		Ecosystem="Lacustre",
		SheetClient="object_fx_la_serpent_sub.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_la_serpent_sub", entries.fx_la_serpent_sub);

	entries.fx_la_taupe=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_la_taupe",
		-- RingAccess="l1",
		Ecosystem="Lacustre",
		SheetClient="object_fx_la_taupe.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_la_taupe", entries.fx_la_taupe);

	entries.fx_la_vent=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_la_vent",
		-- RingAccess="l1",
		Ecosystem="Lacustre",
		SheetClient="object_fx_la_vent.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_la_vent", entries.fx_la_vent);

	entries.fx_ju_bibubirdb=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_ju_bibubirdb",
		Ecosystem="",
		SheetClient="object_fx_matis_ju_fo_bibubirdb.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_ju_bibubirdb", entries.fx_ju_bibubirdb);

    entries.fx_fo_bibubirdb=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_fo_bibubirdb",
		Ecosystem="",
		SheetClient="object_fx_matis_ju_fo_bibubirdb.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_fo_bibubirdb", entries.fx_fo_bibubirdb);

	entries.fx_tr_colibris=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_tr_colibris",
		-- RingAccess="l1",
		Ecosystem="Lacustre",
		SheetClient="object_fx_tr-colibris.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_tr_colibris", entries.fx_tr_colibris);

	entries.fx_tr_cricket_aqua=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_tr_cricket_aqua",
		-- RingAccess="l1",
		Ecosystem="Lacustre",
		SheetClient="object_fx_tr-cricket_aqua.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_tr_cricket_aqua", entries.fx_tr_cricket_aqua);

	entries.fx_tr_dragonflya=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_tr_dragonflya",
		-- RingAccess="l1",
		Ecosystem="Lacustre",
		SheetClient="object_fx_tr-dragonflya.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_tr_dragonflya", entries.fx_tr_dragonflya);

	entries.fx_tr_dragonflyb=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_tr_dragonflyb",
		-- RingAccess="l1",
		Ecosystem="Lacustre",
		SheetClient="object_fx_tr-dragonflyb.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_tr_dragonflyb", entries.fx_tr_dragonflyb);

	entries.fx_tr_fishes=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_tr_fishes",
		-- RingAccess="l1",
		Ecosystem="Lacustre",
		SheetClient="object_fx_tr-fishes.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_tr_fishes", entries.fx_tr_fishes);

	entries.fx_tr_fishesb=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_tr_fishesb",
		-- RingAccess="l1",
		Ecosystem="Lacustre",
		SheetClient="object_fx_tr-fishesb.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_tr_fishesb", entries.fx_tr_fishesb);

	entries.fx_tr_fishesc=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_tr_fishesc",
		-- RingAccess="l1",
		Ecosystem="Lacustre",
		SheetClient="object_fx_tr-fishesc.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_tr_fishesc", entries.fx_tr_fishesc);

	entries.fx_tr_serpent=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_tr_serpent",
		-- RingAccess="l1",
		Ecosystem="Lacustre",
		SheetClient="object_fx_tr-serpent.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_tr_serpent", entries.fx_tr_serpent);

	entries.fx_tr_pollen=
	{
		Base="palette.entities.botobjects.fx_base",
		Name = "fx_tr_pollen",
		-- RingAccess="l1",
		Ecosystem="Lacustre",
		SheetClient="object_fx_tr_pollen.creature",
		Level=1,
	}
	r2.addPaletteElement("palette.entities.botobjects.fx_tr_pollen", entries.fx_tr_pollen);


-- New NPC Bandits added by Max




-- Melee Bandits


-- Damage dealers

	entries.f_melee_dd_20 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_melee_damage_dealer_slash_b2.creature", SheetModel="ring_melee_damage_dealer_$hands_b$level.creature", SheetClient="basic_fyros_male.creature", Level=20, RingAccess="a1", Equipment="f_melee_dd_20_equipment"  }r2.addPaletteElement("palette.entities.npcs.bandits.f_melee_dd_20",  entries.f_melee_dd_20)
	entries.m_melee_dd_20 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_melee_damage_dealer_slash_b2.creature", SheetModel="ring_melee_damage_dealer_$hands_b$level.creature", SheetClient="basic_matis_male.creature", Level=20, RingAccess="a1", Equipment="m_melee_dd_20_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.m_melee_dd_20", entries.m_melee_dd_20)
	entries.t_melee_dd_20 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_melee_damage_dealer_slash_b2.creature", SheetModel="ring_melee_damage_dealer_$hands_b$level.creature", SheetClient="basic_tryker_male.creature",Level=20, RingAccess="a1", Equipment="t_melee_dd_20_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.t_melee_dd_20", entries.t_melee_dd_20)
	entries.z_melee_dd_20 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_melee_damage_dealer_slash_b2.creature", SheetModel="ring_melee_damage_dealer_$hands_b$level.creature", SheetClient="basic_zorai_male.creature", Level=20, RingAccess="a1", Equipment="z_melee_dd_20_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.z_melee_dd_20", entries.z_melee_dd_20)

	entries.f_melee_dd_70 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_melee_damage_dealer_slash_c2.creature", SheetModel="ring_melee_damage_dealer_$hands_c$level.creature", SheetClient="basic_fyros_male.creature", Level=70, RingAccess="d2", Equipment="f_melee_dd_70_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.f_melee_dd_70", entries.f_melee_dd_70)
	entries.m_melee_dd_70 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_melee_damage_dealer_slash_c2.creature", SheetModel="ring_melee_damage_dealer_$hands_c$level.creature", SheetClient="basic_matis_male.creature", Level=70, RingAccess="f5", Equipment="m_melee_dd_70_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.m_melee_dd_70", entries.m_melee_dd_70)
	entries.t_melee_dd_70 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_melee_damage_dealer_slash_c2.creature", SheetModel="ring_melee_damage_dealer_$hands_c$level.creature", SheetClient="basic_tryker_male.creature", Level=70, RingAccess="l5", Equipment="t_melee_dd_70_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.t_melee_dd_70", entries.t_melee_dd_70)
	entries.z_melee_dd_70 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_melee_damage_dealer_slash_c2.creature", SheetModel="ring_melee_damage_dealer_$hands_c$level.creature", SheetClient="basic_zorai_male.creature", Level=70, RingAccess="j5", Equipment="z_melee_dd_70_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.z_melee_dd_70", entries.z_melee_dd_70)

	entries.f_melee_dd_120 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_melee_damage_dealer_slash_d2.creature", SheetModel="ring_melee_damage_dealer_$hands_d$level.creature", SheetClient="basic_fyros_male.creature", Level=120, RingAccess="d4", Equipment="f_melee_dd_120_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.f_melee_dd_120", entries.f_melee_dd_120)
	entries.m_melee_dd_120 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_melee_damage_dealer_slash_d2.creature", SheetModel="ring_melee_damage_dealer_$hands_d$level.creature", SheetClient="basic_matis_male.creature", Level=120, RingAccess="f5", Equipment="m_melee_dd_120_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.m_melee_dd_120", entries.m_melee_dd_120)
	entries.t_melee_dd_120 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_melee_damage_dealer_pierce_d2.creature", SheetModel="ring_melee_damage_dealer_$hands_d$level.creature", SheetClient="basic_tryker_male.creature", Level=120, RingAccess="l5", Equipment="t_melee_dd_120_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.t_melee_dd_120", entries.t_melee_dd_120)
	entries.z_melee_dd_120 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_melee_damage_dealer_blunt_d2.creature", SheetModel="ring_melee_damage_dealer_$hands_d$level.creature", SheetClient="basic_zorai_male.creature", Level=120, RingAccess="j5", Equipment="z_melee_dd_120_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.z_melee_dd_120", entries.z_melee_dd_120)

	entries.f_melee_dd_170 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_melee_damage_dealer_slash_e2.creature", SheetModel="ring_melee_damage_dealer_$hands_e$level.creature", SheetClient="basic_fyros_male.creature", Level=170, RingAccess="d6", Equipment="f_melee_dd_170_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.f_melee_dd_170", entries.f_melee_dd_170)
	entries.m_melee_dd_170 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_melee_damage_dealer_slash_e2.creature", SheetModel="ring_melee_damage_dealer_$hands_e$level.creature", SheetClient="basic_matis_male.creature", Level=170, RingAccess="f6", Equipment="m_melee_dd_170_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.m_melee_dd_170", entries.m_melee_dd_170)
	entries.t_melee_dd_170 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_melee_damage_dealer_pierce_e2.creature", SheetModel="ring_melee_damage_dealer_$hands_e$level.creature", SheetClient="basic_tryker_male.creature", Level=170, RingAccess="l5", Equipment="t_melee_dd_170_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.t_melee_dd_170", entries.t_melee_dd_170)
	entries.z_melee_dd_170 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_melee_damage_dealer_blunt_e2.creature", SheetModel="ring_melee_damage_dealer_$hands_e$level.creature", SheetClient="basic_zorai_male.creature", Level=170, RingAccess="j6", Equipment="z_melee_dd_170_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.z_melee_dd_170", entries.z_melee_dd_170)

	entries.f_melee_dd_220 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_melee_damage_dealer_slash_f2.creature", SheetModel="ring_melee_damage_dealer_$hands_f$level.creature", SheetClient="basic_fyros_male.creature", Level=220, RingAccess="d7", Equipment="f_melee_dd_220_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.f_melee_dd_220", entries.f_melee_dd_220)
	entries.m_melee_dd_220 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_melee_damage_dealer_slash_f2.creature", SheetModel="ring_melee_damage_dealer_$hands_f$level.creature", SheetClient="basic_matis_male.creature", Level=220, RingAccess="f7", Equipment="m_melee_dd_220_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.m_melee_dd_220", entries.m_melee_dd_220)
	entries.t_melee_dd_220 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_melee_damage_dealer_pierce_f2.creature", SheetModel="ring_melee_damage_dealer_$hands_f$level.creature", SheetClient="basic_tryker_male.creature", Level=220, RingAccess="l6", Equipment="t_melee_dd_220_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.t_melee_dd_220", entries.t_melee_dd_220)
	entries.z_melee_dd_220 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_melee_damage_dealer_blunt_f2.creature", SheetModel="ring_melee_damage_dealer_$hands_f$level.creature", SheetClient="basic_zorai_male.creature", Level=220, RingAccess="j7", Equipment="z_melee_dd_220_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.z_melee_dd_220", entries.z_melee_dd_220)



	entries.f_melee_dd_20_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icfalv"] = "icfalv.sitem", ["uiR2EDequipment_icfamv"] = "icfamv.sitem", }, legs = { ["uiR2EDequipment_icfalp"] = "icfalp.sitem", ["uiR2EDequipment_icfamp"] = "icfamp.sitem", }, boots = { ["uiR2EDequipment_icfamb"] = "icfamb.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icfals"] = "icfals.sitem", ["uiR2EDequipment_icfams"] = "icfams.sitem", }, gloves = { ["uiR2EDequipment_icfamg"] = "icfamg.sitem", }, hands = { ["uiR2EDequipment_icfm2ss"] = "icfm2ss.sitem::slash", ["uiR2EDequipment_icfm2sa"] = "icfm2sa.sitem::slash", ["uiR2EDequipment_icfm2bm"] = "icfm2bm.sitem::blunt", ["uiR2EDequipment_icfm2pp"] = "icfm2pp.sitem::pierce",  }, } r2.addR2PlayerEquipment(entries.f_melee_dd_20, entries.f_melee_dd_20_equipment)
	entries.m_melee_dd_20_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icmalv"] = "icmalv.sitem", ["uiR2EDequipment_icmamv"] = "icmamv.sitem", }, legs = { ["uiR2EDequipment_icmalp"] = "icmalp.sitem", ["uiR2EDequipment_icmamp"] = "icmamp.sitem", }, boots = { ["uiR2EDequipment_icmamb"] = "icmamb.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icmals"] = "icmals.sitem", ["uiR2EDequipment_icmams"] = "icmams.sitem", }, gloves = { ["uiR2EDequipment_icmamg"] = "icmamg.sitem", }, hands = { ["uiR2EDequipment_icmm2ss"] = "icmm2ss.sitem::slash", ["uiR2EDequipment_icmm2sa"] = "icmm2sa.sitem::slash", ["uiR2EDequipment_icmm2bm"] = "icmm2bm.sitem::blunt", ["uiR2EDequipment_icmm2pp"] = "icmm2pp.sitem::pierce",  }, } r2.addR2PlayerEquipment(entries.m_melee_dd_20, entries.m_melee_dd_20_equipment)
	entries.t_melee_dd_20_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_ictalv"] = "ictalv.sitem", ["uiR2EDequipment_ictamv"] = "ictamv.sitem", }, legs = { ["uiR2EDequipment_ictalp"] = "ictalp.sitem", ["uiR2EDequipment_ictamp"] = "ictamp.sitem", }, boots = { ["uiR2EDequipment_ictamb"] = "ictamb.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_ictals"] = "ictals.sitem", ["uiR2EDequipment_ictams"] = "ictams.sitem", }, gloves = { ["uiR2EDequipment_ictamg"] = "ictamg.sitem", }, hands = { ["uiR2EDequipment_ictm2ss"] = "ictm2ss.sitem::slash", ["uiR2EDequipment_ictm2sa"] = "ictm2sa.sitem::slash", ["uiR2EDequipment_ictm2bm"] = "ictm2bm.sitem::blunt", ["uiR2EDequipment_ictm2pp"] = "ictm2pp.sitem::pierce",  }, } r2.addR2PlayerEquipment(entries.t_melee_dd_20, entries.t_melee_dd_20_equipment)
	entries.z_melee_dd_20_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_iczalv"] = "iczalv.sitem", ["uiR2EDequipment_iczamv"] = "iczamv.sitem", }, legs = { ["uiR2EDequipment_iczalp"] = "iczalp.sitem", ["uiR2EDequipment_iczamp"] = "iczamp.sitem", }, boots = { ["uiR2EDequipment_iczamb"] = "iczamb.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_iczals"] = "iczals.sitem", ["uiR2EDequipment_iczams"] = "iczams.sitem", }, gloves = { ["uiR2EDequipment_iczamg"] = "iczamg.sitem", }, hands = { ["uiR2EDequipment_iczm2ss"] = "iczm2ss.sitem::slash", ["uiR2EDequipment_iczm2sa"] = "iczm2sa.sitem::slash", ["uiR2EDequipment_iczm2bm"] = "iczm2bm.sitem::blunt", ["uiR2EDequipment_iczm2pp"] = "iczm2pp.sitem::pierce",  }, } r2.addR2PlayerEquipment(entries.z_melee_dd_20, entries.z_melee_dd_20_equipment)

	entries.f_melee_dd_70_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icfalv"] = "icfalv.sitem", ["uiR2EDequipment_icfamv"] = "icfamv.sitem", ["uiR2EDequipment_icfalv_2"] = "icfalv_2.sitem", ["uiR2EDequipment_icfamv_2"] = "icfamv_2.sitem", }, legs = { ["uiR2EDequipment_icfalp"] = "icfalp.sitem", ["uiR2EDequipment_icfamp"] = "icfamp.sitem", ["uiR2EDequipment_icfalp_2"] = "icfalp_2.sitem", ["uiR2EDequipment_icfamp_2"] = "icfamp_2.sitem", }, boots = { ["uiR2EDequipment_icfamb"] = "icfamb.sitem", ["uiR2EDequipment_icfamb_2"] = "icfamb_2.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icfals"] = "icfals.sitem", ["uiR2EDequipment_icfams"] = "icfams.sitem", ["uiR2EDequipment_icfals_2"] = "icfals_2.sitem", ["uiR2EDequipment_icfams_2"] = "icfams_2.sitem", }, gloves = { ["uiR2EDequipment_icfamg"] = "icfamg.sitem", ["uiR2EDequipment_icfamg_2"] = "icfamg_2.sitem", }, hands = { ["uiR2EDequipment_icfm2ss"] = "icfm2ss.sitem::slash", ["uiR2EDequipment_icfm2ss_2"] = "icfm2ss_2.sitem::slash", ["uiR2EDequipment_icfm2sa"] = "icfm2sa.sitem::slash", ["uiR2EDequipment_icfm2sa_2"] = "icfm2sa_2.sitem::slash", ["uiR2EDequipment_icfm2bm"] = "icfm2bm.sitem::blunt", ["uiR2EDequipment_icfm2bm_2"] = "icfm2bm_2.sitem::blunt", ["uiR2EDequipment_icfm2pp"] = "icfm2pp.sitem::pierce", ["uiR2EDequipment_icfm2pp_2"] = "icfm2pp_2.sitem::pierce",  }, } r2.addR2PlayerEquipment(entries.f_melee_dd_70, entries.f_melee_dd_70_equipment)
	entries.m_melee_dd_70_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icmalv"] = "icmalv.sitem", ["uiR2EDequipment_icmamv"] = "icmamv.sitem", ["uiR2EDequipment_icmalv_2"] = "icmalv_2.sitem", ["uiR2EDequipment_icmamv_2"] = "icmamv_2.sitem", }, legs = { ["uiR2EDequipment_icmalp"] = "icmalp.sitem", ["uiR2EDequipment_icmamp"] = "icmamp.sitem", ["uiR2EDequipment_icmalp_2"] = "icmalp_2.sitem", ["uiR2EDequipment_icmamp_2"] = "icmamp_2.sitem", }, boots = { ["uiR2EDequipment_icmamb"] = "icmamb.sitem", ["uiR2EDequipment_icmamb_2"] = "icmamb_2.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icmals"] = "icmals.sitem", ["uiR2EDequipment_icmams"] = "icmams.sitem", ["uiR2EDequipment_icmals_2"] = "icmals_2.sitem", ["uiR2EDequipment_icmams_2"] = "icmams_2.sitem", }, gloves = { ["uiR2EDequipment_icmamg"] = "icmamg.sitem", ["uiR2EDequipment_icmamg_2"] = "icmamg_2.sitem", }, hands = { ["uiR2EDequipment_icmm2ss"] = "icmm2ss.sitem::slash", ["uiR2EDequipment_icmm2ss_2"] = "icmm2ss_2.sitem::slash", ["uiR2EDequipment_icmm2sa"] = "icmm2sa.sitem::slash", ["uiR2EDequipment_icmm2sa_2"] = "icmm2sa_2.sitem::slash", ["uiR2EDequipment_icmm2bm"] = "icmm2bm.sitem::blunt", ["uiR2EDequipment_icmm2bm_2"] = "icmm2bm_2.sitem::blunt", ["uiR2EDequipment_icmm2pp"] = "icmm2pp.sitem::pierce", ["uiR2EDequipment_icmm2pp_2"] = "icmm2pp_2.sitem::pierce",  }, } r2.addR2PlayerEquipment(entries.m_melee_dd_70, entries.m_melee_dd_70_equipment)
	entries.t_melee_dd_70_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_ictalv"] = "ictalv.sitem", ["uiR2EDequipment_ictamv"] = "ictamv.sitem", ["uiR2EDequipment_ictalv_2"] = "ictalv_2.sitem", ["uiR2EDequipment_ictamv_2"] = "ictamv_2.sitem", }, legs = { ["uiR2EDequipment_ictalp"] = "ictalp.sitem", ["uiR2EDequipment_ictamp"] = "ictamp.sitem", ["uiR2EDequipment_ictalp_2"] = "ictalp_2.sitem", ["uiR2EDequipment_ictamp_2"] = "ictamp_2.sitem", }, boots = { ["uiR2EDequipment_ictamb"] = "ictamb.sitem", ["uiR2EDequipment_ictamb_2"] = "ictamb_2.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_ictals"] = "ictals.sitem", ["uiR2EDequipment_ictams"] = "ictams.sitem", ["uiR2EDequipment_ictals_2"] = "ictals_2.sitem", ["uiR2EDequipment_ictams_2"] = "ictams_2.sitem", }, gloves = { ["uiR2EDequipment_ictamg"] = "ictamg.sitem", ["uiR2EDequipment_ictamg_2"] = "ictamg_2.sitem", }, hands = { ["uiR2EDequipment_ictm2ss"] = "ictm2ss.sitem::slash", ["uiR2EDequipment_ictm2ss_2"] = "ictm2ss_2.sitem::slash", ["uiR2EDequipment_ictm2sa"] = "ictm2sa.sitem::slash", ["uiR2EDequipment_ictm2sa_2"] = "ictm2sa_2.sitem::slash", ["uiR2EDequipment_ictm2bm"] = "ictm2bm.sitem::blunt", ["uiR2EDequipment_ictm2bm_2"] = "ictm2bm_2.sitem::blunt", ["uiR2EDequipment_ictm2pp"] = "ictm2pp.sitem::pierce", ["uiR2EDequipment_ictm2pp_2"] = "ictm2pp_2.sitem::pierce",  }, } r2.addR2PlayerEquipment(entries.t_melee_dd_70, entries.t_melee_dd_70_equipment)
	entries.z_melee_dd_70_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_iczalv"] = "iczalv.sitem", ["uiR2EDequipment_iczamv"] = "iczamv.sitem", ["uiR2EDequipment_iczalv_2"] = "iczalv_2.sitem", ["uiR2EDequipment_iczamv_2"] = "iczamv_2.sitem", }, legs = { ["uiR2EDequipment_iczalp"] = "iczalp.sitem", ["uiR2EDequipment_iczamp"] = "iczamp.sitem", ["uiR2EDequipment_iczalp_2"] = "iczalp_2.sitem", ["uiR2EDequipment_iczamp_2"] = "iczamp_2.sitem", }, boots = { ["uiR2EDequipment_iczamb"] = "iczamb.sitem", ["uiR2EDequipment_iczamb_2"] = "iczamb_2.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_iczals"] = "iczals.sitem", ["uiR2EDequipment_iczams"] = "iczams.sitem", ["uiR2EDequipment_iczals_2"] = "iczals_2.sitem", ["uiR2EDequipment_iczams_2"] = "iczams_2.sitem", }, gloves = { ["uiR2EDequipment_iczamg"] = "iczamg.sitem", ["uiR2EDequipment_iczamg_2"] = "iczamg_2.sitem", }, hands = { ["uiR2EDequipment_iczm2ss"] = "iczm2ss.sitem::slash", ["uiR2EDequipment_iczm2ss_2"] = "iczm2ss_2.sitem::slash", ["uiR2EDequipment_iczm2sa"] = "iczm2sa.sitem::slash", ["uiR2EDequipment_iczm2sa_2"] = "iczm2sa_2.sitem::slash", ["uiR2EDequipment_iczm2bm"] = "iczm2bm.sitem::blunt", ["uiR2EDequipment_iczm2bm_2"] = "iczm2bm_2.sitem::blunt", ["uiR2EDequipment_iczm2pp"] = "iczm2pp.sitem::pierce", ["uiR2EDequipment_iczm2pp_2"] = "iczm2pp_2.sitem::pierce",  }, } r2.addR2PlayerEquipment(entries.z_melee_dd_70, entries.z_melee_dd_70_equipment)

	entries.f_melee_dd_120_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icfalv"] = "icfalv.sitem", ["uiR2EDequipment_icfamv"] = "icfamv.sitem", ["uiR2EDequipment_icfalv_2"] = "icfalv_2.sitem", ["uiR2EDequipment_icfamv_2"] = "icfamv_2.sitem", }, legs = { ["uiR2EDequipment_icfamp"] = "icfamp.sitem", ["uiR2EDequipment_icfamp_2"] = "icfamp_2.sitem", }, boots = { ["uiR2EDequipment_icfamb"] = "icfamb.sitem", ["uiR2EDequipment_icfamb_2"] = "icfamb_2.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icfals"] = "icfals.sitem", ["uiR2EDequipment_icfams"] = "icfams.sitem", ["uiR2EDequipment_icfals_2"] = "icfals_2.sitem", ["uiR2EDequipment_icfams_2"] = "icfams_2.sitem", }, gloves = { ["uiR2EDequipment_icfamg"] = "icfamg.sitem", ["uiR2EDequipment_icfamg_2"] = "icfamg_2.sitem", }, hands = { ["uiR2EDequipment_icfm2ss"] = "icfm2ss.sitem::slash", ["uiR2EDequipment_icfm2ss_2"] = "icfm2ss_2.sitem::slash", ["uiR2EDequipment_icfm2sa"] = "icfm2sa.sitem::slash", ["uiR2EDequipment_icfm2sa_2"] = "icfm2sa_2.sitem::slash", ["uiR2EDequipment_icfm2bm"] = "icfm2bm.sitem::blunt", ["uiR2EDequipment_icfm2bm_2"] = "icfm2bm_2.sitem::blunt", ["uiR2EDequipment_icfm2pp"] = "icfm2pp.sitem::pierce", ["uiR2EDequipment_icfm2pp_2"] = "icfm2pp_2.sitem::pierce",  }, } r2.addR2PlayerEquipment(entries.f_melee_dd_120, entries.f_melee_dd_120_equipment)
	entries.m_melee_dd_120_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icmalv"] = "icmalv.sitem", ["uiR2EDequipment_icmamv"] = "icmamv.sitem", ["uiR2EDequipment_icmalv_2"] = "icmalv_2.sitem", ["uiR2EDequipment_icmamv_2"] = "icmamv_2.sitem", }, legs = { ["uiR2EDequipment_icmamp"] = "icmamp.sitem", ["uiR2EDequipment_icmamp_2"] = "icmamp_2.sitem", }, boots = { ["uiR2EDequipment_icmamb"] = "icmamb.sitem", ["uiR2EDequipment_icmamb_2"] = "icmamb_2.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icmals"] = "icmals.sitem", ["uiR2EDequipment_icmams"] = "icmams.sitem", ["uiR2EDequipment_icmals_2"] = "icmals_2.sitem", ["uiR2EDequipment_icmams_2"] = "icmams_2.sitem", }, gloves = { ["uiR2EDequipment_icmamg"] = "icmamg.sitem", ["uiR2EDequipment_icmamg_2"] = "icmamg_2.sitem", }, hands = { ["uiR2EDequipment_icmm2ss"] = "icmm2ss.sitem::slash", ["uiR2EDequipment_icmm2ss_2"] = "icmm2ss_2.sitem::slash", ["uiR2EDequipment_icmm2sa"] = "icmm2sa.sitem::slash", ["uiR2EDequipment_icmm2sa_2"] = "icmm2sa_2.sitem::slash", ["uiR2EDequipment_icmm2bm"] = "icmm2bm.sitem::blunt", ["uiR2EDequipment_icmm2bm_2"] = "icmm2bm_2.sitem::blunt", ["uiR2EDequipment_icmm2pp"] = "icmm2pp.sitem::pierce", ["uiR2EDequipment_icmm2pp_2"] = "icmm2pp_2.sitem::pierce",  }, } r2.addR2PlayerEquipment(entries.m_melee_dd_120, entries.m_melee_dd_120_equipment)
	entries.t_melee_dd_120_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_ictalv"] = "ictalv.sitem", ["uiR2EDequipment_ictamv"] = "ictamv.sitem", ["uiR2EDequipment_ictalv_2"] = "ictalv_2.sitem", ["uiR2EDequipment_ictamv_2"] = "ictamv_2.sitem", }, legs = { ["uiR2EDequipment_ictamp"] = "ictamp.sitem", ["uiR2EDequipment_ictamp_2"] = "ictamp_2.sitem", }, boots = { ["uiR2EDequipment_ictamb"] = "ictamb.sitem", ["uiR2EDequipment_ictamb_2"] = "ictamb_2.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_ictals"] = "ictals.sitem", ["uiR2EDequipment_ictams"] = "ictams.sitem", ["uiR2EDequipment_ictals_2"] = "ictals_2.sitem", ["uiR2EDequipment_ictams_2"] = "ictams_2.sitem", }, gloves = { ["uiR2EDequipment_ictamg"] = "ictamg.sitem", ["uiR2EDequipment_ictamg_2"] = "ictamg_2.sitem", }, hands = { ["uiR2EDequipment_ictm2ss"] = "ictm2ss.sitem::slash", ["uiR2EDequipment_ictm2ss_2"] = "ictm2ss_2.sitem::slash", ["uiR2EDequipment_ictm2sa"] = "ictm2sa.sitem::slash", ["uiR2EDequipment_ictm2sa_2"] = "ictm2sa_2.sitem::slash", ["uiR2EDequipment_ictm2bm"] = "ictm2bm.sitem::blunt", ["uiR2EDequipment_ictm2bm_2"] = "ictm2bm_2.sitem::blunt", ["uiR2EDequipment_ictm2pp"] = "ictm2pp.sitem::pierce", ["uiR2EDequipment_ictm2pp_2"] = "ictm2pp_2.sitem::pierce",  }, } r2.addR2PlayerEquipment(entries.t_melee_dd_120, entries.t_melee_dd_120_equipment)
	entries.z_melee_dd_120_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_iczalv"] = "iczalv.sitem", ["uiR2EDequipment_iczamv"] = "iczamv.sitem", ["uiR2EDequipment_iczalv_2"] = "iczalv_2.sitem", ["uiR2EDequipment_iczamv_2"] = "iczamv_2.sitem", }, legs = { ["uiR2EDequipment_iczamp"] = "iczamp.sitem", ["uiR2EDequipment_iczamp_2"] = "iczamp_2.sitem", }, boots = { ["uiR2EDequipment_iczamb"] = "iczamb.sitem", ["uiR2EDequipment_iczamb_2"] = "iczamb_2.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_iczals"] = "iczals.sitem", ["uiR2EDequipment_iczams"] = "iczams.sitem", ["uiR2EDequipment_iczals_2"] = "iczals_2.sitem", ["uiR2EDequipment_iczams_2"] = "iczams_2.sitem", }, gloves = { ["uiR2EDequipment_iczamg"] = "iczamg.sitem", ["uiR2EDequipment_iczamg_2"] = "iczamg_2.sitem", }, hands = { ["uiR2EDequipment_iczm2ss"] = "iczm2ss.sitem::slash", ["uiR2EDequipment_iczm2ss_2"] = "iczm2ss_2.sitem::slash", ["uiR2EDequipment_iczm2sa"] = "iczm2sa.sitem::slash", ["uiR2EDequipment_iczm2sa_2"] = "iczm2sa_2.sitem::slash", ["uiR2EDequipment_iczm2bm"] = "iczm2bm.sitem::blunt", ["uiR2EDequipment_iczm2bm_2"] = "iczm2bm_2.sitem::blunt", ["uiR2EDequipment_iczm2pp"] = "iczm2pp.sitem::pierce", ["uiR2EDequipment_iczm2pp_2"] = "iczm2pp_2.sitem::pierce",  }, } r2.addR2PlayerEquipment(entries.z_melee_dd_120, entries.z_melee_dd_120_equipment)

	entries.f_melee_dd_170_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icfamv_2"] = "icfamv_2.sitem", ["uiR2EDequipment_icfahv_2"] = "icfahv_2.sitem", ["uiR2EDequipment_icfamv_3"] = "icfamv_3.sitem", ["uiR2EDequipment_icfahv_3"] = "icfahv_3.sitem", }, legs = { ["uiR2EDequipment_icfamp_2"] = "icfamp_2.sitem", ["uiR2EDequipment_icfamp_3"] = "icfamp_3.sitem", }, boots = { ["uiR2EDequipment_icfamb_2"] = "icfamb_2.sitem", ["uiR2EDequipment_icfamb_3"] = "icfamb_3.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icfals_2"] = "icfals_2.sitem", ["uiR2EDequipment_icfams_2"] = "icfams_2.sitem", ["uiR2EDequipment_icfals_3"] = "icfals_3.sitem", ["uiR2EDequipment_icfams_3"] = "icfams_3.sitem", }, gloves = { ["uiR2EDequipment_icfamg_2"] = "icfamg_2.sitem", ["uiR2EDequipment_icfamg_3"] = "icfamg_3.sitem", }, hands = { ["uiR2EDequipment_icfm2ss_2"] = "icfm2ss_2.sitem::slash", ["uiR2EDequipment_icfm2ss_3"] = "icfm2ss_3.sitem::slash", ["uiR2EDequipment_icfm2sa_2"] = "icfm2sa_2.sitem::slash", ["uiR2EDequipment_icfm2sa_3"] = "icfm2sa_3.sitem::slash", ["uiR2EDequipment_icfm2bm_2"] = "icfm2bm_2.sitem::blunt", ["uiR2EDequipment_icfm2bm_3"] = "icfm2bm_3.sitem::blunt", ["uiR2EDequipment_icfm2pp_2"] = "icfm2pp_2.sitem::pierce", ["uiR2EDequipment_icfm2pp_3"] = "icfm2pp_3.sitem::pierce",  }, } r2.addR2PlayerEquipment(entries.f_melee_dd_170, entries.f_melee_dd_170_equipment)
	entries.m_melee_dd_170_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icmamv_2"] = "icmamv_2.sitem", ["uiR2EDequipment_icmahv_2"] = "icmahv_2.sitem", ["uiR2EDequipment_icmamv_3"] = "icmamv_3.sitem", ["uiR2EDequipment_icmahv_3"] = "icmahv_3.sitem", }, legs = { ["uiR2EDequipment_icmamp_2"] = "icmamp_2.sitem", ["uiR2EDequipment_icmamp_3"] = "icmamp_3.sitem", }, boots = { ["uiR2EDequipment_icmamb_2"] = "icmamb_2.sitem", ["uiR2EDequipment_icmamb_3"] = "icmamb_3.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icmals_2"] = "icmals_2.sitem", ["uiR2EDequipment_icmams_2"] = "icmams_2.sitem", ["uiR2EDequipment_icmals_3"] = "icmals_3.sitem", ["uiR2EDequipment_icmams_3"] = "icmams_3.sitem", }, gloves = { ["uiR2EDequipment_icmamg_2"] = "icmamg_2.sitem", ["uiR2EDequipment_icmamg_3"] = "icmamg_3.sitem", }, hands = { ["uiR2EDequipment_icmm2ss_2"] = "icmm2ss_2.sitem::slash", ["uiR2EDequipment_icmm2ss_3"] = "icmm2ss_3.sitem::slash", ["uiR2EDequipment_icmm2sa_2"] = "icmm2sa_2.sitem::slash", ["uiR2EDequipment_icmm2sa_3"] = "icmm2sa_3.sitem::slash", ["uiR2EDequipment_icmm2bm_2"] = "icmm2bm_2.sitem::blunt", ["uiR2EDequipment_icmm2bm_3"] = "icmm2bm_3.sitem::blunt", ["uiR2EDequipment_icmm2pp_2"] = "icmm2pp_2.sitem::pierce", ["uiR2EDequipment_icmm2pp_3"] = "icmm2pp_3.sitem::pierce",  }, } r2.addR2PlayerEquipment(entries.m_melee_dd_170, entries.m_melee_dd_170_equipment)
	entries.t_melee_dd_170_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_ictamv_2"] = "ictamv_2.sitem", ["uiR2EDequipment_ictahv_2"] = "ictahv_2.sitem", ["uiR2EDequipment_ictamv_3"] = "ictamv_3.sitem", ["uiR2EDequipment_ictahv_3"] = "ictahv_3.sitem", }, legs = { ["uiR2EDequipment_ictamp_2"] = "ictamp_2.sitem", ["uiR2EDequipment_ictamp_3"] = "ictamp_3.sitem", }, boots = { ["uiR2EDequipment_ictamb_2"] = "ictamb_2.sitem", ["uiR2EDequipment_ictamb_3"] = "ictamb_3.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_ictals_2"] = "ictals_2.sitem", ["uiR2EDequipment_ictams_2"] = "ictams_2.sitem", ["uiR2EDequipment_ictals_3"] = "ictals_3.sitem", ["uiR2EDequipment_ictams_3"] = "ictams_3.sitem", }, gloves = { ["uiR2EDequipment_ictamg_2"] = "ictamg_2.sitem", ["uiR2EDequipment_ictamg_3"] = "ictamg_3.sitem", }, hands = { ["uiR2EDequipment_ictm2ss_2"] = "ictm2ss_2.sitem::slash", ["uiR2EDequipment_ictm2ss_3"] = "ictm2ss_3.sitem::slash", ["uiR2EDequipment_ictm2sa_2"] = "ictm2sa_2.sitem::slash", ["uiR2EDequipment_ictm2sa_3"] = "ictm2sa_3.sitem::slash", ["uiR2EDequipment_ictm2bm_2"] = "ictm2bm_2.sitem::blunt", ["uiR2EDequipment_ictm2bm_3"] = "ictm2bm_3.sitem::blunt", ["uiR2EDequipment_ictm2pp_2"] = "ictm2pp_2.sitem::pierce", ["uiR2EDequipment_ictm2pp_3"] = "ictm2pp_3.sitem::pierce",  }, } r2.addR2PlayerEquipment(entries.t_melee_dd_170, entries.t_melee_dd_170_equipment)
	entries.z_melee_dd_170_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_iczamv_2"] = "iczamv_2.sitem", ["uiR2EDequipment_iczahv_2"] = "iczahv_2.sitem", ["uiR2EDequipment_iczamv_3"] = "iczamv_3.sitem", ["uiR2EDequipment_iczahv_3"] = "iczahv_3.sitem", }, legs = { ["uiR2EDequipment_iczamp_2"] = "iczamp_2.sitem", ["uiR2EDequipment_iczamp_3"] = "iczamp_3.sitem", }, boots = { ["uiR2EDequipment_iczamb_2"] = "iczamb_2.sitem", ["uiR2EDequipment_iczamb_3"] = "iczamb_3.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_iczals_2"] = "iczals_2.sitem", ["uiR2EDequipment_iczams_2"] = "iczams_2.sitem", ["uiR2EDequipment_iczals_3"] = "iczals_3.sitem", ["uiR2EDequipment_iczams_3"] = "iczams_3.sitem", }, gloves = { ["uiR2EDequipment_iczamg_2"] = "iczamg_2.sitem", ["uiR2EDequipment_iczamg_3"] = "iczamg_3.sitem", }, hands = { ["uiR2EDequipment_iczm2ss_2"] = "iczm2ss_2.sitem::slash", ["uiR2EDequipment_iczm2ss_3"] = "iczm2ss_3.sitem::slash", ["uiR2EDequipment_iczm2sa_2"] = "iczm2sa_2.sitem::slash", ["uiR2EDequipment_iczm2sa_3"] = "iczm2sa_3.sitem::slash", ["uiR2EDequipment_iczm2bm_2"] = "iczm2bm_2.sitem::blunt", ["uiR2EDequipment_iczm2bm_3"] = "iczm2bm_3.sitem::blunt", ["uiR2EDequipment_iczm2pp_2"] = "iczm2pp_2.sitem::pierce", ["uiR2EDequipment_iczm2pp_3"] = "iczm2pp_3.sitem::pierce",  }, } r2.addR2PlayerEquipment(entries.z_melee_dd_170, entries.z_melee_dd_170_equipment)

	entries.f_melee_dd_220_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icfamv_2"] = "icfamv_2.sitem", ["uiR2EDequipment_icfahv_2"] = "icfahv_2.sitem", ["uiR2EDequipment_icfamv_3"] = "icfamv_3.sitem", ["uiR2EDequipment_icfahv_3"] = "icfahv_3.sitem", }, legs = { ["uiR2EDequipment_icfamp_2"] = "icfamp_2.sitem", ["uiR2EDequipment_icfamp_3"] = "icfamp_3.sitem", }, boots = { ["uiR2EDequipment_icfamb_2"] = "icfamb_2.sitem", ["uiR2EDequipment_icfahb_2"] = "icfahb_2.sitem", ["uiR2EDequipment_icfamb_3"] = "icfamb_3.sitem", ["uiR2EDequipment_icfahb_3"] = "icfahb_3.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icfams_2"] = "icfams_2.sitem", ["uiR2EDequipment_icfams_3"] = "icfams_3.sitem", }, gloves = { ["uiR2EDequipment_icfamg_2"] = "icfamg_2.sitem", ["uiR2EDequipment_icfamg_3"] = "icfamg_3.sitem", }, hands = { ["uiR2EDequipment_icfm2ss_2"] = "icfm2ss_2.sitem::slash", ["uiR2EDequipment_icfm2ss_3"] = "icfm2ss_3.sitem::slash", ["uiR2EDequipment_icfm2sa_2"] = "icfm2sa_2.sitem::slash", ["uiR2EDequipment_icfm2sa_3"] = "icfm2sa_3.sitem::slash", ["uiR2EDequipment_icfm2bm_2"] = "icfm2bm_2.sitem::blunt", ["uiR2EDequipment_icfm2bm_3"] = "icfm2bm_3.sitem::blunt", ["uiR2EDequipment_icfm2pp_2"] = "icfm2pp_2.sitem::pierce", ["uiR2EDequipment_icfm2pp_3"] = "icfm2pp_3.sitem::pierce",  }, } r2.addR2PlayerEquipment(entries.f_melee_dd_220, entries.f_melee_dd_220_equipment)
	entries.m_melee_dd_220_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icmamv_2"] = "icmamv_2.sitem", ["uiR2EDequipment_icmahv_2"] = "icmahv_2.sitem", ["uiR2EDequipment_icmamv_3"] = "icmamv_3.sitem", ["uiR2EDequipment_icmahv_3"] = "icmahv_3.sitem", }, legs = { ["uiR2EDequipment_icmamp_2"] = "icmamp_2.sitem", ["uiR2EDequipment_icmamp_3"] = "icmamp_3.sitem", }, boots = { ["uiR2EDequipment_icmamb_2"] = "icmamb_2.sitem", ["uiR2EDequipment_icmahb_2"] = "icmahb_2.sitem", ["uiR2EDequipment_icmamb_3"] = "icmamb_3.sitem", ["uiR2EDequipment_icmahb_3"] = "icmahb_3.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icmams_2"] = "icmams_2.sitem", ["uiR2EDequipment_icmams_3"] = "icmams_3.sitem", }, gloves = { ["uiR2EDequipment_icmamg_2"] = "icmamg_2.sitem", ["uiR2EDequipment_icmamg_3"] = "icmamg_3.sitem", }, hands = { ["uiR2EDequipment_icmm2ss_2"] = "icmm2ss_2.sitem::slash", ["uiR2EDequipment_icmm2ss_3"] = "icmm2ss_3.sitem::slash", ["uiR2EDequipment_icmm2sa_2"] = "icmm2sa_2.sitem::slash", ["uiR2EDequipment_icmm2sa_3"] = "icmm2sa_3.sitem::slash", ["uiR2EDequipment_icmm2bm_2"] = "icmm2bm_2.sitem::blunt", ["uiR2EDequipment_icmm2bm_3"] = "icmm2bm_3.sitem::blunt", ["uiR2EDequipment_icmm2pp_2"] = "icmm2pp_2.sitem::pierce", ["uiR2EDequipment_icmm2pp_3"] = "icmm2pp_3.sitem::pierce",  }, } r2.addR2PlayerEquipment(entries.m_melee_dd_220, entries.m_melee_dd_220_equipment)
	entries.t_melee_dd_220_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_ictamv_2"] = "ictamv_2.sitem", ["uiR2EDequipment_ictahv_2"] = "ictahv_2.sitem", ["uiR2EDequipment_ictamv_3"] = "ictamv_3.sitem", ["uiR2EDequipment_ictahv_3"] = "ictahv_3.sitem", }, legs = { ["uiR2EDequipment_ictamp_2"] = "ictamp_2.sitem", ["uiR2EDequipment_ictamp_3"] = "ictamp_3.sitem", }, boots = { ["uiR2EDequipment_ictamb_2"] = "ictamb_2.sitem", ["uiR2EDequipment_ictahb_2"] = "ictahb_2.sitem", ["uiR2EDequipment_ictamb_3"] = "ictamb_3.sitem", ["uiR2EDequipment_ictahb_3"] = "ictahb_3.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_ictams_2"] = "ictams_2.sitem", ["uiR2EDequipment_ictams_3"] = "ictams_3.sitem", }, gloves = { ["uiR2EDequipment_ictamg_2"] = "ictamg_2.sitem", ["uiR2EDequipment_ictamg_3"] = "ictamg_3.sitem", }, hands = { ["uiR2EDequipment_ictm2ss_2"] = "ictm2ss_2.sitem::slash", ["uiR2EDequipment_ictm2ss_3"] = "ictm2ss_3.sitem::slash", ["uiR2EDequipment_ictm2sa_2"] = "ictm2sa_2.sitem::slash", ["uiR2EDequipment_ictm2sa_3"] = "ictm2sa_3.sitem::slash", ["uiR2EDequipment_ictm2bm_2"] = "ictm2bm_2.sitem::blunt", ["uiR2EDequipment_ictm2bm_3"] = "ictm2bm_3.sitem::blunt", ["uiR2EDequipment_ictm2pp_2"] = "ictm2pp_2.sitem::pierce", ["uiR2EDequipment_ictm2pp_3"] = "ictm2pp_3.sitem::pierce",  }, } r2.addR2PlayerEquipment(entries.t_melee_dd_220, entries.t_melee_dd_220_equipment)
	entries.z_melee_dd_220_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_iczamv_2"] = "iczamv_2.sitem", ["uiR2EDequipment_iczahv_2"] = "iczahv_2.sitem", ["uiR2EDequipment_iczamv_3"] = "iczamv_3.sitem", ["uiR2EDequipment_iczahv_3"] = "iczahv_3.sitem", }, legs = { ["uiR2EDequipment_iczamp_2"] = "iczamp_2.sitem", ["uiR2EDequipment_iczamp_3"] = "iczamp_3.sitem", }, boots = { ["uiR2EDequipment_iczamb_2"] = "iczamb_2.sitem", ["uiR2EDequipment_iczahb_2"] = "iczahb_2.sitem", ["uiR2EDequipment_iczamb_3"] = "iczamb_3.sitem", ["uiR2EDequipment_iczahb_3"] = "iczahb_3.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_iczams_2"] = "iczams_2.sitem", ["uiR2EDequipment_iczams_3"] = "iczams_3.sitem", }, gloves = { ["uiR2EDequipment_iczamg_2"] = "iczamg_2.sitem", ["uiR2EDequipment_iczamg_3"] = "iczamg_3.sitem", }, hands = { ["uiR2EDequipment_iczm2ss_2"] = "iczm2ss_2.sitem::slash", ["uiR2EDequipment_iczm2ss_3"] = "iczm2ss_3.sitem::slash", ["uiR2EDequipment_iczm2sa_2"] = "iczm2sa_2.sitem::slash", ["uiR2EDequipment_iczm2sa_3"] = "iczm2sa_3.sitem::slash", ["uiR2EDequipment_iczm2bm_2"] = "iczm2bm_2.sitem::blunt", ["uiR2EDequipment_iczm2bm_3"] = "iczm2bm_3.sitem::blunt", ["uiR2EDequipment_iczm2pp_2"] = "iczm2pp_2.sitem::pierce", ["uiR2EDequipment_iczm2pp_3"] = "iczm2pp_3.sitem::pierce",  }, } r2.addR2PlayerEquipment(entries.z_melee_dd_220, entries.z_melee_dd_220_equipment)



-- Tanks

	entries.f_melee_tank_20 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_melee_tank_slash_b2.creature", SheetModel="ring_melee_tank_$hands_b$level.creature", SheetClient="basic_fyros_male.creature", Level=20, RingAccess="a1", Equipment="f_melee_tank_20_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.f_melee_tank_20", entries.f_melee_tank_20)
	entries.m_melee_tank_20 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_melee_tank_slash_b2.creature", SheetModel="ring_melee_tank_$hands_b$level.creature", SheetClient="basic_matis_male.creature", Level=20, RingAccess="a1", Equipment="m_melee_tank_20_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.m_melee_tank_20", entries.m_melee_tank_20)
	entries.t_melee_tank_20 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_melee_tank_slash_b2.creature", SheetModel="ring_melee_tank_$hands_b$level.creature", SheetClient="basic_tryker_male.creature", Level=20, RingAccess="a1", Equipment="t_melee_tank_20_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.t_melee_tank_20", entries.t_melee_tank_20)
	entries.z_melee_tank_20 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_melee_tank_slash_b2.creature", SheetModel="ring_melee_tank_$hands_b$level.creature", SheetClient="basic_zorai_male.creature", Level=20, RingAccess="a1", Equipment="z_melee_tank_20_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.z_melee_tank_20", entries.z_melee_tank_20)

	entries.f_melee_tank_70 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_melee_tank_slash_c2.creature", SheetModel="ring_melee_tank_$hands_c$level.creature", SheetClient="basic_fyros_male.creature", Level=70, RingAccess="d2", Equipment="f_melee_tank_70_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.f_melee_tank_70", entries.f_melee_tank_70)
	entries.m_melee_tank_70 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_melee_tank_slash_c2.creature", SheetModel="ring_melee_tank_$hands_c$level.creature", SheetClient="basic_matis_male.creature", Level=70, RingAccess="f5", Equipment="m_melee_tank_70_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.m_melee_tank_70", entries.m_melee_tank_70)
	entries.t_melee_tank_70 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_melee_tank_slash_c2.creature", SheetModel="ring_melee_tank_$hands_c$level.creature", SheetClient="basic_tryker_male.creature", Level=70, RingAccess="l5", Equipment="t_melee_tank_70_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.t_melee_tank_70", entries.t_melee_tank_70)
	entries.z_melee_tank_70 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_melee_tank_slash_c2.creature", SheetModel="ring_melee_tank_$hands_c$level.creature", SheetClient="basic_zorai_male.creature", Level=70, RingAccess="j5", Equipment="z_melee_tank_70_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.z_melee_tank_70", entries.z_melee_tank_70)

	entries.f_melee_tank_120 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_melee_tank_slash_d2.creature", SheetModel="ring_melee_tank_$hands_d$level.creature", SheetClient="basic_fyros_male.creature", Level=120, RingAccess="d4", Equipment="f_melee_tank_120_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.f_melee_tank_120", entries.f_melee_tank_120)
	entries.m_melee_tank_120 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_melee_tank_slash_d2.creature", SheetModel="ring_melee_tank_$hands_d$level.creature", SheetClient="basic_matis_male.creature", Level=120, RingAccess="f5", Equipment="m_melee_tank_120_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.m_melee_tank_120", entries.m_melee_tank_120)
	entries.t_melee_tank_120 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_melee_tank_slash_d2.creature", SheetModel="ring_melee_tank_$hands_d$level.creature", SheetClient="basic_tryker_male.creature", Level=120, RingAccess="l5", Equipment="t_melee_tank_120_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.t_melee_tank_120", entries.t_melee_tank_120)
	entries.z_melee_tank_120 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_melee_tank_slash_d2.creature", SheetModel="ring_melee_tank_$hands_d$level.creature", SheetClient="basic_zorai_male.creature", Level=120, RingAccess="j5", Equipment="z_melee_tank_120_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.z_melee_tank_120", entries.z_melee_tank_120)

	entries.f_melee_tank_170 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_melee_tank_slash_e2.creature", SheetModel="ring_melee_tank_$hands_e$level.creature", SheetClient="basic_fyros_male.creature", Level=170, RingAccess="d6", Equipment="f_melee_tank_170_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.f_melee_tank_170", entries.f_melee_tank_170)
	entries.m_melee_tank_170 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_melee_tank_slash_e2.creature", SheetModel="ring_melee_tank_$hands_e$level.creature", SheetClient="basic_matis_male.creature", Level=170, RingAccess="f6", Equipment="m_melee_tank_170_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.m_melee_tank_170", entries.m_melee_tank_170)
	entries.t_melee_tank_170 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_melee_tank_slash_e2.creature", SheetModel="ring_melee_tank_$hands_e$level.creature", SheetClient="basic_tryker_male.creature", Level=170, RingAccess="l5", Equipment="t_melee_tank_170_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.t_melee_tank_170", entries.t_melee_tank_170)
	entries.z_melee_tank_170 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_melee_tank_slash_e2.creature", SheetModel="ring_melee_tank_$hands_e$level.creature", SheetClient="basic_zorai_male.creature", Level=170, RingAccess="j6", Equipment="z_melee_tank_170_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.z_melee_tank_170", entries.z_melee_tank_170)

	entries.f_melee_tank_220 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_melee_tank_slash_f2.creature", SheetModel="ring_melee_tank_$hands_f$level.creature", SheetClient="basic_fyros_male.creature", Level=220, RingAccess="d7", Equipment="f_melee_tank_220_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.f_melee_tank_220", entries.f_melee_tank_220)
	entries.m_melee_tank_220 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_melee_tank_slash_f2.creature", SheetModel="ring_melee_tank_$hands_f$level.creature", SheetClient="basic_matis_male.creature", Level=220, RingAccess="f7", Equipment="m_melee_tank_220_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.m_melee_tank_220", entries.m_melee_tank_220)
	entries.t_melee_tank_220 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_melee_tank_slash_f2.creature", SheetModel="ring_melee_tank_$hands_f$level.creature", SheetClient="basic_tryker_male.creature", Level=220, RingAccess="l6", Equipment="t_melee_tank_220_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.t_melee_tank_220", entries.t_melee_tank_220)
	entries.z_melee_tank_220 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_melee_tank_slash_f2.creature", SheetModel="ring_melee_tank_$hands_f$level.creature", SheetClient="basic_zorai_male.creature", Level=220, RingAccess="j7", Equipment="z_melee_tank_220_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.z_melee_tank_220", entries.z_melee_tank_220)



	entries.f_melee_tank_20_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icfalv"] = "icfalv.sitem", ["uiR2EDequipment_icfamv"] = "icfamv.sitem", }, legs = { ["uiR2EDequipment_icfalp"] = "icfalp.sitem", ["uiR2EDequipment_icfamp"] = "icfamp.sitem", }, boots = { ["uiR2EDequipment_icfamb"] = "icfamb.sitem", }, arms_guard = { ["uiR2EDequipment_icfals"] = "icfals.sitem", ["uiR2EDequipment_icfams"] = "icfams.sitem", }, gloves = { ["uiR2EDequipment_icfahg"] = "icfahg.sitem", }, hands = { ["uiR2EDequipment_icfm1ss"] = "icfm1ss.sitem:icfsb.sitem:slash", ["uiR2EDequipment_icfm1ss"] = "icfm1ss.sitem:icfss.sitem:slash", ["uiR2EDequipment_icfm1sa"] = "icfm1sa.sitem:icfsb.sitem:slash", ["uiR2EDequipment_icfm1sa"] = "icfm1sa.sitem:icfss.sitem:slash", ["uiR2EDequipment_icfm1bm"] = "icfm1bm.sitem:icfsb.sitem:blunt", ["uiR2EDequipment_icfm1bm"] = "icfm1bm.sitem:icfss.sitem:blunt", ["uiR2EDequipment_icfm1ps"] = "icfm1ps.sitem:icfsb.sitem:pierce", ["uiR2EDequipment_icfm1ps"] = "icfm1ps.sitem:icfss.sitem:pierce",  }, } r2.addR2PlayerEquipment(entries.f_melee_tank_20, entries.f_melee_tank_20_equipment)
	entries.m_melee_tank_20_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icmalv"] = "icmalv.sitem", ["uiR2EDequipment_icmamv"] = "icmamv.sitem", }, legs = { ["uiR2EDequipment_icmalp"] = "icmalp.sitem", ["uiR2EDequipment_icmamp"] = "icmamp.sitem", }, boots = { ["uiR2EDequipment_icmamb"] = "icmamb.sitem", }, arms_guard = { ["uiR2EDequipment_icmals"] = "icmals.sitem", ["uiR2EDequipment_icmams"] = "icmams.sitem", }, gloves = { ["uiR2EDequipment_icmahg"] = "icmahg.sitem", }, hands = { ["uiR2EDequipment_icmm1ss"] = "icmm1ss.sitem:icmsb.sitem:slash", ["uiR2EDequipment_icmm1ss"] = "icmm1ss.sitem:icmss.sitem:slash", ["uiR2EDequipment_icmm1sa"] = "icmm1sa.sitem:icmsb.sitem:slash", ["uiR2EDequipment_icmm1sa"] = "icmm1sa.sitem:icmss.sitem:slash", ["uiR2EDequipment_icmm1bm"] = "icmm1bm.sitem:icmsb.sitem:blunt", ["uiR2EDequipment_icmm1bm"] = "icmm1bm.sitem:icmss.sitem:blunt", ["uiR2EDequipment_icmm1ps"] = "icmm1ps.sitem:icmsb.sitem:pierce", ["uiR2EDequipment_icmm1ps"] = "icmm1ps.sitem:icmss.sitem:pierce",  }, } r2.addR2PlayerEquipment(entries.m_melee_tank_20, entries.m_melee_tank_20_equipment)
	entries.t_melee_tank_20_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_ictalv"] = "ictalv.sitem", ["uiR2EDequipment_ictamv"] = "ictamv.sitem", }, legs = { ["uiR2EDequipment_ictalp"] = "ictalp.sitem", ["uiR2EDequipment_ictamp"] = "ictamp.sitem", }, boots = { ["uiR2EDequipment_ictamb"] = "ictamb.sitem", }, arms_guard = { ["uiR2EDequipment_ictals"] = "ictals.sitem", ["uiR2EDequipment_ictams"] = "ictams.sitem", }, gloves = { ["uiR2EDequipment_ictahg"] = "ictahg.sitem", }, hands = { ["uiR2EDequipment_ictm1ss"] = "ictm1ss.sitem:ictsb.sitem:slash", ["uiR2EDequipment_ictm1ss"] = "ictm1ss.sitem:ictss.sitem:slash", ["uiR2EDequipment_ictm1sa"] = "ictm1sa.sitem:ictsb.sitem:slash", ["uiR2EDequipment_ictm1sa"] = "ictm1sa.sitem:ictss.sitem:slash", ["uiR2EDequipment_ictm1bm"] = "ictm1bm.sitem:ictsb.sitem:blunt", ["uiR2EDequipment_ictm1bm"] = "ictm1bm.sitem:ictss.sitem:blunt", ["uiR2EDequipment_ictm1ps"] = "ictm1ps.sitem:ictsb.sitem:pierce", ["uiR2EDequipment_ictm1ps"] = "ictm1ps.sitem:ictss.sitem:pierce",  }, } r2.addR2PlayerEquipment(entries.t_melee_tank_20, entries.t_melee_tank_20_equipment)
	entries.z_melee_tank_20_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_iczalv"] = "iczalv.sitem", ["uiR2EDequipment_iczamv"] = "iczamv.sitem", }, legs = { ["uiR2EDequipment_iczalp"] = "iczalp.sitem", ["uiR2EDequipment_iczamp"] = "iczamp.sitem", }, boots = { ["uiR2EDequipment_iczamb"] = "iczamb.sitem", }, arms_guard = { ["uiR2EDequipment_iczals"] = "iczals.sitem", ["uiR2EDequipment_iczams"] = "iczams.sitem", }, gloves = { ["uiR2EDequipment_iczahg"] = "iczahg.sitem", }, hands = { ["uiR2EDequipment_iczm1ss"] = "iczm1ss.sitem:iczsb.sitem:slash", ["uiR2EDequipment_iczm1ss"] = "iczm1ss.sitem:iczss.sitem:slash", ["uiR2EDequipment_iczm1sa"] = "iczm1sa.sitem:iczsb.sitem:slash", ["uiR2EDequipment_iczm1sa"] = "iczm1sa.sitem:iczss.sitem:slash", ["uiR2EDequipment_iczm1bm"] = "iczm1bm.sitem:iczsb.sitem:blunt", ["uiR2EDequipment_iczm1bm"] = "iczm1bm.sitem:iczss.sitem:blunt", ["uiR2EDequipment_iczm1ps"] = "iczm1ps.sitem:iczsb.sitem:pierce", ["uiR2EDequipment_iczm1ps"] = "iczm1ps.sitem:iczss.sitem:pierce",  }, } r2.addR2PlayerEquipment(entries.z_melee_tank_20, entries.z_melee_tank_20_equipment)

	entries.f_melee_tank_70_equipment = { helmet = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icfahh"] = "icfahh.sitem", ["uiR2EDequipment_icfahh_2"] = "icfahh_2.sitem", }, chest_plate = { ["uiR2EDequipment_icfamv"] = "icfamv.sitem", ["uiR2EDequipment_icfamv_2"] = "icfamv_2.sitem", }, legs = { ["uiR2EDequipment_icfamp"] = "icfamp.sitem", ["uiR2EDequipment_icfamp_2"] = "icfamp_2.sitem", }, boots = { ["uiR2EDequipment_icfamb"] = "icfamb.sitem", ["uiR2EDequipment_icfamb_2"] = "icfamb_2.sitem", }, arms_guard = { ["uiR2EDequipment_icfams"] = "icfams.sitem", ["uiR2EDequipment_icfams_2"] = "icfams_2.sitem", }, gloves = { ["uiR2EDequipment_icfahg"] = "icfahg.sitem", ["uiR2EDequipment_icfahg_2"] = "icfahg_2.sitem", }, hands = { ["uiR2EDequipment_icfm1ss"] = "icfm1ss.sitem:icfsb.sitem:slash", ["uiR2EDequipment_icfm1ss"] = "icfm1ss.sitem:icfss.sitem:slash", ["uiR2EDequipment_icfm1ss_2"] = "icfm1ss_2.sitem:icfsb_2.sitem:slash", ["uiR2EDequipment_icfm1ss_2"] = "icfm1ss_2.sitem:icfss_2.sitem:slash", ["uiR2EDequipment_icfm1sa"] = "icfm1sa.sitem:icfsb.sitem:slash", ["uiR2EDequipment_icfm1sa"] = "icfm1sa.sitem:icfss.sitem:slash", ["uiR2EDequipment_icfm1sa_2"] = "icfm1sa_2.sitem:icfsb_2.sitem:slash", ["uiR2EDequipment_icfm1sa_2"] = "icfm1sa_2.sitem:icfss_2.sitem:slash", ["uiR2EDequipment_icfm1bm"] = "icfm1bm.sitem:icfsb.sitem:blunt", ["uiR2EDequipment_icfm1bm"] = "icfm1bm.sitem:icfss.sitem:blunt", ["uiR2EDequipment_icfm1bm_2"] = "icfm1bm_2.sitem:icfsb_2.sitem:blunt", ["uiR2EDequipment_icfm1bm_2"] = "icfm1bm_2.sitem:icfss_2.sitem:blunt", ["uiR2EDequipment_icfm1ps"] = "icfm1ps.sitem:icfsb.sitem:pierce", ["uiR2EDequipment_icfm1ps"] = "icfm1ps.sitem:icfss.sitem:pierce", ["uiR2EDequipment_icfm1ps_2"] = "icfm1ps_2.sitem:icfsb_2.sitem:pierce", ["uiR2EDequipment_icfm1ps_2"] = "icfm1ps_2.sitem:icfss_2.sitem:pierce", }, } r2.addR2PlayerEquipment(entries.f_melee_tank_70, entries.f_melee_tank_70_equipment)
	entries.m_melee_tank_70_equipment = { helmet = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icmahh"] = "icmahh.sitem", ["uiR2EDequipment_icmahh_2"] = "icmahh_2.sitem", }, chest_plate = { ["uiR2EDequipment_icmamv"] = "icmamv.sitem", ["uiR2EDequipment_icmamv_2"] = "icmamv_2.sitem", }, legs = { ["uiR2EDequipment_icmamp"] = "icmamp.sitem", ["uiR2EDequipment_icmamp_2"] = "icmamp_2.sitem", }, boots = { ["uiR2EDequipment_icmamb"] = "icmamb.sitem", ["uiR2EDequipment_icmamb_2"] = "icmamb_2.sitem", }, arms_guard = { ["uiR2EDequipment_icmams"] = "icmams.sitem", ["uiR2EDequipment_icmams_2"] = "icmams_2.sitem", }, gloves = { ["uiR2EDequipment_icmahg"] = "icmahg.sitem", ["uiR2EDequipment_icmahg_2"] = "icmahg_2.sitem", }, hands = { ["uiR2EDequipment_icmm1ss"] = "icmm1ss.sitem:icmsb.sitem:slash", ["uiR2EDequipment_icmm1ss"] = "icmm1ss.sitem:icmss.sitem:slash", ["uiR2EDequipment_icmm1ss_2"] = "icmm1ss_2.sitem:icmsb_2.sitem:slash", ["uiR2EDequipment_icmm1ss_2"] = "icmm1ss_2.sitem:icmss_2.sitem:slash", ["uiR2EDequipment_icmm1sa"] = "icmm1sa.sitem:icmsb.sitem:slash", ["uiR2EDequipment_icmm1sa"] = "icmm1sa.sitem:icmss.sitem:slash", ["uiR2EDequipment_icmm1sa_2"] = "icmm1sa_2.sitem:icmsb_2.sitem:slash", ["uiR2EDequipment_icmm1sa_2"] = "icmm1sa_2.sitem:icmss_2.sitem:slash", ["uiR2EDequipment_icmm1bm"] = "icmm1bm.sitem:icmsb.sitem:blunt", ["uiR2EDequipment_icmm1bm"] = "icmm1bm.sitem:icmss.sitem:blunt", ["uiR2EDequipment_icmm1bm_2"] = "icmm1bm_2.sitem:icmsb_2.sitem:blunt", ["uiR2EDequipment_icmm1bm_2"] = "icmm1bm_2.sitem:icmss_2.sitem:blunt", ["uiR2EDequipment_icmm1ps"] = "icmm1ps.sitem:icmsb.sitem:pierce", ["uiR2EDequipment_icmm1ps"] = "icmm1ps.sitem:icmss.sitem:pierce", ["uiR2EDequipment_icmm1ps_2"] = "icmm1ps_2.sitem:icmsb_2.sitem:pierce", ["uiR2EDequipment_icmm1ps_2"] = "icmm1ps_2.sitem:icmss_2.sitem:pierce", }, } r2.addR2PlayerEquipment(entries.m_melee_tank_70, entries.m_melee_tank_70_equipment)
	entries.t_melee_tank_70_equipment = { helmet = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_ictahh"] = "ictahh.sitem", ["uiR2EDequipment_ictahh_2"] = "ictahh_2.sitem", }, chest_plate = { ["uiR2EDequipment_ictamv"] = "ictamv.sitem", ["uiR2EDequipment_ictamv_2"] = "ictamv_2.sitem", }, legs = { ["uiR2EDequipment_ictamp"] = "ictamp.sitem", ["uiR2EDequipment_ictamp_2"] = "ictamp_2.sitem", }, boots = { ["uiR2EDequipment_ictamb"] = "ictamb.sitem", ["uiR2EDequipment_ictamb_2"] = "ictamb_2.sitem", }, arms_guard = { ["uiR2EDequipment_ictams"] = "ictams.sitem", ["uiR2EDequipment_ictams_2"] = "ictams_2.sitem", }, gloves = { ["uiR2EDequipment_ictahg"] = "ictahg.sitem", ["uiR2EDequipment_ictahg_2"] = "ictahg_2.sitem", }, hands = { ["uiR2EDequipment_ictm1ss"] = "ictm1ss.sitem:ictsb.sitem:slash", ["uiR2EDequipment_ictm1ss"] = "ictm1ss.sitem:ictss.sitem:slash", ["uiR2EDequipment_ictm1ss_2"] = "ictm1ss_2.sitem:ictsb_2.sitem:slash", ["uiR2EDequipment_ictm1ss_2"] = "ictm1ss_2.sitem:ictss_2.sitem:slash", ["uiR2EDequipment_ictm1sa"] = "ictm1sa.sitem:ictsb.sitem:slash", ["uiR2EDequipment_ictm1sa"] = "ictm1sa.sitem:ictss.sitem:slash", ["uiR2EDequipment_ictm1sa_2"] = "ictm1sa_2.sitem:ictsb_2.sitem:slash", ["uiR2EDequipment_ictm1sa_2"] = "ictm1sa_2.sitem:ictss_2.sitem:slash", ["uiR2EDequipment_ictm1bm"] = "ictm1bm.sitem:ictsb.sitem:blunt", ["uiR2EDequipment_ictm1bm"] = "ictm1bm.sitem:ictss.sitem:blunt", ["uiR2EDequipment_ictm1bm_2"] = "ictm1bm_2.sitem:ictsb_2.sitem:blunt", ["uiR2EDequipment_ictm1bm_2"] = "ictm1bm_2.sitem:ictss_2.sitem:blunt", ["uiR2EDequipment_ictm1ps"] = "ictm1ps.sitem:ictsb.sitem:pierce", ["uiR2EDequipment_ictm1ps"] = "ictm1ps.sitem:ictss.sitem:pierce", ["uiR2EDequipment_ictm1ps_2"] = "ictm1ps_2.sitem:ictsb_2.sitem:pierce", ["uiR2EDequipment_ictm1ps_2"] = "ictm1ps_2.sitem:ictss_2.sitem:pierce", }, } r2.addR2PlayerEquipment(entries.t_melee_tank_70, entries.t_melee_tank_70_equipment)
	entries.z_melee_tank_70_equipment = { helmet = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_iczahh"] = "iczahh.sitem", ["uiR2EDequipment_iczahh_2"] = "iczahh_2.sitem", }, chest_plate = { ["uiR2EDequipment_iczamv"] = "iczamv.sitem", ["uiR2EDequipment_iczamv_2"] = "iczamv_2.sitem", }, legs = { ["uiR2EDequipment_iczamp"] = "iczamp.sitem", ["uiR2EDequipment_iczamp_2"] = "iczamp_2.sitem", }, boots = { ["uiR2EDequipment_iczamb"] = "iczamb.sitem", ["uiR2EDequipment_iczamb_2"] = "iczamb_2.sitem", }, arms_guard = { ["uiR2EDequipment_iczams"] = "iczams.sitem", ["uiR2EDequipment_iczams_2"] = "iczams_2.sitem", }, gloves = { ["uiR2EDequipment_iczahg"] = "iczahg.sitem", ["uiR2EDequipment_iczahg_2"] = "iczahg_2.sitem", }, hands = { ["uiR2EDequipment_iczm1ss"] = "iczm1ss.sitem:iczsb.sitem:slash", ["uiR2EDequipment_iczm1ss"] = "iczm1ss.sitem:iczss.sitem:slash", ["uiR2EDequipment_iczm1ss_2"] = "iczm1ss_2.sitem:iczsb_2.sitem:slash", ["uiR2EDequipment_iczm1ss_2"] = "iczm1ss_2.sitem:iczss_2.sitem:slash", ["uiR2EDequipment_iczm1sa"] = "iczm1sa.sitem:iczsb.sitem:slash", ["uiR2EDequipment_iczm1sa"] = "iczm1sa.sitem:iczss.sitem:slash", ["uiR2EDequipment_iczm1sa_2"] = "iczm1sa_2.sitem:iczsb_2.sitem:slash", ["uiR2EDequipment_iczm1sa_2"] = "iczm1sa_2.sitem:iczss_2.sitem:slash", ["uiR2EDequipment_iczm1bm"] = "iczm1bm.sitem:iczsb.sitem:blunt", ["uiR2EDequipment_iczm1bm"] = "iczm1bm.sitem:iczss.sitem:blunt", ["uiR2EDequipment_iczm1bm_2"] = "iczm1bm_2.sitem:iczsb_2.sitem:blunt", ["uiR2EDequipment_iczm1bm_2"] = "iczm1bm_2.sitem:iczss_2.sitem:blunt", ["uiR2EDequipment_iczm1ps"] = "iczm1ps.sitem:iczsb.sitem:pierce", ["uiR2EDequipment_iczm1ps"] = "iczm1ps.sitem:iczss.sitem:pierce", ["uiR2EDequipment_iczm1ps_2"] = "iczm1ps_2.sitem:iczsb_2.sitem:pierce", ["uiR2EDequipment_iczm1ps_2"] = "iczm1ps_2.sitem:iczss_2.sitem:pierce", }, } r2.addR2PlayerEquipment(entries.z_melee_tank_70, entries.z_melee_tank_70_equipment)

	entries.f_melee_tank_120_equipment = { helmet = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icfahh"] = "icfahh.sitem", ["uiR2EDequipment_icfahh_2"] = "icfahh_2.sitem", }, chest_plate = { ["uiR2EDequipment_icfamv"] = "icfamv.sitem", ["uiR2EDequipment_icfahv"] = "icfahv.sitem", ["uiR2EDequipment_icfamv_2"] = "icfamv_2.sitem", ["uiR2EDequipment_icfahv_2"] = "icfahv_2.sitem", }, legs = { ["uiR2EDequipment_icfamp"] = "icfamp.sitem", ["uiR2EDequipment_icfahp"] = "icfahp.sitem", ["uiR2EDequipment_icfamp_2"] = "icfamp_2.sitem", ["uiR2EDequipment_icfahp_2"] = "icfahp_2.sitem", }, boots = { ["uiR2EDequipment_icfamb"] = "icfamb.sitem", ["uiR2EDequipment_icfahb"] = "icfahb.sitem", ["uiR2EDequipment_icfamb_2"] = "icfamb_2.sitem", ["uiR2EDequipment_icfahb_2"] = "icfahb_2.sitem", }, arms_guard = { ["uiR2EDequipment_icfams"] = "icfams.sitem", ["uiR2EDequipment_icfahs"] = "icfahs.sitem", ["uiR2EDequipment_icfams_2"] = "icfams_2.sitem", ["uiR2EDequipment_icfahs_2"] = "icfahs_2.sitem", }, gloves = { ["uiR2EDequipment_icfahg"] = "icfahg.sitem", ["uiR2EDequipment_icfahg_2"] = "icfahg_2.sitem", }, hands = { ["uiR2EDequipment_icfm1ss"] = "icfm1ss.sitem:icfsb.sitem:slash", ["uiR2EDequipment_icfm1ss"] = "icfm1ss.sitem:icfss.sitem:slash", ["uiR2EDequipment_icfm1ss_2"] = "icfm1ss_2.sitem:icfsb_2.sitem:slash", ["uiR2EDequipment_icfm1ss_2"] = "icfm1ss_2.sitem:icfss_2.sitem:slash", ["uiR2EDequipment_icfm1sa"] = "icfm1sa.sitem:icfsb.sitem:slash", ["uiR2EDequipment_icfm1sa"] = "icfm1sa.sitem:icfss.sitem:slash", ["uiR2EDequipment_icfm1sa_2"] = "icfm1sa_2.sitem:icfsb_2.sitem:slash", ["uiR2EDequipment_icfm1sa_2"] = "icfm1sa_2.sitem:icfss_2.sitem:slash", ["uiR2EDequipment_icfm1bm"] = "icfm1bm.sitem:icfsb.sitem:blunt", ["uiR2EDequipment_icfm1bm"] = "icfm1bm.sitem:icfss.sitem:blunt", ["uiR2EDequipment_icfm1bm_2"] = "icfm1bm_2.sitem:icfsb_2.sitem:blunt", ["uiR2EDequipment_icfm1bm_2"] = "icfm1bm_2.sitem:icfss_2.sitem:blunt", ["uiR2EDequipment_icfm1ps"] = "icfm1ps.sitem:icfsb.sitem:pierce", ["uiR2EDequipment_icfm1ps"] = 
	"icfm1ps.sitem:icfss.sitem:pierce", ["uiR2EDequipment_icfm1ps_2"] = "icfm1ps_2.sitem:icfsb_2.sitem:pierce", ["uiR2EDequipment_icfm1ps_2"] = "icfm1ps_2.sitem:icfss_2.sitem:pierce", }, } r2.addR2PlayerEquipment(entries.f_melee_tank_120, entries.f_melee_tank_120_equipment)
	entries.m_melee_tank_120_equipment = { helmet = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icmahh"] = "icmahh.sitem", ["uiR2EDequipment_icmahh_2"] = "icmahh_2.sitem", }, chest_plate = { ["uiR2EDequipment_icmamv"] = "icmamv.sitem", ["uiR2EDequipment_icmahv"] = "icmahv.sitem", ["uiR2EDequipment_icmamv_2"] = "icmamv_2.sitem", ["uiR2EDequipment_icmahv_2"] = "icmahv_2.sitem", }, legs = { ["uiR2EDequipment_icmamp"] = "icmamp.sitem", ["uiR2EDequipment_icmahp"] = "icmahp.sitem", ["uiR2EDequipment_icmamp_2"] = "icmamp_2.sitem", ["uiR2EDequipment_icmahp_2"] = "icmahp_2.sitem", }, boots = { ["uiR2EDequipment_icmamb"] = "icmamb.sitem", ["uiR2EDequipment_icmahb"] = "icmahb.sitem", ["uiR2EDequipment_icmamb_2"] = "icmamb_2.sitem", ["uiR2EDequipment_icmahb_2"] = "icmahb_2.sitem", }, arms_guard = { ["uiR2EDequipment_icmams"] = "icmams.sitem", ["uiR2EDequipment_icmahs"] = "icmahs.sitem", ["uiR2EDequipment_icmams_2"] = "icmams_2.sitem", ["uiR2EDequipment_icmahs_2"] = "icmahs_2.sitem", }, gloves = { ["uiR2EDequipment_icmahg"] = "icmahg.sitem", ["uiR2EDequipment_icmahg_2"] = "icmahg_2.sitem", }, hands = { ["uiR2EDequipment_icmm1ss"] = "icmm1ss.sitem:icmsb.sitem:slash", ["uiR2EDequipment_icmm1ss"] = "icmm1ss.sitem:icmss.sitem:slash", ["uiR2EDequipment_icmm1ss_2"] = "icmm1ss_2.sitem:icmsb_2.sitem:slash", ["uiR2EDequipment_icmm1ss_2"] = "icmm1ss_2.sitem:icmss_2.sitem:slash", ["uiR2EDequipment_icmm1sa"] = "icmm1sa.sitem:icmsb.sitem:slash", ["uiR2EDequipment_icmm1sa"] = "icmm1sa.sitem:icmss.sitem:slash", ["uiR2EDequipment_icmm1sa_2"] = "icmm1sa_2.sitem:icmsb_2.sitem:slash", ["uiR2EDequipment_icmm1sa_2"] = "icmm1sa_2.sitem:icmss_2.sitem:slash", ["uiR2EDequipment_icmm1bm"] = "icmm1bm.sitem:icmsb.sitem:blunt", ["uiR2EDequipment_icmm1bm"] = "icmm1bm.sitem:icmss.sitem:blunt", ["uiR2EDequipment_icmm1bm_2"] = "icmm1bm_2.sitem:icmsb_2.sitem:blunt", ["uiR2EDequipment_icmm1bm_2"] = "icmm1bm_2.sitem:icmss_2.sitem:blunt", ["uiR2EDequipment_icmm1ps"] = "icmm1ps.sitem:icmsb.sitem:pierce", ["uiR2EDequipment_icmm1ps"] = 
	"icmm1ps.sitem:icmss.sitem:pierce", ["uiR2EDequipment_icmm1ps_2"] = "icmm1ps_2.sitem:icmsb_2.sitem:pierce", ["uiR2EDequipment_icmm1ps_2"] = "icmm1ps_2.sitem:icmss_2.sitem:pierce", }, } r2.addR2PlayerEquipment(entries.m_melee_tank_120, entries.m_melee_tank_120_equipment)
	entries.t_melee_tank_120_equipment = { helmet = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_ictahh"] = "ictahh.sitem", ["uiR2EDequipment_ictahh_2"] = "ictahh_2.sitem", }, chest_plate = { ["uiR2EDequipment_ictamv"] = "ictamv.sitem", ["uiR2EDequipment_ictahv"] = "ictahv.sitem", ["uiR2EDequipment_ictamv_2"] = "ictamv_2.sitem", ["uiR2EDequipment_ictahv_2"] = "ictahv_2.sitem", }, legs = { ["uiR2EDequipment_ictamp"] = "ictamp.sitem", ["uiR2EDequipment_ictahp"] = "ictahp.sitem", ["uiR2EDequipment_ictamp_2"] = "ictamp_2.sitem", ["uiR2EDequipment_ictahp_2"] = "ictahp_2.sitem", }, boots = { ["uiR2EDequipment_ictamb"] = "ictamb.sitem", ["uiR2EDequipment_ictahb"] = "ictahb.sitem", ["uiR2EDequipment_ictamb_2"] = "ictamb_2.sitem", ["uiR2EDequipment_ictahb_2"] = "ictahb_2.sitem", }, arms_guard = { ["uiR2EDequipment_ictams"] = "ictams.sitem", ["uiR2EDequipment_ictahs"] = "ictahs.sitem", ["uiR2EDequipment_ictams_2"] = "ictams_2.sitem", ["uiR2EDequipment_ictahs_2"] = "ictahs_2.sitem", }, gloves = { ["uiR2EDequipment_ictahg"] = "ictahg.sitem", ["uiR2EDequipment_ictahg_2"] = "ictahg_2.sitem", }, hands = { ["uiR2EDequipment_ictm1ss"] = "ictm1ss.sitem:ictsb.sitem:slash", ["uiR2EDequipment_ictm1ss"] = "ictm1ss.sitem:ictss.sitem:slash", ["uiR2EDequipment_ictm1ss_2"] = "ictm1ss_2.sitem:ictsb_2.sitem:slash", ["uiR2EDequipment_ictm1ss_2"] = "ictm1ss_2.sitem:ictss_2.sitem:slash", ["uiR2EDequipment_ictm1sa"] = "ictm1sa.sitem:ictsb.sitem:slash", ["uiR2EDequipment_ictm1sa"] = "ictm1sa.sitem:ictss.sitem:slash", ["uiR2EDequipment_ictm1sa_2"] = "ictm1sa_2.sitem:ictsb_2.sitem:slash", ["uiR2EDequipment_ictm1sa_2"] = "ictm1sa_2.sitem:ictss_2.sitem:slash", ["uiR2EDequipment_ictm1bm"] = "ictm1bm.sitem:ictsb.sitem:blunt", ["uiR2EDequipment_ictm1bm"] = "ictm1bm.sitem:ictss.sitem:blunt", ["uiR2EDequipment_ictm1bm_2"] = "ictm1bm_2.sitem:ictsb_2.sitem:blunt", ["uiR2EDequipment_ictm1bm_2"] = "ictm1bm_2.sitem:ictss_2.sitem:blunt", ["uiR2EDequipment_ictm1ps"] = "ictm1ps.sitem:ictsb.sitem:pierce", ["uiR2EDequipment_ictm1ps"] = 
	"ictm1ps.sitem:ictss.sitem:pierce", ["uiR2EDequipment_ictm1ps_2"] = "ictm1ps_2.sitem:ictsb_2.sitem:pierce", ["uiR2EDequipment_ictm1ps_2"] = "ictm1ps_2.sitem:ictss_2.sitem:pierce", }, } r2.addR2PlayerEquipment(entries.t_melee_tank_120, entries.t_melee_tank_120_equipment)
	entries.z_melee_tank_120_equipment = { helmet = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_iczahh"] = "iczahh.sitem", ["uiR2EDequipment_iczahh_2"] = "iczahh_2.sitem", }, chest_plate = { ["uiR2EDequipment_iczamv"] = "iczamv.sitem", ["uiR2EDequipment_iczahv"] = "iczahv.sitem", ["uiR2EDequipment_iczamv_2"] = "iczamv_2.sitem", ["uiR2EDequipment_iczahv_2"] = "iczahv_2.sitem", }, legs = { ["uiR2EDequipment_iczamp"] = "iczamp.sitem", ["uiR2EDequipment_iczahp"] = "iczahp.sitem", ["uiR2EDequipment_iczamp_2"] = "iczamp_2.sitem", ["uiR2EDequipment_iczahp_2"] = "iczahp_2.sitem", }, boots = { ["uiR2EDequipment_iczamb"] = "iczamb.sitem", ["uiR2EDequipment_iczahb"] = "iczahb.sitem", ["uiR2EDequipment_iczamb_2"] = "iczamb_2.sitem", ["uiR2EDequipment_iczahb_2"] = "iczahb_2.sitem", }, arms_guard = { ["uiR2EDequipment_iczams"] = "iczams.sitem", ["uiR2EDequipment_iczahs"] = "iczahs.sitem", ["uiR2EDequipment_iczams_2"] = "iczams_2.sitem", ["uiR2EDequipment_iczahs_2"] = "iczahs_2.sitem", }, gloves = { ["uiR2EDequipment_iczahg"] = "iczahg.sitem", ["uiR2EDequipment_iczahg_2"] = "iczahg_2.sitem", }, hands = { ["uiR2EDequipment_iczm1ss"] = "iczm1ss.sitem:iczsb.sitem:slash", ["uiR2EDequipment_iczm1ss"] = "iczm1ss.sitem:iczss.sitem:slash", ["uiR2EDequipment_iczm1ss_2"] = "iczm1ss_2.sitem:iczsb_2.sitem:slash", ["uiR2EDequipment_iczm1ss_2"] = "iczm1ss_2.sitem:iczss_2.sitem:slash", ["uiR2EDequipment_iczm1sa"] = "iczm1sa.sitem:iczsb.sitem:slash", ["uiR2EDequipment_iczm1sa"] = "iczm1sa.sitem:iczss.sitem:slash", ["uiR2EDequipment_iczm1sa_2"] = "iczm1sa_2.sitem:iczsb_2.sitem:slash", ["uiR2EDequipment_iczm1sa_2"] = "iczm1sa_2.sitem:iczss_2.sitem:slash", ["uiR2EDequipment_iczm1bm"] = "iczm1bm.sitem:iczsb.sitem:blunt", ["uiR2EDequipment_iczm1bm"] = "iczm1bm.sitem:iczss.sitem:blunt", ["uiR2EDequipment_iczm1bm_2"] = "iczm1bm_2.sitem:iczsb_2.sitem:blunt", ["uiR2EDequipment_iczm1bm_2"] = "iczm1bm_2.sitem:iczss_2.sitem:blunt", ["uiR2EDequipment_iczm1ps"] = "iczm1ps.sitem:iczsb.sitem:pierce", ["uiR2EDequipment_iczm1ps"] = 
	"iczm1ps.sitem:iczss.sitem:pierce", ["uiR2EDequipment_iczm1ps_2"] = "iczm1ps_2.sitem:iczsb_2.sitem:pierce", ["uiR2EDequipment_iczm1ps_2"] = "iczm1ps_2.sitem:iczss_2.sitem:pierce", }, } r2.addR2PlayerEquipment(entries.z_melee_tank_120, entries.z_melee_tank_120_equipment)

	entries.f_melee_tank_170_equipment = { helmet = { ["uiR2EDequipment_icfahh_2"] = "icfahh_2.sitem", ["uiR2EDequipment_icfahh_3"] = "icfahh_3.sitem", }, chest_plate = { ["uiR2EDequipment_icfahv_2"] = "icfahv_2.sitem", ["uiR2EDequipment_icfahv_3"] = "icfahv_3.sitem", }, legs = { ["uiR2EDequipment_icfahp_2"] = "icfahp_2.sitem", ["uiR2EDequipment_icfahp_3"] = "icfahp_3.sitem", }, boots = { ["uiR2EDequipment_icfahb_2"] = "icfahb_2.sitem", ["uiR2EDequipment_icfahb_3"] = "icfahb_3.sitem", }, arms_guard = { ["uiR2EDequipment_icfahs_2"] = "icfahs_2.sitem", ["uiR2EDequipment_icfahs_3"] = "icfahs_3.sitem", }, gloves = { ["uiR2EDequipment_icfahg_2"] = "icfahg_2.sitem", ["uiR2EDequipment_icfahg_3"] = "icfahg_3.sitem", }, hands = { ["uiR2EDequipment_icfm1ss_2"] = "icfm1ss_2.sitem:icfsb_2.sitem:slash", ["uiR2EDequipment_icfm1ss_2"] = "icfm1ss_2.sitem:icfss_2.sitem:slash", ["uiR2EDequipment_icfm1ss_3"] = "icfm1ss_3.sitem:icfsb_3.sitem:slash", ["uiR2EDequipment_icfm1ss_3"] = "icfm1ss_3.sitem:icfss_3.sitem:slash", ["uiR2EDequipment_icfm1sa_2"] = "icfm1sa_2.sitem:icfsb_2.sitem:slash", ["uiR2EDequipment_icfm1sa_2"] = "icfm1sa_2.sitem:icfss_2.sitem:slash", ["uiR2EDequipment_icfm1sa_3"] = "icfm1sa_3.sitem:icfsb_3.sitem:slash", ["uiR2EDequipment_icfm1sa_3"] = "icfm1sa_3.sitem:icfss_3.sitem:slash", ["uiR2EDequipment_icfm1bm_2"] = "icfm1bm_2.sitem:icfsb_2.sitem:blunt", ["uiR2EDequipment_icfm1bm_2"] = "icfm1bm_2.sitem:icfss_2.sitem:blunt", ["uiR2EDequipment_icfm1bm_3"] = "icfm1bm_3.sitem:icfsb_3.sitem:blunt", ["uiR2EDequipment_icfm1bm_3"] = "icfm1bm_3.sitem:icfss_3.sitem:blunt", ["uiR2EDequipment_icfm1ps_2"] = "icfm1ps_2.sitem:icfsb_2.sitem:pierce", ["uiR2EDequipment_icfm1ps_2"] = "icfm1ps_2.sitem:icfss_2.sitem:pierce", ["uiR2EDequipment_icfm1ps_3"] = "icfm1ps_3.sitem:icfsb_3.sitem:pierce", ["uiR2EDequipment_icfm1ps_3"] = "icfm1ps_3.sitem:icfss_3.sitem:pierce", }, } r2.addR2PlayerEquipment(entries.f_melee_tank_170, entries.f_melee_tank_170_equipment)
	entries.m_melee_tank_170_equipment = { helmet = { ["uiR2EDequipment_icmahh_2"] = "icmahh_2.sitem", ["uiR2EDequipment_icmahh_3"] = "icmahh_3.sitem", }, chest_plate = { ["uiR2EDequipment_icmahv_2"] = "icmahv_2.sitem", ["uiR2EDequipment_icmahv_3"] = "icmahv_3.sitem", }, legs = { ["uiR2EDequipment_icmahp_2"] = "icmahp_2.sitem", ["uiR2EDequipment_icmahp_3"] = "icmahp_3.sitem", }, boots = { ["uiR2EDequipment_icmahb_2"] = "icmahb_2.sitem", ["uiR2EDequipment_icmahb_3"] = "icmahb_3.sitem", }, arms_guard = { ["uiR2EDequipment_icmahs_2"] = "icmahs_2.sitem", ["uiR2EDequipment_icmahs_3"] = "icmahs_3.sitem", }, gloves = { ["uiR2EDequipment_icmahg_2"] = "icmahg_2.sitem", ["uiR2EDequipment_icmahg_3"] = "icmahg_3.sitem", }, hands = { ["uiR2EDequipment_icmm1ss_2"] = "icmm1ss_2.sitem:icmsb_2.sitem:slash", ["uiR2EDequipment_icmm1ss_2"] = "icmm1ss_2.sitem:icmss_2.sitem:slash", ["uiR2EDequipment_icmm1ss_3"] = "icmm1ss_3.sitem:icmsb_3.sitem:slash", ["uiR2EDequipment_icmm1ss_3"] = "icmm1ss_3.sitem:icmss_3.sitem:slash", ["uiR2EDequipment_icmm1sa_2"] = "icmm1sa_2.sitem:icmsb_2.sitem:slash", ["uiR2EDequipment_icmm1sa_2"] = "icmm1sa_2.sitem:icmss_2.sitem:slash", ["uiR2EDequipment_icmm1sa_3"] = "icmm1sa_3.sitem:icmsb_3.sitem:slash", ["uiR2EDequipment_icmm1sa_3"] = "icmm1sa_3.sitem:icmss_3.sitem:slash", ["uiR2EDequipment_icmm1bm_2"] = "icmm1bm_2.sitem:icmsb_2.sitem:blunt", ["uiR2EDequipment_icmm1bm_2"] = "icmm1bm_2.sitem:icmss_2.sitem:blunt", ["uiR2EDequipment_icmm1bm_3"] = "icmm1bm_3.sitem:icmsb_3.sitem:blunt", ["uiR2EDequipment_icmm1bm_3"] = "icmm1bm_3.sitem:icmss_3.sitem:blunt", ["uiR2EDequipment_icmm1ps_2"] = "icmm1ps_2.sitem:icmsb_2.sitem:pierce", ["uiR2EDequipment_icmm1ps_2"] = "icmm1ps_2.sitem:icmss_2.sitem:pierce", ["uiR2EDequipment_icmm1ps_3"] = "icmm1ps_3.sitem:icmsb_3.sitem:pierce", ["uiR2EDequipment_icmm1ps_3"] = "icmm1ps_3.sitem:icmss_3.sitem:pierce", }, } r2.addR2PlayerEquipment(entries.m_melee_tank_170, entries.m_melee_tank_170_equipment)
	entries.t_melee_tank_170_equipment = { helmet = { ["uiR2EDequipment_ictahh_2"] = "ictahh_2.sitem", ["uiR2EDequipment_ictahh_3"] = "ictahh_3.sitem", }, chest_plate = { ["uiR2EDequipment_ictahv_2"] = "ictahv_2.sitem", ["uiR2EDequipment_ictahv_3"] = "ictahv_3.sitem", }, legs = { ["uiR2EDequipment_ictahp_2"] = "ictahp_2.sitem", ["uiR2EDequipment_ictahp_3"] = "ictahp_3.sitem", }, boots = { ["uiR2EDequipment_ictahb_2"] = "ictahb_2.sitem", ["uiR2EDequipment_ictahb_3"] = "ictahb_3.sitem", }, arms_guard = { ["uiR2EDequipment_ictahs_2"] = "ictahs_2.sitem", ["uiR2EDequipment_ictahs_3"] = "ictahs_3.sitem", }, gloves = { ["uiR2EDequipment_ictahg_2"] = "ictahg_2.sitem", ["uiR2EDequipment_ictahg_3"] = "ictahg_3.sitem", }, hands = { ["uiR2EDequipment_ictm1ss_2"] = "ictm1ss_2.sitem:ictsb_2.sitem:slash", ["uiR2EDequipment_ictm1ss_2"] = "ictm1ss_2.sitem:ictss_2.sitem:slash", ["uiR2EDequipment_ictm1ss_3"] = "ictm1ss_3.sitem:ictsb_3.sitem:slash", ["uiR2EDequipment_ictm1ss_3"] = "ictm1ss_3.sitem:ictss_3.sitem:slash", ["uiR2EDequipment_ictm1sa_2"] = "ictm1sa_2.sitem:ictsb_2.sitem:slash", ["uiR2EDequipment_ictm1sa_2"] = "ictm1sa_2.sitem:ictss_2.sitem:slash", ["uiR2EDequipment_ictm1sa_3"] = "ictm1sa_3.sitem:ictsb_3.sitem:slash", ["uiR2EDequipment_ictm1sa_3"] = "ictm1sa_3.sitem:ictss_3.sitem:slash", ["uiR2EDequipment_ictm1bm_2"] = "ictm1bm_2.sitem:ictsb_2.sitem:blunt", ["uiR2EDequipment_ictm1bm_2"] = "ictm1bm_2.sitem:ictss_2.sitem:blunt", ["uiR2EDequipment_ictm1bm_3"] = "ictm1bm_3.sitem:ictsb_3.sitem:blunt", ["uiR2EDequipment_ictm1bm_3"] = "ictm1bm_3.sitem:ictss_3.sitem:blunt", ["uiR2EDequipment_ictm1ps_2"] = "ictm1ps_2.sitem:ictsb_2.sitem:pierce", ["uiR2EDequipment_ictm1ps_2"] = "ictm1ps_2.sitem:ictss_2.sitem:pierce", ["uiR2EDequipment_ictm1ps_3"] = "ictm1ps_3.sitem:ictsb_3.sitem:pierce", ["uiR2EDequipment_ictm1ps_3"] = "ictm1ps_3.sitem:ictss_3.sitem:pierce", }, } r2.addR2PlayerEquipment(entries.t_melee_tank_170, entries.t_melee_tank_170_equipment)
	entries.z_melee_tank_170_equipment = { helmet = { ["uiR2EDequipment_iczahh_2"] = "iczahh_2.sitem", ["uiR2EDequipment_iczahh_3"] = "iczahh_3.sitem", }, chest_plate = { ["uiR2EDequipment_iczahv_2"] = "iczahv_2.sitem", ["uiR2EDequipment_iczahv_3"] = "iczahv_3.sitem", }, legs = { ["uiR2EDequipment_iczahp_2"] = "iczahp_2.sitem", ["uiR2EDequipment_iczahp_3"] = "iczahp_3.sitem", }, boots = { ["uiR2EDequipment_iczahb_2"] = "iczahb_2.sitem", ["uiR2EDequipment_iczahb_3"] = "iczahb_3.sitem", }, arms_guard = { ["uiR2EDequipment_iczahs_2"] = "iczahs_2.sitem", ["uiR2EDequipment_iczahs_3"] = "iczahs_3.sitem", }, gloves = { ["uiR2EDequipment_iczahg_2"] = "iczahg_2.sitem", ["uiR2EDequipment_iczahg_3"] = "iczahg_3.sitem", }, hands = { ["uiR2EDequipment_iczm1ss_2"] = "iczm1ss_2.sitem:iczsb_2.sitem:slash", ["uiR2EDequipment_iczm1ss_2"] = "iczm1ss_2.sitem:iczss_2.sitem:slash", ["uiR2EDequipment_iczm1ss_3"] = "iczm1ss_3.sitem:iczsb_3.sitem:slash", ["uiR2EDequipment_iczm1ss_3"] = "iczm1ss_3.sitem:iczss_3.sitem:slash", ["uiR2EDequipment_iczm1sa_2"] = "iczm1sa_2.sitem:iczsb_2.sitem:slash", ["uiR2EDequipment_iczm1sa_2"] = "iczm1sa_2.sitem:iczss_2.sitem:slash", ["uiR2EDequipment_iczm1sa_3"] = "iczm1sa_3.sitem:iczsb_3.sitem:slash", ["uiR2EDequipment_iczm1sa_3"] = "iczm1sa_3.sitem:iczss_3.sitem:slash", ["uiR2EDequipment_iczm1bm_2"] = "iczm1bm_2.sitem:iczsb_2.sitem:blunt", ["uiR2EDequipment_iczm1bm_2"] = "iczm1bm_2.sitem:iczss_2.sitem:blunt", ["uiR2EDequipment_iczm1bm_3"] = "iczm1bm_3.sitem:iczsb_3.sitem:blunt", ["uiR2EDequipment_iczm1bm_3"] = "iczm1bm_3.sitem:iczss_3.sitem:blunt", ["uiR2EDequipment_iczm1ps_2"] = "iczm1ps_2.sitem:iczsb_2.sitem:pierce", ["uiR2EDequipment_iczm1ps_2"] = "iczm1ps_2.sitem:iczss_2.sitem:pierce", ["uiR2EDequipment_iczm1ps_3"] = "iczm1ps_3.sitem:iczsb_3.sitem:pierce", ["uiR2EDequipment_iczm1ps_3"] = "iczm1ps_3.sitem:iczss_3.sitem:pierce", }, } r2.addR2PlayerEquipment(entries.z_melee_tank_170, entries.z_melee_tank_170_equipment)

	entries.f_melee_tank_220_equipment = { helmet = { ["uiR2EDequipment_icfahh_2"] = "icfahh_2.sitem", ["uiR2EDequipment_icfahh_3"] = "icfahh_3.sitem", }, chest_plate = { ["uiR2EDequipment_icfahv_2"] = "icfahv_2.sitem", ["uiR2EDequipment_icfahv_3"] = "icfahv_3.sitem", }, legs = { ["uiR2EDequipment_icfahp_2"] = "icfahp_2.sitem", ["uiR2EDequipment_icfahp_3"] = "icfahp_3.sitem", }, boots = { ["uiR2EDequipment_icfahb_2"] = "icfahb_2.sitem", ["uiR2EDequipment_icfahb_3"] = "icfahb_3.sitem", }, arms_guard = { ["uiR2EDequipment_icfahs_2"] = "icfahs_2.sitem", ["uiR2EDequipment_icfahs_3"] = "icfahs_3.sitem", }, gloves = { ["uiR2EDequipment_icfahg_2"] = "icfahg_2.sitem", ["uiR2EDequipment_icfahg_3"] = "icfahg_3.sitem", }, hands = { ["uiR2EDequipment_icfm1ss_2"] = "icfm1ss_2.sitem:icfsb_2.sitem:slash", ["uiR2EDequipment_icfm1ss_2"] = "icfm1ss_2.sitem:icfss_2.sitem:slash", ["uiR2EDequipment_icfm1ss_3"] = "icfm1ss_3.sitem:icfsb_3.sitem:slash", ["uiR2EDequipment_icfm1ss_3"] = "icfm1ss_3.sitem:icfss_3.sitem:slash", ["uiR2EDequipment_icfm1sa_2"] = "icfm1sa_2.sitem:icfsb_2.sitem:slash", ["uiR2EDequipment_icfm1sa_2"] = "icfm1sa_2.sitem:icfss_2.sitem:slash", ["uiR2EDequipment_icfm1sa_3"] = "icfm1sa_3.sitem:icfsb_3.sitem:slash", ["uiR2EDequipment_icfm1sa_3"] = "icfm1sa_3.sitem:icfss_3.sitem:slash", ["uiR2EDequipment_icfm1bm_2"] = "icfm1bm_2.sitem:icfsb_2.sitem:blunt", ["uiR2EDequipment_icfm1bm_2"] = "icfm1bm_2.sitem:icfss_2.sitem:blunt", ["uiR2EDequipment_icfm1bm_3"] = "icfm1bm_3.sitem:icfsb_3.sitem:blunt", ["uiR2EDequipment_icfm1bm_3"] = "icfm1bm_3.sitem:icfss_3.sitem:blunt", ["uiR2EDequipment_icfm1ps_2"] = "icfm1ps_2.sitem:icfsb_2.sitem:pierce", ["uiR2EDequipment_icfm1ps_2"] = "icfm1ps_2.sitem:icfss_2.sitem:pierce", ["uiR2EDequipment_icfm1ps_3"] = "icfm1ps_3.sitem:icfsb_3.sitem:pierce", ["uiR2EDequipment_icfm1ps_3"] = "icfm1ps_3.sitem:icfss_3.sitem:pierce", }, } r2.addR2PlayerEquipment(entries.f_melee_tank_220, entries.f_melee_tank_220_equipment)
	entries.m_melee_tank_220_equipment = { helmet = { ["uiR2EDequipment_icmahh_2"] = "icmahh_2.sitem", ["uiR2EDequipment_icmahh_3"] = "icmahh_3.sitem", }, chest_plate = { ["uiR2EDequipment_icmahv_2"] = "icmahv_2.sitem", ["uiR2EDequipment_icmahv_3"] = "icmahv_3.sitem", }, legs = { ["uiR2EDequipment_icmahp_2"] = "icmahp_2.sitem", ["uiR2EDequipment_icmahp_3"] = "icmahp_3.sitem", }, boots = { ["uiR2EDequipment_icmahb_2"] = "icmahb_2.sitem", ["uiR2EDequipment_icmahb_3"] = "icmahb_3.sitem", }, arms_guard = { ["uiR2EDequipment_icmahs_2"] = "icmahs_2.sitem", ["uiR2EDequipment_icmahs_3"] = "icmahs_3.sitem", }, gloves = { ["uiR2EDequipment_icmahg_2"] = "icmahg_2.sitem", ["uiR2EDequipment_icmahg_3"] = "icmahg_3.sitem", }, hands = { ["uiR2EDequipment_icmm1ss_2"] = "icmm1ss_2.sitem:icmsb_2.sitem:slash", ["uiR2EDequipment_icmm1ss_2"] = "icmm1ss_2.sitem:icmss_2.sitem:slash", ["uiR2EDequipment_icmm1ss_3"] = "icmm1ss_3.sitem:icmsb_3.sitem:slash", ["uiR2EDequipment_icmm1ss_3"] = "icmm1ss_3.sitem:icmss_3.sitem:slash", ["uiR2EDequipment_icmm1sa_2"] = "icmm1sa_2.sitem:icmsb_2.sitem:slash", ["uiR2EDequipment_icmm1sa_2"] = "icmm1sa_2.sitem:icmss_2.sitem:slash", ["uiR2EDequipment_icmm1sa_3"] = "icmm1sa_3.sitem:icmsb_3.sitem:slash", ["uiR2EDequipment_icmm1sa_3"] = "icmm1sa_3.sitem:icmss_3.sitem:slash", ["uiR2EDequipment_icmm1bm_2"] = "icmm1bm_2.sitem:icmsb_2.sitem:blunt", ["uiR2EDequipment_icmm1bm_2"] = "icmm1bm_2.sitem:icmss_2.sitem:blunt", ["uiR2EDequipment_icmm1bm_3"] = "icmm1bm_3.sitem:icmsb_3.sitem:blunt", ["uiR2EDequipment_icmm1bm_3"] = "icmm1bm_3.sitem:icmss_3.sitem:blunt", ["uiR2EDequipment_icmm1ps_2"] = "icmm1ps_2.sitem:icmsb_2.sitem:pierce", ["uiR2EDequipment_icmm1ps_2"] = "icmm1ps_2.sitem:icmss_2.sitem:pierce", ["uiR2EDequipment_icmm1ps_3"] = "icmm1ps_3.sitem:icmsb_3.sitem:pierce", ["uiR2EDequipment_icmm1ps_3"] = "icmm1ps_3.sitem:icmss_3.sitem:pierce", }, } r2.addR2PlayerEquipment(entries.m_melee_tank_220, entries.m_melee_tank_220_equipment)
	entries.t_melee_tank_220_equipment = { helmet = { ["uiR2EDequipment_ictahh_2"] = "ictahh_2.sitem", ["uiR2EDequipment_ictahh_3"] = "ictahh_3.sitem", }, chest_plate = { ["uiR2EDequipment_ictahv_2"] = "ictahv_2.sitem", ["uiR2EDequipment_ictahv_3"] = "ictahv_3.sitem", }, legs = { ["uiR2EDequipment_ictahp_2"] = "ictahp_2.sitem", ["uiR2EDequipment_ictahp_3"] = "ictahp_3.sitem", }, boots = { ["uiR2EDequipment_ictahb_2"] = "ictahb_2.sitem", ["uiR2EDequipment_ictahb_3"] = "ictahb_3.sitem", }, arms_guard = { ["uiR2EDequipment_ictahs_2"] = "ictahs_2.sitem", ["uiR2EDequipment_ictahs_3"] = "ictahs_3.sitem", }, gloves = { ["uiR2EDequipment_ictahg_2"] = "ictahg_2.sitem", ["uiR2EDequipment_ictahg_3"] = "ictahg_3.sitem", }, hands = { ["uiR2EDequipment_ictm1ss_2"] = "ictm1ss_2.sitem:ictsb_2.sitem:slash", ["uiR2EDequipment_ictm1ss_2"] = "ictm1ss_2.sitem:ictss_2.sitem:slash", ["uiR2EDequipment_ictm1ss_3"] = "ictm1ss_3.sitem:ictsb_3.sitem:slash", ["uiR2EDequipment_ictm1ss_3"] = "ictm1ss_3.sitem:ictss_3.sitem:slash", ["uiR2EDequipment_ictm1sa_2"] = "ictm1sa_2.sitem:ictsb_2.sitem:slash", ["uiR2EDequipment_ictm1sa_2"] = "ictm1sa_2.sitem:ictss_2.sitem:slash", ["uiR2EDequipment_ictm1sa_3"] = "ictm1sa_3.sitem:ictsb_3.sitem:slash", ["uiR2EDequipment_ictm1sa_3"] = "ictm1sa_3.sitem:ictss_3.sitem:slash", ["uiR2EDequipment_ictm1bm_2"] = "ictm1bm_2.sitem:ictsb_2.sitem:blunt", ["uiR2EDequipment_ictm1bm_2"] = "ictm1bm_2.sitem:ictss_2.sitem:blunt", ["uiR2EDequipment_ictm1bm_3"] = "ictm1bm_3.sitem:ictsb_3.sitem:blunt", ["uiR2EDequipment_ictm1bm_3"] = "ictm1bm_3.sitem:ictss_3.sitem:blunt", ["uiR2EDequipment_ictm1ps_2"] = "ictm1ps_2.sitem:ictsb_2.sitem:pierce", ["uiR2EDequipment_ictm1ps_2"] = "ictm1ps_2.sitem:ictss_2.sitem:pierce", ["uiR2EDequipment_ictm1ps_3"] = "ictm1ps_3.sitem:ictsb_3.sitem:pierce", ["uiR2EDequipment_ictm1ps_3"] = "ictm1ps_3.sitem:ictss_3.sitem:pierce", }, } r2.addR2PlayerEquipment(entries.t_melee_tank_220, entries.t_melee_tank_220_equipment)
	entries.z_melee_tank_220_equipment = { helmet = { ["uiR2EDequipment_iczahh_2"] = "iczahh_2.sitem", ["uiR2EDequipment_iczahh_3"] = "iczahh_3.sitem", }, chest_plate = { ["uiR2EDequipment_iczahv_2"] = "iczahv_2.sitem", ["uiR2EDequipment_iczahv_3"] = "iczahv_3.sitem", }, legs = { ["uiR2EDequipment_iczahp_2"] = "iczahp_2.sitem", ["uiR2EDequipment_iczahp_3"] = "iczahp_3.sitem", }, boots = { ["uiR2EDequipment_iczahb_2"] = "iczahb_2.sitem", ["uiR2EDequipment_iczahb_3"] = "iczahb_3.sitem", }, arms_guard = { ["uiR2EDequipment_iczahs_2"] = "iczahs_2.sitem", ["uiR2EDequipment_iczahs_3"] = "iczahs_3.sitem", }, gloves = { ["uiR2EDequipment_iczahg_2"] = "iczahg_2.sitem", ["uiR2EDequipment_iczahg_3"] = "iczahg_3.sitem", }, hands = { ["uiR2EDequipment_iczm1ss_2"] = "iczm1ss_2.sitem:iczsb_2.sitem:slash", ["uiR2EDequipment_iczm1ss_2"] = "iczm1ss_2.sitem:iczss_2.sitem:slash", ["uiR2EDequipment_iczm1ss_3"] = "iczm1ss_3.sitem:iczsb_3.sitem:slash", ["uiR2EDequipment_iczm1ss_3"] = "iczm1ss_3.sitem:iczss_3.sitem:slash", ["uiR2EDequipment_iczm1sa_2"] = "iczm1sa_2.sitem:iczsb_2.sitem:slash", ["uiR2EDequipment_iczm1sa_2"] = "iczm1sa_2.sitem:iczss_2.sitem:slash", ["uiR2EDequipment_iczm1sa_3"] = "iczm1sa_3.sitem:iczsb_3.sitem:slash", ["uiR2EDequipment_iczm1sa_3"] = "iczm1sa_3.sitem:iczss_3.sitem:slash", ["uiR2EDequipment_iczm1bm_2"] = "iczm1bm_2.sitem:iczsb_2.sitem:blunt", ["uiR2EDequipment_iczm1bm_2"] = "iczm1bm_2.sitem:iczss_2.sitem:blunt", ["uiR2EDequipment_iczm1bm_3"] = "iczm1bm_3.sitem:iczsb_3.sitem:blunt", ["uiR2EDequipment_iczm1bm_3"] = "iczm1bm_3.sitem:iczss_3.sitem:blunt", ["uiR2EDequipment_iczm1ps_2"] = "iczm1ps_2.sitem:iczsb_2.sitem:pierce", ["uiR2EDequipment_iczm1ps_2"] = "iczm1ps_2.sitem:iczss_2.sitem:pierce", ["uiR2EDequipment_iczm1ps_3"] = "iczm1ps_3.sitem:iczsb_3.sitem:pierce", ["uiR2EDequipment_iczm1ps_3"] = "iczm1ps_3.sitem:iczss_3.sitem:pierce", }, } r2.addR2PlayerEquipment(entries.z_melee_tank_220, entries.z_melee_tank_220_equipment)



-- Light

	entries.f_light_melee_20 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_light_melee_pierce_b2.creature", SheetModel="ring_light_melee_$hands_b$level.creature", SheetClient="basic_fyros_male.creature", Level=20, RingAccess="a1", Equipment="f_light_melee_20_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.f_light_melee_20", entries.f_light_melee_20)
	entries.m_light_melee_20 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_light_melee_pierce_b2.creature", SheetModel="ring_light_melee_$hands_b$level.creature", SheetClient="basic_matis_male.creature", Level=20, RingAccess="a1", Equipment="m_light_melee_20_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.m_light_melee_20", entries.m_light_melee_20)
	entries.t_light_melee_20 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_light_melee_pierce_b2.creature", SheetModel="ring_light_melee_$hands_b$level.creature", SheetClient="basic_tryker_male.creature", Level=20, RingAccess="a1", Equipment="t_light_melee_20_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.t_light_melee_20", entries.t_light_melee_20)
	entries.z_light_melee_20 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_light_melee_pierce_b2.creature", SheetModel="ring_light_melee_$hands_b$level.creature", SheetClient="basic_zorai_male.creature", Level=20, RingAccess="a1", Equipment="z_light_melee_20_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.z_light_melee_20", entries.z_light_melee_20)

	entries.f_light_melee_70 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_light_melee_pierce_c2.creature", SheetModel="ring_light_melee_$hands_c$level.creature", SheetClient="basic_fyros_male.creature", Level=70, RingAccess="d2", Equipment="f_light_melee_70_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.f_light_melee_70", entries.f_light_melee_70)
	entries.m_light_melee_70 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_light_melee_pierce_c2.creature", SheetModel="ring_light_melee_$hands_c$level.creature", SheetClient="basic_matis_male.creature", Level=70, RingAccess="f5", Equipment="m_light_melee_70_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.m_light_melee_70", entries.m_light_melee_70)
	entries.t_light_melee_70 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_light_melee_pierce_c2.creature", SheetModel="ring_light_melee_$hands_c$level.creature", SheetClient="basic_tryker_male.creature", Level=70, RingAccess="l5", Equipment="t_light_melee_70_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.t_light_melee_70", entries.t_light_melee_70)
	entries.z_light_melee_70 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_light_melee_pierce_c2.creature", SheetModel="ring_light_melee_$hands_c$level.creature", SheetClient="basic_zorai_male.creature", Level=70, RingAccess="j5", Equipment="z_light_melee_70_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.z_light_melee_70", entries.z_light_melee_70)

	entries.f_light_melee_120 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_light_melee_slash_d2.creature", SheetModel="ring_light_melee_$hands_d$level.creature", SheetClient="basic_fyros_male.creature", Level=120, RingAccess="d4", Equipment="f_light_melee_120_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.f_light_melee_120", entries.f_light_melee_120)
	entries.m_light_melee_120 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_light_melee_slash_d2.creature", SheetModel="ring_light_melee_$hands_d$level.creature", SheetClient="basic_matis_male.creature", Level=120, RingAccess="f5", Equipment="m_light_melee_120_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.m_light_melee_120", entries.m_light_melee_120)
	entries.t_light_melee_120 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_light_melee_slash_d2.creature", SheetModel="ring_light_melee_$hands_d$level.creature", SheetClient="basic_tryker_male.creature", Level=120, RingAccess="l5", Equipment="t_light_melee_120_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.t_light_melee_120", entries.t_light_melee_120)
	entries.z_light_melee_120 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_light_melee_slash_d2.creature", SheetModel="ring_light_melee_$hands_d$level.creature", SheetClient="basic_zorai_male.creature", Level=120, RingAccess="j5", Equipment="z_light_melee_120_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.z_light_melee_120", entries.z_light_melee_120)

	entries.f_light_melee_170 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_light_melee_slash_e2.creature", SheetModel="ring_light_melee_$hands_e$level.creature", SheetClient="basic_fyros_male.creature", Level=170, RingAccess="d6", Equipment="f_light_melee_170_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.f_light_melee_170", entries.f_light_melee_170)
	entries.m_light_melee_170 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_light_melee_slash_e2.creature", SheetModel="ring_light_melee_$hands_e$level.creature", SheetClient="basic_matis_male.creature", Level=170, RingAccess="f6", Equipment="m_light_melee_170_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.m_light_melee_170", entries.m_light_melee_170)
	entries.t_light_melee_170 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_light_melee_slash_e2.creature", SheetModel="ring_light_melee_$hands_e$level.creature", SheetClient="basic_tryker_male.creature", Level=170, RingAccess="l5", Equipment="t_light_melee_170_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.t_light_melee_170", entries.t_light_melee_170)
	entries.z_light_melee_170 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_light_melee_slash_e2.creature", SheetModel="ring_light_melee_$hands_e$level.creature", SheetClient="basic_zorai_male.creature", Level=170, RingAccess="j6", Equipment="z_light_melee_170_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.z_light_melee_170", entries.z_light_melee_170)

	entries.f_light_melee_220 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_light_melee_slash_f2.creature", SheetModel="ring_light_melee_$hands_f$level.creature", SheetClient="basic_fyros_male.creature", Level=220, RingAccess="d7", Equipment="f_light_melee_220_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.f_light_melee_220", entries.f_light_melee_220)
	entries.m_light_melee_220 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_light_melee_slash_f2.creature", SheetModel="ring_light_melee_$hands_f$level.creature", SheetClient="basic_matis_male.creature", Level=220, RingAccess="f7", Equipment="m_light_melee_220_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.m_light_melee_220", entries.m_light_melee_220)
	entries.t_light_melee_220 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_light_melee_slash_f2.creature", SheetModel="ring_light_melee_$hands_f$level.creature", SheetClient="basic_tryker_male.creature", Level=220, RingAccess="l6", Equipment="t_light_melee_220_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.t_light_melee_220", entries.t_light_melee_220)
	entries.z_light_melee_220 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_light_melee_slash_f2.creature", SheetModel="ring_light_melee_$hands_f$level.creature", SheetClient="basic_zorai_male.creature", Level=220, RingAccess="j7", Equipment="z_light_melee_220_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.z_light_melee_220", entries.z_light_melee_220)



	entries.f_light_melee_20_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icfalv"] = "icfalv.sitem", }, legs = { ["uiR2EDequipment_icfalp"] = "icfalp.sitem", }, boots = { ["uiR2EDequipment_icfalb"] = "icfalb.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", }, gloves = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icfalg"] = "icfalg.sitem", }, hands = { ["uiR2EDequipment_icfm1ss"] = "icfm1ss.sitem::slash", ["uiR2EDequipment_icfm1sa"] = "icfm1sa.sitem::slash", ["uiR2EDequipment_icfm1pd"] = "icfm1pd.sitem:icfm1pd.sitem:pierce", ["uiR2EDequipment_icfm1bm"] = "icfm1bm.sitem::blunt", ["uiR2EDequipment_icfm1ps"] = "icfm1ps.sitem::pierce",  }, } r2.addR2PlayerEquipment(entries.f_light_melee_20, entries.f_light_melee_20_equipment)
	entries.m_light_melee_20_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icmalv"] = "icmalv.sitem", }, legs = { ["uiR2EDequipment_icmalp"] = "icmalp.sitem", }, boots = { ["uiR2EDequipment_icmalb"] = "icmalb.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", }, gloves = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icmalg"] = "icmalg.sitem", }, hands = { ["uiR2EDequipment_icmm1ss"] = "icmm1ss.sitem::slash", ["uiR2EDequipment_icmm1sa"] = "icmm1sa.sitem::slash", ["uiR2EDequipment_icmm1pd"] = "icmm1pd.sitem:icmm1pd.sitem:pierce", ["uiR2EDequipment_icmm1bm"] = "icmm1bm.sitem::blunt", ["uiR2EDequipment_icmm1ps"] = "icmm1ps.sitem::pierce",  }, } r2.addR2PlayerEquipment(entries.m_light_melee_20, entries.m_light_melee_20_equipment)
	entries.t_light_melee_20_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_ictalv"] = "ictalv.sitem", }, legs = { ["uiR2EDequipment_ictalp"] = "ictalp.sitem", }, boots = { ["uiR2EDequipment_ictalb"] = "ictalb.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", }, gloves = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_ictalg"] = "ictalg.sitem", }, hands = { ["uiR2EDequipment_ictm1ss"] = "ictm1ss.sitem::slash", ["uiR2EDequipment_ictm1sa"] = "ictm1sa.sitem::slash", ["uiR2EDequipment_ictm1pd"] = "ictm1pd.sitem:ictm1pd.sitem:pierce", ["uiR2EDequipment_ictm1bm"] = "ictm1bm.sitem::blunt", ["uiR2EDequipment_ictm1ps"] = "ictm1ps.sitem::pierce",  }, } r2.addR2PlayerEquipment(entries.t_light_melee_20, entries.t_light_melee_20_equipment)
	entries.z_light_melee_20_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_iczalv"] = "iczalv.sitem", }, legs = { ["uiR2EDequipment_iczalp"] = "iczalp.sitem", }, boots = { ["uiR2EDequipment_iczalb"] = "iczalb.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", }, gloves = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_iczalg"] = "iczalg.sitem", }, hands = { ["uiR2EDequipment_iczm1ss"] = "iczm1ss.sitem::slash", ["uiR2EDequipment_iczm1sa"] = "iczm1sa.sitem::slash", ["uiR2EDequipment_iczm1pd"] = "iczm1pd.sitem:iczm1pd.sitem:pierce", ["uiR2EDequipment_iczm1bm"] = "iczm1bm.sitem::blunt", ["uiR2EDequipment_iczm1ps"] = "iczm1ps.sitem::pierce",  }, } r2.addR2PlayerEquipment(entries.z_light_melee_20, entries.z_light_melee_20_equipment)

	entries.f_light_melee_70_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icfalv"] = "icfalv.sitem", ["uiR2EDequipment_icfalv_2"] = "icfalv_2.sitem", }, legs = { ["uiR2EDequipment_icfalp"] = "icfalp.sitem", ["uiR2EDequipment_icfalp_2"] = "icfalp_2.sitem", }, boots = { ["uiR2EDequipment_icfalb"] = "icfalb.sitem", ["uiR2EDequipment_icfalb_2"] = "icfalb_2.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", }, gloves = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icfalg"] = "icfalg.sitem", ["uiR2EDequipment_icfalg_2"] = "icfalg_2.sitem", }, hands = { ["uiR2EDequipment_icfm1ss"] = "icfm1ss.sitem::slash", ["uiR2EDequipment_icfm1ss_2"] = "icfm1ss_2.sitem::slash", ["uiR2EDequipment_icfm1sa"] = "icfm1sa.sitem::slash", ["uiR2EDequipment_icfm1sa_2"] = "icfm1sa_2.sitem::slash", ["uiR2EDequipment_icfm1pd"] = "icfm1pd.sitem:icfm1pd.sitem:pierce", ["uiR2EDequipment_icfm1pd_2"] = "icfm1pd_2.sitem:icfm1pd_2.sitem:pierce", ["uiR2EDequipment_icfm1bm"] = "icfm1bm.sitem::blunt", ["uiR2EDequipment_icfm1bm_2"] = "icfm1bm_2.sitem::blunt", ["uiR2EDequipment_icfm1ps"] = "icfm1ps.sitem::pierce", ["uiR2EDequipment_icfm1ps_2"] = "icfm1ps_2.sitem::pierce",  }, } r2.addR2PlayerEquipment(entries.f_light_melee_70, entries.f_light_melee_70_equipment)
	entries.m_light_melee_70_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icmalv"] = "icmalv.sitem", ["uiR2EDequipment_icmalv_2"] = "icmalv_2.sitem", }, legs = { ["uiR2EDequipment_icmalp"] = "icmalp.sitem", ["uiR2EDequipment_icmalp_2"] = "icmalp_2.sitem", }, boots = { ["uiR2EDequipment_icmalb"] = "icmalb.sitem", ["uiR2EDequipment_icmalb_2"] = "icmalb_2.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", }, gloves = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icmalg"] = "icmalg.sitem", ["uiR2EDequipment_icmalg_2"] = "icmalg_2.sitem", }, hands = { ["uiR2EDequipment_icmm1ss"] = "icmm1ss.sitem::slash", ["uiR2EDequipment_icmm1ss_2"] = "icmm1ss_2.sitem::slash", ["uiR2EDequipment_icmm1sa"] = "icmm1sa.sitem::slash", ["uiR2EDequipment_icmm1sa_2"] = "icmm1sa_2.sitem::slash", ["uiR2EDequipment_icmm1pd"] = "icmm1pd.sitem:icmm1pd.sitem:pierce", ["uiR2EDequipment_icmm1pd_2"] = "icmm1pd_2.sitem:icmm1pd_2.sitem:pierce", ["uiR2EDequipment_icmm1bm"] = "icmm1bm.sitem::blunt", ["uiR2EDequipment_icmm1bm_2"] = "icmm1bm_2.sitem::blunt", ["uiR2EDequipment_icmm1ps"] = "icmm1ps.sitem::pierce", ["uiR2EDequipment_icmm1ps_2"] = "icmm1ps_2.sitem::pierce",  }, } r2.addR2PlayerEquipment(entries.m_light_melee_70, entries.m_light_melee_70_equipment)
	entries.t_light_melee_70_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_ictalv"] = "ictalv.sitem", ["uiR2EDequipment_ictalv_2"] = "ictalv_2.sitem", }, legs = { ["uiR2EDequipment_ictalp"] = "ictalp.sitem", ["uiR2EDequipment_ictalp_2"] = "ictalp_2.sitem", }, boots = { ["uiR2EDequipment_ictalb"] = "ictalb.sitem", ["uiR2EDequipment_ictalb_2"] = "ictalb_2.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", }, gloves = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_ictalg"] = "ictalg.sitem", ["uiR2EDequipment_ictalg_2"] = "ictalg_2.sitem", }, hands = { ["uiR2EDequipment_ictm1ss"] = "ictm1ss.sitem::slash", ["uiR2EDequipment_ictm1ss_2"] = "ictm1ss_2.sitem::slash", ["uiR2EDequipment_ictm1sa"] = "ictm1sa.sitem::slash", ["uiR2EDequipment_ictm1sa_2"] = "ictm1sa_2.sitem::slash", ["uiR2EDequipment_ictm1pd"] = "ictm1pd.sitem:ictm1pd.sitem:pierce", ["uiR2EDequipment_ictm1pd_2"] = "ictm1pd_2.sitem:ictm1pd_2.sitem:pierce", ["uiR2EDequipment_ictm1bm"] = "ictm1bm.sitem::blunt", ["uiR2EDequipment_ictm1bm_2"] = "ictm1bm_2.sitem::blunt", ["uiR2EDequipment_ictm1ps"] = "ictm1ps.sitem::pierce", ["uiR2EDequipment_ictm1ps_2"] = "ictm1ps_2.sitem::pierce",  }, } r2.addR2PlayerEquipment(entries.t_light_melee_70, entries.t_light_melee_70_equipment)
	entries.z_light_melee_70_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_iczalv"] = "iczalv.sitem", ["uiR2EDequipment_iczalv_2"] = "iczalv_2.sitem", }, legs = { ["uiR2EDequipment_iczalp"] = "iczalp.sitem", ["uiR2EDequipment_iczalp_2"] = "iczalp_2.sitem", }, boots = { ["uiR2EDequipment_iczalb"] = "iczalb.sitem", ["uiR2EDequipment_iczalb_2"] = "iczalb_2.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", }, gloves = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_iczalg"] = "iczalg.sitem", ["uiR2EDequipment_iczalg_2"] = "iczalg_2.sitem", }, hands = { ["uiR2EDequipment_iczm1ss"] = "iczm1ss.sitem::slash", ["uiR2EDequipment_iczm1ss_2"] = "iczm1ss_2.sitem::slash", ["uiR2EDequipment_iczm1sa"] = "iczm1sa.sitem::slash", ["uiR2EDequipment_iczm1sa_2"] = "iczm1sa_2.sitem::slash", ["uiR2EDequipment_iczm1pd"] = "iczm1pd.sitem:iczm1pd.sitem:pierce", ["uiR2EDequipment_iczm1pd_2"] = "iczm1pd_2.sitem:iczm1pd_2.sitem:pierce", ["uiR2EDequipment_iczm1bm"] = "iczm1bm.sitem::blunt", ["uiR2EDequipment_iczm1bm_2"] = "iczm1bm_2.sitem::blunt", ["uiR2EDequipment_iczm1ps"] = "iczm1ps.sitem::pierce", ["uiR2EDequipment_iczm1ps_2"] = "iczm1ps_2.sitem::pierce",  }, } r2.addR2PlayerEquipment(entries.z_light_melee_70, entries.z_light_melee_70_equipment)

	entries.f_light_melee_120_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icfalv"] = "icfalv.sitem", ["uiR2EDequipment_icfamv"] = "icfamv.sitem", ["uiR2EDequipment_icfalv_2"] = "icfalv_2.sitem", ["uiR2EDequipment_icfamv_2"] = "icfamv_2.sitem", }, legs = { ["uiR2EDequipment_icfalp"] = "icfalp.sitem", ["uiR2EDequipment_icfalp_2"] = "icfalp_2.sitem", }, boots = { ["uiR2EDequipment_icfalb"] = "icfalb.sitem", ["uiR2EDequipment_icfalb_2"] = "icfalb_2.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", }, gloves = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icfamg"] = "icfamg.sitem", ["uiR2EDequipment_icfamg_2"] = "icfamg_2.sitem", }, hands = { ["uiR2EDequipment_icfm1ss"] = "icfm1ss.sitem::slash", ["uiR2EDequipment_icfm1ss_2"] = "icfm1ss_2.sitem::slash", ["uiR2EDequipment_icfm1sa"] = "icfm1sa.sitem::slash", ["uiR2EDequipment_icfm1sa_2"] = "icfm1sa_2.sitem::slash", ["uiR2EDequipment_icfm1pd"] = "icfm1pd.sitem:icfm1pd.sitem:pierce", ["uiR2EDequipment_icfm1pd_2"] = "icfm1pd_2.sitem:icfm1pd_2.sitem:pierce", ["uiR2EDequipment_icfm1bm"] = "icfm1bm.sitem::blunt", ["uiR2EDequipment_icfm1bm_2"] = "icfm1bm_2.sitem::blunt", ["uiR2EDequipment_icfm1ps"] = "icfm1ps.sitem::pierce", ["uiR2EDequipment_icfm1ps_2"] = "icfm1ps_2.sitem::pierce",  }, } r2.addR2PlayerEquipment(entries.f_light_melee_120, entries.f_light_melee_120_equipment)
	entries.m_light_melee_120_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icmalv"] = "icmalv.sitem", ["uiR2EDequipment_icmamv"] = "icmamv.sitem", ["uiR2EDequipment_icmalv_2"] = "icmalv_2.sitem", ["uiR2EDequipment_icmamv_2"] = "icmamv_2.sitem", }, legs = { ["uiR2EDequipment_icmalp"] = "icmalp.sitem", ["uiR2EDequipment_icmalp_2"] = "icmalp_2.sitem", }, boots = { ["uiR2EDequipment_icmalb"] = "icmalb.sitem", ["uiR2EDequipment_icmalb_2"] = "icmalb_2.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", }, gloves = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icmamg"] = "icmamg.sitem", ["uiR2EDequipment_icmamg_2"] = "icmamg_2.sitem", }, hands = { ["uiR2EDequipment_icmm1ss"] = "icmm1ss.sitem::slash", ["uiR2EDequipment_icmm1ss_2"] = "icmm1ss_2.sitem::slash", ["uiR2EDequipment_icmm1sa"] = "icmm1sa.sitem::slash", ["uiR2EDequipment_icmm1sa_2"] = "icmm1sa_2.sitem::slash", ["uiR2EDequipment_icmm1pd"] = "icmm1pd.sitem:icmm1pd.sitem:pierce", ["uiR2EDequipment_icmm1pd_2"] = "icmm1pd_2.sitem:icmm1pd_2.sitem:pierce", ["uiR2EDequipment_icmm1bm"] = "icmm1bm.sitem::blunt", ["uiR2EDequipment_icmm1bm_2"] = "icmm1bm_2.sitem::blunt", ["uiR2EDequipment_icmm1ps"] = "icmm1ps.sitem::pierce", ["uiR2EDequipment_icmm1ps_2"] = "icmm1ps_2.sitem::pierce",  }, } r2.addR2PlayerEquipment(entries.m_light_melee_120, entries.m_light_melee_120_equipment)
	entries.t_light_melee_120_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_ictalv"] = "ictalv.sitem", ["uiR2EDequipment_ictamv"] = "ictamv.sitem", ["uiR2EDequipment_ictalv_2"] = "ictalv_2.sitem", ["uiR2EDequipment_ictamv_2"] = "ictamv_2.sitem", }, legs = { ["uiR2EDequipment_ictalp"] = "ictalp.sitem", ["uiR2EDequipment_ictalp_2"] = "ictalp_2.sitem", }, boots = { ["uiR2EDequipment_ictalb"] = "ictalb.sitem", ["uiR2EDequipment_ictalb_2"] = "ictalb_2.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", }, gloves = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_ictamg"] = "ictamg.sitem", ["uiR2EDequipment_ictamg_2"] = "ictamg_2.sitem", }, hands = { ["uiR2EDequipment_ictm1ss"] = "ictm1ss.sitem::slash", ["uiR2EDequipment_ictm1ss_2"] = "ictm1ss_2.sitem::slash", ["uiR2EDequipment_ictm1sa"] = "ictm1sa.sitem::slash", ["uiR2EDequipment_ictm1sa_2"] = "ictm1sa_2.sitem::slash", ["uiR2EDequipment_ictm1pd"] = "ictm1pd.sitem:ictm1pd.sitem:pierce", ["uiR2EDequipment_ictm1pd_2"] = "ictm1pd_2.sitem:ictm1pd_2.sitem:pierce", ["uiR2EDequipment_ictm1bm"] = "ictm1bm.sitem::blunt", ["uiR2EDequipment_ictm1bm_2"] = "ictm1bm_2.sitem::blunt", ["uiR2EDequipment_ictm1ps"] = "ictm1ps.sitem::pierce", ["uiR2EDequipment_ictm1ps_2"] = "ictm1ps_2.sitem::pierce",  }, } r2.addR2PlayerEquipment(entries.t_light_melee_120, entries.t_light_melee_120_equipment)
	entries.z_light_melee_120_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_iczalv"] = "iczalv.sitem", ["uiR2EDequipment_iczamv"] = "iczamv.sitem", ["uiR2EDequipment_iczalv_2"] = "iczalv_2.sitem", ["uiR2EDequipment_iczamv_2"] = "iczamv_2.sitem", }, legs = { ["uiR2EDequipment_iczalp"] = "iczalp.sitem", ["uiR2EDequipment_iczalp_2"] = "iczalp_2.sitem", }, boots = { ["uiR2EDequipment_iczalb"] = "iczalb.sitem", ["uiR2EDequipment_iczalb_2"] = "iczalb_2.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", }, gloves = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_iczamg"] = "iczamg.sitem", ["uiR2EDequipment_iczamg_2"] = "iczamg_2.sitem", }, hands = { ["uiR2EDequipment_iczm1ss"] = "iczm1ss.sitem::slash", ["uiR2EDequipment_iczm1ss_2"] = "iczm1ss_2.sitem::slash", ["uiR2EDequipment_iczm1sa"] = "iczm1sa.sitem::slash", ["uiR2EDequipment_iczm1sa_2"] = "iczm1sa_2.sitem::slash", ["uiR2EDequipment_iczm1pd"] = "iczm1pd.sitem:iczm1pd.sitem:pierce", ["uiR2EDequipment_iczm1pd_2"] = "iczm1pd_2.sitem:iczm1pd_2.sitem:pierce", ["uiR2EDequipment_iczm1bm"] = "iczm1bm.sitem::blunt", ["uiR2EDequipment_iczm1bm_2"] = "iczm1bm_2.sitem::blunt", ["uiR2EDequipment_iczm1ps"] = "iczm1ps.sitem::pierce", ["uiR2EDequipment_iczm1ps_2"] = "iczm1ps_2.sitem::pierce",  }, } r2.addR2PlayerEquipment(entries.z_light_melee_120, entries.z_light_melee_120_equipment)

	entries.f_light_melee_170_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icfalv_2"] = "icfalv_2.sitem", ["uiR2EDequipment_icfamv_2"] = "icfamv_2.sitem", ["uiR2EDequipment_icfalv_3"] = "icfalv_3.sitem", ["uiR2EDequipment_icfamv_3"] = "icfamv_3.sitem", }, legs = { ["uiR2EDequipment_icfalp_2"] = "icfalp_2.sitem", ["uiR2EDequipment_icfamp_2"] = "icfamp_2.sitem", ["uiR2EDequipment_icfalp_3"] = "icfalp_3.sitem", ["uiR2EDequipment_icfamp_3"] = "icfamp_3.sitem", }, boots = { ["uiR2EDequipment_icfalb_2"] = "icfalb_2.sitem", ["uiR2EDequipment_icfamb_2"] = "icfamb_2.sitem", ["uiR2EDequipment_icfalb_3"] = "icfalb_3.sitem", ["uiR2EDequipment_icfamb_3"] = "icfamb_3.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icfals_2"] = "icfals_2.sitem", ["uiR2EDequipment_icfals_3"] = "icfals_3.sitem", }, gloves = { ["uiR2EDequipment_icfamg_2"] = "icfamg_2.sitem", ["uiR2EDequipment_icfamg_3"] = "icfamg_3.sitem", }, hands = { ["uiR2EDequipment_icfm1ss_2"] = "icfm1ss_2.sitem::slash", ["uiR2EDequipment_icfm1ss_3"] = "icfm1ss_3.sitem::slash", ["uiR2EDequipment_icfm1sa_2"] = "icfm1sa_2.sitem::slash", ["uiR2EDequipment_icfm1sa_3"] = "icfm1sa_3.sitem::slash", ["uiR2EDequipment_icfm1pd_2"] = "icfm1pd_2.sitem:icfm1pd_2.sitem:pierce", ["uiR2EDequipment_icfm1pd_3"] = "icfm1pd_3.sitem:icfm1pd_3.sitem:pierce", ["uiR2EDequipment_icfm1bm_2"] = "icfm1bm_2.sitem::blunt", ["uiR2EDequipment_icfm1bm_3"] = "icfm1bm_3.sitem::blunt", ["uiR2EDequipment_icfm1ps_2"] = "icfm1ps_2.sitem::pierce", ["uiR2EDequipment_icfm1ps_3"] = "icfm1ps_3.sitem::pierce",  }, } r2.addR2PlayerEquipment(entries.f_light_melee_170, entries.f_light_melee_170_equipment)
	entries.m_light_melee_170_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icmalv_2"] = "icmalv_2.sitem", ["uiR2EDequipment_icmamv_2"] = "icmamv_2.sitem", ["uiR2EDequipment_icmalv_3"] = "icmalv_3.sitem", ["uiR2EDequipment_icmamv_3"] = "icmamv_3.sitem", }, legs = { ["uiR2EDequipment_icmalp_2"] = "icmalp_2.sitem", ["uiR2EDequipment_icmamp_2"] = "icmamp_2.sitem", ["uiR2EDequipment_icmalp_3"] = "icmalp_3.sitem", ["uiR2EDequipment_icmamp_3"] = "icmamp_3.sitem", }, boots = { ["uiR2EDequipment_icmalb_2"] = "icmalb_2.sitem", ["uiR2EDequipment_icmamb_2"] = "icmamb_2.sitem", ["uiR2EDequipment_icmalb_3"] = "icmalb_3.sitem", ["uiR2EDequipment_icmamb_3"] = "icmamb_3.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icmals_2"] = "icmals_2.sitem", ["uiR2EDequipment_icmals_3"] = "icmals_3.sitem", }, gloves = { ["uiR2EDequipment_icmamg_2"] = "icmamg_2.sitem", ["uiR2EDequipment_icmamg_3"] = "icmamg_3.sitem", }, hands = { ["uiR2EDequipment_icmm1ss_2"] = "icmm1ss_2.sitem::slash", ["uiR2EDequipment_icmm1ss_3"] = "icmm1ss_3.sitem::slash", ["uiR2EDequipment_icmm1sa_2"] = "icmm1sa_2.sitem::slash", ["uiR2EDequipment_icmm1sa_3"] = "icmm1sa_3.sitem::slash", ["uiR2EDequipment_icmm1pd_2"] = "icmm1pd_2.sitem:icmm1pd_2.sitem:pierce", ["uiR2EDequipment_icmm1pd_3"] = "icmm1pd_3.sitem:icmm1pd_3.sitem:pierce", ["uiR2EDequipment_icmm1bm_2"] = "icmm1bm_2.sitem::blunt", ["uiR2EDequipment_icmm1bm_3"] = "icmm1bm_3.sitem::blunt", ["uiR2EDequipment_icmm1ps_2"] = "icmm1ps_2.sitem::pierce", ["uiR2EDequipment_icmm1ps_3"] = "icmm1ps_3.sitem::pierce",  }, } r2.addR2PlayerEquipment(entries.m_light_melee_170, entries.m_light_melee_170_equipment)
	entries.t_light_melee_170_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_ictalv_2"] = "ictalv_2.sitem", ["uiR2EDequipment_ictamv_2"] = "ictamv_2.sitem", ["uiR2EDequipment_ictalv_3"] = "ictalv_3.sitem", ["uiR2EDequipment_ictamv_3"] = "ictamv_3.sitem", }, legs = { ["uiR2EDequipment_ictalp_2"] = "ictalp_2.sitem", ["uiR2EDequipment_ictamp_2"] = "ictamp_2.sitem", ["uiR2EDequipment_ictalp_3"] = "ictalp_3.sitem", ["uiR2EDequipment_ictamp_3"] = "ictamp_3.sitem", }, boots = { ["uiR2EDequipment_ictalb_2"] = "ictalb_2.sitem", ["uiR2EDequipment_ictamb_2"] = "ictamb_2.sitem", ["uiR2EDequipment_ictalb_3"] = "ictalb_3.sitem", ["uiR2EDequipment_ictamb_3"] = "ictamb_3.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_ictals_2"] = "ictals_2.sitem", ["uiR2EDequipment_ictals_3"] = "ictals_3.sitem", }, gloves = { ["uiR2EDequipment_ictamg_2"] = "ictamg_2.sitem", ["uiR2EDequipment_ictamg_3"] = "ictamg_3.sitem", }, hands = { ["uiR2EDequipment_ictm1ss_2"] = "ictm1ss_2.sitem::slash", ["uiR2EDequipment_ictm1ss_3"] = "ictm1ss_3.sitem::slash", ["uiR2EDequipment_ictm1sa_2"] = "ictm1sa_2.sitem::slash", ["uiR2EDequipment_ictm1sa_3"] = "ictm1sa_3.sitem::slash", ["uiR2EDequipment_ictm1pd_2"] = "ictm1pd_2.sitem:ictm1pd_2.sitem:pierce", ["uiR2EDequipment_ictm1pd_3"] = "ictm1pd_3.sitem:ictm1pd_3.sitem:pierce", ["uiR2EDequipment_ictm1bm_2"] = "ictm1bm_2.sitem::blunt", ["uiR2EDequipment_ictm1bm_3"] = "ictm1bm_3.sitem::blunt", ["uiR2EDequipment_ictm1ps_2"] = "ictm1ps_2.sitem::pierce", ["uiR2EDequipment_ictm1ps_3"] = "ictm1ps_3.sitem::pierce",  }, } r2.addR2PlayerEquipment(entries.t_light_melee_170, entries.t_light_melee_170_equipment)
	entries.z_light_melee_170_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_iczalv_2"] = "iczalv_2.sitem", ["uiR2EDequipment_iczamv_2"] = "iczamv_2.sitem", ["uiR2EDequipment_iczalv_3"] = "iczalv_3.sitem", ["uiR2EDequipment_iczamv_3"] = "iczamv_3.sitem", }, legs = { ["uiR2EDequipment_iczalp_2"] = "iczalp_2.sitem", ["uiR2EDequipment_iczamp_2"] = "iczamp_2.sitem", ["uiR2EDequipment_iczalp_3"] = "iczalp_3.sitem", ["uiR2EDequipment_iczamp_3"] = "iczamp_3.sitem", }, boots = { ["uiR2EDequipment_iczalb_2"] = "iczalb_2.sitem", ["uiR2EDequipment_iczamb_2"] = "iczamb_2.sitem", ["uiR2EDequipment_iczalb_3"] = "iczalb_3.sitem", ["uiR2EDequipment_iczamb_3"] = "iczamb_3.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_iczals_2"] = "iczals_2.sitem", ["uiR2EDequipment_iczals_3"] = "iczals_3.sitem", }, gloves = { ["uiR2EDequipment_iczamg_2"] = "iczamg_2.sitem", ["uiR2EDequipment_iczamg_3"] = "iczamg_3.sitem", }, hands = { ["uiR2EDequipment_iczm1ss_2"] = "iczm1ss_2.sitem::slash", ["uiR2EDequipment_iczm1ss_3"] = "iczm1ss_3.sitem::slash", ["uiR2EDequipment_iczm1sa_2"] = "iczm1sa_2.sitem::slash", ["uiR2EDequipment_iczm1sa_3"] = "iczm1sa_3.sitem::slash", ["uiR2EDequipment_iczm1pd_2"] = "iczm1pd_2.sitem:iczm1pd_2.sitem:pierce", ["uiR2EDequipment_iczm1pd_3"] = "iczm1pd_3.sitem:iczm1pd_3.sitem:pierce", ["uiR2EDequipment_iczm1bm_2"] = "iczm1bm_2.sitem::blunt", ["uiR2EDequipment_iczm1bm_3"] = "iczm1bm_3.sitem::blunt", ["uiR2EDequipment_iczm1ps_2"] = "iczm1ps_2.sitem::pierce", ["uiR2EDequipment_iczm1ps_3"] = "iczm1ps_3.sitem::pierce",  }, } r2.addR2PlayerEquipment(entries.z_light_melee_170, entries.z_light_melee_170_equipment)

	entries.f_light_melee_220_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icfalv_2"] = "icfalv_2.sitem", ["uiR2EDequipment_icfamv_2"] = "icfamv_2.sitem", ["uiR2EDequipment_icfalv_3"] = "icfalv_3.sitem", ["uiR2EDequipment_icfamv_3"] = "icfamv_3.sitem", }, legs = { ["uiR2EDequipment_icfalp_2"] = "icfalp_2.sitem", ["uiR2EDequipment_icfamp_2"] = "icfamp_2.sitem", ["uiR2EDequipment_icfalp_3"] = "icfalp_3.sitem", ["uiR2EDequipment_icfamp_3"] = "icfamp_3.sitem", }, boots = { ["uiR2EDequipment_icfalb_2"] = "icfalb_2.sitem", ["uiR2EDequipment_icfamb_2"] = "icfamb_2.sitem", ["uiR2EDequipment_icfalb_3"] = "icfalb_3.sitem", ["uiR2EDequipment_icfamb_3"] = "icfamb_3.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icfals_2"] = "icfals_2.sitem", ["uiR2EDequipment_icfams_2"] = "icfams_2.sitem", ["uiR2EDequipment_icfals_3"] = "icfals_3.sitem", ["uiR2EDequipment_icfams_3"] = "icfams_3.sitem", }, gloves = { ["uiR2EDequipment_icfamg_2"] = "icfamg_2.sitem", ["uiR2EDequipment_icfamg_3"] = "icfamg_3.sitem", }, hands = { ["uiR2EDequipment_icfm1ss_2"] = "icfm1ss_2.sitem::slash", ["uiR2EDequipment_icfm1ss_3"] = "icfm1ss_3.sitem::slash", ["uiR2EDequipment_icfm1sa_2"] = "icfm1sa_2.sitem::slash", ["uiR2EDequipment_icfm1sa_3"] = "icfm1sa_3.sitem::slash", ["uiR2EDequipment_icfm1pd_2"] = "icfm1pd_2.sitem:icfm1pd_2.sitem:pierce", ["uiR2EDequipment_icfm1pd_3"] = "icfm1pd_3.sitem:icfm1pd_3.sitem:pierce", ["uiR2EDequipment_icfm1bm_2"] = "icfm1bm_2.sitem::blunt", ["uiR2EDequipment_icfm1bm_3"] = "icfm1bm_3.sitem::blunt", ["uiR2EDequipment_icfm1ps_2"] = "icfm1ps_2.sitem::pierce", ["uiR2EDequipment_icfm1ps_3"] = "icfm1ps_3.sitem::pierce",  }, } r2.addR2PlayerEquipment(entries.f_light_melee_220, entries.f_light_melee_220_equipment)
	entries.m_light_melee_220_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icmalv_2"] = "icmalv_2.sitem", ["uiR2EDequipment_icmamv_2"] = "icmamv_2.sitem", ["uiR2EDequipment_icmalv_3"] = "icmalv_3.sitem", ["uiR2EDequipment_icmamv_3"] = "icmamv_3.sitem", }, legs = { ["uiR2EDequipment_icmalp_2"] = "icmalp_2.sitem", ["uiR2EDequipment_icmamp_2"] = "icmamp_2.sitem", ["uiR2EDequipment_icmalp_3"] = "icmalp_3.sitem", ["uiR2EDequipment_icmamp_3"] = "icmamp_3.sitem", }, boots = { ["uiR2EDequipment_icmalb_2"] = "icmalb_2.sitem", ["uiR2EDequipment_icmamb_2"] = "icmamb_2.sitem", ["uiR2EDequipment_icmalb_3"] = "icmalb_3.sitem", ["uiR2EDequipment_icmamb_3"] = "icmamb_3.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icmals_2"] = "icmals_2.sitem", ["uiR2EDequipment_icmams_2"] = "icmams_2.sitem", ["uiR2EDequipment_icmals_3"] = "icmals_3.sitem", ["uiR2EDequipment_icmams_3"] = "icmams_3.sitem", }, gloves = { ["uiR2EDequipment_icmamg_2"] = "icmamg_2.sitem", ["uiR2EDequipment_icmamg_3"] = "icmamg_3.sitem", }, hands = { ["uiR2EDequipment_icmm1ss_2"] = "icmm1ss_2.sitem::slash", ["uiR2EDequipment_icmm1ss_3"] = "icmm1ss_3.sitem::slash", ["uiR2EDequipment_icmm1sa_2"] = "icmm1sa_2.sitem::slash", ["uiR2EDequipment_icmm1sa_3"] = "icmm1sa_3.sitem::slash", ["uiR2EDequipment_icmm1pd_2"] = "icmm1pd_2.sitem:icmm1pd_2.sitem:pierce", ["uiR2EDequipment_icmm1pd_3"] = "icmm1pd_3.sitem:icmm1pd_3.sitem:pierce", ["uiR2EDequipment_icmm1bm_2"] = "icmm1bm_2.sitem::blunt", ["uiR2EDequipment_icmm1bm_3"] = "icmm1bm_3.sitem::blunt", ["uiR2EDequipment_icmm1ps_2"] = "icmm1ps_2.sitem::pierce", ["uiR2EDequipment_icmm1ps_3"] = "icmm1ps_3.sitem::pierce",  }, } r2.addR2PlayerEquipment(entries.m_light_melee_220, entries.m_light_melee_220_equipment)
	entries.t_light_melee_220_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_ictalv_2"] = "ictalv_2.sitem", ["uiR2EDequipment_ictamv_2"] = "ictamv_2.sitem", ["uiR2EDequipment_ictalv_3"] = "ictalv_3.sitem", ["uiR2EDequipment_ictamv_3"] = "ictamv_3.sitem", }, legs = { ["uiR2EDequipment_ictalp_2"] = "ictalp_2.sitem", ["uiR2EDequipment_ictamp_2"] = "ictamp_2.sitem", ["uiR2EDequipment_ictalp_3"] = "ictalp_3.sitem", ["uiR2EDequipment_ictamp_3"] = "ictamp_3.sitem", }, boots = { ["uiR2EDequipment_ictalb_2"] = "ictalb_2.sitem", ["uiR2EDequipment_ictamb_2"] = "ictamb_2.sitem", ["uiR2EDequipment_ictalb_3"] = "ictalb_3.sitem", ["uiR2EDequipment_ictamb_3"] = "ictamb_3.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_ictals_2"] = "ictals_2.sitem", ["uiR2EDequipment_ictams_2"] = "ictams_2.sitem", ["uiR2EDequipment_ictals_3"] = "ictals_3.sitem", ["uiR2EDequipment_ictams_3"] = "ictams_3.sitem", }, gloves = { ["uiR2EDequipment_ictamg_2"] = "ictamg_2.sitem", ["uiR2EDequipment_ictamg_3"] = "ictamg_3.sitem", }, hands = { ["uiR2EDequipment_ictm1ss_2"] = "ictm1ss_2.sitem::slash", ["uiR2EDequipment_ictm1ss_3"] = "ictm1ss_3.sitem::slash", ["uiR2EDequipment_ictm1sa_2"] = "ictm1sa_2.sitem::slash", ["uiR2EDequipment_ictm1sa_3"] = "ictm1sa_3.sitem::slash", ["uiR2EDequipment_ictm1pd_2"] = "ictm1pd_2.sitem:ictm1pd_2.sitem:pierce", ["uiR2EDequipment_ictm1pd_3"] = "ictm1pd_3.sitem:ictm1pd_3.sitem:pierce", ["uiR2EDequipment_ictm1bm_2"] = "ictm1bm_2.sitem::blunt", ["uiR2EDequipment_ictm1bm_3"] = "ictm1bm_3.sitem::blunt", ["uiR2EDequipment_ictm1ps_2"] = "ictm1ps_2.sitem::pierce", ["uiR2EDequipment_ictm1ps_3"] = "ictm1ps_3.sitem::pierce",  }, } r2.addR2PlayerEquipment(entries.t_light_melee_220, entries.t_light_melee_220_equipment)
	entries.z_light_melee_220_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_iczalv_2"] = "iczalv_2.sitem", ["uiR2EDequipment_iczamv_2"] = "iczamv_2.sitem", ["uiR2EDequipment_iczalv_3"] = "iczalv_3.sitem", ["uiR2EDequipment_iczamv_3"] = "iczamv_3.sitem", }, legs = { ["uiR2EDequipment_iczalp_2"] = "iczalp_2.sitem", ["uiR2EDequipment_iczamp_2"] = "iczamp_2.sitem", ["uiR2EDequipment_iczalp_3"] = "iczalp_3.sitem", ["uiR2EDequipment_iczamp_3"] = "iczamp_3.sitem", }, boots = { ["uiR2EDequipment_iczalb_2"] = "iczalb_2.sitem", ["uiR2EDequipment_iczamb_2"] = "iczamb_2.sitem", ["uiR2EDequipment_iczalb_3"] = "iczalb_3.sitem", ["uiR2EDequipment_iczamb_3"] = "iczamb_3.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_iczals_2"] = "iczals_2.sitem", ["uiR2EDequipment_iczams_2"] = "iczams_2.sitem", ["uiR2EDequipment_iczals_3"] = "iczals_3.sitem", ["uiR2EDequipment_iczams_3"] = "iczams_3.sitem", }, gloves = { ["uiR2EDequipment_iczamg_2"] = "iczamg_2.sitem", ["uiR2EDequipment_iczamg_3"] = "iczamg_3.sitem", }, hands = { ["uiR2EDequipment_iczm1ss_2"] = "iczm1ss_2.sitem::slash", ["uiR2EDequipment_iczm1ss_3"] = "iczm1ss_3.sitem::slash", ["uiR2EDequipment_iczm1sa_2"] = "iczm1sa_2.sitem::slash", ["uiR2EDequipment_iczm1sa_3"] = "iczm1sa_3.sitem::slash", ["uiR2EDequipment_iczm1pd_2"] = "iczm1pd_2.sitem:iczm1pd_2.sitem:pierce", ["uiR2EDequipment_iczm1pd_3"] = "iczm1pd_3.sitem:iczm1pd_3.sitem:pierce", ["uiR2EDequipment_iczm1bm_2"] = "iczm1bm_2.sitem::blunt", ["uiR2EDequipment_iczm1bm_3"] = "iczm1bm_3.sitem::blunt", ["uiR2EDequipment_iczm1ps_2"] = "iczm1ps_2.sitem::pierce", ["uiR2EDequipment_iczm1ps_3"] = "iczm1ps_3.sitem::pierce",  }, } r2.addR2PlayerEquipment(entries.z_light_melee_220, entries.z_light_melee_220_equipment)




-- Mages


-- Healers

	entries.f_healer_20 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_healer_b2.creature", SheetClient="basic_fyros_male.creature", Level=20, RingAccess="a1", Equipment="f_healer_20_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.f_healer_20", entries.f_healer_20)
	entries.m_healer_20 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_healer_b2.creature", SheetClient="basic_matis_male.creature", Level=20, RingAccess="a1", Equipment="m_healer_20_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.m_healer_20", entries.m_healer_20)
	entries.t_healer_20 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_healer_b2.creature", SheetClient="basic_tryker_male.creature", Level=20, RingAccess="a1", Equipment="t_healer_20_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.t_healer_20", entries.t_healer_20)
	entries.z_healer_20 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_healer_b2.creature", SheetClient="basic_zorai_male.creature", Level=20, RingAccess="a1", Equipment="z_healer_20_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.z_healer_20", entries.z_healer_20)

	entries.f_healer_70 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_healer_c2.creature", SheetClient="basic_fyros_male.creature", Level=70, RingAccess="d2", Equipment="f_healer_70_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.f_healer_70", entries.f_healer_70)
	entries.m_healer_70 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_healer_c2.creature", SheetClient="basic_matis_male.creature", Level=70, RingAccess="f5", Equipment="m_healer_70_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.m_healer_70", entries.m_healer_70)
	entries.t_healer_70 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_healer_c2.creature", SheetClient="basic_tryker_male.creature", Level=70, RingAccess="l5", Equipment="t_healer_70_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.t_healer_70", entries.t_healer_70)
	entries.z_healer_70 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_healer_c2.creature", SheetClient="basic_zorai_male.creature", Level=70, RingAccess="j5", Equipment="z_healer_70_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.z_healer_70", entries.z_healer_70)

	entries.f_healer_120 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_healer_d2.creature", SheetClient="basic_fyros_male.creature", Level=120, RingAccess="d4", Equipment="f_healer_120_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.f_healer_120", entries.f_healer_120)
	entries.m_healer_120 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_healer_d2.creature", SheetClient="basic_matis_male.creature", Level=120, RingAccess="f5", Equipment="m_healer_120_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.m_healer_120", entries.m_healer_120)
	entries.t_healer_120 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_healer_d2.creature", SheetClient="basic_tryker_male.creature", Level=120, RingAccess="l5", Equipment="t_healer_120_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.t_healer_120", entries.t_healer_120)
	entries.z_healer_120 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_healer_d2.creature", SheetClient="basic_zorai_male.creature", Level=120, RingAccess="j5", Equipment="z_healer_120_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.z_healer_120", entries.z_healer_120)

	entries.f_healer_170 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_healer_e2.creature", SheetClient="basic_fyros_male.creature", Level=170, RingAccess="d6", Equipment="f_healer_170_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.f_healer_170", entries.f_healer_170)
	entries.m_healer_170 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_healer_e2.creature", SheetClient="basic_matis_male.creature", Level=170, RingAccess="f6", Equipment="m_healer_170_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.m_healer_170", entries.m_healer_170)
	entries.t_healer_170 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_healer_e2.creature", SheetClient="basic_tryker_male.creature", Level=170, RingAccess="l5", Equipment="t_healer_170_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.t_healer_170", entries.t_healer_170)
	entries.z_healer_170 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_healer_e2.creature", SheetClient="basic_zorai_male.creature", Level=170, RingAccess="j6", Equipment="z_healer_170_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.z_healer_170", entries.z_healer_170)

	entries.f_healer_220 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_healer_f2.creature", SheetClient="basic_fyros_male.creature", Level=220, RingAccess="d7", Equipment="f_healer_220_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.f_healer_220", entries.f_healer_220)
	entries.m_healer_220 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_healer_f2.creature", SheetClient="basic_matis_male.creature", Level=220, RingAccess="f7", Equipment="m_healer_220_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.m_healer_220", entries.m_healer_220)
	entries.t_healer_220 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_healer_f2.creature", SheetClient="basic_tryker_male.creature", Level=220, RingAccess="l6", Equipment="t_healer_220_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.t_healer_220", entries.t_healer_220)
	entries.z_healer_220 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_healer_f2.creature", SheetClient="basic_zorai_male.creature", Level=220, RingAccess="j7", Equipment="z_healer_220_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.z_healer_220", entries.z_healer_220)


	entries.f_healer_20_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icfalv"] = "icfalv.sitem", }, legs = { ["uiR2EDequipment_icfacp"] = "icfacp.sitem", }, boots = { ["uiR2EDequipment_icfalb"] = "icfalb.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", }, gloves = { ["uiR2EDequipment_none"] = "", }, right_hand = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icfm2ms"] = "icfm2ms.sitem", }, left_hand = { ["uiR2EDequipment_none"] = "", }, } r2.addR2PlayerEquipment(entries.f_healer_20, entries.f_healer_20_equipment)
	entries.m_healer_20_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icmalv"] = "icmalv.sitem", }, legs = { ["uiR2EDequipment_icm"] = "icm.sitem", }, boots = { ["uiR2EDequipment_icmalb"] = "icmalb.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", }, gloves = { ["uiR2EDequipment_none"] = "", }, right_hand = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icmm2ms"] = "icmm2ms.sitem", }, left_hand = { ["uiR2EDequipment_none"] = "", }, } r2.addR2PlayerEquipment(entries.m_healer_20, entries.m_healer_20_equipment)
	entries.t_healer_20_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_ictalv"] = "ictalv.sitem", }, legs = { ["uiR2EDequipment_ict"] = "ict.sitem", }, boots = { ["uiR2EDequipment_ictalb"] = "ictalb.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", }, gloves = { ["uiR2EDequipment_none"] = "", }, right_hand = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_ictm2ms"] = "ictm2ms.sitem", }, left_hand = { ["uiR2EDequipment_none"] = "", }, } r2.addR2PlayerEquipment(entries.t_healer_20, entries.t_healer_20_equipment)
	entries.z_healer_20_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_iczalv"] = "iczalv.sitem", }, legs = { ["uiR2EDequipment_icz"] = "icz.sitem", }, boots = { ["uiR2EDequipment_iczalb"] = "iczalb.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", }, gloves = { ["uiR2EDequipment_none"] = "", }, right_hand = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_iczm2ms"] = "iczm2ms.sitem", }, left_hand = { ["uiR2EDequipment_none"] = "", }, } r2.addR2PlayerEquipment(entries.z_healer_20, entries.z_healer_20_equipment)

	entries.f_healer_70_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icfalv"] = "icfalv.sitem", ["uiR2EDequipment_icfalv_2"] = "icfalv_2.sitem", }, legs = { ["uiR2EDequipment_icf"] = "icf.sitem", ["uiR2EDequipment_icf_2"] = "icf_2.sitem", }, boots = { ["uiR2EDequipment_icfalb"] = "icfalb.sitem", ["uiR2EDequipment_icfalb_2"] = "icfalb_2.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icfals"] = "icfals.sitem", ["uiR2EDequipment_icfals_2"] = "icfals_2.sitem", }, gloves = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icfalg"] = "icfalg.sitem", ["uiR2EDequipment_icfalg_2"] = "icfalg_2.sitem", }, right_hand = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icfm2ms"] = "icfm2ms.sitem", ["uiR2EDequipment_icfm2ms_2"] = "icfm2ms_2.sitem", }, left_hand = { ["uiR2EDequipment_none"] = "", }, } r2.addR2PlayerEquipment(entries.f_healer_70, entries.f_healer_70_equipment)
	entries.m_healer_70_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icmalv"] = "icmalv.sitem", ["uiR2EDequipment_icmalv_2"] = "icmalv_2.sitem", }, legs = { ["uiR2EDequipment_icm"] = "icm.sitem", ["uiR2EDequipment_icm_2"] = "icm_2.sitem", }, boots = { ["uiR2EDequipment_icmalb"] = "icmalb.sitem", ["uiR2EDequipment_icmalb_2"] = "icmalb_2.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icmals"] = "icmals.sitem", ["uiR2EDequipment_icmals_2"] = "icmals_2.sitem", }, gloves = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icmalg"] = "icmalg.sitem", ["uiR2EDequipment_icmalg_2"] = "icmalg_2.sitem", }, right_hand = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icmm2ms"] = "icmm2ms.sitem", ["uiR2EDequipment_icmm2ms_2"] = "icmm2ms_2.sitem", }, left_hand = { ["uiR2EDequipment_none"] = "", }, } r2.addR2PlayerEquipment(entries.m_healer_70, entries.m_healer_70_equipment)
	entries.t_healer_70_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_ictalv"] = "ictalv.sitem", ["uiR2EDequipment_ictalv_2"] = "ictalv_2.sitem", }, legs = { ["uiR2EDequipment_ict"] = "ict.sitem", ["uiR2EDequipment_ict_2"] = "ict_2.sitem", }, boots = { ["uiR2EDequipment_ictalb"] = "ictalb.sitem", ["uiR2EDequipment_ictalb_2"] = "ictalb_2.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_ictals"] = "ictals.sitem", ["uiR2EDequipment_ictals_2"] = "ictals_2.sitem", }, gloves = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_ictalg"] = "ictalg.sitem", ["uiR2EDequipment_ictalg_2"] = "ictalg_2.sitem", }, right_hand = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_ictm2ms"] = "ictm2ms.sitem", ["uiR2EDequipment_ictm2ms_2"] = "ictm2ms_2.sitem", }, left_hand = { ["uiR2EDequipment_none"] = "", }, } r2.addR2PlayerEquipment(entries.t_healer_70, entries.t_healer_70_equipment)
	entries.z_healer_70_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_iczalv"] = "iczalv.sitem", ["uiR2EDequipment_iczalv_2"] = "iczalv_2.sitem", }, legs = { ["uiR2EDequipment_icz"] = "icz.sitem", ["uiR2EDequipment_icz_2"] = "icz_2.sitem", }, boots = { ["uiR2EDequipment_iczalb"] = "iczalb.sitem", ["uiR2EDequipment_iczalb_2"] = "iczalb_2.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_iczals"] = "iczals.sitem", ["uiR2EDequipment_iczals_2"] = "iczals_2.sitem", }, gloves = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_iczalg"] = "iczalg.sitem", ["uiR2EDequipment_iczalg_2"] = "iczalg_2.sitem", }, right_hand = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_iczm2ms"] = "iczm2ms.sitem", ["uiR2EDequipment_iczm2ms_2"] = "iczm2ms_2.sitem", }, left_hand = { ["uiR2EDequipment_none"] = "", }, } r2.addR2PlayerEquipment(entries.z_healer_70, entries.z_healer_70_equipment)

	entries.f_healer_120_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icfalv"] = "icfalv.sitem", ["uiR2EDequipment_icfalv_2"] = "icfalv_2.sitem", }, legs = { ["uiR2EDequipment_icf"] = "icf.sitem", ["uiR2EDequipment_icf_2"] = "icf_2.sitem", }, boots = { ["uiR2EDequipment_icfalb"] = "icfalb.sitem", ["uiR2EDequipment_icfalb_2"] = "icfalb_2.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icfals"] = "icfals.sitem", ["uiR2EDequipment_icfals_2"] = "icfals_2.sitem", }, gloves = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icfalg"] = "icfalg.sitem", ["uiR2EDequipment_icfalg_2"] = "icfalg_2.sitem", }, right_hand = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icfm2ms"] = "icfm2ms.sitem", ["uiR2EDequipment_icfm2ms_2"] = "icfm2ms_2.sitem", }, left_hand = { ["uiR2EDequipment_none"] = "", }, } r2.addR2PlayerEquipment(entries.f_healer_120, entries.f_healer_120_equipment)
	entries.m_healer_120_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icmalv"] = "icmalv.sitem", ["uiR2EDequipment_icmalv_2"] = "icmalv_2.sitem", }, legs = { ["uiR2EDequipment_icm"] = "icm.sitem", ["uiR2EDequipment_icm_2"] = "icm_2.sitem", }, boots = { ["uiR2EDequipment_icmalb"] = "icmalb.sitem", ["uiR2EDequipment_icmalb_2"] = "icmalb_2.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icmals"] = "icmals.sitem", ["uiR2EDequipment_icmals_2"] = "icmals_2.sitem", }, gloves = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icmalg"] = "icmalg.sitem", ["uiR2EDequipment_icmalg_2"] = "icmalg_2.sitem", }, right_hand = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icmm2ms"] = "icmm2ms.sitem", ["uiR2EDequipment_icmm2ms_2"] = "icmm2ms_2.sitem", }, left_hand = { ["uiR2EDequipment_none"] = "", }, } r2.addR2PlayerEquipment(entries.m_healer_120, entries.m_healer_120_equipment)
	entries.t_healer_120_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_ictalv"] = "ictalv.sitem", ["uiR2EDequipment_ictalv_2"] = "ictalv_2.sitem", }, legs = { ["uiR2EDequipment_ict"] = "ict.sitem", ["uiR2EDequipment_ict_2"] = "ict_2.sitem", }, boots = { ["uiR2EDequipment_ictalb"] = "ictalb.sitem", ["uiR2EDequipment_ictalb_2"] = "ictalb_2.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_ictals"] = "ictals.sitem", ["uiR2EDequipment_ictals_2"] = "ictals_2.sitem", }, gloves = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_ictalg"] = "ictalg.sitem", ["uiR2EDequipment_ictalg_2"] = "ictalg_2.sitem", }, right_hand = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_ictm2ms"] = "ictm2ms.sitem", ["uiR2EDequipment_ictm2ms_2"] = "ictm2ms_2.sitem", }, left_hand = { ["uiR2EDequipment_none"] = "", }, } r2.addR2PlayerEquipment(entries.t_healer_120, entries.t_healer_120_equipment)
	entries.z_healer_120_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_iczalv"] = "iczalv.sitem", ["uiR2EDequipment_iczalv_2"] = "iczalv_2.sitem", }, legs = { ["uiR2EDequipment_icz"] = "icz.sitem", ["uiR2EDequipment_icz_2"] = "icz_2.sitem", }, boots = { ["uiR2EDequipment_iczalb"] = "iczalb.sitem", ["uiR2EDequipment_iczalb_2"] = "iczalb_2.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_iczals"] = "iczals.sitem", ["uiR2EDequipment_iczals_2"] = "iczals_2.sitem", }, gloves = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_iczalg"] = "iczalg.sitem", ["uiR2EDequipment_iczalg_2"] = "iczalg_2.sitem", }, right_hand = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_iczm2ms"] = "iczm2ms.sitem", ["uiR2EDequipment_iczm2ms_2"] = "iczm2ms_2.sitem", }, left_hand = { ["uiR2EDequipment_none"] = "", }, } r2.addR2PlayerEquipment(entries.z_healer_120, entries.z_healer_120_equipment)

	entries.f_healer_170_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icfalv_2"] = "icfalv_2.sitem", ["uiR2EDequipment_icfalv_3"] = "icfalv_3.sitem", }, legs = { ["uiR2EDequipment_icf_2"] = "icf_2.sitem", ["uiR2EDequipment_icf_3"] = "icf_3.sitem", }, boots = { ["uiR2EDequipment_icfalb_2"] = "icfalb_2.sitem", ["uiR2EDequipment_icfalb_3"] = "icfalb_3.sitem", }, arms_guard = { ["uiR2EDequipment_icfals_2"] = "icfals_2.sitem", ["uiR2EDequipment_icfals_3"] = "icfals_3.sitem", }, gloves = { ["uiR2EDequipment_icfalg_2"] = "icfalg_2.sitem", ["uiR2EDequipment_icfalg_3"] = "icfalg_3.sitem", }, right_hand = { ["uiR2EDequipment_icfm2ms_2"] = "icfm2ms_2.sitem", ["uiR2EDequipment_icfm2ms_3"] = "icfm2ms_3.sitem", }, left_hand = { ["uiR2EDequipment_none"] = "", }, } r2.addR2PlayerEquipment(entries.f_healer_170, entries.f_healer_170_equipment)
	entries.m_healer_170_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icmalv_2"] = "icmalv_2.sitem", ["uiR2EDequipment_icmalv_3"] = "icmalv_3.sitem", }, legs = { ["uiR2EDequipment_icm_2"] = "icm_2.sitem", ["uiR2EDequipment_icm_3"] = "icm_3.sitem", }, boots = { ["uiR2EDequipment_icmalb_2"] = "icmalb_2.sitem", ["uiR2EDequipment_icmalb_3"] = "icmalb_3.sitem", }, arms_guard = { ["uiR2EDequipment_icmals_2"] = "icmals_2.sitem", ["uiR2EDequipment_icmals_3"] = "icmals_3.sitem", }, gloves = { ["uiR2EDequipment_icmalg_2"] = "icmalg_2.sitem", ["uiR2EDequipment_icmalg_3"] = "icmalg_3.sitem", }, right_hand = { ["uiR2EDequipment_icmm2ms_2"] = "icmm2ms_2.sitem", ["uiR2EDequipment_icmm2ms_3"] = "icmm2ms_3.sitem", }, left_hand = { ["uiR2EDequipment_none"] = "", }, } r2.addR2PlayerEquipment(entries.m_healer_170, entries.m_healer_170_equipment)
	entries.t_healer_170_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_ictalv_2"] = "ictalv_2.sitem", ["uiR2EDequipment_ictalv_3"] = "ictalv_3.sitem", }, legs = { ["uiR2EDequipment_ict_2"] = "ict_2.sitem", ["uiR2EDequipment_ict_3"] = "ict_3.sitem", }, boots = { ["uiR2EDequipment_ictalb_2"] = "ictalb_2.sitem", ["uiR2EDequipment_ictalb_3"] = "ictalb_3.sitem", }, arms_guard = { ["uiR2EDequipment_ictals_2"] = "ictals_2.sitem", ["uiR2EDequipment_ictals_3"] = "ictals_3.sitem", }, gloves = { ["uiR2EDequipment_ictalg_2"] = "ictalg_2.sitem", ["uiR2EDequipment_ictalg_3"] = "ictalg_3.sitem", }, right_hand = { ["uiR2EDequipment_ictm2ms_2"] = "ictm2ms_2.sitem", ["uiR2EDequipment_ictm2ms_3"] = "ictm2ms_3.sitem", }, left_hand = { ["uiR2EDequipment_none"] = "", }, } r2.addR2PlayerEquipment(entries.t_healer_170, entries.t_healer_170_equipment)
	entries.z_healer_170_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_iczalv_2"] = "iczalv_2.sitem", ["uiR2EDequipment_iczalv_3"] = "iczalv_3.sitem", }, legs = { ["uiR2EDequipment_icz_2"] = "icz_2.sitem", ["uiR2EDequipment_icz_3"] = "icz_3.sitem", }, boots = { ["uiR2EDequipment_iczalb_2"] = "iczalb_2.sitem", ["uiR2EDequipment_iczalb_3"] = "iczalb_3.sitem", }, arms_guard = { ["uiR2EDequipment_iczals_2"] = "iczals_2.sitem", ["uiR2EDequipment_iczals_3"] = "iczals_3.sitem", }, gloves = { ["uiR2EDequipment_iczalg_2"] = "iczalg_2.sitem", ["uiR2EDequipment_iczalg_3"] = "iczalg_3.sitem", }, right_hand = { ["uiR2EDequipment_iczm2ms_2"] = "iczm2ms_2.sitem", ["uiR2EDequipment_iczm2ms_3"] = "iczm2ms_3.sitem", }, left_hand = { ["uiR2EDequipment_none"] = "", }, } r2.addR2PlayerEquipment(entries.z_healer_170, entries.z_healer_170_equipment)

	entries.f_healer_220_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icfalv_2"] = "icfalv_2.sitem", ["uiR2EDequipment_icfalv_3"] = "icfalv_3.sitem", }, legs = { ["uiR2EDequipment_icf_2"] = "icf_2.sitem", ["uiR2EDequipment_icf_3"] = "icf_3.sitem", }, boots = { ["uiR2EDequipment_icfalb_2"] = "icfalb_2.sitem", ["uiR2EDequipment_icfalb_3"] = "icfalb_3.sitem", }, arms_guard = { ["uiR2EDequipment_icfals_2"] = "icfals_2.sitem", ["uiR2EDequipment_icfals_3"] = "icfals_3.sitem", }, gloves = { ["uiR2EDequipment_icfalg_2"] = "icfalg_2.sitem", ["uiR2EDequipment_icfalg_3"] = "icfalg_3.sitem", }, right_hand = { ["uiR2EDequipment_icfm2ms_2"] = "icfm2ms_2.sitem", ["uiR2EDequipment_icfm2ms_3"] = "icfm2ms_3.sitem", }, left_hand = { ["uiR2EDequipment_none"] = "", }, } r2.addR2PlayerEquipment(entries.f_healer_220, entries.f_healer_220_equipment)
	entries.m_healer_220_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icmalv_2"] = "icmalv_2.sitem", ["uiR2EDequipment_icmalv_3"] = "icmalv_3.sitem", }, legs = { ["uiR2EDequipment_icm_2"] = "icm_2.sitem", ["uiR2EDequipment_icm_3"] = "icm_3.sitem", }, boots = { ["uiR2EDequipment_icmalb_2"] = "icmalb_2.sitem", ["uiR2EDequipment_icmalb_3"] = "icmalb_3.sitem", }, arms_guard = { ["uiR2EDequipment_icmals_2"] = "icmals_2.sitem", ["uiR2EDequipment_icmals_3"] = "icmals_3.sitem", }, gloves = { ["uiR2EDequipment_icmalg_2"] = "icmalg_2.sitem", ["uiR2EDequipment_icmalg_3"] = "icmalg_3.sitem", }, right_hand = { ["uiR2EDequipment_icmm2ms_2"] = "icmm2ms_2.sitem", ["uiR2EDequipment_icmm2ms_3"] = "icmm2ms_3.sitem", }, left_hand = { ["uiR2EDequipment_none"] = "", }, } r2.addR2PlayerEquipment(entries.m_healer_220, entries.m_healer_220_equipment)
	entries.t_healer_220_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_ictalv_2"] = "ictalv_2.sitem", ["uiR2EDequipment_ictalv_3"] = "ictalv_3.sitem", }, legs = { ["uiR2EDequipment_ict_2"] = "ict_2.sitem", ["uiR2EDequipment_ict_3"] = "ict_3.sitem", }, boots = { ["uiR2EDequipment_ictalb_2"] = "ictalb_2.sitem", ["uiR2EDequipment_ictalb_3"] = "ictalb_3.sitem", }, arms_guard = { ["uiR2EDequipment_ictals_2"] = "ictals_2.sitem", ["uiR2EDequipment_ictals_3"] = "ictals_3.sitem", }, gloves = { ["uiR2EDequipment_ictalg_2"] = "ictalg_2.sitem", ["uiR2EDequipment_ictalg_3"] = "ictalg_3.sitem", }, right_hand = { ["uiR2EDequipment_ictm2ms_2"] = "ictm2ms_2.sitem", ["uiR2EDequipment_ictm2ms_3"] = "ictm2ms_3.sitem", }, left_hand = { ["uiR2EDequipment_none"] = "", }, } r2.addR2PlayerEquipment(entries.t_healer_220, entries.t_healer_220_equipment)
	entries.z_healer_220_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_iczalv_2"] = "iczalv_2.sitem", ["uiR2EDequipment_iczalv_3"] = "iczalv_3.sitem", }, legs = { ["uiR2EDequipment_icz_2"] = "icz_2.sitem", ["uiR2EDequipment_icz_3"] = "icz_3.sitem", }, boots = { ["uiR2EDequipment_iczalb_2"] = "iczalb_2.sitem", ["uiR2EDequipment_iczalb_3"] = "iczalb_3.sitem", }, arms_guard = { ["uiR2EDequipment_iczals_2"] = "iczals_2.sitem", ["uiR2EDequipment_iczals_3"] = "iczals_3.sitem", }, gloves = { ["uiR2EDequipment_iczalg_2"] = "iczalg_2.sitem", ["uiR2EDequipment_iczalg_3"] = "iczalg_3.sitem", }, right_hand = { ["uiR2EDequipment_iczm2ms_2"] = "iczm2ms_2.sitem", ["uiR2EDequipment_iczm2ms_3"] = "iczm2ms_3.sitem", }, left_hand = { ["uiR2EDequipment_none"] = "", }, } r2.addR2PlayerEquipment(entries.z_healer_220, entries.z_healer_220_equipment)


-- Damage Dealers

	entries.f_mage_damage_dealer_20 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_damage_dealer_acid_b2.creature", SheetModel="ring_magic_damage_dealer_$hands_b$level.creature", SheetClient="basic_fyros_male.creature", Level=20, RingAccess="a1", Equipment="f_mage_damage_dealer_20_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.f_mage_damage_dealer_20", entries.f_mage_damage_dealer_20)
	entries.m_mage_damage_dealer_20 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_damage_dealer_acid_b2.creature", SheetModel="ring_magic_damage_dealer_$hands_b$level.creature", SheetClient="basic_matis_male.creature", Level=20, RingAccess="a1", Equipment="m_mage_damage_dealer_20_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.m_mage_damage_dealer_20", entries.m_mage_damage_dealer_20)
	entries.t_mage_damage_dealer_20 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_damage_dealer_cold_b2.creature", SheetModel="ring_magic_damage_dealer_$hands_b$level.creature", SheetClient="basic_tryker_male.creature", Level=20, RingAccess="a1", Equipment="t_mage_damage_dealer_20_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.t_mage_damage_dealer_20", entries.t_mage_damage_dealer_20)
	entries.z_mage_damage_dealer_20 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_damage_dealer_rot_b2.creature", SheetModel="ring_magic_damage_dealer_$hands_b$level.creature", SheetClient="basic_zorai_male.creature", Level=20, RingAccess="a1", Equipment="z_mage_damage_dealer_20_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.z_mage_damage_dealer_20", entries.z_mage_damage_dealer_20)

	entries.f_mage_damage_dealer_70 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_damage_dealer_acid_c2.creature", SheetModel="ring_magic_damage_dealer_$hands_c$level.creature", SheetClient="basic_fyros_male.creature", Level=70, RingAccess="d2", Equipment="f_mage_damage_dealer_70_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.f_mage_damage_dealer_70", entries.f_mage_damage_dealer_70)
	entries.m_mage_damage_dealer_70 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_damage_dealer_acid_c2.creature", SheetModel="ring_magic_damage_dealer_$hands_c$level.creature", SheetClient="basic_matis_male.creature", Level=70, RingAccess="f5", Equipment="m_mage_damage_dealer_70_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.m_mage_damage_dealer_70", entries.m_mage_damage_dealer_70)
	entries.t_mage_damage_dealer_70 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_damage_dealer_cold_c2.creature", SheetModel="ring_magic_damage_dealer_$hands_c$level.creature", SheetClient="basic_tryker_male.creature", Level=70, RingAccess="l5", Equipment="t_mage_damage_dealer_70_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.t_mage_damage_dealer_70", entries.t_mage_damage_dealer_70)
	entries.z_mage_damage_dealer_70 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_damage_dealer_rot_c2.creature", SheetModel="ring_magic_damage_dealer_$hands_c$level.creature", SheetClient="basic_zorai_male.creature", Level=70, RingAccess="j5", Equipment="z_mage_damage_dealer_70_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.z_mage_damage_dealer_70", entries.z_mage_damage_dealer_70)

	entries.f_mage_damage_dealer_120 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_damage_dealer_fire_d2.creature", SheetModel="ring_magic_damage_dealer_$hands_d$level.creature", SheetClient="basic_fyros_male.creature", Level=120, RingAccess="d4", Equipment="f_mage_damage_dealer_120_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.f_mage_damage_dealer_120", entries.f_mage_damage_dealer_120)
	entries.m_mage_damage_dealer_120 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_damage_dealer_poison_d2.creature", SheetModel="ring_magic_damage_dealer_$hands_d$level.creature", SheetClient="basic_matis_male.creature", Level=120, RingAccess="f5", Equipment="m_mage_damage_dealer_120_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.m_mage_damage_dealer_120", entries.m_mage_damage_dealer_120)
	entries.t_mage_damage_dealer_120 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_damage_dealer_shockwave_d2.creature", SheetModel="ring_magic_damage_dealer_$hands_d$level.creature", SheetClient="basic_tryker_male.creature", Level=120, RingAccess="l5", Equipment="t_mage_damage_dealer_120_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.t_mage_damage_dealer_120", entries.t_mage_damage_dealer_120)
	entries.z_mage_damage_dealer_120 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_damage_dealer_electricity_d2.creature", SheetModel="ring_magic_damage_dealer_$hands_d$level.creature", SheetClient="basic_zorai_male.creature", Level=120, RingAccess="j5", Equipment="z_mage_damage_dealer_120_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.z_mage_damage_dealer_120", entries.z_mage_damage_dealer_120)

	entries.f_mage_damage_dealer_170 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_damage_dealer_fire_e2.creature", SheetModel="ring_magic_damage_dealer_$hands_e$level.creature", SheetClient="basic_fyros_male.creature", Level=170, RingAccess="d6", Equipment="f_mage_damage_dealer_170_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.f_mage_damage_dealer_170", entries.f_mage_damage_dealer_170)
	entries.m_mage_damage_dealer_170 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_damage_dealer_poison_e2.creature", SheetModel="ring_magic_damage_dealer_$hands_e$level.creature", SheetClient="basic_matis_male.creature", Level=170, RingAccess="f6", Equipment="m_mage_damage_dealer_170_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.m_mage_damage_dealer_170", entries.m_mage_damage_dealer_170)
	entries.t_mage_damage_dealer_170 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_damage_dealer_shockwave_e2.creature", SheetModel="ring_magic_damage_dealer_$hands_e$level.creature", SheetClient="basic_tryker_male.creature", Level=170, RingAccess="l5", Equipment="t_mage_damage_dealer_170_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.t_mage_damage_dealer_170", entries.t_mage_damage_dealer_170)
	entries.z_mage_damage_dealer_170 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_damage_dealer_electricity_e2.creature", SheetModel="ring_magic_damage_dealer_$hands_e$level.creature", SheetClient="basic_zorai_male.creature", Level=170, RingAccess="j6", Equipment="z_mage_damage_dealer_170_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.z_mage_damage_dealer_170", entries.z_mage_damage_dealer_170)

	entries.f_mage_damage_dealer_220 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_damage_dealer_fire_f2.creature", SheetModel="ring_magic_damage_dealer_$hands_f$level.creature", SheetClient="basic_fyros_male.creature", Level=220, RingAccess="d7", Equipment="f_mage_damage_dealer_220_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.f_mage_damage_dealer_220", entries.f_mage_damage_dealer_220)
	entries.m_mage_damage_dealer_220 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_damage_dealer_poison_f2.creature", SheetModel="ring_magic_damage_dealer_$hands_f$level.creature", SheetClient="basic_matis_male.creature", Level=220, RingAccess="f7", Equipment="m_mage_damage_dealer_220_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.m_mage_damage_dealer_220", entries.m_mage_damage_dealer_220)
	entries.t_mage_damage_dealer_220 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_damage_dealer_shockwave_f2.creature", SheetModel="ring_magic_damage_dealer_$hands_f$level.creature", SheetClient="basic_tryker_male.creature", Level=220, RingAccess="l6", Equipment="t_mage_damage_dealer_220_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.t_mage_damage_dealer_220", entries.t_mage_damage_dealer_220)
	entries.z_mage_damage_dealer_220 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_damage_dealer_electricity_f2.creature", SheetModel="ring_magic_damage_dealer_$hands_f$level.creature", SheetClient="basic_zorai_male.creature", Level=220, RingAccess="j7", Equipment="z_mage_damage_dealer_220_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.z_mage_damage_dealer_220", entries.z_mage_damage_dealer_220)


	entries.f_mage_damage_dealer_20_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icfalv"] = "icfalv.sitem", }, legs = { ["uiR2EDequipment_icfalp"] = "icfalp.sitem", }, boots = { ["uiR2EDequipment_icfalb"] = "icfalb.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", }, gloves = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icfalg"] = "icfalg.sitem", }, hands = { ["uiR2EDequipment_acid"] = "icfm2ms.sitem::acid", ["uiR2EDequipment_cold"] = "icfm2ms.sitem::cold", ["uiR2EDequipment_rot"] = "icfm2ms.sitem::rot",  }, } r2.addR2PlayerEquipment(entries.f_mage_damage_dealer_20, entries.f_mage_damage_dealer_20_equipment)
	entries.m_mage_damage_dealer_20_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icmalv"] = "icmalv.sitem", }, legs = { ["uiR2EDequipment_icmalp"] = "icmalp.sitem", }, boots = { ["uiR2EDequipment_icmalb"] = "icmalb.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", }, gloves = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icmalg"] = "icmalg.sitem", }, hands = { ["uiR2EDequipment_acid"] = "icmm2ms.sitem::acid", ["uiR2EDequipment_cold"] = "icmm2ms.sitem::cold", ["uiR2EDequipment_rot"] = "icmm2ms.sitem::rot",  }, } r2.addR2PlayerEquipment(entries.m_mage_damage_dealer_20, entries.m_mage_damage_dealer_20_equipment)
	entries.t_mage_damage_dealer_20_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_ictalv"] = "ictalv.sitem", }, legs = { ["uiR2EDequipment_ictalp"] = "ictalp.sitem", }, boots = { ["uiR2EDequipment_ictalb"] = "ictalb.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", }, gloves = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_ictalg"] = "ictalg.sitem", }, hands = { ["uiR2EDequipment_acid"] = "ictm2ms.sitem::acid", ["uiR2EDequipment_cold"] = "ictm2ms.sitem::cold", ["uiR2EDequipment_rot"] = "ictm2ms.sitem::rot",  }, } r2.addR2PlayerEquipment(entries.t_mage_damage_dealer_20, entries.t_mage_damage_dealer_20_equipment)
	entries.z_mage_damage_dealer_20_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_iczalv"] = "iczalv.sitem", }, legs = { ["uiR2EDequipment_iczalp"] = "iczalp.sitem", }, boots = { ["uiR2EDequipment_iczalb"] = "iczalb.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", }, gloves = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_iczalg"] = "iczalg.sitem", }, hands = { ["uiR2EDequipment_acid"] = "iczm2ms.sitem::acid", ["uiR2EDequipment_cold"] = "iczm2ms.sitem::cold", ["uiR2EDequipment_rot"] = "iczm2ms.sitem::rot",  }, } r2.addR2PlayerEquipment(entries.z_mage_damage_dealer_20, entries.z_mage_damage_dealer_20_equipment)

	entries.f_mage_damage_dealer_70_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icfalv"] = "icfalv.sitem", ["uiR2EDequipment_icfalv_2"] = "icfalv_2.sitem", }, legs = { ["uiR2EDequipment_icfalp"] = "icfalp.sitem", ["uiR2EDequipment_icfalp_2"] = "icfalp_2.sitem", }, boots = { ["uiR2EDequipment_icfalb"] = "icfalb.sitem", ["uiR2EDequipment_icfalb_2"] = "icfalb_2.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", }, gloves = { ["uiR2EDequipment_icfalg"] = "icfalg.sitem", ["uiR2EDequipment_icfalg_2"] = "icfalg_2.sitem", }, hands = { ["uiR2EDequipment_acid"] = "icfm2ms_2.sitem::acid", ["uiR2EDequipment_cold"] = "icfm2ms_2.sitem::cold", ["uiR2EDequipment_rot"] = "icfm2ms_2.sitem::rot",  }, } r2.addR2PlayerEquipment(entries.f_mage_damage_dealer_70, entries.f_mage_damage_dealer_70_equipment)
	entries.m_mage_damage_dealer_70_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icmalv"] = "icmalv.sitem", ["uiR2EDequipment_icmalv_2"] = "icmalv_2.sitem", }, legs = { ["uiR2EDequipment_icmalp"] = "icmalp.sitem", ["uiR2EDequipment_icmalp_2"] = "icmalp_2.sitem", }, boots = { ["uiR2EDequipment_icmalb"] = "icmalb.sitem", ["uiR2EDequipment_icmalb_2"] = "icmalb_2.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", }, gloves = { ["uiR2EDequipment_icmalg"] = "icmalg.sitem", ["uiR2EDequipment_icmalg_2"] = "icmalg_2.sitem", }, hands = { ["uiR2EDequipment_acid"] = "icmm2ms_2.sitem::acid", ["uiR2EDequipment_cold"] = "icmm2ms_2.sitem::cold", ["uiR2EDequipment_rot"] = "icmm2ms_2.sitem::rot",  }, } r2.addR2PlayerEquipment(entries.m_mage_damage_dealer_70, entries.m_mage_damage_dealer_70_equipment)
	entries.t_mage_damage_dealer_70_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_ictalv"] = "ictalv.sitem", ["uiR2EDequipment_ictalv_2"] = "ictalv_2.sitem", }, legs = { ["uiR2EDequipment_ictalp"] = "ictalp.sitem", ["uiR2EDequipment_ictalp_2"] = "ictalp_2.sitem", }, boots = { ["uiR2EDequipment_ictalb"] = "ictalb.sitem", ["uiR2EDequipment_ictalb_2"] = "ictalb_2.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", }, gloves = { ["uiR2EDequipment_ictalg"] = "ictalg.sitem", ["uiR2EDequipment_ictalg_2"] = "ictalg_2.sitem", }, hands = { ["uiR2EDequipment_acid"] = "ictm2ms_2.sitem::acid", ["uiR2EDequipment_cold"] = "ictm2ms_2.sitem::cold", ["uiR2EDequipment_rot"] = "ictm2ms_2.sitem::rot",  }, } r2.addR2PlayerEquipment(entries.t_mage_damage_dealer_70, entries.t_mage_damage_dealer_70_equipment)
	entries.z_mage_damage_dealer_70_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_iczalv"] = "iczalv.sitem", ["uiR2EDequipment_iczalv_2"] = "iczalv_2.sitem", }, legs = { ["uiR2EDequipment_iczalp"] = "iczalp.sitem", ["uiR2EDequipment_iczalp_2"] = "iczalp_2.sitem", }, boots = { ["uiR2EDequipment_iczalb"] = "iczalb.sitem", ["uiR2EDequipment_iczalb_2"] = "iczalb_2.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", }, gloves = { ["uiR2EDequipment_iczalg"] = "iczalg.sitem", ["uiR2EDequipment_iczalg_2"] = "iczalg_2.sitem", }, hands = { ["uiR2EDequipment_acid"] = "iczm2ms_2.sitem::acid", ["uiR2EDequipment_cold"] = "iczm2ms_2.sitem::cold", ["uiR2EDequipment_rot"] = "iczm2ms_2.sitem::rot",  }, } r2.addR2PlayerEquipment(entries.z_mage_damage_dealer_70, entries.z_mage_damage_dealer_70_equipment)

	entries.f_mage_damage_dealer_120_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icfalv"] = "icfalv.sitem", ["uiR2EDequipment_icfalv_2"] = "icfalv_2.sitem", }, legs = { ["uiR2EDequipment_icfalp"] = "icfalp.sitem", ["uiR2EDequipment_icfalp_2"] = "icfalp_2.sitem", }, boots = { ["uiR2EDequipment_icfalb"] = "icfalb.sitem", ["uiR2EDequipment_icfalb_2"] = "icfalb_2.sitem", }, arms_guard = { ["uiR2EDequipment_icfals"] = "icfals.sitem", ["uiR2EDequipment_icfals_2"] = "icfals_2.sitem", }, gloves = { ["uiR2EDequipment_icfalg"] = "icfalg.sitem", ["uiR2EDequipment_icfalg_2"] = "icfalg_2.sitem", }, hands = { ["uiR2EDequipment_acid"] = "icfm2ms_2.sitem::acid", ["uiR2EDequipment_cold"] = "icfm2ms_2.sitem::cold", ["uiR2EDequipment_rot"] = "icfm2ms_2.sitem::rot", ["uiR2EDequipment_fire"] = "icfm2ms_2.sitem::fire",  }, } r2.addR2PlayerEquipment(entries.f_mage_damage_dealer_120, entries.f_mage_damage_dealer_120_equipment)
	entries.m_mage_damage_dealer_120_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icmalv"] = "icmalv.sitem", ["uiR2EDequipment_icmalv_2"] = "icmalv_2.sitem", }, legs = { ["uiR2EDequipment_icmalp"] = "icmalp.sitem", ["uiR2EDequipment_icmalp_2"] = "icmalp_2.sitem", }, boots = { ["uiR2EDequipment_icmalb"] = "icmalb.sitem", ["uiR2EDequipment_icmalb_2"] = "icmalb_2.sitem", }, arms_guard = { ["uiR2EDequipment_icmals"] = "icmals.sitem", ["uiR2EDequipment_icmals_2"] = "icmals_2.sitem", }, gloves = { ["uiR2EDequipment_icmalg"] = "icmalg.sitem", ["uiR2EDequipment_icmalg_2"] = "icmalg_2.sitem", }, hands = { ["uiR2EDequipment_acid"] = "icmm2ms_2.sitem::acid", ["uiR2EDequipment_cold"] = "icmm2ms_2.sitem::cold", ["uiR2EDequipment_rot"] = "icmm2ms_2.sitem::rot", ["uiR2EDequipment_poison"] = "icmm2ms_2.sitem::poison",  }, } r2.addR2PlayerEquipment(entries.m_mage_damage_dealer_120, entries.m_mage_damage_dealer_120_equipment)
	entries.t_mage_damage_dealer_120_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_ictalv"] = "ictalv.sitem", ["uiR2EDequipment_ictalv_2"] = "ictalv_2.sitem", }, legs = { ["uiR2EDequipment_ictalp"] = "ictalp.sitem", ["uiR2EDequipment_ictalp_2"] = "ictalp_2.sitem", }, boots = { ["uiR2EDequipment_ictalb"] = "ictalb.sitem", ["uiR2EDequipment_ictalb_2"] = "ictalb_2.sitem", }, arms_guard = { ["uiR2EDequipment_ictals"] = "ictals.sitem", ["uiR2EDequipment_ictals_2"] = "ictals_2.sitem", }, gloves = { ["uiR2EDequipment_ictalg"] = "ictalg.sitem", ["uiR2EDequipment_ictalg_2"] = "ictalg_2.sitem", }, hands = { ["uiR2EDequipment_acid"] = "ictm2ms_2.sitem::acid", ["uiR2EDequipment_cold"] = "ictm2ms_2.sitem::cold", ["uiR2EDequipment_rot"] = "ictm2ms_2.sitem::rot", ["uiR2EDequipment_shockwave"] = "ictm2ms_2.sitem::shockwave",  }, } r2.addR2PlayerEquipment(entries.t_mage_damage_dealer_120, entries.t_mage_damage_dealer_120_equipment)
	entries.z_mage_damage_dealer_120_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_iczalv"] = "iczalv.sitem", ["uiR2EDequipment_iczalv_2"] = "iczalv_2.sitem", }, legs = { ["uiR2EDequipment_iczalp"] = "iczalp.sitem", ["uiR2EDequipment_iczalp_2"] = "iczalp_2.sitem", }, boots = { ["uiR2EDequipment_iczalb"] = "iczalb.sitem", ["uiR2EDequipment_iczalb_2"] = "iczalb_2.sitem", }, arms_guard = { ["uiR2EDequipment_iczals"] = "iczals.sitem", ["uiR2EDequipment_iczals_2"] = "iczals_2.sitem", }, gloves = { ["uiR2EDequipment_iczalg"] = "iczalg.sitem", ["uiR2EDequipment_iczalg_2"] = "iczalg_2.sitem", }, hands = { ["uiR2EDequipment_acid"] = "iczm2ms_2.sitem::acid", ["uiR2EDequipment_cold"] = "iczm2ms_2.sitem::cold", ["uiR2EDequipment_rot"] = "iczm2ms_2.sitem::rot", ["uiR2EDequipment_electricity"] = "iczm2ms_2.sitem::electricity",  }, } r2.addR2PlayerEquipment(entries.z_mage_damage_dealer_120, entries.z_mage_damage_dealer_120_equipment)

	entries.f_mage_damage_dealer_170_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icfalv_2"] = "icfalv_2.sitem", ["uiR2EDequipment_icfalv_3"] = "icfalv_3.sitem", }, legs = { ["uiR2EDequipment_icfalp_2"] = "icfalp_2.sitem", ["uiR2EDequipment_icfalp_3"] = "icfalp_3.sitem", }, boots = { ["uiR2EDequipment_icfalb_2"] = "icfalb_2.sitem", ["uiR2EDequipment_icfalb_3"] = "icfalb_3.sitem", }, arms_guard = { ["uiR2EDequipment_icfals_2"] = "icfals_2.sitem", ["uiR2EDequipment_icfals_3"] = "icfals_3.sitem", }, gloves = { ["uiR2EDequipment_icfalg_2"] = "icfalg_2.sitem", ["uiR2EDequipment_icfalg_3"] = "icfalg_3.sitem", }, hands = { ["uiR2EDequipment_acid"] = "icfm2ms_3.sitem::acid", ["uiR2EDequipment_cold"] = "icfm2ms_3.sitem::cold", ["uiR2EDequipment_rot"] = "icfm2ms_3.sitem::rot", ["uiR2EDequipment_fire"] = "icfm2ms_3.sitem::fire",  }, } r2.addR2PlayerEquipment(entries.f_mage_damage_dealer_170, entries.f_mage_damage_dealer_170_equipment)
	entries.m_mage_damage_dealer_170_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icmalv_2"] = "icmalv_2.sitem", ["uiR2EDequipment_icmalv_3"] = "icmalv_3.sitem", }, legs = { ["uiR2EDequipment_icmalp_2"] = "icmalp_2.sitem", ["uiR2EDequipment_icmalp_3"] = "icmalp_3.sitem", }, boots = { ["uiR2EDequipment_icmalb_2"] = "icmalb_2.sitem", ["uiR2EDequipment_icmalb_3"] = "icmalb_3.sitem", }, arms_guard = { ["uiR2EDequipment_icmals_2"] = "icmals_2.sitem", ["uiR2EDequipment_icmals_3"] = "icmals_3.sitem", }, gloves = { ["uiR2EDequipment_icmalg_2"] = "icmalg_2.sitem", ["uiR2EDequipment_icmalg_3"] = "icmalg_3.sitem", }, hands = { ["uiR2EDequipment_acid"] = "icmm2ms_3.sitem::acid", ["uiR2EDequipment_cold"] = "icmm2ms_3.sitem::cold", ["uiR2EDequipment_rot"] = "icmm2ms_3.sitem::rot", ["uiR2EDequipment_poison"] = "icmm2ms_3.sitem::poison",  }, } r2.addR2PlayerEquipment(entries.m_mage_damage_dealer_170, entries.m_mage_damage_dealer_170_equipment)
	entries.t_mage_damage_dealer_170_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_ictalv_2"] = "ictalv_2.sitem", ["uiR2EDequipment_ictalv_3"] = "ictalv_3.sitem", }, legs = { ["uiR2EDequipment_ictalp_2"] = "ictalp_2.sitem", ["uiR2EDequipment_ictalp_3"] = "ictalp_3.sitem", }, boots = { ["uiR2EDequipment_ictalb_2"] = "ictalb_2.sitem", ["uiR2EDequipment_ictalb_3"] = "ictalb_3.sitem", }, arms_guard = { ["uiR2EDequipment_ictals_2"] = "ictals_2.sitem", ["uiR2EDequipment_ictals_3"] = "ictals_3.sitem", }, gloves = { ["uiR2EDequipment_ictalg_2"] = "ictalg_2.sitem", ["uiR2EDequipment_ictalg_3"] = "ictalg_3.sitem", }, hands = { ["uiR2EDequipment_acid"] = "ictm2ms_3.sitem::acid", ["uiR2EDequipment_cold"] = "ictm2ms_3.sitem::cold", ["uiR2EDequipment_rot"] = "ictm2ms_3.sitem::rot", ["uiR2EDequipment_shockwave"] = "ictm2ms_3.sitem::shockwave",  }, } r2.addR2PlayerEquipment(entries.t_mage_damage_dealer_170, entries.t_mage_damage_dealer_170_equipment)
	entries.z_mage_damage_dealer_170_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_iczalv_2"] = "iczalv_2.sitem", ["uiR2EDequipment_iczalv_3"] = "iczalv_3.sitem", }, legs = { ["uiR2EDequipment_iczalp_2"] = "iczalp_2.sitem", ["uiR2EDequipment_iczalp_3"] = "iczalp_3.sitem", }, boots = { ["uiR2EDequipment_iczalb_2"] = "iczalb_2.sitem", ["uiR2EDequipment_iczalb_3"] = "iczalb_3.sitem", }, arms_guard = { ["uiR2EDequipment_iczals_2"] = "iczals_2.sitem", ["uiR2EDequipment_iczals_3"] = "iczals_3.sitem", }, gloves = { ["uiR2EDequipment_iczalg_2"] = "iczalg_2.sitem", ["uiR2EDequipment_iczalg_3"] = "iczalg_3.sitem", }, hands = { ["uiR2EDequipment_acid"] = "iczm2ms_3.sitem::acid", ["uiR2EDequipment_cold"] = "iczm2ms_3.sitem::cold", ["uiR2EDequipment_rot"] = "iczm2ms_3.sitem::rot", ["uiR2EDequipment_electricity"] = "iczm2ms_3.sitem::electricity",  }, } r2.addR2PlayerEquipment(entries.z_mage_damage_dealer_170, entries.z_mage_damage_dealer_170_equipment)

	entries.f_mage_damage_dealer_220_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icfalv_2"] = "icfalv_2.sitem", ["uiR2EDequipment_icfalv_3"] = "icfalv_3.sitem", }, legs = { ["uiR2EDequipment_icfalp_2"] = "icfalp_2.sitem", ["uiR2EDequipment_icfalp_3"] = "icfalp_3.sitem", }, boots = { ["uiR2EDequipment_icfalb_2"] = "icfalb_2.sitem", ["uiR2EDequipment_icfalb_3"] = "icfalb_3.sitem", }, arms_guard = { ["uiR2EDequipment_icfals_2"] = "icfals_2.sitem", ["uiR2EDequipment_icfals_3"] = "icfals_3.sitem", }, gloves = { ["uiR2EDequipment_icfalg_2"] = "icfalg_2.sitem", ["uiR2EDequipment_icfalg_3"] = "icfalg_3.sitem", }, hands = { ["uiR2EDequipment_acid"] = "icfm2ms_3.sitem::acid", ["uiR2EDequipment_cold"] = "icfm2ms_3.sitem::cold", ["uiR2EDequipment_rot"] = "icfm2ms_3.sitem::rot", ["uiR2EDequipment_fire"] = "icfm2ms_3.sitem::fire",  }, } r2.addR2PlayerEquipment(entries.f_mage_damage_dealer_220, entries.f_mage_damage_dealer_220_equipment)
	entries.m_mage_damage_dealer_220_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icmalv_2"] = "icmalv_2.sitem", ["uiR2EDequipment_icmalv_3"] = "icmalv_3.sitem", }, legs = { ["uiR2EDequipment_icmalp_2"] = "icmalp_2.sitem", ["uiR2EDequipment_icmalp_3"] = "icmalp_3.sitem", }, boots = { ["uiR2EDequipment_icmalb_2"] = "icmalb_2.sitem", ["uiR2EDequipment_icmalb_3"] = "icmalb_3.sitem", }, arms_guard = { ["uiR2EDequipment_icmals_2"] = "icmals_2.sitem", ["uiR2EDequipment_icmals_3"] = "icmals_3.sitem", }, gloves = { ["uiR2EDequipment_icmalg_2"] = "icmalg_2.sitem", ["uiR2EDequipment_icmalg_3"] = "icmalg_3.sitem", }, hands = { ["uiR2EDequipment_acid"] = "icmm2ms_3.sitem::acid", ["uiR2EDequipment_cold"] = "icmm2ms_3.sitem::cold", ["uiR2EDequipment_rot"] = "icmm2ms_3.sitem::rot", ["uiR2EDequipment_poison"] = "icmm2ms_3.sitem::poison",  }, } r2.addR2PlayerEquipment(entries.m_mage_damage_dealer_220, entries.m_mage_damage_dealer_220_equipment)
	entries.t_mage_damage_dealer_220_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_ictalv_2"] = "ictalv_2.sitem", ["uiR2EDequipment_ictalv_3"] = "ictalv_3.sitem", }, legs = { ["uiR2EDequipment_ictalp_2"] = "ictalp_2.sitem", ["uiR2EDequipment_ictalp_3"] = "ictalp_3.sitem", }, boots = { ["uiR2EDequipment_ictalb_2"] = "ictalb_2.sitem", ["uiR2EDequipment_ictalb_3"] = "ictalb_3.sitem", }, arms_guard = { ["uiR2EDequipment_ictals_2"] = "ictals_2.sitem", ["uiR2EDequipment_ictals_3"] = "ictals_3.sitem", }, gloves = { ["uiR2EDequipment_ictalg_2"] = "ictalg_2.sitem", ["uiR2EDequipment_ictalg_3"] = "ictalg_3.sitem", }, hands = { ["uiR2EDequipment_acid"] = "ictm2ms_3.sitem::acid", ["uiR2EDequipment_cold"] = "ictm2ms_3.sitem::cold", ["uiR2EDequipment_rot"] = "ictm2ms_3.sitem::rot", ["uiR2EDequipment_shockwave"] = "ictm2ms_3.sitem::shockwave",  }, } r2.addR2PlayerEquipment(entries.t_mage_damage_dealer_220, entries.t_mage_damage_dealer_220_equipment)
	entries.z_mage_damage_dealer_220_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_iczalv_2"] = "iczalv_2.sitem", ["uiR2EDequipment_iczalv_3"] = "iczalv_3.sitem", }, legs = { ["uiR2EDequipment_iczalp_2"] = "iczalp_2.sitem", ["uiR2EDequipment_iczalp_3"] = "iczalp_3.sitem", }, boots = { ["uiR2EDequipment_iczalb_2"] = "iczalb_2.sitem", ["uiR2EDequipment_iczalb_3"] = "iczalb_3.sitem", }, arms_guard = { ["uiR2EDequipment_iczals_2"] = "iczals_2.sitem", ["uiR2EDequipment_iczals_3"] = "iczals_3.sitem", }, gloves = { ["uiR2EDequipment_iczalg_2"] = "iczalg_2.sitem", ["uiR2EDequipment_iczalg_3"] = "iczalg_3.sitem", }, hands = { ["uiR2EDequipment_acid"] = "iczm2ms_3.sitem::acid", ["uiR2EDequipment_cold"] = "iczm2ms_3.sitem::cold", ["uiR2EDequipment_rot"] = "iczm2ms_3.sitem::rot", ["uiR2EDequipment_electricity"] = "iczm2ms_3.sitem::electricity",  }, } r2.addR2PlayerEquipment(entries.z_mage_damage_dealer_220, entries.z_mage_damage_dealer_220_equipment)



-- AOE

	entries.f_mage_aoe_20 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_aoe_acid_b2.creature", SheetModel="ring_magic_aoe_$hands_b$level.creature", SheetClient="basic_fyros_male.creature", Level=20, RingAccess="a1", Equipment="f_mage_aoe_20_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.f_mage_aoe_20", entries.f_mage_aoe_20)
	entries.m_mage_aoe_20 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_aoe_acid_b2.creature", SheetModel="ring_magic_aoe_$hands_b$level.creature", SheetClient="basic_matis_male.creature", Level=20, RingAccess="a1", Equipment="m_mage_aoe_20_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.m_mage_aoe_20", entries.m_mage_aoe_20)
	entries.t_mage_aoe_20 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_aoe_cold_b2.creature", SheetModel="ring_magic_aoe_$hands_b$level.creature", SheetClient="basic_tryker_male.creature", Level=20, RingAccess="a1", Equipment="t_mage_aoe_20_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.t_mage_aoe_20", entries.t_mage_aoe_20)
	entries.z_mage_aoe_20 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_aoe_rot_b2.creature", SheetModel="ring_magic_aoe_$hands_b$level.creature", SheetClient="basic_zorai_male.creature", Level=20, RingAccess="a1", Equipment="z_mage_aoe_20_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.z_mage_aoe_20", entries.z_mage_aoe_20)

	entries.f_mage_aoe_70 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_aoe_acid_c2.creature", SheetModel="ring_magic_aoe_$hands_c$level.creature", SheetClient="basic_fyros_male.creature", Level=70, RingAccess="d2", Equipment="f_mage_aoe_70_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.f_mage_aoe_70", entries.f_mage_aoe_70)
	entries.m_mage_aoe_70 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_aoe_acid_c2.creature", SheetModel="ring_magic_aoe_$hands_c$level.creature", SheetClient="basic_matis_male.creature", Level=70, RingAccess="f5", Equipment="m_mage_aoe_70_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.m_mage_aoe_70", entries.m_mage_aoe_70)
	entries.t_mage_aoe_70 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_aoe_cold_c2.creature", SheetModel="ring_magic_aoe_$hands_c$level.creature", SheetClient="basic_tryker_male.creature", Level=70, RingAccess="l5", Equipment="t_mage_aoe_70_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.t_mage_aoe_70", entries.t_mage_aoe_70)
	entries.z_mage_aoe_70 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_aoe_rot_c2.creature", SheetModel="ring_magic_aoe_$hands_c$level.creature", SheetClient="basic_zorai_male.creature", Level=70, RingAccess="j5", Equipment="z_mage_aoe_70_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.z_mage_aoe_70", entries.z_mage_aoe_70)

	entries.f_mage_aoe_120 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_aoe_fire_d2.creature", SheetModel="ring_magic_aoe_$hands_d$level.creature", SheetClient="basic_fyros_male.creature", Level=120, RingAccess="d4", Equipment="f_mage_aoe_120_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.f_mage_aoe_120", entries.f_mage_aoe_120)
	entries.m_mage_aoe_120 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_aoe_poison_d2.creature", SheetModel="ring_magic_aoe_$hands_d$level.creature", SheetClient="basic_matis_male.creature", Level=120, RingAccess="f5", Equipment="m_mage_aoe_120_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.m_mage_aoe_120", entries.m_mage_aoe_120)
	entries.t_mage_aoe_120 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_aoe_shockwave_d2.creature", SheetModel="ring_magic_aoe_$hands_d$level.creature", SheetClient="basic_tryker_male.creature", Level=120, RingAccess="l5", Equipment="t_mage_aoe_120_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.t_mage_aoe_120", entries.t_mage_aoe_120)
	entries.z_mage_aoe_120 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_aoe_electricity_d2.creature", SheetModel="ring_magic_aoe_$hands_d$level.creature", SheetClient="basic_zorai_male.creature", Level=120, RingAccess="j5", Equipment="z_mage_aoe_120_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.z_mage_aoe_120", entries.z_mage_aoe_120)

	entries.f_mage_aoe_170 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_aoe_fire_e2.creature", SheetModel="ring_magic_aoe_$hands_e$level.creature", SheetClient="basic_fyros_male.creature", Level=170, RingAccess="d6", Equipment="f_mage_aoe_170_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.f_mage_aoe_170", entries.f_mage_aoe_170)
	entries.m_mage_aoe_170 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_aoe_poison_e2.creature", SheetModel="ring_magic_aoe_$hands_e$level.creature", SheetClient="basic_matis_male.creature", Level=170, RingAccess="f6", Equipment="m_mage_aoe_170_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.m_mage_aoe_170", entries.m_mage_aoe_170)
	entries.t_mage_aoe_170 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_aoe_shockwave_e2.creature", SheetModel="ring_magic_aoe_$hands_e$level.creature", SheetClient="basic_tryker_male.creature", Level=170, RingAccess="l5", Equipment="t_mage_aoe_170_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.t_mage_aoe_170", entries.t_mage_aoe_170)
	entries.z_mage_aoe_170 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_aoe_electricity_e2.creature", SheetModel="ring_magic_aoe_$hands_e$level.creature", SheetClient="basic_zorai_male.creature", Level=170, RingAccess="j6", Equipment="z_mage_aoe_170_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.z_mage_aoe_170", entries.z_mage_aoe_170)

	entries.f_mage_aoe_220 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_aoe_fire_f2.creature", SheetModel="ring_magic_aoe_$hands_f$level.creature", SheetClient="basic_fyros_male.creature", Level=220, RingAccess="d7", Equipment="f_mage_aoe_220_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.f_mage_aoe_220", entries.f_mage_aoe_220)
	entries.m_mage_aoe_220 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_aoe_poison_f2.creature", SheetModel="ring_magic_aoe_$hands_f$level.creature", SheetClient="basic_matis_male.creature", Level=220, RingAccess="f7", Equipment="m_mage_aoe_220_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.m_mage_aoe_220", entries.m_mage_aoe_220)
	entries.t_mage_aoe_220 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_aoe_shockwave_f2.creature", SheetModel="ring_magic_aoe_$hands_f$level.creature", SheetClient="basic_tryker_male.creature", Level=220, RingAccess="l6", Equipment="t_mage_aoe_220_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.t_mage_aoe_220", entries.t_mage_aoe_220)
	entries.z_mage_aoe_220 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_aoe_electricity_f2.creature", SheetModel="ring_magic_aoe_$hands_f$level.creature", SheetClient="basic_zorai_male.creature", Level=220, RingAccess="j7", Equipment="z_mage_aoe_220_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.z_mage_aoe_220", entries.z_mage_aoe_220)


	entries.f_mage_aoe_20_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icfalv"] = "icfalv.sitem", }, legs = { ["uiR2EDequipment_icfacp"] = "icfacp.sitem", }, boots = { ["uiR2EDequipment_icfalb"] = "icfalb.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", }, gloves = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icfalg"] = "icfalg.sitem", }, hands = { ["uiR2EDequipment_acid"] = "icfm2ms.sitem::acid", ["uiR2EDequipment_cold"] = "icfm2ms.sitem::cold", ["uiR2EDequipment_rot"] = "icfm2ms.sitem::rot",  }, } r2.addR2PlayerEquipment(entries.f_mage_aoe_20, entries.f_mage_aoe_20_equipment)
	entries.m_mage_aoe_20_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icmalv"] = "icmalv.sitem", }, legs = { ["uiR2EDequipment_icmacp"] = "icmacp.sitem", }, boots = { ["uiR2EDequipment_icmalb"] = "icmalb.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", }, gloves = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icmalg"] = "icmalg.sitem", }, hands = { ["uiR2EDequipment_acid"] = "icmm2ms.sitem::acid", ["uiR2EDequipment_cold"] = "icmm2ms.sitem::cold", ["uiR2EDequipment_rot"] = "icmm2ms.sitem::rot",  }, } r2.addR2PlayerEquipment(entries.m_mage_aoe_20, entries.m_mage_aoe_20_equipment)
	entries.t_mage_aoe_20_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_ictalv"] = "ictalv.sitem", }, legs = { ["uiR2EDequipment_ictacp"] = "ictacp.sitem", }, boots = { ["uiR2EDequipment_ictalb"] = "ictalb.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", }, gloves = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_ictalg"] = "ictalg.sitem", }, hands = { ["uiR2EDequipment_acid"] = "ictm2ms.sitem::acid", ["uiR2EDequipment_cold"] = "ictm2ms.sitem::cold", ["uiR2EDequipment_rot"] = "ictm2ms.sitem::rot",  }, } r2.addR2PlayerEquipment(entries.t_mage_aoe_20, entries.t_mage_aoe_20_equipment)
	entries.z_mage_aoe_20_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_iczalv"] = "iczalv.sitem", }, legs = { ["uiR2EDequipment_iczacp"] = "iczacp.sitem", }, boots = { ["uiR2EDequipment_iczalb"] = "iczalb.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", }, gloves = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_iczalg"] = "iczalg.sitem", }, hands = { ["uiR2EDequipment_acid"] = "iczm2ms.sitem::acid", ["uiR2EDequipment_cold"] = "iczm2ms.sitem::cold", ["uiR2EDequipment_rot"] = "iczm2ms.sitem::rot",  }, } r2.addR2PlayerEquipment(entries.z_mage_aoe_20, entries.z_mage_aoe_20_equipment)

	entries.f_mage_aoe_70_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icfalv"] = "icfalv.sitem", ["uiR2EDequipment_icfalv_2"] = "icfalv_2.sitem", }, legs = { ["uiR2EDequipment_icfacp"] = "icfacp.sitem", ["uiR2EDequipment_icfacp_2"] = "icfacp_2.sitem", }, boots = { ["uiR2EDequipment_icfalb"] = "icfalb.sitem", ["uiR2EDequipment_icfalb_2"] = "icfalb_2.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", }, gloves = { ["uiR2EDequipment_icfalg"] = "icfalg.sitem", ["uiR2EDequipment_icfalg_2"] = "icfalg_2.sitem", }, hands = { ["uiR2EDequipment_acid"] = "icfm2ms_2.sitem::acid", ["uiR2EDequipment_cold"] = "icfm2ms_2.sitem::cold", ["uiR2EDequipment_rot"] = "icfm2ms_2.sitem::rot",  }, } r2.addR2PlayerEquipment(entries.f_mage_aoe_70, entries.f_mage_aoe_70_equipment)
	entries.m_mage_aoe_70_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icmalv"] = "icmalv.sitem", ["uiR2EDequipment_icmalv_2"] = "icmalv_2.sitem", }, legs = { ["uiR2EDequipment_icmacp"] = "icmacp.sitem", ["uiR2EDequipment_icmacp_2"] = "icmacp_2.sitem", }, boots = { ["uiR2EDequipment_icmalb"] = "icmalb.sitem", ["uiR2EDequipment_icmalb_2"] = "icmalb_2.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", }, gloves = { ["uiR2EDequipment_icmalg"] = "icmalg.sitem", ["uiR2EDequipment_icmalg_2"] = "icmalg_2.sitem", }, hands = { ["uiR2EDequipment_acid"] = "icmm2ms_2.sitem::acid", ["uiR2EDequipment_cold"] = "icmm2ms_2.sitem::cold", ["uiR2EDequipment_rot"] = "icmm2ms_2.sitem::rot",  }, } r2.addR2PlayerEquipment(entries.m_mage_aoe_70, entries.m_mage_aoe_70_equipment)
	entries.t_mage_aoe_70_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_ictalv"] = "ictalv.sitem", ["uiR2EDequipment_ictalv_2"] = "ictalv_2.sitem", }, legs = { ["uiR2EDequipment_ictacp"] = "ictacp.sitem", ["uiR2EDequipment_ictacp_2"] = "ictacp_2.sitem", }, boots = { ["uiR2EDequipment_ictalb"] = "ictalb.sitem", ["uiR2EDequipment_ictalb_2"] = "ictalb_2.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", }, gloves = { ["uiR2EDequipment_ictalg"] = "ictalg.sitem", ["uiR2EDequipment_ictalg_2"] = "ictalg_2.sitem", }, hands = { ["uiR2EDequipment_acid"] = "ictm2ms_2.sitem::acid", ["uiR2EDequipment_cold"] = "ictm2ms_2.sitem::cold", ["uiR2EDequipment_rot"] = "ictm2ms_2.sitem::rot",  }, } r2.addR2PlayerEquipment(entries.t_mage_aoe_70, entries.t_mage_aoe_70_equipment)
	entries.z_mage_aoe_70_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_iczalv"] = "iczalv.sitem", ["uiR2EDequipment_iczalv_2"] = "iczalv_2.sitem", }, legs = { ["uiR2EDequipment_iczacp"] = "iczacp.sitem", ["uiR2EDequipment_iczacp_2"] = "iczacp_2.sitem", }, boots = { ["uiR2EDequipment_iczalb"] = "iczalb.sitem", ["uiR2EDequipment_iczalb_2"] = "iczalb_2.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", }, gloves = { ["uiR2EDequipment_iczalg"] = "iczalg.sitem", ["uiR2EDequipment_iczalg_2"] = "iczalg_2.sitem", }, hands = { ["uiR2EDequipment_acid"] = "iczm2ms_2.sitem::acid", ["uiR2EDequipment_cold"] = "iczm2ms_2.sitem::cold", ["uiR2EDequipment_rot"] = "iczm2ms_2.sitem::rot",  }, } r2.addR2PlayerEquipment(entries.z_mage_aoe_70, entries.z_mage_aoe_70_equipment)

	entries.f_mage_aoe_120_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icfalv"] = "icfalv.sitem", ["uiR2EDequipment_icfalv_2"] = "icfalv_2.sitem", }, legs = { ["uiR2EDequipment_icfacp"] = "icfacp.sitem", ["uiR2EDequipment_icfacp_2"] = "icfacp_2.sitem", }, boots = { ["uiR2EDequipment_icfalb"] = "icfalb.sitem", ["uiR2EDequipment_icfalb_2"] = "icfalb_2.sitem", }, arms_guard = { ["uiR2EDequipment_icfals"] = "icfals.sitem", ["uiR2EDequipment_icfals_2"] = "icfals_2.sitem", }, gloves = { ["uiR2EDequipment_icfalg"] = "icfalg.sitem", ["uiR2EDequipment_icfalg_2"] = "icfalg_2.sitem", }, hands = { ["uiR2EDequipment_acid"] = "icfm2ms_2.sitem::acid", ["uiR2EDequipment_cold"] = "icfm2ms_2.sitem::cold", ["uiR2EDequipment_rot"] = "icfm2ms_2.sitem::rot", ["uiR2EDequipment_fire"] = "icfm2ms_2.sitem::fire",  }, } r2.addR2PlayerEquipment(entries.f_mage_aoe_120, entries.f_mage_aoe_120_equipment)
	entries.m_mage_aoe_120_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icmalv"] = "icmalv.sitem", ["uiR2EDequipment_icmalv_2"] = "icmalv_2.sitem", }, legs = { ["uiR2EDequipment_icmacp"] = "icmacp.sitem", ["uiR2EDequipment_icmacp_2"] = "icmacp_2.sitem", }, boots = { ["uiR2EDequipment_icmalb"] = "icmalb.sitem", ["uiR2EDequipment_icmalb_2"] = "icmalb_2.sitem", }, arms_guard = { ["uiR2EDequipment_icmals"] = "icmals.sitem", ["uiR2EDequipment_icmals_2"] = "icmals_2.sitem", }, gloves = { ["uiR2EDequipment_icmalg"] = "icmalg.sitem", ["uiR2EDequipment_icmalg_2"] = "icmalg_2.sitem", }, hands = { ["uiR2EDequipment_acid"] = "icmm2ms_2.sitem::acid", ["uiR2EDequipment_cold"] = "icmm2ms_2.sitem::cold", ["uiR2EDequipment_rot"] = "icmm2ms_2.sitem::rot", ["uiR2EDequipment_poison"] = "icmm2ms_2.sitem::poison",  }, } r2.addR2PlayerEquipment(entries.m_mage_aoe_120, entries.m_mage_aoe_120_equipment)
	entries.t_mage_aoe_120_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_ictalv"] = "ictalv.sitem", ["uiR2EDequipment_ictalv_2"] = "ictalv_2.sitem", }, legs = { ["uiR2EDequipment_ictacp"] = "ictacp.sitem", ["uiR2EDequipment_ictacp_2"] = "ictacp_2.sitem", }, boots = { ["uiR2EDequipment_ictalb"] = "ictalb.sitem", ["uiR2EDequipment_ictalb_2"] = "ictalb_2.sitem", }, arms_guard = { ["uiR2EDequipment_ictals"] = "ictals.sitem", ["uiR2EDequipment_ictals_2"] = "ictals_2.sitem", }, gloves = { ["uiR2EDequipment_ictalg"] = "ictalg.sitem", ["uiR2EDequipment_ictalg_2"] = "ictalg_2.sitem", }, hands = { ["uiR2EDequipment_acid"] = "ictm2ms_2.sitem::acid", ["uiR2EDequipment_cold"] = "ictm2ms_2.sitem::cold", ["uiR2EDequipment_rot"] = "ictm2ms_2.sitem::rot", ["uiR2EDequipment_shockwave"] = "ictm2ms_2.sitem::shockwave",  }, } r2.addR2PlayerEquipment(entries.t_mage_aoe_120, entries.t_mage_aoe_120_equipment)
	entries.z_mage_aoe_120_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_iczalv"] = "iczalv.sitem", ["uiR2EDequipment_iczalv_2"] = "iczalv_2.sitem", }, legs = { ["uiR2EDequipment_iczacp"] = "iczacp.sitem", ["uiR2EDequipment_iczacp_2"] = "iczacp_2.sitem", }, boots = { ["uiR2EDequipment_iczalb"] = "iczalb.sitem", ["uiR2EDequipment_iczalb_2"] = "iczalb_2.sitem", }, arms_guard = { ["uiR2EDequipment_iczals"] = "iczals.sitem", ["uiR2EDequipment_iczals_2"] = "iczals_2.sitem", }, gloves = { ["uiR2EDequipment_iczalg"] = "iczalg.sitem", ["uiR2EDequipment_iczalg_2"] = "iczalg_2.sitem", }, hands = { ["uiR2EDequipment_acid"] = "iczm2ms_2.sitem::acid", ["uiR2EDequipment_cold"] = "iczm2ms_2.sitem::cold", ["uiR2EDequipment_rot"] = "iczm2ms_2.sitem::rot", ["uiR2EDequipment_electricity"] = "iczm2ms_2.sitem::electricity",  }, } r2.addR2PlayerEquipment(entries.z_mage_aoe_120, entries.z_mage_aoe_120_equipment)

	entries.f_mage_aoe_170_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icfalv_2"] = "icfalv_2.sitem", ["uiR2EDequipment_icfalv_3"] = "icfalv_3.sitem", }, legs = { ["uiR2EDequipment_icfacp_2"] = "icfacp_2.sitem", ["uiR2EDequipment_icfacp_3"] = "icfacp_3.sitem", }, boots = { ["uiR2EDequipment_icfalb_2"] = "icfalb_2.sitem", ["uiR2EDequipment_icfalb_3"] = "icfalb_3.sitem", }, arms_guard = { ["uiR2EDequipment_icfals_2"] = "icfals_2.sitem", ["uiR2EDequipment_icfals_3"] = "icfals_3.sitem", }, gloves = { ["uiR2EDequipment_icfalg_2"] = "icfalg_2.sitem", ["uiR2EDequipment_icfalg_3"] = "icfalg_3.sitem", }, hands = { ["uiR2EDequipment_acid"] = "icfm2ms_3.sitem::acid", ["uiR2EDequipment_cold"] = "icfm2ms_3.sitem::cold", ["uiR2EDequipment_rot"] = "icfm2ms_3.sitem::rot", ["uiR2EDequipment_fire"] = "icfm2ms_3.sitem::fire",  }, } r2.addR2PlayerEquipment(entries.f_mage_aoe_170, entries.f_mage_aoe_170_equipment)
	entries.m_mage_aoe_170_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icmalv_2"] = "icmalv_2.sitem", ["uiR2EDequipment_icmalv_3"] = "icmalv_3.sitem", }, legs = { ["uiR2EDequipment_icmacp_2"] = "icmacp_2.sitem", ["uiR2EDequipment_icmacp_3"] = "icmacp_3.sitem", }, boots = { ["uiR2EDequipment_icmalb_2"] = "icmalb_2.sitem", ["uiR2EDequipment_icmalb_3"] = "icmalb_3.sitem", }, arms_guard = { ["uiR2EDequipment_icmals_2"] = "icmals_2.sitem", ["uiR2EDequipment_icmals_3"] = "icmals_3.sitem", }, gloves = { ["uiR2EDequipment_icmalg_2"] = "icmalg_2.sitem", ["uiR2EDequipment_icmalg_3"] = "icmalg_3.sitem", }, hands = { ["uiR2EDequipment_acid"] = "icmm2ms_3.sitem::acid", ["uiR2EDequipment_cold"] = "icmm2ms_3.sitem::cold", ["uiR2EDequipment_rot"] = "icmm2ms_3.sitem::rot", ["uiR2EDequipment_poison"] = "icmm2ms_3.sitem::poison",  }, } r2.addR2PlayerEquipment(entries.m_mage_aoe_170, entries.m_mage_aoe_170_equipment)
	entries.t_mage_aoe_170_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_ictalv_2"] = "ictalv_2.sitem", ["uiR2EDequipment_ictalv_3"] = "ictalv_3.sitem", }, legs = { ["uiR2EDequipment_ictacp_2"] = "ictacp_2.sitem", ["uiR2EDequipment_ictacp_3"] = "ictacp_3.sitem", }, boots = { ["uiR2EDequipment_ictalb_2"] = "ictalb_2.sitem", ["uiR2EDequipment_ictalb_3"] = "ictalb_3.sitem", }, arms_guard = { ["uiR2EDequipment_ictals_2"] = "ictals_2.sitem", ["uiR2EDequipment_ictals_3"] = "ictals_3.sitem", }, gloves = { ["uiR2EDequipment_ictalg_2"] = "ictalg_2.sitem", ["uiR2EDequipment_ictalg_3"] = "ictalg_3.sitem", }, hands = { ["uiR2EDequipment_acid"] = "ictm2ms_3.sitem::acid", ["uiR2EDequipment_cold"] = "ictm2ms_3.sitem::cold", ["uiR2EDequipment_rot"] = "ictm2ms_3.sitem::rot", ["uiR2EDequipment_shockwave"] = "ictm2ms_3.sitem::shockwave",  }, } r2.addR2PlayerEquipment(entries.t_mage_aoe_170, entries.t_mage_aoe_170_equipment)
	entries.z_mage_aoe_170_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_iczalv_2"] = "iczalv_2.sitem", ["uiR2EDequipment_iczalv_3"] = "iczalv_3.sitem", }, legs = { ["uiR2EDequipment_iczacp_2"] = "iczacp_2.sitem", ["uiR2EDequipment_iczacp_3"] = "iczacp_3.sitem", }, boots = { ["uiR2EDequipment_iczalb_2"] = "iczalb_2.sitem", ["uiR2EDequipment_iczalb_3"] = "iczalb_3.sitem", }, arms_guard = { ["uiR2EDequipment_iczals_2"] = "iczals_2.sitem", ["uiR2EDequipment_iczals_3"] = "iczals_3.sitem", }, gloves = { ["uiR2EDequipment_iczalg_2"] = "iczalg_2.sitem", ["uiR2EDequipment_iczalg_3"] = "iczalg_3.sitem", }, hands = { ["uiR2EDequipment_acid"] = "iczm2ms_3.sitem::acid", ["uiR2EDequipment_cold"] = "iczm2ms_3.sitem::cold", ["uiR2EDequipment_rot"] = "iczm2ms_3.sitem::rot", ["uiR2EDequipment_electricity"] = "iczm2ms_3.sitem::electricity",  }, } r2.addR2PlayerEquipment(entries.z_mage_aoe_170, entries.z_mage_aoe_170_equipment)

	entries.f_mage_aoe_220_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icfalv_2"] = "icfalv_2.sitem", ["uiR2EDequipment_icfalv_3"] = "icfalv_3.sitem", }, legs = { ["uiR2EDequipment_icfacp_2"] = "icfacp_2.sitem", ["uiR2EDequipment_icfacp_3"] = "icfacp_3.sitem", }, boots = { ["uiR2EDequipment_icfalb_2"] = "icfalb_2.sitem", ["uiR2EDequipment_icfalb_3"] = "icfalb_3.sitem", }, arms_guard = { ["uiR2EDequipment_icfals_2"] = "icfals_2.sitem", ["uiR2EDequipment_icfals_3"] = "icfals_3.sitem", }, gloves = { ["uiR2EDequipment_icfalg_2"] = "icfalg_2.sitem", ["uiR2EDequipment_icfalg_3"] = "icfalg_3.sitem", }, hands = { ["uiR2EDequipment_acid"] = "icfm2ms_3.sitem::acid", ["uiR2EDequipment_cold"] = "icfm2ms_3.sitem::cold", ["uiR2EDequipment_rot"] = "icfm2ms_3.sitem::rot", ["uiR2EDequipment_fire"] = "icfm2ms_3.sitem::fire",  }, } r2.addR2PlayerEquipment(entries.f_mage_aoe_220, entries.f_mage_aoe_220_equipment)
	entries.m_mage_aoe_220_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icmalv_2"] = "icmalv_2.sitem", ["uiR2EDequipment_icmalv_3"] = "icmalv_3.sitem", }, legs = { ["uiR2EDequipment_icmacp_2"] = "icmacp_2.sitem", ["uiR2EDequipment_icmacp_3"] = "icmacp_3.sitem", }, boots = { ["uiR2EDequipment_icmalb_2"] = "icmalb_2.sitem", ["uiR2EDequipment_icmalb_3"] = "icmalb_3.sitem", }, arms_guard = { ["uiR2EDequipment_icmals_2"] = "icmals_2.sitem", ["uiR2EDequipment_icmals_3"] = "icmals_3.sitem", }, gloves = { ["uiR2EDequipment_icmalg_2"] = "icmalg_2.sitem", ["uiR2EDequipment_icmalg_3"] = "icmalg_3.sitem", }, hands = { ["uiR2EDequipment_acid"] = "icmm2ms_3.sitem::acid", ["uiR2EDequipment_cold"] = "icmm2ms_3.sitem::cold", ["uiR2EDequipment_rot"] = "icmm2ms_3.sitem::rot", ["uiR2EDequipment_poison"] = "icmm2ms_3.sitem::poison",  }, } r2.addR2PlayerEquipment(entries.m_mage_aoe_220, entries.m_mage_aoe_220_equipment)
	entries.t_mage_aoe_220_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_ictalv_2"] = "ictalv_2.sitem", ["uiR2EDequipment_ictalv_3"] = "ictalv_3.sitem", }, legs = { ["uiR2EDequipment_ictacp_2"] = "ictacp_2.sitem", ["uiR2EDequipment_ictacp_3"] = "ictacp_3.sitem", }, boots = { ["uiR2EDequipment_ictalb_2"] = "ictalb_2.sitem", ["uiR2EDequipment_ictalb_3"] = "ictalb_3.sitem", }, arms_guard = { ["uiR2EDequipment_ictals_2"] = "ictals_2.sitem", ["uiR2EDequipment_ictals_3"] = "ictals_3.sitem", }, gloves = { ["uiR2EDequipment_ictalg_2"] = "ictalg_2.sitem", ["uiR2EDequipment_ictalg_3"] = "ictalg_3.sitem", }, hands = { ["uiR2EDequipment_acid"] = "ictm2ms_3.sitem::acid", ["uiR2EDequipment_cold"] = "ictm2ms_3.sitem::cold", ["uiR2EDequipment_rot"] = "ictm2ms_3.sitem::rot", ["uiR2EDequipment_shockwave"] = "ictm2ms_3.sitem::shockwave",  }, } r2.addR2PlayerEquipment(entries.t_mage_aoe_220, entries.t_mage_aoe_220_equipment)
	entries.z_mage_aoe_220_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_iczalv_2"] = "iczalv_2.sitem", ["uiR2EDequipment_iczalv_3"] = "iczalv_3.sitem", }, legs = { ["uiR2EDequipment_iczacp_2"] = "iczacp_2.sitem", ["uiR2EDequipment_iczacp_3"] = "iczacp_3.sitem", }, boots = { ["uiR2EDequipment_iczalb_2"] = "iczalb_2.sitem", ["uiR2EDequipment_iczalb_3"] = "iczalb_3.sitem", }, arms_guard = { ["uiR2EDequipment_iczals_2"] = "iczals_2.sitem", ["uiR2EDequipment_iczals_3"] = "iczals_3.sitem", }, gloves = { ["uiR2EDequipment_iczalg_2"] = "iczalg_2.sitem", ["uiR2EDequipment_iczalg_3"] = "iczalg_3.sitem", }, hands = { ["uiR2EDequipment_acid"] = "iczm2ms_3.sitem::acid", ["uiR2EDequipment_cold"] = "iczm2ms_3.sitem::cold", ["uiR2EDequipment_rot"] = "iczm2ms_3.sitem::rot", ["uiR2EDequipment_electricity"] = "iczm2ms_3.sitem::electricity",  }, } r2.addR2PlayerEquipment(entries.z_mage_aoe_220, entries.z_mage_aoe_220_equipment)


-- Atysian Cursers

	entries.f_mage_atysian_curser_20 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_curser_blind_b2.creature", SheetModel="ring_magic_curser_$hands_b$level.creature", SheetClient="basic_fyros_male.creature", Level=20,  RingAccess="a1", Equipment="f_mage_atysian_curser_20_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.f_mage_atysian_curser_20", entries.f_mage_atysian_curser_20)
	entries.m_mage_atysian_curser_20 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_curser_blind_b2.creature", SheetModel="ring_magic_curser_$hands_b$level.creature", SheetClient="basic_matis_male.creature", Level=20, RingAccess="a1", Equipment="m_mage_atysian_curser_20_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.m_mage_atysian_curser_20", entries.m_mage_atysian_curser_20)
	entries.t_mage_atysian_curser_20 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_curser_blind_b2.creature", SheetModel="ring_magic_curser_$hands_b$level.creature", SheetClient="basic_tryker_male.creature", Level=20, RingAccess="a1", Equipment="t_mage_atysian_curser_20_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.t_mage_atysian_curser_20", entries.t_mage_atysian_curser_20)
	entries.z_mage_atysian_curser_20 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_curser_blind_b2.creature", SheetModel="ring_magic_curser_$hands_b$level.creature", SheetClient="basic_zorai_male.creature", Level=20, RingAccess="a1", Equipment="z_mage_atysian_curser_20_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.z_mage_atysian_curser_20", entries.z_mage_atysian_curser_20)

	entries.f_mage_atysian_curser_70 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_curser_blind_c2.creature", SheetModel="ring_magic_curser_$hands_c$level.creature", SheetClient="basic_fyros_male.creature", Level=70, RingAccess="d2", Equipment="f_mage_atysian_curser_70_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.f_mage_atysian_curser_70", entries.f_mage_atysian_curser_70)
	entries.m_mage_atysian_curser_70 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_curser_blind_c2.creature", SheetModel="ring_magic_curser_$hands_c$level.creature", SheetClient="basic_matis_male.creature", Level=70, RingAccess="f5", Equipment="m_mage_atysian_curser_70_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.m_mage_atysian_curser_70", entries.m_mage_atysian_curser_70)
	entries.t_mage_atysian_curser_70 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_curser_blind_c2.creature", SheetModel="ring_magic_curser_$hands_c$level.creature", SheetClient="basic_tryker_male.creature", Level=70, RingAccess="l5", Equipment="t_mage_atysian_curser_70_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.t_mage_atysian_curser_70", entries.t_mage_atysian_curser_70)
	entries.z_mage_atysian_curser_70 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_curser_blind_c2.creature", SheetModel="ring_magic_curser_$hands_c$level.creature", SheetClient="basic_zorai_male.creature", Level=70, RingAccess="j5", Equipment="z_mage_atysian_curser_70_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.z_mage_atysian_curser_70", entries.z_mage_atysian_curser_70)

	entries.f_mage_atysian_curser_120 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_curser_blind_d2.creature", SheetModel="ring_magic_curser_$hands_d$level.creature", SheetClient="basic_fyros_male.creature", Level=120, RingAccess="d4", Equipment="f_mage_atysian_curser_120_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.f_mage_atysian_curser_120", entries.f_mage_atysian_curser_120)
	entries.m_mage_atysian_curser_120 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_curser_blind_d2.creature", SheetModel="ring_magic_curser_$hands_d$level.creature", SheetClient="basic_matis_male.creature", Level=120, RingAccess="f5", Equipment="m_mage_atysian_curser_120_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.m_mage_atysian_curser_120", entries.m_mage_atysian_curser_120)
	entries.t_mage_atysian_curser_120 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_curser_blind_d2.creature", SheetModel="ring_magic_curser_$hands_d$level.creature", SheetClient="basic_tryker_male.creature", Level=120, RingAccess="l5", Equipment="t_mage_atysian_curser_120_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.t_mage_atysian_curser_120", entries.t_mage_atysian_curser_120)
	entries.z_mage_atysian_curser_120 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_curser_blind_d2.creature", SheetModel="ring_magic_curser_$hands_d$level.creature", SheetClient="basic_zorai_male.creature", Level=120, RingAccess="j5", Equipment="z_mage_atysian_curser_120_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.z_mage_atysian_curser_120", entries.z_mage_atysian_curser_120)

	entries.f_mage_atysian_curser_170 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_curser_blind_e2.creature", SheetModel="ring_magic_curser_$hands_e$level.creature", SheetClient="basic_fyros_male.creature", Level=170, RingAccess="d6", Equipment="f_mage_atysian_curser_170_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.f_mage_atysian_curser_170", entries.f_mage_atysian_curser_170)
	entries.m_mage_atysian_curser_170 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_curser_blind_e2.creature", SheetModel="ring_magic_curser_$hands_e$level.creature", SheetClient="basic_matis_male.creature", Level=170, RingAccess="f6", Equipment="m_mage_atysian_curser_170_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.m_mage_atysian_curser_170", entries.m_mage_atysian_curser_170)
	entries.t_mage_atysian_curser_170 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_curser_blind_e2.creature", SheetModel="ring_magic_curser_$hands_e$level.creature", SheetClient="basic_tryker_male.creature", Level=170, RingAccess="l5", Equipment="t_mage_atysian_curser_170_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.t_mage_atysian_curser_170", entries.t_mage_atysian_curser_170)
	entries.z_mage_atysian_curser_170 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_curser_blind_e2.creature", SheetModel="ring_magic_curser_$hands_e$level.creature", SheetClient="basic_zorai_male.creature", Level=170, RingAccess="j6", Equipment="z_mage_atysian_curser_170_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.z_mage_atysian_curser_170", entries.z_mage_atysian_curser_170)

	entries.f_mage_atysian_curser_220 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_curser_blind_f2.creature", SheetModel="ring_magic_curser_$hands_f$level.creature", SheetClient="basic_fyros_male.creature", Level=220, RingAccess="d7", Equipment="f_mage_atysian_curser_220_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.f_mage_atysian_curser_220", entries.f_mage_atysian_curser_220)
	entries.m_mage_atysian_curser_220 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_curser_blind_f2.creature", SheetModel="ring_magic_curser_$hands_f$level.creature", SheetClient="basic_matis_male.creature", Level=220, RingAccess="f7", Equipment="m_mage_atysian_curser_220_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.m_mage_atysian_curser_220", entries.m_mage_atysian_curser_220)
	entries.t_mage_atysian_curser_220 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_curser_blind_f2.creature", SheetModel="ring_magic_curser_$hands_f$level.creature", SheetClient="basic_tryker_male.creature", Level=220, RingAccess="l6", Equipment="t_mage_atysian_curser_220_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.t_mage_atysian_curser_220", entries.t_mage_atysian_curser_220)
	entries.z_mage_atysian_curser_220 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_curser_blind_f2.creature", SheetModel="ring_magic_curser_$hands_f$level.creature", SheetClient="basic_zorai_male.creature", Level=220, RingAccess="j7", Equipment="z_mage_atysian_curser_220_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.z_mage_atysian_curser_220", entries.z_mage_atysian_curser_220)


	entries.f_mage_atysian_curser_20_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icfalv"] = "icfalv.sitem", }, legs = { ["uiR2EDequipment_icfacp"] = "icfacp.sitem", }, boots = { ["uiR2EDequipment_icfalb"] = "icfalb.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", }, gloves = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icfalg"] = "icfalg.sitem", }, hands = { ["uiR2EDequipment_root"] = "icfm2ms.sitem::root", ["uiR2EDequipment_blind"] = "icfm2ms.sitem::blind", ["uiR2EDequipment_snare"] = "icfm2ms.sitem::snare", ["uiR2EDequipment_slow"] = "icfm2ms.sitem::slow", ["uiR2EDequipment_madness"] = "icfm2ms.sitem::madness",  }, } r2.addR2PlayerEquipment(entries.f_mage_atysian_curser_20, entries.f_mage_atysian_curser_20_equipment)
	entries.m_mage_atysian_curser_20_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icmalv"] = "icmalv.sitem", }, legs = { ["uiR2EDequipment_icmacp"] = "icmacp.sitem", }, boots = { ["uiR2EDequipment_icmalb"] = "icmalb.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", }, gloves = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icmalg"] = "icmalg.sitem", }, hands = { ["uiR2EDequipment_root"] = "icmm2ms.sitem::root", ["uiR2EDequipment_blind"] = "icmm2ms.sitem::blind", ["uiR2EDequipment_snare"] = "icmm2ms.sitem::snare", ["uiR2EDequipment_slow"] = "icmm2ms.sitem::slow", ["uiR2EDequipment_madness"] = "icfm2ms.sitem::madness", }, } r2.addR2PlayerEquipment(entries.m_mage_atysian_curser_20, entries.m_mage_atysian_curser_20_equipment)
	entries.t_mage_atysian_curser_20_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_ictalv"] = "ictalv.sitem", }, legs = { ["uiR2EDequipment_ictacp"] = "ictacp.sitem", }, boots = { ["uiR2EDequipment_ictalb"] = "ictalb.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", }, gloves = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_ictalg"] = "ictalg.sitem", }, hands = { ["uiR2EDequipment_root"] = "ictm2ms.sitem::root", ["uiR2EDequipment_blind"] = "ictm2ms.sitem::blind", ["uiR2EDequipment_snare"] = "ictm2ms.sitem::snare", ["uiR2EDequipment_slow"] = "ictm2ms.sitem::slow", ["uiR2EDequipment_madness"] = "icfm2ms.sitem::madness", }, } r2.addR2PlayerEquipment(entries.t_mage_atysian_curser_20, entries.t_mage_atysian_curser_20_equipment)
	entries.z_mage_atysian_curser_20_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_iczalv"] = "iczalv.sitem", }, legs = { ["uiR2EDequipment_iczacp"] = "iczacp.sitem", }, boots = { ["uiR2EDequipment_iczalb"] = "iczalb.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", }, gloves = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_iczalg"] = "iczalg.sitem", }, hands = { ["uiR2EDequipment_root"] = "iczm2ms.sitem::root", ["uiR2EDequipment_blind"] = "iczm2ms.sitem::blind", ["uiR2EDequipment_snare"] = "iczm2ms.sitem::snare", ["uiR2EDequipment_slow"] = "iczm2ms.sitem::slow", ["uiR2EDequipment_madness"] = "icfm2ms.sitem::madness", }, } r2.addR2PlayerEquipment(entries.z_mage_atysian_curser_20, entries.z_mage_atysian_curser_20_equipment)

	entries.f_mage_atysian_curser_70_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icfalv"] = "icfalv.sitem", ["uiR2EDequipment_icfalv_2"] = "icfalv_2.sitem", }, legs = { ["uiR2EDequipment_icfacp"] = "icfacp.sitem", ["uiR2EDequipment_icfacp_2"] = "icfacp_2.sitem", }, boots = { ["uiR2EDequipment_icfalb"] = "icfalb.sitem", ["uiR2EDequipment_icfalb_2"] = "icfalb_2.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icfals"] = "icfals.sitem", ["uiR2EDequipment_icfals_2"] = "icfals_2.sitem", }, gloves = { ["uiR2EDequipment_icfalg"] = "icfalg.sitem", ["uiR2EDequipment_icfalg_2"] = "icfalg_2.sitem", }, hands = { ["uiR2EDequipment_root"] = "icfm2ms_2.sitem::root", ["uiR2EDequipment_blind"] = "icfm2ms_2.sitem::blind", ["uiR2EDequipment_snare"] = "icfm2ms_2.sitem::snare", ["uiR2EDequipment_slow"] = "icfm2ms_2.sitem::slow", ["uiR2EDequipment_madness"] = "icfm2ms_2.sitem::madness", }, } r2.addR2PlayerEquipment(entries.f_mage_atysian_curser_70, entries.f_mage_atysian_curser_70_equipment)
	entries.m_mage_atysian_curser_70_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icmalv"] = "icmalv.sitem", ["uiR2EDequipment_icmalv_2"] = "icmalv_2.sitem", }, legs = { ["uiR2EDequipment_icmacp"] = "icmacp.sitem", ["uiR2EDequipment_icmacp_2"] = "icmacp_2.sitem", }, boots = { ["uiR2EDequipment_icmalb"] = "icmalb.sitem", ["uiR2EDequipment_icmalb_2"] = "icmalb_2.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icmals"] = "icmals.sitem", ["uiR2EDequipment_icmals_2"] = "icmals_2.sitem", }, gloves = { ["uiR2EDequipment_icmalg"] = "icmalg.sitem", ["uiR2EDequipment_icmalg_2"] = "icmalg_2.sitem", }, hands = { ["uiR2EDequipment_root"] = "icmm2ms_2.sitem::root", ["uiR2EDequipment_blind"] = "icmm2ms_2.sitem::blind", ["uiR2EDequipment_snare"] = "icmm2ms_2.sitem::snare", ["uiR2EDequipment_slow"] = "icmm2ms_2.sitem::slow", ["uiR2EDequipment_madness"] = "icfm2ms_2.sitem::madness", }, } r2.addR2PlayerEquipment(entries.m_mage_atysian_curser_70, entries.m_mage_atysian_curser_70_equipment)
	entries.t_mage_atysian_curser_70_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_ictalv"] = "ictalv.sitem", ["uiR2EDequipment_ictalv_2"] = "ictalv_2.sitem", }, legs = { ["uiR2EDequipment_ictacp"] = "ictacp.sitem", ["uiR2EDequipment_ictacp_2"] = "ictacp_2.sitem", }, boots = { ["uiR2EDequipment_ictalb"] = "ictalb.sitem", ["uiR2EDequipment_ictalb_2"] = "ictalb_2.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_ictals"] = "ictals.sitem", ["uiR2EDequipment_ictals_2"] = "ictals_2.sitem", }, gloves = { ["uiR2EDequipment_ictalg"] = "ictalg.sitem", ["uiR2EDequipment_ictalg_2"] = "ictalg_2.sitem", }, hands = { ["uiR2EDequipment_root"] = "ictm2ms_2.sitem::root", ["uiR2EDequipment_blind"] = "ictm2ms_2.sitem::blind", ["uiR2EDequipment_snare"] = "ictm2ms_2.sitem::snare", ["uiR2EDequipment_slow"] = "ictm2ms_2.sitem::slow", ["uiR2EDequipment_madness"] = "icfm2ms_2.sitem::madness", }, } r2.addR2PlayerEquipment(entries.t_mage_atysian_curser_70, entries.t_mage_atysian_curser_70_equipment)
	entries.z_mage_atysian_curser_70_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_iczalv"] = "iczalv.sitem", ["uiR2EDequipment_iczalv_2"] = "iczalv_2.sitem", }, legs = { ["uiR2EDequipment_iczacp"] = "iczacp.sitem", ["uiR2EDequipment_iczacp_2"] = "iczacp_2.sitem", }, boots = { ["uiR2EDequipment_iczalb"] = "iczalb.sitem", ["uiR2EDequipment_iczalb_2"] = "iczalb_2.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_iczals"] = "iczals.sitem", ["uiR2EDequipment_iczals_2"] = "iczals_2.sitem", }, gloves = { ["uiR2EDequipment_iczalg"] = "iczalg.sitem", ["uiR2EDequipment_iczalg_2"] = "iczalg_2.sitem", }, hands = { ["uiR2EDequipment_root"] = "iczm2ms_2.sitem::root", ["uiR2EDequipment_blind"] = "iczm2ms_2.sitem::blind", ["uiR2EDequipment_snare"] = "iczm2ms_2.sitem::snare", ["uiR2EDequipment_slow"] = "iczm2ms_2.sitem::slow", ["uiR2EDequipment_madness"] = "icfm2ms_2.sitem::madness", }, } r2.addR2PlayerEquipment(entries.z_mage_atysian_curser_70, entries.z_mage_atysian_curser_70_equipment)

	entries.f_mage_atysian_curser_120_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icfalv"] = "icfalv.sitem", ["uiR2EDequipment_icfalv_2"] = "icfalv_2.sitem", }, legs = { ["uiR2EDequipment_icfacp"] = "icfacp.sitem", ["uiR2EDequipment_icfacp_2"] = "icfacp_2.sitem", }, boots = { ["uiR2EDequipment_icfalb"] = "icfalb.sitem", ["uiR2EDequipment_icfalb_2"] = "icfalb_2.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icfals"] = "icfals.sitem", ["uiR2EDequipment_icfals_2"] = "icfals_2.sitem", }, gloves = { ["uiR2EDequipment_icfalg"] = "icfalg.sitem", ["uiR2EDequipment_icfalg_2"] = "icfalg_2.sitem", }, hands = { ["uiR2EDequipment_root"] = "icfm2ms_2.sitem::root", ["uiR2EDequipment_blind"] = "icfm2ms_2.sitem::blind", ["uiR2EDequipment_snare"] = "icfm2ms_2.sitem::snare", ["uiR2EDequipment_slow"] = "icfm2ms_2.sitem::slow", ["uiR2EDequipment_madness"] = "icfm2ms_2.sitem::madness", }, } r2.addR2PlayerEquipment(entries.f_mage_atysian_curser_120, entries.f_mage_atysian_curser_120_equipment)
	entries.m_mage_atysian_curser_120_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icmalv"] = "icmalv.sitem", ["uiR2EDequipment_icmalv_2"] = "icmalv_2.sitem", }, legs = { ["uiR2EDequipment_icmacp"] = "icmacp.sitem", ["uiR2EDequipment_icmacp_2"] = "icmacp_2.sitem", }, boots = { ["uiR2EDequipment_icmalb"] = "icmalb.sitem", ["uiR2EDequipment_icmalb_2"] = "icmalb_2.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icmals"] = "icmals.sitem", ["uiR2EDequipment_icmals_2"] = "icmals_2.sitem", }, gloves = { ["uiR2EDequipment_icmalg"] = "icmalg.sitem", ["uiR2EDequipment_icmalg_2"] = "icmalg_2.sitem", }, hands = { ["uiR2EDequipment_root"] = "icmm2ms_2.sitem::root", ["uiR2EDequipment_blind"] = "icmm2ms_2.sitem::blind", ["uiR2EDequipment_snare"] = "icmm2ms_2.sitem::snare", ["uiR2EDequipment_slow"] = "icmm2ms_2.sitem::slow", ["uiR2EDequipment_madness"] = "icfm2ms_2.sitem::madness", }, } r2.addR2PlayerEquipment(entries.m_mage_atysian_curser_120, entries.m_mage_atysian_curser_120_equipment)
	entries.t_mage_atysian_curser_120_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_ictalv"] = "ictalv.sitem", ["uiR2EDequipment_ictalv_2"] = "ictalv_2.sitem", }, legs = { ["uiR2EDequipment_ictacp"] = "ictacp.sitem", ["uiR2EDequipment_ictacp_2"] = "ictacp_2.sitem", }, boots = { ["uiR2EDequipment_ictalb"] = "ictalb.sitem", ["uiR2EDequipment_ictalb_2"] = "ictalb_2.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_ictals"] = "ictals.sitem", ["uiR2EDequipment_ictals_2"] = "ictals_2.sitem", }, gloves = { ["uiR2EDequipment_ictalg"] = "ictalg.sitem", ["uiR2EDequipment_ictalg_2"] = "ictalg_2.sitem", }, hands = { ["uiR2EDequipment_root"] = "ictm2ms_2.sitem::root", ["uiR2EDequipment_blind"] = "ictm2ms_2.sitem::blind", ["uiR2EDequipment_snare"] = "ictm2ms_2.sitem::snare", ["uiR2EDequipment_slow"] = "ictm2ms_2.sitem::slow", ["uiR2EDequipment_madness"] = "icfm2ms_2.sitem::madness", }, } r2.addR2PlayerEquipment(entries.t_mage_atysian_curser_120, entries.t_mage_atysian_curser_120_equipment)
	entries.z_mage_atysian_curser_120_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_iczalv"] = "iczalv.sitem", ["uiR2EDequipment_iczalv_2"] = "iczalv_2.sitem", }, legs = { ["uiR2EDequipment_iczacp"] = "iczacp.sitem", ["uiR2EDequipment_iczacp_2"] = "iczacp_2.sitem", }, boots = { ["uiR2EDequipment_iczalb"] = "iczalb.sitem", ["uiR2EDequipment_iczalb_2"] = "iczalb_2.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_iczals"] = "iczals.sitem", ["uiR2EDequipment_iczals_2"] = "iczals_2.sitem", }, gloves = { ["uiR2EDequipment_iczalg"] = "iczalg.sitem", ["uiR2EDequipment_iczalg_2"] = "iczalg_2.sitem", }, hands = { ["uiR2EDequipment_root"] = "iczm2ms_2.sitem::root", ["uiR2EDequipment_blind"] = "iczm2ms_2.sitem::blind", ["uiR2EDequipment_snare"] = "iczm2ms_2.sitem::snare", ["uiR2EDequipment_slow"] = "iczm2ms_2.sitem::slow", ["uiR2EDequipment_madness"] = "icfm2ms_2.sitem::madness", }, } r2.addR2PlayerEquipment(entries.z_mage_atysian_curser_120, entries.z_mage_atysian_curser_120_equipment)

	entries.f_mage_atysian_curser_170_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icfalv_2"] = "icfalv_2.sitem", ["uiR2EDequipment_icfalv_3"] = "icfalv_3.sitem", }, legs = { ["uiR2EDequipment_icfacp_2"] = "icfacp_2.sitem", ["uiR2EDequipment_icfacp_3"] = "icfacp_3.sitem", }, boots = { ["uiR2EDequipment_icfalb_2"] = "icfalb_2.sitem", ["uiR2EDequipment_icfalb_3"] = "icfalb_3.sitem", }, arms_guard = { ["uiR2EDequipment_icfals_2"] = "icfals_2.sitem", ["uiR2EDequipment_icfals_3"] = "icfals_3.sitem", }, gloves = { ["uiR2EDequipment_icfalg_2"] = "icfalg_2.sitem", ["uiR2EDequipment_icfalg_3"] = "icfalg_3.sitem", }, hands = { ["uiR2EDequipment_root"] = "icfm2ms_3.sitem::root", ["uiR2EDequipment_blind"] = "icfm2ms_3.sitem::blind", ["uiR2EDequipment_snare"] = "icfm2ms_3.sitem::snare", ["uiR2EDequipment_slow"] = "icfm2ms_3.sitem::slow", ["uiR2EDequipment_madness"] = "icfm2ms_3.sitem::madness", }, } r2.addR2PlayerEquipment(entries.f_mage_atysian_curser_170, entries.f_mage_atysian_curser_170_equipment)
	entries.m_mage_atysian_curser_170_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icmalv_2"] = "icmalv_2.sitem", ["uiR2EDequipment_icmalv_3"] = "icmalv_3.sitem", }, legs = { ["uiR2EDequipment_icmacp_2"] = "icmacp_2.sitem", ["uiR2EDequipment_icmacp_3"] = "icmacp_3.sitem", }, boots = { ["uiR2EDequipment_icmalb_2"] = "icmalb_2.sitem", ["uiR2EDequipment_icmalb_3"] = "icmalb_3.sitem", }, arms_guard = { ["uiR2EDequipment_icmals_2"] = "icmals_2.sitem", ["uiR2EDequipment_icmals_3"] = "icmals_3.sitem", }, gloves = { ["uiR2EDequipment_icmalg_2"] = "icmalg_2.sitem", ["uiR2EDequipment_icmalg_3"] = "icmalg_3.sitem", }, hands = { ["uiR2EDequipment_root"] = "icmm2ms_3.sitem::root", ["uiR2EDequipment_blind"] = "icmm2ms_3.sitem::blind", ["uiR2EDequipment_snare"] = "icmm2ms_3.sitem::snare", ["uiR2EDequipment_slow"] = "icmm2ms_3.sitem::slow", ["uiR2EDequipment_madness"] = "icfm2ms_3.sitem::madness", }, } r2.addR2PlayerEquipment(entries.m_mage_atysian_curser_170, entries.m_mage_atysian_curser_170_equipment)
	entries.t_mage_atysian_curser_170_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_ictalv_2"] = "ictalv_2.sitem", ["uiR2EDequipment_ictalv_3"] = "ictalv_3.sitem", }, legs = { ["uiR2EDequipment_ictacp_2"] = "ictacp_2.sitem", ["uiR2EDequipment_ictacp_3"] = "ictacp_3.sitem", }, boots = { ["uiR2EDequipment_ictalb_2"] = "ictalb_2.sitem", ["uiR2EDequipment_ictalb_3"] = "ictalb_3.sitem", }, arms_guard = { ["uiR2EDequipment_ictals_2"] = "ictals_2.sitem", ["uiR2EDequipment_ictals_3"] = "ictals_3.sitem", }, gloves = { ["uiR2EDequipment_ictalg_2"] = "ictalg_2.sitem", ["uiR2EDequipment_ictalg_3"] = "ictalg_3.sitem", }, hands = { ["uiR2EDequipment_root"] = "ictm2ms_3.sitem::root", ["uiR2EDequipment_blind"] = "ictm2ms_3.sitem::blind", ["uiR2EDequipment_snare"] = "ictm2ms_3.sitem::snare", ["uiR2EDequipment_slow"] = "ictm2ms_3.sitem::slow", ["uiR2EDequipment_madness"] = "icfm2ms_3.sitem::madness", }, } r2.addR2PlayerEquipment(entries.t_mage_atysian_curser_170, entries.t_mage_atysian_curser_170_equipment)
	entries.z_mage_atysian_curser_170_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_iczalv_2"] = "iczalv_2.sitem", ["uiR2EDequipment_iczalv_3"] = "iczalv_3.sitem", }, legs = { ["uiR2EDequipment_iczacp_2"] = "iczacp_2.sitem", ["uiR2EDequipment_iczacp_3"] = "iczacp_3.sitem", }, boots = { ["uiR2EDequipment_iczalb_2"] = "iczalb_2.sitem", ["uiR2EDequipment_iczalb_3"] = "iczalb_3.sitem", }, arms_guard = { ["uiR2EDequipment_iczals_2"] = "iczals_2.sitem", ["uiR2EDequipment_iczals_3"] = "iczals_3.sitem", }, gloves = { ["uiR2EDequipment_iczalg_2"] = "iczalg_2.sitem", ["uiR2EDequipment_iczalg_3"] = "iczalg_3.sitem", }, hands = { ["uiR2EDequipment_root"] = "iczm2ms_3.sitem::root", ["uiR2EDequipment_blind"] = "iczm2ms_3.sitem::blind", ["uiR2EDequipment_snare"] = "iczm2ms_3.sitem::snare", ["uiR2EDequipment_slow"] = "iczm2ms_3.sitem::slow", ["uiR2EDequipment_madness"] = "icfm2ms_3.sitem::madness", }, } r2.addR2PlayerEquipment(entries.z_mage_atysian_curser_170, entries.z_mage_atysian_curser_170_equipment)

	entries.f_mage_atysian_curser_220_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icfalv_2"] = "icfalv_2.sitem", ["uiR2EDequipment_icfalv_3"] = "icfalv_3.sitem", }, legs = { ["uiR2EDequipment_icfacp_2"] = "icfacp_2.sitem", ["uiR2EDequipment_icfacp_3"] = "icfacp_3.sitem", }, boots = { ["uiR2EDequipment_icfalb_2"] = "icfalb_2.sitem", ["uiR2EDequipment_icfalb_3"] = "icfalb_3.sitem", }, arms_guard = { ["uiR2EDequipment_icfals_2"] = "icfals_2.sitem", ["uiR2EDequipment_icfals_3"] = "icfals_3.sitem", }, gloves = { ["uiR2EDequipment_icfalg_2"] = "icfalg_2.sitem", ["uiR2EDequipment_icfalg_3"] = "icfalg_3.sitem", }, hands = { ["uiR2EDequipment_root"] = "icfm2ms_3.sitem::root", ["uiR2EDequipment_blind"] = "icfm2ms_3.sitem::blind", ["uiR2EDequipment_snare"] = "icfm2ms_3.sitem::snare", ["uiR2EDequipment_slow"] = "icfm2ms_3.sitem::slow", ["uiR2EDequipment_madness"] = "icfm2ms_3.sitem::madness", }, } r2.addR2PlayerEquipment(entries.f_mage_atysian_curser_220, entries.f_mage_atysian_curser_220_equipment)
	entries.m_mage_atysian_curser_220_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icmalv_2"] = "icmalv_2.sitem", ["uiR2EDequipment_icmalv_3"] = "icmalv_3.sitem", }, legs = { ["uiR2EDequipment_icmacp_2"] = "icmacp_2.sitem", ["uiR2EDequipment_icmacp_3"] = "icmacp_3.sitem", }, boots = { ["uiR2EDequipment_icmalb_2"] = "icmalb_2.sitem", ["uiR2EDequipment_icmalb_3"] = "icmalb_3.sitem", }, arms_guard = { ["uiR2EDequipment_icmals_2"] = "icmals_2.sitem", ["uiR2EDequipment_icmals_3"] = "icmals_3.sitem", }, gloves = { ["uiR2EDequipment_icmalg_2"] = "icmalg_2.sitem", ["uiR2EDequipment_icmalg_3"] = "icmalg_3.sitem", }, hands = { ["uiR2EDequipment_root"] = "icmm2ms_3.sitem::root", ["uiR2EDequipment_blind"] = "icmm2ms_3.sitem::blind", ["uiR2EDequipment_snare"] = "icmm2ms_3.sitem::snare", ["uiR2EDequipment_slow"] = "icmm2ms_3.sitem::slow", ["uiR2EDequipment_madness"] = "icfm2ms_3.sitem::madness", }, } r2.addR2PlayerEquipment(entries.m_mage_atysian_curser_220, entries.m_mage_atysian_curser_220_equipment)
	entries.t_mage_atysian_curser_220_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_ictalv_2"] = "ictalv_2.sitem", ["uiR2EDequipment_ictalv_3"] = "ictalv_3.sitem", }, legs = { ["uiR2EDequipment_ictacp_2"] = "ictacp_2.sitem", ["uiR2EDequipment_ictacp_3"] = "ictacp_3.sitem", }, boots = { ["uiR2EDequipment_ictalb_2"] = "ictalb_2.sitem", ["uiR2EDequipment_ictalb_3"] = "ictalb_3.sitem", }, arms_guard = { ["uiR2EDequipment_ictals_2"] = "ictals_2.sitem", ["uiR2EDequipment_ictals_3"] = "ictals_3.sitem", }, gloves = { ["uiR2EDequipment_ictalg_2"] = "ictalg_2.sitem", ["uiR2EDequipment_ictalg_3"] = "ictalg_3.sitem", }, hands = { ["uiR2EDequipment_root"] = "ictm2ms_3.sitem::root", ["uiR2EDequipment_blind"] = "ictm2ms_3.sitem::blind", ["uiR2EDequipment_snare"] = "ictm2ms_3.sitem::snare", ["uiR2EDequipment_slow"] = "ictm2ms_3.sitem::slow", ["uiR2EDequipment_madness"] = "icfm2ms_3.sitem::madness", }, } r2.addR2PlayerEquipment(entries.t_mage_atysian_curser_220, entries.t_mage_atysian_curser_220_equipment)
	entries.z_mage_atysian_curser_220_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_iczalv_2"] = "iczalv_2.sitem", ["uiR2EDequipment_iczalv_3"] = "iczalv_3.sitem", }, legs = { ["uiR2EDequipment_iczacp_2"] = "iczacp_2.sitem", ["uiR2EDequipment_iczacp_3"] = "iczacp_3.sitem", }, boots = { ["uiR2EDequipment_iczalb_2"] = "iczalb_2.sitem", ["uiR2EDequipment_iczalb_3"] = "iczalb_3.sitem", }, arms_guard = { ["uiR2EDequipment_iczals_2"] = "iczals_2.sitem", ["uiR2EDequipment_iczals_3"] = "iczals_3.sitem", }, gloves = { ["uiR2EDequipment_iczalg_2"] = "iczalg_2.sitem", ["uiR2EDequipment_iczalg_3"] = "iczalg_3.sitem", }, hands = { ["uiR2EDequipment_root"] = "iczm2ms_3.sitem::root", ["uiR2EDequipment_blind"] = "iczm2ms_3.sitem::blind", ["uiR2EDequipment_snare"] = "iczm2ms_3.sitem::snare", ["uiR2EDequipment_slow"] = "iczm2ms_3.sitem::slow", ["uiR2EDequipment_madness"] = "icfm2ms_3.sitem::madness", }, } r2.addR2PlayerEquipment(entries.z_mage_atysian_curser_220, entries.z_mage_atysian_curser_220_equipment)


 
-- Celestial Cursers

	entries.f_mage_celestial_curser_20 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_curser_sleep_b2.creature", SheetModel="ring_magic_curser_$hands_b$level.creature", SheetClient="basic_fyros_male.creature", Level=20, RingAccess="a1", Equipment="f_mage_celestial_curser_20_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.f_mage_celestial_curser_20", entries.f_mage_celestial_curser_20)
	entries.m_mage_celestial_curser_20 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_curser_sleep_b2.creature", SheetModel="ring_magic_curser_$hands_b$level.creature", SheetClient="basic_matis_male.creature", Level=20, RingAccess="a1", Equipment="m_mage_celestial_curser_20_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.m_mage_celestial_curser_20", entries.m_mage_celestial_curser_20)
	entries.t_mage_celestial_curser_20 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_curser_stun_b2.creature", SheetModel="ring_magic_curser_$hands_b$level.creature", SheetClient="basic_tryker_male.creature", Level=20, RingAccess="a1", Equipment="t_mage_celestial_curser_20_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.t_mage_celestial_curser_20", entries.t_mage_celestial_curser_20)
	entries.z_mage_celestial_curser_20 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_curser_fear_b2.creature", SheetModel="ring_magic_curser_$hands_b$level.creature", SheetClient="basic_zorai_male.creature", Level=20, RingAccess="a1", Equipment="z_mage_celestial_curser_20_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.z_mage_celestial_curser_20", entries.z_mage_celestial_curser_20)

	entries.f_mage_celestial_curser_70 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_curser_sleep_c2.creature", SheetModel="ring_magic_curser_$hands_c$level.creature", SheetClient="basic_fyros_male.creature", Level=70, RingAccess="d2", Equipment="f_mage_celestial_curser_70_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.f_mage_celestial_curser_70", entries.f_mage_celestial_curser_70)
	entries.m_mage_celestial_curser_70 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_curser_sleep_c2.creature", SheetModel="ring_magic_curser_$hands_c$level.creature", SheetClient="basic_matis_male.creature", Level=70, RingAccess="f5", Equipment="m_mage_celestial_curser_70_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.m_mage_celestial_curser_70", entries.m_mage_celestial_curser_70)
	entries.t_mage_celestial_curser_70 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_curser_stun_c2.creature", SheetModel="ring_magic_curser_$hands_c$level.creature", SheetClient="basic_tryker_male.creature", Level=70, RingAccess="l5", Equipment="t_mage_celestial_curser_70_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.t_mage_celestial_curser_70", entries.t_mage_celestial_curser_70)
	entries.z_mage_celestial_curser_70 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_curser_fear_c2.creature", SheetModel="ring_magic_curser_$hands_c$level.creature", SheetClient="basic_zorai_male.creature", Level=70, RingAccess="j5", Equipment="z_mage_celestial_curser_70_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.z_mage_celestial_curser_70", entries.z_mage_celestial_curser_70)

	entries.f_mage_celestial_curser_120 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_curser_sleep_d2.creature", SheetModel="ring_magic_curser_$hands_d$level.creature", SheetClient="basic_fyros_male.creature", Level=120, RingAccess="d4", Equipment="f_mage_celestial_curser_120_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.f_mage_celestial_curser_120", entries.f_mage_celestial_curser_120)
	entries.m_mage_celestial_curser_120 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_curser_sleep_d2.creature", SheetModel="ring_magic_curser_$hands_d$level.creature", SheetClient="basic_matis_male.creature", Level=120, RingAccess="f5", Equipment="m_mage_celestial_curser_120_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.m_mage_celestial_curser_120", entries.m_mage_celestial_curser_120)
	entries.t_mage_celestial_curser_120 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_curser_stun_d2.creature", SheetModel="ring_magic_curser_$hands_d$level.creature", SheetClient="basic_tryker_male.creature", Level=120, RingAccess="l5", Equipment="t_mage_celestial_curser_120_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.t_mage_celestial_curser_120", entries.t_mage_celestial_curser_120)
	entries.z_mage_celestial_curser_120 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_curser_fear_d2.creature", SheetModel="ring_magic_curser_$hands_d$level.creature", SheetClient="basic_zorai_male.creature", Level=120, RingAccess="j5", Equipment="z_mage_celestial_curser_120_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.z_mage_celestial_curser_120", entries.z_mage_celestial_curser_120)

	entries.f_mage_celestial_curser_170 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_curser_sleep_e2.creature", SheetModel="ring_magic_curser_$hands_e$level.creature", SheetClient="basic_fyros_male.creature", Level=170, RingAccess="d6", Equipment="f_mage_celestial_curser_170_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.f_mage_celestial_curser_170", entries.f_mage_celestial_curser_170)
	entries.m_mage_celestial_curser_170 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_curser_sleep_e2.creature", SheetModel="ring_magic_curser_$hands_e$level.creature", SheetClient="basic_matis_male.creature", Level=170, RingAccess="f6", Equipment="m_mage_celestial_curser_170_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.m_mage_celestial_curser_170", entries.m_mage_celestial_curser_170)
	entries.t_mage_celestial_curser_170 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_curser_stun_e2.creature", SheetModel="ring_magic_curser_$hands_e$level.creature", SheetClient="basic_tryker_male.creature", Level=170, RingAccess="l5", Equipment="t_mage_celestial_curser_170_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.t_mage_celestial_curser_170", entries.t_mage_celestial_curser_170)
	entries.z_mage_celestial_curser_170 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_curser_fear_e2.creature", SheetModel="ring_magic_curser_$hands_e$level.creature", SheetClient="basic_zorai_male.creature", Level=170, RingAccess="j6", Equipment="z_mage_celestial_curser_170_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.z_mage_celestial_curser_170", entries.z_mage_celestial_curser_170)

	entries.f_mage_celestial_curser_220 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_curser_sleep_f2.creature", SheetModel="ring_magic_curser_$hands_f$level.creature", SheetClient="basic_fyros_male.creature", Level=220, RingAccess="d7", Equipment="f_mage_celestial_curser_220_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.f_mage_celestial_curser_220", entries.f_mage_celestial_curser_220)
	entries.m_mage_celestial_curser_220 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_curser_sleep_f2.creature", SheetModel="ring_magic_curser_$hands_f$level.creature", SheetClient="basic_matis_male.creature", Level=220, RingAccess="f7", Equipment="m_mage_celestial_curser_220_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.m_mage_celestial_curser_220", entries.m_mage_celestial_curser_220)
	entries.t_mage_celestial_curser_220 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_curser_stun_f2.creature", SheetModel="ring_magic_curser_$hands_f$level.creature", SheetClient="basic_tryker_male.creature", Level=220, RingAccess="l6", Equipment="t_mage_celestial_curser_220_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.t_mage_celestial_curser_220", entries.t_mage_celestial_curser_220)
	entries.z_mage_celestial_curser_220 = { Class="NpcCustom", Type="base", Base="palette.entities.bandit", Sheet="ring_magic_curser_fear_f2.creature", SheetModel="ring_magic_curser_$hands_f$level.creature", SheetClient="basic_zorai_male.creature", Level=220, RingAccess="j7", Equipment="z_mage_celestial_curser_220_equipment" } r2.addPaletteElement("palette.entities.npcs.bandits.z_mage_celestial_curser_220", entries.z_mage_celestial_curser_220)


	entries.f_mage_celestial_curser_20_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icfalv"] = "icfalv.sitem", }, legs = { ["uiR2EDequipment_icfacp"] = "icfacp.sitem", }, boots = { ["uiR2EDequipment_icfalb"] = "icfalb.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", }, gloves = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icfalg"] = "icfalg.sitem", }, hands = { ["uiR2EDequipment_fear"] = "icfm2ms.sitem::fear", ["uiR2EDequipment_stun"] = "icfm2ms.sitem::stun", ["uiR2EDequipment_sleep"] = "icfm2ms.sitem::sleep",  }, } r2.addR2PlayerEquipment(entries.f_mage_celestial_curser_20, entries.f_mage_celestial_curser_20_equipment)
	entries.m_mage_celestial_curser_20_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icmalv"] = "icmalv.sitem", }, legs = { ["uiR2EDequipment_icmacp"] = "icmacp.sitem", }, boots = { ["uiR2EDequipment_icmalb"] = "icmalb.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", }, gloves = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icmalg"] = "icmalg.sitem", }, hands = { ["uiR2EDequipment_fear"] = "icmm2ms.sitem::fear", ["uiR2EDequipment_stun"] = "icmm2ms.sitem::stun", ["uiR2EDequipment_sleep"] = "icmm2ms.sitem::sleep",  }, } r2.addR2PlayerEquipment(entries.m_mage_celestial_curser_20, entries.m_mage_celestial_curser_20_equipment)
	entries.t_mage_celestial_curser_20_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_ictalv"] = "ictalv.sitem", }, legs = { ["uiR2EDequipment_ictacp"] = "ictacp.sitem", }, boots = { ["uiR2EDequipment_ictalb"] = "ictalb.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", }, gloves = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_ictalg"] = "ictalg.sitem", }, hands = { ["uiR2EDequipment_fear"] = "ictm2ms.sitem::fear", ["uiR2EDequipment_stun"] = "ictm2ms.sitem::stun", ["uiR2EDequipment_sleep"] = "ictm2ms.sitem::sleep",  }, } r2.addR2PlayerEquipment(entries.t_mage_celestial_curser_20, entries.t_mage_celestial_curser_20_equipment)
	entries.z_mage_celestial_curser_20_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_iczalv"] = "iczalv.sitem", }, legs = { ["uiR2EDequipment_iczacp"] = "iczacp.sitem", }, boots = { ["uiR2EDequipment_iczalb"] = "iczalb.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", }, gloves = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_iczalg"] = "iczalg.sitem", }, hands = { ["uiR2EDequipment_fear"] = "iczm2ms.sitem::fear", ["uiR2EDequipment_stun"] = "iczm2ms.sitem::stun", ["uiR2EDequipment_sleep"] = "iczm2ms.sitem::sleep",  }, } r2.addR2PlayerEquipment(entries.z_mage_celestial_curser_20, entries.z_mage_celestial_curser_20_equipment)

	entries.f_mage_celestial_curser_70_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icfalv"] = "icfalv.sitem", ["uiR2EDequipment_icfalv_2"] = "icfalv_2.sitem", }, legs = { ["uiR2EDequipment_icfacp"] = "icfacp.sitem", ["uiR2EDequipment_icfacp_2"] = "icfacp_2.sitem", }, boots = { ["uiR2EDequipment_icfalb"] = "icfalb.sitem", ["uiR2EDequipment_icfalb_2"] = "icfalb_2.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icfals"] = "icfals.sitem", ["uiR2EDequipment_icfals_2"] = "icfals_2.sitem", }, gloves = { ["uiR2EDequipment_icfalg"] = "icfalg.sitem", ["uiR2EDequipment_icfalg_2"] = "icfalg_2.sitem", }, hands = { ["uiR2EDequipment_fear"] = "icfm2ms_2.sitem::fear", ["uiR2EDequipment_stun"] = "icfm2ms_2.sitem::stun", ["uiR2EDequipment_sleep"] = "icfm2ms_2.sitem::sleep",  }, } r2.addR2PlayerEquipment(entries.f_mage_celestial_curser_70, entries.f_mage_celestial_curser_70_equipment)
	entries.m_mage_celestial_curser_70_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icmalv"] = "icmalv.sitem", ["uiR2EDequipment_icmalv_2"] = "icmalv_2.sitem", }, legs = { ["uiR2EDequipment_icmacp"] = "icmacp.sitem", ["uiR2EDequipment_icmacp_2"] = "icmacp_2.sitem", }, boots = { ["uiR2EDequipment_icmalb"] = "icmalb.sitem", ["uiR2EDequipment_icmalb_2"] = "icmalb_2.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icmals"] = "icmals.sitem", ["uiR2EDequipment_icmals_2"] = "icmals_2.sitem", }, gloves = { ["uiR2EDequipment_icmalg"] = "icmalg.sitem", ["uiR2EDequipment_icmalg_2"] = "icmalg_2.sitem", }, hands = { ["uiR2EDequipment_fear"] = "icmm2ms_2.sitem::fear", ["uiR2EDequipment_stun"] = "icmm2ms_2.sitem::stun", ["uiR2EDequipment_sleep"] = "icmm2ms_2.sitem::sleep",  }, } r2.addR2PlayerEquipment(entries.m_mage_celestial_curser_70, entries.m_mage_celestial_curser_70_equipment)
	entries.t_mage_celestial_curser_70_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_ictalv"] = "ictalv.sitem", ["uiR2EDequipment_ictalv_2"] = "ictalv_2.sitem", }, legs = { ["uiR2EDequipment_ictacp"] = "ictacp.sitem", ["uiR2EDequipment_ictacp_2"] = "ictacp_2.sitem", }, boots = { ["uiR2EDequipment_ictalb"] = "ictalb.sitem", ["uiR2EDequipment_ictalb_2"] = "ictalb_2.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_ictals"] = "ictals.sitem", ["uiR2EDequipment_ictals_2"] = "ictals_2.sitem", }, gloves = { ["uiR2EDequipment_ictalg"] = "ictalg.sitem", ["uiR2EDequipment_ictalg_2"] = "ictalg_2.sitem", }, hands = { ["uiR2EDequipment_fear"] = "ictm2ms_2.sitem::fear", ["uiR2EDequipment_stun"] = "ictm2ms_2.sitem::stun", ["uiR2EDequipment_sleep"] = "ictm2ms_2.sitem::sleep",  }, } r2.addR2PlayerEquipment(entries.t_mage_celestial_curser_70, entries.t_mage_celestial_curser_70_equipment)
	entries.z_mage_celestial_curser_70_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_iczalv"] = "iczalv.sitem", ["uiR2EDequipment_iczalv_2"] = "iczalv_2.sitem", }, legs = { ["uiR2EDequipment_iczacp"] = "iczacp.sitem", ["uiR2EDequipment_iczacp_2"] = "iczacp_2.sitem", }, boots = { ["uiR2EDequipment_iczalb"] = "iczalb.sitem", ["uiR2EDequipment_iczalb_2"] = "iczalb_2.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_iczals"] = "iczals.sitem", ["uiR2EDequipment_iczals_2"] = "iczals_2.sitem", }, gloves = { ["uiR2EDequipment_iczalg"] = "iczalg.sitem", ["uiR2EDequipment_iczalg_2"] = "iczalg_2.sitem", }, hands = { ["uiR2EDequipment_fear"] = "iczm2ms_2.sitem::fear", ["uiR2EDequipment_stun"] = "iczm2ms_2.sitem::stun", ["uiR2EDequipment_sleep"] = "iczm2ms_2.sitem::sleep",  }, } r2.addR2PlayerEquipment(entries.z_mage_celestial_curser_70, entries.z_mage_celestial_curser_70_equipment)

	entries.f_mage_celestial_curser_120_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icfalv"] = "icfalv.sitem", ["uiR2EDequipment_icfalv_2"] = "icfalv_2.sitem", }, legs = { ["uiR2EDequipment_icfacp"] = "icfacp.sitem", ["uiR2EDequipment_icfacp_2"] = "icfacp_2.sitem", }, boots = { ["uiR2EDequipment_icfalb"] = "icfalb.sitem", ["uiR2EDequipment_icfalb_2"] = "icfalb_2.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icfals"] = "icfals.sitem", ["uiR2EDequipment_icfals_2"] = "icfals_2.sitem", }, gloves = { ["uiR2EDequipment_icfalg"] = "icfalg.sitem", ["uiR2EDequipment_icfalg_2"] = "icfalg_2.sitem", }, hands = { ["uiR2EDequipment_fear"] = "icfm2ms_2.sitem::fear", ["uiR2EDequipment_stun"] = "icfm2ms_2.sitem::stun", ["uiR2EDequipment_sleep"] = "icfm2ms_2.sitem::sleep",  }, } r2.addR2PlayerEquipment(entries.f_mage_celestial_curser_120, entries.f_mage_celestial_curser_120_equipment)
	entries.m_mage_celestial_curser_120_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icmalv"] = "icmalv.sitem", ["uiR2EDequipment_icmalv_2"] = "icmalv_2.sitem", }, legs = { ["uiR2EDequipment_icmacp"] = "icmacp.sitem", ["uiR2EDequipment_icmacp_2"] = "icmacp_2.sitem", }, boots = { ["uiR2EDequipment_icmalb"] = "icmalb.sitem", ["uiR2EDequipment_icmalb_2"] = "icmalb_2.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icmals"] = "icmals.sitem", ["uiR2EDequipment_icmals_2"] = "icmals_2.sitem", }, gloves = { ["uiR2EDequipment_icmalg"] = "icmalg.sitem", ["uiR2EDequipment_icmalg_2"] = "icmalg_2.sitem", }, hands = { ["uiR2EDequipment_fear"] = "icmm2ms_2.sitem::fear", ["uiR2EDequipment_stun"] = "icmm2ms_2.sitem::stun", ["uiR2EDequipment_sleep"] = "icmm2ms_2.sitem::sleep",  }, } r2.addR2PlayerEquipment(entries.m_mage_celestial_curser_120, entries.m_mage_celestial_curser_120_equipment)
	entries.t_mage_celestial_curser_120_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_ictalv"] = "ictalv.sitem", ["uiR2EDequipment_ictalv_2"] = "ictalv_2.sitem", }, legs = { ["uiR2EDequipment_ictacp"] = "ictacp.sitem", ["uiR2EDequipment_ictacp_2"] = "ictacp_2.sitem", }, boots = { ["uiR2EDequipment_ictalb"] = "ictalb.sitem", ["uiR2EDequipment_ictalb_2"] = "ictalb_2.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_ictals"] = "ictals.sitem", ["uiR2EDequipment_ictals_2"] = "ictals_2.sitem", }, gloves = { ["uiR2EDequipment_ictalg"] = "ictalg.sitem", ["uiR2EDequipment_ictalg_2"] = "ictalg_2.sitem", }, hands = { ["uiR2EDequipment_fear"] = "ictm2ms_2.sitem::fear", ["uiR2EDequipment_stun"] = "ictm2ms_2.sitem::stun", ["uiR2EDequipment_sleep"] = "ictm2ms_2.sitem::sleep",  }, } r2.addR2PlayerEquipment(entries.t_mage_celestial_curser_120, entries.t_mage_celestial_curser_120_equipment)
	entries.z_mage_celestial_curser_120_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_iczalv"] = "iczalv.sitem", ["uiR2EDequipment_iczalv_2"] = "iczalv_2.sitem", }, legs = { ["uiR2EDequipment_iczacp"] = "iczacp.sitem", ["uiR2EDequipment_iczacp_2"] = "iczacp_2.sitem", }, boots = { ["uiR2EDequipment_iczalb"] = "iczalb.sitem", ["uiR2EDequipment_iczalb_2"] = "iczalb_2.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_iczals"] = "iczals.sitem", ["uiR2EDequipment_iczals_2"] = "iczals_2.sitem", }, gloves = { ["uiR2EDequipment_iczalg"] = "iczalg.sitem", ["uiR2EDequipment_iczalg_2"] = "iczalg_2.sitem", }, hands = { ["uiR2EDequipment_fear"] = "iczm2ms_2.sitem::fear", ["uiR2EDequipment_stun"] = "iczm2ms_2.sitem::stun", ["uiR2EDequipment_sleep"] = "iczm2ms_2.sitem::sleep",  }, } r2.addR2PlayerEquipment(entries.z_mage_celestial_curser_120, entries.z_mage_celestial_curser_120_equipment)

	entries.f_mage_celestial_curser_170_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icfalv_2"] = "icfalv_2.sitem", ["uiR2EDequipment_icfalv_3"] = "icfalv_3.sitem", }, legs = { ["uiR2EDequipment_icfacp_2"] = "icfacp_2.sitem", ["uiR2EDequipment_icfacp_3"] = "icfacp_3.sitem", }, boots = { ["uiR2EDequipment_icfalb_2"] = "icfalb_2.sitem", ["uiR2EDequipment_icfalb_3"] = "icfalb_3.sitem", }, arms_guard = { ["uiR2EDequipment_icfals_2"] = "icfals_2.sitem", ["uiR2EDequipment_icfals_3"] = "icfals_3.sitem", }, gloves = { ["uiR2EDequipment_icfalg_2"] = "icfalg_2.sitem", ["uiR2EDequipment_icfalg_3"] = "icfalg_3.sitem", }, hands = { ["uiR2EDequipment_fear"] = "icfm2ms_3.sitem::fear", ["uiR2EDequipment_stun"] = "icfm2ms_3.sitem::stun", ["uiR2EDequipment_sleep"] = "icfm2ms_3.sitem::sleep",  }, } r2.addR2PlayerEquipment(entries.f_mage_celestial_curser_170, entries.f_mage_celestial_curser_170_equipment)
	entries.m_mage_celestial_curser_170_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icmalv_2"] = "icmalv_2.sitem", ["uiR2EDequipment_icmalv_3"] = "icmalv_3.sitem", }, legs = { ["uiR2EDequipment_icmacp_2"] = "icmacp_2.sitem", ["uiR2EDequipment_icmacp_3"] = "icmacp_3.sitem", }, boots = { ["uiR2EDequipment_icmalb_2"] = "icmalb_2.sitem", ["uiR2EDequipment_icmalb_3"] = "icmalb_3.sitem", }, arms_guard = { ["uiR2EDequipment_icmals_2"] = "icmals_2.sitem", ["uiR2EDequipment_icmals_3"] = "icmals_3.sitem", }, gloves = { ["uiR2EDequipment_icmalg_2"] = "icmalg_2.sitem", ["uiR2EDequipment_icmalg_3"] = "icmalg_3.sitem", }, hands = { ["uiR2EDequipment_fear"] = "icmm2ms_3.sitem::fear", ["uiR2EDequipment_stun"] = "icmm2ms_3.sitem::stun", ["uiR2EDequipment_sleep"] = "icmm2ms_3.sitem::sleep",  }, } r2.addR2PlayerEquipment(entries.m_mage_celestial_curser_170, entries.m_mage_celestial_curser_170_equipment)
	entries.t_mage_celestial_curser_170_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_ictalv_2"] = "ictalv_2.sitem", ["uiR2EDequipment_ictalv_3"] = "ictalv_3.sitem", }, legs = { ["uiR2EDequipment_ictacp_2"] = "ictacp_2.sitem", ["uiR2EDequipment_ictacp_3"] = "ictacp_3.sitem", }, boots = { ["uiR2EDequipment_ictalb_2"] = "ictalb_2.sitem", ["uiR2EDequipment_ictalb_3"] = "ictalb_3.sitem", }, arms_guard = { ["uiR2EDequipment_ictals_2"] = "ictals_2.sitem", ["uiR2EDequipment_ictals_3"] = "ictals_3.sitem", }, gloves = { ["uiR2EDequipment_ictalg_2"] = "ictalg_2.sitem", ["uiR2EDequipment_ictalg_3"] = "ictalg_3.sitem", }, hands = { ["uiR2EDequipment_fear"] = "ictm2ms_3.sitem::fear", ["uiR2EDequipment_stun"] = "ictm2ms_3.sitem::stun", ["uiR2EDequipment_sleep"] = "ictm2ms_3.sitem::sleep",  }, } r2.addR2PlayerEquipment(entries.t_mage_celestial_curser_170, entries.t_mage_celestial_curser_170_equipment)
	entries.z_mage_celestial_curser_170_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_iczalv_2"] = "iczalv_2.sitem", ["uiR2EDequipment_iczalv_3"] = "iczalv_3.sitem", }, legs = { ["uiR2EDequipment_iczacp_2"] = "iczacp_2.sitem", ["uiR2EDequipment_iczacp_3"] = "iczacp_3.sitem", }, boots = { ["uiR2EDequipment_iczalb_2"] = "iczalb_2.sitem", ["uiR2EDequipment_iczalb_3"] = "iczalb_3.sitem", }, arms_guard = { ["uiR2EDequipment_iczals_2"] = "iczals_2.sitem", ["uiR2EDequipment_iczals_3"] = "iczals_3.sitem", }, gloves = { ["uiR2EDequipment_iczalg_2"] = "iczalg_2.sitem", ["uiR2EDequipment_iczalg_3"] = "iczalg_3.sitem", }, hands = { ["uiR2EDequipment_fear"] = "iczm2ms_3.sitem::fear", ["uiR2EDequipment_stun"] = "iczm2ms_3.sitem::stun", ["uiR2EDequipment_sleep"] = "iczm2ms_3.sitem::sleep",  }, } r2.addR2PlayerEquipment(entries.z_mage_celestial_curser_170, entries.z_mage_celestial_curser_170_equipment)

	entries.f_mage_celestial_curser_220_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icfalv_2"] = "icfalv_2.sitem", ["uiR2EDequipment_icfalv_3"] = "icfalv_3.sitem", }, legs = { ["uiR2EDequipment_icfacp_2"] = "icfacp_2.sitem", ["uiR2EDequipment_icfacp_3"] = "icfacp_3.sitem", }, boots = { ["uiR2EDequipment_icfalb_2"] = "icfalb_2.sitem", ["uiR2EDequipment_icfalb_3"] = "icfalb_3.sitem", }, arms_guard = { ["uiR2EDequipment_icfals_2"] = "icfals_2.sitem", ["uiR2EDequipment_icfals_3"] = "icfals_3.sitem", }, gloves = { ["uiR2EDequipment_icfalg_2"] = "icfalg_2.sitem", ["uiR2EDequipment_icfalg_3"] = "icfalg_3.sitem", }, hands = { ["uiR2EDequipment_fear"] = "icfm2ms_3.sitem::fear", ["uiR2EDequipment_stun"] = "icfm2ms_3.sitem::stun", ["uiR2EDequipment_sleep"] = "icfm2ms_3.sitem::sleep",  }, } r2.addR2PlayerEquipment(entries.f_mage_celestial_curser_220, entries.f_mage_celestial_curser_220_equipment)
	entries.m_mage_celestial_curser_220_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icmalv_2"] = "icmalv_2.sitem", ["uiR2EDequipment_icmalv_3"] = "icmalv_3.sitem", }, legs = { ["uiR2EDequipment_icmacp_2"] = "icmacp_2.sitem", ["uiR2EDequipment_icmacp_3"] = "icmacp_3.sitem", }, boots = { ["uiR2EDequipment_icmalb_2"] = "icmalb_2.sitem", ["uiR2EDequipment_icmalb_3"] = "icmalb_3.sitem", }, arms_guard = { ["uiR2EDequipment_icmals_2"] = "icmals_2.sitem", ["uiR2EDequipment_icmals_3"] = "icmals_3.sitem", }, gloves = { ["uiR2EDequipment_icmalg_2"] = "icmalg_2.sitem", ["uiR2EDequipment_icmalg_3"] = "icmalg_3.sitem", }, hands = { ["uiR2EDequipment_fear"] = "icmm2ms_3.sitem::fear", ["uiR2EDequipment_stun"] = "icmm2ms_3.sitem::stun", ["uiR2EDequipment_sleep"] = "icmm2ms_3.sitem::sleep",  }, } r2.addR2PlayerEquipment(entries.m_mage_celestial_curser_220, entries.m_mage_celestial_curser_220_equipment)
	entries.t_mage_celestial_curser_220_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_ictalv_2"] = "ictalv_2.sitem", ["uiR2EDequipment_ictalv_3"] = "ictalv_3.sitem", }, legs = { ["uiR2EDequipment_ictacp_2"] = "ictacp_2.sitem", ["uiR2EDequipment_ictacp_3"] = "ictacp_3.sitem", }, boots = { ["uiR2EDequipment_ictalb_2"] = "ictalb_2.sitem", ["uiR2EDequipment_ictalb_3"] = "ictalb_3.sitem", }, arms_guard = { ["uiR2EDequipment_ictals_2"] = "ictals_2.sitem", ["uiR2EDequipment_ictals_3"] = "ictals_3.sitem", }, gloves = { ["uiR2EDequipment_ictalg_2"] = "ictalg_2.sitem", ["uiR2EDequipment_ictalg_3"] = "ictalg_3.sitem", }, hands = { ["uiR2EDequipment_fear"] = "ictm2ms_3.sitem::fear", ["uiR2EDequipment_stun"] = "ictm2ms_3.sitem::stun", ["uiR2EDequipment_sleep"] = "ictm2ms_3.sitem::sleep",  }, } r2.addR2PlayerEquipment(entries.t_mage_celestial_curser_220, entries.t_mage_celestial_curser_220_equipment)
	entries.z_mage_celestial_curser_220_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_iczalv_2"] = "iczalv_2.sitem", ["uiR2EDequipment_iczalv_3"] = "iczalv_3.sitem", }, legs = { ["uiR2EDequipment_iczacp_2"] = "iczacp_2.sitem", ["uiR2EDequipment_iczacp_3"] = "iczacp_3.sitem", }, boots = { ["uiR2EDequipment_iczalb_2"] = "iczalb_2.sitem", ["uiR2EDequipment_iczalb_3"] = "iczalb_3.sitem", }, arms_guard = { ["uiR2EDequipment_iczals_2"] = "iczals_2.sitem", ["uiR2EDequipment_iczals_3"] = "iczals_3.sitem", }, gloves = { ["uiR2EDequipment_iczalg_2"] = "iczalg_2.sitem", ["uiR2EDequipment_iczalg_3"] = "iczalg_3.sitem", }, hands = { ["uiR2EDequipment_fear"] = "iczm2ms_3.sitem::fear", ["uiR2EDequipment_stun"] = "iczm2ms_3.sitem::stun", ["uiR2EDequipment_sleep"] = "iczm2ms_3.sitem::sleep",  }, } r2.addR2PlayerEquipment(entries.z_mage_celestial_curser_220, entries.z_mage_celestial_curser_220_equipment)


  

-- Civilians

	entries.f_civil_20 = { Class="NpcCustom", Type="base", Base="palette.entities.civil", Sheet="ring_civil_light_melee_blunt_b2.creature", SheetModel="ring_civil_light_melee_$hands_b$level.creature", SheetClient="basic_fyros_male.creature", Level=20, RingAccess="a1", Equipment="f_civil_20_equipment" } r2.addPaletteElement("palette.entities.npcs.civils.f_civil_20", entries.f_civil_20)
	entries.m_civil_20 = { Class="NpcCustom", Type="base", Base="palette.entities.civil", Sheet="ring_civil_light_melee_blunt_b2.creature", SheetModel="ring_civil_light_melee_$hands_b$level.creature", SheetClient="basic_matis_male.creature", Level=20, RingAccess="a1", Equipment="m_civil_20_equipment" } r2.addPaletteElement("palette.entities.npcs.civils.m_civil_20", entries.m_civil_20)
	entries.t_civil_20 = { Class="NpcCustom", Type="base", Base="palette.entities.civil", Sheet="ring_civil_light_melee_blunt_b2.creature", SheetModel="ring_civil_light_melee_$hands_b$level.creature", SheetClient="basic_tryker_male.creature", Level=20, RingAccess="a1", Equipment="t_civil_20_equipment" } r2.addPaletteElement("palette.entities.npcs.civils.t_civil_20", entries.t_civil_20)
	entries.z_civil_20 = { Class="NpcCustom", Type="base", Base="palette.entities.civil", Sheet="ring_civil_light_melee_blunt_b2.creature", SheetModel="ring_civil_light_melee_$hands_b$level.creature", SheetClient="basic_zorai_male.creature", Level=20, RingAccess="a1", Equipment="z_civil_20_equipment" } r2.addPaletteElement("palette.entities.npcs.civils.z_civil_20", entries.z_civil_20)

	entries.f_civil_70 = { Class="NpcCustom", Type="base", Base="palette.entities.civil", Sheet="ring_civil_light_melee_blunt_c2.creature", SheetModel="ring_civil_light_melee_$hands_c$level.creature", SheetClient="basic_fyros_male.creature", Level=70, RingAccess="d2", Equipment="f_civil_70_equipment" } r2.addPaletteElement("palette.entities.npcs.civils.f_civil_70", entries.f_civil_70)
	entries.m_civil_70 = { Class="NpcCustom", Type="base", Base="palette.entities.civil", Sheet="ring_civil_light_melee_blunt_c2.creature", SheetModel="ring_civil_light_melee_$hands_c$level.creature", SheetClient="basic_matis_male.creature", Level=70, RingAccess="f5", Equipment="m_civil_70_equipment" } r2.addPaletteElement("palette.entities.npcs.civils.m_civil_70", entries.m_civil_70)
	entries.t_civil_70 = { Class="NpcCustom", Type="base", Base="palette.entities.civil", Sheet="ring_civil_light_melee_blunt_c2.creature", SheetModel="ring_civil_light_melee_$hands_c$level.creature", SheetClient="basic_tryker_male.creature", Level=70, RingAccess="l5", Equipment="t_civil_70_equipment" } r2.addPaletteElement("palette.entities.npcs.civils.t_civil_70", entries.t_civil_70)
	entries.z_civil_70 = { Class="NpcCustom", Type="base", Base="palette.entities.civil", Sheet="ring_civil_light_melee_blunt_c2.creature", SheetModel="ring_civil_light_melee_$hands_c$level.creature", SheetClient="basic_zorai_male.creature", Level=70, RingAccess="j5", Equipment="z_civil_70_equipment" } r2.addPaletteElement("palette.entities.npcs.civils.z_civil_70", entries.z_civil_70)

	entries.f_civil_120 = { Class="NpcCustom", Type="base", Base="palette.entities.civil", Sheet="ring_civil_light_melee_blunt_d2.creature", SheetModel="ring_civil_light_melee_$hands_d$level.creature", SheetClient="basic_fyros_male.creature", Level=120, RingAccess="d4", Equipment="f_civil_120_equipment" } r2.addPaletteElement("palette.entities.npcs.civils.f_civil_120", entries.f_civil_120)
	entries.m_civil_120 = { Class="NpcCustom", Type="base", Base="palette.entities.civil", Sheet="ring_civil_light_melee_blunt_d2.creature", SheetModel="ring_civil_light_melee_$hands_d$level.creature", SheetClient="basic_matis_male.creature", Level=120, RingAccess="f5", Equipment="m_civil_120_equipment" } r2.addPaletteElement("palette.entities.npcs.civils.m_civil_120", entries.m_civil_120)
	entries.t_civil_120 = { Class="NpcCustom", Type="base", Base="palette.entities.civil", Sheet="ring_civil_light_melee_blunt_d2.creature", SheetModel="ring_civil_light_melee_$hands_d$level.creature", SheetClient="basic_tryker_male.creature", Level=120, RingAccess="l5", Equipment="t_civil_120_equipment" } r2.addPaletteElement("palette.entities.npcs.civils.t_civil_120", entries.t_civil_120)
	entries.z_civil_120 = { Class="NpcCustom", Type="base", Base="palette.entities.civil", Sheet="ring_civil_light_melee_blunt_d2.creature", SheetModel="ring_civil_light_melee_$hands_d$level.creature", SheetClient="basic_zorai_male.creature", Level=120, RingAccess="j5", Equipment="z_civil_120_equipment" } r2.addPaletteElement("palette.entities.npcs.civils.z_civil_120", entries.z_civil_120)

	entries.f_civil_170 = { Class="NpcCustom", Type="base", Base="palette.entities.civil", Sheet="ring_civil_light_melee_blunt_e2.creature", SheetModel="ring_civil_light_melee_$hands_e$level.creature", SheetClient="basic_fyros_male.creature", Level=170, RingAccess="d6", Equipment="f_civil_170_equipment" } r2.addPaletteElement("palette.entities.npcs.civils.f_civil_170", entries.f_civil_170)
	entries.m_civil_170 = { Class="NpcCustom", Type="base", Base="palette.entities.civil", Sheet="ring_civil_light_melee_blunt_e2.creature", SheetModel="ring_civil_light_melee_$hands_e$level.creature", SheetClient="basic_matis_male.creature", Level=170, RingAccess="f6", Equipment="m_civil_170_equipment" } r2.addPaletteElement("palette.entities.npcs.civils.m_civil_170", entries.m_civil_170)
	entries.t_civil_170 = { Class="NpcCustom", Type="base", Base="palette.entities.civil", Sheet="ring_civil_light_melee_blunt_e2.creature", SheetModel="ring_civil_light_melee_$hands_e$level.creature", SheetClient="basic_tryker_male.creature", Level=170, RingAccess="l5", Equipment="t_civil_170_equipment" } r2.addPaletteElement("palette.entities.npcs.civils.t_civil_170", entries.t_civil_170)
	entries.z_civil_170 = { Class="NpcCustom", Type="base", Base="palette.entities.civil", Sheet="ring_civil_light_melee_blunt_e2.creature", SheetModel="ring_civil_light_melee_$hands_e$level.creature", SheetClient="basic_zorai_male.creature", Level=170, RingAccess="j6", Equipment="z_civil_170_equipment" } r2.addPaletteElement("palette.entities.npcs.civils.z_civil_170", entries.z_civil_170)

	entries.f_civil_220 = { Class="NpcCustom", Type="base", Base="palette.entities.civil", Sheet="ring_civil_light_melee_blunt_f2.creature", SheetModel="ring_civil_light_melee_$hands_f$level.creature", SheetClient="basic_fyros_male.creature", Level=220, RingAccess="d7", Equipment="f_civil_220_equipment" } r2.addPaletteElement("palette.entities.npcs.civils.f_civil_220", entries.f_civil_220)
	entries.m_civil_220 = { Class="NpcCustom", Type="base", Base="palette.entities.civil", Sheet="ring_civil_light_melee_blunt_f2.creature", SheetModel="ring_civil_light_melee_$hands_f$level.creature", SheetClient="basic_matis_male.creature", Level=220, RingAccess="f7", Equipment="m_civil_220_equipment" } r2.addPaletteElement("palette.entities.npcs.civils.m_civil_220", entries.m_civil_220)
	entries.t_civil_220 = { Class="NpcCustom", Type="base", Base="palette.entities.civil", Sheet="ring_civil_light_melee_blunt_f2.creature", SheetModel="ring_civil_light_melee_$hands_f$level.creature", SheetClient="basic_tryker_male.creature", Level=220, RingAccess="l6", Equipment="t_civil_220_equipment" } r2.addPaletteElement("palette.entities.npcs.civils.t_civil_220", entries.t_civil_220)
	entries.z_civil_220 = { Class="NpcCustom", Type="base", Base="palette.entities.civil", Sheet="ring_civil_light_melee_blunt_f2.creature", SheetModel="ring_civil_light_melee_$hands_f$level.creature", SheetClient="basic_zorai_male.creature", Level=220, RingAccess="j7", Equipment="z_civil_220_equipment" } r2.addPaletteElement("palette.entities.npcs.civils.z_civil_220", entries.z_civil_220)

	
	entries.f_civil_20_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icfalv"] = "icfalv.sitem", }, legs = { ["uiR2EDequipment_icfalp"] = "icfalp.sitem", }, boots = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icfalb"] = "icfalb.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", }, gloves = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icfalg"] = "icfalg.sitem", }, hands = { ["uiR2EDequipment_none"] = "::blunt", }, } r2.addR2PlayerEquipment(entries.f_civil_20, entries.f_civil_20_equipment)
	entries.m_civil_20_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icmalv"] = "icmalv.sitem", }, legs = { ["uiR2EDequipment_icmalp"] = "icmalp.sitem", }, boots = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icmalb"] = "icmalb.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", }, gloves = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icmalg"] = "icmalg.sitem", }, hands = { ["uiR2EDequipment_none"] = "::blunt", }, } r2.addR2PlayerEquipment(entries.m_civil_20, entries.m_civil_20_equipment)
	entries.t_civil_20_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_ictalv"] = "ictalv.sitem", }, legs = { ["uiR2EDequipment_ictalp"] = "ictalp.sitem", }, boots = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_ictalb"] = "ictalb.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", }, gloves = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_ictalg"] = "ictalg.sitem", }, hands = { ["uiR2EDequipment_none"] = "::blunt", }, } r2.addR2PlayerEquipment(entries.t_civil_20, entries.t_civil_20_equipment)
	entries.z_civil_20_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_iczalv"] = "iczalv.sitem", }, legs = { ["uiR2EDequipment_iczalp"] = "iczalp.sitem", }, boots = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_iczalb"] = "iczalb.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", }, gloves = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_iczalg"] = "iczalg.sitem", }, hands = { ["uiR2EDequipment_none"] = "::blunt", }, } r2.addR2PlayerEquipment(entries.z_civil_20, entries.z_civil_20_equipment)
	
	entries.f_civil_70_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icfalv"] = "icfalv.sitem", ["uiR2EDequipment_icfalv_2"] = "icfalv_2.sitem", }, legs = { ["uiR2EDequipment_icfalp"] = "icfalp.sitem", ["uiR2EDequipment_icfalp_2"] = "icfalp_2.sitem", }, boots = { ["uiR2EDequipment_icfalb"] = "icfalb.sitem", ["uiR2EDequipment_icfalb_2"] = "icfalb_2.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icfals"] = "icfals.sitem", ["uiR2EDequipment_icfals_2"] = "icfals_2.sitem", }, gloves = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icfalg"] = "icfalg.sitem", ["uiR2EDequipment_icfalg_2"] = "icfalg_2.sitem", }, hands = { ["uiR2EDequipment_none"] = "::blunt", }, } r2.addR2PlayerEquipment(entries.f_civil_70, entries.f_civil_70_equipment)
	entries.m_civil_70_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icmalv"] = "icmalv.sitem", ["uiR2EDequipment_icmalv_2"] = "icmalv_2.sitem", }, legs = { ["uiR2EDequipment_icmalp"] = "icmalp.sitem", ["uiR2EDequipment_icmalp_2"] = "icmalp_2.sitem", }, boots = { ["uiR2EDequipment_icmalb"] = "icmalb.sitem", ["uiR2EDequipment_icmalb_2"] = "icmalb_2.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icmals"] = "icmals.sitem", ["uiR2EDequipment_icmals_2"] = "icmals_2.sitem", }, gloves = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icmalg"] = "icmalg.sitem", ["uiR2EDequipment_icmalg_2"] = "icmalg_2.sitem", }, hands = { ["uiR2EDequipment_none"] = "::blunt", }, } r2.addR2PlayerEquipment(entries.m_civil_70, entries.m_civil_70_equipment)
	entries.t_civil_70_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_ictalv"] = "ictalv.sitem", ["uiR2EDequipment_ictalv_2"] = "ictalv_2.sitem", }, legs = { ["uiR2EDequipment_ictalp"] = "ictalp.sitem", ["uiR2EDequipment_ictalp_2"] = "ictalp_2.sitem", }, boots = { ["uiR2EDequipment_ictalb"] = "ictalb.sitem", ["uiR2EDequipment_ictalb_2"] = "ictalb_2.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_ictals"] = "ictals.sitem", ["uiR2EDequipment_ictals_2"] = "ictals_2.sitem", }, gloves = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_ictalg"] = "ictalg.sitem", ["uiR2EDequipment_ictalg_2"] = "ictalg_2.sitem", }, hands = { ["uiR2EDequipment_none"] = "::blunt", }, } r2.addR2PlayerEquipment(entries.t_civil_70, entries.t_civil_70_equipment)
	entries.z_civil_70_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_iczalv"] = "iczalv.sitem", ["uiR2EDequipment_iczalv_2"] = "iczalv_2.sitem", }, legs = { ["uiR2EDequipment_iczalp"] = "iczalp.sitem", ["uiR2EDequipment_iczalp_2"] = "iczalp_2.sitem", }, boots = { ["uiR2EDequipment_iczalb"] = "iczalb.sitem", ["uiR2EDequipment_iczalb_2"] = "iczalb_2.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_iczals"] = "iczals.sitem", ["uiR2EDequipment_iczals_2"] = "iczals_2.sitem", }, gloves = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_iczalg"] = "iczalg.sitem", ["uiR2EDequipment_iczalg_2"] = "iczalg_2.sitem", }, hands = { ["uiR2EDequipment_none"] = "::blunt", }, } r2.addR2PlayerEquipment(entries.z_civil_70, entries.z_civil_70_equipment)
	
	entries.f_civil_120_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icfalv"] = "icfalv.sitem", ["uiR2EDequipment_icfalv_2"] = "icfalv_2.sitem", }, legs = { ["uiR2EDequipment_icfalp"] = "icfalp.sitem", ["uiR2EDequipment_icfalp_2"] = "icfalp_2.sitem", }, boots = { ["uiR2EDequipment_icfalb"] = "icfalb.sitem", ["uiR2EDequipment_icfalb_2"] = "icfalb_2.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icfals"] = "icfals.sitem", ["uiR2EDequipment_icfals_2"] = "icfals_2.sitem", }, gloves = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icfalg"] = "icfalg.sitem", ["uiR2EDequipment_icfalg_2"] = "icfalg_2.sitem", }, hands = { ["uiR2EDequipment_none"] = "::blunt", }, } r2.addR2PlayerEquipment(entries.f_civil_120, entries.f_civil_120_equipment)
	entries.m_civil_120_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icmalv"] = "icmalv.sitem", ["uiR2EDequipment_icmalv_2"] = "icmalv_2.sitem", }, legs = { ["uiR2EDequipment_icmalp"] = "icmalp.sitem", ["uiR2EDequipment_icmalp_2"] = "icmalp_2.sitem", }, boots = { ["uiR2EDequipment_icmalb"] = "icmalb.sitem", ["uiR2EDequipment_icmalb_2"] = "icmalb_2.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icmals"] = "icmals.sitem", ["uiR2EDequipment_icmals_2"] = "icmals_2.sitem", }, gloves = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icmalg"] = "icmalg.sitem", ["uiR2EDequipment_icmalg_2"] = "icmalg_2.sitem", }, hands = { ["uiR2EDequipment_none"] = "::blunt", }, } r2.addR2PlayerEquipment(entries.m_civil_120, entries.m_civil_120_equipment)
	entries.t_civil_120_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_ictalv"] = "ictalv.sitem", ["uiR2EDequipment_ictalv_2"] = "ictalv_2.sitem", }, legs = { ["uiR2EDequipment_ictalp"] = "ictalp.sitem", ["uiR2EDequipment_ictalp_2"] = "ictalp_2.sitem", }, boots = { ["uiR2EDequipment_ictalb"] = "ictalb.sitem", ["uiR2EDequipment_ictalb_2"] = "ictalb_2.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_ictals"] = "ictals.sitem", ["uiR2EDequipment_ictals_2"] = "ictals_2.sitem", }, gloves = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_ictalg"] = "ictalg.sitem", ["uiR2EDequipment_ictalg_2"] = "ictalg_2.sitem", }, hands = { ["uiR2EDequipment_none"] = "::blunt", }, } r2.addR2PlayerEquipment(entries.t_civil_120, entries.t_civil_120_equipment)
	entries.z_civil_120_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_iczalv"] = "iczalv.sitem", ["uiR2EDequipment_iczalv_2"] = "iczalv_2.sitem", }, legs = { ["uiR2EDequipment_iczalp"] = "iczalp.sitem", ["uiR2EDequipment_iczalp_2"] = "iczalp_2.sitem", }, boots = { ["uiR2EDequipment_iczalb"] = "iczalb.sitem", ["uiR2EDequipment_iczalb_2"] = "iczalb_2.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_iczals"] = "iczals.sitem", ["uiR2EDequipment_iczals_2"] = "iczals_2.sitem", }, gloves = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_iczalg"] = "iczalg.sitem", ["uiR2EDequipment_iczalg_2"] = "iczalg_2.sitem", }, hands = { ["uiR2EDequipment_none"] = "::blunt", }, } r2.addR2PlayerEquipment(entries.z_civil_120, entries.z_civil_120_equipment)
	
	entries.f_civil_170_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icfalv_2"] = "icfalv_2.sitem", ["uiR2EDequipment_icfamv_2"] = "icfamv_2.sitem", ["uiR2EDequipment_icfalv_3"] = "icfalv_3.sitem", ["uiR2EDequipment_icfamv_3"] = "icfamv_3.sitem", }, legs = { ["uiR2EDequipment_icfalp_2"] = "icfalp_2.sitem", ["uiR2EDequipment_icfamp_2"] = "icfamp_2.sitem", ["uiR2EDequipment_icfalp_3"] = "icfalp_3.sitem", ["uiR2EDequipment_icfamp_3"] = "icfamp_3.sitem", }, boots = { ["uiR2EDequipment_icfalb_2"] = "icfalb_2.sitem", ["uiR2EDequipment_icfamb_2"] = "icfamb_2.sitem", ["uiR2EDequipment_icfalb_3"] = "icfalb_3.sitem", ["uiR2EDequipment_icfamb_3"] = "icfamb_3.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icfals_2"] = "icfals_2.sitem", ["uiR2EDequipment_icfams_2"] = "icfams_2.sitem", ["uiR2EDequipment_icfals_3"] = "icfals_3.sitem", ["uiR2EDequipment_icfams_3"] = "icfams_3.sitem", }, gloves = { ["uiR2EDequipment_icfalg_2"] = "icfalg_2.sitem", ["uiR2EDequipment_icfalg_3"] = "icfalg_3.sitem", }, hands = { ["uiR2EDequipment_none"] = "::blunt", }, } r2.addR2PlayerEquipment(entries.f_civil_170, entries.f_civil_170_equipment)
	entries.m_civil_170_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icmalv_2"] = "icmalv_2.sitem", ["uiR2EDequipment_icmamv_2"] = "icmamv_2.sitem", ["uiR2EDequipment_icmalv_3"] = "icmalv_3.sitem", ["uiR2EDequipment_icmamv_3"] = "icmamv_3.sitem", }, legs = { ["uiR2EDequipment_icmalp_2"] = "icmalp_2.sitem", ["uiR2EDequipment_icmamp_2"] = "icmamp_2.sitem", ["uiR2EDequipment_icmalp_3"] = "icmalp_3.sitem", ["uiR2EDequipment_icmamp_3"] = "icmamp_3.sitem", }, boots = { ["uiR2EDequipment_icmalb_2"] = "icmalb_2.sitem", ["uiR2EDequipment_icmamb_2"] = "icmamb_2.sitem", ["uiR2EDequipment_icmalb_3"] = "icmalb_3.sitem", ["uiR2EDequipment_icmamb_3"] = "icmamb_3.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icmals_2"] = "icmals_2.sitem", ["uiR2EDequipment_icmams_2"] = "icmams_2.sitem", ["uiR2EDequipment_icmals_3"] = "icmals_3.sitem", ["uiR2EDequipment_icmams_3"] = "icmams_3.sitem", }, gloves = { ["uiR2EDequipment_icmalg_2"] = "icmalg_2.sitem", ["uiR2EDequipment_icmalg_3"] = "icmalg_3.sitem", }, hands = { ["uiR2EDequipment_none"] = "::blunt", }, } r2.addR2PlayerEquipment(entries.m_civil_170, entries.m_civil_170_equipment)
	entries.t_civil_170_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_ictalv_2"] = "ictalv_2.sitem", ["uiR2EDequipment_ictamv_2"] = "ictamv_2.sitem", ["uiR2EDequipment_ictalv_3"] = "ictalv_3.sitem", ["uiR2EDequipment_ictamv_3"] = "ictamv_3.sitem", }, legs = { ["uiR2EDequipment_ictalp_2"] = "ictalp_2.sitem", ["uiR2EDequipment_ictamp_2"] = "ictamp_2.sitem", ["uiR2EDequipment_ictalp_3"] = "ictalp_3.sitem", ["uiR2EDequipment_ictamp_3"] = "ictamp_3.sitem", }, boots = { ["uiR2EDequipment_ictalb_2"] = "ictalb_2.sitem", ["uiR2EDequipment_ictamb_2"] = "ictamb_2.sitem", ["uiR2EDequipment_ictalb_3"] = "ictalb_3.sitem", ["uiR2EDequipment_ictamb_3"] = "ictamb_3.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_ictals_2"] = "ictals_2.sitem", ["uiR2EDequipment_ictams_2"] = "ictams_2.sitem", ["uiR2EDequipment_ictals_3"] = "ictals_3.sitem", ["uiR2EDequipment_ictams_3"] = "ictams_3.sitem", }, gloves = { ["uiR2EDequipment_ictalg_2"] = "ictalg_2.sitem", ["uiR2EDequipment_ictalg_3"] = "ictalg_3.sitem", }, hands = { ["uiR2EDequipment_none"] = "::blunt", }, } r2.addR2PlayerEquipment(entries.t_civil_170, entries.t_civil_170_equipment)
	entries.z_civil_170_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_iczalv_2"] = "iczalv_2.sitem", ["uiR2EDequipment_iczamv_2"] = "iczamv_2.sitem", ["uiR2EDequipment_iczalv_3"] = "iczalv_3.sitem", ["uiR2EDequipment_iczamv_3"] = "iczamv_3.sitem", }, legs = { ["uiR2EDequipment_iczalp_2"] = "iczalp_2.sitem", ["uiR2EDequipment_iczamp_2"] = "iczamp_2.sitem", ["uiR2EDequipment_iczalp_3"] = "iczalp_3.sitem", ["uiR2EDequipment_iczamp_3"] = "iczamp_3.sitem", }, boots = { ["uiR2EDequipment_iczalb_2"] = "iczalb_2.sitem", ["uiR2EDequipment_iczamb_2"] = "iczamb_2.sitem", ["uiR2EDequipment_iczalb_3"] = "iczalb_3.sitem", ["uiR2EDequipment_iczamb_3"] = "iczamb_3.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_iczals_2"] = "iczals_2.sitem", ["uiR2EDequipment_iczams_2"] = "iczams_2.sitem", ["uiR2EDequipment_iczals_3"] = "iczals_3.sitem", ["uiR2EDequipment_iczams_3"] = "iczams_3.sitem", }, gloves = { ["uiR2EDequipment_iczalg_2"] = "iczalg_2.sitem", ["uiR2EDequipment_iczalg_3"] = "iczalg_3.sitem", }, hands = { ["uiR2EDequipment_none"] = "::blunt", }, } r2.addR2PlayerEquipment(entries.z_civil_170, entries.z_civil_170_equipment)
	
	entries.f_civil_220_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icfalv_2"] = "icfalv_2.sitem", ["uiR2EDequipment_icfamv_2"] = "icfamv_2.sitem", ["uiR2EDequipment_icfalv_3"] = "icfalv_3.sitem", ["uiR2EDequipment_icfamv_3"] = "icfamv_3.sitem", }, legs = { ["uiR2EDequipment_icfalp_2"] = "icfalp_2.sitem", ["uiR2EDequipment_icfamp_2"] = "icfamp_2.sitem", ["uiR2EDequipment_icfalp_3"] = "icfalp_3.sitem", ["uiR2EDequipment_icfamp_3"] = "icfamp_3.sitem", }, boots = { ["uiR2EDequipment_icfalb_2"] = "icfalb_2.sitem", ["uiR2EDequipment_icfamb_2"] = "icfamb_2.sitem", ["uiR2EDequipment_icfalb_3"] = "icfalb_3.sitem", ["uiR2EDequipment_icfamb_3"] = "icfamb_3.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icfals_2"] = "icfals_2.sitem", ["uiR2EDequipment_icfams_2"] = "icfams_2.sitem", ["uiR2EDequipment_icfals_3"] = "icfals_3.sitem", ["uiR2EDequipment_icfams_3"] = "icfams_3.sitem", }, gloves = { ["uiR2EDequipment_icfalg_2"] = "icfalg_2.sitem", ["uiR2EDequipment_icfalg_3"] = "icfalg_3.sitem", }, hands = { ["uiR2EDequipment_none"] = "::blunt", }, } r2.addR2PlayerEquipment(entries.f_civil_220, entries.f_civil_220_equipment)
	entries.m_civil_220_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_icmalv_2"] = "icmalv_2.sitem", ["uiR2EDequipment_icmamv_2"] = "icmamv_2.sitem", ["uiR2EDequipment_icmalv_3"] = "icmalv_3.sitem", ["uiR2EDequipment_icmamv_3"] = "icmamv_3.sitem", }, legs = { ["uiR2EDequipment_icmalp_2"] = "icmalp_2.sitem", ["uiR2EDequipment_icmamp_2"] = "icmamp_2.sitem", ["uiR2EDequipment_icmalp_3"] = "icmalp_3.sitem", ["uiR2EDequipment_icmamp_3"] = "icmamp_3.sitem", }, boots = { ["uiR2EDequipment_icmalb_2"] = "icmalb_2.sitem", ["uiR2EDequipment_icmamb_2"] = "icmamb_2.sitem", ["uiR2EDequipment_icmalb_3"] = "icmalb_3.sitem", ["uiR2EDequipment_icmamb_3"] = "icmamb_3.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icmals_2"] = "icmals_2.sitem", ["uiR2EDequipment_icmams_2"] = "icmams_2.sitem", ["uiR2EDequipment_icmals_3"] = "icmals_3.sitem", ["uiR2EDequipment_icmams_3"] = "icmams_3.sitem", }, gloves = { ["uiR2EDequipment_icmalg_2"] = "icmalg_2.sitem", ["uiR2EDequipment_icmalg_3"] = "icmalg_3.sitem", }, hands = { ["uiR2EDequipment_none"] = "::blunt", }, } r2.addR2PlayerEquipment(entries.m_civil_220, entries.m_civil_220_equipment)
	entries.t_civil_220_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_ictalv_2"] = "ictalv_2.sitem", ["uiR2EDequipment_ictamv_2"] = "ictamv_2.sitem", ["uiR2EDequipment_ictalv_3"] = "ictalv_3.sitem", ["uiR2EDequipment_ictamv_3"] = "ictamv_3.sitem", }, legs = { ["uiR2EDequipment_ictalp_2"] = "ictalp_2.sitem", ["uiR2EDequipment_ictamp_2"] = "ictamp_2.sitem", ["uiR2EDequipment_ictalp_3"] = "ictalp_3.sitem", ["uiR2EDequipment_ictamp_3"] = "ictamp_3.sitem", }, boots = { ["uiR2EDequipment_ictalb_2"] = "ictalb_2.sitem", ["uiR2EDequipment_ictamb_2"] = "ictamb_2.sitem", ["uiR2EDequipment_ictalb_3"] = "ictalb_3.sitem", ["uiR2EDequipment_ictamb_3"] = "ictamb_3.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_ictals_2"] = "ictals_2.sitem", ["uiR2EDequipment_ictams_2"] = "ictams_2.sitem", ["uiR2EDequipment_ictals_3"] = "ictals_3.sitem", ["uiR2EDequipment_ictams_3"] = "ictams_3.sitem", }, gloves = { ["uiR2EDequipment_ictalg_2"] = "ictalg_2.sitem", ["uiR2EDequipment_ictalg_3"] = "ictalg_3.sitem", }, hands = { ["uiR2EDequipment_none"] = "::blunt", }, } r2.addR2PlayerEquipment(entries.t_civil_220, entries.t_civil_220_equipment)
	entries.z_civil_220_equipment = { helmet = { ["uiR2EDequipment_none"] = "", }, chest_plate = { ["uiR2EDequipment_iczalv_2"] = "iczalv_2.sitem", ["uiR2EDequipment_iczamv_2"] = "iczamv_2.sitem", ["uiR2EDequipment_iczalv_3"] = "iczalv_3.sitem", ["uiR2EDequipment_iczamv_3"] = "iczamv_3.sitem", }, legs = { ["uiR2EDequipment_iczalp_2"] = "iczalp_2.sitem", ["uiR2EDequipment_iczamp_2"] = "iczamp_2.sitem", ["uiR2EDequipment_iczalp_3"] = "iczalp_3.sitem", ["uiR2EDequipment_iczamp_3"] = "iczamp_3.sitem", }, boots = { ["uiR2EDequipment_iczalb_2"] = "iczalb_2.sitem", ["uiR2EDequipment_iczamb_2"] = "iczamb_2.sitem", ["uiR2EDequipment_iczalb_3"] = "iczalb_3.sitem", ["uiR2EDequipment_iczamb_3"] = "iczamb_3.sitem", }, arms_guard = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_iczals_2"] = "iczals_2.sitem", ["uiR2EDequipment_iczams_2"] = "iczams_2.sitem", ["uiR2EDequipment_iczals_3"] = "iczals_3.sitem", ["uiR2EDequipment_iczams_3"] = "iczams_3.sitem", }, gloves = { ["uiR2EDequipment_iczalg_2"] = "iczalg_2.sitem", ["uiR2EDequipment_iczalg_3"] = "iczalg_3.sitem", }, hands = { ["uiR2EDequipment_none"] = "::blunt", }, } r2.addR2PlayerEquipment(entries.z_civil_220, entries.z_civil_220_equipment)


-- Melee Guards

	entries.f_guard_45 = { Class="NpcCustom", Type="base", Base="palette.entities.guard", Sheet="ring_guard_melee_tank_slash_b4.creature", SheetModel="ring_guard_melee_tank_$hands_b$level.creature", SheetClient="basic_fyros_male.creature", Level=45, RingAccess="a1", Equipment="f_guard_45_equipment" } r2.addPaletteElement("palette.entities.npcs.guards.f_guard_45", entries.f_guard_45)
	entries.m_guard_45 = { Class="NpcCustom", Type="base", Base="palette.entities.guard", Sheet="ring_guard_melee_tank_pierce_b4.creature", SheetModel="ring_guard_melee_tank_$hands_b$level.creature", SheetClient="basic_matis_male.creature", Level=45, RingAccess="a1", Equipment="m_guard_45_equipment" } r2.addPaletteElement("palette.entities.npcs.guards.m_guard_45", entries.m_guard_45)
	entries.t_guard_45 = { Class="NpcCustom", Type="base", Base="palette.entities.guard", Sheet="ring_guard_melee_tank_pierce_b4.creature", SheetModel="ring_guard_melee_tank_$hands_b$level.creature", SheetClient="basic_tryker_male.creature", Level=45, RingAccess="a1", Equipment="t_guard_45_equipment" } r2.addPaletteElement("palette.entities.npcs.guards.t_guard_45", entries.t_guard_45)
	entries.z_guard_45 = { Class="NpcCustom", Type="base", Base="palette.entities.guard", Sheet="ring_guard_melee_tank_blunt_b4.creature", SheetModel="ring_guard_melee_tank_$hands_b$level.creature", SheetClient="basic_zorai_male.creature", Level=45, RingAccess="a1", Equipment="z_guard_45_equipment" } r2.addPaletteElement("palette.entities.npcs.guards.z_guard_45", entries.z_guard_45)

	entries.f_guard_95 = { Class="NpcCustom", Type="base", Base="palette.entities.guard", Sheet="ring_guard_melee_tank_slash_c4.creature", SheetModel="ring_guard_melee_tank_$hands_c$level.creature", SheetClient="basic_fyros_male.creature", Level=95, RingAccess="d2", Equipment="f_guard_95_equipment" } r2.addPaletteElement("palette.entities.npcs.guards.f_guard_95", entries.f_guard_95)
	entries.m_guard_95 = { Class="NpcCustom", Type="base", Base="palette.entities.guard", Sheet="ring_guard_melee_tank_slash_c4.creature", SheetModel="ring_guard_melee_tank_$hands_c$level.creature", SheetClient="basic_matis_male.creature", Level=95, RingAccess="f5", Equipment="m_guard_95_equipment" } r2.addPaletteElement("palette.entities.npcs.guards.m_guard_95", entries.m_guard_95)
	entries.t_guard_95 = { Class="NpcCustom", Type="base", Base="palette.entities.guard", Sheet="ring_guard_melee_tank_slash_c4.creature", SheetModel="ring_guard_melee_tank_$hands_c$level.creature", SheetClient="basic_tryker_male.creature", Level=95, RingAccess="l5", Equipment="t_guard_95_equipment" } r2.addPaletteElement("palette.entities.npcs.guards.t_guard_95", entries.t_guard_95)
	entries.z_guard_95 = { Class="NpcCustom", Type="base", Base="palette.entities.guard", Sheet="ring_guard_melee_tank_slash_c4.creature", SheetModel="ring_guard_melee_tank_$hands_c$level.creature", SheetClient="basic_zorai_male.creature", Level=95, RingAccess="j5", Equipment="z_guard_95_equipment" } r2.addPaletteElement("palette.entities.npcs.guards.z_guard_95", entries.z_guard_95)

	entries.f_guard_145 = { Class="NpcCustom", Type="base", Base="palette.entities.guard", Sheet="ring_guard_melee_tank_slash_d4.creature", SheetModel="ring_guard_melee_tank_$hands_d$level.creature", SheetClient="basic_fyros_male.creature", Level=145, RingAccess="d4", Equipment="f_guard_145_equipment" } r2.addPaletteElement("palette.entities.npcs.guards.f_guard_145", entries.f_guard_145)
	entries.m_guard_145 = { Class="NpcCustom", Type="base", Base="palette.entities.guard", Sheet="ring_guard_melee_tank_slash_d4.creature", SheetModel="ring_guard_melee_tank_$hands_d$level.creature", SheetClient="basic_matis_male.creature", Level=145, RingAccess="f5", Equipment="m_guard_145_equipment" } r2.addPaletteElement("palette.entities.npcs.guards.m_guard_145", entries.m_guard_145)
	entries.t_guard_145 = { Class="NpcCustom", Type="base", Base="palette.entities.guard", Sheet="ring_guard_melee_tank_slash_d4.creature", SheetModel="ring_guard_melee_tank_$hands_d$level.creature", SheetClient="basic_tryker_male.creature", Level=145, RingAccess="l5", Equipment="t_guard_145_equipment" } r2.addPaletteElement("palette.entities.npcs.guards.t_guard_145", entries.t_guard_145)
	entries.z_guard_145 = { Class="NpcCustom", Type="base", Base="palette.entities.guard", Sheet="ring_guard_melee_tank_slash_d4.creature", SheetModel="ring_guard_melee_tank_$hands_d$level.creature", SheetClient="basic_zorai_male.creature", Level=145, RingAccess="j5", Equipment="z_guard_145_equipment" } r2.addPaletteElement("palette.entities.npcs.guards.z_guard_145", entries.z_guard_145)

	entries.f_guard_195 = { Class="NpcCustom", Type="base", Base="palette.entities.guard", Sheet="ring_guard_melee_tank_slash_e4.creature", SheetModel="ring_guard_melee_tank_$hands_e$level.creature", SheetClient="basic_fyros_male.creature", Level=195, RingAccess="d6", Equipment="f_guard_195_equipment" } r2.addPaletteElement("palette.entities.npcs.guards.f_guard_195", entries.f_guard_195)
	entries.m_guard_195 = { Class="NpcCustom", Type="base", Base="palette.entities.guard", Sheet="ring_guard_melee_tank_slash_e4.creature", SheetModel="ring_guard_melee_tank_$hands_e$level.creature", SheetClient="basic_matis_male.creature", Level=195, RingAccess="f6", Equipment="m_guard_195_equipment" } r2.addPaletteElement("palette.entities.npcs.guards.m_guard_195", entries.m_guard_195)
	entries.t_guard_195 = { Class="NpcCustom", Type="base", Base="palette.entities.guard", Sheet="ring_guard_melee_tank_slash_e4.creature", SheetModel="ring_guard_melee_tank_$hands_e$level.creature", SheetClient="basic_tryker_male.creature", Level=195, RingAccess="l5", Equipment="t_guard_195_equipment" } r2.addPaletteElement("palette.entities.npcs.guards.t_guard_195", entries.t_guard_195)
	entries.z_guard_195 = { Class="NpcCustom", Type="base", Base="palette.entities.guard", Sheet="ring_guard_melee_tank_slash_e4.creature", SheetModel="ring_guard_melee_tank_$hands_e$level.creature", SheetClient="basic_zorai_male.creature", Level=195, RingAccess="j6", Equipment="z_guard_195_equipment" } r2.addPaletteElement("palette.entities.npcs.guards.z_guard_195", entries.z_guard_195)

	entries.f_guard_245 = { Class="NpcCustom", Type="base", Base="palette.entities.guard", Sheet="ring_guard_melee_tank_slash_f4.creature", SheetModel="ring_guard_melee_tank_$hands_f$level.creature", SheetClient="basic_fyros_male.creature", Level=245, RingAccess="d7", Equipment="f_guard_245_equipment" } r2.addPaletteElement("palette.entities.npcs.guards.f_guard_245", entries.f_guard_245)
	entries.m_guard_245 = { Class="NpcCustom", Type="base", Base="palette.entities.guard", Sheet="ring_guard_melee_tank_slash_f4.creature", SheetModel="ring_guard_melee_tank_$hands_f$level.creature", SheetClient="basic_matis_male.creature", Level=245, RingAccess="f7", Equipment="m_guard_245_equipment" } r2.addPaletteElement("palette.entities.npcs.guards.m_guard_245", entries.m_guard_245)
	entries.t_guard_245 = { Class="NpcCustom", Type="base", Base="palette.entities.guard", Sheet="ring_guard_melee_tank_slash_f4.creature", SheetModel="ring_guard_melee_tank_$hands_f$level.creature", SheetClient="basic_tryker_male.creature", Level=245, RingAccess="l6", Equipment="t_guard_245_equipment" } r2.addPaletteElement("palette.entities.npcs.guards.t_guard_245", entries.t_guard_245)
	entries.z_guard_245 = { Class="NpcCustom", Type="base", Base="palette.entities.guard", Sheet="ring_guard_melee_tank_slash_f4.creature", SheetModel="ring_guard_melee_tank_$hands_f$level.creature", SheetClient="basic_zorai_male.creature", Level=245, RingAccess="j7", Equipment="z_guard_245_equipment" } r2.addPaletteElement("palette.entities.npcs.guards.z_guard_245", entries.z_guard_245)

	
	entries.f_guard_45_equipment = { helmet = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icfahh"] = "icfahh.sitem", }, chest_plate = { ["uiR2EDequipment_icfamv"] = "icfamv.sitem", ["uiR2EDequipment_icfahv"] = "icfahv.sitem", }, legs = { ["uiR2EDequipment_icfamp"] = "icfamp.sitem", ["uiR2EDequipment_icfahp"] = "icfahp.sitem", }, boots = { ["uiR2EDequipment_icfamb"] = "icfamb.sitem", ["uiR2EDequipment_icfahb"] = "icfahb.sitem", }, arms_guard = { ["uiR2EDequipment_icfams"] = "icfams.sitem", ["uiR2EDequipment_icfahs"] = "icfahs.sitem", }, gloves = { ["uiR2EDequipment_icfamg"] = "icfamg.sitem", ["uiR2EDequipment_icfahg"] = "icfahg.sitem", }, hands = { ["uiR2EDequipment_icfm2ss"] = "icfm2ss.sitem::slash", ["uiR2EDequipment_icfm2sa"] = "icfm2sa.sitem::slash", ["uiR2EDequipment_icfm2bm"] = "icfm2bm.sitem::blunt", ["uiR2EDequipment_icfm2pp"] = "icfm2pp.sitem::pierce",  }, } r2.addR2PlayerEquipment(entries.f_guard_45, entries.f_guard_45_equipment)
	entries.m_guard_45_equipment = { helmet = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_icmahh"] = "icmahh.sitem", }, chest_plate = { ["uiR2EDequipment_icmamv"] = "icmamv.sitem", ["uiR2EDequipment_icmahv"] = "icmahv.sitem", }, legs = { ["uiR2EDequipment_icmamp"] = "icmamp.sitem", ["uiR2EDequipment_icmahp"] = "icmahp.sitem", }, boots = { ["uiR2EDequipment_icmamb"] = "icmamb.sitem", ["uiR2EDequipment_icmahb"] = "icmahb.sitem", }, arms_guard = { ["uiR2EDequipment_icmams"] = "icmams.sitem", ["uiR2EDequipment_icmahs"] = "icmahs.sitem", }, gloves = { ["uiR2EDequipment_icmamg"] = "icmamg.sitem", ["uiR2EDequipment_icmahg"] = "icmahg.sitem", }, hands = { ["uiR2EDequipment_icmm2ss"] = "icmm2ss.sitem::slash", ["uiR2EDequipment_icmm2sa"] = "icmm2sa.sitem::slash", ["uiR2EDequipment_icmm2bm"] = "icmm2bm.sitem::blunt", ["uiR2EDequipment_icmm2pp"] = "icmm2pp.sitem::pierce",  }, } r2.addR2PlayerEquipment(entries.m_guard_45, entries.m_guard_45_equipment)
	entries.t_guard_45_equipment = { helmet = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_ictahh"] = "ictahh.sitem", }, chest_plate = { ["uiR2EDequipment_ictamv"] = "ictamv.sitem", ["uiR2EDequipment_ictahv"] = "ictahv.sitem", }, legs = { ["uiR2EDequipment_ictamp"] = "ictamp.sitem", ["uiR2EDequipment_ictahp"] = "ictahp.sitem", }, boots = { ["uiR2EDequipment_ictamb"] = "ictamb.sitem", ["uiR2EDequipment_ictahb"] = "ictahb.sitem", }, arms_guard = { ["uiR2EDequipment_ictams"] = "ictams.sitem", ["uiR2EDequipment_ictahs"] = "ictahs.sitem", }, gloves = { ["uiR2EDequipment_ictamg"] = "ictamg.sitem", ["uiR2EDequipment_ictahg"] = "ictahg.sitem", }, hands = { ["uiR2EDequipment_ictm2ss"] = "ictm2ss.sitem::slash", ["uiR2EDequipment_ictm2sa"] = "ictm2sa.sitem::slash", ["uiR2EDequipment_ictm2bm"] = "ictm2bm.sitem::blunt", ["uiR2EDequipment_ictm2pp"] = "ictm2pp.sitem::pierce",  }, } r2.addR2PlayerEquipment(entries.t_guard_45, entries.t_guard_45_equipment)
	entries.z_guard_45_equipment = { helmet = { ["uiR2EDequipment_none"] = "", ["uiR2EDequipment_iczahh"] = "iczahh.sitem", }, chest_plate = { ["uiR2EDequipment_iczamv"] = "iczamv.sitem", ["uiR2EDequipment_iczahv"] = "iczahv.sitem", }, legs = { ["uiR2EDequipment_iczamp"] = "iczamp.sitem", ["uiR2EDequipment_iczahp"] = "iczahp.sitem", }, boots = { ["uiR2EDequipment_iczamb"] = "iczamb.sitem", ["uiR2EDequipment_iczahb"] = "iczahb.sitem", }, arms_guard = { ["uiR2EDequipment_iczams"] = "iczams.sitem", ["uiR2EDequipment_iczahs"] = "iczahs.sitem", }, gloves = { ["uiR2EDequipment_iczamg"] = "iczamg.sitem", ["uiR2EDequipment_iczahg"] = "iczahg.sitem", }, hands = { ["uiR2EDequipment_iczm2ss"] = "iczm2ss.sitem::slash", ["uiR2EDequipment_iczm2sa"] = "iczm2sa.sitem::slash", ["uiR2EDequipment_iczm2bm"] = "iczm2bm.sitem::blunt", ["uiR2EDequipment_iczm2pp"] = "iczm2pp.sitem::pierce",  }, } r2.addR2PlayerEquipment(entries.z_guard_45, entries.z_guard_45_equipment)
	
	entries.f_guard_95_equipment = { helmet = { ["uiR2EDequipment_icfahh"] = "icfahh.sitem", ["uiR2EDequipment_icfahh_2"] = "icfahh_2.sitem", }, chest_plate = { ["uiR2EDequipment_icfahv"] = "icfahv.sitem", ["uiR2EDequipment_icfahv_2"] = "icfahv_2.sitem", }, legs = { ["uiR2EDequipment_icfahp"] = "icfahp.sitem", ["uiR2EDequipment_icfahp_2"] = "icfahp_2.sitem", }, boots = { ["uiR2EDequipment_icfahb"] = "icfahb.sitem", ["uiR2EDequipment_icfahb_2"] = "icfahb_2.sitem", }, arms_guard = { ["uiR2EDequipment_icfahs"] = "icfahs.sitem", ["uiR2EDequipment_icfahs_2"] = "icfahs_2.sitem", }, gloves = { ["uiR2EDequipment_icfahg"] = "icfahg.sitem", ["uiR2EDequipment_icfahg_2"] = "icfahg_2.sitem", }, hands = { ["uiR2EDequipment_icfm2ss"] = "icfm2ss.sitem::slash", ["uiR2EDequipment_icfm2ss_2"] = "icfm2ss_2.sitem::slash", ["uiR2EDequipment_icfm2sa"] = "icfm2sa.sitem::slash", ["uiR2EDequipment_icfm2sa_2"] = "icfm2sa_2.sitem::slash", ["uiR2EDequipment_icfm2bm"] = "icfm2bm.sitem::blunt", ["uiR2EDequipment_icfm2bm_2"] = "icfm2bm_2.sitem::blunt", ["uiR2EDequipment_icfm2pp"] = "icfm2pp.sitem::pierce", ["uiR2EDequipment_icfm2pp_2"] = "icfm2pp_2.sitem::pierce",  }, } r2.addR2PlayerEquipment(entries.f_guard_95, entries.f_guard_95_equipment)
	entries.m_guard_95_equipment = { helmet = { ["uiR2EDequipment_icmahh"] = "icmahh.sitem", ["uiR2EDequipment_icmahh_2"] = "icmahh_2.sitem", }, chest_plate = { ["uiR2EDequipment_icmahv"] = "icmahv.sitem", ["uiR2EDequipment_icmahv_2"] = "icmahv_2.sitem", }, legs = { ["uiR2EDequipment_icmahp"] = "icmahp.sitem", ["uiR2EDequipment_icmahp_2"] = "icmahp_2.sitem", }, boots = { ["uiR2EDequipment_icmahb"] = "icmahb.sitem", ["uiR2EDequipment_icmahb_2"] = "icmahb_2.sitem", }, arms_guard = { ["uiR2EDequipment_icmahs"] = "icmahs.sitem", ["uiR2EDequipment_icmahs_2"] = "icmahs_2.sitem", }, gloves = { ["uiR2EDequipment_icmahg"] = "icmahg.sitem", ["uiR2EDequipment_icmahg_2"] = "icmahg_2.sitem", }, hands = { ["uiR2EDequipment_icmm2ss"] = "icmm2ss.sitem::slash", ["uiR2EDequipment_icmm2ss_2"] = "icmm2ss_2.sitem::slash", ["uiR2EDequipment_icmm2sa"] = "icmm2sa.sitem::slash", ["uiR2EDequipment_icmm2sa_2"] = "icmm2sa_2.sitem::slash", ["uiR2EDequipment_icmm2bm"] = "icmm2bm.sitem::blunt", ["uiR2EDequipment_icmm2bm_2"] = "icmm2bm_2.sitem::blunt", ["uiR2EDequipment_icmm2pp"] = "icmm2pp.sitem::pierce", ["uiR2EDequipment_icmm2pp_2"] = "icmm2pp_2.sitem::pierce",  }, } r2.addR2PlayerEquipment(entries.m_guard_95, entries.m_guard_95_equipment)
	entries.t_guard_95_equipment = { helmet = { ["uiR2EDequipment_ictahh"] = "ictahh.sitem", ["uiR2EDequipment_ictahh_2"] = "ictahh_2.sitem", }, chest_plate = { ["uiR2EDequipment_ictahv"] = "ictahv.sitem", ["uiR2EDequipment_ictahv_2"] = "ictahv_2.sitem", }, legs = { ["uiR2EDequipment_ictahp"] = "ictahp.sitem", ["uiR2EDequipment_ictahp_2"] = "ictahp_2.sitem", }, boots = { ["uiR2EDequipment_ictahb"] = "ictahb.sitem", ["uiR2EDequipment_ictahb_2"] = "ictahb_2.sitem", }, arms_guard = { ["uiR2EDequipment_ictahs"] = "ictahs.sitem", ["uiR2EDequipment_ictahs_2"] = "ictahs_2.sitem", }, gloves = { ["uiR2EDequipment_ictahg"] = "ictahg.sitem", ["uiR2EDequipment_ictahg_2"] = "ictahg_2.sitem", }, hands = { ["uiR2EDequipment_ictm2ss"] = "ictm2ss.sitem::slash", ["uiR2EDequipment_ictm2ss_2"] = "ictm2ss_2.sitem::slash", ["uiR2EDequipment_ictm2sa"] = "ictm2sa.sitem::slash", ["uiR2EDequipment_ictm2sa_2"] = "ictm2sa_2.sitem::slash", ["uiR2EDequipment_ictm2bm"] = "ictm2bm.sitem::blunt", ["uiR2EDequipment_ictm2bm_2"] = "ictm2bm_2.sitem::blunt", ["uiR2EDequipment_ictm2pp"] = "ictm2pp.sitem::pierce", ["uiR2EDequipment_ictm2pp_2"] = "ictm2pp_2.sitem::pierce",  }, } r2.addR2PlayerEquipment(entries.t_guard_95, entries.t_guard_95_equipment)
	entries.z_guard_95_equipment = { helmet = { ["uiR2EDequipment_iczahh"] = "iczahh.sitem", ["uiR2EDequipment_iczahh_2"] = "iczahh_2.sitem", }, chest_plate = { ["uiR2EDequipment_iczahv"] = "iczahv.sitem", ["uiR2EDequipment_iczahv_2"] = "iczahv_2.sitem", }, legs = { ["uiR2EDequipment_iczahp"] = "iczahp.sitem", ["uiR2EDequipment_iczahp_2"] = "iczahp_2.sitem", }, boots = { ["uiR2EDequipment_iczahb"] = "iczahb.sitem", ["uiR2EDequipment_iczahb_2"] = "iczahb_2.sitem", }, arms_guard = { ["uiR2EDequipment_iczahs"] = "iczahs.sitem", ["uiR2EDequipment_iczahs_2"] = "iczahs_2.sitem", }, gloves = { ["uiR2EDequipment_iczahg"] = "iczahg.sitem", ["uiR2EDequipment_iczahg_2"] = "iczahg_2.sitem", }, hands = { ["uiR2EDequipment_iczm2ss"] = "iczm2ss.sitem::slash", ["uiR2EDequipment_iczm2ss_2"] = "iczm2ss_2.sitem::slash", ["uiR2EDequipment_iczm2sa"] = "iczm2sa.sitem::slash", ["uiR2EDequipment_iczm2sa_2"] = "iczm2sa_2.sitem::slash", ["uiR2EDequipment_iczm2bm"] = "iczm2bm.sitem::blunt", ["uiR2EDequipment_iczm2bm_2"] = "iczm2bm_2.sitem::blunt", ["uiR2EDequipment_iczm2pp"] = "iczm2pp.sitem::pierce", ["uiR2EDequipment_iczm2pp_2"] = "iczm2pp_2.sitem::pierce",  }, } r2.addR2PlayerEquipment(entries.z_guard_95, entries.z_guard_95_equipment)
	
	entries.f_guard_145_equipment = { helmet = { ["uiR2EDequipment_icfahh"] = "icfahh.sitem", ["uiR2EDequipment_icfahh_2"] = "icfahh_2.sitem", }, chest_plate = { ["uiR2EDequipment_icfahv"] = "icfahv.sitem", ["uiR2EDequipment_icfahv_2"] = "icfahv_2.sitem", }, legs = { ["uiR2EDequipment_icfahp"] = "icfahp.sitem", ["uiR2EDequipment_icfahp_2"] = "icfahp_2.sitem", }, boots = { ["uiR2EDequipment_icfahb"] = "icfahb.sitem", ["uiR2EDequipment_icfahb_2"] = "icfahb_2.sitem", }, arms_guard = { ["uiR2EDequipment_icfahs"] = "icfahs.sitem", ["uiR2EDequipment_icfahs_2"] = "icfahs_2.sitem", }, gloves = { ["uiR2EDequipment_icfahg"] = "icfahg.sitem", ["uiR2EDequipment_icfahg_2"] = "icfahg_2.sitem", }, hands = { ["uiR2EDequipment_icfm2ss"] = "icfm2ss.sitem::slash", ["uiR2EDequipment_icfm2ss_2"] = "icfm2ss_2.sitem::slash", ["uiR2EDequipment_icfm2sa"] = "icfm2sa.sitem::slash", ["uiR2EDequipment_icfm2sa_2"] = "icfm2sa_2.sitem::slash", ["uiR2EDequipment_icfm2bm"] = "icfm2bm.sitem::blunt", ["uiR2EDequipment_icfm2bm_2"] = "icfm2bm_2.sitem::blunt", ["uiR2EDequipment_icfm2pp"] = "icfm2pp.sitem::pierce", ["uiR2EDequipment_icfm2pp_2"] = "icfm2pp_2.sitem::pierce",  }, } r2.addR2PlayerEquipment(entries.f_guard_145, entries.f_guard_145_equipment)
	entries.m_guard_145_equipment = { helmet = { ["uiR2EDequipment_icmahh"] = "icmahh.sitem", ["uiR2EDequipment_icmahh_2"] = "icmahh_2.sitem", }, chest_plate = { ["uiR2EDequipment_icmahv"] = "icmahv.sitem", ["uiR2EDequipment_icmahv_2"] = "icmahv_2.sitem", }, legs = { ["uiR2EDequipment_icmahp"] = "icmahp.sitem", ["uiR2EDequipment_icmahp_2"] = "icmahp_2.sitem", }, boots = { ["uiR2EDequipment_icmahb"] = "icmahb.sitem", ["uiR2EDequipment_icmahb_2"] = "icmahb_2.sitem", }, arms_guard = { ["uiR2EDequipment_icmahs"] = "icmahs.sitem", ["uiR2EDequipment_icmahs_2"] = "icmahs_2.sitem", }, gloves = { ["uiR2EDequipment_icmahg"] = "icmahg.sitem", ["uiR2EDequipment_icmahg_2"] = "icmahg_2.sitem", }, hands = { ["uiR2EDequipment_icmm2ss"] = "icmm2ss.sitem::slash", ["uiR2EDequipment_icmm2ss_2"] = "icmm2ss_2.sitem::slash", ["uiR2EDequipment_icmm2sa"] = "icmm2sa.sitem::slash", ["uiR2EDequipment_icmm2sa_2"] = "icmm2sa_2.sitem::slash", ["uiR2EDequipment_icmm2bm"] = "icmm2bm.sitem::blunt", ["uiR2EDequipment_icmm2bm_2"] = "icmm2bm_2.sitem::blunt", ["uiR2EDequipment_icmm2pp"] = "icmm2pp.sitem::pierce", ["uiR2EDequipment_icmm2pp_2"] = "icmm2pp_2.sitem::pierce",  }, } r2.addR2PlayerEquipment(entries.m_guard_145, entries.m_guard_145_equipment)
	entries.t_guard_145_equipment = { helmet = { ["uiR2EDequipment_ictahh"] = "ictahh.sitem", ["uiR2EDequipment_ictahh_2"] = "ictahh_2.sitem", }, chest_plate = { ["uiR2EDequipment_ictahv"] = "ictahv.sitem", ["uiR2EDequipment_ictahv_2"] = "ictahv_2.sitem", }, legs = { ["uiR2EDequipment_ictahp"] = "ictahp.sitem", ["uiR2EDequipment_ictahp_2"] = "ictahp_2.sitem", }, boots = { ["uiR2EDequipment_ictahb"] = "ictahb.sitem", ["uiR2EDequipment_ictahb_2"] = "ictahb_2.sitem", }, arms_guard = { ["uiR2EDequipment_ictahs"] = "ictahs.sitem", ["uiR2EDequipment_ictahs_2"] = "ictahs_2.sitem", }, gloves = { ["uiR2EDequipment_ictahg"] = "ictahg.sitem", ["uiR2EDequipment_ictahg_2"] = "ictahg_2.sitem", }, hands = { ["uiR2EDequipment_ictm2ss"] = "ictm2ss.sitem::slash", ["uiR2EDequipment_ictm2ss_2"] = "ictm2ss_2.sitem::slash", ["uiR2EDequipment_ictm2sa"] = "ictm2sa.sitem::slash", ["uiR2EDequipment_ictm2sa_2"] = "ictm2sa_2.sitem::slash", ["uiR2EDequipment_ictm2bm"] = "ictm2bm.sitem::blunt", ["uiR2EDequipment_ictm2bm_2"] = "ictm2bm_2.sitem::blunt", ["uiR2EDequipment_ictm2pp"] = "ictm2pp.sitem::pierce", ["uiR2EDequipment_ictm2pp_2"] = "ictm2pp_2.sitem::pierce",  }, } r2.addR2PlayerEquipment(entries.t_guard_145, entries.t_guard_145_equipment)
	entries.z_guard_145_equipment = { helmet = { ["uiR2EDequipment_iczahh"] = "iczahh.sitem", ["uiR2EDequipment_iczahh_2"] = "iczahh_2.sitem", }, chest_plate = { ["uiR2EDequipment_iczahv"] = "iczahv.sitem", ["uiR2EDequipment_iczahv_2"] = "iczahv_2.sitem", }, legs = { ["uiR2EDequipment_iczahp"] = "iczahp.sitem", ["uiR2EDequipment_iczahp_2"] = "iczahp_2.sitem", }, boots = { ["uiR2EDequipment_iczahb"] = "iczahb.sitem", ["uiR2EDequipment_iczahb_2"] = "iczahb_2.sitem", }, arms_guard = { ["uiR2EDequipment_iczahs"] = "iczahs.sitem", ["uiR2EDequipment_iczahs_2"] = "iczahs_2.sitem", }, gloves = { ["uiR2EDequipment_iczahg"] = "iczahg.sitem", ["uiR2EDequipment_iczahg_2"] = "iczahg_2.sitem", }, hands = { ["uiR2EDequipment_iczm2ss"] = "iczm2ss.sitem::slash", ["uiR2EDequipment_iczm2ss_2"] = "iczm2ss_2.sitem::slash", ["uiR2EDequipment_iczm2sa"] = "iczm2sa.sitem::slash", ["uiR2EDequipment_iczm2sa_2"] = "iczm2sa_2.sitem::slash", ["uiR2EDequipment_iczm2bm"] = "iczm2bm.sitem::blunt", ["uiR2EDequipment_iczm2bm_2"] = "iczm2bm_2.sitem::blunt", ["uiR2EDequipment_iczm2pp"] = "iczm2pp.sitem::pierce", ["uiR2EDequipment_iczm2pp_2"] = "iczm2pp_2.sitem::pierce",  }, } r2.addR2PlayerEquipment(entries.z_guard_145, entries.z_guard_145_equipment)
	
	entries.f_guard_195_equipment = { helmet = { ["uiR2EDequipment_icfahh_2"] = "icfahh_2.sitem", ["uiR2EDequipment_icfahh_3"] = "icfahh_3.sitem", }, chest_plate = { ["uiR2EDequipment_icfahv_2"] = "icfahv_2.sitem", ["uiR2EDequipment_icfahv_3"] = "icfahv_3.sitem", }, legs = { ["uiR2EDequipment_icfahp_2"] = "icfahp_2.sitem", ["uiR2EDequipment_icfahp_3"] = "icfahp_3.sitem", }, boots = { ["uiR2EDequipment_icfahb_2"] = "icfahb_2.sitem", ["uiR2EDequipment_icfahb_3"] = "icfahb_3.sitem", }, arms_guard = { ["uiR2EDequipment_icfahs_2"] = "icfahs_2.sitem", ["uiR2EDequipment_icfahs_3"] = "icfahs_3.sitem", }, gloves = { ["uiR2EDequipment_icfahg_2"] = "icfahg_2.sitem", ["uiR2EDequipment_icfahg_3"] = "icfahg_3.sitem", }, hands = { ["uiR2EDequipment_icfm2ss_2"] = "icfm2ss_2.sitem::slash", ["uiR2EDequipment_icfm2ss_3"] = "icfm2ss_3.sitem::slash", ["uiR2EDequipment_icfm2sa_2"] = "icfm2sa_2.sitem::slash", ["uiR2EDequipment_icfm2sa_3"] = "icfm2sa_3.sitem::slash", ["uiR2EDequipment_icfm2bm_2"] = "icfm2bm_2.sitem::blunt", ["uiR2EDequipment_icfm2bm_3"] = "icfm2bm_3.sitem::blunt", ["uiR2EDequipment_icfm2pp_2"] = "icfm2pp_2.sitem::pierce", ["uiR2EDequipment_icfm2pp_3"] = "icfm2pp_3.sitem::pierce",  }, } r2.addR2PlayerEquipment(entries.f_guard_195, entries.f_guard_195_equipment)
	entries.m_guard_195_equipment = { helmet = { ["uiR2EDequipment_icmahh_2"] = "icmahh_2.sitem", ["uiR2EDequipment_icmahh_3"] = "icmahh_3.sitem", }, chest_plate = { ["uiR2EDequipment_icmahv_2"] = "icmahv_2.sitem", ["uiR2EDequipment_icmahv_3"] = "icmahv_3.sitem", }, legs = { ["uiR2EDequipment_icmahp_2"] = "icmahp_2.sitem", ["uiR2EDequipment_icmahp_3"] = "icmahp_3.sitem", }, boots = { ["uiR2EDequipment_icmahb_2"] = "icmahb_2.sitem", ["uiR2EDequipment_icmahb_3"] = "icmahb_3.sitem", }, arms_guard = { ["uiR2EDequipment_icmahs_2"] = "icmahs_2.sitem", ["uiR2EDequipment_icmahs_3"] = "icmahs_3.sitem", }, gloves = { ["uiR2EDequipment_icmahg_2"] = "icmahg_2.sitem", ["uiR2EDequipment_icmahg_3"] = "icmahg_3.sitem", }, hands = { ["uiR2EDequipment_icmm2ss_2"] = "icmm2ss_2.sitem::slash", ["uiR2EDequipment_icmm2ss_3"] = "icmm2ss_3.sitem::slash", ["uiR2EDequipment_icmm2sa_2"] = "icmm2sa_2.sitem::slash", ["uiR2EDequipment_icmm2sa_3"] = "icmm2sa_3.sitem::slash", ["uiR2EDequipment_icmm2bm_2"] = "icmm2bm_2.sitem::blunt", ["uiR2EDequipment_icmm2bm_3"] = "icmm2bm_3.sitem::blunt", ["uiR2EDequipment_icmm2pp_2"] = "icmm2pp_2.sitem::pierce", ["uiR2EDequipment_icmm2pp_3"] = "icmm2pp_3.sitem::pierce",  }, } r2.addR2PlayerEquipment(entries.m_guard_195, entries.m_guard_195_equipment)
	entries.t_guard_195_equipment = { helmet = { ["uiR2EDequipment_ictahh_2"] = "ictahh_2.sitem", ["uiR2EDequipment_ictahh_3"] = "ictahh_3.sitem", }, chest_plate = { ["uiR2EDequipment_ictahv_2"] = "ictahv_2.sitem", ["uiR2EDequipment_ictahv_3"] = "ictahv_3.sitem", }, legs = { ["uiR2EDequipment_ictahp_2"] = "ictahp_2.sitem", ["uiR2EDequipment_ictahp_3"] = "ictahp_3.sitem", }, boots = { ["uiR2EDequipment_ictahb_2"] = "ictahb_2.sitem", ["uiR2EDequipment_ictahb_3"] = "ictahb_3.sitem", }, arms_guard = { ["uiR2EDequipment_ictahs_2"] = "ictahs_2.sitem", ["uiR2EDequipment_ictahs_3"] = "ictahs_3.sitem", }, gloves = { ["uiR2EDequipment_ictahg_2"] = "ictahg_2.sitem", ["uiR2EDequipment_ictahg_3"] = "ictahg_3.sitem", }, hands = { ["uiR2EDequipment_ictm2ss_2"] = "ictm2ss_2.sitem::slash", ["uiR2EDequipment_ictm2ss_3"] = "ictm2ss_3.sitem::slash", ["uiR2EDequipment_ictm2sa_2"] = "ictm2sa_2.sitem::slash", ["uiR2EDequipment_ictm2sa_3"] = "ictm2sa_3.sitem::slash", ["uiR2EDequipment_ictm2bm_2"] = "ictm2bm_2.sitem::blunt", ["uiR2EDequipment_ictm2bm_3"] = "ictm2bm_3.sitem::blunt", ["uiR2EDequipment_ictm2pp_2"] = "ictm2pp_2.sitem::pierce", ["uiR2EDequipment_ictm2pp_3"] = "ictm2pp_3.sitem::pierce",  }, } r2.addR2PlayerEquipment(entries.t_guard_195, entries.t_guard_195_equipment)
	entries.z_guard_195_equipment = { helmet = { ["uiR2EDequipment_iczahh_2"] = "iczahh_2.sitem", ["uiR2EDequipment_iczahh_3"] = "iczahh_3.sitem", }, chest_plate = { ["uiR2EDequipment_iczahv_2"] = "iczahv_2.sitem", ["uiR2EDequipment_iczahv_3"] = "iczahv_3.sitem", }, legs = { ["uiR2EDequipment_iczahp_2"] = "iczahp_2.sitem", ["uiR2EDequipment_iczahp_3"] = "iczahp_3.sitem", }, boots = { ["uiR2EDequipment_iczahb_2"] = "iczahb_2.sitem", ["uiR2EDequipment_iczahb_3"] = "iczahb_3.sitem", }, arms_guard = { ["uiR2EDequipment_iczahs_2"] = "iczahs_2.sitem", ["uiR2EDequipment_iczahs_3"] = "iczahs_3.sitem", }, gloves = { ["uiR2EDequipment_iczahg_2"] = "iczahg_2.sitem", ["uiR2EDequipment_iczahg_3"] = "iczahg_3.sitem", }, hands = { ["uiR2EDequipment_iczm2ss_2"] = "iczm2ss_2.sitem::slash", ["uiR2EDequipment_iczm2ss_3"] = "iczm2ss_3.sitem::slash", ["uiR2EDequipment_iczm2sa_2"] = "iczm2sa_2.sitem::slash", ["uiR2EDequipment_iczm2sa_3"] = "iczm2sa_3.sitem::slash", ["uiR2EDequipment_iczm2bm_2"] = "iczm2bm_2.sitem::blunt", ["uiR2EDequipment_iczm2bm_3"] = "iczm2bm_3.sitem::blunt", ["uiR2EDequipment_iczm2pp_2"] = "iczm2pp_2.sitem::pierce", ["uiR2EDequipment_iczm2pp_3"] = "iczm2pp_3.sitem::pierce",  }, } r2.addR2PlayerEquipment(entries.z_guard_195, entries.z_guard_195_equipment)
	
	entries.f_guard_245_equipment = { helmet = { ["uiR2EDequipment_icfahh_2"] = "icfahh_2.sitem", ["uiR2EDequipment_icfahh_3"] = "icfahh_3.sitem", }, chest_plate = { ["uiR2EDequipment_icfahv_2"] = "icfahv_2.sitem", ["uiR2EDequipment_icfahv_3"] = "icfahv_3.sitem", }, legs = { ["uiR2EDequipment_icfahp_2"] = "icfahp_2.sitem", ["uiR2EDequipment_icfahp_3"] = "icfahp_3.sitem", }, boots = { ["uiR2EDequipment_icfahb_2"] = "icfahb_2.sitem", ["uiR2EDequipment_icfahb_3"] = "icfahb_3.sitem", }, arms_guard = { ["uiR2EDequipment_icfahs_2"] = "icfahs_2.sitem", ["uiR2EDequipment_icfahs_3"] = "icfahs_3.sitem", }, gloves = { ["uiR2EDequipment_icfahg_2"] = "icfahg_2.sitem", ["uiR2EDequipment_icfahg_3"] = "icfahg_3.sitem", }, hands = { ["uiR2EDequipment_icfm2ss_2"] = "icfm2ss_2.sitem::slash", ["uiR2EDequipment_icfm2ss_3"] = "icfm2ss_3.sitem::slash", ["uiR2EDequipment_icfm2sa_2"] = "icfm2sa_2.sitem::slash", ["uiR2EDequipment_icfm2sa_3"] = "icfm2sa_3.sitem::slash", ["uiR2EDequipment_icfm2bm_2"] = "icfm2bm_2.sitem::blunt", ["uiR2EDequipment_icfm2bm_3"] = "icfm2bm_3.sitem::blunt", ["uiR2EDequipment_icfm2pp_2"] = "icfm2pp_2.sitem::pierce", ["uiR2EDequipment_icfm2pp_3"] = "icfm2pp_3.sitem::pierce",  }, } r2.addR2PlayerEquipment(entries.f_guard_245, entries.f_guard_245_equipment)
	entries.m_guard_245_equipment = { helmet = { ["uiR2EDequipment_icmahh_2"] = "icmahh_2.sitem", ["uiR2EDequipment_icmahh_3"] = "icmahh_3.sitem", }, chest_plate = { ["uiR2EDequipment_icmahv_2"] = "icmahv_2.sitem", ["uiR2EDequipment_icmahv_3"] = "icmahv_3.sitem", }, legs = { ["uiR2EDequipment_icmahp_2"] = "icmahp_2.sitem", ["uiR2EDequipment_icmahp_3"] = "icmahp_3.sitem", }, boots = { ["uiR2EDequipment_icmahb_2"] = "icmahb_2.sitem", ["uiR2EDequipment_icmahb_3"] = "icmahb_3.sitem", }, arms_guard = { ["uiR2EDequipment_icmahs_2"] = "icmahs_2.sitem", ["uiR2EDequipment_icmahs_3"] = "icmahs_3.sitem", }, gloves = { ["uiR2EDequipment_icmahg_2"] = "icmahg_2.sitem", ["uiR2EDequipment_icmahg_3"] = "icmahg_3.sitem", }, hands = { ["uiR2EDequipment_icmm2ss_2"] = "icmm2ss_2.sitem::slash", ["uiR2EDequipment_icmm2ss_3"] = "icmm2ss_3.sitem::slash", ["uiR2EDequipment_icmm2sa_2"] = "icmm2sa_2.sitem::slash", ["uiR2EDequipment_icmm2sa_3"] = "icmm2sa_3.sitem::slash", ["uiR2EDequipment_icmm2bm_2"] = "icmm2bm_2.sitem::blunt", ["uiR2EDequipment_icmm2bm_3"] = "icmm2bm_3.sitem::blunt", ["uiR2EDequipment_icmm2pp_2"] = "icmm2pp_2.sitem::pierce", ["uiR2EDequipment_icmm2pp_3"] = "icmm2pp_3.sitem::pierce",  }, } r2.addR2PlayerEquipment(entries.m_guard_245, entries.m_guard_245_equipment)
	entries.t_guard_245_equipment = { helmet = { ["uiR2EDequipment_ictahh_2"] = "ictahh_2.sitem", ["uiR2EDequipment_ictahh_3"] = "ictahh_3.sitem", }, chest_plate = { ["uiR2EDequipment_ictahv_2"] = "ictahv_2.sitem", ["uiR2EDequipment_ictahv_3"] = "ictahv_3.sitem", }, legs = { ["uiR2EDequipment_ictahp_2"] = "ictahp_2.sitem", ["uiR2EDequipment_ictahp_3"] = "ictahp_3.sitem", }, boots = { ["uiR2EDequipment_ictahb_2"] = "ictahb_2.sitem", ["uiR2EDequipment_ictahb_3"] = "ictahb_3.sitem", }, arms_guard = { ["uiR2EDequipment_ictahs_2"] = "ictahs_2.sitem", ["uiR2EDequipment_ictahs_3"] = "ictahs_3.sitem", }, gloves = { ["uiR2EDequipment_ictahg_2"] = "ictahg_2.sitem", ["uiR2EDequipment_ictahg_3"] = "ictahg_3.sitem", }, hands = { ["uiR2EDequipment_ictm2ss_2"] = "ictm2ss_2.sitem::slash", ["uiR2EDequipment_ictm2ss_3"] = "ictm2ss_3.sitem::slash", ["uiR2EDequipment_ictm2sa_2"] = "ictm2sa_2.sitem::slash", ["uiR2EDequipment_ictm2sa_3"] = "ictm2sa_3.sitem::slash", ["uiR2EDequipment_ictm2bm_2"] = "ictm2bm_2.sitem::blunt", ["uiR2EDequipment_ictm2bm_3"] = "ictm2bm_3.sitem::blunt", ["uiR2EDequipment_ictm2pp_2"] = "ictm2pp_2.sitem::pierce", ["uiR2EDequipment_ictm2pp_3"] = "ictm2pp_3.sitem::pierce",  }, } r2.addR2PlayerEquipment(entries.t_guard_245, entries.t_guard_245_equipment)
	entries.z_guard_245_equipment = { helmet = { ["uiR2EDequipment_iczahh_2"] = "iczahh_2.sitem", ["uiR2EDequipment_iczahh_3"] = "iczahh_3.sitem", }, chest_plate = { ["uiR2EDequipment_iczahv_2"] = "iczahv_2.sitem", ["uiR2EDequipment_iczahv_3"] = "iczahv_3.sitem", }, legs = { ["uiR2EDequipment_iczahp_2"] = "iczahp_2.sitem", ["uiR2EDequipment_iczahp_3"] = "iczahp_3.sitem", }, boots = { ["uiR2EDequipment_iczahb_2"] = "iczahb_2.sitem", ["uiR2EDequipment_iczahb_3"] = "iczahb_3.sitem", }, arms_guard = { ["uiR2EDequipment_iczahs_2"] = "iczahs_2.sitem", ["uiR2EDequipment_iczahs_3"] = "iczahs_3.sitem", }, gloves = { ["uiR2EDequipment_iczahg_2"] = "iczahg_2.sitem", ["uiR2EDequipment_iczahg_3"] = "iczahg_3.sitem", }, hands = { ["uiR2EDequipment_iczm2ss_2"] = "iczm2ss_2.sitem::slash", ["uiR2EDequipment_iczm2ss_3"] = "iczm2ss_3.sitem::slash", ["uiR2EDequipment_iczm2sa_2"] = "iczm2sa_2.sitem::slash", ["uiR2EDequipment_iczm2sa_3"] = "iczm2sa_3.sitem::slash", ["uiR2EDequipment_iczm2bm_2"] = "iczm2bm_2.sitem::blunt", ["uiR2EDequipment_iczm2bm_3"] = "iczm2bm_3.sitem::blunt", ["uiR2EDequipment_iczm2pp_2"] = "iczm2pp_2.sitem::pierce", ["uiR2EDequipment_iczm2pp_3"] = "iczm2pp_3.sitem::pierce",  }, } r2.addR2PlayerEquipment(entries.z_guard_245, entries.z_guard_245_equipment)





-- Passive Creatures (birds & carnivores)
	entries.creature_cbadc1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbadc1.creature", Level=60, RingAccess="d2", Ecosystem="Desert", Region="c" } r2.addPaletteElement("palette.entities.creatures.cbadc1", entries.creature_cbadc1)
	entries.creature_cbadc2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbadc2.creature", Level=70, RingAccess="d2", Ecosystem="Desert", Region="c" } r2.addPaletteElement("palette.entities.creatures.cbadc2", entries.creature_cbadc2)
	entries.creature_cbadc3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbadc3.creature", Level=80, RingAccess="d2", Ecosystem="Desert", Region="c" } r2.addPaletteElement("palette.entities.creatures.cbadc3", entries.creature_cbadc3)
	entries.creature_cbadc4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbadc4.creature", Level=90, RingAccess="d2", Ecosystem="Desert", Region="c" } r2.addPaletteElement("palette.entities.creatures.cbadc4", entries.creature_cbadc4)
	entries.creature_cbadd1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbadd1.creature", Level=110, RingAccess="d4", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.cbadd1", entries.creature_cbadd1)
	entries.creature_cbadd2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbadd2.creature", Level=120, RingAccess="d4", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.cbadd2", entries.creature_cbadd2)
	entries.creature_cbadd3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbadd3.creature", Level=130, RingAccess="d4", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.cbadd3", entries.creature_cbadd3)
	entries.creature_cbadd4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbadd4.creature", Level=140, RingAccess="d4", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.cbadd4", entries.creature_cbadd4)
	--entries.creature_cbagb1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbagb1.creature", Level=10, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.cbagb1", entries.creature_cbagb1)
	--entries.creature_cbagb2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbagb2.creature", Level=20, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.cbagb2", entries.creature_cbagb2)
	--entries.creature_cbagb3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbagb3.creature", Level=30, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.cbagb3", entries.creature_cbagb3)
	--entries.creature_cbagb4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbagb4.creature", Level=40, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.cbagb4", entries.creature_cbagb4)
	--entries.creature_cbagc1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbagc1.creature", Level=60, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.cbagc1", entries.creature_cbagc1)
	--entries.creature_cbagc2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbagc2.creature", Level=70, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.cbagc2", entries.creature_cbagc2)
	--entries.creature_cbagc3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbagc3.creature", Level=80, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.cbagc3", entries.creature_cbagc3)
	--entries.creature_cbagc4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbagc4.creature", Level=90, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.cbagc4", entries.creature_cbagc4)
	--entries.creature_cbagd1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbagd1.creature", Level=110, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.cbagd1", entries.creature_cbagd1)
	--entries.creature_cbagd2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbagd2.creature", Level=120, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.cbagd2", entries.creature_cbagd2)
	--entries.creature_cbagd3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbagd3.creature", Level=130, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.cbagd3", entries.creature_cbagd3)
	--entries.creature_cbagd4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbagd4.creature", Level=140, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.cbagd4", entries.creature_cbagd4)
	--entries.creature_cbage1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbage1.creature", Level=160, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.cbage1", entries.creature_cbage1)
	--entries.creature_cbage2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbage2.creature", Level=170, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.cbage2", entries.creature_cbage2)
	--entries.creature_cbage3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbage3.creature", Level=180, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.cbage3", entries.creature_cbage3)
	--entries.creature_cbage4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbage4.creature", Level=190, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.cbage4", entries.creature_cbage4)
	--entries.creature_cbagf1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbagf1.creature", Level=210, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.cbagf1", entries.creature_cbagf1)
	--entries.creature_cbagf2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbagf2.creature", Level=220, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.cbagf2", entries.creature_cbagf2)
	--entries.creature_cbagf3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbagf3.creature", Level=230, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.cbagf3", entries.creature_cbagf3)
	--entries.creature_cbagf4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbagf4.creature", Level=240, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.cbagf4", entries.creature_cbagf4)
	entries.creature_cbajb4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbajb4.creature", Level=40, RingAccess="a1", Ecosystem="Jungle", Region="b" } r2.addPaletteElement("palette.entities.creatures.cbajb4", entries.creature_cbajb4)
	entries.creature_cbajd1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbajd1.creature", Level=110, RingAccess="j5", Ecosystem="Jungle", Region="d" } r2.addPaletteElement("palette.entities.creatures.cbajd1", entries.creature_cbajd1)
	entries.creature_cbajd2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbajd2.creature", Level=120, RingAccess="j5", Ecosystem="Jungle", Region="d" } r2.addPaletteElement("palette.entities.creatures.cbajd2", entries.creature_cbajd2)
	entries.creature_cbajd3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbajd3.creature", Level=130, RingAccess="j5", Ecosystem="Jungle", Region="d" } r2.addPaletteElement("palette.entities.creatures.cbajd3", entries.creature_cbajd3)
	entries.creature_cbajd4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbajd4.creature", Level=140, RingAccess="j5", Ecosystem="Jungle", Region="d" } r2.addPaletteElement("palette.entities.creatures.cbajd4", entries.creature_cbajd4)
	entries.creature_cbbda1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbbda1.creature", Level=10, RingAccess="a1", Ecosystem="Desert", Region="a" } r2.addPaletteElement("palette.entities.creatures.cbbda1", entries.creature_cbbda1)
	entries.creature_cbbda2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbbda2.creature", Level=17, RingAccess="a1", Ecosystem="Desert", Region="a" } r2.addPaletteElement("palette.entities.creatures.cbbda2", entries.creature_cbbda2)
	entries.creature_cbbdb1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbbdb1.creature", Level=10, RingAccess="a1", Ecosystem="Desert", Region="b" } r2.addPaletteElement("palette.entities.creatures.cbbdb1", entries.creature_cbbdb1)
	entries.creature_cbbdb2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbbdb2.creature", Level=20, RingAccess="a1", Ecosystem="Desert", Region="b" } r2.addPaletteElement("palette.entities.creatures.cbbdb2", entries.creature_cbbdb2)
	entries.creature_cbbdb3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbbdb3.creature", Level=30, RingAccess="a1", Ecosystem="Desert", Region="b" } r2.addPaletteElement("palette.entities.creatures.cbbdb3", entries.creature_cbbdb3)
	entries.creature_cbbdb4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbbdb4.creature", Level=40, RingAccess="a1", Ecosystem="Desert", Region="b" } r2.addPaletteElement("palette.entities.creatures.cbbdb4", entries.creature_cbbdb4)
	entries.creature_cbbdd4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbbdd4.creature", Level=140, RingAccess="d4", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.cbbdd4", entries.creature_cbbdd4)
	entries.creature_cbbja1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbbja1.creature", Level=10, RingAccess="a1", Ecosystem="Jungle", Region="a" } r2.addPaletteElement("palette.entities.creatures.cbbja1", entries.creature_cbbja1)
	entries.creature_cbbja2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbbja2.creature", Level=10, RingAccess="a1", Ecosystem="Jungle", Region="a" } r2.addPaletteElement("palette.entities.creatures.cbbja2", entries.creature_cbbja2)
	entries.creature_cbbjb1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbbjb1.creature", Level=10, RingAccess="a1", Ecosystem="Jungle", Region="b" } r2.addPaletteElement("palette.entities.creatures.cbbjb1", entries.creature_cbbjb1)
	entries.creature_cbbjb2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbbjb2.creature", Level=20, RingAccess="a1", Ecosystem="Jungle", Region="b" } r2.addPaletteElement("palette.entities.creatures.cbbjb2", entries.creature_cbbjb2)
	entries.creature_cbbjb3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbbjb3.creature", Level=30, RingAccess="a1", Ecosystem="Jungle", Region="b" } r2.addPaletteElement("palette.entities.creatures.cbbjb3", entries.creature_cbbjb3)
	entries.creature_cbbjb4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbbjb4.creature", Level=40, RingAccess="a1", Ecosystem="Jungle", Region="b" } r2.addPaletteElement("palette.entities.creatures.cbbjb4", entries.creature_cbbjb4)
	entries.creature_cbbjc1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbbjc1.creature", Level=60, RingAccess="j5", Ecosystem="Jungle", Region="c" } r2.addPaletteElement("palette.entities.creatures.cbbjc1", entries.creature_cbbjc1)
	entries.creature_cbbjc2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbbjc2.creature", Level=70, RingAccess="j5", Ecosystem="Jungle", Region="c" } r2.addPaletteElement("palette.entities.creatures.cbbjc2", entries.creature_cbbjc2)
	entries.creature_cbbjc3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbbjc3.creature", Level=80, RingAccess="j5", Ecosystem="Jungle", Region="c" } r2.addPaletteElement("palette.entities.creatures.cbbjc3", entries.creature_cbbjc3)
	entries.creature_cbbjc4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbbjc4.creature", Level=90, RingAccess="j5", Ecosystem="Jungle", Region="c" } r2.addPaletteElement("palette.entities.creatures.cbbjc4", entries.creature_cbbjc4)
	entries.creature_cbblc1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbblc1.creature", Level=60, RingAccess="l5", Ecosystem="Lacustre", Region="c" } r2.addPaletteElement("palette.entities.creatures.cbblc1", entries.creature_cbblc1)
	entries.creature_cbblc2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbblc2.creature", Level=70, RingAccess="l5", Ecosystem="Lacustre", Region="c" } r2.addPaletteElement("palette.entities.creatures.cbblc2", entries.creature_cbblc2)
	entries.creature_cbblc3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbblc3.creature", Level=80, RingAccess="l5", Ecosystem="Lacustre", Region="c" } r2.addPaletteElement("palette.entities.creatures.cbblc3", entries.creature_cbblc3)
	entries.creature_cbblc4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbblc4.creature", Level=90, RingAccess="l5", Ecosystem="Lacustre", Region="c" } r2.addPaletteElement("palette.entities.creatures.cbblc4", entries.creature_cbblc4)
	entries.creature_cbbld1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbbld1.creature", Level=110, RingAccess="l5", Ecosystem="Lacustre", Region="d" } r2.addPaletteElement("palette.entities.creatures.cbbld1", entries.creature_cbbld1)
	entries.creature_cbbld2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbbld2.creature", Level=120, RingAccess="l5", Ecosystem="Lacustre", Region="d" } r2.addPaletteElement("palette.entities.creatures.cbbld2", entries.creature_cbbld2)
	entries.creature_cbbld3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbbld3.creature", Level=130, RingAccess="l5", Ecosystem="Lacustre", Region="d" } r2.addPaletteElement("palette.entities.creatures.cbbld3", entries.creature_cbbld3)
	entries.creature_cbbld4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbbld4.creature", Level=140, RingAccess="l5", Ecosystem="Lacustre", Region="d" } r2.addPaletteElement("palette.entities.creatures.cbbld4", entries.creature_cbbld4)
	entries.creature_cbbpd1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbbpd1.creature", Level=110, RingAccess="p1", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.cbbpd1", entries.creature_cbbpd1)
	entries.creature_cbbpd2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbbpd2.creature", Level=120, RingAccess="p1", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.cbbpd2", entries.creature_cbbpd2)
	entries.creature_cbbpd3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbbpd3.creature", Level=130, RingAccess="p1", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.cbbpd3", entries.creature_cbbpd3)
	entries.creature_cbbpd4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbbpd4.creature", Level=140, RingAccess="p1", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.cbbpd4", entries.creature_cbbpd4)
	entries.creature_cbbpe4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbbpe4.creature", Level=190, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.cbbpe4", entries.creature_cbbpe4)
	--entries.creature_cbcgb1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbcgb1.creature", Level=10, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.cbcgb1", entries.creature_cbcgb1)
	--entries.creature_cbcgb2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbcgb2.creature", Level=20, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.cbcgb2", entries.creature_cbcgb2)
	--entries.creature_cbcgb3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbcgb3.creature", Level=30, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.cbcgb3", entries.creature_cbcgb3)
	--entries.creature_cbcgb4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbcgb4.creature", Level=40, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.cbcgb4", entries.creature_cbcgb4)
	--entries.creature_cbcgc1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbcgc1.creature", Level=60, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.cbcgc1", entries.creature_cbcgc1)
	--entries.creature_cbcgc2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbcgc2.creature", Level=70, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.cbcgc2", entries.creature_cbcgc2)
	--entries.creature_cbcgc3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbcgc3.creature", Level=80, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.cbcgc3", entries.creature_cbcgc3)
	--entries.creature_cbcgc4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbcgc4.creature", Level=90, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.cbcgc4", entries.creature_cbcgc4)
	--entries.creature_cbcgd1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbcgd1.creature", Level=110, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.cbcgd1", entries.creature_cbcgd1)
	--entries.creature_cbcgd2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbcgd2.creature", Level=120, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.cbcgd2", entries.creature_cbcgd2)
	--entries.creature_cbcgd3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbcgd3.creature", Level=130, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.cbcgd3", entries.creature_cbcgd3)
	--entries.creature_cbcgd4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbcgd4.creature", Level=140, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.cbcgd4", entries.creature_cbcgd4)
	--entries.creature_cbcge1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbcge1.creature", Level=160, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.cbcge1", entries.creature_cbcge1)
	--entries.creature_cbcge2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbcge2.creature", Level=170, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.cbcge2", entries.creature_cbcge2)
	--entries.creature_cbcge3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbcge3.creature", Level=180, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.cbcge3", entries.creature_cbcge3)
	--entries.creature_cbcge4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbcge4.creature", Level=190, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.cbcge4", entries.creature_cbcge4)
	--entries.creature_cbcgf1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbcgf1.creature", Level=210, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.cbcgf1", entries.creature_cbcgf1)
	--entries.creature_cbcgf2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbcgf2.creature", Level=220, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.cbcgf2", entries.creature_cbcgf2)
	--entries.creature_cbcgf3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbcgf3.creature", Level=230, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.cbcgf3", entries.creature_cbcgf3)
	--entries.creature_cbcgf4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbcgf4.creature", Level=240, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.cbcgf4", entries.creature_cbcgf4)
	entries.creature_cbcjc1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbcjc1.creature", Level=60, RingAccess="j5", Ecosystem="Jungle", Region="c" } r2.addPaletteElement("palette.entities.creatures.cbcjc1", entries.creature_cbcjc1)
	entries.creature_cbcjc2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbcjc2.creature", Level=70, RingAccess="j5", Ecosystem="Jungle", Region="c" } r2.addPaletteElement("palette.entities.creatures.cbcjc2", entries.creature_cbcjc2)
	entries.creature_cbcjc3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbcjc3.creature", Level=80, RingAccess="j5", Ecosystem="Jungle", Region="c" } r2.addPaletteElement("palette.entities.creatures.cbcjc3", entries.creature_cbcjc3)
	entries.creature_cbcjc4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbcjc4.creature", Level=90, RingAccess="j5", Ecosystem="Jungle", Region="c" } r2.addPaletteElement("palette.entities.creatures.cbcjc4", entries.creature_cbcjc4)
	entries.creature_cbcla1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbcla1.creature", Level=10, RingAccess="a1", Ecosystem="Lacustre", Region="a" } r2.addPaletteElement("palette.entities.creatures.cbcla1", entries.creature_cbcla1)
	entries.creature_cbcla2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbcla2.creature", Level=10, RingAccess="a1", Ecosystem="Lacustre", Region="a" } r2.addPaletteElement("palette.entities.creatures.cbcla2", entries.creature_cbcla2)
	entries.creature_cbclb1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbclb1.creature", Level=10, RingAccess="a1", Ecosystem="Lacustre", Region="b" } r2.addPaletteElement("palette.entities.creatures.cbclb1", entries.creature_cbclb1)
	entries.creature_cbclb2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbclb2.creature", Level=20, RingAccess="a1", Ecosystem="Lacustre", Region="b" } r2.addPaletteElement("palette.entities.creatures.cbclb2", entries.creature_cbclb2)
	entries.creature_cbclb3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbclb3.creature", Level=30, RingAccess="a1", Ecosystem="Lacustre", Region="b" } r2.addPaletteElement("palette.entities.creatures.cbclb3", entries.creature_cbclb3)
	entries.creature_cbclb4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbclb4.creature", Level=40, RingAccess="a1", Ecosystem="Lacustre", Region="b" } r2.addPaletteElement("palette.entities.creatures.cbclb4", entries.creature_cbclb4)
	entries.creature_cbclc1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbclc1.creature", Level=60, RingAccess="l5", Ecosystem="Lacustre", Region="c" } r2.addPaletteElement("palette.entities.creatures.cbclc1", entries.creature_cbclc1)
	entries.creature_cbclc2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbclc2.creature", Level=70, RingAccess="l5", Ecosystem="Lacustre", Region="c" } r2.addPaletteElement("palette.entities.creatures.cbclc2", entries.creature_cbclc2)
	entries.creature_cbclc3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbclc3.creature", Level=80, RingAccess="l5", Ecosystem="Lacustre", Region="c" } r2.addPaletteElement("palette.entities.creatures.cbclc3", entries.creature_cbclc3)
	entries.creature_cbclc4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cbclc4.creature", Level=90, RingAccess="l5", Ecosystem="Lacustre", Region="c" } r2.addPaletteElement("palette.entities.creatures.cbclc4", entries.creature_cbclc4)
	entries.creature_chadc1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chadc1.creature", Level=60, RingAccess="d2", Ecosystem="Desert", Region="c" } r2.addPaletteElement("palette.entities.creatures.chadc1", entries.creature_chadc1)
	entries.creature_chadc2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chadc2.creature", Level=70, RingAccess="d2", Ecosystem="Desert", Region="c" } r2.addPaletteElement("palette.entities.creatures.chadc2", entries.creature_chadc2)
	entries.creature_chadc3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chadc3.creature", Level=80, RingAccess="d2", Ecosystem="Desert", Region="c" } r2.addPaletteElement("palette.entities.creatures.chadc3", entries.creature_chadc3)
	entries.creature_chadc4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chadc4.creature", Level=90, RingAccess="d2", Ecosystem="Desert", Region="c" } r2.addPaletteElement("palette.entities.creatures.chadc4", entries.creature_chadc4)
	entries.creature_chafd1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chafd1.creature", Level=110, RingAccess="f5", Ecosystem="Forest", Region="d" } r2.addPaletteElement("palette.entities.creatures.chafd1", entries.creature_chafd1)
	entries.creature_chafd2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chafd2.creature", Level=120, RingAccess="f5", Ecosystem="Forest", Region="d" } r2.addPaletteElement("palette.entities.creatures.chafd2", entries.creature_chafd2)
	entries.creature_chafd3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chafd3.creature", Level=130, RingAccess="f5", Ecosystem="Forest", Region="d" } r2.addPaletteElement("palette.entities.creatures.chafd3", entries.creature_chafd3)
	entries.creature_chafd4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chafd4.creature", Level=140, RingAccess="f5", Ecosystem="Forest", Region="d" } r2.addPaletteElement("palette.entities.creatures.chafd4", entries.creature_chafd4)
	entries.creature_chafe1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chafe1.creature", Level=160, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.chafe1", entries.creature_chafe1)
	entries.creature_chafe2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chafe2.creature", Level=170, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.chafe2", entries.creature_chafe2)
	entries.creature_chafe3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chafe3.creature", Level=180, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.chafe3", entries.creature_chafe3)
	entries.creature_chafe4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chafe4.creature", Level=190, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.chafe4", entries.creature_chafe4)
	entries.creature_chajf1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chajf1.creature", Level=210, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.chajf1", entries.creature_chajf1)
	entries.creature_chajf2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chajf2.creature", Level=220, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.chajf2", entries.creature_chajf2)
	entries.creature_chajf3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chajf3.creature", Level=230, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.chajf3", entries.creature_chajf3)
	entries.creature_chajf4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chajf4.creature", Level=240, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.chajf4", entries.creature_chajf4)
	entries.creature_chale1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chale1.creature", Level=160, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.chale1", entries.creature_chale1)
	entries.creature_chale2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chale2.creature", Level=170, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.chale2", entries.creature_chale2)
	entries.creature_chale3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chale3.creature", Level=180, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.chale3", entries.creature_chale3)
	entries.creature_chale4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chale4.creature", Level=190, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.chale4", entries.creature_chale4)
	entries.creature_chalf1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chalf1.creature", Level=210, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.chalf1", entries.creature_chalf1)
	entries.creature_chalf2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chalf2.creature", Level=220, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.chalf2", entries.creature_chalf2)
	entries.creature_chalf3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chalf3.creature", Level=230, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.chalf3", entries.creature_chalf3)
	entries.creature_chalf4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chalf4.creature", Level=240, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.chalf4", entries.creature_chalf4)
	entries.creature_chapd1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chapd1.creature", Level=110, RingAccess="p1", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.chapd1", entries.creature_chapd1)
	entries.creature_chapd2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chapd2.creature", Level=120, RingAccess="p1", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.chapd2", entries.creature_chapd2)
	entries.creature_chapd3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chapd3.creature", Level=130, RingAccess="p1", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.chapd3", entries.creature_chapd3)
	entries.creature_chapd4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chapd4.creature", Level=140, RingAccess="p1", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.chapd4", entries.creature_chapd4)
	entries.creature_chape1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chape1.creature", Level=160, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.chape1", entries.creature_chape1)
	entries.creature_chape2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chape2.creature", Level=170, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.chape2", entries.creature_chape2)
	entries.creature_chape3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chape3.creature", Level=180, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.chape3", entries.creature_chape3)
	entries.creature_chape4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chape4.creature", Level=190, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.chape4", entries.creature_chape4)
	entries.creature_chbdc1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chbdc1.creature", Level=60, RingAccess="d2", Ecosystem="Desert", Region="c" } r2.addPaletteElement("palette.entities.creatures.chbdc1", entries.creature_chbdc1)
	entries.creature_chbdc2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chbdc2.creature", Level=70, RingAccess="d2", Ecosystem="Desert", Region="c" } r2.addPaletteElement("palette.entities.creatures.chbdc2", entries.creature_chbdc2)
	entries.creature_chbdc3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chbdc3.creature", Level=80, RingAccess="d2", Ecosystem="Desert", Region="c" } r2.addPaletteElement("palette.entities.creatures.chbdc3", entries.creature_chbdc3)
	entries.creature_chbdc4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chbdc4.creature", Level=90, RingAccess="d2", Ecosystem="Desert", Region="c" } r2.addPaletteElement("palette.entities.creatures.chbdc4", entries.creature_chbdc4)
	entries.creature_chbfa1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chbfa1.creature", Level=10, RingAccess="a1", Ecosystem="Forest", Region="a" } r2.addPaletteElement("palette.entities.creatures.chbfa1", entries.creature_chbfa1)
	entries.creature_chbfa2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chbfa2.creature", Level=10, RingAccess="a1", Ecosystem="Forest", Region="a" } r2.addPaletteElement("palette.entities.creatures.chbfa2", entries.creature_chbfa2)
	entries.creature_chbfb1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chbfb1.creature", Level=10, RingAccess="a1", Ecosystem="Forest", Region="b" } r2.addPaletteElement("palette.entities.creatures.chbfb1", entries.creature_chbfb1)
	entries.creature_chbfb2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chbfb2.creature", Level=20, RingAccess="a1", Ecosystem="Forest", Region="b" } r2.addPaletteElement("palette.entities.creatures.chbfb2", entries.creature_chbfb2)
	entries.creature_chbfb3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chbfb3.creature", Level=30, RingAccess="a1", Ecosystem="Forest", Region="b" } r2.addPaletteElement("palette.entities.creatures.chbfb3", entries.creature_chbfb3)
	entries.creature_chbfb4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chbfb4.creature", Level=40, RingAccess="a1", Ecosystem="Forest", Region="b" } r2.addPaletteElement("palette.entities.creatures.chbfb4", entries.creature_chbfb4)
	entries.creature_chbfc1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chbfc1.creature", Level=60, RingAccess="f5", Ecosystem="Forest", Region="c" } r2.addPaletteElement("palette.entities.creatures.chbfc1", entries.creature_chbfc1)
	entries.creature_chbfc2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chbfc2.creature", Level=70, RingAccess="f5", Ecosystem="Forest", Region="c" } r2.addPaletteElement("palette.entities.creatures.chbfc2", entries.creature_chbfc2)
	entries.creature_chbfc3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chbfc3.creature", Level=80, RingAccess="f5", Ecosystem="Forest", Region="c" } r2.addPaletteElement("palette.entities.creatures.chbfc3", entries.creature_chbfc3)
	entries.creature_chbfc4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chbfc4.creature", Level=90, RingAccess="f5", Ecosystem="Forest", Region="c" } r2.addPaletteElement("palette.entities.creatures.chbfc4", entries.creature_chbfc4)
	entries.creature_chbje1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chbje1.creature", Level=160, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.chbje1", entries.creature_chbje1)
	entries.creature_chbje2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chbje2.creature", Level=170, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.chbje2", entries.creature_chbje2)
	entries.creature_chbje3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chbje3.creature", Level=180, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.chbje3", entries.creature_chbje3)
	entries.creature_chbje4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chbje4.creature", Level=190, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.chbje4", entries.creature_chbje4)
	entries.creature_chbld1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chbld1.creature", Level=110, RingAccess="l5", Ecosystem="Lacustre", Region="d" } r2.addPaletteElement("palette.entities.creatures.chbld1", entries.creature_chbld1)
	entries.creature_chbld2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chbld2.creature", Level=120, RingAccess="l5", Ecosystem="Lacustre", Region="d" } r2.addPaletteElement("palette.entities.creatures.chbld2", entries.creature_chbld2)
	entries.creature_chbld3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chbld3.creature", Level=130, RingAccess="l5", Ecosystem="Lacustre", Region="d" } r2.addPaletteElement("palette.entities.creatures.chbld3", entries.creature_chbld3)
	entries.creature_chbld4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chbld4.creature", Level=140, RingAccess="l5", Ecosystem="Lacustre", Region="d" } r2.addPaletteElement("palette.entities.creatures.chbld4", entries.creature_chbld4)
	entries.creature_chbpd1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chbpd1.creature", Level=110, RingAccess="p1", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.chbpd1", entries.creature_chbpd1)
	entries.creature_chbpd2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chbpd2.creature", Level=120, RingAccess="p1", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.chbpd2", entries.creature_chbpd2)
	entries.creature_chbpd3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chbpd3.creature", Level=130, RingAccess="p1", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.chbpd3", entries.creature_chbpd3)
	entries.creature_chbpd4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chbpd4.creature", Level=140, RingAccess="p1", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.chbpd4", entries.creature_chbpd4)
	entries.creature_chbpe1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chbpe1.creature", Level=160, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.chbpe1", entries.creature_chbpe1)
	entries.creature_chbpe2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chbpe2.creature", Level=170, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.chbpe2", entries.creature_chbpe2)
	entries.creature_chbpe3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chbpe3.creature", Level=180, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.chbpe3", entries.creature_chbpe3)
	entries.creature_chbpe4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chbpe4.creature", Level=190, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.chbpe4", entries.creature_chbpe4)
	entries.creature_chcda1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chcda1.creature", Level=10, RingAccess="a1", Ecosystem="Desert", Region="a" } r2.addPaletteElement("palette.entities.creatures.chcda1", entries.creature_chcda1)
	entries.creature_chcda2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chcda2.creature", Level=17, RingAccess="a1", Ecosystem="Desert", Region="a" } r2.addPaletteElement("palette.entities.creatures.chcda2", entries.creature_chcda2)
	entries.creature_chcdb1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chcdb1.creature", Level=10, RingAccess="a1", Ecosystem="Desert", Region="b" } r2.addPaletteElement("palette.entities.creatures.chcdb1", entries.creature_chcdb1)
	entries.creature_chcdb2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chcdb2.creature", Level=20, RingAccess="a1", Ecosystem="Desert", Region="b" } r2.addPaletteElement("palette.entities.creatures.chcdb2", entries.creature_chcdb2)
	entries.creature_chcdb3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chcdb3.creature", Level=30, RingAccess="a1", Ecosystem="Desert", Region="b" } r2.addPaletteElement("palette.entities.creatures.chcdb3", entries.creature_chcdb3)
	entries.creature_chcdb4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chcdb4.creature", Level=40, RingAccess="a1", Ecosystem="Desert", Region="b" } r2.addPaletteElement("palette.entities.creatures.chcdb4", entries.creature_chcdb4)
	entries.creature_chcfa1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chcfa1.creature", Level=10, RingAccess="a1", Ecosystem="Forest", Region="a" } r2.addPaletteElement("palette.entities.creatures.chcfa1", entries.creature_chcfa1)
	entries.creature_chcfa2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chcfa2.creature", Level=10, RingAccess="a1", Ecosystem="Forest", Region="a" } r2.addPaletteElement("palette.entities.creatures.chcfa2", entries.creature_chcfa2)
	entries.creature_chcfb1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chcfb1.creature", Level=10, RingAccess="a1", Ecosystem="Forest", Region="b" } r2.addPaletteElement("palette.entities.creatures.chcfb1", entries.creature_chcfb1)
	entries.creature_chcfb2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chcfb2.creature", Level=20, RingAccess="a1", Ecosystem="Forest", Region="b" } r2.addPaletteElement("palette.entities.creatures.chcfb2", entries.creature_chcfb2)
	entries.creature_chcfb3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chcfb3.creature", Level=30, RingAccess="a1", Ecosystem="Forest", Region="b" } r2.addPaletteElement("palette.entities.creatures.chcfb3", entries.creature_chcfb3)
	entries.creature_chcfb4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chcfb4.creature", Level=40, RingAccess="a1", Ecosystem="Forest", Region="b" } r2.addPaletteElement("palette.entities.creatures.chcfb4", entries.creature_chcfb4)
	entries.creature_chcjd1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chcjd1.creature", Level=110, RingAccess="j5", Ecosystem="Jungle", Region="d" } r2.addPaletteElement("palette.entities.creatures.chcjd1", entries.creature_chcjd1)
	entries.creature_chcjd2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chcjd2.creature", Level=120, RingAccess="j5", Ecosystem="Jungle", Region="d" } r2.addPaletteElement("palette.entities.creatures.chcjd2", entries.creature_chcjd2)
	entries.creature_chcjd3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chcjd3.creature", Level=130, RingAccess="j5", Ecosystem="Jungle", Region="d" } r2.addPaletteElement("palette.entities.creatures.chcjd3", entries.creature_chcjd3)
	entries.creature_chcjd4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chcjd4.creature", Level=140, RingAccess="j5", Ecosystem="Jungle", Region="d" } r2.addPaletteElement("palette.entities.creatures.chcjd4", entries.creature_chcjd4)
	entries.creature_chclc1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chclc1.creature", Level=60, RingAccess="l5", Ecosystem="Lacustre", Region="c" } r2.addPaletteElement("palette.entities.creatures.chclc1", entries.creature_chclc1)
	entries.creature_chclc2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chclc2.creature", Level=70, RingAccess="l5", Ecosystem="Lacustre", Region="c" } r2.addPaletteElement("palette.entities.creatures.chclc2", entries.creature_chclc2)
	entries.creature_chclc3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chclc3.creature", Level=80, RingAccess="l5", Ecosystem="Lacustre", Region="c" } r2.addPaletteElement("palette.entities.creatures.chclc3", entries.creature_chclc3)
	entries.creature_chclc4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chclc4.creature", Level=90, RingAccess="l5", Ecosystem="Lacustre", Region="c" } r2.addPaletteElement("palette.entities.creatures.chclc4", entries.creature_chclc4)
	entries.creature_chcld4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chcld4.creature", Level=140, RingAccess="l5", Ecosystem="Lacustre", Region="d" } r2.addPaletteElement("palette.entities.creatures.chcld4", entries.creature_chcld4)
	entries.creature_chdda1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chdda1.creature", Level=10, RingAccess="a1", Ecosystem="Desert", Region="a" } r2.addPaletteElement("palette.entities.creatures.chdda1", entries.creature_chdda1)
	entries.creature_chdda2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chdda2.creature", Level=17, RingAccess="a1", Ecosystem="Desert", Region="a" } r2.addPaletteElement("palette.entities.creatures.chdda2", entries.creature_chdda2)
	entries.creature_chddb1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chddb1.creature", Level=10, RingAccess="a1", Ecosystem="Desert", Region="b" } r2.addPaletteElement("palette.entities.creatures.chddb1", entries.creature_chddb1)
	entries.creature_chddb2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chddb2.creature", Level=20, RingAccess="a1", Ecosystem="Desert", Region="b" } r2.addPaletteElement("palette.entities.creatures.chddb2", entries.creature_chddb2)
	entries.creature_chddb3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chddb3.creature", Level=30, RingAccess="a1", Ecosystem="Desert", Region="b" } r2.addPaletteElement("palette.entities.creatures.chddb3", entries.creature_chddb3)
	entries.creature_chddb4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chddb4.creature", Level=40, RingAccess="a1", Ecosystem="Desert", Region="b" } r2.addPaletteElement("palette.entities.creatures.chddb4", entries.creature_chddb4)
	entries.creature_chdfa1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chdfa1.creature", Level=10, RingAccess="a1", Ecosystem="Forest", Region="a" } r2.addPaletteElement("palette.entities.creatures.chdfa1", entries.creature_chdfa1)
	entries.creature_chdfa2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chdfa2.creature", Level=10, RingAccess="a1", Ecosystem="Forest", Region="a" } r2.addPaletteElement("palette.entities.creatures.chdfa2", entries.creature_chdfa2)
	entries.creature_chdfb1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chdfb1.creature", Level=10, RingAccess="a1", Ecosystem="Forest", Region="b" } r2.addPaletteElement("palette.entities.creatures.chdfb1", entries.creature_chdfb1)
	entries.creature_chdfb2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chdfb2.creature", Level=20, RingAccess="a1", Ecosystem="Forest", Region="b" } r2.addPaletteElement("palette.entities.creatures.chdfb2", entries.creature_chdfb2)
	entries.creature_chdfb3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chdfb3.creature", Level=30, RingAccess="a1", Ecosystem="Forest", Region="b" } r2.addPaletteElement("palette.entities.creatures.chdfb3", entries.creature_chdfb3)
	entries.creature_chdfb4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chdfb4.creature", Level=40, RingAccess="a1", Ecosystem="Forest", Region="b" } r2.addPaletteElement("palette.entities.creatures.chdfb4", entries.creature_chdfb4)
	entries.creature_chdja1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chdja1.creature", Level=10, RingAccess="a1", Ecosystem="Jungle", Region="a" } r2.addPaletteElement("palette.entities.creatures.chdja1", entries.creature_chdja1)
	entries.creature_chdja2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chdja2.creature", Level=10, RingAccess="a1", Ecosystem="Jungle", Region="a" } r2.addPaletteElement("palette.entities.creatures.chdja2", entries.creature_chdja2)
	entries.creature_chdjb1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chdjb1.creature", Level=10, RingAccess="a1", Ecosystem="Jungle", Region="b" } r2.addPaletteElement("palette.entities.creatures.chdjb1", entries.creature_chdjb1)
	entries.creature_chdjb2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chdjb2.creature", Level=20, RingAccess="a1", Ecosystem="Jungle", Region="b" } r2.addPaletteElement("palette.entities.creatures.chdjb2", entries.creature_chdjb2)
	entries.creature_chdjb3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chdjb3.creature", Level=30, RingAccess="a1", Ecosystem="Jungle", Region="b" } r2.addPaletteElement("palette.entities.creatures.chdjb3", entries.creature_chdjb3)
	entries.creature_chdjb4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chdjb4.creature", Level=40, RingAccess="a1", Ecosystem="Jungle", Region="b" } r2.addPaletteElement("palette.entities.creatures.chdjb4", entries.creature_chdjb4)
	entries.creature_chdla1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chdla1.creature", Level=10, RingAccess="a1", Ecosystem="Lacustre", Region="a" } r2.addPaletteElement("palette.entities.creatures.chdla1", entries.creature_chdla1)
	entries.creature_chdla2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chdla2.creature", Level=10, RingAccess="a1", Ecosystem="Lacustre", Region="a" } r2.addPaletteElement("palette.entities.creatures.chdla2", entries.creature_chdla2)
	entries.creature_chdlb1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chdlb1.creature", Level=10, RingAccess="a1", Ecosystem="Lacustre", Region="b" } r2.addPaletteElement("palette.entities.creatures.chdlb1", entries.creature_chdlb1)
	entries.creature_chdlb2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chdlb2.creature", Level=20, RingAccess="a1", Ecosystem="Lacustre", Region="b" } r2.addPaletteElement("palette.entities.creatures.chdlb2", entries.creature_chdlb2)
	entries.creature_chdlb3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chdlb3.creature", Level=30, RingAccess="a1", Ecosystem="Lacustre", Region="b" } r2.addPaletteElement("palette.entities.creatures.chdlb3", entries.creature_chdlb3)
	entries.creature_chdlb4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chdlb4.creature", Level=40, RingAccess="a1", Ecosystem="Lacustre", Region="b" } r2.addPaletteElement("palette.entities.creatures.chdlb4", entries.creature_chdlb4)
	--entries.creature_chegb1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chegb1.creature", Level=10, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.chegb1", entries.creature_chegb1)
	--entries.creature_chegb2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chegb2.creature", Level=20, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.chegb2", entries.creature_chegb2)
	--entries.creature_chegb3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chegb3.creature", Level=30, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.chegb3", entries.creature_chegb3)
	--entries.creature_chegb4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chegb4.creature", Level=40, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.chegb4", entries.creature_chegb4)
	--entries.creature_chegc1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chegc1.creature", Level=60, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.chegc1", entries.creature_chegc1)
	--entries.creature_chegc2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chegc2.creature", Level=70, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.chegc2", entries.creature_chegc2)
	--entries.creature_chegc3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chegc3.creature", Level=80, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.chegc3", entries.creature_chegc3)
	--entries.creature_chegc4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chegc4.creature", Level=90, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.chegc4", entries.creature_chegc4)
	--entries.creature_chegd1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chegd1.creature", Level=110, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.chegd1", entries.creature_chegd1)
	--entries.creature_chegd2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chegd2.creature", Level=120, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.chegd2", entries.creature_chegd2)
	--entries.creature_chegd3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chegd3.creature", Level=130, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.chegd3", entries.creature_chegd3)
	--entries.creature_chegd4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chegd4.creature", Level=140, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.chegd4", entries.creature_chegd4)
	--entries.creature_chege1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chege1.creature", Level=160, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.chege1", entries.creature_chege1)
	--entries.creature_chege2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chege2.creature", Level=170, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.chege2", entries.creature_chege2)
	--entries.creature_chege3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chege3.creature", Level=180, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.chege3", entries.creature_chege3)
	--entries.creature_chege4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chege4.creature", Level=190, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.chege4", entries.creature_chege4)
	--entries.creature_chegf1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chegf1.creature", Level=210, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.chegf1", entries.creature_chegf1)
	--entries.creature_chegf2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chegf2.creature", Level=220, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.chegf2", entries.creature_chegf2)
	--entries.creature_chegf3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chegf3.creature", Level=230, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.chegf3", entries.creature_chegf3)
	--entries.creature_chegf4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chegf4.creature", Level=240, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.chegf4", entries.creature_chegf4)
	entries.creature_cheld1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cheld1.creature", Level=110, RingAccess="l5", Ecosystem="Lacustre", Region="d" } r2.addPaletteElement("palette.entities.creatures.cheld1", entries.creature_cheld1)
	entries.creature_cheld2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cheld2.creature", Level=120, RingAccess="l5", Ecosystem="Lacustre", Region="d" } r2.addPaletteElement("palette.entities.creatures.cheld2", entries.creature_cheld2)
	entries.creature_cheld3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cheld3.creature", Level=130, RingAccess="l5", Ecosystem="Lacustre", Region="d" } r2.addPaletteElement("palette.entities.creatures.cheld3", entries.creature_cheld3)
	entries.creature_cheld4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="cheld4.creature", Level=140, RingAccess="l5", Ecosystem="Lacustre", Region="d" } r2.addPaletteElement("palette.entities.creatures.cheld4", entries.creature_cheld4)
	entries.creature_chele4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chele4.creature", Level=190, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.chele4", entries.creature_chele4)
	--entries.creature_chfgb1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chfgb1.creature", Level=10, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.chfgb1", entries.creature_chfgb1)
	--entries.creature_chfgb2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chfgb2.creature", Level=20, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.chfgb2", entries.creature_chfgb2)
	--entries.creature_chfgb3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chfgb3.creature", Level=30, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.chfgb3", entries.creature_chfgb3)
	--entries.creature_chfgb4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chfgb4.creature", Level=40, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.chfgb4", entries.creature_chfgb4)
	--entries.creature_chfgc1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chfgc1.creature", Level=60, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.chfgc1", entries.creature_chfgc1)
	--entries.creature_chfgc2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chfgc2.creature", Level=70, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.chfgc2", entries.creature_chfgc2)
	--entries.creature_chfgc3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chfgc3.creature", Level=80, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.chfgc3", entries.creature_chfgc3)
	--entries.creature_chfgc4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chfgc4.creature", Level=90, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.chfgc4", entries.creature_chfgc4)
	--entries.creature_chfgd1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chfgd1.creature", Level=110, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.chfgd1", entries.creature_chfgd1)
	--entries.creature_chfgd2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chfgd2.creature", Level=120, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.chfgd2", entries.creature_chfgd2)
	--entries.creature_chfgd3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chfgd3.creature", Level=130, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.chfgd3", entries.creature_chfgd3)
	--entries.creature_chfgd4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chfgd4.creature", Level=140, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.chfgd4", entries.creature_chfgd4)
	--entries.creature_chfge1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chfge1.creature", Level=160, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.chfge1", entries.creature_chfge1)
	--entries.creature_chfge2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chfge2.creature", Level=170, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.chfge2", entries.creature_chfge2)
	--entries.creature_chfge3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chfge3.creature", Level=180, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.chfge3", entries.creature_chfge3)
	--entries.creature_chfge4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chfge4.creature", Level=190, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.chfge4", entries.creature_chfge4)
	--entries.creature_chfgf1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chfgf1.creature", Level=210, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.chfgf1", entries.creature_chfgf1)

	--entries.creature_chfgf2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chfgf2.creature", Level=220, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.chfgf2", entries.creature_chfgf2)
	--entries.creature_chfgf3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chfgf3.creature", Level=230, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.chfgf3", entries.creature_chfgf3)
	--entries.creature_chfgf4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chfgf4.creature", Level=240, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.chfgf4", entries.creature_chfgf4)
	entries.creature_chfjc1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chfjc1.creature", Level=60, RingAccess="j5", Ecosystem="Jungle", Region="c" } r2.addPaletteElement("palette.entities.creatures.chfjc1", entries.creature_chfjc1)
	entries.creature_chfjc2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chfjc2.creature", Level=70, RingAccess="j5", Ecosystem="Jungle", Region="c" } r2.addPaletteElement("palette.entities.creatures.chfjc2", entries.creature_chfjc2)
	entries.creature_chfjc3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chfjc3.creature", Level=80, RingAccess="j5", Ecosystem="Jungle", Region="c" } r2.addPaletteElement("palette.entities.creatures.chfjc3", entries.creature_chfjc3)
	entries.creature_chfjc4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chfjc4.creature", Level=90, RingAccess="j5", Ecosystem="Jungle", Region="c" } r2.addPaletteElement("palette.entities.creatures.chfjc4", entries.creature_chfjc4)
	entries.creature_chfjd1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chfjd1.creature", Level=110, RingAccess="j5", Ecosystem="Jungle", Region="d" } r2.addPaletteElement("palette.entities.creatures.chfjd1", entries.creature_chfjd1)
	entries.creature_chfjd2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chfjd2.creature", Level=120, RingAccess="j5", Ecosystem="Jungle", Region="d" } r2.addPaletteElement("palette.entities.creatures.chfjd2", entries.creature_chfjd2)
	entries.creature_chfjd3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chfjd3.creature", Level=130, RingAccess="j5", Ecosystem="Jungle", Region="d" } r2.addPaletteElement("palette.entities.creatures.chfjd3", entries.creature_chfjd3)
	entries.creature_chfjd4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chfjd4.creature", Level=140, RingAccess="j5", Ecosystem="Jungle", Region="d" } r2.addPaletteElement("palette.entities.creatures.chfjd4", entries.creature_chfjd4)
	entries.creature_chfla1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chfla1.creature", Level=10, RingAccess="a1", Ecosystem="Lacustre", Region="a" } r2.addPaletteElement("palette.entities.creatures.chfla1", entries.creature_chfla1)
	entries.creature_chfla2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chfla2.creature", Level=10, RingAccess="a1", Ecosystem="Lacustre", Region="a" } r2.addPaletteElement("palette.entities.creatures.chfla2", entries.creature_chfla2)
	entries.creature_chflb1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chflb1.creature", Level=10, RingAccess="a1", Ecosystem="Lacustre", Region="b" } r2.addPaletteElement("palette.entities.creatures.chflb1", entries.creature_chflb1)
	entries.creature_chflb2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chflb2.creature", Level=20, RingAccess="a1", Ecosystem="Lacustre", Region="b" } r2.addPaletteElement("palette.entities.creatures.chflb2", entries.creature_chflb2)
	entries.creature_chflb3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chflb3.creature", Level=30, RingAccess="a1", Ecosystem="Lacustre", Region="b" } r2.addPaletteElement("palette.entities.creatures.chflb3", entries.creature_chflb3)
	entries.creature_chflb4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chflb4.creature", Level=40, RingAccess="a1", Ecosystem="Lacustre", Region="b" } r2.addPaletteElement("palette.entities.creatures.chflb4", entries.creature_chflb4)
	entries.creature_chgdd1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chgdd1.creature", Level=110, RingAccess="d4", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.chgdd1", entries.creature_chgdd1)
	entries.creature_chgdd2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chgdd2.creature", Level=120, RingAccess="d4", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.chgdd2", entries.creature_chgdd2)
	entries.creature_chgdd3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chgdd3.creature", Level=130, RingAccess="d4", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.chgdd3", entries.creature_chgdd3)
	entries.creature_chgdd4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chgdd4.creature", Level=140, RingAccess="d4", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.chgdd4", entries.creature_chgdd4)
	entries.creature_chgde1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chgde1.creature", Level=160, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.chgde1", entries.creature_chgde1)
	entries.creature_chgde2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chgde2.creature", Level=170, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.chgde2", entries.creature_chgde2)
	entries.creature_chgde3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chgde3.creature", Level=180, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.chgde3", entries.creature_chgde3)
	entries.creature_chgde4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chgde4.creature", Level=190, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.chgde4", entries.creature_chgde4)
	--entries.creature_chggb1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chggb1.creature", Level=10, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.chggb1", entries.creature_chggb1)
	--entries.creature_chggb2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chggb2.creature", Level=20, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.chggb2", entries.creature_chggb2)
	--entries.creature_chggb3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chggb3.creature", Level=30, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.chggb3", entries.creature_chggb3)
	--entries.creature_chggb4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chggb4.creature", Level=40, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.chggb4", entries.creature_chggb4)
	--entries.creature_chggc1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chggc1.creature", Level=60, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.chggc1", entries.creature_chggc1)
	--entries.creature_chggc2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chggc2.creature", Level=70, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.chggc2", entries.creature_chggc2)
	--entries.creature_chggc3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chggc3.creature", Level=80, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.chggc3", entries.creature_chggc3)
	--entries.creature_chggc4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chggc4.creature", Level=90, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.chggc4", entries.creature_chggc4)
	--entries.creature_chggd1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chggd1.creature", Level=110, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.chggd1", entries.creature_chggd1)
	--entries.creature_chggd2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chggd2.creature", Level=120, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.chggd2", entries.creature_chggd2)
	--entries.creature_chggd3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chggd3.creature", Level=130, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.chggd3", entries.creature_chggd3)
	--entries.creature_chggd4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chggd4.creature", Level=140, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.chggd4", entries.creature_chggd4)
	--entries.creature_chgge1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chgge1.creature", Level=160, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.chgge1", entries.creature_chgge1)
	--entries.creature_chgge2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chgge2.creature", Level=170, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.chgge2", entries.creature_chgge2)
	--entries.creature_chgge3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chgge3.creature", Level=180, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.chgge3", entries.creature_chgge3)
	--entries.creature_chgge4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chgge4.creature", Level=190, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.chgge4", entries.creature_chgge4)
	--entries.creature_chggf1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chggf1.creature", Level=210, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.chggf1", entries.creature_chggf1)
	--entries.creature_chggf2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chggf2.creature", Level=220, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.chggf2", entries.creature_chggf2)
	--entries.creature_chggf3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chggf3.creature", Level=230, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.chggf3", entries.creature_chggf3)
	--entries.creature_chggf4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chggf4.creature", Level=240, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.chggf4", entries.creature_chggf4)
	entries.creature_chgpd1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chgpd1.creature", Level=110, RingAccess="p1", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.chgpd1", entries.creature_chgpd1)
	entries.creature_chgpd2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chgpd2.creature", Level=120, RingAccess="p1", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.chgpd2", entries.creature_chgpd2)
	entries.creature_chgpd3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chgpd3.creature", Level=130, RingAccess="p1", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.chgpd3", entries.creature_chgpd3)
	entries.creature_chgpd4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chgpd4.creature", Level=140, RingAccess="p1", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.chgpd4", entries.creature_chgpd4)
	entries.creature_chgpf1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chgpf1.creature", Level=210, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.chgpf1", entries.creature_chgpf1)
	entries.creature_chgpf2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chgpf2.creature", Level=220, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.chgpf2", entries.creature_chgpf2)
	entries.creature_chgpf3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chgpf3.creature", Level=230, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.chgpf3", entries.creature_chgpf3)
	entries.creature_chgpf4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chgpf4.creature", Level=240, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.chgpf4", entries.creature_chgpf4)
	entries.creature_chhdd1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chhdd1.creature", Level=110, RingAccess="d4", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.chhdd1", entries.creature_chhdd1)
	entries.creature_chhdd2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chhdd2.creature", Level=120, RingAccess="d4", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.chhdd2", entries.creature_chhdd2)
	entries.creature_chhdd3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chhdd3.creature", Level=130, RingAccess="d4", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.chhdd3", entries.creature_chhdd3)
	entries.creature_chhdd4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chhdd4.creature", Level=140, RingAccess="d4", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.chhdd4", entries.creature_chhdd4)
	entries.creature_chhfc1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chhfc1.creature", Level=60, RingAccess="f5", Ecosystem="Forest", Region="c" } r2.addPaletteElement("palette.entities.creatures.chhfc1", entries.creature_chhfc1)
	entries.creature_chhfc2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chhfc2.creature", Level=70, RingAccess="f5", Ecosystem="Forest", Region="c" } r2.addPaletteElement("palette.entities.creatures.chhfc2", entries.creature_chhfc2)
	entries.creature_chhfc3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chhfc3.creature", Level=80, RingAccess="f5", Ecosystem="Forest", Region="c" } r2.addPaletteElement("palette.entities.creatures.chhfc3", entries.creature_chhfc3)
	entries.creature_chhfc4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chhfc4.creature", Level=90, RingAccess="f5", Ecosystem="Forest", Region="c" } r2.addPaletteElement("palette.entities.creatures.chhfc4", entries.creature_chhfc4)
	entries.creature_chhfd1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chhfd1.creature", Level=110, RingAccess="f5", Ecosystem="Forest", Region="d" } r2.addPaletteElement("palette.entities.creatures.chhfd1", entries.creature_chhfd1)
	entries.creature_chhfd2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chhfd2.creature", Level=120, RingAccess="f5", Ecosystem="Forest", Region="d" } r2.addPaletteElement("palette.entities.creatures.chhfd2", entries.creature_chhfd2)
	entries.creature_chhfd3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chhfd3.creature", Level=130, RingAccess="f5", Ecosystem="Forest", Region="d" } r2.addPaletteElement("palette.entities.creatures.chhfd3", entries.creature_chhfd3)
	entries.creature_chhfd4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chhfd4.creature", Level=140, RingAccess="f5", Ecosystem="Forest", Region="d" } r2.addPaletteElement("palette.entities.creatures.chhfd4", entries.creature_chhfd4)
	entries.creature_chhja1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chhja1.creature", Level=10, RingAccess="a1", Ecosystem="Jungle", Region="a" } r2.addPaletteElement("palette.entities.creatures.chhja1", entries.creature_chhja1)
	entries.creature_chhja2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chhja2.creature", Level=10, RingAccess="a1", Ecosystem="Jungle", Region="a" } r2.addPaletteElement("palette.entities.creatures.chhja2", entries.creature_chhja2)
	entries.creature_chhjb1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chhjb1.creature", Level=10, RingAccess="a1", Ecosystem="Jungle", Region="b" } r2.addPaletteElement("palette.entities.creatures.chhjb1", entries.creature_chhjb1)
	entries.creature_chhjb2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chhjb2.creature", Level=20, RingAccess="a1", Ecosystem="Jungle", Region="b" } r2.addPaletteElement("palette.entities.creatures.chhjb2", entries.creature_chhjb2)
	entries.creature_chhjb3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chhjb3.creature", Level=30, RingAccess="a1", Ecosystem="Jungle", Region="b" } r2.addPaletteElement("palette.entities.creatures.chhjb3", entries.creature_chhjb3)
	entries.creature_chhjb4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chhjb4.creature", Level=40, RingAccess="a1", Ecosystem="Jungle", Region="b" } r2.addPaletteElement("palette.entities.creatures.chhjb4", entries.creature_chhjb4)
	entries.creature_chhle1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chhle1.creature", Level=160, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.chhle1", entries.creature_chhle1)
	entries.creature_chhle2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chhle2.creature", Level=170, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.chhle2", entries.creature_chhle2)
	entries.creature_chhle3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chhle3.creature", Level=180, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.chhle3", entries.creature_chhle3)
	entries.creature_chhle4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chhle4.creature", Level=190, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.chhle4", entries.creature_chhle4)
	entries.creature_chhpf1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chhpf1.creature", Level=210, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.chhpf1", entries.creature_chhpf1)
	entries.creature_chhpf2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chhpf2.creature", Level=220, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.chhpf2", entries.creature_chhpf2)
	entries.creature_chhpf3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chhpf3.creature", Level=230, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.chhpf3", entries.creature_chhpf3)
	entries.creature_chhpf4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chhpf4.creature", Level=240, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.chhpf4", entries.creature_chhpf4)
	entries.creature_chidb2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chidb2.creature", Level=20, RingAccess="a1", Ecosystem="Desert", Region="b" } r2.addPaletteElement("palette.entities.creatures.chidb2", entries.creature_chidb2)
	entries.creature_chidc2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chidc2.creature", Level=70, RingAccess="d2", Ecosystem="Desert", Region="c" } r2.addPaletteElement("palette.entities.creatures.chidc2", entries.creature_chidc2)
	entries.creature_chidd2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chidd2.creature", Level=120, RingAccess="d4", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.chidd2", entries.creature_chidd2)
	entries.creature_chide2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chide2.creature", Level=170, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.chide2", entries.creature_chide2)
	entries.creature_chidf2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chidf2.creature", Level=220, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.chidf2", entries.creature_chidf2)
	entries.creature_chifb2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chifb2.creature", Level=20, RingAccess="a1", Ecosystem="Forest", Region="b" } r2.addPaletteElement("palette.entities.creatures.chifb2", entries.creature_chifb2)
	entries.creature_chifc2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chifc2.creature", Level=70, RingAccess="f5", Ecosystem="Forest", Region="c" } r2.addPaletteElement("palette.entities.creatures.chifc2", entries.creature_chifc2)
	entries.creature_chifd2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chifd2.creature", Level=120, RingAccess="f5", Ecosystem="Forest", Region="d" } r2.addPaletteElement("palette.entities.creatures.chifd2", entries.creature_chifd2)
	entries.creature_chife2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chife2.creature", Level=170, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.chife2", entries.creature_chife2)
	entries.creature_chiff2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chiff2.creature", Level=220, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.chiff2", entries.creature_chiff2)
	entries.creature_chijb2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chijb2.creature", Level=20, RingAccess="a1", Ecosystem="Jungle", Region="b" } r2.addPaletteElement("palette.entities.creatures.chijb2", entries.creature_chijb2)
	entries.creature_chijc2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chijc2.creature", Level=70, RingAccess="j5", Ecosystem="Jungle", Region="c" } r2.addPaletteElement("palette.entities.creatures.chijc2", entries.creature_chijc2)
	entries.creature_chijd2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chijd2.creature", Level=120, RingAccess="j5", Ecosystem="Jungle", Region="d" } r2.addPaletteElement("palette.entities.creatures.chijd2", entries.creature_chijd2)
	entries.creature_chije2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chije2.creature", Level=170, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.chije2", entries.creature_chije2)
	entries.creature_chijf2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chijf2.creature", Level=220, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.chijf2", entries.creature_chijf2)
	entries.creature_chilb2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chilb2.creature", Level=20, RingAccess="a1", Ecosystem="Lacustre", Region="b" } r2.addPaletteElement("palette.entities.creatures.chilb2", entries.creature_chilb2)
	entries.creature_chilc2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chilc2.creature", Level=70, RingAccess="l5", Ecosystem="Lacustre", Region="c" } r2.addPaletteElement("palette.entities.creatures.chilc2", entries.creature_chilc2)
	entries.creature_child2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="child2.creature", Level=120, RingAccess="l5", Ecosystem="Lacustre", Region="d" } r2.addPaletteElement("palette.entities.creatures.child2", entries.creature_child2)
	entries.creature_chile2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chile2.creature", Level=170, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.chile2", entries.creature_chile2)
	entries.creature_chilf2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chilf2.creature", Level=220, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.chilf2", entries.creature_chilf2)
	entries.creature_chipd2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chipd2.creature", Level=120, RingAccess="p1", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.chipd2", entries.creature_chipd2)
	entries.creature_chipe2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chipe2.creature", Level=170, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.chipe2", entries.creature_chipe2)
	entries.creature_chipf2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chipf2.creature", Level=220, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.chipf2", entries.creature_chipf2)
	entries.creature_chjdb2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chjdb2.creature", Level=20, RingAccess="a1", Ecosystem="Desert", Region="b" } r2.addPaletteElement("palette.entities.creatures.chjdb2", entries.creature_chjdb2)
	entries.creature_chjdb3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chjdb3.creature", Level=30, RingAccess="a1", Ecosystem="Desert", Region="b" } r2.addPaletteElement("palette.entities.creatures.chjdb3", entries.creature_chjdb3)
	entries.creature_chjdc2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chjdc2.creature", Level=70, RingAccess="d2", Ecosystem="Desert", Region="c" } r2.addPaletteElement("palette.entities.creatures.chjdc2", entries.creature_chjdc2)
	entries.creature_chjdc3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chjdc3.creature", Level=80, RingAccess="d2", Ecosystem="Desert", Region="c" } r2.addPaletteElement("palette.entities.creatures.chjdc3", entries.creature_chjdc3)
	entries.creature_chjdd2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chjdd2.creature", Level=120, RingAccess="d4", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.chjdd2", entries.creature_chjdd2)
	entries.creature_chjdd3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chjdd3.creature", Level=130, RingAccess="d4", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.chjdd3", entries.creature_chjdd3)
	entries.creature_chjde2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chjde2.creature", Level=170, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.chjde2", entries.creature_chjde2)
	entries.creature_chjde3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chjde3.creature", Level=180, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.chjde3", entries.creature_chjde3)
	entries.creature_chjdf2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chjdf2.creature", Level=220, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.chjdf2", entries.creature_chjdf2)
	entries.creature_chjdf3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chjdf3.creature", Level=230, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.chjdf3", entries.creature_chjdf3)
	entries.creature_chjfb2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chjfb2.creature", Level=20, RingAccess="a1", Ecosystem="Forest", Region="b" } r2.addPaletteElement("palette.entities.creatures.chjfb2", entries.creature_chjfb2)
	entries.creature_chjfb3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chjfb3.creature", Level=30, RingAccess="a1", Ecosystem="Forest", Region="b" } r2.addPaletteElement("palette.entities.creatures.chjfb3", entries.creature_chjfb3)
	entries.creature_chjfc2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chjfc2.creature", Level=70, RingAccess="f5", Ecosystem="Forest", Region="c" } r2.addPaletteElement("palette.entities.creatures.chjfc2", entries.creature_chjfc2)
	entries.creature_chjfc3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chjfc3.creature", Level=80, RingAccess="f5", Ecosystem="Forest", Region="c" } r2.addPaletteElement("palette.entities.creatures.chjfc3", entries.creature_chjfc3)
	entries.creature_chjfd2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chjfd2.creature", Level=120, RingAccess="f5", Ecosystem="Forest", Region="d" } r2.addPaletteElement("palette.entities.creatures.chjfd2", entries.creature_chjfd2)
	entries.creature_chjfd3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chjfd3.creature", Level=130, RingAccess="f5", Ecosystem="Forest", Region="d" } r2.addPaletteElement("palette.entities.creatures.chjfd3", entries.creature_chjfd3)
	entries.creature_chjfe2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chjfe2.creature", Level=170, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.chjfe2", entries.creature_chjfe2)
	entries.creature_chjfe3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chjfe3.creature", Level=180, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.chjfe3", entries.creature_chjfe3)
	entries.creature_chjff2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chjff2.creature", Level=220, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.chjff2", entries.creature_chjff2)
	entries.creature_chjff3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chjff3.creature", Level=230, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.chjff3", entries.creature_chjff3)
	entries.creature_chjjb2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chjjb2.creature", Level=20, RingAccess="a1", Ecosystem="Jungle", Region="b" } r2.addPaletteElement("palette.entities.creatures.chjjb2", entries.creature_chjjb2)
	entries.creature_chjjb3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chjjb3.creature", Level=30, RingAccess="a1", Ecosystem="Jungle", Region="b" } r2.addPaletteElement("palette.entities.creatures.chjjb3", entries.creature_chjjb3)
	entries.creature_chjjc2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chjjc2.creature", Level=70, RingAccess="j5", Ecosystem="Jungle", Region="c" } r2.addPaletteElement("palette.entities.creatures.chjjc2", entries.creature_chjjc2)
	entries.creature_chjjc3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chjjc3.creature", Level=80, RingAccess="j5", Ecosystem="Jungle", Region="c" } r2.addPaletteElement("palette.entities.creatures.chjjc3", entries.creature_chjjc3)
	entries.creature_chjjd2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chjjd2.creature", Level=120, RingAccess="j5", Ecosystem="Jungle", Region="d" } r2.addPaletteElement("palette.entities.creatures.chjjd2", entries.creature_chjjd2)
	entries.creature_chjjd3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chjjd3.creature", Level=130, RingAccess="j5", Ecosystem="Jungle", Region="d" } r2.addPaletteElement("palette.entities.creatures.chjjd3", entries.creature_chjjd3)
	entries.creature_chjje2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chjje2.creature", Level=170, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.chjje2", entries.creature_chjje2)
	entries.creature_chjje3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chjje3.creature", Level=180, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.chjje3", entries.creature_chjje3)
	entries.creature_chjjf2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chjjf2.creature", Level=220, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.chjjf2", entries.creature_chjjf2)
	entries.creature_chjjf3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chjjf3.creature", Level=230, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.chjjf3", entries.creature_chjjf3)
	entries.creature_chjlb2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chjlb2.creature", Level=20, RingAccess="a1", Ecosystem="Lacustre", Region="b" } r2.addPaletteElement("palette.entities.creatures.chjlb2", entries.creature_chjlb2)
	entries.creature_chjlb3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chjlb3.creature", Level=30, RingAccess="a1", Ecosystem="Lacustre", Region="b" } r2.addPaletteElement("palette.entities.creatures.chjlb3", entries.creature_chjlb3)
	entries.creature_chjlc2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chjlc2.creature", Level=70, RingAccess="l5", Ecosystem="Lacustre", Region="c" } r2.addPaletteElement("palette.entities.creatures.chjlc2", entries.creature_chjlc2)
	entries.creature_chjlc3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chjlc3.creature", Level=80, RingAccess="l5", Ecosystem="Lacustre", Region="c" } r2.addPaletteElement("palette.entities.creatures.chjlc3", entries.creature_chjlc3)
	entries.creature_chjld2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chjld2.creature", Level=120, RingAccess="l5", Ecosystem="Lacustre", Region="d" } r2.addPaletteElement("palette.entities.creatures.chjld2", entries.creature_chjld2)
	entries.creature_chjld3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chjld3.creature", Level=130, RingAccess="l5", Ecosystem="Lacustre", Region="d" } r2.addPaletteElement("palette.entities.creatures.chjld3", entries.creature_chjld3)
	entries.creature_chjle2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chjle2.creature", Level=170, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.chjle2", entries.creature_chjle2)
	entries.creature_chjle3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chjle3.creature", Level=180, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.chjle3", entries.creature_chjle3)
	entries.creature_chjlf2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chjlf2.creature", Level=220, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.chjlf2", entries.creature_chjlf2)
	entries.creature_chjlf3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chjlf3.creature", Level=230, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.chjlf3", entries.creature_chjlf3)
	entries.creature_chjpd2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chjpd2.creature", Level=120, RingAccess="p1", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.chjpd2", entries.creature_chjpd2)
	entries.creature_chjpe2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chjpe2.creature", Level=170, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.chjpe2", entries.creature_chjpe2)
	entries.creature_chjpf2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chjpf2.creature", Level=220, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.chjpf2", entries.creature_chjpf2)
	entries.creature_chkde1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chkde1.creature", Level=160, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.chkde1", entries.creature_chkde1)
	entries.creature_chkde2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chkde2.creature", Level=170, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.chkde2", entries.creature_chkde2)
	entries.creature_chkde3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chkde3.creature", Level=180, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.chkde3", entries.creature_chkde3)
	entries.creature_chkde4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chkde4.creature", Level=190, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.chkde4", entries.creature_chkde4)
	entries.creature_chkdf1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chkdf1.creature", Level=210, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.chkdf1", entries.creature_chkdf1)
	entries.creature_chkdf2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chkdf2.creature", Level=220, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.chkdf2", entries.creature_chkdf2)
	entries.creature_chkdf3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chkdf3.creature", Level=230, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.chkdf3", entries.creature_chkdf3)
	entries.creature_chkdf4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chkdf4.creature", Level=240, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.chkdf4", entries.creature_chkdf4)
	--entries.creature_chkgb1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chkgb1.creature", Level=10, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.chkgb1", entries.creature_chkgb1)
	--entries.creature_chkgb2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chkgb2.creature", Level=20, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.chkgb2", entries.creature_chkgb2)
	--entries.creature_chkgb3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chkgb3.creature", Level=30, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.chkgb3", entries.creature_chkgb3)
	--entries.creature_chkgb4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chkgb4.creature", Level=40, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.chkgb4", entries.creature_chkgb4)
	--entries.creature_chkgc1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chkgc1.creature", Level=60, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.chkgc1", entries.creature_chkgc1)
	--entries.creature_chkgc2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chkgc2.creature", Level=70, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.chkgc2", entries.creature_chkgc2)
	--entries.creature_chkgc3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chkgc3.creature", Level=80, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.chkgc3", entries.creature_chkgc3)
	--entries.creature_chkgc4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chkgc4.creature", Level=90, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.chkgc4", entries.creature_chkgc4)
	--entries.creature_chkgd1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chkgd1.creature", Level=110, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.chkgd1", entries.creature_chkgd1)
	--entries.creature_chkgd2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chkgd2.creature", Level=120, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.chkgd2", entries.creature_chkgd2)
	--entries.creature_chkgd3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chkgd3.creature", Level=130, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.chkgd3", entries.creature_chkgd3)
	--entries.creature_chkgd4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chkgd4.creature", Level=140, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.chkgd4", entries.creature_chkgd4)
	--entries.creature_chkge1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chkge1.creature", Level=160, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.chkge1", entries.creature_chkge1)
	--entries.creature_chkge2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chkge2.creature", Level=170, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.chkge2", entries.creature_chkge2)
	--entries.creature_chkge3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chkge3.creature", Level=180, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.chkge3", entries.creature_chkge3)
	--entries.creature_chkge4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chkge4.creature", Level=190, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.chkge4", entries.creature_chkge4)
	--entries.creature_chkgf1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chkgf1.creature", Level=210, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.chkgf1", entries.creature_chkgf1)
	--entries.creature_chkgf2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chkgf2.creature", Level=220, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.chkgf2", entries.creature_chkgf2)
	--entries.creature_chkgf3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chkgf3.creature", Level=230, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.chkgf3", entries.creature_chkgf3)
	--entries.creature_chkgf4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chkgf4.creature", Level=240, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.chkgf4", entries.creature_chkgf4)
	entries.creature_chkjd1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chkjd1.creature", Level=110, RingAccess="j5", Ecosystem="Jungle", Region="d" } r2.addPaletteElement("palette.entities.creatures.chkjd1", entries.creature_chkjd1)
	entries.creature_chkjd2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chkjd2.creature", Level=120, RingAccess="j5", Ecosystem="Jungle", Region="d" } r2.addPaletteElement("palette.entities.creatures.chkjd2", entries.creature_chkjd2)
	entries.creature_chkjd3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chkjd3.creature", Level=130, RingAccess="j5", Ecosystem="Jungle", Region="d" } r2.addPaletteElement("palette.entities.creatures.chkjd3", entries.creature_chkjd3)
	entries.creature_chkjd4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chkjd4.creature", Level=140, RingAccess="j5", Ecosystem="Jungle", Region="d" } r2.addPaletteElement("palette.entities.creatures.chkjd4", entries.creature_chkjd4)
	entries.creature_chkje1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chkje1.creature", Level=160, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.chkje1", entries.creature_chkje1)
	entries.creature_chkje2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chkje2.creature", Level=170, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.chkje2", entries.creature_chkje2)
	entries.creature_chkje3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chkje3.creature", Level=180, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.chkje3", entries.creature_chkje3)
	entries.creature_chkje4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chkje4.creature", Level=190, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.chkje4", entries.creature_chkje4)
	entries.creature_chldf1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chldf1.creature", Level=210, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.chldf1", entries.creature_chldf1)
	entries.creature_chldf2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chldf2.creature", Level=220, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.chldf2", entries.creature_chldf2)
	entries.creature_chldf3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chldf3.creature", Level=230, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.chldf3", entries.creature_chldf3)
	entries.creature_chldf4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chldf4.creature", Level=240, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.chldf4", entries.creature_chldf4)
	entries.creature_chlfe1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chlfe1.creature", Level=160, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.chlfe1", entries.creature_chlfe1)
	entries.creature_chlfe2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chlfe2.creature", Level=170, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.chlfe2", entries.creature_chlfe2)
	entries.creature_chlfe3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chlfe3.creature", Level=180, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.chlfe3", entries.creature_chlfe3)
	entries.creature_chlfe4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chlfe4.creature", Level=190, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.chlfe4", entries.creature_chlfe4)
	entries.creature_chlff1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chlff1.creature", Level=210, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.chlff1", entries.creature_chlff1)
	entries.creature_chlff2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chlff2.creature", Level=220, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.chlff2", entries.creature_chlff2)
	entries.creature_chlff3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chlff3.creature", Level=230, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.chlff3", entries.creature_chlff3)
	entries.creature_chlff4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chlff4.creature", Level=240, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.chlff4", entries.creature_chlff4)
	--entries.creature_chlgb1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chlgb1.creature", Level=10, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.chlgb1", entries.creature_chlgb1)
	--entries.creature_chlgb2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chlgb2.creature", Level=20, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.chlgb2", entries.creature_chlgb2)
	--entries.creature_chlgb3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chlgb3.creature", Level=30, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.chlgb3", entries.creature_chlgb3)
	--entries.creature_chlgb4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chlgb4.creature", Level=40, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.chlgb4", entries.creature_chlgb4)
	--entries.creature_chlgc1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chlgc1.creature", Level=60, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.chlgc1", entries.creature_chlgc1)
	--entries.creature_chlgc2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chlgc2.creature", Level=70, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.chlgc2", entries.creature_chlgc2)
	--entries.creature_chlgc3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chlgc3.creature", Level=80, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.chlgc3", entries.creature_chlgc3)
	--entries.creature_chlgc4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chlgc4.creature", Level=90, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.chlgc4", entries.creature_chlgc4)
	--entries.creature_chlgd1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chlgd1.creature", Level=110, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.chlgd1", entries.creature_chlgd1)
	--entries.creature_chlgd2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chlgd2.creature", Level=120, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.chlgd2", entries.creature_chlgd2)
	--entries.creature_chlgd3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chlgd3.creature", Level=130, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.chlgd3", entries.creature_chlgd3)
	--entries.creature_chlgd4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chlgd4.creature", Level=140, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.chlgd4", entries.creature_chlgd4)
	--entries.creature_chlge1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chlge1.creature", Level=160, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.chlge1", entries.creature_chlge1)
	--entries.creature_chlge2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chlge2.creature", Level=170, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.chlge2", entries.creature_chlge2)
	--entries.creature_chlge3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chlge3.creature", Level=180, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.chlge3", entries.creature_chlge3)
	--entries.creature_chlge4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chlge4.creature", Level=190, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.chlge4", entries.creature_chlge4)
	--entries.creature_chlgf1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chlgf1.creature", Level=210, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.chlgf1", entries.creature_chlgf1)
	--entries.creature_chlgf2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chlgf2.creature", Level=220, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.chlgf2", entries.creature_chlgf2)
	--entries.creature_chlgf3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chlgf3.creature", Level=230, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.chlgf3", entries.creature_chlgf3)
	--entries.creature_chlgf4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chlgf4.creature", Level=240, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.chlgf4", entries.creature_chlgf4)
	entries.creature_chlld1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chlld1.creature", Level=110, RingAccess="l5", Ecosystem="Lacustre", Region="d" } r2.addPaletteElement("palette.entities.creatures.chlld1", entries.creature_chlld1)
	entries.creature_chlld2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chlld2.creature", Level=120, RingAccess="l5", Ecosystem="Lacustre", Region="d" } r2.addPaletteElement("palette.entities.creatures.chlld2", entries.creature_chlld2)
	entries.creature_chlld3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chlld3.creature", Level=130, RingAccess="l5", Ecosystem="Lacustre", Region="d" } r2.addPaletteElement("palette.entities.creatures.chlld3", entries.creature_chlld3)
	entries.creature_chlld4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chlld4.creature", Level=140, RingAccess="l5", Ecosystem="Lacustre", Region="d" } r2.addPaletteElement("palette.entities.creatures.chlld4", entries.creature_chlld4)
	entries.creature_chlle1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chlle1.creature", Level=160, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.chlle1", entries.creature_chlle1)
	entries.creature_chlle2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chlle2.creature", Level=170, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.chlle2", entries.creature_chlle2)
	entries.creature_chlle3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chlle3.creature", Level=180, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.chlle3", entries.creature_chlle3)
	entries.creature_chlle4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chlle4.creature", Level=190, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.chlle4", entries.creature_chlle4)
	entries.creature_chlpe1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chlpe1.creature", Level=160, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.chlpe1", entries.creature_chlpe1)
	entries.creature_chlpe2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chlpe2.creature", Level=170, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.chlpe2", entries.creature_chlpe2)
	entries.creature_chlpe3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chlpe3.creature", Level=180, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.chlpe3", entries.creature_chlpe3)
	entries.creature_chlpe4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chlpe4.creature", Level=190, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.chlpe4", entries.creature_chlpe4)
	entries.creature_chlpf1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chlpf1.creature", Level=210, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.chlpf1", entries.creature_chlpf1)
	entries.creature_chlpf2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chlpf2.creature", Level=220, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.chlpf2", entries.creature_chlpf2)
	entries.creature_chlpf3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chlpf3.creature", Level=230, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.chlpf3", entries.creature_chlpf3)
	entries.creature_chlpf4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chlpf4.creature", Level=240, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.chlpf4", entries.creature_chlpf4)
	entries.creature_chmdd1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chmdd1.creature", Level=110, RingAccess="d4", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.chmdd1", entries.creature_chmdd1)
	entries.creature_chmdd2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chmdd2.creature", Level=120, RingAccess="d4", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.chmdd2", entries.creature_chmdd2)
	entries.creature_chmdd3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chmdd3.creature", Level=130, RingAccess="d4", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.chmdd3", entries.creature_chmdd3)
	entries.creature_chmdd4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chmdd4.creature", Level=140, RingAccess="d4", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.chmdd4", entries.creature_chmdd4)
	entries.creature_chmfc1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chmfc1.creature", Level=60, RingAccess="f5", Ecosystem="Forest", Region="c" } r2.addPaletteElement("palette.entities.creatures.chmfc1", entries.creature_chmfc1)
	entries.creature_chmfc2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chmfc2.creature", Level=70, RingAccess="f5", Ecosystem="Forest", Region="c" } r2.addPaletteElement("palette.entities.creatures.chmfc2", entries.creature_chmfc2)
	entries.creature_chmfc3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chmfc3.creature", Level=80, RingAccess="f5", Ecosystem="Forest", Region="c" } r2.addPaletteElement("palette.entities.creatures.chmfc3", entries.creature_chmfc3)
	entries.creature_chmfc4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chmfc4.creature", Level=90, RingAccess="f5", Ecosystem="Forest", Region="c" } r2.addPaletteElement("palette.entities.creatures.chmfc4", entries.creature_chmfc4)
	entries.creature_chnfd1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chnfd1.creature", Level=110, RingAccess="f5", Ecosystem="Forest", Region="d" } r2.addPaletteElement("palette.entities.creatures.chnfd1", entries.creature_chnfd1)
	entries.creature_chnfd2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chnfd2.creature", Level=120, RingAccess="f5", Ecosystem="Forest", Region="d" } r2.addPaletteElement("palette.entities.creatures.chnfd2", entries.creature_chnfd2)
	entries.creature_chnfd3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chnfd3.creature", Level=130, RingAccess="f5", Ecosystem="Forest", Region="d" } r2.addPaletteElement("palette.entities.creatures.chnfd3", entries.creature_chnfd3)
	entries.creature_chnfd4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chnfd4.creature", Level=140, RingAccess="f5", Ecosystem="Forest", Region="d" } r2.addPaletteElement("palette.entities.creatures.chnfd4", entries.creature_chnfd4)
	entries.creature_chnjc1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chnjc1.creature", Level=60, RingAccess="j5", Ecosystem="Jungle", Region="c" } r2.addPaletteElement("palette.entities.creatures.chnjc1", entries.creature_chnjc1)
	entries.creature_chnjc2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chnjc2.creature", Level=70, RingAccess="j5", Ecosystem="Jungle", Region="c" } r2.addPaletteElement("palette.entities.creatures.chnjc2", entries.creature_chnjc2)
	entries.creature_chnjc3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chnjc3.creature", Level=80, RingAccess="j5", Ecosystem="Jungle", Region="c" } r2.addPaletteElement("palette.entities.creatures.chnjc3", entries.creature_chnjc3)
	entries.creature_chnjc4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chnjc4.creature", Level=90, RingAccess="j5", Ecosystem="Jungle", Region="c" } r2.addPaletteElement("palette.entities.creatures.chnjc4", entries.creature_chnjc4)
	entries.creature_chofc1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chofc1.creature", Level=60, RingAccess="f5", Ecosystem="Forest", Region="c" } r2.addPaletteElement("palette.entities.creatures.chofc1", entries.creature_chofc1)
	entries.creature_chofc2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chofc2.creature", Level=70, RingAccess="f5", Ecosystem="Forest", Region="c" } r2.addPaletteElement("palette.entities.creatures.chofc2", entries.creature_chofc2)
	entries.creature_chofc3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chofc3.creature", Level=80, RingAccess="f5", Ecosystem="Forest", Region="c" } r2.addPaletteElement("palette.entities.creatures.chofc3", entries.creature_chofc3)
	entries.creature_chofc4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chofc4.creature", Level=90, RingAccess="f5", Ecosystem="Forest", Region="c" } r2.addPaletteElement("palette.entities.creatures.chofc4", entries.creature_chofc4)
	--entries.creature_chogb1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chogb1.creature", Level=10, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.chogb1", entries.creature_chogb1)
	--entries.creature_chogb2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chogb2.creature", Level=20, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.chogb2", entries.creature_chogb2)
	--entries.creature_chogb3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chogb3.creature", Level=30, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.chogb3", entries.creature_chogb3)
	--entries.creature_chogb4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chogb4.creature", Level=40, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.chogb4", entries.creature_chogb4)
	--entries.creature_chogc1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chogc1.creature", Level=60, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.chogc1", entries.creature_chogc1)
	--entries.creature_chogc2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chogc2.creature", Level=70, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.chogc2", entries.creature_chogc2)
	--entries.creature_chogc3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chogc3.creature", Level=80, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.chogc3", entries.creature_chogc3)
	--entries.creature_chogc4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chogc4.creature", Level=90, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.chogc4", entries.creature_chogc4)
	--entries.creature_chogd1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chogd1.creature", Level=110, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.chogd1", entries.creature_chogd1)
	--entries.creature_chogd2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chogd2.creature", Level=120, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.chogd2", entries.creature_chogd2)
	--entries.creature_chogd3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chogd3.creature", Level=130, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.chogd3", entries.creature_chogd3)
	--entries.creature_chogd4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chogd4.creature", Level=140, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.chogd4", entries.creature_chogd4)
	--entries.creature_choge1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="choge1.creature", Level=160, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.choge1", entries.creature_choge1)
	--entries.creature_choge2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="choge2.creature", Level=170, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.choge2", entries.creature_choge2)
	--entries.creature_choge3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="choge3.creature", Level=180, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.choge3", entries.creature_choge3)
	--entries.creature_choge4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="choge4.creature", Level=190, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.choge4", entries.creature_choge4)
	--entries.creature_chogf1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chogf1.creature", Level=210, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.chogf1", entries.creature_chogf1)
	--entries.creature_chogf2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chogf2.creature", Level=220, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.chogf2", entries.creature_chogf2)
	--entries.creature_chogf3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chogf3.creature", Level=230, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.chogf3", entries.creature_chogf3)
	--entries.creature_chogf4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chogf4.creature", Level=240, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.chogf4", entries.creature_chogf4)
	entries.creature_chpdc1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chpdc1.creature", Level=60, RingAccess="d2", Ecosystem="Desert", Region="c" } r2.addPaletteElement("palette.entities.creatures.chpdc1", entries.creature_chpdc1)
	entries.creature_chpdc2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chpdc2.creature", Level=70, RingAccess="d2", Ecosystem="Desert", Region="c" } r2.addPaletteElement("palette.entities.creatures.chpdc2", entries.creature_chpdc2)
	entries.creature_chpdc3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chpdc3.creature", Level=80, RingAccess="d2", Ecosystem="Desert", Region="c" } r2.addPaletteElement("palette.entities.creatures.chpdc3", entries.creature_chpdc3)
	entries.creature_chpdc4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chpdc4.creature", Level=90, RingAccess="d2", Ecosystem="Desert", Region="c" } r2.addPaletteElement("palette.entities.creatures.chpdc4", entries.creature_chpdc4)
	entries.creature_chpde4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chpde4.creature", Level=190, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.chpde4", entries.creature_chpde4)
	entries.creature_chpfd1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chpfd1.creature", Level=110, RingAccess="f5", Ecosystem="Forest", Region="d" } r2.addPaletteElement("palette.entities.creatures.chpfd1", entries.creature_chpfd1)
	entries.creature_chpfd2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chpfd2.creature", Level=120, RingAccess="f5", Ecosystem="Forest", Region="d" } r2.addPaletteElement("palette.entities.creatures.chpfd2", entries.creature_chpfd2)
	entries.creature_chpfd3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chpfd3.creature", Level=130, RingAccess="f5", Ecosystem="Forest", Region="d" } r2.addPaletteElement("palette.entities.creatures.chpfd3", entries.creature_chpfd3)
	entries.creature_chpfd4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chpfd4.creature", Level=140, RingAccess="f5", Ecosystem="Forest", Region="d" } r2.addPaletteElement("palette.entities.creatures.chpfd4", entries.creature_chpfd4)
	entries.creature_chqfe1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chqfe1.creature", Level=160, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.chqfe1", entries.creature_chqfe1)
	entries.creature_chqfe2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chqfe2.creature", Level=170, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.chqfe2", entries.creature_chqfe2)
	entries.creature_chqfe3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chqfe3.creature", Level=180, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.chqfe3", entries.creature_chqfe3)
	entries.creature_chqfe4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chqfe4.creature", Level=190, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.chqfe4", entries.creature_chqfe4)
	entries.creature_chqlc1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chqlc1.creature", Level=60, RingAccess="l5", Ecosystem="Lacustre", Region="c" } r2.addPaletteElement("palette.entities.creatures.chqlc1", entries.creature_chqlc1)
	entries.creature_chqlc2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chqlc2.creature", Level=70, RingAccess="l5", Ecosystem="Lacustre", Region="c" } r2.addPaletteElement("palette.entities.creatures.chqlc2", entries.creature_chqlc2)
	entries.creature_chqlc3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chqlc3.creature", Level=80, RingAccess="l5", Ecosystem="Lacustre", Region="c" } r2.addPaletteElement("palette.entities.creatures.chqlc3", entries.creature_chqlc3)
	entries.creature_chqlc4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chqlc4.creature", Level=90, RingAccess="l5", Ecosystem="Lacustre", Region="c" } r2.addPaletteElement("palette.entities.creatures.chqlc4", entries.creature_chqlc4)
	entries.creature_chrfe1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chrfe1.creature", Level=160, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.chrfe1", entries.creature_chrfe1)
	entries.creature_chrfe2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chrfe2.creature", Level=170, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.chrfe2", entries.creature_chrfe2)
	entries.creature_chrfe3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chrfe3.creature", Level=180, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.chrfe3", entries.creature_chrfe3)
	entries.creature_chrfe4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chrfe4.creature", Level=190, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.chrfe4", entries.creature_chrfe4)
	entries.creature_chrlf1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chrlf1.creature", Level=210, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.chrlf1", entries.creature_chrlf1)
	entries.creature_chrlf2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chrlf2.creature", Level=220, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.chrlf2", entries.creature_chrlf2)
	entries.creature_chrlf3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chrlf3.creature", Level=230, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.chrlf3", entries.creature_chrlf3)
	entries.creature_chrlf4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chrlf4.creature", Level=240, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.chrlf4", entries.creature_chrlf4)
	entries.creature_chsdf1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chsdf1.creature", Level=210, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.chsdf1", entries.creature_chsdf1)
	entries.creature_chsdf2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chsdf2.creature", Level=220, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.chsdf2", entries.creature_chsdf2)
	entries.creature_chsdf3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chsdf3.creature", Level=230, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.chsdf3", entries.creature_chsdf3)
	entries.creature_chsdf4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chsdf4.creature", Level=240, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.chsdf4", entries.creature_chsdf4)
	entries.creature_chsle1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chsle1.creature", Level=160, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.chsle1", entries.creature_chsle1)
	entries.creature_chsle2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chsle2.creature", Level=170, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.chsle2", entries.creature_chsle2)
	entries.creature_chsle3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chsle3.creature", Level=180, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.chsle3", entries.creature_chsle3)
	entries.creature_chsle4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chsle4.creature", Level=190, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.chsle4", entries.creature_chsle4)
	entries.creature_chtde1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chtde1.creature", Level=160, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.chtde1", entries.creature_chtde1)
	entries.creature_chtde2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chtde2.creature", Level=170, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.chtde2", entries.creature_chtde2)
	entries.creature_chtde3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chtde3.creature", Level=180, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.chtde3", entries.creature_chtde3)
	entries.creature_chtde4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chtde4.creature", Level=190, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.chtde4", entries.creature_chtde4)
	entries.creature_chtjf1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chtjf1.creature", Level=210, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.chtjf1", entries.creature_chtjf1)
	entries.creature_chtjf2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chtjf2.creature", Level=220, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.chtjf2", entries.creature_chtjf2)
	entries.creature_chtjf3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chtjf3.creature", Level=230, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.chtjf3", entries.creature_chtjf3)
	entries.creature_chtjf4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chtjf4.creature", Level=240, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.chtjf4", entries.creature_chtjf4)
	entries.creature_chuje1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chuje1.creature", Level=160, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.chuje1", entries.creature_chuje1)
	entries.creature_chuje2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chuje2.creature", Level=170, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.chuje2", entries.creature_chuje2)
	entries.creature_chuje3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chuje3.creature", Level=180, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.chuje3", entries.creature_chuje3)
	entries.creature_chuje4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chuje4.creature", Level=190, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.chuje4", entries.creature_chuje4)
	entries.creature_chulf1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chulf1.creature", Level=210, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.chulf1", entries.creature_chulf1)
	entries.creature_chulf2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chulf2.creature", Level=220, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.chulf2", entries.creature_chulf2)
	entries.creature_chulf3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chulf3.creature", Level=230, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.chulf3", entries.creature_chulf3)
	entries.creature_chulf4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chulf4.creature", Level=240, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.chulf4", entries.creature_chulf4)
	entries.creature_chvfe4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chvfe4.creature", Level=190, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.chvfe4", entries.creature_chvfe4)
	entries.creature_chvff1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chvff1.creature", Level=210, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.chvff1", entries.creature_chvff1)
	entries.creature_chvff2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chvff2.creature", Level=220, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.chvff2", entries.creature_chvff2)
	entries.creature_chvff3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chvff3.creature", Level=230, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.chvff3", entries.creature_chvff3)
	entries.creature_chvff4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chvff4.creature", Level=240, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.chvff4", entries.creature_chvff4)
	entries.creature_chvje1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chvje1.creature", Level=160, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.chvje1", entries.creature_chvje1)
	entries.creature_chvje2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chvje2.creature", Level=170, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.chvje2", entries.creature_chvje2)
	entries.creature_chvje3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chvje3.creature", Level=180, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.chvje3", entries.creature_chvje3)
	entries.creature_chvje4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chvje4.creature", Level=190, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.chvje4", entries.creature_chvje4)
	entries.creature_chvpf4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chvpf4.creature", Level=240, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.chvpf4", entries.creature_chvpf4)
	entries.creature_chwde1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chwde1.creature", Level=160, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.chwde1", entries.creature_chwde1)
	entries.creature_chwde2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chwde2.creature", Level=170, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.chwde2", entries.creature_chwde2)
	entries.creature_chwde3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chwde3.creature", Level=180, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.chwde3", entries.creature_chwde3)
	entries.creature_chwde4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chwde4.creature", Level=190, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.chwde4", entries.creature_chwde4)
	entries.creature_chwff1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chwff1.creature", Level=210, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.chwff1", entries.creature_chwff1)
	entries.creature_chwff2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chwff2.creature", Level=220, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.chwff2", entries.creature_chwff2)
	entries.creature_chwff3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chwff3.creature", Level=230, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.chwff3", entries.creature_chwff3)
	entries.creature_chwff4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chwff4.creature", Level=240, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.chwff4", entries.creature_chwff4)
	entries.creature_chxjf1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chxjf1.creature", Level=210, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.chxjf1", entries.creature_chxjf1)
	entries.creature_chxjf2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chxjf2.creature", Level=220, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.chxjf2", entries.creature_chxjf2)
	entries.creature_chxjf3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chxjf3.creature", Level=230, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.chxjf3", entries.creature_chxjf3)
	entries.creature_chxjf4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chxjf4.creature", Level=240, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.chxjf4", entries.creature_chxjf4)
	entries.creature_chxpe1 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chxpe1.creature", Level=160, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.chxpe1", entries.creature_chxpe1)
	entries.creature_chxpe2 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chxpe2.creature", Level=170, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.chxpe2", entries.creature_chxpe2)
	entries.creature_chxpe3 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chxpe3.creature", Level=180, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.chxpe3", entries.creature_chxpe3)
	entries.creature_chxpe4 = { Class="Npc", Base="palette.entities.creatures.passive", SheetClient="chxpe4.creature", Level=190, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.chxpe4", entries.creature_chxpe4)


-- Predators (carnivores)
	entries.creature_ccada1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccada1.creature", Level=10, RingAccess="a1", Ecosystem="Desert", Region="a" } r2.addPaletteElement("palette.entities.creatures.ccada1", entries.creature_ccada1)
	entries.creature_ccada2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccada2.creature", Level=17, RingAccess="a1", Ecosystem="Desert", Region="a" } r2.addPaletteElement("palette.entities.creatures.ccada2", entries.creature_ccada2)
	entries.creature_ccadb1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccadb1.creature", Level=10, RingAccess="a1", Ecosystem="Desert", Region="b" } r2.addPaletteElement("palette.entities.creatures.ccadb1", entries.creature_ccadb1)
	entries.creature_ccadb2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccadb2.creature", Level=20, RingAccess="a1", Ecosystem="Desert", Region="b" } r2.addPaletteElement("palette.entities.creatures.ccadb2", entries.creature_ccadb2)
	entries.creature_ccadb3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccadb3.creature", Level=30, RingAccess="a1", Ecosystem="Desert", Region="b" } r2.addPaletteElement("palette.entities.creatures.ccadb3", entries.creature_ccadb3)
	entries.creature_ccadb4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccadb4.creature", Level=40, RingAccess="a1", Ecosystem="Desert", Region="b" } r2.addPaletteElement("palette.entities.creatures.ccadb4", entries.creature_ccadb4)
	entries.creature_ccafa1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccafa1.creature", Level=10, RingAccess="a1", Ecosystem="Forest", Region="a" } r2.addPaletteElement("palette.entities.creatures.ccafa1", entries.creature_ccafa1)
	entries.creature_ccafa2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccafa2.creature", Level=10, RingAccess="a1", Ecosystem="Forest", Region="a" } r2.addPaletteElement("palette.entities.creatures.ccafa2", entries.creature_ccafa2)
	entries.creature_ccafb1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccafb1.creature", Level=10, RingAccess="a1", Ecosystem="Forest", Region="b" } r2.addPaletteElement("palette.entities.creatures.ccafb1", entries.creature_ccafb1)
	entries.creature_ccafb2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccafb2.creature", Level=20, RingAccess="a1", Ecosystem="Forest", Region="b" } r2.addPaletteElement("palette.entities.creatures.ccafb2", entries.creature_ccafb2)
	entries.creature_ccafb3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccafb3.creature", Level=30, RingAccess="a1", Ecosystem="Forest", Region="b" } r2.addPaletteElement("palette.entities.creatures.ccafb3", entries.creature_ccafb3)
	entries.creature_ccafb4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccafb4.creature", Level=40, RingAccess="a1", Ecosystem="Forest", Region="b" } r2.addPaletteElement("palette.entities.creatures.ccafb4", entries.creature_ccafb4)
	entries.creature_ccafc1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccafc1.creature", Level=60, RingAccess="f5", Ecosystem="Forest", Region="c" } r2.addPaletteElement("palette.entities.creatures.ccafc1", entries.creature_ccafc1)
	entries.creature_ccafc2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccafc2.creature", Level=70, RingAccess="f5", Ecosystem="Forest", Region="c" } r2.addPaletteElement("palette.entities.creatures.ccafc2", entries.creature_ccafc2)
	entries.creature_ccafc3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccafc3.creature", Level=80, RingAccess="f5", Ecosystem="Forest", Region="c" } r2.addPaletteElement("palette.entities.creatures.ccafc3", entries.creature_ccafc3)
	entries.creature_ccafc4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccafc4.creature", Level=90, RingAccess="f5", Ecosystem="Forest", Region="c" } r2.addPaletteElement("palette.entities.creatures.ccafc4", entries.creature_ccafc4)
	entries.creature_ccafe4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccafe4.creature", Level=190, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccafe4", entries.creature_ccafe4)
	--entries.creature_ccagb1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccagb1.creature", Level=10, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.ccagb1", entries.creature_ccagb1)
	--entries.creature_ccagb2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccagb2.creature", Level=20, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.ccagb2", entries.creature_ccagb2)
	--entries.creature_ccagb3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccagb3.creature", Level=30, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.ccagb3", entries.creature_ccagb3)
	--entries.creature_ccagb4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccagb4.creature", Level=40, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.ccagb4", entries.creature_ccagb4)
	--entries.creature_ccagc1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccagc1.creature", Level=60, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.ccagc1", entries.creature_ccagc1)
	--entries.creature_ccagc2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccagc2.creature", Level=70, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.ccagc2", entries.creature_ccagc2)
	--entries.creature_ccagc3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccagc3.creature", Level=80, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.ccagc3", entries.creature_ccagc3)
	--entries.creature_ccagc4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccagc4.creature", Level=90, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.ccagc4", entries.creature_ccagc4)
	--entries.creature_ccagd1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccagd1.creature", Level=110, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccagd1", entries.creature_ccagd1)
	--entries.creature_ccagd2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccagd2.creature", Level=120, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccagd2", entries.creature_ccagd2)
	--entries.creature_ccagd3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccagd3.creature", Level=130, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccagd3", entries.creature_ccagd3)
	--entries.creature_ccagd4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccagd4.creature", Level=140, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccagd4", entries.creature_ccagd4)
	--entries.creature_ccage1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccage1.creature", Level=160, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccage1", entries.creature_ccage1)
	--entries.creature_ccage2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccage2.creature", Level=170, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccage2", entries.creature_ccage2)
	--entries.creature_ccage3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccage3.creature", Level=180, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccage3", entries.creature_ccage3)
	--entries.creature_ccage4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccage4.creature", Level=190, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccage4", entries.creature_ccage4)
	--entries.creature_ccagf1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccagf1.creature", Level=210, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccagf1", entries.creature_ccagf1)
	--entries.creature_ccagf2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccagf2.creature", Level=220, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccagf2", entries.creature_ccagf2)
	--entries.creature_ccagf3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccagf3.creature", Level=230, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccagf3", entries.creature_ccagf3)
	--entries.creature_ccagf4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccagf4.creature", Level=240, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccagf4", entries.creature_ccagf4)
	entries.creature_ccajd1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccajd1.creature", Level=110, RingAccess="j5", Ecosystem="Jungle", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccajd1", entries.creature_ccajd1)
	entries.creature_ccajd2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccajd2.creature", Level=120, RingAccess="j5", Ecosystem="Jungle", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccajd2", entries.creature_ccajd2)
	entries.creature_ccajd3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccajd3.creature", Level=130, RingAccess="j5", Ecosystem="Jungle", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccajd3", entries.creature_ccajd3)
	entries.creature_ccajd4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccajd4.creature", Level=140, RingAccess="j5", Ecosystem="Jungle", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccajd4", entries.creature_ccajd4)
	entries.creature_ccaje1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccaje1.creature", Level=160, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccaje1", entries.creature_ccaje1)
	entries.creature_ccaje2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccaje2.creature", Level=170, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccaje2", entries.creature_ccaje2)
	entries.creature_ccaje3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccaje3.creature", Level=180, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccaje3", entries.creature_ccaje3)
	entries.creature_ccaje4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccaje4.creature", Level=190, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccaje4", entries.creature_ccaje4)
	entries.creature_ccbdc1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccbdc1.creature", Level=60, RingAccess="d2", Ecosystem="Desert", Region="c" } r2.addPaletteElement("palette.entities.creatures.ccbdc1", entries.creature_ccbdc1)
	entries.creature_ccbdc2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccbdc2.creature", Level=70, RingAccess="d2", Ecosystem="Desert", Region="c" } r2.addPaletteElement("palette.entities.creatures.ccbdc2", entries.creature_ccbdc2)
	entries.creature_ccbdc3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccbdc3.creature", Level=80, RingAccess="d2", Ecosystem="Desert", Region="c" } r2.addPaletteElement("palette.entities.creatures.ccbdc3", entries.creature_ccbdc3)
	entries.creature_ccbdc4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccbdc4.creature", Level=90, RingAccess="d2", Ecosystem="Desert", Region="c" } r2.addPaletteElement("palette.entities.creatures.ccbdc4", entries.creature_ccbdc4)
	--entries.creature_ccbgb1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccbgb1.creature", Level=10, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.ccbgb1", entries.creature_ccbgb1)
	--entries.creature_ccbgb2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccbgb2.creature", Level=20, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.ccbgb2", entries.creature_ccbgb2)
	--entries.creature_ccbgb3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccbgb3.creature", Level=30, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.ccbgb3", entries.creature_ccbgb3)
	--entries.creature_ccbgb4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccbgb4.creature", Level=40, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.ccbgb4", entries.creature_ccbgb4)
	--entries.creature_ccbgc1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccbgc1.creature", Level=60, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.ccbgc1", entries.creature_ccbgc1)
	--entries.creature_ccbgc2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccbgc2.creature", Level=70, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.ccbgc2", entries.creature_ccbgc2)
	--entries.creature_ccbgc3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccbgc3.creature", Level=80, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.ccbgc3", entries.creature_ccbgc3)
	--entries.creature_ccbgc4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccbgc4.creature", Level=90, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.ccbgc4", entries.creature_ccbgc4)
	--entries.creature_ccbgd1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccbgd1.creature", Level=110, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccbgd1", entries.creature_ccbgd1)
	--entries.creature_ccbgd2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccbgd2.creature", Level=120, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccbgd2", entries.creature_ccbgd2)
	--entries.creature_ccbgd3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccbgd3.creature", Level=130, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccbgd3", entries.creature_ccbgd3)

	--entries.creature_ccbgd4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccbgd4.creature", Level=140, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccbgd4", entries.creature_ccbgd4)

	--entries.creature_ccbge1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccbge1.creature", Level=160, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccbge1", entries.creature_ccbge1)
	--entries.creature_ccbge2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccbge2.creature", Level=170, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccbge2", entries.creature_ccbge2)
	--entries.creature_ccbge3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccbge3.creature", Level=180, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccbge3", entries.creature_ccbge3)
	--entries.creature_ccbge4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccbge4.creature", Level=190, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccbge4", entries.creature_ccbge4)
	--entries.creature_ccbgf1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccbgf1.creature", Level=210, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccbgf1", entries.creature_ccbgf1)
	--entries.creature_ccbgf2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccbgf2.creature", Level=220, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccbgf2", entries.creature_ccbgf2)
	--entries.creature_ccbgf3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccbgf3.creature", Level=230, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccbgf3", entries.creature_ccbgf3)
	--entries.creature_ccbgf4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccbgf4.creature", Level=240, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccbgf4", entries.creature_ccbgf4)
	entries.creature_ccbla1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccbla1.creature", Level=10, RingAccess="a1", Ecosystem="Lacustre", Region="a" } r2.addPaletteElement("palette.entities.creatures.ccbla1", entries.creature_ccbla1)
	entries.creature_ccbla2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccbla2.creature", Level=10, RingAccess="a1", Ecosystem="Lacustre", Region="a" } r2.addPaletteElement("palette.entities.creatures.ccbla2", entries.creature_ccbla2)
	entries.creature_ccblb1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccblb1.creature", Level=10, RingAccess="a1", Ecosystem="Lacustre", Region="b" } r2.addPaletteElement("palette.entities.creatures.ccblb1", entries.creature_ccblb1)
	entries.creature_ccblb2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccblb2.creature", Level=20, RingAccess="a1", Ecosystem="Lacustre", Region="b" } r2.addPaletteElement("palette.entities.creatures.ccblb2", entries.creature_ccblb2)
	entries.creature_ccblb3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccblb3.creature", Level=30, RingAccess="a1", Ecosystem="Lacustre", Region="b" } r2.addPaletteElement("palette.entities.creatures.ccblb3", entries.creature_ccblb3)
	entries.creature_ccblb4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccblb4.creature", Level=40, RingAccess="a1", Ecosystem="Lacustre", Region="b" } r2.addPaletteElement("palette.entities.creatures.ccblb4", entries.creature_ccblb4)
	entries.creature_ccblc1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccblc1.creature", Level=60, RingAccess="l5", Ecosystem="Lacustre", Region="c" } r2.addPaletteElement("palette.entities.creatures.ccblc1", entries.creature_ccblc1)
	entries.creature_ccblc2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccblc2.creature", Level=70, RingAccess="l5", Ecosystem="Lacustre", Region="c" } r2.addPaletteElement("palette.entities.creatures.ccblc2", entries.creature_ccblc2)
	entries.creature_ccblc3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccblc3.creature", Level=80, RingAccess="l5", Ecosystem="Lacustre", Region="c" } r2.addPaletteElement("palette.entities.creatures.ccblc3", entries.creature_ccblc3)
	entries.creature_ccblc4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccblc4.creature", Level=90, RingAccess="l5", Ecosystem="Lacustre", Region="c" } r2.addPaletteElement("palette.entities.creatures.ccblc4", entries.creature_ccblc4)
	entries.creature_cccda1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cccda1.creature", Level=10, RingAccess="a1", Ecosystem="Desert", Region="a" } r2.addPaletteElement("palette.entities.creatures.cccda1", entries.creature_cccda1)
	entries.creature_cccda2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cccda2.creature", Level=17, RingAccess="a1", Ecosystem="Desert", Region="a" } r2.addPaletteElement("palette.entities.creatures.cccda2", entries.creature_cccda2)
	entries.creature_cccdb1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cccdb1.creature", Level=10, RingAccess="a1", Ecosystem="Desert", Region="b" } r2.addPaletteElement("palette.entities.creatures.cccdb1", entries.creature_cccdb1)
	entries.creature_cccdb2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cccdb2.creature", Level=20, RingAccess="a1", Ecosystem="Desert", Region="b" } r2.addPaletteElement("palette.entities.creatures.cccdb2", entries.creature_cccdb2)
	entries.creature_cccdb3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cccdb3.creature", Level=30, RingAccess="a1", Ecosystem="Desert", Region="b" } r2.addPaletteElement("palette.entities.creatures.cccdb3", entries.creature_cccdb3)
	entries.creature_cccdb4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cccdb4.creature", Level=40, RingAccess="a1", Ecosystem="Desert", Region="b" } r2.addPaletteElement("palette.entities.creatures.cccdb4", entries.creature_cccdb4)
	entries.creature_cccdc1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cccdc1.creature", Level=60, RingAccess="d2", Ecosystem="Desert", Region="c" } r2.addPaletteElement("palette.entities.creatures.cccdc1", entries.creature_cccdc1)
	entries.creature_cccdc2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cccdc2.creature", Level=70, RingAccess="d2", Ecosystem="Desert", Region="c" } r2.addPaletteElement("palette.entities.creatures.cccdc2", entries.creature_cccdc2)
	entries.creature_cccdc3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cccdc3.creature", Level=80, RingAccess="d2", Ecosystem="Desert", Region="c" } r2.addPaletteElement("palette.entities.creatures.cccdc3", entries.creature_cccdc3)
	entries.creature_cccdc4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cccdc4.creature", Level=90, RingAccess="d2", Ecosystem="Desert", Region="c" } r2.addPaletteElement("palette.entities.creatures.cccdc4", entries.creature_cccdc4)
	entries.creature_cccdd4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cccdd4.creature", Level=140, RingAccess="d4", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.cccdd4", entries.creature_cccdd4)
	--entries.creature_cccgb1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cccgb1.creature", Level=10, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.cccgb1", entries.creature_cccgb1)
	--entries.creature_cccgb2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cccgb2.creature", Level=20, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.cccgb2", entries.creature_cccgb2)
	--entries.creature_cccgb3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cccgb3.creature", Level=30, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.cccgb3", entries.creature_cccgb3)
	--entries.creature_cccgb4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cccgb4.creature", Level=40, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.cccgb4", entries.creature_cccgb4)
	--entries.creature_cccgc1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cccgc1.creature", Level=60, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.cccgc1", entries.creature_cccgc1)
	--entries.creature_cccgc2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cccgc2.creature", Level=70, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.cccgc2", entries.creature_cccgc2)
	--entries.creature_cccgc3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cccgc3.creature", Level=80, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.cccgc3", entries.creature_cccgc3)
	--entries.creature_cccgc4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cccgc4.creature", Level=90, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.cccgc4", entries.creature_cccgc4)
	--entries.creature_cccgd1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cccgd1.creature", Level=110, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.cccgd1", entries.creature_cccgd1)
	--entries.creature_cccgd2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cccgd2.creature", Level=120, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.cccgd2", entries.creature_cccgd2)
	--entries.creature_cccgd3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cccgd3.creature", Level=130, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.cccgd3", entries.creature_cccgd3)
	--entries.creature_cccgd4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cccgd4.creature", Level=140, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.cccgd4", entries.creature_cccgd4)
	--entries.creature_cccge1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cccge1.creature", Level=160, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.cccge1", entries.creature_cccge1)
	--entries.creature_cccge2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cccge2.creature", Level=170, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.cccge2", entries.creature_cccge2)
	--entries.creature_cccge3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cccge3.creature", Level=180, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.cccge3", entries.creature_cccge3)
	--entries.creature_cccge4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cccge4.creature", Level=190, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.cccge4", entries.creature_cccge4)
	--entries.creature_cccgf1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cccgf1.creature", Level=210, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.cccgf1", entries.creature_cccgf1)
	--entries.creature_cccgf2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cccgf2.creature", Level=220, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.cccgf2", entries.creature_cccgf2)
	--entries.creature_cccgf3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cccgf3.creature", Level=230, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.cccgf3", entries.creature_cccgf3)
	--entries.creature_cccgf4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cccgf4.creature", Level=240, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.cccgf4", entries.creature_cccgf4)
	entries.creature_cccla1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cccla1.creature", Level=10, RingAccess="a1", Ecosystem="Lacustre", Region="a" } r2.addPaletteElement("palette.entities.creatures.cccla1", entries.creature_cccla1)
	entries.creature_cccla2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cccla2.creature", Level=10, RingAccess="a1", Ecosystem="Lacustre", Region="a" } r2.addPaletteElement("palette.entities.creatures.cccla2", entries.creature_cccla2)
	entries.creature_ccclb1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccclb1.creature", Level=10, RingAccess="a1", Ecosystem="Lacustre", Region="b" } r2.addPaletteElement("palette.entities.creatures.ccclb1", entries.creature_ccclb1)
	entries.creature_ccclb2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccclb2.creature", Level=20, RingAccess="a1", Ecosystem="Lacustre", Region="b" } r2.addPaletteElement("palette.entities.creatures.ccclb2", entries.creature_ccclb2)
	entries.creature_ccclb3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccclb3.creature", Level=30, RingAccess="a1", Ecosystem="Lacustre", Region="b" } r2.addPaletteElement("palette.entities.creatures.ccclb3", entries.creature_ccclb3)
	entries.creature_ccclb4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccclb4.creature", Level=40, RingAccess="a1", Ecosystem="Lacustre", Region="b" } r2.addPaletteElement("palette.entities.creatures.ccclb4", entries.creature_ccclb4)
	entries.creature_ccclf4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccclf4.creature", Level=240, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccclf4", entries.creature_ccclf4)
	entries.creature_ccdfd1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccdfd1.creature", Level=110, RingAccess="f5", Ecosystem="Forest", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccdfd1", entries.creature_ccdfd1)
	entries.creature_ccdfd2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccdfd2.creature", Level=120, RingAccess="f5", Ecosystem="Forest", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccdfd2", entries.creature_ccdfd2)
	entries.creature_ccdfd3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccdfd3.creature", Level=130, RingAccess="f5", Ecosystem="Forest", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccdfd3", entries.creature_ccdfd3)
	entries.creature_ccdfd4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccdfd4.creature", Level=140, RingAccess="f5", Ecosystem="Forest", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccdfd4", entries.creature_ccdfd4)
	entries.creature_ccdfe1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccdfe1.creature", Level=160, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccdfe1", entries.creature_ccdfe1)
	entries.creature_ccdfe2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccdfe2.creature", Level=170, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccdfe2", entries.creature_ccdfe2)
	entries.creature_ccdfe3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccdfe3.creature", Level=180, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccdfe3", entries.creature_ccdfe3)
	entries.creature_ccdfe4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccdfe4.creature", Level=190, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccdfe4", entries.creature_ccdfe4)
	--entries.creature_ccdgb1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccdgb1.creature", Level=10, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.ccdgb1", entries.creature_ccdgb1)
	--entries.creature_ccdgb2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccdgb2.creature", Level=20, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.ccdgb2", entries.creature_ccdgb2)
	--entries.creature_ccdgb3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccdgb3.creature", Level=30, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.ccdgb3", entries.creature_ccdgb3)
	--entries.creature_ccdgb4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccdgb4.creature", Level=40, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.ccdgb4", entries.creature_ccdgb4)
	--entries.creature_ccdgc1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccdgc1.creature", Level=60, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.ccdgc1", entries.creature_ccdgc1)
	--entries.creature_ccdgc2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccdgc2.creature", Level=70, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.ccdgc2", entries.creature_ccdgc2)
	--entries.creature_ccdgc3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccdgc3.creature", Level=80, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.ccdgc3", entries.creature_ccdgc3)
	--entries.creature_ccdgc4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccdgc4.creature", Level=90, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.ccdgc4", entries.creature_ccdgc4)
	--entries.creature_ccdgd1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccdgd1.creature", Level=110, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccdgd1", entries.creature_ccdgd1)
	--entries.creature_ccdgd2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccdgd2.creature", Level=120, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccdgd2", entries.creature_ccdgd2)
	--entries.creature_ccdgd3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccdgd3.creature", Level=130, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccdgd3", entries.creature_ccdgd3)
	--entries.creature_ccdgd4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccdgd4.creature", Level=140, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccdgd4", entries.creature_ccdgd4)
	--entries.creature_ccdge1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccdge1.creature", Level=160, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccdge1", entries.creature_ccdge1)
	--entries.creature_ccdge2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccdge2.creature", Level=170, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccdge2", entries.creature_ccdge2)
	--entries.creature_ccdge3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccdge3.creature", Level=180, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccdge3", entries.creature_ccdge3)
	--entries.creature_ccdge4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccdge4.creature", Level=190, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccdge4", entries.creature_ccdge4)
	--entries.creature_ccdgf1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccdgf1.creature", Level=210, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccdgf1", entries.creature_ccdgf1)
	--entries.creature_ccdgf2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccdgf2.creature", Level=220, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccdgf2", entries.creature_ccdgf2)
	--entries.creature_ccdgf3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccdgf3.creature", Level=230, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccdgf3", entries.creature_ccdgf3)
	--entries.creature_ccdgf4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccdgf4.creature", Level=240, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccdgf4", entries.creature_ccdgf4)
	entries.creature_ccdjc1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccdjc1.creature", Level=60, RingAccess="j5", Ecosystem="Jungle", Region="c" } r2.addPaletteElement("palette.entities.creatures.ccdjc1", entries.creature_ccdjc1)
	entries.creature_ccdjc2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccdjc2.creature", Level=70, RingAccess="j5", Ecosystem="Jungle", Region="c" } r2.addPaletteElement("palette.entities.creatures.ccdjc2", entries.creature_ccdjc2)
	entries.creature_ccdjc3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccdjc3.creature", Level=80, RingAccess="j5", Ecosystem="Jungle", Region="c" } r2.addPaletteElement("palette.entities.creatures.ccdjc3", entries.creature_ccdjc3)
	entries.creature_ccdjc4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccdjc4.creature", Level=90, RingAccess="j5", Ecosystem="Jungle", Region="c" } r2.addPaletteElement("palette.entities.creatures.ccdjc4", entries.creature_ccdjc4)
	entries.creature_ccdjd1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccdjd1.creature", Level=110, RingAccess="j5", Ecosystem="Jungle", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccdjd1", entries.creature_ccdjd1)
	entries.creature_ccdjd2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccdjd2.creature", Level=120, RingAccess="j5", Ecosystem="Jungle", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccdjd2", entries.creature_ccdjd2)
	entries.creature_ccdjd3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccdjd3.creature", Level=130, RingAccess="j5", Ecosystem="Jungle", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccdjd3", entries.creature_ccdjd3)
	entries.creature_ccdjd4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccdjd4.creature", Level=140, RingAccess="j5", Ecosystem="Jungle", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccdjd4", entries.creature_ccdjd4)
	entries.creature_ccdle1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccdle1.creature", Level=160, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccdle1", entries.creature_ccdle1)
	entries.creature_ccdle2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccdle2.creature", Level=170, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccdle2", entries.creature_ccdle2)
	entries.creature_ccdle3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccdle3.creature", Level=180, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccdle3", entries.creature_ccdle3)
	entries.creature_ccdle4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccdle4.creature", Level=190, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccdle4", entries.creature_ccdle4)
	entries.creature_ccdlf1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccdlf1.creature", Level=210, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccdlf1", entries.creature_ccdlf1)
	entries.creature_ccdlf2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccdlf2.creature", Level=220, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccdlf2", entries.creature_ccdlf2)
	entries.creature_ccdlf3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccdlf3.creature", Level=230, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccdlf3", entries.creature_ccdlf3)
	entries.creature_ccdlf4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccdlf4.creature", Level=240, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccdlf4", entries.creature_ccdlf4)
	entries.creature_ccefa1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccefa1.creature", Level=10, RingAccess="a1", Ecosystem="Forest", Region="a" } r2.addPaletteElement("palette.entities.creatures.ccefa1", entries.creature_ccefa1)
	entries.creature_ccefa2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccefa2.creature", Level=10, RingAccess="a1", Ecosystem="Forest", Region="a" } r2.addPaletteElement("palette.entities.creatures.ccefa2", entries.creature_ccefa2)
	entries.creature_ccefb1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccefb1.creature", Level=10, RingAccess="a1", Ecosystem="Forest", Region="b" } r2.addPaletteElement("palette.entities.creatures.ccefb1", entries.creature_ccefb1)
	entries.creature_ccefb2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccefb2.creature", Level=20, RingAccess="a1", Ecosystem="Forest", Region="b" } r2.addPaletteElement("palette.entities.creatures.ccefb2", entries.creature_ccefb2)
	entries.creature_ccefb3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccefb3.creature", Level=30, RingAccess="a1", Ecosystem="Forest", Region="b" } r2.addPaletteElement("palette.entities.creatures.ccefb3", entries.creature_ccefb3)
	entries.creature_ccefb4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccefb4.creature", Level=40, RingAccess="a1", Ecosystem="Forest", Region="b" } r2.addPaletteElement("palette.entities.creatures.ccefb4", entries.creature_ccefb4)
	entries.creature_cceff4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cceff4.creature", Level=240, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.cceff4", entries.creature_cceff4)
	--entries.creature_ccegb1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccegb1.creature", Level=10, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.ccegb1", entries.creature_ccegb1)
	--entries.creature_ccegb2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccegb2.creature", Level=20, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.ccegb2", entries.creature_ccegb2)
	--entries.creature_ccegb3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccegb3.creature", Level=30, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.ccegb3", entries.creature_ccegb3)
	--entries.creature_ccegb4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccegb4.creature", Level=40, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.ccegb4", entries.creature_ccegb4)
	--entries.creature_ccegc1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccegc1.creature", Level=60, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.ccegc1", entries.creature_ccegc1)
	--entries.creature_ccegc2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccegc2.creature", Level=70, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.ccegc2", entries.creature_ccegc2)
	--entries.creature_ccegc3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccegc3.creature", Level=80, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.ccegc3", entries.creature_ccegc3)
	--entries.creature_ccegc4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccegc4.creature", Level=90, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.ccegc4", entries.creature_ccegc4)
	--entries.creature_ccegd1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccegd1.creature", Level=110, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccegd1", entries.creature_ccegd1)
	--entries.creature_ccegd2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccegd2.creature", Level=120, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccegd2", entries.creature_ccegd2)
	--entries.creature_ccegd3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccegd3.creature", Level=130, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccegd3", entries.creature_ccegd3)
	--entries.creature_ccegd4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccegd4.creature", Level=140, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccegd4", entries.creature_ccegd4)
	--entries.creature_ccege1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccege1.creature", Level=160, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccege1", entries.creature_ccege1)
	--entries.creature_ccege2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccege2.creature", Level=170, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccege2", entries.creature_ccege2)
	--entries.creature_ccege3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccege3.creature", Level=180, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccege3", entries.creature_ccege3)
	--entries.creature_ccege4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccege4.creature", Level=190, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccege4", entries.creature_ccege4)
	--entries.creature_ccegf1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccegf1.creature", Level=210, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccegf1", entries.creature_ccegf1)
	--entries.creature_ccegf2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccegf2.creature", Level=220, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccegf2", entries.creature_ccegf2)
	--entries.creature_ccegf3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccegf3.creature", Level=230, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccegf3", entries.creature_ccegf3)
	--entries.creature_ccegf4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccegf4.creature", Level=240, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccegf4", entries.creature_ccegf4)
	entries.creature_cceja1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cceja1.creature", Level=10, RingAccess="a1", Ecosystem="Jungle", Region="a" } r2.addPaletteElement("palette.entities.creatures.cceja1", entries.creature_cceja1)
	entries.creature_cceja2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cceja2.creature", Level=10, RingAccess="a1", Ecosystem="Jungle", Region="a" } r2.addPaletteElement("palette.entities.creatures.cceja2", entries.creature_cceja2)
	entries.creature_ccejb1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccejb1.creature", Level=10, RingAccess="a1", Ecosystem="Jungle", Region="b" } r2.addPaletteElement("palette.entities.creatures.ccejb1", entries.creature_ccejb1)
	entries.creature_ccejb2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccejb2.creature", Level=20, RingAccess="a1", Ecosystem="Jungle", Region="b" } r2.addPaletteElement("palette.entities.creatures.ccejb2", entries.creature_ccejb2)
	entries.creature_ccejb3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccejb3.creature", Level=30, RingAccess="a1", Ecosystem="Jungle", Region="b" } r2.addPaletteElement("palette.entities.creatures.ccejb3", entries.creature_ccejb3)
	entries.creature_ccejb4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccejb4.creature", Level=40, RingAccess="a1", Ecosystem="Jungle", Region="b" } r2.addPaletteElement("palette.entities.creatures.ccejb4", entries.creature_ccejb4)
	entries.creature_ccejc1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccejc1.creature", Level=60, RingAccess="j5", Ecosystem="Jungle", Region="c" } r2.addPaletteElement("palette.entities.creatures.ccejc1", entries.creature_ccejc1)
	entries.creature_ccejc2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccejc2.creature", Level=70, RingAccess="j5", Ecosystem="Jungle", Region="c" } r2.addPaletteElement("palette.entities.creatures.ccejc2", entries.creature_ccejc2)
	entries.creature_ccejc3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccejc3.creature", Level=80, RingAccess="j5", Ecosystem="Jungle", Region="c" } r2.addPaletteElement("palette.entities.creatures.ccejc3", entries.creature_ccejc3)
	entries.creature_ccejc4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccejc4.creature", Level=90, RingAccess="j5", Ecosystem="Jungle", Region="c" } r2.addPaletteElement("palette.entities.creatures.ccejc4", entries.creature_ccejc4)
	entries.creature_ccelc1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccelc1.creature", Level=60, RingAccess="l5", Ecosystem="Lacustre", Region="c" } r2.addPaletteElement("palette.entities.creatures.ccelc1", entries.creature_ccelc1)
	entries.creature_ccelc2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccelc2.creature", Level=70, RingAccess="l5", Ecosystem="Lacustre", Region="c" } r2.addPaletteElement("palette.entities.creatures.ccelc2", entries.creature_ccelc2)
	entries.creature_ccelc3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccelc3.creature", Level=80, RingAccess="l5", Ecosystem="Lacustre", Region="c" } r2.addPaletteElement("palette.entities.creatures.ccelc3", entries.creature_ccelc3)
	entries.creature_ccelc4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccelc4.creature", Level=90, RingAccess="l5", Ecosystem="Lacustre", Region="c" } r2.addPaletteElement("palette.entities.creatures.ccelc4", entries.creature_ccelc4)
	entries.creature_cceld1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cceld1.creature", Level=110, RingAccess="l5", Ecosystem="Lacustre", Region="d" } r2.addPaletteElement("palette.entities.creatures.cceld1", entries.creature_cceld1)
	entries.creature_cceld2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cceld2.creature", Level=120, RingAccess="l5", Ecosystem="Lacustre", Region="d" } r2.addPaletteElement("palette.entities.creatures.cceld2", entries.creature_cceld2)
	entries.creature_cceld3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cceld3.creature", Level=130, RingAccess="l5", Ecosystem="Lacustre", Region="d" } r2.addPaletteElement("palette.entities.creatures.cceld3", entries.creature_cceld3)
	entries.creature_cceld4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cceld4.creature", Level=140, RingAccess="l5", Ecosystem="Lacustre", Region="d" } r2.addPaletteElement("palette.entities.creatures.cceld4", entries.creature_cceld4)
	entries.creature_ccepf4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccepf4.creature", Level=240, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccepf4", entries.creature_ccepf4)
	--entries.creature_ccfgb1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccfgb1.creature", Level=10, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.ccfgb1", entries.creature_ccfgb1)
	--entries.creature_ccfgb2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccfgb2.creature", Level=20, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.ccfgb2", entries.creature_ccfgb2)
	--entries.creature_ccfgb3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccfgb3.creature", Level=30, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.ccfgb3", entries.creature_ccfgb3)
	--entries.creature_ccfgb4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccfgb4.creature", Level=40, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.ccfgb4", entries.creature_ccfgb4)
	--entries.creature_ccfgc1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccfgc1.creature", Level=60, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.ccfgc1", entries.creature_ccfgc1)
	--entries.creature_ccfgc2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccfgc2.creature", Level=70, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.ccfgc2", entries.creature_ccfgc2)
	--entries.creature_ccfgc3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccfgc3.creature", Level=80, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.ccfgc3", entries.creature_ccfgc3)
	--entries.creature_ccfgc4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccfgc4.creature", Level=90, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.ccfgc4", entries.creature_ccfgc4)
	--entries.creature_ccfgd1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccfgd1.creature", Level=110, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccfgd1", entries.creature_ccfgd1)
	--entries.creature_ccfgd2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccfgd2.creature", Level=120, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccfgd2", entries.creature_ccfgd2)
	--entries.creature_ccfgd3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccfgd3.creature", Level=130, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccfgd3", entries.creature_ccfgd3)
	--entries.creature_ccfgd4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccfgd4.creature", Level=140, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccfgd4", entries.creature_ccfgd4)
	--entries.creature_ccfge1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccfge1.creature", Level=160, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccfge1", entries.creature_ccfge1)
	--entries.creature_ccfge2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccfge2.creature", Level=170, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccfge2", entries.creature_ccfge2)
	--entries.creature_ccfge3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccfge3.creature", Level=180, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccfge3", entries.creature_ccfge3)
	--entries.creature_ccfge4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccfge4.creature", Level=190, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccfge4", entries.creature_ccfge4)
	--entries.creature_ccfgf1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccfgf1.creature", Level=210, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccfgf1", entries.creature_ccfgf1)
	--entries.creature_ccfgf2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccfgf2.creature", Level=220, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccfgf2", entries.creature_ccfgf2)
	--entries.creature_ccfgf3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccfgf3.creature", Level=230, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccfgf3", entries.creature_ccfgf3)
	--entries.creature_ccfgf4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccfgf4.creature", Level=240, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccfgf4", entries.creature_ccfgf4)
	entries.creature_ccfjd4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccfjd4.creature", Level=140, RingAccess="j5", Ecosystem="Jungle", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccfjd4", entries.creature_ccfjd4)
	entries.creature_ccfje1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccfje1.creature", Level=160, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccfje1", entries.creature_ccfje1)
	entries.creature_ccfje2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccfje2.creature", Level=170, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccfje2", entries.creature_ccfje2)
	entries.creature_ccfje3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccfje3.creature", Level=180, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccfje3", entries.creature_ccfje3)
	entries.creature_ccfje4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccfje4.creature", Level=190, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccfje4", entries.creature_ccfje4)
	entries.creature_ccfjf1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccfjf1.creature", Level=210, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccfjf1", entries.creature_ccfjf1)
	entries.creature_ccfjf2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccfjf2.creature", Level=220, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccfjf2", entries.creature_ccfjf2)
	entries.creature_ccfjf3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccfjf3.creature", Level=230, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccfjf3", entries.creature_ccfjf3)
	entries.creature_ccfjf4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccfjf4.creature", Level=240, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccfjf4", entries.creature_ccfjf4)
	entries.creature_ccflf1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccflf1.creature", Level=210, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccflf1", entries.creature_ccflf1)
	entries.creature_ccflf2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccflf2.creature", Level=220, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccflf2", entries.creature_ccflf2)
	entries.creature_ccflf3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccflf3.creature", Level=230, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccflf3", entries.creature_ccflf3)
	entries.creature_ccflf4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccflf4.creature", Level=240, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccflf4", entries.creature_ccflf4)
	entries.creature_ccfpe4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccfpe4.creature", Level=190, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccfpe4", entries.creature_ccfpe4)
	--entries.creature_ccggf1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccggf1.creature", Level=210, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccggf1", entries.creature_ccggf1)
	--entries.creature_ccggf2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccggf2.creature", Level=220, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccggf2", entries.creature_ccggf2)
	--entries.creature_ccggf3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccggf3.creature", Level=230, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccggf3", entries.creature_ccggf3)
	--entries.creature_ccggf4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccggf4.creature", Level=240, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccggf4", entries.creature_ccggf4)
	entries.creature_ccgpf1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccgpf1.creature", Level=210, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccgpf1", entries.creature_ccgpf1)
	entries.creature_ccgpf2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccgpf2.creature", Level=220, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccgpf2", entries.creature_ccgpf2)
	entries.creature_ccgpf3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccgpf3.creature", Level=230, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccgpf3", entries.creature_ccgpf3)
	entries.creature_ccgpf4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccgpf4.creature", Level=240, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccgpf4", entries.creature_ccgpf4)
	entries.creature_cchdd1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cchdd1.creature", Level=110, RingAccess="d4", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.cchdd1", entries.creature_cchdd1)
	entries.creature_cchdd2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cchdd2.creature", Level=120, RingAccess="d4", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.cchdd2", entries.creature_cchdd2)
	entries.creature_cchdd3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cchdd3.creature", Level=130, RingAccess="d4", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.cchdd3", entries.creature_cchdd3)
	entries.creature_cchdd4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cchdd4.creature", Level=140, RingAccess="d4", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.cchdd4", entries.creature_cchdd4)
	entries.creature_cchde1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cchde1.creature", Level=160, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.cchde1", entries.creature_cchde1)
	entries.creature_cchde2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cchde2.creature", Level=170, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.cchde2", entries.creature_cchde2)
	entries.creature_cchde3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cchde3.creature", Level=180, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.cchde3", entries.creature_cchde3)
	entries.creature_cchde4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cchde4.creature", Level=190, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.cchde4", entries.creature_cchde4)
	--entries.creature_cchgb1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cchgb1.creature", Level=10, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.cchgb1", entries.creature_cchgb1)

	--entries.creature_cchgb2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cchgb2.creature", Level=20, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.cchgb2", entries.creature_cchgb2)
	--entries.creature_cchgb3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cchgb3.creature", Level=30, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.cchgb3", entries.creature_cchgb3)
	--entries.creature_cchgb4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cchgb4.creature", Level=40, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.cchgb4", entries.creature_cchgb4)
	--entries.creature_cchgc1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cchgc1.creature", Level=60, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.cchgc1", entries.creature_cchgc1)
	--entries.creature_cchgc2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cchgc2.creature", Level=70, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.cchgc2", entries.creature_cchgc2)
	--entries.creature_cchgc3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cchgc3.creature", Level=80, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.cchgc3", entries.creature_cchgc3)
	--entries.creature_cchgc4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cchgc4.creature", Level=90, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.cchgc4", entries.creature_cchgc4)
	--entries.creature_cchgd1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cchgd1.creature", Level=110, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.cchgd1", entries.creature_cchgd1)
	--entries.creature_cchgd2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cchgd2.creature", Level=120, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.cchgd2", entries.creature_cchgd2)
	--entries.creature_cchgd3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cchgd3.creature", Level=130, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.cchgd3", entries.creature_cchgd3)
	--entries.creature_cchgd4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cchgd4.creature", Level=140, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.cchgd4", entries.creature_cchgd4)
	--entries.creature_cchge1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cchge1.creature", Level=160, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.cchge1", entries.creature_cchge1)
	--entries.creature_cchge2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cchge2.creature", Level=170, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.cchge2", entries.creature_cchge2)
	--entries.creature_cchge3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cchge3.creature", Level=180, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.cchge3", entries.creature_cchge3)
	--entries.creature_cchge4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cchge4.creature", Level=190, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.cchge4", entries.creature_cchge4)
	--entries.creature_cchgf1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cchgf1.creature", Level=210, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.cchgf1", entries.creature_cchgf1)
	--entries.creature_cchgf2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cchgf2.creature", Level=220, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.cchgf2", entries.creature_cchgf2)
	--entries.creature_cchgf3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cchgf3.creature", Level=230, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.cchgf3", entries.creature_cchgf3)
	--entries.creature_cchgf4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cchgf4.creature", Level=240, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.cchgf4", entries.creature_cchgf4)
	entries.creature_cchpe1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cchpe1.creature", Level=160, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.cchpe1", entries.creature_cchpe1)
	entries.creature_cchpe2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cchpe2.creature", Level=170, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.cchpe2", entries.creature_cchpe2)
	entries.creature_cchpe3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cchpe3.creature", Level=180, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.cchpe3", entries.creature_cchpe3)
	entries.creature_cchpe4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cchpe4.creature", Level=190, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.cchpe4", entries.creature_cchpe4)
	entries.creature_ccidd1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccidd1.creature", Level=110, RingAccess="d4", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccidd1", entries.creature_ccidd1)
	entries.creature_ccidd2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccidd2.creature", Level=120, RingAccess="d4", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccidd2", entries.creature_ccidd2)
	entries.creature_ccidd3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccidd3.creature", Level=130, RingAccess="d4", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccidd3", entries.creature_ccidd3)
	entries.creature_ccidd4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccidd4.creature", Level=140, RingAccess="d4", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccidd4", entries.creature_ccidd4)
	entries.creature_ccidf1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccidf1.creature", Level=210, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccidf1", entries.creature_ccidf1)
	entries.creature_ccidf2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccidf2.creature", Level=220, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccidf2", entries.creature_ccidf2)
	entries.creature_ccidf3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccidf3.creature", Level=230, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccidf3", entries.creature_ccidf3)
	entries.creature_ccidf4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccidf4.creature", Level=240, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccidf4", entries.creature_ccidf4)
	entries.creature_ccijf1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccijf1.creature", Level=210, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccijf1", entries.creature_ccijf1)
	entries.creature_ccijf2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccijf2.creature", Level=220, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccijf2", entries.creature_ccijf2)
	entries.creature_ccijf3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccijf3.creature", Level=230, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccijf3", entries.creature_ccijf3)
	entries.creature_ccijf4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccijf4.creature", Level=240, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccijf4", entries.creature_ccijf4)
	entries.creature_ccild1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccild1.creature", Level=110, RingAccess="l5", Ecosystem="Lacustre", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccild1", entries.creature_ccild1)
	entries.creature_ccild2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccild2.creature", Level=120, RingAccess="l5", Ecosystem="Lacustre", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccild2", entries.creature_ccild2)
	entries.creature_ccild3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccild3.creature", Level=130, RingAccess="l5", Ecosystem="Lacustre", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccild3", entries.creature_ccild3)
	entries.creature_ccild4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccild4.creature", Level=140, RingAccess="l5", Ecosystem="Lacustre", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccild4", entries.creature_ccild4)
	entries.creature_ccile1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccile1.creature", Level=160, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccile1", entries.creature_ccile1)
	entries.creature_ccile2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccile2.creature", Level=170, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccile2", entries.creature_ccile2)
	entries.creature_ccile3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccile3.creature", Level=180, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccile3", entries.creature_ccile3)
	entries.creature_ccile4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccile4.creature", Level=190, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccile4", entries.creature_ccile4)
	entries.creature_ccipd1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccipd1.creature", Level=110, RingAccess="p1", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccipd1", entries.creature_ccipd1)
	entries.creature_ccipd2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccipd2.creature", Level=120, RingAccess="p1", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccipd2", entries.creature_ccipd2)
	entries.creature_ccipd3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccipd3.creature", Level=130, RingAccess="p1", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccipd3", entries.creature_ccipd3)
	entries.creature_ccipd4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccipd4.creature", Level=140, RingAccess="p1", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccipd4", entries.creature_ccipd4)
	entries.creature_ccjfc1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccjfc1.creature", Level=60, RingAccess="f5", Ecosystem="Forest", Region="c" } r2.addPaletteElement("palette.entities.creatures.ccjfc1", entries.creature_ccjfc1)
	entries.creature_ccjfc2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccjfc2.creature", Level=70, RingAccess="f5", Ecosystem="Forest", Region="c" } r2.addPaletteElement("palette.entities.creatures.ccjfc2", entries.creature_ccjfc2)
	entries.creature_ccjfc3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccjfc3.creature", Level=80, RingAccess="f5", Ecosystem="Forest", Region="c" } r2.addPaletteElement("palette.entities.creatures.ccjfc3", entries.creature_ccjfc3)
	entries.creature_ccjfc4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccjfc4.creature", Level=90, RingAccess="f5", Ecosystem="Forest", Region="c" } r2.addPaletteElement("palette.entities.creatures.ccjfc4", entries.creature_ccjfc4)
	entries.creature_ccjfd1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccjfd1.creature", Level=110, RingAccess="f5", Ecosystem="Forest", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccjfd1", entries.creature_ccjfd1)
	entries.creature_ccjfd2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccjfd2.creature", Level=120, RingAccess="f5", Ecosystem="Forest", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccjfd2", entries.creature_ccjfd2)
	entries.creature_ccjfd3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccjfd3.creature", Level=130, RingAccess="f5", Ecosystem="Forest", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccjfd3", entries.creature_ccjfd3)
	entries.creature_ccjfd4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccjfd4.creature", Level=140, RingAccess="f5", Ecosystem="Forest", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccjfd4", entries.creature_ccjfd4)
	entries.creature_ccjja1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccjja1.creature", Level=10, RingAccess="a1", Ecosystem="Jungle", Region="a" } r2.addPaletteElement("palette.entities.creatures.ccjja1", entries.creature_ccjja1)
	entries.creature_ccjja2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccjja2.creature", Level=10, RingAccess="a1", Ecosystem="Jungle", Region="a" } r2.addPaletteElement("palette.entities.creatures.ccjja2", entries.creature_ccjja2)
	entries.creature_ccjjb1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccjjb1.creature", Level=10, RingAccess="a1", Ecosystem="Jungle", Region="b" } r2.addPaletteElement("palette.entities.creatures.ccjjb1", entries.creature_ccjjb1)
	entries.creature_ccjjb2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccjjb2.creature", Level=20, RingAccess="a1", Ecosystem="Jungle", Region="b" } r2.addPaletteElement("palette.entities.creatures.ccjjb2", entries.creature_ccjjb2)
	entries.creature_ccjjb3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccjjb3.creature", Level=30, RingAccess="a1", Ecosystem="Jungle", Region="b" } r2.addPaletteElement("palette.entities.creatures.ccjjb3", entries.creature_ccjjb3)
	entries.creature_ccjjb4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccjjb4.creature", Level=40, RingAccess="a1", Ecosystem="Jungle", Region="b" } r2.addPaletteElement("palette.entities.creatures.ccjjb4", entries.creature_ccjjb4)
	entries.creature_cckdf1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cckdf1.creature", Level=210, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.cckdf1", entries.creature_cckdf1)
	entries.creature_cckdf2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cckdf2.creature", Level=220, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.cckdf2", entries.creature_cckdf2)
	entries.creature_cckdf3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cckdf3.creature", Level=230, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.cckdf3", entries.creature_cckdf3)
	entries.creature_cckdf4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cckdf4.creature", Level=240, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.cckdf4", entries.creature_cckdf4)
	entries.creature_cckfe1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cckfe1.creature", Level=160, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.cckfe1", entries.creature_cckfe1)
	entries.creature_cckfe2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cckfe2.creature", Level=170, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.cckfe2", entries.creature_cckfe2)
	entries.creature_cckfe3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cckfe3.creature", Level=180, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.cckfe3", entries.creature_cckfe3)
	entries.creature_cckfe4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cckfe4.creature", Level=190, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.cckfe4", entries.creature_cckfe4)
	entries.creature_cckff1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cckff1.creature", Level=210, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.cckff1", entries.creature_cckff1)
	entries.creature_cckff2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cckff2.creature", Level=220, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.cckff2", entries.creature_cckff2)
	entries.creature_cckff3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cckff3.creature", Level=230, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.cckff3", entries.creature_cckff3)
	entries.creature_cckff4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cckff4.creature", Level=240, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.cckff4", entries.creature_cckff4)
	entries.creature_cclde1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cclde1.creature", Level=160, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.cclde1", entries.creature_cclde1)
	entries.creature_cclde2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cclde2.creature", Level=170, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.cclde2", entries.creature_cclde2)
	entries.creature_cclde3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cclde3.creature", Level=180, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.cclde3", entries.creature_cclde3)
	entries.creature_cclde4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cclde4.creature", Level=190, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.cclde4", entries.creature_cclde4)
	entries.creature_cclff1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cclff1.creature", Level=210, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.cclff1", entries.creature_cclff1)
	entries.creature_cclff2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cclff2.creature", Level=220, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.cclff2", entries.creature_cclff2)
	entries.creature_cclff3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cclff3.creature", Level=230, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.cclff3", entries.creature_cclff3)
	entries.creature_cclff4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="cclff4.creature", Level=240, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.cclff4", entries.creature_cclff4)
	entries.creature_ccmff1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccmff1.creature", Level=210, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccmff1", entries.creature_ccmff1)
	entries.creature_ccmff2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccmff2.creature", Level=220, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccmff2", entries.creature_ccmff2)
	entries.creature_ccmff3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccmff3.creature", Level=230, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccmff3", entries.creature_ccmff3)
	entries.creature_ccmff4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccmff4.creature", Level=240, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccmff4", entries.creature_ccmff4)
	--entries.creature_ccmgb1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccmgb1.creature", Level=10, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.ccmgb1", entries.creature_ccmgb1)
	--entries.creature_ccmgb2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccmgb2.creature", Level=20, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.ccmgb2", entries.creature_ccmgb2)
	--entries.creature_ccmgb3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccmgb3.creature", Level=30, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.ccmgb3", entries.creature_ccmgb3)
	--entries.creature_ccmgb4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccmgb4.creature", Level=40, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.ccmgb4", entries.creature_ccmgb4)
	--entries.creature_ccmgc1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccmgc1.creature", Level=60, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.ccmgc1", entries.creature_ccmgc1)
	--entries.creature_ccmgc2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccmgc2.creature", Level=70, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.ccmgc2", entries.creature_ccmgc2)
	--entries.creature_ccmgc3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccmgc3.creature", Level=80, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.ccmgc3", entries.creature_ccmgc3)
	--entries.creature_ccmgc4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccmgc4.creature", Level=90, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.ccmgc4", entries.creature_ccmgc4)
	--entries.creature_ccmgd1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccmgd1.creature", Level=110, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccmgd1", entries.creature_ccmgd1)
	--entries.creature_ccmgd2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccmgd2.creature", Level=120, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccmgd2", entries.creature_ccmgd2)
	--entries.creature_ccmgd3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccmgd3.creature", Level=130, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccmgd3", entries.creature_ccmgd3)
	--entries.creature_ccmgd4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccmgd4.creature", Level=140, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccmgd4", entries.creature_ccmgd4)
	--entries.creature_ccmge1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccmge1.creature", Level=160, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccmge1", entries.creature_ccmge1)
	--entries.creature_ccmge2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccmge2.creature", Level=170, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccmge2", entries.creature_ccmge2)
	--entries.creature_ccmge3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccmge3.creature", Level=180, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccmge3", entries.creature_ccmge3)
	--entries.creature_ccmge4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccmge4.creature", Level=190, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccmge4", entries.creature_ccmge4)
	--entries.creature_ccmgf1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccmgf1.creature", Level=210, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccmgf1", entries.creature_ccmgf1)
	--entries.creature_ccmgf2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccmgf2.creature", Level=220, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccmgf2", entries.creature_ccmgf2)
	--entries.creature_ccmgf3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccmgf3.creature", Level=230, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccmgf3", entries.creature_ccmgf3)
	--entries.creature_ccmgf4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccmgf4.creature", Level=240, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccmgf4", entries.creature_ccmgf4)
	entries.creature_ccmpf1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccmpf1.creature", Level=210, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccmpf1", entries.creature_ccmpf1)
	entries.creature_ccmpf2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccmpf2.creature", Level=220, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccmpf2", entries.creature_ccmpf2)
	entries.creature_ccmpf3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccmpf3.creature", Level=230, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccmpf3", entries.creature_ccmpf3)
	entries.creature_ccmpf4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccmpf4.creature", Level=240, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccmpf4", entries.creature_ccmpf4)
	entries.creature_ccnlf1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccnlf1.creature", Level=210, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccnlf1", entries.creature_ccnlf1)
	entries.creature_ccnlf2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccnlf2.creature", Level=220, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccnlf2", entries.creature_ccnlf2)
	entries.creature_ccnlf3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccnlf3.creature", Level=230, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccnlf3", entries.creature_ccnlf3)
	entries.creature_ccnlf4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccnlf4.creature", Level=240, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccnlf4", entries.creature_ccnlf4)
	entries.creature_ccnpd1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccnpd1.creature", Level=110, RingAccess="p1", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccnpd1", entries.creature_ccnpd1)
	entries.creature_ccnpd2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccnpd2.creature", Level=120, RingAccess="p1", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccnpd2", entries.creature_ccnpd2)
	entries.creature_ccnpd3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccnpd3.creature", Level=130, RingAccess="p1", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccnpd3", entries.creature_ccnpd3)
	entries.creature_ccnpd4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccnpd4.creature", Level=140, RingAccess="p1", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccnpd4", entries.creature_ccnpd4)
	entries.creature_ccodf1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccodf1.creature", Level=210, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccodf1", entries.creature_ccodf1)
	entries.creature_ccodf2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccodf2.creature", Level=220, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccodf2", entries.creature_ccodf2)
	entries.creature_ccodf3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccodf3.creature", Level=230, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccodf3", entries.creature_ccodf3)
	entries.creature_ccodf4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccodf4.creature", Level=240, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccodf4", entries.creature_ccodf4)
	entries.creature_ccope1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccope1.creature", Level=160, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccope1", entries.creature_ccope1)
	entries.creature_ccope2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccope2.creature", Level=170, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccope2", entries.creature_ccope2)
	entries.creature_ccope3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccope3.creature", Level=180, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccope3", entries.creature_ccope3)
	entries.creature_ccope4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccope4.creature", Level=190, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccope4", entries.creature_ccope4)
	entries.creature_ccopf1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccopf1.creature", Level=210, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccopf1", entries.creature_ccopf1)
	entries.creature_ccopf2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccopf2.creature", Level=220, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccopf2", entries.creature_ccopf2)
	entries.creature_ccopf3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccopf3.creature", Level=230, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccopf3", entries.creature_ccopf3)
	entries.creature_ccopf4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccopf4.creature", Level=240, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccopf4", entries.creature_ccopf4)
	entries.creature_ccpjf1 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccpjf1.creature", Level=210, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccpjf1", entries.creature_ccpjf1)
	entries.creature_ccpjf2 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccpjf2.creature", Level=220, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccpjf2", entries.creature_ccpjf2)
	entries.creature_ccpjf3 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccpjf3.creature", Level=230, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccpjf3", entries.creature_ccpjf3)
	entries.creature_ccpjf4 = { Class="Npc", Base="palette.entities.creatures.predator", SheetClient="ccpjf4.creature", Level=240, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccpjf4", entries.creature_ccpjf4)


-- Plants
	--entries.creature_cpagb1 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpagb1.creature", Level=10, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.cpagb1", entries.creature_cpagb1)
	--entries.creature_cpagb2 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpagb2.creature", Level=20, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.cpagb2", entries.creature_cpagb2)
	--entries.creature_cpagb3 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpagb3.creature", Level=30, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.cpagb3", entries.creature_cpagb3)
	--entries.creature_cpagb4 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpagb4.creature", Level=40, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.cpagb4", entries.creature_cpagb4)
	--entries.creature_cpagc1 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpagc1.creature", Level=60, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.cpagc1", entries.creature_cpagc1)
	--entries.creature_cpagc2 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpagc2.creature", Level=70, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.cpagc2", entries.creature_cpagc2)
	--entries.creature_cpagc3 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpagc3.creature", Level=80, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.cpagc3", entries.creature_cpagc3)
	--entries.creature_cpagc4 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpagc4.creature", Level=90, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.cpagc4", entries.creature_cpagc4)
	--entries.creature_cpagd1 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpagd1.creature", Level=110, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.cpagd1", entries.creature_cpagd1)
	--entries.creature_cpagd2 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpagd2.creature", Level=120, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.cpagd2", entries.creature_cpagd2)
	--entries.creature_cpagd3 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpagd3.creature", Level=130, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.cpagd3", entries.creature_cpagd3)
	--entries.creature_cpagd4 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpagd4.creature", Level=140, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.cpagd4", entries.creature_cpagd4)
	--entries.creature_cpage1 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpage1.creature", Level=160, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.cpage1", entries.creature_cpage1)
	--entries.creature_cpage2 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpage2.creature", Level=170, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.cpage2", entries.creature_cpage2)
	--entries.creature_cpage3 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpage3.creature", Level=180, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.cpage3", entries.creature_cpage3)
	--entries.creature_cpage4 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpage4.creature", Level=190, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.cpage4", entries.creature_cpage4)
	--entries.creature_cpagf1 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpagf1.creature", Level=210, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.cpagf1", entries.creature_cpagf1)
	--entries.creature_cpagf2 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpagf2.creature", Level=220, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.cpagf2", entries.creature_cpagf2)
	--entries.creature_cpagf3 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpagf3.creature", Level=230, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.cpagf3", entries.creature_cpagf3)
	--entries.creature_cpagf4 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpagf4.creature", Level=240, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.cpagf4", entries.creature_cpagf4)
	entries.creature_cpapd1 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpapd1.creature", Level=110, RingAccess="p1", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.cpapd1", entries.creature_cpapd1)
	entries.creature_cpapd2 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpapd2.creature", Level=120, RingAccess="p1", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.cpapd2", entries.creature_cpapd2)
	entries.creature_cpapd3 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpapd3.creature", Level=130, RingAccess="p1", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.cpapd3", entries.creature_cpapd3)
	entries.creature_cpapd4 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpapd4.creature", Level=140, RingAccess="p1", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.cpapd4", entries.creature_cpapd4)
	entries.creature_cpape1 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpape1.creature", Level=160, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.cpape1", entries.creature_cpape1)
	entries.creature_cpape2 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpape2.creature", Level=170, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.cpape2", entries.creature_cpape2)
	entries.creature_cpape3 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpape3.creature", Level=180, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.cpape3", entries.creature_cpape3)
	entries.creature_cpape4 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpape4.creature", Level=190, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.cpape4", entries.creature_cpape4)
	entries.creature_cpapf1 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpapf1.creature", Level=210, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.cpapf1", entries.creature_cpapf1)
	entries.creature_cpapf2 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpapf2.creature", Level=220, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.cpapf2", entries.creature_cpapf2)
	entries.creature_cpapf3 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpapf3.creature", Level=230, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.cpapf3", entries.creature_cpapf3)
	entries.creature_cpapf4 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpapf4.creature", Level=240, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.cpapf4", entries.creature_cpapf4)
	--entries.creature_cpbgb1 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpbgb1.creature", Level=10, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.cpbgb1", entries.creature_cpbgb1)
	--entries.creature_cpbgb2 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpbgb2.creature", Level=20, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.cpbgb2", entries.creature_cpbgb2)
	--entries.creature_cpbgb3 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpbgb3.creature", Level=30, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.cpbgb3", entries.creature_cpbgb3)
	--entries.creature_cpbgb4 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpbgb4.creature", Level=40, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.cpbgb4", entries.creature_cpbgb4)
	--entries.creature_cpbgc1 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpbgc1.creature", Level=60, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.cpbgc1", entries.creature_cpbgc1)
	--entries.creature_cpbgc2 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpbgc2.creature", Level=70, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.cpbgc2", entries.creature_cpbgc2)
	--entries.creature_cpbgc3 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpbgc3.creature", Level=80, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.cpbgc3", entries.creature_cpbgc3)
	--entries.creature_cpbgc4 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpbgc4.creature", Level=90, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.cpbgc4", entries.creature_cpbgc4)
	--entries.creature_cpbgd1 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpbgd1.creature", Level=110, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.cpbgd1", entries.creature_cpbgd1)
	--entries.creature_cpbgd2 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpbgd2.creature", Level=120, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.cpbgd2", entries.creature_cpbgd2)
	--entries.creature_cpbgd3 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpbgd3.creature", Level=130, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.cpbgd3", entries.creature_cpbgd3)
	--entries.creature_cpbgd4 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpbgd4.creature", Level=140, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.cpbgd4", entries.creature_cpbgd4)
	--entries.creature_cpbge1 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpbge1.creature", Level=160, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.cpbge1", entries.creature_cpbge1)
	--entries.creature_cpbge2 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpbge2.creature", Level=170, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.cpbge2", entries.creature_cpbge2)
	--entries.creature_cpbge3 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpbge3.creature", Level=180, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.cpbge3", entries.creature_cpbge3)
	--entries.creature_cpbge4 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpbge4.creature", Level=190, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.cpbge4", entries.creature_cpbge4)
	--entries.creature_cpbgf1 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpbgf1.creature", Level=210, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.cpbgf1", entries.creature_cpbgf1)
	--entries.creature_cpbgf2 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpbgf2.creature", Level=220, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.cpbgf2", entries.creature_cpbgf2)
	--entries.creature_cpbgf3 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpbgf3.creature", Level=230, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.cpbgf3", entries.creature_cpbgf3)
	--entries.creature_cpbgf4 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpbgf4.creature", Level=240, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.cpbgf4", entries.creature_cpbgf4)
	entries.creature_cpblb1 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpblb1.creature", Level=10, RingAccess="a1", Ecosystem="Lacustre", Region="b" } r2.addPaletteElement("palette.entities.creatures.cpblb1", entries.creature_cpblb1)
	entries.creature_cpblb2 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpblb2.creature", Level=20, RingAccess="a1", Ecosystem="Lacustre", Region="b" } r2.addPaletteElement("palette.entities.creatures.cpblb2", entries.creature_cpblb2)
	entries.creature_cpblb3 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpblb3.creature", Level=30, RingAccess="a1", Ecosystem="Lacustre", Region="b" } r2.addPaletteElement("palette.entities.creatures.cpblb3", entries.creature_cpblb3)
	entries.creature_cpblb4 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpblb4.creature", Level=40, RingAccess="a1", Ecosystem="Lacustre", Region="b" } r2.addPaletteElement("palette.entities.creatures.cpblb4", entries.creature_cpblb4)
	entries.creature_cpblc1 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpblc1.creature", Level=60, RingAccess="l5", Ecosystem="Lacustre", Region="c" } r2.addPaletteElement("palette.entities.creatures.cpblc1", entries.creature_cpblc1)
	entries.creature_cpblc2 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpblc2.creature", Level=70, RingAccess="l5", Ecosystem="Lacustre", Region="c" } r2.addPaletteElement("palette.entities.creatures.cpblc2", entries.creature_cpblc2)
	entries.creature_cpblc3 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpblc3.creature", Level=80, RingAccess="l5", Ecosystem="Lacustre", Region="c" } r2.addPaletteElement("palette.entities.creatures.cpblc3", entries.creature_cpblc3)
	entries.creature_cpblc4 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpblc4.creature", Level=90, RingAccess="l5", Ecosystem="Lacustre", Region="c" } r2.addPaletteElement("palette.entities.creatures.cpblc4", entries.creature_cpblc4)
	entries.creature_cpbld1 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpbld1.creature", Level=110, RingAccess="l5", Ecosystem="Lacustre", Region="d" } r2.addPaletteElement("palette.entities.creatures.cpbld1", entries.creature_cpbld1)
	entries.creature_cpbld2 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpbld2.creature", Level=120, RingAccess="l5", Ecosystem="Lacustre", Region="d" } r2.addPaletteElement("palette.entities.creatures.cpbld2", entries.creature_cpbld2)
	entries.creature_cpbld3 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpbld3.creature", Level=130, RingAccess="l5", Ecosystem="Lacustre", Region="d" } r2.addPaletteElement("palette.entities.creatures.cpbld3", entries.creature_cpbld3)
	entries.creature_cpbld4 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpbld4.creature", Level=140, RingAccess="l5", Ecosystem="Lacustre", Region="d" } r2.addPaletteElement("palette.entities.creatures.cpbld4", entries.creature_cpbld4)
	entries.creature_cpblf4 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpblf4.creature", Level=240, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.cpblf4", entries.creature_cpblf4)
	entries.creature_cpcfb1 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpcfb1.creature", Level=10, RingAccess="a1", Ecosystem="Forest", Region="b" } r2.addPaletteElement("palette.entities.creatures.cpcfb1", entries.creature_cpcfb1)
	entries.creature_cpcfb2 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpcfb2.creature", Level=20, RingAccess="a1", Ecosystem="Forest", Region="b" } r2.addPaletteElement("palette.entities.creatures.cpcfb2", entries.creature_cpcfb2)
	entries.creature_cpcfb3 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpcfb3.creature", Level=30, RingAccess="a1", Ecosystem="Forest", Region="b" } r2.addPaletteElement("palette.entities.creatures.cpcfb3", entries.creature_cpcfb3)
	entries.creature_cpcfb4 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpcfb4.creature", Level=40, RingAccess="a1", Ecosystem="Forest", Region="b" } r2.addPaletteElement("palette.entities.creatures.cpcfb4", entries.creature_cpcfb4)
	entries.creature_cpcfc1 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpcfc1.creature", Level=60, RingAccess="f5", Ecosystem="Forest", Region="c" } r2.addPaletteElement("palette.entities.creatures.cpcfc1", entries.creature_cpcfc1)
	entries.creature_cpcfc2 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpcfc2.creature", Level=70, RingAccess="f5", Ecosystem="Forest", Region="c" } r2.addPaletteElement("palette.entities.creatures.cpcfc2", entries.creature_cpcfc2)
	entries.creature_cpcfc3 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpcfc3.creature", Level=80, RingAccess="f5", Ecosystem="Forest", Region="c" } r2.addPaletteElement("palette.entities.creatures.cpcfc3", entries.creature_cpcfc3)
	entries.creature_cpcfc4 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpcfc4.creature", Level=90, RingAccess="f5", Ecosystem="Forest", Region="c" } r2.addPaletteElement("palette.entities.creatures.cpcfc4", entries.creature_cpcfc4)
	--entries.creature_cpcgb1 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpcgb1.creature", Level=10, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.cpcgb1", entries.creature_cpcgb1)
	--entries.creature_cpcgb2 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpcgb2.creature", Level=20, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.cpcgb2", entries.creature_cpcgb2)
	--entries.creature_cpcgb3 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpcgb3.creature", Level=30, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.cpcgb3", entries.creature_cpcgb3)
	--entries.creature_cpcgb4 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpcgb4.creature", Level=40, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.cpcgb4", entries.creature_cpcgb4)
	--entries.creature_cpcgc1 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpcgc1.creature", Level=60, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.cpcgc1", entries.creature_cpcgc1)
	--entries.creature_cpcgc2 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpcgc2.creature", Level=70, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.cpcgc2", entries.creature_cpcgc2)
	--entries.creature_cpcgc3 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpcgc3.creature", Level=80, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.cpcgc3", entries.creature_cpcgc3)
	--entries.creature_cpcgc4 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpcgc4.creature", Level=90, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.cpcgc4", entries.creature_cpcgc4)
	--entries.creature_cpcgd1 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpcgd1.creature", Level=110, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.cpcgd1", entries.creature_cpcgd1)
	--entries.creature_cpcgd2 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpcgd2.creature", Level=120, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.cpcgd2", entries.creature_cpcgd2)
	--entries.creature_cpcgd3 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpcgd3.creature", Level=130, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.cpcgd3", entries.creature_cpcgd3)
	--entries.creature_cpcgd4 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpcgd4.creature", Level=140, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.cpcgd4", entries.creature_cpcgd4)
	--entries.creature_cpcge1 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpcge1.creature", Level=160, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.cpcge1", entries.creature_cpcge1)
	--entries.creature_cpcge2 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpcge2.creature", Level=170, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.cpcge2", entries.creature_cpcge2)
	--entries.creature_cpcge3 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpcge3.creature", Level=180, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.cpcge3", entries.creature_cpcge3)
	--entries.creature_cpcge4 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpcge4.creature", Level=190, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.cpcge4", entries.creature_cpcge4)
	--entries.creature_cpcgf1 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpcgf1.creature", Level=210, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.cpcgf1", entries.creature_cpcgf1)
	--entries.creature_cpcgf2 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpcgf2.creature", Level=220, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.cpcgf2", entries.creature_cpcgf2)

	--entries.creature_cpcgf3 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpcgf3.creature", Level=230, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.cpcgf3", entries.creature_cpcgf3)
	--entries.creature_cpcgf4 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpcgf4.creature", Level=240, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.cpcgf4", entries.creature_cpcgf4)
	entries.creature_cpcjd1 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpcjd1.creature", Level=110, RingAccess="j5", Ecosystem="Jungle", Region="d" } r2.addPaletteElement("palette.entities.creatures.cpcjd1", entries.creature_cpcjd1)
	entries.creature_cpcjd2 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpcjd2.creature", Level=120, RingAccess="j5", Ecosystem="Jungle", Region="d" } r2.addPaletteElement("palette.entities.creatures.cpcjd2", entries.creature_cpcjd2)
	entries.creature_cpcjd3 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpcjd3.creature", Level=130, RingAccess="j5", Ecosystem="Jungle", Region="d" } r2.addPaletteElement("palette.entities.creatures.cpcjd3", entries.creature_cpcjd3)
	entries.creature_cpcjd4 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpcjd4.creature", Level=140, RingAccess="j5", Ecosystem="Jungle", Region="d" } r2.addPaletteElement("palette.entities.creatures.cpcjd4", entries.creature_cpcjd4)
	entries.creature_cpcje1 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpcje1.creature", Level=160, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.cpcje1", entries.creature_cpcje1)
	entries.creature_cpcje2 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpcje2.creature", Level=170, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.cpcje2", entries.creature_cpcje2)
	entries.creature_cpcje3 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpcje3.creature", Level=180, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.cpcje3", entries.creature_cpcje3)
	entries.creature_cpcje4 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpcje4.creature", Level=190, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.cpcje4", entries.creature_cpcje4)
	entries.creature_cpcpf4 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpcpf4.creature", Level=240, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.cpcpf4", entries.creature_cpcpf4)
	entries.creature_cpdfe1 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpdfe1.creature", Level=160, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.cpdfe1", entries.creature_cpdfe1)
	entries.creature_cpdfe2 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpdfe2.creature", Level=170, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.cpdfe2", entries.creature_cpdfe2)
	entries.creature_cpdfe3 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpdfe3.creature", Level=180, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.cpdfe3", entries.creature_cpdfe3)
	entries.creature_cpdfe4 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpdfe4.creature", Level=190, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.cpdfe4", entries.creature_cpdfe4)
	entries.creature_cpdff1 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpdff1.creature", Level=210, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.cpdff1", entries.creature_cpdff1)
	entries.creature_cpdff2 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpdff2.creature", Level=220, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.cpdff2", entries.creature_cpdff2)
	entries.creature_cpdff3 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpdff3.creature", Level=230, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.cpdff3", entries.creature_cpdff3)
	entries.creature_cpdff4 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpdff4.creature", Level=240, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.cpdff4", entries.creature_cpdff4)
	--entries.creature_cpdgb1 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpdgb1.creature", Level=10, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.cpdgb1", entries.creature_cpdgb1)
	--entries.creature_cpdgb2 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpdgb2.creature", Level=20, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.cpdgb2", entries.creature_cpdgb2)
	--entries.creature_cpdgb3 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpdgb3.creature", Level=30, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.cpdgb3", entries.creature_cpdgb3)
	--entries.creature_cpdgb4 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpdgb4.creature", Level=40, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.cpdgb4", entries.creature_cpdgb4)
	--entries.creature_cpdgc1 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpdgc1.creature", Level=60, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.cpdgc1", entries.creature_cpdgc1)
	--entries.creature_cpdgc2 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpdgc2.creature", Level=70, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.cpdgc2", entries.creature_cpdgc2)
	--entries.creature_cpdgc3 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpdgc3.creature", Level=80, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.cpdgc3", entries.creature_cpdgc3)
	--entries.creature_cpdgc4 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpdgc4.creature", Level=90, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.cpdgc4", entries.creature_cpdgc4)
	--entries.creature_cpdgd1 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpdgd1.creature", Level=110, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.cpdgd1", entries.creature_cpdgd1)
	--entries.creature_cpdgd2 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpdgd2.creature", Level=120, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.cpdgd2", entries.creature_cpdgd2)
	--entries.creature_cpdgd3 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpdgd3.creature", Level=130, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.cpdgd3", entries.creature_cpdgd3)
	--entries.creature_cpdgd4 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpdgd4.creature", Level=140, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.cpdgd4", entries.creature_cpdgd4)
	--entries.creature_cpdge1 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpdge1.creature", Level=160, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.cpdge1", entries.creature_cpdge1)
	--entries.creature_cpdge2 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpdge2.creature", Level=170, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.cpdge2", entries.creature_cpdge2)
	--entries.creature_cpdge3 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpdge3.creature", Level=180, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.cpdge3", entries.creature_cpdge3)
	--entries.creature_cpdge4 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpdge4.creature", Level=190, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.cpdge4", entries.creature_cpdge4)
	--entries.creature_cpdgf1 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpdgf1.creature", Level=210, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.cpdgf1", entries.creature_cpdgf1)
	--entries.creature_cpdgf2 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpdgf2.creature", Level=220, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.cpdgf2", entries.creature_cpdgf2)
	--entries.creature_cpdgf3 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpdgf3.creature", Level=230, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.cpdgf3", entries.creature_cpdgf3)
	--entries.creature_cpdgf4 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpdgf4.creature", Level=240, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.cpdgf4", entries.creature_cpdgf4)
	entries.creature_cpdjb1 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpdjb1.creature", Level=10, RingAccess="a1", Ecosystem="Jungle", Region="b" } r2.addPaletteElement("palette.entities.creatures.cpdjb1", entries.creature_cpdjb1)
	entries.creature_cpdjb2 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpdjb2.creature", Level=20, RingAccess="a1", Ecosystem="Jungle", Region="b" } r2.addPaletteElement("palette.entities.creatures.cpdjb2", entries.creature_cpdjb2)
	entries.creature_cpdjb3 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpdjb3.creature", Level=30, RingAccess="a1", Ecosystem="Jungle", Region="b" } r2.addPaletteElement("palette.entities.creatures.cpdjb3", entries.creature_cpdjb3)
	entries.creature_cpdjb4 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpdjb4.creature", Level=40, RingAccess="a1", Ecosystem="Jungle", Region="b" } r2.addPaletteElement("palette.entities.creatures.cpdjb4", entries.creature_cpdjb4)
	entries.creature_cpdjc1 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpdjc1.creature", Level=60, RingAccess="j5", Ecosystem="Jungle", Region="c" } r2.addPaletteElement("palette.entities.creatures.cpdjc1", entries.creature_cpdjc1)
	entries.creature_cpdjc2 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpdjc2.creature", Level=70, RingAccess="j5", Ecosystem="Jungle", Region="c" } r2.addPaletteElement("palette.entities.creatures.cpdjc2", entries.creature_cpdjc2)
	entries.creature_cpdjc3 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpdjc3.creature", Level=80, RingAccess="j5", Ecosystem="Jungle", Region="c" } r2.addPaletteElement("palette.entities.creatures.cpdjc3", entries.creature_cpdjc3)
	entries.creature_cpdjc4 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpdjc4.creature", Level=90, RingAccess="j5", Ecosystem="Jungle", Region="c" } r2.addPaletteElement("palette.entities.creatures.cpdjc4", entries.creature_cpdjc4)
	entries.creature_cpdje4 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpdje4.creature", Level=190, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.cpdje4", entries.creature_cpdje4)
	entries.creature_cpefd1 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpefd1.creature", Level=110, RingAccess="f5", Ecosystem="Forest", Region="d" } r2.addPaletteElement("palette.entities.creatures.cpefd1", entries.creature_cpefd1)
	entries.creature_cpefd2 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpefd2.creature", Level=120, RingAccess="f5", Ecosystem="Forest", Region="d" } r2.addPaletteElement("palette.entities.creatures.cpefd2", entries.creature_cpefd2)
	entries.creature_cpefd3 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpefd3.creature", Level=130, RingAccess="f5", Ecosystem="Forest", Region="d" } r2.addPaletteElement("palette.entities.creatures.cpefd3", entries.creature_cpefd3)
	entries.creature_cpefd4 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpefd4.creature", Level=140, RingAccess="f5", Ecosystem="Forest", Region="d" } r2.addPaletteElement("palette.entities.creatures.cpefd4", entries.creature_cpefd4)
	entries.creature_cpefe1 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpefe1.creature", Level=160, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.cpefe1", entries.creature_cpefe1)
	entries.creature_cpefe2 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpefe2.creature", Level=170, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.cpefe2", entries.creature_cpefe2)

	entries.creature_cpefe3 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpefe3.creature", Level=180, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.cpefe3", entries.creature_cpefe3)
	entries.creature_cpefe4 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpefe4.creature", Level=190, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.cpefe4", entries.creature_cpefe4)
	--entries.creature_cpegb1 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpegb1.creature", Level=10, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.cpegb1", entries.creature_cpegb1)
	--entries.creature_cpegb2 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpegb2.creature", Level=20, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.cpegb2", entries.creature_cpegb2)
	--entries.creature_cpegb3 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpegb3.creature", Level=30, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.cpegb3", entries.creature_cpegb3)
	--entries.creature_cpegb4 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpegb4.creature", Level=40, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.cpegb4", entries.creature_cpegb4)
	--entries.creature_cpegc1 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpegc1.creature", Level=60, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.cpegc1", entries.creature_cpegc1)
	--entries.creature_cpegc2 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpegc2.creature", Level=70, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.cpegc2", entries.creature_cpegc2)
	--entries.creature_cpegc3 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpegc3.creature", Level=80, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.cpegc3", entries.creature_cpegc3)
	--entries.creature_cpegc4 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpegc4.creature", Level=90, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.cpegc4", entries.creature_cpegc4)
	--entries.creature_cpegd1 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpegd1.creature", Level=110, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.cpegd1", entries.creature_cpegd1)
	--entries.creature_cpegd2 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpegd2.creature", Level=120, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.cpegd2", entries.creature_cpegd2)
	--entries.creature_cpegd3 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpegd3.creature", Level=130, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.cpegd3", entries.creature_cpegd3)
	--entries.creature_cpegd4 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpegd4.creature", Level=140, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.cpegd4", entries.creature_cpegd4)
	--entries.creature_cpege1 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpege1.creature", Level=160, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.cpege1", entries.creature_cpege1)
	--entries.creature_cpege2 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpege2.creature", Level=170, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.cpege2", entries.creature_cpege2)
	--entries.creature_cpege3 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpege3.creature", Level=180, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.cpege3", entries.creature_cpege3)
	--entries.creature_cpege4 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpege4.creature", Level=190, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.cpege4", entries.creature_cpege4)
	--entries.creature_cpegf1 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpegf1.creature", Level=210, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.cpegf1", entries.creature_cpegf1)
	--entries.creature_cpegf2 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpegf2.creature", Level=220, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.cpegf2", entries.creature_cpegf2)
	--entries.creature_cpegf3 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpegf3.creature", Level=230, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.cpegf3", entries.creature_cpegf3)
	--entries.creature_cpegf4 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpegf4.creature", Level=240, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.cpegf4", entries.creature_cpegf4)
	entries.creature_cpejf1 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpejf1.creature", Level=210, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.cpejf1", entries.creature_cpejf1)
	entries.creature_cpejf2 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpejf2.creature", Level=220, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.cpejf2", entries.creature_cpejf2)
	entries.creature_cpejf3 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpejf3.creature", Level=230, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.cpejf3", entries.creature_cpejf3)
	entries.creature_cpejf4 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpejf4.creature", Level=240, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.cpejf4", entries.creature_cpejf4)
	entries.creature_cpfdb1 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpfdb1.creature", Level=10, RingAccess="a1", Ecosystem="Desert", Region="b" } r2.addPaletteElement("palette.entities.creatures.cpfdb1", entries.creature_cpfdb1)
	entries.creature_cpfdb2 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpfdb2.creature", Level=20, RingAccess="a1", Ecosystem="Desert", Region="b" } r2.addPaletteElement("palette.entities.creatures.cpfdb2", entries.creature_cpfdb2)
	entries.creature_cpfdb3 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpfdb3.creature", Level=30, RingAccess="a1", Ecosystem="Desert", Region="b" } r2.addPaletteElement("palette.entities.creatures.cpfdb3", entries.creature_cpfdb3)
	entries.creature_cpfdb4 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpfdb4.creature", Level=40, RingAccess="a1", Ecosystem="Desert", Region="b" } r2.addPaletteElement("palette.entities.creatures.cpfdb4", entries.creature_cpfdb4)
	entries.creature_cpfdc1 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpfdc1.creature", Level=60, RingAccess="d2", Ecosystem="Desert", Region="c" } r2.addPaletteElement("palette.entities.creatures.cpfdc1", entries.creature_cpfdc1)
	entries.creature_cpfdc2 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpfdc2.creature", Level=70, RingAccess="d2", Ecosystem="Desert", Region="c" } r2.addPaletteElement("palette.entities.creatures.cpfdc2", entries.creature_cpfdc2)
	entries.creature_cpfdc3 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpfdc3.creature", Level=80, RingAccess="d2", Ecosystem="Desert", Region="c" } r2.addPaletteElement("palette.entities.creatures.cpfdc3", entries.creature_cpfdc3)
	entries.creature_cpfdc4 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpfdc4.creature", Level=90, RingAccess="d2", Ecosystem="Desert", Region="c" } r2.addPaletteElement("palette.entities.creatures.cpfdc4", entries.creature_cpfdc4)
	entries.creature_cpfdd1 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpfdd1.creature", Level=110, RingAccess="d4", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.cpfdd1", entries.creature_cpfdd1)
	entries.creature_cpfdd2 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpfdd2.creature", Level=120, RingAccess="d4", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.cpfdd2", entries.creature_cpfdd2)
	entries.creature_cpfdd3 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpfdd3.creature", Level=130, RingAccess="d4", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.cpfdd3", entries.creature_cpfdd3)
	entries.creature_cpfdd4 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpfdd4.creature", Level=140, RingAccess="d4", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.cpfdd4", entries.creature_cpfdd4)
	entries.creature_cpfdf4 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpfdf4.creature", Level=240, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.cpfdf4", entries.creature_cpfdf4)
	--entries.creature_cpfgb1 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpfgb1.creature", Level=10, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.cpfgb1", entries.creature_cpfgb1)
	--entries.creature_cpfgb2 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpfgb2.creature", Level=20, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.cpfgb2", entries.creature_cpfgb2)
	--entries.creature_cpfgb3 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpfgb3.creature", Level=30, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.cpfgb3", entries.creature_cpfgb3)
	--entries.creature_cpfgb4 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpfgb4.creature", Level=40, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.cpfgb4", entries.creature_cpfgb4)
	--entries.creature_cpfgc1 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpfgc1.creature", Level=60, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.cpfgc1", entries.creature_cpfgc1)
	--entries.creature_cpfgc2 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpfgc2.creature", Level=70, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.cpfgc2", entries.creature_cpfgc2)
	--entries.creature_cpfgc3 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpfgc3.creature", Level=80, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.cpfgc3", entries.creature_cpfgc3)
	--entries.creature_cpfgc4 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpfgc4.creature", Level=90, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.cpfgc4", entries.creature_cpfgc4)
	--entries.creature_cpfgd1 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpfgd1.creature", Level=110, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.cpfgd1", entries.creature_cpfgd1)
	--entries.creature_cpfgd2 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpfgd2.creature", Level=120, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.cpfgd2", entries.creature_cpfgd2)
	--entries.creature_cpfgd3 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpfgd3.creature", Level=130, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.cpfgd3", entries.creature_cpfgd3)
	--entries.creature_cpfgd4 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpfgd4.creature", Level=140, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.cpfgd4", entries.creature_cpfgd4)
	--entries.creature_cpfge1 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpfge1.creature", Level=160, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.cpfge1", entries.creature_cpfge1)
	--entries.creature_cpfge2 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpfge2.creature", Level=170, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.cpfge2", entries.creature_cpfge2)
	--entries.creature_cpfge3 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpfge3.creature", Level=180, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.cpfge3", entries.creature_cpfge3)
	--entries.creature_cpfge4 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpfge4.creature", Level=190, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.cpfge4", entries.creature_cpfge4)
	--entries.creature_cpfgf1 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpfgf1.creature", Level=210, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.cpfgf1", entries.creature_cpfgf1)
	--entries.creature_cpfgf2 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpfgf2.creature", Level=220, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.cpfgf2", entries.creature_cpfgf2)
	--entries.creature_cpfgf3 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpfgf3.creature", Level=230, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.cpfgf3", entries.creature_cpfgf3)
	--entries.creature_cpfgf4 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpfgf4.creature", Level=240, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.cpfgf4", entries.creature_cpfgf4)


-- Degens (primitive tribes)
	--entries.creature_cdagb1 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdagb1.creature", Level=10, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.cdagb1", entries.creature_cdagb1)
	--entries.creature_cdagb2 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdagb2.creature", Level=20, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.cdagb2", entries.creature_cdagb2)
	--entries.creature_cdagb3 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdagb3.creature", Level=30, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.cdagb3", entries.creature_cdagb3)
	--entries.creature_cdagb4 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdagb4.creature", Level=40, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.cdagb4", entries.creature_cdagb4)
	--entries.creature_cdagc1 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdagc1.creature", Level=60, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.cdagc1", entries.creature_cdagc1)
	--entries.creature_cdagc2 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdagc2.creature", Level=70, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.cdagc2", entries.creature_cdagc2)
	--entries.creature_cdagc3 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdagc3.creature", Level=80, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.cdagc3", entries.creature_cdagc3)
	--entries.creature_cdagc4 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdagc4.creature", Level=90, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.cdagc4", entries.creature_cdagc4)
	--entries.creature_cdagd1 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdagd1.creature", Level=110, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.cdagd1", entries.creature_cdagd1)
	--entries.creature_cdagd2 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdagd2.creature", Level=120, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.cdagd2", entries.creature_cdagd2)
	--entries.creature_cdagd3 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdagd3.creature", Level=130, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.cdagd3", entries.creature_cdagd3)
	--entries.creature_cdagd4 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdagd4.creature", Level=140, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.cdagd4", entries.creature_cdagd4)
	--entries.creature_cdage1 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdage1.creature", Level=160, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.cdage1", entries.creature_cdage1)
	--entries.creature_cdage2 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdage2.creature", Level=170, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.cdage2", entries.creature_cdage2)
	--entries.creature_cdage3 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdage3.creature", Level=180, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.cdage3", entries.creature_cdage3)
	--entries.creature_cdage4 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdage4.creature", Level=190, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.cdage4", entries.creature_cdage4)
	--entries.creature_cdagf1 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdagf1.creature", Level=210, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.cdagf1", entries.creature_cdagf1)
	--entries.creature_cdagf2 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdagf2.creature", Level=220, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.cdagf2", entries.creature_cdagf2)
	--entries.creature_cdagf3 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdagf3.creature", Level=230, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.cdagf3", entries.creature_cdagf3)
	--entries.creature_cdagf4 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdagf4.creature", Level=240, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.cdagf4", entries.creature_cdagf4)
	entries.creature_cdald1 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdald1.creature", Level=110, RingAccess="l5", Ecosystem="Lacustre", Region="d" } r2.addPaletteElement("palette.entities.creatures.cdald1", entries.creature_cdald1)
	entries.creature_cdald2 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdald2.creature", Level=120, RingAccess="l5", Ecosystem="Lacustre", Region="d" } r2.addPaletteElement("palette.entities.creatures.cdald2", entries.creature_cdald2)
	entries.creature_cdald3 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdald3.creature", Level=130, RingAccess="l5", Ecosystem="Lacustre", Region="d" } r2.addPaletteElement("palette.entities.creatures.cdald3", entries.creature_cdald3)
	entries.creature_cdald4 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdald4.creature", Level=140, RingAccess="l5", Ecosystem="Lacustre", Region="d" } r2.addPaletteElement("palette.entities.creatures.cdald4", entries.creature_cdald4)
	entries.creature_cdale1 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdale1.creature", Level=160, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.cdale1", entries.creature_cdale1)
	entries.creature_cdale2 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdale2.creature", Level=170, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.cdale2", entries.creature_cdale2)
	entries.creature_cdale3 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdale3.creature", Level=180, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.cdale3", entries.creature_cdale3)
	entries.creature_cdale4 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdale4.creature", Level=190, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.cdale4", entries.creature_cdale4)
	entries.creature_cdapd1 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdapd1.creature", Level=110, RingAccess="p1", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.cdapd1", entries.creature_cdapd1)
	entries.creature_cdapd2 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdapd2.creature", Level=120, RingAccess="p1", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.cdapd2", entries.creature_cdapd2)
	entries.creature_cdapd3 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdapd3.creature", Level=130, RingAccess="p1", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.cdapd3", entries.creature_cdapd3)
	entries.creature_cdapd4 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdapd4.creature", Level=140, RingAccess="p1", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.cdapd4", entries.creature_cdapd4)
	entries.creature_cdape1 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdape1.creature", Level=160, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.cdape1", entries.creature_cdape1)
	entries.creature_cdape2 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdape2.creature", Level=170, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.cdape2", entries.creature_cdape2)
	entries.creature_cdape3 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdape3.creature", Level=180, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.cdape3", entries.creature_cdape3)
	entries.creature_cdape4 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdape4.creature", Level=190, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.cdape4", entries.creature_cdape4)
	entries.creature_cdbfd1 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdbfd1.creature", Level=110, RingAccess="f5", Ecosystem="Forest", Region="d" } r2.addPaletteElement("palette.entities.creatures.cdbfd1", entries.creature_cdbfd1)
	entries.creature_cdbfd2 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdbfd2.creature", Level=120, RingAccess="f5", Ecosystem="Forest", Region="d" } r2.addPaletteElement("palette.entities.creatures.cdbfd2", entries.creature_cdbfd2)
	entries.creature_cdbfd3 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdbfd3.creature", Level=130, RingAccess="f5", Ecosystem="Forest", Region="d" } r2.addPaletteElement("palette.entities.creatures.cdbfd3", entries.creature_cdbfd3)
	entries.creature_cdbfd4 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdbfd4.creature", Level=140, RingAccess="f5", Ecosystem="Forest", Region="d" } r2.addPaletteElement("palette.entities.creatures.cdbfd4", entries.creature_cdbfd4)
	entries.creature_cdbfe1 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdbfe1.creature", Level=160, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.cdbfe1", entries.creature_cdbfe1)
	entries.creature_cdbfe2 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdbfe2.creature", Level=170, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.cdbfe2", entries.creature_cdbfe2)
	entries.creature_cdbfe3 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdbfe3.creature", Level=180, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.cdbfe3", entries.creature_cdbfe3)
	entries.creature_cdbfe4 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdbfe4.creature", Level=190, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.cdbfe4", entries.creature_cdbfe4)
	--entries.creature_cdbgb1 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdbgb1.creature", Level=10, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.cdbgb1", entries.creature_cdbgb1)
	--entries.creature_cdbgb2 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdbgb2.creature", Level=20, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.cdbgb2", entries.creature_cdbgb2)
	--entries.creature_cdbgb3 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdbgb3.creature", Level=30, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.cdbgb3", entries.creature_cdbgb3)
	--entries.creature_cdbgb4 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdbgb4.creature", Level=40, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.cdbgb4", entries.creature_cdbgb4)
	--entries.creature_cdbgc1 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdbgc1.creature", Level=60, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.cdbgc1", entries.creature_cdbgc1)
	--entries.creature_cdbgc2 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdbgc2.creature", Level=70, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.cdbgc2", entries.creature_cdbgc2)
	--entries.creature_cdbgc3 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdbgc3.creature", Level=80, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.cdbgc3", entries.creature_cdbgc3)
	--entries.creature_cdbgc4 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdbgc4.creature", Level=90, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.cdbgc4", entries.creature_cdbgc4)
	--entries.creature_cdbgd1 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdbgd1.creature", Level=110, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.cdbgd1", entries.creature_cdbgd1)
	--entries.creature_cdbgd2 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdbgd2.creature", Level=120, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.cdbgd2", entries.creature_cdbgd2)
	--entries.creature_cdbgd3 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdbgd3.creature", Level=130, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.cdbgd3", entries.creature_cdbgd3)
	--entries.creature_cdbgd4 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdbgd4.creature", Level=140, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.cdbgd4", entries.creature_cdbgd4)
	--entries.creature_cdbge1 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdbge1.creature", Level=160, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.cdbge1", entries.creature_cdbge1)
	--entries.creature_cdbge2 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdbge2.creature", Level=170, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.cdbge2", entries.creature_cdbge2)
	--entries.creature_cdbge3 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdbge3.creature", Level=180, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.cdbge3", entries.creature_cdbge3)
	--entries.creature_cdbge4 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdbge4.creature", Level=190, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.cdbge4", entries.creature_cdbge4)
	--entries.creature_cdbgf1 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdbgf1.creature", Level=210, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.cdbgf1", entries.creature_cdbgf1)
	--entries.creature_cdbgf2 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdbgf2.creature", Level=220, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.cdbgf2", entries.creature_cdbgf2)
	--entries.creature_cdbgf3 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdbgf3.creature", Level=230, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.cdbgf3", entries.creature_cdbgf3)
	--entries.creature_cdbgf4 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdbgf4.creature", Level=240, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.cdbgf4", entries.creature_cdbgf4)
	entries.creature_cdbjd1 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdbjd1.creature", Level=110, RingAccess="j5", Ecosystem="Jungle", Region="d" } r2.addPaletteElement("palette.entities.creatures.cdbjd1", entries.creature_cdbjd1)
	entries.creature_cdbjd2 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdbjd2.creature", Level=120, RingAccess="j5", Ecosystem="Jungle", Region="d" } r2.addPaletteElement("palette.entities.creatures.cdbjd2", entries.creature_cdbjd2)
	entries.creature_cdbjd3 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdbjd3.creature", Level=130, RingAccess="j5", Ecosystem="Jungle", Region="d" } r2.addPaletteElement("palette.entities.creatures.cdbjd3", entries.creature_cdbjd3)
	entries.creature_cdbjd4 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdbjd4.creature", Level=140, RingAccess="j5", Ecosystem="Jungle", Region="d" } r2.addPaletteElement("palette.entities.creatures.cdbjd4", entries.creature_cdbjd4)
	entries.creature_cdbje1 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdbje1.creature", Level=160, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.cdbje1", entries.creature_cdbje1)
	entries.creature_cdbje2 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdbje2.creature", Level=170, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.cdbje2", entries.creature_cdbje2)
	entries.creature_cdbje3 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdbje3.creature", Level=180, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.cdbje3", entries.creature_cdbje3)
	entries.creature_cdbje4 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdbje4.creature", Level=190, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.cdbje4", entries.creature_cdbje4)
	entries.creature_cdcdd1 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdcdd1.creature", Level=110, RingAccess="d4", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.cdcdd1", entries.creature_cdcdd1)
	entries.creature_cdcdd2 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdcdd2.creature", Level=120, RingAccess="d4", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.cdcdd2", entries.creature_cdcdd2)
	entries.creature_cdcdd3 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdcdd3.creature", Level=130, RingAccess="d4", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.cdcdd3", entries.creature_cdcdd3)
	entries.creature_cdcdd4 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdcdd4.creature", Level=140, RingAccess="d4", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.cdcdd4", entries.creature_cdcdd4)
	entries.creature_cdcde1 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdcde1.creature", Level=160, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.cdcde1", entries.creature_cdcde1)
	entries.creature_cdcde2 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdcde2.creature", Level=170, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.cdcde2", entries.creature_cdcde2)
	entries.creature_cdcde3 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdcde3.creature", Level=180, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.cdcde3", entries.creature_cdcde3)
	entries.creature_cdcde4 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdcde4.creature", Level=190, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.cdcde4", entries.creature_cdcde4)
	--entries.creature_cdcgb1 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdcgb1.creature", Level=10, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.cdcgb1", entries.creature_cdcgb1)
	--entries.creature_cdcgb2 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdcgb2.creature", Level=20, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.cdcgb2", entries.creature_cdcgb2)
	--entries.creature_cdcgb3 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdcgb3.creature", Level=30, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.cdcgb3", entries.creature_cdcgb3)
	--entries.creature_cdcgb4 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdcgb4.creature", Level=40, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.cdcgb4", entries.creature_cdcgb4)
	--entries.creature_cdcgc1 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdcgc1.creature", Level=60, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.cdcgc1", entries.creature_cdcgc1)
	--entries.creature_cdcgc2 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdcgc2.creature", Level=70, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.cdcgc2", entries.creature_cdcgc2)
	--entries.creature_cdcgc3 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdcgc3.creature", Level=80, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.cdcgc3", entries.creature_cdcgc3)
	--entries.creature_cdcgc4 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdcgc4.creature", Level=90, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.cdcgc4", entries.creature_cdcgc4)
	--entries.creature_cdcgd1 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdcgd1.creature", Level=110, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.cdcgd1", entries.creature_cdcgd1)
	--entries.creature_cdcgd2 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdcgd2.creature", Level=120, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.cdcgd2", entries.creature_cdcgd2)
	--entries.creature_cdcgd3 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdcgd3.creature", Level=130, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.cdcgd3", entries.creature_cdcgd3)
	--entries.creature_cdcgd4 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdcgd4.creature", Level=140, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.cdcgd4", entries.creature_cdcgd4)
	--entries.creature_cdcge1 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdcge1.creature", Level=160, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.cdcge1", entries.creature_cdcge1)
	--entries.creature_cdcge2 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdcge2.creature", Level=170, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.cdcge2", entries.creature_cdcge2)
	--entries.creature_cdcge3 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdcge3.creature", Level=180, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.cdcge3", entries.creature_cdcge3)
	--entries.creature_cdcge4 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdcge4.creature", Level=190, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.cdcge4", entries.creature_cdcge4)
	--entries.creature_cdcgf1 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdcgf1.creature", Level=210, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.cdcgf1", entries.creature_cdcgf1)
	--entries.creature_cdcgf2 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdcgf2.creature", Level=220, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.cdcgf2", entries.creature_cdcgf2)
	--entries.creature_cdcgf3 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdcgf3.creature", Level=230, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.cdcgf3", entries.creature_cdcgf3)
	--entries.creature_cdcgf4 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdcgf4.creature", Level=240, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.cdcgf4", entries.creature_cdcgf4)


-- Kitins
	entries.creature_ckade1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckade1.creature", Level=160, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckade1", entries.creature_ckade1)
	entries.creature_ckade2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckade2.creature", Level=170, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckade2", entries.creature_ckade2)
	entries.creature_ckade3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckade3.creature", Level=180, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckade3", entries.creature_ckade3)
	entries.creature_ckade4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckade4.creature", Level=190, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckade4", entries.creature_ckade4)
	entries.creature_ckadf1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckadf1.creature", Level=210, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckadf1", entries.creature_ckadf1)
	entries.creature_ckadf2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckadf2.creature", Level=220, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckadf2", entries.creature_ckadf2)
	entries.creature_ckadf3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckadf3.creature", Level=230, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckadf3", entries.creature_ckadf3)
	entries.creature_ckadf4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckadf4.creature", Level=240, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckadf4", entries.creature_ckadf4)
	entries.creature_ckafe1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckafe1.creature", Level=160, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckafe1", entries.creature_ckafe1)
	entries.creature_ckafe2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckafe2.creature", Level=170, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckafe2", entries.creature_ckafe2)
	entries.creature_ckafe3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckafe3.creature", Level=180, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckafe3", entries.creature_ckafe3)
	entries.creature_ckafe4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckafe4.creature", Level=190, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckafe4", entries.creature_ckafe4)
	entries.creature_ckaff1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckaff1.creature", Level=210, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckaff1", entries.creature_ckaff1)
	entries.creature_ckaff2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckaff2.creature", Level=220, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckaff2", entries.creature_ckaff2)
	entries.creature_ckaff3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckaff3.creature", Level=230, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckaff3", entries.creature_ckaff3)
	entries.creature_ckaff4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckaff4.creature", Level=240, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckaff4", entries.creature_ckaff4)
	--entries.creature_ckagb1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckagb1.creature", Level=10, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckagb1", entries.creature_ckagb1)
	--entries.creature_ckagb2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckagb2.creature", Level=20, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckagb2", entries.creature_ckagb2)
	--entries.creature_ckagb3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckagb3.creature", Level=30, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckagb3", entries.creature_ckagb3)
	--entries.creature_ckagb4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckagb4.creature", Level=40, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckagb4", entries.creature_ckagb4)
	--entries.creature_ckagc1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckagc1.creature", Level=60, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckagc1", entries.creature_ckagc1)
	--entries.creature_ckagc2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckagc2.creature", Level=70, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckagc2", entries.creature_ckagc2)
	--entries.creature_ckagc3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckagc3.creature", Level=80, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckagc3", entries.creature_ckagc3)
	--entries.creature_ckagc4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckagc4.creature", Level=90, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckagc4", entries.creature_ckagc4)
	--entries.creature_ckagd1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckagd1.creature", Level=110, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckagd1", entries.creature_ckagd1)
	--entries.creature_ckagd2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckagd2.creature", Level=120, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckagd2", entries.creature_ckagd2)
	--entries.creature_ckagd3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckagd3.creature", Level=130, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckagd3", entries.creature_ckagd3)
	--entries.creature_ckagd4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckagd4.creature", Level=140, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckagd4", entries.creature_ckagd4)
	--entries.creature_ckage1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckage1.creature", Level=160, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckage1", entries.creature_ckage1)
	--entries.creature_ckage2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckage2.creature", Level=170, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckage2", entries.creature_ckage2)
	--entries.creature_ckage3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckage3.creature", Level=180, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckage3", entries.creature_ckage3)
	--entries.creature_ckage4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckage4.creature", Level=190, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckage4", entries.creature_ckage4)
	--entries.creature_ckagf1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckagf1.creature", Level=210, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckagf1", entries.creature_ckagf1)
	--entries.creature_ckagf2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckagf2.creature", Level=220, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckagf2", entries.creature_ckagf2)
	--entries.creature_ckagf3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckagf3.creature", Level=230, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckagf3", entries.creature_ckagf3)
	--entries.creature_ckagf4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckagf4.creature", Level=240, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckagf4", entries.creature_ckagf4)
	entries.creature_ckaje1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckaje1.creature", Level=160, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckaje1", entries.creature_ckaje1)
	entries.creature_ckaje2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckaje2.creature", Level=170, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckaje2", entries.creature_ckaje2)
	entries.creature_ckaje3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckaje3.creature", Level=180, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckaje3", entries.creature_ckaje3)
	entries.creature_ckaje4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckaje4.creature", Level=190, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckaje4", entries.creature_ckaje4)
	entries.creature_ckajf1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckajf1.creature", Level=210, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckajf1", entries.creature_ckajf1)
	entries.creature_ckajf2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckajf2.creature", Level=220, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckajf2", entries.creature_ckajf2)
	entries.creature_ckajf3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckajf3.creature", Level=230, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckajf3", entries.creature_ckajf3)
	entries.creature_ckajf4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckajf4.creature", Level=240, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckajf4", entries.creature_ckajf4)
	entries.creature_ckale1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckale1.creature", Level=160, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckale1", entries.creature_ckale1)
	entries.creature_ckale2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckale2.creature", Level=170, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckale2", entries.creature_ckale2)
	entries.creature_ckale3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckale3.creature", Level=180, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckale3", entries.creature_ckale3)
	entries.creature_ckale4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckale4.creature", Level=190, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckale4", entries.creature_ckale4)
	entries.creature_ckalf1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckalf1.creature", Level=210, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckalf1", entries.creature_ckalf1)
	entries.creature_ckalf2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckalf2.creature", Level=220, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckalf2", entries.creature_ckalf2)
	entries.creature_ckalf3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckalf3.creature", Level=230, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckalf3", entries.creature_ckalf3)
	entries.creature_ckalf4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckalf4.creature", Level=240, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckalf4", entries.creature_ckalf4)
	entries.creature_ckape1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckape1.creature", Level=160, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckape1", entries.creature_ckape1)
	entries.creature_ckape2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckape2.creature", Level=170, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckape2", entries.creature_ckape2)
	entries.creature_ckape3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckape3.creature", Level=180, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckape3", entries.creature_ckape3)
	entries.creature_ckape4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckape4.creature", Level=190, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckape4", entries.creature_ckape4)
	entries.creature_ckapf1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckapf1.creature", Level=210, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckapf1", entries.creature_ckapf1)
	entries.creature_ckapf2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckapf2.creature", Level=220, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckapf2", entries.creature_ckapf2)
	entries.creature_ckapf3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckapf3.creature", Level=230, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckapf3", entries.creature_ckapf3)
	entries.creature_ckapf4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckapf4.creature", Level=240, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckapf4", entries.creature_ckapf4)
	entries.creature_ckbde1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbde1.creature", Level=160, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckbde1", entries.creature_ckbde1)
	entries.creature_ckbde2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbde2.creature", Level=170, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckbde2", entries.creature_ckbde2)
	entries.creature_ckbde3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbde3.creature", Level=180, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckbde3", entries.creature_ckbde3)
	entries.creature_ckbde4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbde4.creature", Level=190, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckbde4", entries.creature_ckbde4)
	entries.creature_ckbdf1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbdf1.creature", Level=210, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckbdf1", entries.creature_ckbdf1)
	entries.creature_ckbdf2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbdf2.creature", Level=220, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckbdf2", entries.creature_ckbdf2)
	entries.creature_ckbdf3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbdf3.creature", Level=230, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckbdf3", entries.creature_ckbdf3)
	entries.creature_ckbdf4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbdf4.creature", Level=240, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckbdf4", entries.creature_ckbdf4)
	entries.creature_ckbfe1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbfe1.creature", Level=160, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckbfe1", entries.creature_ckbfe1)
	entries.creature_ckbfe2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbfe2.creature", Level=170, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckbfe2", entries.creature_ckbfe2)
	entries.creature_ckbfe3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbfe3.creature", Level=180, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckbfe3", entries.creature_ckbfe3)
	entries.creature_ckbfe4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbfe4.creature", Level=190, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckbfe4", entries.creature_ckbfe4)
	entries.creature_ckbff1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbff1.creature", Level=210, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckbff1", entries.creature_ckbff1)
	entries.creature_ckbff2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbff2.creature", Level=220, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckbff2", entries.creature_ckbff2)
	entries.creature_ckbff3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbff3.creature", Level=230, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckbff3", entries.creature_ckbff3)
	entries.creature_ckbff4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbff4.creature", Level=240, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckbff4", entries.creature_ckbff4)
	--entries.creature_ckbgb1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbgb1.creature", Level=10, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckbgb1", entries.creature_ckbgb1)
	--entries.creature_ckbgb2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbgb2.creature", Level=20, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckbgb2", entries.creature_ckbgb2)
	--entries.creature_ckbgb3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbgb3.creature", Level=30, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckbgb3", entries.creature_ckbgb3)
	--entries.creature_ckbgb4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbgb4.creature", Level=40, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckbgb4", entries.creature_ckbgb4)
	--entries.creature_ckbgc1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbgc1.creature", Level=60, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckbgc1", entries.creature_ckbgc1)
	--entries.creature_ckbgc2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbgc2.creature", Level=70, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckbgc2", entries.creature_ckbgc2)
	--entries.creature_ckbgc3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbgc3.creature", Level=80, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckbgc3", entries.creature_ckbgc3)
	--entries.creature_ckbgc4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbgc4.creature", Level=90, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckbgc4", entries.creature_ckbgc4)
	--entries.creature_ckbgd1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbgd1.creature", Level=110, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckbgd1", entries.creature_ckbgd1)
	--entries.creature_ckbgd2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbgd2.creature", Level=120, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckbgd2", entries.creature_ckbgd2)
	--entries.creature_ckbgd3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbgd3.creature", Level=130, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckbgd3", entries.creature_ckbgd3)
	--entries.creature_ckbgd4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbgd4.creature", Level=140, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckbgd4", entries.creature_ckbgd4)
	--entries.creature_ckbge1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbge1.creature", Level=160, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckbge1", entries.creature_ckbge1)
	--entries.creature_ckbge2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbge2.creature", Level=170, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckbge2", entries.creature_ckbge2)
	--entries.creature_ckbge3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbge3.creature", Level=180, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckbge3", entries.creature_ckbge3)
	--entries.creature_ckbge4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbge4.creature", Level=190, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckbge4", entries.creature_ckbge4)
	--entries.creature_ckbgf1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbgf1.creature", Level=210, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckbgf1", entries.creature_ckbgf1)
	--entries.creature_ckbgf2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbgf2.creature", Level=220, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckbgf2", entries.creature_ckbgf2)
	--entries.creature_ckbgf3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbgf3.creature", Level=230, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckbgf3", entries.creature_ckbgf3)
	--entries.creature_ckbgf4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbgf4.creature", Level=240, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckbgf4", entries.creature_ckbgf4)
	entries.creature_ckbje1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbje1.creature", Level=160, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckbje1", entries.creature_ckbje1)
	entries.creature_ckbje2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbje2.creature", Level=170, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckbje2", entries.creature_ckbje2)
	entries.creature_ckbje3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbje3.creature", Level=180, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckbje3", entries.creature_ckbje3)
	entries.creature_ckbje4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbje4.creature", Level=190, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckbje4", entries.creature_ckbje4)
	entries.creature_ckbjf1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbjf1.creature", Level=210, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckbjf1", entries.creature_ckbjf1)
	entries.creature_ckbjf2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbjf2.creature", Level=220, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckbjf2", entries.creature_ckbjf2)
	entries.creature_ckbjf3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbjf3.creature", Level=230, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckbjf3", entries.creature_ckbjf3)
	entries.creature_ckbjf4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbjf4.creature", Level=240, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckbjf4", entries.creature_ckbjf4)
	entries.creature_ckble1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckble1.creature", Level=160, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckble1", entries.creature_ckble1)
	entries.creature_ckble2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckble2.creature", Level=170, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckble2", entries.creature_ckble2)
	entries.creature_ckble3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckble3.creature", Level=180, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckble3", entries.creature_ckble3)
	entries.creature_ckble4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckble4.creature", Level=190, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckble4", entries.creature_ckble4)
	entries.creature_ckblf1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckblf1.creature", Level=210, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckblf1", entries.creature_ckblf1)
	entries.creature_ckblf2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckblf2.creature", Level=220, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckblf2", entries.creature_ckblf2)
	entries.creature_ckblf3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckblf3.creature", Level=230, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckblf3", entries.creature_ckblf3)
	entries.creature_ckblf4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckblf4.creature", Level=240, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckblf4", entries.creature_ckblf4)
	entries.creature_ckbpe1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbpe1.creature", Level=160, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckbpe1", entries.creature_ckbpe1)
	entries.creature_ckbpe2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbpe2.creature", Level=170, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckbpe2", entries.creature_ckbpe2)
	entries.creature_ckbpe3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbpe3.creature", Level=180, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckbpe3", entries.creature_ckbpe3)
	entries.creature_ckbpe4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbpe4.creature", Level=190, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckbpe4", entries.creature_ckbpe4)
	entries.creature_ckbpf1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbpf1.creature", Level=210, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckbpf1", entries.creature_ckbpf1)
	entries.creature_ckbpf2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbpf2.creature", Level=220, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckbpf2", entries.creature_ckbpf2)
	entries.creature_ckbpf3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbpf3.creature", Level=230, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckbpf3", entries.creature_ckbpf3)
	entries.creature_ckbpf4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbpf4.creature", Level=240, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckbpf4", entries.creature_ckbpf4)
	entries.creature_ckcde1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcde1.creature", Level=160, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckcde1", entries.creature_ckcde1)
	entries.creature_ckcde2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcde2.creature", Level=170, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckcde2", entries.creature_ckcde2)
	entries.creature_ckcde3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcde3.creature", Level=180, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckcde3", entries.creature_ckcde3)
	entries.creature_ckcde4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcde4.creature", Level=190, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckcde4", entries.creature_ckcde4)
	entries.creature_ckcdf1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcdf1.creature", Level=210, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckcdf1", entries.creature_ckcdf1)
	entries.creature_ckcdf2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcdf2.creature", Level=220, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckcdf2", entries.creature_ckcdf2)
	entries.creature_ckcdf3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcdf3.creature", Level=230, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckcdf3", entries.creature_ckcdf3)
	entries.creature_ckcdf4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcdf4.creature", Level=240, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckcdf4", entries.creature_ckcdf4)
	entries.creature_ckcfe1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcfe1.creature", Level=160, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckcfe1", entries.creature_ckcfe1)
	entries.creature_ckcfe2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcfe2.creature", Level=170, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckcfe2", entries.creature_ckcfe2)
	entries.creature_ckcfe3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcfe3.creature", Level=180, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckcfe3", entries.creature_ckcfe3)
	entries.creature_ckcfe4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcfe4.creature", Level=190, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckcfe4", entries.creature_ckcfe4)
	entries.creature_ckcff1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcff1.creature", Level=210, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckcff1", entries.creature_ckcff1)
	entries.creature_ckcff2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcff2.creature", Level=220, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckcff2", entries.creature_ckcff2)
	entries.creature_ckcff3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcff3.creature", Level=230, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckcff3", entries.creature_ckcff3)
	entries.creature_ckcff4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcff4.creature", Level=240, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckcff4", entries.creature_ckcff4)
	--entries.creature_ckcgb1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcgb1.creature", Level=10, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckcgb1", entries.creature_ckcgb1)
	--entries.creature_ckcgb2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcgb2.creature", Level=20, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckcgb2", entries.creature_ckcgb2)
	--entries.creature_ckcgb3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcgb3.creature", Level=30, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckcgb3", entries.creature_ckcgb3)
	--entries.creature_ckcgb4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcgb4.creature", Level=40, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckcgb4", entries.creature_ckcgb4)
	--entries.creature_ckcgc1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcgc1.creature", Level=60, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckcgc1", entries.creature_ckcgc1)
	--entries.creature_ckcgc2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcgc2.creature", Level=70, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckcgc2", entries.creature_ckcgc2)
	--entries.creature_ckcgc3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcgc3.creature", Level=80, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckcgc3", entries.creature_ckcgc3)
	--entries.creature_ckcgc4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcgc4.creature", Level=90, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckcgc4", entries.creature_ckcgc4)
	--entries.creature_ckcgd1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcgd1.creature", Level=110, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckcgd1", entries.creature_ckcgd1)
	--entries.creature_ckcgd2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcgd2.creature", Level=120, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckcgd2", entries.creature_ckcgd2)
	--entries.creature_ckcgd3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcgd3.creature", Level=130, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckcgd3", entries.creature_ckcgd3)
	--entries.creature_ckcgd4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcgd4.creature", Level=140, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckcgd4", entries.creature_ckcgd4)
	--entries.creature_ckcge1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcge1.creature", Level=160, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckcge1", entries.creature_ckcge1)
	--entries.creature_ckcge2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcge2.creature", Level=170, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckcge2", entries.creature_ckcge2)
	--entries.creature_ckcge3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcge3.creature", Level=180, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckcge3", entries.creature_ckcge3)
	--entries.creature_ckcge4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcge4.creature", Level=190, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckcge4", entries.creature_ckcge4)
	--entries.creature_ckcgf1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcgf1.creature", Level=210, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckcgf1", entries.creature_ckcgf1)
	--entries.creature_ckcgf2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcgf2.creature", Level=220, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckcgf2", entries.creature_ckcgf2)
	--entries.creature_ckcgf3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcgf3.creature", Level=230, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckcgf3", entries.creature_ckcgf3)
	--entries.creature_ckcgf4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcgf4.creature", Level=240, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckcgf4", entries.creature_ckcgf4)
	entries.creature_ckcje1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcje1.creature", Level=160, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckcje1", entries.creature_ckcje1)
	entries.creature_ckcje2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcje2.creature", Level=170, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckcje2", entries.creature_ckcje2)
	entries.creature_ckcje3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcje3.creature", Level=180, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckcje3", entries.creature_ckcje3)
	entries.creature_ckcje4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcje4.creature", Level=190, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckcje4", entries.creature_ckcje4)
	entries.creature_ckcjf1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcjf1.creature", Level=210, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckcjf1", entries.creature_ckcjf1)
	entries.creature_ckcjf2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcjf2.creature", Level=220, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckcjf2", entries.creature_ckcjf2)
	entries.creature_ckcjf3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcjf3.creature", Level=230, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckcjf3", entries.creature_ckcjf3)
	entries.creature_ckcjf4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcjf4.creature", Level=240, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckcjf4", entries.creature_ckcjf4)
	entries.creature_ckcle1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcle1.creature", Level=160, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckcle1", entries.creature_ckcle1)
	entries.creature_ckcle2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcle2.creature", Level=170, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckcle2", entries.creature_ckcle2)
	entries.creature_ckcle3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcle3.creature", Level=180, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckcle3", entries.creature_ckcle3)
	entries.creature_ckcle4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcle4.creature", Level=190, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckcle4", entries.creature_ckcle4)
	entries.creature_ckclf1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckclf1.creature", Level=210, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckclf1", entries.creature_ckclf1)
	entries.creature_ckclf2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckclf2.creature", Level=220, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckclf2", entries.creature_ckclf2)
	entries.creature_ckclf3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckclf3.creature", Level=230, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckclf3", entries.creature_ckclf3)
	entries.creature_ckclf4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckclf4.creature", Level=240, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckclf4", entries.creature_ckclf4)
	entries.creature_ckcpe1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcpe1.creature", Level=160, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckcpe1", entries.creature_ckcpe1)
	entries.creature_ckcpe2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcpe2.creature", Level=170, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckcpe2", entries.creature_ckcpe2)
	entries.creature_ckcpe3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcpe3.creature", Level=180, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckcpe3", entries.creature_ckcpe3)
	entries.creature_ckcpe4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcpe4.creature", Level=190, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckcpe4", entries.creature_ckcpe4)
	entries.creature_ckcpf1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcpf1.creature", Level=210, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckcpf1", entries.creature_ckcpf1)
	entries.creature_ckcpf2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcpf2.creature", Level=220, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckcpf2", entries.creature_ckcpf2)
	entries.creature_ckcpf3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcpf3.creature", Level=230, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckcpf3", entries.creature_ckcpf3)
	entries.creature_ckcpf4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcpf4.creature", Level=240, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckcpf4", entries.creature_ckcpf4)
	entries.creature_ckddd1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckddd1.creature", Level=110, RingAccess="d4", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckddd1", entries.creature_ckddd1)
	entries.creature_ckddd2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckddd2.creature", Level=120, RingAccess="d4", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckddd2", entries.creature_ckddd2)
	entries.creature_ckddd3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckddd3.creature", Level=130, RingAccess="d4", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckddd3", entries.creature_ckddd3)
	entries.creature_ckddd4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckddd4.creature", Level=140, RingAccess="d4", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckddd4", entries.creature_ckddd4)
	entries.creature_ckdde1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdde1.creature", Level=160, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckdde1", entries.creature_ckdde1)
	entries.creature_ckdde2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdde2.creature", Level=170, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckdde2", entries.creature_ckdde2)
	entries.creature_ckdde3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdde3.creature", Level=180, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckdde3", entries.creature_ckdde3)
	entries.creature_ckdde4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdde4.creature", Level=190, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckdde4", entries.creature_ckdde4)
	entries.creature_ckddf1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckddf1.creature", Level=210, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckddf1", entries.creature_ckddf1)
	entries.creature_ckddf2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckddf2.creature", Level=220, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckddf2", entries.creature_ckddf2)
	entries.creature_ckddf3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckddf3.creature", Level=230, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckddf3", entries.creature_ckddf3)
	entries.creature_ckddf4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckddf4.creature", Level=240, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckddf4", entries.creature_ckddf4)
	entries.creature_ckdfd1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdfd1.creature", Level=110, RingAccess="f5", Ecosystem="Forest", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckdfd1", entries.creature_ckdfd1)
	entries.creature_ckdfd2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdfd2.creature", Level=120, RingAccess="f5", Ecosystem="Forest", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckdfd2", entries.creature_ckdfd2)
	entries.creature_ckdfd3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdfd3.creature", Level=130, RingAccess="f5", Ecosystem="Forest", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckdfd3", entries.creature_ckdfd3)
	entries.creature_ckdfd4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdfd4.creature", Level=140, RingAccess="f5", Ecosystem="Forest", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckdfd4", entries.creature_ckdfd4)
	entries.creature_ckdfe1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdfe1.creature", Level=160, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckdfe1", entries.creature_ckdfe1)
	entries.creature_ckdfe2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdfe2.creature", Level=170, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckdfe2", entries.creature_ckdfe2)
	entries.creature_ckdfe3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdfe3.creature", Level=180, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckdfe3", entries.creature_ckdfe3)
	entries.creature_ckdfe4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdfe4.creature", Level=190, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckdfe4", entries.creature_ckdfe4)
	entries.creature_ckdff1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdff1.creature", Level=210, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckdff1", entries.creature_ckdff1)
	entries.creature_ckdff2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdff2.creature", Level=220, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckdff2", entries.creature_ckdff2)
	entries.creature_ckdff3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdff3.creature", Level=230, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckdff3", entries.creature_ckdff3)
	entries.creature_ckdff4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdff4.creature", Level=240, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckdff4", entries.creature_ckdff4)
	--entries.creature_ckdgb1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdgb1.creature", Level=10, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckdgb1", entries.creature_ckdgb1)
	--entries.creature_ckdgb2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdgb2.creature", Level=20, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckdgb2", entries.creature_ckdgb2)
	--entries.creature_ckdgb3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdgb3.creature", Level=30, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckdgb3", entries.creature_ckdgb3)
	--entries.creature_ckdgb4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdgb4.creature", Level=40, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckdgb4", entries.creature_ckdgb4)
	--entries.creature_ckdgc1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdgc1.creature", Level=60, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckdgc1", entries.creature_ckdgc1)
	--entries.creature_ckdgc2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdgc2.creature", Level=70, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckdgc2", entries.creature_ckdgc2)
	--entries.creature_ckdgc3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdgc3.creature", Level=80, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckdgc3", entries.creature_ckdgc3)
	--entries.creature_ckdgc4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdgc4.creature", Level=90, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckdgc4", entries.creature_ckdgc4)
	--entries.creature_ckdgd1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdgd1.creature", Level=110, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckdgd1", entries.creature_ckdgd1)
	--entries.creature_ckdgd2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdgd2.creature", Level=120, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckdgd2", entries.creature_ckdgd2)
	--entries.creature_ckdgd3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdgd3.creature", Level=130, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckdgd3", entries.creature_ckdgd3)
	--entries.creature_ckdgd4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdgd4.creature", Level=140, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckdgd4", entries.creature_ckdgd4)
	--entries.creature_ckdge1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdge1.creature", Level=160, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckdge1", entries.creature_ckdge1)
	--entries.creature_ckdge2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdge2.creature", Level=170, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckdge2", entries.creature_ckdge2)
	--entries.creature_ckdge3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdge3.creature", Level=180, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckdge3", entries.creature_ckdge3)
	--entries.creature_ckdge4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdge4.creature", Level=190, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckdge4", entries.creature_ckdge4)
	--entries.creature_ckdgf1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdgf1.creature", Level=210, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckdgf1", entries.creature_ckdgf1)
	--entries.creature_ckdgf2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdgf2.creature", Level=220, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckdgf2", entries.creature_ckdgf2)
	--entries.creature_ckdgf3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdgf3.creature", Level=230, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckdgf3", entries.creature_ckdgf3)
	--entries.creature_ckdgf4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdgf4.creature", Level=240, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckdgf4", entries.creature_ckdgf4)
	entries.creature_ckdjd1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdjd1.creature", Level=110, RingAccess="j5", Ecosystem="Jungle", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckdjd1", entries.creature_ckdjd1)
	entries.creature_ckdjd2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdjd2.creature", Level=120, RingAccess="j5", Ecosystem="Jungle", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckdjd2", entries.creature_ckdjd2)
	entries.creature_ckdjd3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdjd3.creature", Level=130, RingAccess="j5", Ecosystem="Jungle", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckdjd3", entries.creature_ckdjd3)
	entries.creature_ckdjd4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdjd4.creature", Level=140, RingAccess="j5", Ecosystem="Jungle", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckdjd4", entries.creature_ckdjd4)
	entries.creature_ckdje1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdje1.creature", Level=160, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckdje1", entries.creature_ckdje1)
	entries.creature_ckdje2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdje2.creature", Level=170, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckdje2", entries.creature_ckdje2)
	entries.creature_ckdje3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdje3.creature", Level=180, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckdje3", entries.creature_ckdje3)
	entries.creature_ckdje4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdje4.creature", Level=190, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckdje4", entries.creature_ckdje4)
	entries.creature_ckdjf1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdjf1.creature", Level=210, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckdjf1", entries.creature_ckdjf1)
	entries.creature_ckdjf2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdjf2.creature", Level=220, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckdjf2", entries.creature_ckdjf2)
	entries.creature_ckdjf3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdjf3.creature", Level=230, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckdjf3", entries.creature_ckdjf3)
	entries.creature_ckdjf4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdjf4.creature", Level=240, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckdjf4", entries.creature_ckdjf4)
	entries.creature_ckdld1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdld1.creature", Level=110, RingAccess="l5", Ecosystem="Lacustre", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckdld1", entries.creature_ckdld1)
	entries.creature_ckdld2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdld2.creature", Level=120, RingAccess="l5", Ecosystem="Lacustre", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckdld2", entries.creature_ckdld2)
	entries.creature_ckdld3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdld3.creature", Level=130, RingAccess="l5", Ecosystem="Lacustre", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckdld3", entries.creature_ckdld3)
	entries.creature_ckdld4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdld4.creature", Level=140, RingAccess="l5", Ecosystem="Lacustre", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckdld4", entries.creature_ckdld4)
	entries.creature_ckdle1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdle1.creature", Level=160, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckdle1", entries.creature_ckdle1)
	entries.creature_ckdle2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdle2.creature", Level=170, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckdle2", entries.creature_ckdle2)
	entries.creature_ckdle3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdle3.creature", Level=180, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckdle3", entries.creature_ckdle3)
	entries.creature_ckdle4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdle4.creature", Level=190, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckdle4", entries.creature_ckdle4)
	entries.creature_ckdlf1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdlf1.creature", Level=210, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckdlf1", entries.creature_ckdlf1)
	entries.creature_ckdlf2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdlf2.creature", Level=220, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckdlf2", entries.creature_ckdlf2)
	entries.creature_ckdlf3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdlf3.creature", Level=230, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckdlf3", entries.creature_ckdlf3)
	entries.creature_ckdlf4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdlf4.creature", Level=240, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckdlf4", entries.creature_ckdlf4)
	entries.creature_ckdpd1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdpd1.creature", Level=110, RingAccess="p1", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckdpd1", entries.creature_ckdpd1)
	entries.creature_ckdpd2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdpd2.creature", Level=120, RingAccess="p1", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckdpd2", entries.creature_ckdpd2)
	entries.creature_ckdpd3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdpd3.creature", Level=130, RingAccess="p1", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckdpd3", entries.creature_ckdpd3)
	entries.creature_ckdpd4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdpd4.creature", Level=140, RingAccess="p1", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckdpd4", entries.creature_ckdpd4)
	entries.creature_ckdpe1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdpe1.creature", Level=160, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckdpe1", entries.creature_ckdpe1)
	entries.creature_ckdpe2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdpe2.creature", Level=170, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckdpe2", entries.creature_ckdpe2)
	entries.creature_ckdpe3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdpe3.creature", Level=180, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckdpe3", entries.creature_ckdpe3)
	entries.creature_ckdpe4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdpe4.creature", Level=190, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckdpe4", entries.creature_ckdpe4)
	entries.creature_ckdpf1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdpf1.creature", Level=210, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckdpf1", entries.creature_ckdpf1)
	entries.creature_ckdpf2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdpf2.creature", Level=220, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckdpf2", entries.creature_ckdpf2)
	entries.creature_ckdpf3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdpf3.creature", Level=230, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckdpf3", entries.creature_ckdpf3)
	entries.creature_ckdpf4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdpf4.creature", Level=240, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckdpf4", entries.creature_ckdpf4)
	entries.creature_ckede1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckede1.creature", Level=160, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckede1", entries.creature_ckede1)
	entries.creature_ckede2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckede2.creature", Level=170, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckede2", entries.creature_ckede2)
	entries.creature_ckede3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckede3.creature", Level=180, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckede3", entries.creature_ckede3)
	entries.creature_ckede4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckede4.creature", Level=190, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckede4", entries.creature_ckede4)
	entries.creature_ckedf1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckedf1.creature", Level=210, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckedf1", entries.creature_ckedf1)
	entries.creature_ckedf2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckedf2.creature", Level=220, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckedf2", entries.creature_ckedf2)
	entries.creature_ckedf3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckedf3.creature", Level=230, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckedf3", entries.creature_ckedf3)
	entries.creature_ckedf4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckedf4.creature", Level=240, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckedf4", entries.creature_ckedf4)
	entries.creature_ckefe1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckefe1.creature", Level=160, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckefe1", entries.creature_ckefe1)
	entries.creature_ckefe2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckefe2.creature", Level=170, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckefe2", entries.creature_ckefe2)
	entries.creature_ckefe3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckefe3.creature", Level=180, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckefe3", entries.creature_ckefe3)
	entries.creature_ckefe4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckefe4.creature", Level=190, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckefe4", entries.creature_ckefe4)
	entries.creature_ckeff1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckeff1.creature", Level=210, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckeff1", entries.creature_ckeff1)
	entries.creature_ckeff2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckeff2.creature", Level=220, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckeff2", entries.creature_ckeff2)
	entries.creature_ckeff3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckeff3.creature", Level=230, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckeff3", entries.creature_ckeff3)
	entries.creature_ckeff4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckeff4.creature", Level=240, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckeff4", entries.creature_ckeff4)
	--entries.creature_ckegb1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckegb1.creature", Level=10, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckegb1", entries.creature_ckegb1)
	--entries.creature_ckegb2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckegb2.creature", Level=20, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckegb2", entries.creature_ckegb2)
	--entries.creature_ckegb3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckegb3.creature", Level=30, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckegb3", entries.creature_ckegb3)
	--entries.creature_ckegb4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckegb4.creature", Level=40, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckegb4", entries.creature_ckegb4)
	--entries.creature_ckegc1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckegc1.creature", Level=60, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckegc1", entries.creature_ckegc1)
	--entries.creature_ckegc2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckegc2.creature", Level=70, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckegc2", entries.creature_ckegc2)
	--entries.creature_ckegc3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckegc3.creature", Level=80, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckegc3", entries.creature_ckegc3)
	--entries.creature_ckegc4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckegc4.creature", Level=90, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckegc4", entries.creature_ckegc4)
	--entries.creature_ckegd1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckegd1.creature", Level=110, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckegd1", entries.creature_ckegd1)
	--entries.creature_ckegd2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckegd2.creature", Level=120, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckegd2", entries.creature_ckegd2)
	--entries.creature_ckegd3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckegd3.creature", Level=130, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckegd3", entries.creature_ckegd3)
	--entries.creature_ckegd4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckegd4.creature", Level=140, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckegd4", entries.creature_ckegd4)
	--entries.creature_ckege1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckege1.creature", Level=160, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckege1", entries.creature_ckege1)
	--entries.creature_ckege2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckege2.creature", Level=170, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckege2", entries.creature_ckege2)
	--entries.creature_ckege3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckege3.creature", Level=180, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckege3", entries.creature_ckege3)
	--entries.creature_ckege4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckege4.creature", Level=190, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckege4", entries.creature_ckege4)
	--entries.creature_ckegf1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckegf1.creature", Level=210, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckegf1", entries.creature_ckegf1)
	--entries.creature_ckegf2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckegf2.creature", Level=220, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckegf2", entries.creature_ckegf2)
	--entries.creature_ckegf3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckegf3.creature", Level=230, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckegf3", entries.creature_ckegf3)
	--entries.creature_ckegf4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckegf4.creature", Level=240, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckegf4", entries.creature_ckegf4)
	entries.creature_ckeje1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckeje1.creature", Level=160, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckeje1", entries.creature_ckeje1)
	entries.creature_ckeje2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckeje2.creature", Level=170, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckeje2", entries.creature_ckeje2)
	entries.creature_ckeje3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckeje3.creature", Level=180, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckeje3", entries.creature_ckeje3)
	entries.creature_ckeje4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckeje4.creature", Level=190, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckeje4", entries.creature_ckeje4)
	entries.creature_ckejf1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckejf1.creature", Level=210, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckejf1", entries.creature_ckejf1)
	entries.creature_ckejf2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckejf2.creature", Level=220, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckejf2", entries.creature_ckejf2)
	entries.creature_ckejf3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckejf3.creature", Level=230, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckejf3", entries.creature_ckejf3)
	entries.creature_ckejf4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckejf4.creature", Level=240, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckejf4", entries.creature_ckejf4)
	entries.creature_ckele1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckele1.creature", Level=160, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckele1", entries.creature_ckele1)
	entries.creature_ckele2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckele2.creature", Level=170, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckele2", entries.creature_ckele2)
	entries.creature_ckele3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckele3.creature", Level=180, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckele3", entries.creature_ckele3)
	entries.creature_ckele4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckele4.creature", Level=190, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckele4", entries.creature_ckele4)
	entries.creature_ckelf1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckelf1.creature", Level=210, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckelf1", entries.creature_ckelf1)
	entries.creature_ckelf2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckelf2.creature", Level=220, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckelf2", entries.creature_ckelf2)
	entries.creature_ckelf3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckelf3.creature", Level=230, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckelf3", entries.creature_ckelf3)
	entries.creature_ckelf4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckelf4.creature", Level=240, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckelf4", entries.creature_ckelf4)
	entries.creature_ckepe1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckepe1.creature", Level=160, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckepe1", entries.creature_ckepe1)
	entries.creature_ckepe2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckepe2.creature", Level=170, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckepe2", entries.creature_ckepe2)
	entries.creature_ckepe3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckepe3.creature", Level=180, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckepe3", entries.creature_ckepe3)
	entries.creature_ckepe4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckepe4.creature", Level=190, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckepe4", entries.creature_ckepe4)
	entries.creature_ckepf1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckepf1.creature", Level=210, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckepf1", entries.creature_ckepf1)
	entries.creature_ckepf2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckepf2.creature", Level=220, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckepf2", entries.creature_ckepf2)
	entries.creature_ckepf3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckepf3.creature", Level=230, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckepf3", entries.creature_ckepf3)
	entries.creature_ckepf4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckepf4.creature", Level=240, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckepf4", entries.creature_ckepf4)
	entries.creature_ckfde1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfde1.creature", Level=160, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckfde1", entries.creature_ckfde1)
	entries.creature_ckfde2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfde2.creature", Level=170, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckfde2", entries.creature_ckfde2)
	entries.creature_ckfde3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfde3.creature", Level=180, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckfde3", entries.creature_ckfde3)
	entries.creature_ckfde4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfde4.creature", Level=190, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckfde4", entries.creature_ckfde4)
	entries.creature_ckfdf1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfdf1.creature", Level=210, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckfdf1", entries.creature_ckfdf1)
	entries.creature_ckfdf2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfdf2.creature", Level=220, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckfdf2", entries.creature_ckfdf2)
	entries.creature_ckfdf3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfdf3.creature", Level=230, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckfdf3", entries.creature_ckfdf3)
	entries.creature_ckfdf4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfdf4.creature", Level=240, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckfdf4", entries.creature_ckfdf4)
	entries.creature_ckffe1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckffe1.creature", Level=160, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckffe1", entries.creature_ckffe1)
	entries.creature_ckffe2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckffe2.creature", Level=170, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckffe2", entries.creature_ckffe2)
	entries.creature_ckffe3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckffe3.creature", Level=180, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckffe3", entries.creature_ckffe3)
	entries.creature_ckffe4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckffe4.creature", Level=190, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckffe4", entries.creature_ckffe4)
	entries.creature_ckfff1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfff1.creature", Level=210, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckfff1", entries.creature_ckfff1)
	entries.creature_ckfff2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfff2.creature", Level=220, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckfff2", entries.creature_ckfff2)
	entries.creature_ckfff3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfff3.creature", Level=230, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckfff3", entries.creature_ckfff3)
	entries.creature_ckfff4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfff4.creature", Level=240, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckfff4", entries.creature_ckfff4)
	entries.creature_ckfje1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfje1.creature", Level=160, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckfje1", entries.creature_ckfje1)
	entries.creature_ckfje2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfje2.creature", Level=170, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckfje2", entries.creature_ckfje2)
	entries.creature_ckfje3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfje3.creature", Level=180, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckfje3", entries.creature_ckfje3)
	entries.creature_ckfje4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfje4.creature", Level=190, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckfje4", entries.creature_ckfje4)
	entries.creature_ckfjf1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfjf1.creature", Level=210, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckfjf1", entries.creature_ckfjf1)
	entries.creature_ckfjf2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfjf2.creature", Level=220, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckfjf2", entries.creature_ckfjf2)
	entries.creature_ckfjf3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfjf3.creature", Level=230, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckfjf3", entries.creature_ckfjf3)
	entries.creature_ckfjf4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfjf4.creature", Level=240, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckfjf4", entries.creature_ckfjf4)
	entries.creature_ckfle1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfle1.creature", Level=160, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckfle1", entries.creature_ckfle1)
	entries.creature_ckfle2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfle2.creature", Level=170, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckfle2", entries.creature_ckfle2)
	entries.creature_ckfle3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfle3.creature", Level=180, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckfle3", entries.creature_ckfle3)
	entries.creature_ckfle4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfle4.creature", Level=190, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckfle4", entries.creature_ckfle4)
	entries.creature_ckflf1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckflf1.creature", Level=210, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckflf1", entries.creature_ckflf1)
	entries.creature_ckflf2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckflf2.creature", Level=220, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckflf2", entries.creature_ckflf2)
	entries.creature_ckflf3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckflf3.creature", Level=230, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckflf3", entries.creature_ckflf3)
	entries.creature_ckflf4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckflf4.creature", Level=240, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckflf4", entries.creature_ckflf4)
	entries.creature_ckfpe1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfpe1.creature", Level=160, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckfpe1", entries.creature_ckfpe1)
	entries.creature_ckfpe2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfpe2.creature", Level=170, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckfpe2", entries.creature_ckfpe2)
	entries.creature_ckfpe3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfpe3.creature", Level=180, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckfpe3", entries.creature_ckfpe3)
	entries.creature_ckfpe4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfpe4.creature", Level=190, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckfpe4", entries.creature_ckfpe4)
	entries.creature_ckfpf1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfpf1.creature", Level=210, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckfpf1", entries.creature_ckfpf1)
	entries.creature_ckfpf2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfpf2.creature", Level=220, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckfpf2", entries.creature_ckfpf2)
	entries.creature_ckfpf3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfpf3.creature", Level=230, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckfpf3", entries.creature_ckfpf3)
	entries.creature_ckfpf4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfpf4.creature", Level=240, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckfpf4", entries.creature_ckfpf4)


--  Kiban (WORKER)
	entries.creature_ckgde1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckgde1.creature", Level=160, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckgde1", entries.creature_ckgde1)
	entries.creature_ckgde2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckgde2.creature", Level=170, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckgde2", entries.creature_ckgde2)
	entries.creature_ckgde3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckgde3.creature", Level=180, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckgde3", entries.creature_ckgde3)
	entries.creature_ckgde4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckgde4.creature", Level=190, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckgde4", entries.creature_ckgde4)
	entries.creature_ckgdf1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckgdf1.creature", Level=210, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckgdf1", entries.creature_ckgdf1)
	entries.creature_ckgdf2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckgdf2.creature", Level=220, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckgdf2", entries.creature_ckgdf2)
	entries.creature_ckgdf3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckgdf3.creature", Level=230, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckgdf3", entries.creature_ckgdf3)
	entries.creature_ckgdf4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckgdf4.creature", Level=240, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckgdf4", entries.creature_ckgdf4)
	entries.creature_ckgfe1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckgfe1.creature", Level=160, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckgfe1", entries.creature_ckgfe1)
	entries.creature_ckgfe2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckgfe2.creature", Level=170, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckgfe2", entries.creature_ckgfe2)
	entries.creature_ckgfe3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckgfe3.creature", Level=180, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckgfe3", entries.creature_ckgfe3)
	entries.creature_ckgfe4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckgfe4.creature", Level=190, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckgfe4", entries.creature_ckgfe4)
	entries.creature_ckgff1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckgff1.creature", Level=210, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckgff1", entries.creature_ckgff1)
	entries.creature_ckgff2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckgff2.creature", Level=220, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckgff2", entries.creature_ckgff2)
	entries.creature_ckgff3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckgff3.creature", Level=230, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckgff3", entries.creature_ckgff3)
	entries.creature_ckgff4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckgff4.creature", Level=240, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckgff4", entries.creature_ckgff4)
	--entries.creature_ckggb1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckggb1.creature", Level=10, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckggb1", entries.creature_ckggb1)
	--entries.creature_ckggb2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckggb2.creature", Level=20, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckggb2", entries.creature_ckggb2)
	--entries.creature_ckggb3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckggb3.creature", Level=30, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckggb3", entries.creature_ckggb3)
	--entries.creature_ckggb4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckggb4.creature", Level=40, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckggb4", entries.creature_ckggb4)
	--entries.creature_ckggc1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckggc1.creature", Level=60, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckggc1", entries.creature_ckggc1)
	--entries.creature_ckggc2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckggc2.creature", Level=70, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckggc2", entries.creature_ckggc2)
	--entries.creature_ckggc3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckggc3.creature", Level=80, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckggc3", entries.creature_ckggc3)
	--entries.creature_ckggc4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckggc4.creature", Level=90, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckggc4", entries.creature_ckggc4)
	--entries.creature_ckggd1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckggd1.creature", Level=110, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckggd1", entries.creature_ckggd1)
	--entries.creature_ckggd2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckggd2.creature", Level=120, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckggd2", entries.creature_ckggd2)
	--entries.creature_ckggd3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckggd3.creature", Level=130, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckggd3", entries.creature_ckggd3)
	--entries.creature_ckggd4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckggd4.creature", Level=140, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckggd4", entries.creature_ckggd4)
	--entries.creature_ckgge1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckgge1.creature", Level=160, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckgge1", entries.creature_ckgge1)
	--entries.creature_ckgge2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckgge2.creature", Level=170, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckgge2", entries.creature_ckgge2)
	--entries.creature_ckgge3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckgge3.creature", Level=180, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckgge3", entries.creature_ckgge3)
	--entries.creature_ckgge4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckgge4.creature", Level=190, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckgge4", entries.creature_ckgge4)
	--entries.creature_ckggf1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckggf1.creature", Level=210, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckggf1", entries.creature_ckggf1)
	--entries.creature_ckggf2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckggf2.creature", Level=220, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckggf2", entries.creature_ckggf2)
	--entries.creature_ckggf3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckggf3.creature", Level=230, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckggf3", entries.creature_ckggf3)
	--entries.creature_ckggf4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckggf4.creature", Level=240, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckggf4", entries.creature_ckggf4)
	entries.creature_ckgje1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckgje1.creature", Level=160, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckgje1", entries.creature_ckgje1)
	entries.creature_ckgje2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckgje2.creature", Level=170, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckgje2", entries.creature_ckgje2)
	entries.creature_ckgje3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckgje3.creature", Level=180, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckgje3", entries.creature_ckgje3)
	entries.creature_ckgje4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckgje4.creature", Level=190, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckgje4", entries.creature_ckgje4)
	entries.creature_ckgjf1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckgjf1.creature", Level=210, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckgjf1", entries.creature_ckgjf1)
	entries.creature_ckgjf2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckgjf2.creature", Level=220, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckgjf2", entries.creature_ckgjf2)
	entries.creature_ckgjf3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckgjf3.creature", Level=230, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckgjf3", entries.creature_ckgjf3)
	entries.creature_ckgjf4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckgjf4.creature", Level=240, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckgjf4", entries.creature_ckgjf4)
	entries.creature_ckgle1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckgle1.creature", Level=160, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckgle1", entries.creature_ckgle1)
	entries.creature_ckgle2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckgle2.creature", Level=170, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckgle2", entries.creature_ckgle2)
	entries.creature_ckgle3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckgle3.creature", Level=180, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckgle3", entries.creature_ckgle3)
	entries.creature_ckgle4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckgle4.creature", Level=190, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckgle4", entries.creature_ckgle4)
	entries.creature_ckglf1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckglf1.creature", Level=210, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckglf1", entries.creature_ckglf1)
	entries.creature_ckglf2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckglf2.creature", Level=220, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckglf2", entries.creature_ckglf2)
	entries.creature_ckglf3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckglf3.creature", Level=230, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckglf3", entries.creature_ckglf3)
	entries.creature_ckglf4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckglf4.creature", Level=240, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckglf4", entries.creature_ckglf4)
	entries.creature_ckgpe1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckgpe1.creature", Level=160, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckgpe1", entries.creature_ckgpe1)
	entries.creature_ckgpe2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckgpe2.creature", Level=170, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckgpe2", entries.creature_ckgpe2)
	entries.creature_ckgpe3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckgpe3.creature", Level=180, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckgpe3", entries.creature_ckgpe3)
	entries.creature_ckgpe4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckgpe4.creature", Level=190, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckgpe4", entries.creature_ckgpe4)
	entries.creature_ckgpf1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckgpf1.creature", Level=210, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckgpf1", entries.creature_ckgpf1)
	entries.creature_ckgpf2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckgpf2.creature", Level=220, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckgpf2", entries.creature_ckgpf2)
	entries.creature_ckgpf3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckgpf3.creature", Level=230, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckgpf3", entries.creature_ckgpf3)
	entries.creature_ckgpf4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckgpf4.creature", Level=240, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckgpf4", entries.creature_ckgpf4)


	--  Kipee (WORKER)
	entries.creature_ckhda1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhda1.creature", Level=10, RingAccess="a1", Ecosystem="Desert", Region="a" } r2.addPaletteElement("palette.entities.creatures.ckhda1", entries.creature_ckhda1)
	entries.creature_ckhdb1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhdb1.creature", Level=10, RingAccess="a1", Ecosystem="Desert", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckhdb1", entries.creature_ckhdb1)
	entries.creature_ckhdb2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhdb2.creature", Level=20, RingAccess="a1", Ecosystem="Desert", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckhdb2", entries.creature_ckhdb2)
	entries.creature_ckhdb3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhdb3.creature", Level=30, RingAccess="a1", Ecosystem="Desert", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckhdb3", entries.creature_ckhdb3)
	entries.creature_ckhdb4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhdb4.creature", Level=40, RingAccess="a1", Ecosystem="Desert", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckhdb4", entries.creature_ckhdb4)
	entries.creature_ckhdc1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhdc1.creature", Level=60, RingAccess="d2", Ecosystem="Desert", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckhdc1", entries.creature_ckhdc1)
	entries.creature_ckhdc2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhdc2.creature", Level=70, RingAccess="d2", Ecosystem="Desert", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckhdc2", entries.creature_ckhdc2)
	entries.creature_ckhdc3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhdc3.creature", Level=80, RingAccess="d2", Ecosystem="Desert", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckhdc3", entries.creature_ckhdc3)
	entries.creature_ckhdc4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhdc4.creature", Level=90, RingAccess="d2", Ecosystem="Desert", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckhdc4", entries.creature_ckhdc4)
	entries.creature_ckhdd1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhdd1.creature", Level=110, RingAccess="d4", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckhdd1", entries.creature_ckhdd1)
	entries.creature_ckhdd2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhdd2.creature", Level=120, RingAccess="d4", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckhdd2", entries.creature_ckhdd2)
	entries.creature_ckhdd3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhdd3.creature", Level=130, RingAccess="d4", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckhdd3", entries.creature_ckhdd3)
	entries.creature_ckhdd4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhdd4.creature", Level=140, RingAccess="d4", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckhdd4", entries.creature_ckhdd4)
	entries.creature_ckhde1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhde1.creature", Level=160, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckhde1", entries.creature_ckhde1)
	entries.creature_ckhde2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhde2.creature", Level=170, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckhde2", entries.creature_ckhde2)
	entries.creature_ckhde3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhde3.creature", Level=180, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckhde3", entries.creature_ckhde3)
	entries.creature_ckhde4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhde4.creature", Level=190, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckhde4", entries.creature_ckhde4)
	entries.creature_ckhdf1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhdf1.creature", Level=210, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckhdf1", entries.creature_ckhdf1)
	entries.creature_ckhdf2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhdf2.creature", Level=220, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckhdf2", entries.creature_ckhdf2)
	entries.creature_ckhdf3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhdf3.creature", Level=230, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckhdf3", entries.creature_ckhdf3)
	entries.creature_ckhdf4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhdf4.creature", Level=240, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckhdf4", entries.creature_ckhdf4)
	entries.creature_ckhfa1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhfa1.creature", Level=10, RingAccess="a1", Ecosystem="Forest", Region="a" } r2.addPaletteElement("palette.entities.creatures.ckhfa1", entries.creature_ckhfa1)
	entries.creature_ckhfb1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhfb1.creature", Level=10, RingAccess="a1", Ecosystem="Forest", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckhfb1", entries.creature_ckhfb1)
	entries.creature_ckhfb2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhfb2.creature", Level=20, RingAccess="a1", Ecosystem="Forest", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckhfb2", entries.creature_ckhfb2)
	entries.creature_ckhfb3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhfb3.creature", Level=30, RingAccess="a1", Ecosystem="Forest", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckhfb3", entries.creature_ckhfb3)
	entries.creature_ckhfb4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhfb4.creature", Level=40, RingAccess="a1", Ecosystem="Forest", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckhfb4", entries.creature_ckhfb4)
	entries.creature_ckhfc1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhfc1.creature", Level=60, RingAccess="f5", Ecosystem="Forest", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckhfc1", entries.creature_ckhfc1)
	entries.creature_ckhfc2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhfc2.creature", Level=70, RingAccess="f5", Ecosystem="Forest", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckhfc2", entries.creature_ckhfc2)
	entries.creature_ckhfc3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhfc3.creature", Level=80, RingAccess="f5", Ecosystem="Forest", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckhfc3", entries.creature_ckhfc3)
	entries.creature_ckhfc4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhfc4.creature", Level=90, RingAccess="f5", Ecosystem="Forest", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckhfc4", entries.creature_ckhfc4)
	entries.creature_ckhfd1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhfd1.creature", Level=110, RingAccess="f5", Ecosystem="Forest", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckhfd1", entries.creature_ckhfd1)
	entries.creature_ckhfd2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhfd2.creature", Level=120, RingAccess="f5", Ecosystem="Forest", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckhfd2", entries.creature_ckhfd2)
	entries.creature_ckhfd3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhfd3.creature", Level=130, RingAccess="f5", Ecosystem="Forest", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckhfd3", entries.creature_ckhfd3)
	entries.creature_ckhfd4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhfd4.creature", Level=140, RingAccess="f5", Ecosystem="Forest", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckhfd4", entries.creature_ckhfd4)
	entries.creature_ckhfe1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhfe1.creature", Level=160, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckhfe1", entries.creature_ckhfe1)
	entries.creature_ckhfe2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhfe2.creature", Level=170, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckhfe2", entries.creature_ckhfe2)
	entries.creature_ckhfe3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhfe3.creature", Level=180, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckhfe3", entries.creature_ckhfe3)
	entries.creature_ckhfe4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhfe4.creature", Level=190, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckhfe4", entries.creature_ckhfe4)
	entries.creature_ckhff1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhff1.creature", Level=210, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckhff1", entries.creature_ckhff1)
	entries.creature_ckhff2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhff2.creature", Level=220, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckhff2", entries.creature_ckhff2)
	entries.creature_ckhff3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhff3.creature", Level=230, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckhff3", entries.creature_ckhff3)
	entries.creature_ckhff4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhff4.creature", Level=240, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckhff4", entries.creature_ckhff4)
	entries.creature_ckhja1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhja1.creature", Level=10, RingAccess="a1", Ecosystem="Jungle", Region="a" } r2.addPaletteElement("palette.entities.creatures.ckhja1", entries.creature_ckhja1)
	entries.creature_ckhjb1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhjb1.creature", Level=10, RingAccess="a1", Ecosystem="Jungle", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckhjb1", entries.creature_ckhjb1)
	entries.creature_ckhjb2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhjb2.creature", Level=20, RingAccess="a1", Ecosystem="Jungle", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckhjb2", entries.creature_ckhjb2)
	entries.creature_ckhjb3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhjb3.creature", Level=30, RingAccess="a1", Ecosystem="Jungle", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckhjb3", entries.creature_ckhjb3)
	entries.creature_ckhjb4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhjb4.creature", Level=40, RingAccess="a1", Ecosystem="Jungle", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckhjb4", entries.creature_ckhjb4)
	entries.creature_ckhjc1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhjc1.creature", Level=60, RingAccess="j5", Ecosystem="Jungle", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckhjc1", entries.creature_ckhjc1)
	entries.creature_ckhjc2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhjc2.creature", Level=70, RingAccess="j5", Ecosystem="Jungle", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckhjc2", entries.creature_ckhjc2)
	entries.creature_ckhjc3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhjc3.creature", Level=80, RingAccess="j5", Ecosystem="Jungle", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckhjc3", entries.creature_ckhjc3)
	entries.creature_ckhjc4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhjc4.creature", Level=90, RingAccess="j5", Ecosystem="Jungle", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckhjc4", entries.creature_ckhjc4)
	entries.creature_ckhjd1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhjd1.creature", Level=110, RingAccess="j5", Ecosystem="Jungle", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckhjd1", entries.creature_ckhjd1)
	entries.creature_ckhjd2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhjd2.creature", Level=120, RingAccess="j5", Ecosystem="Jungle", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckhjd2", entries.creature_ckhjd2)
	entries.creature_ckhjd3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhjd3.creature", Level=130, RingAccess="j5", Ecosystem="Jungle", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckhjd3", entries.creature_ckhjd3)
	entries.creature_ckhjd4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhjd4.creature", Level=140, RingAccess="j5", Ecosystem="Jungle", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckhjd4", entries.creature_ckhjd4)
	entries.creature_ckhje1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhje1.creature", Level=160, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckhje1", entries.creature_ckhje1)
	entries.creature_ckhje2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhje2.creature", Level=170, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckhje2", entries.creature_ckhje2)
	entries.creature_ckhje3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhje3.creature", Level=180, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckhje3", entries.creature_ckhje3)
	entries.creature_ckhje4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhje4.creature", Level=190, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckhje4", entries.creature_ckhje4)
	entries.creature_ckhjf1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhjf1.creature", Level=210, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckhjf1", entries.creature_ckhjf1)
	entries.creature_ckhjf2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhjf2.creature", Level=220, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckhjf2", entries.creature_ckhjf2)
	entries.creature_ckhjf3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhjf3.creature", Level=230, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckhjf3", entries.creature_ckhjf3)
	entries.creature_ckhjf4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhjf4.creature", Level=240, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckhjf4", entries.creature_ckhjf4)
	entries.creature_ckhla1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhla1.creature", Level=10, RingAccess="a1", Ecosystem="Lacustre", Region="a" } r2.addPaletteElement("palette.entities.creatures.ckhla1", entries.creature_ckhla1)
	entries.creature_ckhlb1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhlb1.creature", Level=10, RingAccess="a1", Ecosystem="Lacustre", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckhlb1", entries.creature_ckhlb1)
	entries.creature_ckhlb2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhlb2.creature", Level=20, RingAccess="a1", Ecosystem="Lacustre", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckhlb2", entries.creature_ckhlb2)
	entries.creature_ckhlb3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhlb3.creature", Level=30, RingAccess="a1", Ecosystem="Lacustre", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckhlb3", entries.creature_ckhlb3)
	entries.creature_ckhlb4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhlb4.creature", Level=40, RingAccess="a1", Ecosystem="Lacustre", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckhlb4", entries.creature_ckhlb4)
	entries.creature_ckhlc1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhlc1.creature", Level=60, RingAccess="l5", Ecosystem="Lacustre", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckhlc1", entries.creature_ckhlc1)
	entries.creature_ckhlc2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhlc2.creature", Level=70, RingAccess="l5", Ecosystem="Lacustre", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckhlc2", entries.creature_ckhlc2)
	entries.creature_ckhlc3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhlc3.creature", Level=80, RingAccess="l5", Ecosystem="Lacustre", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckhlc3", entries.creature_ckhlc3)
	entries.creature_ckhlc4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhlc4.creature", Level=90, RingAccess="l5", Ecosystem="Lacustre", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckhlc4", entries.creature_ckhlc4)
	entries.creature_ckhld1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhld1.creature", Level=110, RingAccess="l5", Ecosystem="Lacustre", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckhld1", entries.creature_ckhld1)
	entries.creature_ckhld2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhld2.creature", Level=120, RingAccess="l5", Ecosystem="Lacustre", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckhld2", entries.creature_ckhld2)
	entries.creature_ckhld3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhld3.creature", Level=130, RingAccess="l5", Ecosystem="Lacustre", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckhld3", entries.creature_ckhld3)
	entries.creature_ckhld4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhld4.creature", Level=140, RingAccess="l5", Ecosystem="Lacustre", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckhld4", entries.creature_ckhld4)
	entries.creature_ckhle1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhle1.creature", Level=160, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckhle1", entries.creature_ckhle1)
	entries.creature_ckhle2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhle2.creature", Level=170, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckhle2", entries.creature_ckhle2)
	entries.creature_ckhle3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhle3.creature", Level=180, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckhle3", entries.creature_ckhle3)
	entries.creature_ckhle4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhle4.creature", Level=190, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckhle4", entries.creature_ckhle4)
	entries.creature_ckhlf1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhlf1.creature", Level=210, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckhlf1", entries.creature_ckhlf1)
	entries.creature_ckhlf2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhlf2.creature", Level=220, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckhlf2", entries.creature_ckhlf2)
	entries.creature_ckhlf3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhlf3.creature", Level=230, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckhlf3", entries.creature_ckhlf3)
	entries.creature_ckhlf4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhlf4.creature", Level=240, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckhlf4", entries.creature_ckhlf4)
	entries.creature_ckhpd1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhpd1.creature", Level=110, RingAccess="p1", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckhpd1", entries.creature_ckhpd1)
	entries.creature_ckhpd2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhpd2.creature", Level=120, RingAccess="p1", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckhpd2", entries.creature_ckhpd2)
	entries.creature_ckhpd3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhpd3.creature", Level=130, RingAccess="p1", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckhpd3", entries.creature_ckhpd3)
	entries.creature_ckhpd4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhpd4.creature", Level=140, RingAccess="p1", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckhpd4", entries.creature_ckhpd4)
	entries.creature_ckhpe1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhpe1.creature", Level=160, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckhpe1", entries.creature_ckhpe1)
	entries.creature_ckhpe2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhpe2.creature", Level=170, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckhpe2", entries.creature_ckhpe2)
	entries.creature_ckhpe3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhpe3.creature", Level=180, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckhpe3", entries.creature_ckhpe3)
	entries.creature_ckhpe4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhpe4.creature", Level=190, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckhpe4", entries.creature_ckhpe4)
	entries.creature_ckhpf1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhpf1.creature", Level=210, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckhpf1", entries.creature_ckhpf1)
	entries.creature_ckhpf2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhpf2.creature", Level=220, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckhpf2", entries.creature_ckhpf2)
	entries.creature_ckhpf3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhpf3.creature", Level=230, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckhpf3", entries.creature_ckhpf3)
	entries.creature_ckhpf4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckhpf4.creature", Level=240, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckhpf4", entries.creature_ckhpf4)

	-- Kizoar (Worker)
	entries.creature_ckidc1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckidc1.creature", Level=60, RingAccess="d2", Ecosystem="Desert", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckidc1", entries.creature_ckidc1)
	entries.creature_ckidc2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckidc2.creature", Level=70, RingAccess="d2", Ecosystem="Desert", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckidc2", entries.creature_ckidc2)
	entries.creature_ckidc3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckidc3.creature", Level=80, RingAccess="d2", Ecosystem="Desert", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckidc3", entries.creature_ckidc3)
	entries.creature_ckidc4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckidc4.creature", Level=90, RingAccess="d2", Ecosystem="Desert", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckidc4", entries.creature_ckidc4)
	entries.creature_ckidd1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckidd1.creature", Level=110, RingAccess="d4", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckidd1", entries.creature_ckidd1)
	entries.creature_ckidd2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckidd2.creature", Level=120, RingAccess="d4", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckidd2", entries.creature_ckidd2)
	entries.creature_ckidd3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckidd3.creature", Level=130, RingAccess="d4", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckidd3", entries.creature_ckidd3)
	entries.creature_ckidd4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckidd4.creature", Level=140, RingAccess="d4", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckidd4", entries.creature_ckidd4)
	entries.creature_ckide1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckide1.creature", Level=160, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckide1", entries.creature_ckide1)
	entries.creature_ckide2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckide2.creature", Level=170, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckide2", entries.creature_ckide2)
	entries.creature_ckide3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckide3.creature", Level=180, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckide3", entries.creature_ckide3)
	entries.creature_ckide4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckide4.creature", Level=190, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckide4", entries.creature_ckide4)
	entries.creature_ckidf1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckidf1.creature", Level=210, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckidf1", entries.creature_ckidf1)
	entries.creature_ckidf2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckidf2.creature", Level=220, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckidf2", entries.creature_ckidf2)
	entries.creature_ckidf3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckidf3.creature", Level=230, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckidf3", entries.creature_ckidf3)
	entries.creature_ckidf4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckidf4.creature", Level=240, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckidf4", entries.creature_ckidf4)
	entries.creature_ckifc1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckifc1.creature", Level=60, RingAccess="f5", Ecosystem="Forest", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckifc1", entries.creature_ckifc1)
	entries.creature_ckifc2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckifc2.creature", Level=70, RingAccess="f5", Ecosystem="Forest", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckifc2", entries.creature_ckifc2)
	entries.creature_ckifc3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckifc3.creature", Level=80, RingAccess="f5", Ecosystem="Forest", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckifc3", entries.creature_ckifc3)
	entries.creature_ckifc4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckifc4.creature", Level=90, RingAccess="f5", Ecosystem="Forest", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckifc4", entries.creature_ckifc4)
	entries.creature_ckifd1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckifd1.creature", Level=110, RingAccess="f5", Ecosystem="Forest", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckifd1", entries.creature_ckifd1)
	entries.creature_ckifd2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckifd2.creature", Level=120, RingAccess="f5", Ecosystem="Forest", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckifd2", entries.creature_ckifd2)
	entries.creature_ckifd3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckifd3.creature", Level=130, RingAccess="f5", Ecosystem="Forest", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckifd3", entries.creature_ckifd3)
	entries.creature_ckifd4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckifd4.creature", Level=140, RingAccess="f5", Ecosystem="Forest", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckifd4", entries.creature_ckifd4)
	entries.creature_ckife1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckife1.creature", Level=160, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckife1", entries.creature_ckife1)
	entries.creature_ckife2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckife2.creature", Level=170, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckife2", entries.creature_ckife2)
	entries.creature_ckife3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckife3.creature", Level=180, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckife3", entries.creature_ckife3)
	entries.creature_ckife4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckife4.creature", Level=190, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckife4", entries.creature_ckife4)
	entries.creature_ckiff1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckiff1.creature", Level=210, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckiff1", entries.creature_ckiff1)
	entries.creature_ckiff2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckiff2.creature", Level=220, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckiff2", entries.creature_ckiff2)
	entries.creature_ckiff3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckiff3.creature", Level=230, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckiff3", entries.creature_ckiff3)
	entries.creature_ckiff4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckiff4.creature", Level=240, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckiff4", entries.creature_ckiff4)
	--entries.creature_ckigb1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckigb1.creature", Level=10, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckigb1", entries.creature_ckigb1)
	--entries.creature_ckigb2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckigb2.creature", Level=20, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckigb2", entries.creature_ckigb2)
	--entries.creature_ckigb3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckigb3.creature", Level=30, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckigb3", entries.creature_ckigb3)
	--entries.creature_ckigb4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckigb4.creature", Level=40, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckigb4", entries.creature_ckigb4)
	--entries.creature_ckigc1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckigc1.creature", Level=60, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckigc1", entries.creature_ckigc1)
	--entries.creature_ckigc2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckigc2.creature", Level=70, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckigc2", entries.creature_ckigc2)
	--entries.creature_ckigc3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckigc3.creature", Level=80, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckigc3", entries.creature_ckigc3)
	--entries.creature_ckigc4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckigc4.creature", Level=90, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckigc4", entries.creature_ckigc4)
	--entries.creature_ckigd1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckigd1.creature", Level=110, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckigd1", entries.creature_ckigd1)
	--entries.creature_ckigd2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckigd2.creature", Level=120, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckigd2", entries.creature_ckigd2)
	--entries.creature_ckigd3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckigd3.creature", Level=130, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckigd3", entries.creature_ckigd3)
	--entries.creature_ckigd4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckigd4.creature", Level=140, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckigd4", entries.creature_ckigd4)
	--entries.creature_ckige1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckige1.creature", Level=160, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckige1", entries.creature_ckige1)
	--entries.creature_ckige2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckige2.creature", Level=170, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckige2", entries.creature_ckige2)
	--entries.creature_ckige3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckige3.creature", Level=180, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckige3", entries.creature_ckige3)
	--entries.creature_ckige4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckige4.creature", Level=190, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckige4", entries.creature_ckige4)
	--entries.creature_ckigf1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckigf1.creature", Level=210, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckigf1", entries.creature_ckigf1)
	--entries.creature_ckigf2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckigf2.creature", Level=220, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckigf2", entries.creature_ckigf2)
	--entries.creature_ckigf3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckigf3.creature", Level=230, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckigf3", entries.creature_ckigf3)
	--entries.creature_ckigf4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckigf4.creature", Level=240, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckigf4", entries.creature_ckigf4)
	entries.creature_ckijc1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckijc1.creature", Level=60, RingAccess="j5", Ecosystem="Jungle", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckijc1", entries.creature_ckijc1)
	entries.creature_ckijc2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckijc2.creature", Level=70, RingAccess="j5", Ecosystem="Jungle", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckijc2", entries.creature_ckijc2)
	entries.creature_ckijc3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckijc3.creature", Level=80, RingAccess="j5", Ecosystem="Jungle", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckijc3", entries.creature_ckijc3)
	entries.creature_ckijc4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckijc4.creature", Level=90, RingAccess="j5", Ecosystem="Jungle", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckijc4", entries.creature_ckijc4)
	entries.creature_ckijd1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckijd1.creature", Level=110, RingAccess="j5", Ecosystem="Jungle", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckijd1", entries.creature_ckijd1)
	entries.creature_ckijd2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckijd2.creature", Level=120, RingAccess="j5", Ecosystem="Jungle", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckijd2", entries.creature_ckijd2)
	entries.creature_ckijd3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckijd3.creature", Level=130, RingAccess="j5", Ecosystem="Jungle", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckijd3", entries.creature_ckijd3)
	entries.creature_ckijd4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckijd4.creature", Level=140, RingAccess="j5", Ecosystem="Jungle", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckijd4", entries.creature_ckijd4)
	entries.creature_ckije1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckije1.creature", Level=160, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckije1", entries.creature_ckije1)
	entries.creature_ckije2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckije2.creature", Level=170, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckije2", entries.creature_ckije2)
	entries.creature_ckije3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckije3.creature", Level=180, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckije3", entries.creature_ckije3)
	entries.creature_ckije4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckije4.creature", Level=190, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckije4", entries.creature_ckije4)
	entries.creature_ckijf1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckijf1.creature", Level=210, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckijf1", entries.creature_ckijf1)
	entries.creature_ckijf2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckijf2.creature", Level=220, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckijf2", entries.creature_ckijf2)
	entries.creature_ckijf3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckijf3.creature", Level=230, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckijf3", entries.creature_ckijf3)
	entries.creature_ckijf4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckijf4.creature", Level=240, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckijf4", entries.creature_ckijf4)
	entries.creature_ckilc1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckilc1.creature", Level=60, RingAccess="l5", Ecosystem="Lacustre", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckilc1", entries.creature_ckilc1)
	entries.creature_ckilc2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckilc2.creature", Level=70, RingAccess="l5", Ecosystem="Lacustre", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckilc2", entries.creature_ckilc2)
	entries.creature_ckilc3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckilc3.creature", Level=80, RingAccess="l5", Ecosystem="Lacustre", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckilc3", entries.creature_ckilc3)
	entries.creature_ckilc4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckilc4.creature", Level=90, RingAccess="l5", Ecosystem="Lacustre", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckilc4", entries.creature_ckilc4)
	entries.creature_ckild1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckild1.creature", Level=110, RingAccess="l5", Ecosystem="Lacustre", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckild1", entries.creature_ckild1)
	entries.creature_ckild2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckild2.creature", Level=120, RingAccess="l5", Ecosystem="Lacustre", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckild2", entries.creature_ckild2)
	entries.creature_ckild3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckild3.creature", Level=130, RingAccess="l5", Ecosystem="Lacustre", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckild3", entries.creature_ckild3)
	entries.creature_ckild4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckild4.creature", Level=140, RingAccess="l5", Ecosystem="Lacustre", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckild4", entries.creature_ckild4)
	entries.creature_ckile1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckile1.creature", Level=160, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckile1", entries.creature_ckile1)
	entries.creature_ckile2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckile2.creature", Level=170, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckile2", entries.creature_ckile2)
	entries.creature_ckile3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckile3.creature", Level=180, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckile3", entries.creature_ckile3)
	entries.creature_ckile4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckile4.creature", Level=190, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckile4", entries.creature_ckile4)
	entries.creature_ckilf1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckilf1.creature", Level=210, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckilf1", entries.creature_ckilf1)
	entries.creature_ckilf2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckilf2.creature", Level=220, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckilf2", entries.creature_ckilf2)
	entries.creature_ckilf3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckilf3.creature", Level=230, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckilf3", entries.creature_ckilf3)
	entries.creature_ckilf4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckilf4.creature", Level=240, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckilf4", entries.creature_ckilf4)
	entries.creature_ckipd1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckipd1.creature", Level=110, RingAccess="p1", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckipd1", entries.creature_ckipd1)
	entries.creature_ckipd2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckipd2.creature", Level=120, RingAccess="p1", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckipd2", entries.creature_ckipd2)
	entries.creature_ckipd3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckipd3.creature", Level=130, RingAccess="p1", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckipd3", entries.creature_ckipd3)
	entries.creature_ckipd4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckipd4.creature", Level=140, RingAccess="p1", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckipd4", entries.creature_ckipd4)
	entries.creature_ckipe1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckipe1.creature", Level=160, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckipe1", entries.creature_ckipe1)
	entries.creature_ckipe2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckipe2.creature", Level=170, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckipe2", entries.creature_ckipe2)
	entries.creature_ckipe3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckipe3.creature", Level=180, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckipe3", entries.creature_ckipe3)
	entries.creature_ckipe4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckipe4.creature", Level=190, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckipe4", entries.creature_ckipe4)
	entries.creature_ckipf1 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckipf1.creature", Level=210, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckipf1", entries.creature_ckipf1)
	entries.creature_ckipf2 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckipf2.creature", Level=220, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckipf2", entries.creature_ckipf2)
	entries.creature_ckipf3 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckipf3.creature", Level=230, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckipf3", entries.creature_ckipf3)
	entries.creature_ckipf4 = { Class="Npc", Base="palette.entities.creatures.kitin_worker", SheetClient="ckipf4.creature", Level=240, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckipf4", entries.creature_ckipf4)


	entries.creature_ckjdd1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjdd1.creature", Level=110, RingAccess="d4", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckjdd1", entries.creature_ckjdd1)
	entries.creature_ckjdd2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjdd2.creature", Level=120, RingAccess="d4", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckjdd2", entries.creature_ckjdd2)
	entries.creature_ckjdd3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjdd3.creature", Level=130, RingAccess="d4", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckjdd3", entries.creature_ckjdd3)
	entries.creature_ckjdd4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjdd4.creature", Level=140, RingAccess="d4", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckjdd4", entries.creature_ckjdd4)
	entries.creature_ckjde1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjde1.creature", Level=160, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckjde1", entries.creature_ckjde1)
	entries.creature_ckjde2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjde2.creature", Level=170, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckjde2", entries.creature_ckjde2)
	entries.creature_ckjde3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjde3.creature", Level=180, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckjde3", entries.creature_ckjde3)
	entries.creature_ckjde4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjde4.creature", Level=190, RingAccess="d6", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckjde4", entries.creature_ckjde4)
	entries.creature_ckjdf1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjdf1.creature", Level=210, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckjdf1", entries.creature_ckjdf1)
	entries.creature_ckjdf2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjdf2.creature", Level=220, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckjdf2", entries.creature_ckjdf2)
	entries.creature_ckjdf3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjdf3.creature", Level=230, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckjdf3", entries.creature_ckjdf3)
	entries.creature_ckjdf4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjdf4.creature", Level=240, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckjdf4", entries.creature_ckjdf4)
	entries.creature_ckjfd1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjfd1.creature", Level=110, RingAccess="f5", Ecosystem="Forest", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckjfd1", entries.creature_ckjfd1)
	entries.creature_ckjfd2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjfd2.creature", Level=120, RingAccess="f5", Ecosystem="Forest", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckjfd2", entries.creature_ckjfd2)
	entries.creature_ckjfd3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjfd3.creature", Level=130, RingAccess="f5", Ecosystem="Forest", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckjfd3", entries.creature_ckjfd3)
	entries.creature_ckjfd4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjfd4.creature", Level=140, RingAccess="f5", Ecosystem="Forest", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckjfd4", entries.creature_ckjfd4)
	entries.creature_ckjfe1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjfe1.creature", Level=160, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckjfe1", entries.creature_ckjfe1)
	entries.creature_ckjfe2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjfe2.creature", Level=170, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckjfe2", entries.creature_ckjfe2)
	entries.creature_ckjfe3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjfe3.creature", Level=180, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckjfe3", entries.creature_ckjfe3)
	entries.creature_ckjfe4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjfe4.creature", Level=190, RingAccess="f6", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckjfe4", entries.creature_ckjfe4)
	entries.creature_ckjff1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjff1.creature", Level=210, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckjff1", entries.creature_ckjff1)
	entries.creature_ckjff2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjff2.creature", Level=220, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckjff2", entries.creature_ckjff2)
	entries.creature_ckjff3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjff3.creature", Level=230, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckjff3", entries.creature_ckjff3)
	entries.creature_ckjff4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjff4.creature", Level=240, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckjff4", entries.creature_ckjff4)
	--entries.creature_ckjgb1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjgb1.creature", Level=10, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckjgb1", entries.creature_ckjgb1)
	--entries.creature_ckjgb2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjgb2.creature", Level=20, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckjgb2", entries.creature_ckjgb2)
	--entries.creature_ckjgb3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjgb3.creature", Level=30, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckjgb3", entries.creature_ckjgb3)
	--entries.creature_ckjgb4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjgb4.creature", Level=40, RingAccess="g1", Ecosystem="Goo", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckjgb4", entries.creature_ckjgb4)
	--entries.creature_ckjgc1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjgc1.creature", Level=60, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckjgc1", entries.creature_ckjgc1)
	--entries.creature_ckjgc2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjgc2.creature", Level=70, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckjgc2", entries.creature_ckjgc2)
	--entries.creature_ckjgc3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjgc3.creature", Level=80, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckjgc3", entries.creature_ckjgc3)
	--entries.creature_ckjgc4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjgc4.creature", Level=90, RingAccess="g1", Ecosystem="Goo", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckjgc4", entries.creature_ckjgc4)
	--entries.creature_ckjgd1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjgd1.creature", Level=110, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckjgd1", entries.creature_ckjgd1)
	--entries.creature_ckjgd2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjgd2.creature", Level=120, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckjgd2", entries.creature_ckjgd2)
	--entries.creature_ckjgd3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjgd3.creature", Level=130, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckjgd3", entries.creature_ckjgd3)
	--entries.creature_ckjgd4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjgd4.creature", Level=140, RingAccess="g1", Ecosystem="Goo", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckjgd4", entries.creature_ckjgd4)
	--entries.creature_ckjge1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjge1.creature", Level=160, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckjge1", entries.creature_ckjge1)
	--entries.creature_ckjge2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjge2.creature", Level=170, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckjge2", entries.creature_ckjge2)
	--entries.creature_ckjge3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjge3.creature", Level=180, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckjge3", entries.creature_ckjge3)
	--entries.creature_ckjge4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjge4.creature", Level=190, RingAccess="g1", Ecosystem="Goo", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckjge4", entries.creature_ckjge4)
	--entries.creature_ckjgf1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjgf1.creature", Level=210, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckjgf1", entries.creature_ckjgf1)
	--entries.creature_ckjgf2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjgf2.creature", Level=220, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckjgf2", entries.creature_ckjgf2)
	--entries.creature_ckjgf3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjgf3.creature", Level=230, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckjgf3", entries.creature_ckjgf3)
	--entries.creature_ckjgf4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjgf4.creature", Level=240, RingAccess="g1", Ecosystem="Goo", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckjgf4", entries.creature_ckjgf4)
	entries.creature_ckjjd1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjjd1.creature", Level=110, RingAccess="j5", Ecosystem="Jungle", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckjjd1", entries.creature_ckjjd1)
	entries.creature_ckjjd2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjjd2.creature", Level=120, RingAccess="j5", Ecosystem="Jungle", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckjjd2", entries.creature_ckjjd2)
	entries.creature_ckjjd3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjjd3.creature", Level=130, RingAccess="j5", Ecosystem="Jungle", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckjjd3", entries.creature_ckjjd3)
	entries.creature_ckjjd4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjjd4.creature", Level=140, RingAccess="j5", Ecosystem="Jungle", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckjjd4", entries.creature_ckjjd4)
	entries.creature_ckjje1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjje1.creature", Level=160, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckjje1", entries.creature_ckjje1)
	entries.creature_ckjje2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjje2.creature", Level=170, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckjje2", entries.creature_ckjje2)
	entries.creature_ckjje3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjje3.creature", Level=180, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckjje3", entries.creature_ckjje3)
	entries.creature_ckjje4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjje4.creature", Level=190, RingAccess="j6", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckjje4", entries.creature_ckjje4)
	entries.creature_ckjjf1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjjf1.creature", Level=210, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckjjf1", entries.creature_ckjjf1)
	entries.creature_ckjjf2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjjf2.creature", Level=220, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckjjf2", entries.creature_ckjjf2)
	entries.creature_ckjjf3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjjf3.creature", Level=230, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckjjf3", entries.creature_ckjjf3)
	entries.creature_ckjjf4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjjf4.creature", Level=240, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckjjf4", entries.creature_ckjjf4)
	entries.creature_ckjld1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjld1.creature", Level=110, RingAccess="l5", Ecosystem="Lacustre", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckjld1", entries.creature_ckjld1)
	entries.creature_ckjld2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjld2.creature", Level=120, RingAccess="l5", Ecosystem="Lacustre", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckjld2", entries.creature_ckjld2)
	entries.creature_ckjld3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjld3.creature", Level=130, RingAccess="l5", Ecosystem="Lacustre", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckjld3", entries.creature_ckjld3)
	entries.creature_ckjld4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjld4.creature", Level=140, RingAccess="l5", Ecosystem="Lacustre", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckjld4", entries.creature_ckjld4)
	entries.creature_ckjle1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjle1.creature", Level=160, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckjle1", entries.creature_ckjle1)
	entries.creature_ckjle2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjle2.creature", Level=170, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckjle2", entries.creature_ckjle2)
	entries.creature_ckjle3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjle3.creature", Level=180, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckjle3", entries.creature_ckjle3)
	entries.creature_ckjle4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjle4.creature", Level=190, RingAccess="l5", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckjle4", entries.creature_ckjle4)
	entries.creature_ckjlf1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjlf1.creature", Level=210, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckjlf1", entries.creature_ckjlf1)
	entries.creature_ckjlf2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjlf2.creature", Level=220, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckjlf2", entries.creature_ckjlf2)
	entries.creature_ckjlf3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjlf3.creature", Level=230, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckjlf3", entries.creature_ckjlf3)
	entries.creature_ckjlf4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjlf4.creature", Level=240, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckjlf4", entries.creature_ckjlf4)
	entries.creature_ckjpd1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjpd1.creature", Level=110, RingAccess="p1", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckjpd1", entries.creature_ckjpd1)
	entries.creature_ckjpd2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjpd2.creature", Level=120, RingAccess="p1", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckjpd2", entries.creature_ckjpd2)
	entries.creature_ckjpd3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjpd3.creature", Level=130, RingAccess="p1", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckjpd3", entries.creature_ckjpd3)
	entries.creature_ckjpd4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjpd4.creature", Level=140, RingAccess="p1", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckjpd4", entries.creature_ckjpd4)
	entries.creature_ckjpe1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjpe1.creature", Level=160, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckjpe1", entries.creature_ckjpe1)
	entries.creature_ckjpe2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjpe2.creature", Level=170, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckjpe2", entries.creature_ckjpe2)
	entries.creature_ckjpe3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjpe3.creature", Level=180, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckjpe3", entries.creature_ckjpe3)
	entries.creature_ckjpe4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjpe4.creature", Level=190, RingAccess="p4", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckjpe4", entries.creature_ckjpe4)
	entries.creature_ckjpf1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjpf1.creature", Level=210, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckjpf1", entries.creature_ckjpf1)
	entries.creature_ckjpf2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjpf2.creature", Level=220, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckjpf2", entries.creature_ckjpf2)
	entries.creature_ckjpf3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjpf3.creature", Level=230, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckjpf3", entries.creature_ckjpf3)
	entries.creature_ckjpf4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjpf4.creature", Level=240, RingAccess="p10", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckjpf4", entries.creature_ckjpf4)


-- Named Passives
	entries.creature_cbajf5 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="cbajf5.creature", Level=248, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.cbajf5", entries.creature_cbajf5)
	entries.creature_cbbpe7 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="cbbpe7.creature", Level=199, RingAccess="p9", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.cbbpe7", entries.creature_cbbpe7)
	entries.creature_cbbde5 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="cbbde5.creature", Level=198, RingAccess="d7", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.cbbde5", entries.creature_cbbde5)
	entries.creature_cbbdd7 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="cbbdd7.creature", Level=149, RingAccess="d5", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.cbbdd7", entries.creature_cbbdd7)
	entries.creature_cbcld5 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="cbcld5.creature", Level=148, RingAccess="l5", Ecosystem="Lacustre", Region="d" } r2.addPaletteElement("palette.entities.creatures.cbcld5", entries.creature_cbcld5)
	entries.creature_cbclc7 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="cbclc7.creature", Level=99, RingAccess="l5", Ecosystem="Lacustre", Region="c" } r2.addPaletteElement("palette.entities.creatures.cbclc7", entries.creature_cbclc7)
	entries.creature_cbajb7 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="cbajb7.creature", Level=49, RingAccess="j4", Ecosystem="Jungle", Region="b" } r2.addPaletteElement("palette.entities.creatures.cbajb7", entries.creature_cbajb7)
	entries.creature_chldf7 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chldf7.creature", Level=249, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.chldf7", entries.creature_chldf7)
	entries.creature_chsdf7 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chsdf7.creature", Level=249, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.chsdf7", entries.creature_chsdf7)
	entries.creature_chwff7 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chwff7.creature", Level=249, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.chwff7", entries.creature_chwff7)
	entries.creature_chxjf7 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chxjf7.creature", Level=249, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.chxjf7", entries.creature_chxjf7)
	entries.creature_chtjf7 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chtjf7.creature", Level=249, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.chtjf7", entries.creature_chtjf7)
	entries.creature_chulf7 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chulf7.creature", Level=249, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.chulf7", entries.creature_chulf7)
	entries.creature_chgpf7 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chgpf7.creature", Level=249, RingAccess="p13", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.chgpf7", entries.creature_chgpf7)
	entries.creature_chlpf7 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chlpf7.creature", Level=249, RingAccess="p13", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.chlpf7", entries.creature_chlpf7)
	entries.creature_chhpf7 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chhpf7.creature", Level=249, RingAccess="p13", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.chhpf7", entries.creature_chhpf7)
	entries.creature_chvpf7 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chvpf7.creature", Level=249, RingAccess="p13", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.chvpf7", entries.creature_chvpf7)
	entries.creature_chldf5 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chldf5.creature", Level=248, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.chldf5", entries.creature_chldf5)
	entries.creature_chsdf5 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chsdf5.creature", Level=248, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.chsdf5", entries.creature_chsdf5)
	entries.creature_chlff5 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chlff5.creature", Level=248, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.chlff5", entries.creature_chlff5)
	entries.creature_chvff5 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chvff5.creature", Level=248, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.chvff5", entries.creature_chvff5)
	entries.creature_chajf5 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chajf5.creature", Level=248, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.chajf5", entries.creature_chajf5)
	entries.creature_chtjf5 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chtjf5.creature", Level=248, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.chtjf5", entries.creature_chtjf5)
	entries.creature_chrlf5 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chrlf5.creature", Level=248, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.chrlf5", entries.creature_chrlf5)
	entries.creature_chhpf5 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chhpf5.creature", Level=248, RingAccess="p13", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.chhpf5", entries.creature_chhpf5)
	entries.creature_chlpf5 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chlpf5.creature", Level=248, RingAccess="p13", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.chlpf5", entries.creature_chlpf5)
	entries.creature_chgpf5 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chgpf5.creature", Level=248, RingAccess="p13", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.chgpf5", entries.creature_chgpf5)
	entries.creature_chtde7 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chtde7.creature", Level=199, RingAccess="d7", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.chtde7", entries.creature_chtde7)
	entries.creature_chwde7 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chwde7.creature", Level=199, RingAccess="d7", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.chwde7", entries.creature_chwde7)
	entries.creature_chpde7 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chpde7.creature", Level=199, RingAccess="d7", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.chpde7", entries.creature_chpde7)
	entries.creature_chlfe7 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chlfe7.creature", Level=199, RingAccess="f7", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.chlfe7", entries.creature_chlfe7)
	entries.creature_chqfe7 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chqfe7.creature", Level=199, RingAccess="f7", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.chqfe7", entries.creature_chqfe7)
	entries.creature_chrfe7 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chrfe7.creature", Level=199, RingAccess="f7", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.chrfe7", entries.creature_chrfe7)
	entries.creature_chvfe7 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chvfe7.creature", Level=199, RingAccess="f7", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.chvfe7", entries.creature_chvfe7)
	entries.creature_chvje7 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chvje7.creature", Level=199, RingAccess="j7", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.chvje7", entries.creature_chvje7)
	entries.creature_chuje7 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chuje7.creature", Level=199, RingAccess="j7", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.chuje7", entries.creature_chuje7)
	entries.creature_chsle7 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chsle7.creature", Level=199, RingAccess="l6", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.chsle7", entries.creature_chsle7)
	entries.creature_chale7 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chale7.creature", Level=199, RingAccess="l6", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.chale7", entries.creature_chale7)
	entries.creature_chele7 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chele7.creature", Level=199, RingAccess="l6", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.chele7", entries.creature_chele7)
	entries.creature_chlpe7 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chlpe7.creature", Level=199, RingAccess="p9", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.chlpe7", entries.creature_chlpe7)
	entries.creature_chxpe7 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chxpe7.creature", Level=199, RingAccess="p9", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.chxpe7", entries.creature_chxpe7)
	entries.creature_chape7 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chape7.creature", Level=199, RingAccess="p9", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.chape7", entries.creature_chape7)
	entries.creature_chgde5 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chgde5.creature", Level=198, RingAccess="d7", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.chgde5", entries.creature_chgde5)
	entries.creature_chkde5 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chkde5.creature", Level=198, RingAccess="d7", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.chkde5", entries.creature_chkde5)
	entries.creature_chwde5 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chwde5.creature", Level=198, RingAccess="d7", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.chwde5", entries.creature_chwde5)
	entries.creature_chafe5 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chafe5.creature", Level=198, RingAccess="f7", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.chafe5", entries.creature_chafe5)
	entries.creature_chlfe5 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chlfe5.creature", Level=198, RingAccess="f7", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.chlfe5", entries.creature_chlfe5)
	entries.creature_chqfe5 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chqfe5.creature", Level=198, RingAccess="f7", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.chqfe5", entries.creature_chqfe5)
	entries.creature_chrfe5 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chrfe5.creature", Level=198, RingAccess="f7", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.chrfe5", entries.creature_chrfe5)
	entries.creature_cheje5 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="cheje5.creature", Level=198, RingAccess="j7", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.cheje5", entries.creature_cheje5)
	entries.creature_chuje5 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chuje5.creature", Level=198, RingAccess="j7", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.chuje5", entries.creature_chuje5)
	entries.creature_chale5 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chale5.creature", Level=198, RingAccess="l6", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.chale5", entries.creature_chale5)
	entries.creature_chsle5 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chsle5.creature", Level=198, RingAccess="l6", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.chsle5", entries.creature_chsle5)
	entries.creature_chhle5 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chhle5.creature", Level=198, RingAccess="l6", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.chhle5", entries.creature_chhle5)
	entries.creature_chlpe5 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chlpe5.creature", Level=198, RingAccess="p9", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.chlpe5", entries.creature_chlpe5)
	entries.creature_chxpe5 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chxpe5.creature", Level=198, RingAccess="p9", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.chxpe5", entries.creature_chxpe5)
	entries.creature_chape5 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chape5.creature", Level=198, RingAccess="p9", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.chape5", entries.creature_chape5)
	entries.creature_chbpe5 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chbpe5.creature", Level=198, RingAccess="p9", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.chbpe5", entries.creature_chbpe5)
	entries.creature_chmdd7 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chmdd7.creature", Level=149, RingAccess="d5", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.chmdd7", entries.creature_chmdd7)
	entries.creature_chpfd7 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chpfd7.creature", Level=149, RingAccess="f6", Ecosystem="Forest", Region="d" } r2.addPaletteElement("palette.entities.creatures.chpfd7", entries.creature_chpfd7)
	entries.creature_chkjd7 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chkjd7.creature", Level=149, RingAccess="j6", Ecosystem="Jungle", Region="d" } r2.addPaletteElement("palette.entities.creatures.chkjd7", entries.creature_chkjd7)
	entries.creature_chcld7 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chcld7.creature", Level=149, RingAccess="l5", Ecosystem="Lacustre", Region="d" } r2.addPaletteElement("palette.entities.creatures.chcld7", entries.creature_chcld7)
	entries.creature_chgpd7 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chgpd7.creature", Level=149, RingAccess="p2", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.chgpd7", entries.creature_chgpd7)
	entries.creature_chhdd5 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chhdd5.creature", Level=148, RingAccess="d5", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.chhdd5", entries.creature_chhdd5)
	entries.creature_chmdd5 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chmdd5.creature", Level=148, RingAccess="d5", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.chmdd5", entries.creature_chmdd5)
	entries.creature_chnfd5 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chnfd5.creature", Level=148, RingAccess="f6", Ecosystem="Forest", Region="d" } r2.addPaletteElement("palette.entities.creatures.chnfd5", entries.creature_chnfd5)
	entries.creature_chcjd5 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chcjd5.creature", Level=148, RingAccess="j6", Ecosystem="Jungle", Region="d" } r2.addPaletteElement("palette.entities.creatures.chcjd5", entries.creature_chcjd5)
	entries.creature_cheld5 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="cheld5.creature", Level=148, RingAccess="l5", Ecosystem="Lacustre", Region="d" } r2.addPaletteElement("palette.entities.creatures.cheld5", entries.creature_cheld5)
	entries.creature_chgpd5 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chgpd5.creature", Level=148, RingAccess="p2", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.chgpd5", entries.creature_chgpd5)
	entries.creature_chbpd5 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chbpd5.creature", Level=148, RingAccess="p2", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.chbpd5", entries.creature_chbpd5)
	entries.creature_chnjc7 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chnjc7.creature", Level=99, RingAccess="j5", Ecosystem="Jungle", Region="c" } r2.addPaletteElement("palette.entities.creatures.chnjc7", entries.creature_chnjc7)
	entries.creature_chhdc5 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chhdc5.creature", Level=98, RingAccess="d3", Ecosystem="Desert", Region="c" } r2.addPaletteElement("palette.entities.creatures.chhdc5", entries.creature_chhdc5)
	entries.creature_chpdc5 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chpdc5.creature", Level=98, RingAccess="d3", Ecosystem="Desert", Region="c" } r2.addPaletteElement("palette.entities.creatures.chpdc5", entries.creature_chpdc5)
	entries.creature_chafc5 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chafc5.creature", Level=98, RingAccess="f5", Ecosystem="Forest", Region="c" } r2.addPaletteElement("palette.entities.creatures.chafc5", entries.creature_chafc5)
	entries.creature_chclc5 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chclc5.creature", Level=98, RingAccess="l5", Ecosystem="Lacustre", Region="c" } r2.addPaletteElement("palette.entities.creatures.chclc5", entries.creature_chclc5)
	entries.creature_chblc5 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chblc5.creature", Level=98, RingAccess="l5", Ecosystem="Lacustre", Region="c" } r2.addPaletteElement("palette.entities.creatures.chblc5", entries.creature_chblc5)
	entries.creature_chcdb7 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chcdb7.creature", Level=49, RingAccess="d2", Ecosystem="Desert", Region="b" } r2.addPaletteElement("palette.entities.creatures.chcdb7", entries.creature_chcdb7)
	entries.creature_chbfb7 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chbfb7.creature", Level=49, RingAccess="f4", Ecosystem="Forest", Region="b" } r2.addPaletteElement("palette.entities.creatures.chbfb7", entries.creature_chbfb7)
	entries.creature_chflb7 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chflb7.creature", Level=49, RingAccess="l4", Ecosystem="Lacustre", Region="b" } r2.addPaletteElement("palette.entities.creatures.chflb7", entries.creature_chflb7)
	entries.creature_chgdb5 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chgdb5.creature", Level=48, RingAccess="d2", Ecosystem="Desert", Region="b" } r2.addPaletteElement("palette.entities.creatures.chgdb5", entries.creature_chgdb5)
	entries.creature_chdfb5 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chdfb5.creature", Level=48, RingAccess="f4", Ecosystem="Forest", Region="b" } r2.addPaletteElement("palette.entities.creatures.chdfb5", entries.creature_chdfb5)
	entries.creature_chfjb5 = { Class="Npc", Base="palette.entities.creatures.named_passive", SheetClient="chfjb5.creature", Level=48, RingAccess="j4", Ecosystem="Jungle", Region="b" } r2.addPaletteElement("palette.entities.creatures.chfjb5", entries.creature_chfjb5)


-- Named Predators
	entries.creature_cckdf7 = { Class="Npc", Base="palette.entities.creatures.named_predator", SheetClient="cckdf7.creature", Level=249, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.cckdf7", entries.creature_cckdf7)
	entries.creature_ccmff7 = { Class="Npc", Base="palette.entities.creatures.named_predator", SheetClient="ccmff7.creature", Level=249, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccmff7", entries.creature_ccmff7)
	entries.creature_cceff7 = { Class="Npc", Base="palette.entities.creatures.named_predator", SheetClient="cceff7.creature", Level=249, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.cceff7", entries.creature_cceff7)
	entries.creature_ccijf7 = { Class="Npc", Base="palette.entities.creatures.named_predator", SheetClient="ccijf7.creature", Level=249, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccijf7", entries.creature_ccijf7)
	entries.creature_ccpjf7 = { Class="Npc", Base="palette.entities.creatures.named_predator", SheetClient="ccpjf7.creature", Level=249, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccpjf7", entries.creature_ccpjf7)
	entries.creature_ccnlf7 = { Class="Npc", Base="palette.entities.creatures.named_predator", SheetClient="ccnlf7.creature", Level=249, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccnlf7", entries.creature_ccnlf7)
	entries.creature_ccclf7 = { Class="Npc", Base="palette.entities.creatures.named_predator", SheetClient="ccclf7.creature", Level=249, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccclf7", entries.creature_ccclf7)
	entries.creature_ccgpf7 = { Class="Npc", Base="palette.entities.creatures.named_predator", SheetClient="ccgpf7.creature", Level=249, RingAccess="p13", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccgpf7", entries.creature_ccgpf7)
	entries.creature_ccmpf7 = { Class="Npc", Base="palette.entities.creatures.named_predator", SheetClient="ccmpf7.creature", Level=249, RingAccess="p13", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccmpf7", entries.creature_ccmpf7)
	entries.creature_ccopf7 = { Class="Npc", Base="palette.entities.creatures.named_predator", SheetClient="ccopf7.creature", Level=249, RingAccess="p13", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccopf7", entries.creature_ccopf7)
	entries.creature_ccepf7 = { Class="Npc", Base="palette.entities.creatures.named_predator", SheetClient="ccepf7.creature", Level=249, RingAccess="p13", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccepf7", entries.creature_ccepf7)
	entries.creature_ccidf5 = { Class="Npc", Base="palette.entities.creatures.named_predator", SheetClient="ccidf5.creature", Level=248, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccidf5", entries.creature_ccidf5)
	entries.creature_ccdff5 = { Class="Npc", Base="palette.entities.creatures.named_predator", SheetClient="ccdff5.creature", Level=248, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccdff5", entries.creature_ccdff5)
	entries.creature_cckff5 = { Class="Npc", Base="palette.entities.creatures.named_predator", SheetClient="cckff5.creature", Level=248, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.cckff5", entries.creature_cckff5)
	entries.creature_ccfjf5 = { Class="Npc", Base="palette.entities.creatures.named_predator", SheetClient="ccfjf5.creature", Level=248, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccfjf5", entries.creature_ccfjf5)
	entries.creature_ccdlf5 = { Class="Npc", Base="palette.entities.creatures.named_predator", SheetClient="ccdlf5.creature", Level=248, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccdlf5", entries.creature_ccdlf5)
	entries.creature_ccflf5 = { Class="Npc", Base="palette.entities.creatures.named_predator", SheetClient="ccflf5.creature", Level=248, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccflf5", entries.creature_ccflf5)
	entries.creature_ccmpf5 = { Class="Npc", Base="palette.entities.creatures.named_predator", SheetClient="ccmpf5.creature", Level=248, RingAccess="p13", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccmpf5", entries.creature_ccmpf5)
	entries.creature_ccopf5 = { Class="Npc", Base="palette.entities.creatures.named_predator", SheetClient="ccopf5.creature", Level=248, RingAccess="p13", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccopf5", entries.creature_ccopf5)
	entries.creature_ccgpf5 = { Class="Npc", Base="palette.entities.creatures.named_predator", SheetClient="ccgpf5.creature", Level=248, RingAccess="p13", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ccgpf5", entries.creature_ccgpf5)
	entries.creature_cchde7 = { Class="Npc", Base="palette.entities.creatures.named_predator", SheetClient="cchde7.creature", Level=199, RingAccess="d7", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.cchde7", entries.creature_cchde7)
	entries.creature_cclde7 = { Class="Npc", Base="palette.entities.creatures.named_predator", SheetClient="cclde7.creature", Level=199, RingAccess="d7", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.cclde7", entries.creature_cclde7)
	entries.creature_ccdfe7 = { Class="Npc", Base="palette.entities.creatures.named_predator", SheetClient="ccdfe7.creature", Level=199, RingAccess="f7", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccdfe7", entries.creature_ccdfe7)
	entries.creature_cckfe7 = { Class="Npc", Base="palette.entities.creatures.named_predator", SheetClient="cckfe7.creature", Level=199, RingAccess="f7", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.cckfe7", entries.creature_cckfe7)
	entries.creature_ccafe7 = { Class="Npc", Base="palette.entities.creatures.named_predator", SheetClient="ccafe7.creature", Level=199, RingAccess="f7", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccafe7", entries.creature_ccafe7)
	entries.creature_ccdle7 = { Class="Npc", Base="palette.entities.creatures.named_predator", SheetClient="ccdle7.creature", Level=199, RingAccess="l6", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccdle7", entries.creature_ccdle7)
	entries.creature_ccope7 = { Class="Npc", Base="palette.entities.creatures.named_predator", SheetClient="ccope7.creature", Level=199, RingAccess="p9", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccope7", entries.creature_ccope7)
	entries.creature_ccfpe7 = { Class="Npc", Base="palette.entities.creatures.named_predator", SheetClient="ccfpe7.creature", Level=199, RingAccess="p9", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccfpe7", entries.creature_ccfpe7)
	entries.creature_cchpe7 = { Class="Npc", Base="palette.entities.creatures.named_predator", SheetClient="cchpe7.creature", Level=199, RingAccess="p9", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.cchpe7", entries.creature_cchpe7)
	entries.creature_ccbde5 = { Class="Npc", Base="palette.entities.creatures.named_predator", SheetClient="ccbde5.creature", Level=198, RingAccess="d7", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccbde5", entries.creature_ccbde5)
	entries.creature_cchde5 = { Class="Npc", Base="palette.entities.creatures.named_predator", SheetClient="cchde5.creature", Level=198, RingAccess="d7", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.cchde5", entries.creature_cchde5)
	entries.creature_cclde5 = { Class="Npc", Base="palette.entities.creatures.named_predator", SheetClient="cclde5.creature", Level=198, RingAccess="d7", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.cclde5", entries.creature_cclde5)
	entries.creature_ccdfe5 = { Class="Npc", Base="palette.entities.creatures.named_predator", SheetClient="ccdfe5.creature", Level=198, RingAccess="f7", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccdfe5", entries.creature_ccdfe5)
	entries.creature_cckfe5 = { Class="Npc", Base="palette.entities.creatures.named_predator", SheetClient="cckfe5.creature", Level=198, RingAccess="f7", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.cckfe5", entries.creature_cckfe5)
	entries.creature_ccaje5 = { Class="Npc", Base="palette.entities.creatures.named_predator", SheetClient="ccaje5.creature", Level=198, RingAccess="j7", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccaje5", entries.creature_ccaje5)
	entries.creature_ccdje5 = { Class="Npc", Base="palette.entities.creatures.named_predator", SheetClient="ccdje5.creature", Level=198, RingAccess="j7", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccdje5", entries.creature_ccdje5)
	entries.creature_ccele5 = { Class="Npc", Base="palette.entities.creatures.named_predator", SheetClient="ccele5.creature", Level=198, RingAccess="l6", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccele5", entries.creature_ccele5)
	entries.creature_ccdle5 = { Class="Npc", Base="palette.entities.creatures.named_predator", SheetClient="ccdle5.creature", Level=198, RingAccess="l6", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccdle5", entries.creature_ccdle5)
	entries.creature_ccope5 = { Class="Npc", Base="palette.entities.creatures.named_predator", SheetClient="ccope5.creature", Level=198, RingAccess="p9", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.ccope5", entries.creature_ccope5)
	entries.creature_cchpe5 = { Class="Npc", Base="palette.entities.creatures.named_predator", SheetClient="cchpe5.creature", Level=198, RingAccess="p9", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.cchpe5", entries.creature_cchpe5)
	entries.creature_ccidd7 = { Class="Npc", Base="palette.entities.creatures.named_predator", SheetClient="ccidd7.creature", Level=149, RingAccess="d5", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccidd7", entries.creature_ccidd7)
	entries.creature_cccdd7 = { Class="Npc", Base="palette.entities.creatures.named_predator", SheetClient="cccdd7.creature", Level=149, RingAccess="d5", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.cccdd7", entries.creature_cccdd7)
	entries.creature_ccjfd7 = { Class="Npc", Base="palette.entities.creatures.named_predator", SheetClient="ccjfd7.creature", Level=149, RingAccess="f6", Ecosystem="Forest", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccjfd7", entries.creature_ccjfd7)
	entries.creature_ccfjd7 = { Class="Npc", Base="palette.entities.creatures.named_predator", SheetClient="ccfjd7.creature", Level=149, RingAccess="j6", Ecosystem="Jungle", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccfjd7", entries.creature_ccfjd7)
	entries.creature_ccnpd7 = { Class="Npc", Base="palette.entities.creatures.named_predator", SheetClient="ccnpd7.creature", Level=149, RingAccess="p2", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccnpd7", entries.creature_ccnpd7)
	entries.creature_ccipd7 = { Class="Npc", Base="palette.entities.creatures.named_predator", SheetClient="ccipd7.creature", Level=149, RingAccess="p2", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccipd7", entries.creature_ccipd7)
	entries.creature_cchdd5 = { Class="Npc", Base="palette.entities.creatures.named_predator", SheetClient="cchdd5.creature", Level=148, RingAccess="d5", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.cchdd5", entries.creature_cchdd5)
	entries.creature_ccidd5 = { Class="Npc", Base="palette.entities.creatures.named_predator", SheetClient="ccidd5.creature", Level=148, RingAccess="d5", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccidd5", entries.creature_ccidd5)
	entries.creature_ccafd5 = { Class="Npc", Base="palette.entities.creatures.named_predator", SheetClient="ccafd5.creature", Level=148, RingAccess="f6", Ecosystem="Forest", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccafd5", entries.creature_ccafd5)
	entries.creature_ccjfd5 = { Class="Npc", Base="palette.entities.creatures.named_predator", SheetClient="ccjfd5.creature", Level=148, RingAccess="f6", Ecosystem="Forest", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccjfd5", entries.creature_ccjfd5)
	entries.creature_ccijd5 = { Class="Npc", Base="palette.entities.creatures.named_predator", SheetClient="ccijd5.creature", Level=148, RingAccess="j6", Ecosystem="Jungle", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccijd5", entries.creature_ccijd5)
	entries.creature_ccajd5 = { Class="Npc", Base="palette.entities.creatures.named_predator", SheetClient="ccajd5.creature", Level=148, RingAccess="j6", Ecosystem="Jungle", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccajd5", entries.creature_ccajd5)
	entries.creature_ccfld5 = { Class="Npc", Base="palette.entities.creatures.named_predator", SheetClient="ccfld5.creature", Level=148, RingAccess="l5", Ecosystem="Lacustre", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccfld5", entries.creature_ccfld5)
	entries.creature_ccipd5 = { Class="Npc", Base="palette.entities.creatures.named_predator", SheetClient="ccipd5.creature", Level=148, RingAccess="p2", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.ccipd5", entries.creature_ccipd5)
	entries.creature_ccbdc7 = { Class="Npc", Base="palette.entities.creatures.named_predator", SheetClient="ccbdc7.creature", Level=99, RingAccess="d3", Ecosystem="Desert", Region="c" } r2.addPaletteElement("palette.entities.creatures.ccbdc7", entries.creature_ccbdc7)
	entries.creature_ccelc7 = { Class="Npc", Base="palette.entities.creatures.named_predator", SheetClient="ccelc7.creature", Level=99, RingAccess="l5", Ecosystem="Lacustre", Region="c" } r2.addPaletteElement("palette.entities.creatures.ccelc7", entries.creature_ccelc7)
	entries.creature_ccafc5 = { Class="Npc", Base="palette.entities.creatures.named_predator", SheetClient="ccafc5.creature", Level=98, RingAccess="f5", Ecosystem="Forest", Region="c" } r2.addPaletteElement("palette.entities.creatures.ccafc5", entries.creature_ccafc5)
	entries.creature_ccdjc5 = { Class="Npc", Base="palette.entities.creatures.named_predator", SheetClient="ccdjc5.creature", Level=98, RingAccess="j5", Ecosystem="Jungle", Region="c" } r2.addPaletteElement("palette.entities.creatures.ccdjc5", entries.creature_ccdjc5)
	entries.creature_cccdb7 = { Class="Npc", Base="palette.entities.creatures.named_predator", SheetClient="cccdb7.creature", Level=49, RingAccess="d2", Ecosystem="Desert", Region="b" } r2.addPaletteElement("palette.entities.creatures.cccdb7", entries.creature_cccdb7)
	entries.creature_ccejb7 = { Class="Npc", Base="palette.entities.creatures.named_predator", SheetClient="ccejb7.creature", Level=49, RingAccess="j4", Ecosystem="Jungle", Region="b" } r2.addPaletteElement("palette.entities.creatures.ccejb7", entries.creature_ccejb7)


-- Named Plants
	entries.creature_cpfdf7 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpfdf7.creature", Level=249, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.cpfdf7", entries.creature_cpfdf7)
	entries.creature_cpblf7 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpblf7.creature", Level=249, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.cpblf7", entries.creature_cpblf7)
	entries.creature_cpapf7 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpapf7.creature", Level=249, RingAccess="p13", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.cpapf7", entries.creature_cpapf7)
	entries.creature_cpcpf7 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpcpf7.creature", Level=249, RingAccess="p13", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.cpcpf7", entries.creature_cpcpf7)
	entries.creature_cpefe7 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpefe7.creature", Level=199, RingAccess="f7", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.cpefe7", entries.creature_cpefe7)
	entries.creature_cpdje7 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpdje7.creature", Level=199, RingAccess="j7", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.cpdje7", entries.creature_cpdje7)
	entries.creature_cpapd7 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpapd7.creature", Level=149, RingAccess="p2", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.cpapd7", entries.creature_cpapd7)
	entries.creature_cpcfc7 = { Class="Npc", Base="palette.entities.creatures.plant", SheetClient="cpcfc7.creature", Level=99, RingAccess="f5", Ecosystem="Forest", Region="c" } r2.addPaletteElement("palette.entities.creatures.cpcfc7", entries.creature_cpcfc7)


-- Named Degens
	entries.creature_cdbfe7 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdbfe7.creature", Level=199, RingAccess="f7", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.cdbfe7", entries.creature_cdbfe7)
	entries.creature_cdbje7 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdbje7.creature", Level=199, RingAccess="j7", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.cdbje7", entries.creature_cdbje7)
	entries.creature_cdale7 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdale7.creature", Level=199, RingAccess="l6", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.cdale7", entries.creature_cdale7)
	entries.creature_cdcde5 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdcde5.creature", Level=198, RingAccess="d7", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.cdcde5", entries.creature_cdcde5)
	entries.creature_cdbfe5 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdbfe5.creature", Level=198, RingAccess="f7", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.cdbfe5", entries.creature_cdbfe5)
	entries.creature_cdbje5 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdbje5.creature", Level=198, RingAccess="j7", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.cdbje5", entries.creature_cdbje5)
	entries.creature_cdcdd7 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdcdd7.creature", Level=149, RingAccess="d5", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.cdcdd7", entries.creature_cdcdd7)
	entries.creature_cdapd7 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdapd7.creature", Level=149, RingAccess="p2", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.cdapd7", entries.creature_cdapd7)
	entries.creature_cdcdd5 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdcdd5.creature", Level=148, RingAccess="d5", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.cdcdd5", entries.creature_cdcdd5)
	entries.creature_cdapd5 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdapd5.creature", Level=148, RingAccess="p2", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.cdapd5", entries.creature_cdapd5)
	entries.creature_cdalc5 = { Class="Npc", Base="palette.entities.creatures.degen", SheetClient="cdalc5.creature", Level=98, RingAccess="l5", Ecosystem="Lacustre", Region="c" } r2.addPaletteElement("palette.entities.creatures.cdalc5", entries.creature_cdalc5)


-- Named Kitins
	entries.creature_ckddf7 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckddf7.creature", Level=249, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckddf7", entries.creature_ckddf7)
	entries.creature_ckhdf7 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckhdf7.creature", Level=249, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckhdf7", entries.creature_ckhdf7)
	entries.creature_ckiff7 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckiff7.creature", Level=249, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckiff7", entries.creature_ckiff7)
	entries.creature_ckfjf7 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfjf7.creature", Level=249, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckfjf7", entries.creature_ckfjf7)
	entries.creature_ckglf7 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckglf7.creature", Level=249, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckglf7", entries.creature_ckglf7)
	entries.creature_ckdpf7 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdpf7.creature", Level=249, RingAccess="p13", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckdpf7", entries.creature_ckdpf7)
	entries.creature_ckfpf7 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfpf7.creature", Level=249, RingAccess="p13", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckfpf7", entries.creature_ckfpf7)
	entries.creature_ckipf7 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckipf7.creature", Level=249, RingAccess="p13", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckipf7", entries.creature_ckipf7)
	entries.creature_ckepf7 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckepf7.creature", Level=249, RingAccess="p13", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckepf7", entries.creature_ckepf7)
	entries.creature_ckgpf7 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckgpf7.creature", Level=249, RingAccess="p13", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckgpf7", entries.creature_ckgpf7)
	entries.creature_ckbpf7 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbpf7.creature", Level=249, RingAccess="p13", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckbpf7", entries.creature_ckbpf7)
	entries.creature_ckjpf7 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjpf7.creature", Level=249, RingAccess="p13", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckjpf7", entries.creature_ckjpf7)
	entries.creature_ckfdf5 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfdf5.creature", Level=248, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckfdf5", entries.creature_ckfdf5)
	entries.creature_ckedf5 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckedf5.creature", Level=248, RingAccess="d7", Ecosystem="Desert", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckedf5", entries.creature_ckedf5)
	entries.creature_ckgff5 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckgff5.creature", Level=248, RingAccess="f7", Ecosystem="Forest", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckgff5", entries.creature_ckgff5)
	entries.creature_ckdjf5 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdjf5.creature", Level=248, RingAccess="j7", Ecosystem="Jungle", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckdjf5", entries.creature_ckdjf5)
	entries.creature_ckdlf5 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdlf5.creature", Level=248, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckdlf5", entries.creature_ckdlf5)
	entries.creature_ckglf5 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckglf5.creature", Level=248, RingAccess="l6", Ecosystem="Lacustre", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckglf5", entries.creature_ckglf5)
	entries.creature_ckhpf5 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckhpf5.creature", Level=248, RingAccess="p13", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckhpf5", entries.creature_ckhpf5)
	entries.creature_ckgpf5 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckgpf5.creature", Level=248, RingAccess="p13", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckgpf5", entries.creature_ckgpf5)
	entries.creature_ckepf5 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckepf5.creature", Level=248, RingAccess="p13", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckepf5", entries.creature_ckepf5)
	entries.creature_ckjpf5 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjpf5.creature", Level=248, RingAccess="p13", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckjpf5", entries.creature_ckjpf5)
	entries.creature_ckipf5 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckipf5.creature", Level=248, RingAccess="p13", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckipf5", entries.creature_ckipf5)
	entries.creature_ckfpf5 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfpf5.creature", Level=248, RingAccess="p13", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckfpf5", entries.creature_ckfpf5)
	entries.creature_ckdpf5 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdpf5.creature", Level=248, RingAccess="p13", Ecosystem="PrimeRoots", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckdpf5", entries.creature_ckdpf5)
	entries.creature_ckede7 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckede7.creature", Level=199, RingAccess="d7", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckede7", entries.creature_ckede7)
	entries.creature_ckjde7 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjde7.creature", Level=199, RingAccess="d7", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckjde7", entries.creature_ckjde7)
	entries.creature_ckdfe7 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdfe7.creature", Level=199, RingAccess="f7", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckdfe7", entries.creature_ckdfe7)
	entries.creature_ckdje7 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdje7.creature", Level=199, RingAccess="j7", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckdje7", entries.creature_ckdje7)
	entries.creature_ckeje7 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckeje7.creature", Level=199, RingAccess="j7", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckeje7", entries.creature_ckeje7)
	entries.creature_ckfje7 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfje7.creature", Level=199, RingAccess="j7", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckfje7", entries.creature_ckfje7)
	entries.creature_ckele7 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckele7.creature", Level=199, RingAccess="l6", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckele7", entries.creature_ckele7)
	entries.creature_ckhpe7 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckhpe7.creature", Level=199, RingAccess="p9", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckhpe7", entries.creature_ckhpe7)
	entries.creature_ckfpe7 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfpe7.creature", Level=199, RingAccess="p9", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckfpe7", entries.creature_ckfpe7)
	entries.creature_ckape7 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckape7.creature", Level=199, RingAccess="p9", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckape7", entries.creature_ckape7)
	entries.creature_ckhde5 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckhde5.creature", Level=198, RingAccess="d7", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckhde5", entries.creature_ckhde5)
	entries.creature_ckdde5 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdde5.creature", Level=198, RingAccess="d7", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckdde5", entries.creature_ckdde5)
	entries.creature_ckede5 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckede5.creature", Level=198, RingAccess="d7", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckede5", entries.creature_ckede5)
	entries.creature_ckide5 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckide5.creature", Level=198, RingAccess="d7", Ecosystem="Desert", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckide5", entries.creature_ckide5)
	entries.creature_ckefe5 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckefe5.creature", Level=198, RingAccess="f7", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckefe5", entries.creature_ckefe5)
	entries.creature_ckffe5 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckffe5.creature", Level=198, RingAccess="f7", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckffe5", entries.creature_ckffe5)
	entries.creature_ckdfe5 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdfe5.creature", Level=198, RingAccess="f7", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckdfe5", entries.creature_ckdfe5)
	entries.creature_ckgfe5 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckgfe5.creature", Level=198, RingAccess="f7", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckgfe5", entries.creature_ckgfe5)
	entries.creature_ckhfe5 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckhfe5.creature", Level=198, RingAccess="f7", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckhfe5", entries.creature_ckhfe5)
	entries.creature_ckife5 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckife5.creature", Level=198, RingAccess="f7", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckife5", entries.creature_ckife5)
	entries.creature_ckjfe5 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjfe5.creature", Level=198, RingAccess="f7", Ecosystem="Forest", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckjfe5", entries.creature_ckjfe5)
	entries.creature_ckeje5 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckeje5.creature", Level=198, RingAccess="j7", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckeje5", entries.creature_ckeje5)
	entries.creature_ckfje5 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfje5.creature", Level=198, RingAccess="j7", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckfje5", entries.creature_ckfje5)
	entries.creature_ckije5 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckije5.creature", Level=198, RingAccess="j7", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckije5", entries.creature_ckije5)
--	entries.creature_ckdje5 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdje5.creature", Level=198, RingAccess="j7", Ecosystem="Jungle", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckdje5", entries.creature_ckdje5)
	entries.creature_ckgle5 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckgle5.creature", Level=198, RingAccess="l6", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckgle5", entries.creature_ckgle5)
	entries.creature_ckhle5 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckhle5.creature", Level=198, RingAccess="l6", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckhle5", entries.creature_ckhle5)
	entries.creature_ckdle5 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdle5.creature", Level=198, RingAccess="l6", Ecosystem="Lacustre", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckdle5", entries.creature_ckdle5)
	entries.creature_ckepe5 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckepe5.creature", Level=198, RingAccess="p9", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckepe5", entries.creature_ckepe5)
	entries.creature_ckdpe5 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdpe5.creature", Level=198, RingAccess="p9", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckdpe5", entries.creature_ckdpe5)
	entries.creature_ckipe5 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckipe5.creature", Level=198, RingAccess="p9", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckipe5", entries.creature_ckipe5)
	entries.creature_ckfpe5 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfpe5.creature", Level=198, RingAccess="p9", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckfpe5", entries.creature_ckfpe5)
	entries.creature_ckgpe5 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckgpe5.creature", Level=198, RingAccess="p9", Ecosystem="PrimeRoots", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckgpe5", entries.creature_ckgpe5)
	entries.creature_ckhdd7 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckhdd7.creature", Level=149, RingAccess="d5", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckhdd7", entries.creature_ckhdd7)
	entries.creature_ckhfd7 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckhfd7.creature", Level=149, RingAccess="f6", Ecosystem="Forest", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckhfd7", entries.creature_ckhfd7)
	entries.creature_ckdjd7 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdjd7.creature", Level=149, RingAccess="j6", Ecosystem="Jungle", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckdjd7", entries.creature_ckdjd7)
	entries.creature_ckdld7 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdld7.creature", Level=149, RingAccess="l5", Ecosystem="Lacustre", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckdld7", entries.creature_ckdld7)
	entries.creature_ckjld7 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjld7.creature", Level=149, RingAccess="l5", Ecosystem="Lacustre", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckjld7", entries.creature_ckjld7)

	entries.creature_ckdpd7 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdpd7.creature", Level=149, RingAccess="p2", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckdpd7", entries.creature_ckdpd7)
	entries.creature_ckhdd5 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckhdd5.creature", Level=148, RingAccess="d5", Ecosystem="Desert", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckhdd5", entries.creature_ckhdd5)
	entries.creature_ckjpd5 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjpd5.creature", Level=148, RingAccess="p2", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckjpd5", entries.creature_ckjpd5)
	entries.creature_ckhpd5 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckhpd5.creature", Level=148, RingAccess="p2", Ecosystem="PrimeRoots", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckhpd5", entries.creature_ckhpd5)
	entries.creature_ckijc5 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckijc5.creature", Level=98, RingAccess="j5", Ecosystem="Jungle", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckijc5", entries.creature_ckijc5)


-- Invasion Kitins
	entries.creature_ckgif4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckgif4.creature", Level=240, RingAccess="p10", Ecosystem="", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckgif4", entries.creature_ckgif4)
	entries.creature_ckaif4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckaif4.creature", Level=240, RingAccess="p10", Ecosystem="", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckaif4", entries.creature_ckaif4)
	entries.creature_ckdif4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdif4.creature", Level=240, RingAccess="p10", Ecosystem="", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckdif4", entries.creature_ckdif4)
	entries.creature_ckbif4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbif4.creature", Level=240, RingAccess="p10", Ecosystem="", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckbif4", entries.creature_ckbif4)
	entries.creature_ckhif4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckhif4.creature", Level=240, RingAccess="p10", Ecosystem="", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckhif4", entries.creature_ckhif4)
	entries.creature_ckjif4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjif4.creature", Level=240, RingAccess="p10", Ecosystem="", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckjif4", entries.creature_ckjif4)
	entries.creature_ckeif4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckeif4.creature", Level=240, RingAccess="p10", Ecosystem="", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckeif4", entries.creature_ckeif4)
	entries.creature_ckfif4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfif4.creature", Level=240, RingAccess="p10", Ecosystem="", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckfif4", entries.creature_ckfif4)
	entries.creature_ckcif4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcif4.creature", Level=240, RingAccess="p10", Ecosystem="", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckcif4", entries.creature_ckcif4)
	entries.creature_ckiif4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckiif4.creature", Level=240, RingAccess="p10", Ecosystem="", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckiif4", entries.creature_ckiif4)
	entries.creature_ckfrf4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfrf4.creature", Level=240, RingAccess="p10", Ecosystem="", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckfrf4", entries.creature_ckfrf4)
	entries.creature_ckgif3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckgif3.creature", Level=230, RingAccess="p10", Ecosystem="", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckgif3", entries.creature_ckgif3)
	entries.creature_ckaif3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckaif3.creature", Level=230, RingAccess="p10", Ecosystem="", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckaif3", entries.creature_ckaif3)
	entries.creature_ckdif3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdif3.creature", Level=230, RingAccess="p10", Ecosystem="", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckdif3", entries.creature_ckdif3)
	entries.creature_ckbif3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbif3.creature", Level=230, RingAccess="p10", Ecosystem="", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckbif3", entries.creature_ckbif3)
	entries.creature_ckhif3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckhif3.creature", Level=230, RingAccess="p10", Ecosystem="", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckhif3", entries.creature_ckhif3)
	entries.creature_ckjif3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjif3.creature", Level=230, RingAccess="p10", Ecosystem="", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckjif3", entries.creature_ckjif3)
	entries.creature_ckeif3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckeif3.creature", Level=230, RingAccess="p10", Ecosystem="", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckeif3", entries.creature_ckeif3)
	entries.creature_ckfif3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfif3.creature", Level=230, RingAccess="p10", Ecosystem="", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckfif3", entries.creature_ckfif3)
	entries.creature_ckcif3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcif3.creature", Level=230, RingAccess="p10", Ecosystem="", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckcif3", entries.creature_ckcif3)
	entries.creature_ckiif3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckiif3.creature", Level=230, RingAccess="p10", Ecosystem="", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckiif3", entries.creature_ckiif3)
	entries.creature_ckfrf3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfrf3.creature", Level=230, RingAccess="p10", Ecosystem="", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckfrf3", entries.creature_ckfrf3)
	entries.creature_ckgif2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckgif2.creature", Level=220, RingAccess="p10", Ecosystem="", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckgif2", entries.creature_ckgif2)
	entries.creature_ckaif2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckaif2.creature", Level=220, RingAccess="p10", Ecosystem="", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckaif2", entries.creature_ckaif2)
	entries.creature_ckdif2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdif2.creature", Level=220, RingAccess="p10", Ecosystem="", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckdif2", entries.creature_ckdif2)
	entries.creature_ckbif2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbif2.creature", Level=220, RingAccess="p10", Ecosystem="", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckbif2", entries.creature_ckbif2)
	entries.creature_ckhif2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckhif2.creature", Level=220, RingAccess="p10", Ecosystem="", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckhif2", entries.creature_ckhif2)
	entries.creature_ckjif2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjif2.creature", Level=220, RingAccess="p10", Ecosystem="", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckjif2", entries.creature_ckjif2)
	entries.creature_ckeif2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckeif2.creature", Level=220, RingAccess="p10", Ecosystem="", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckeif2", entries.creature_ckeif2)
	entries.creature_ckfif2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfif2.creature", Level=220, RingAccess="p10", Ecosystem="", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckfif2", entries.creature_ckfif2)
	entries.creature_ckcif2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcif2.creature", Level=220, RingAccess="p10", Ecosystem="", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckcif2", entries.creature_ckcif2)

	entries.creature_ckiif2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckiif2.creature", Level=220, RingAccess="p10", Ecosystem="", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckiif2", entries.creature_ckiif2)
	entries.creature_ckfrf2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfrf2.creature", Level=220, RingAccess="p10", Ecosystem="", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckfrf2", entries.creature_ckfrf2)
	entries.creature_ckgif1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckgif1.creature", Level=210, RingAccess="p10", Ecosystem="", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckgif1", entries.creature_ckgif1)
	entries.creature_ckaif1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckaif1.creature", Level=210, RingAccess="p10", Ecosystem="", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckaif1", entries.creature_ckaif1)
	entries.creature_ckdif1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdif1.creature", Level=210, RingAccess="p10", Ecosystem="", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckdif1", entries.creature_ckdif1)
	entries.creature_ckbif1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbif1.creature", Level=210, RingAccess="p10", Ecosystem="", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckbif1", entries.creature_ckbif1)
	entries.creature_ckhif1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckhif1.creature", Level=210, RingAccess="p10", Ecosystem="", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckhif1", entries.creature_ckhif1)
	entries.creature_ckjif1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjif1.creature", Level=210, RingAccess="p10", Ecosystem="", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckjif1", entries.creature_ckjif1)
	entries.creature_ckeif1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckeif1.creature", Level=210, RingAccess="p10", Ecosystem="", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckeif1", entries.creature_ckeif1)
	entries.creature_ckfif1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfif1.creature", Level=210, RingAccess="p10", Ecosystem="", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckfif1", entries.creature_ckfif1)
	entries.creature_ckcif1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcif1.creature", Level=210, RingAccess="p10", Ecosystem="", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckcif1", entries.creature_ckcif1)
	entries.creature_ckiif1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckiif1.creature", Level=210, RingAccess="p10", Ecosystem="", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckiif1", entries.creature_ckiif1)
	entries.creature_ckfrf1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfrf1.creature", Level=210, RingAccess="p10", Ecosystem="", Region="f" } r2.addPaletteElement("palette.entities.creatures.ckfrf1", entries.creature_ckfrf1)
	entries.creature_ckgie4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckgie4.creature", Level=190, RingAccess="p4", Ecosystem="", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckgie4", entries.creature_ckgie4)
	entries.creature_ckaie4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckaie4.creature", Level=190, RingAccess="p4", Ecosystem="", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckaie4", entries.creature_ckaie4)
	entries.creature_ckdie4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdie4.creature", Level=190, RingAccess="p4", Ecosystem="", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckdie4", entries.creature_ckdie4)
	entries.creature_ckbie4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbie4.creature", Level=190, RingAccess="p4", Ecosystem="", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckbie4", entries.creature_ckbie4)
	entries.creature_ckhie4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckhie4.creature", Level=190, RingAccess="p4", Ecosystem="", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckhie4", entries.creature_ckhie4)
	entries.creature_ckjie4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjie4.creature", Level=190, RingAccess="p4", Ecosystem="", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckjie4", entries.creature_ckjie4)
	entries.creature_ckeie4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckeie4.creature", Level=190, RingAccess="p4", Ecosystem="", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckeie4", entries.creature_ckeie4)
	entries.creature_ckfie4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfie4.creature", Level=190, RingAccess="p4", Ecosystem="", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckfie4", entries.creature_ckfie4)
	entries.creature_ckcie4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcie4.creature", Level=190, RingAccess="p4", Ecosystem="", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckcie4", entries.creature_ckcie4)
	entries.creature_ckiie4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckiie4.creature", Level=190, RingAccess="p4", Ecosystem="", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckiie4", entries.creature_ckiie4)
	entries.creature_ckfre4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfre4.creature", Level=190, RingAccess="p4", Ecosystem="", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckfre4", entries.creature_ckfre4)
	entries.creature_ckgie3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckgie3.creature", Level=180, RingAccess="p4", Ecosystem="", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckgie3", entries.creature_ckgie3)
	entries.creature_ckaie3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckaie3.creature", Level=180, RingAccess="p4", Ecosystem="", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckaie3", entries.creature_ckaie3)
	entries.creature_ckdie3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdie3.creature", Level=180, RingAccess="p4", Ecosystem="", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckdie3", entries.creature_ckdie3)
	entries.creature_ckbie3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbie3.creature", Level=180, RingAccess="p4", Ecosystem="", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckbie3", entries.creature_ckbie3)
	entries.creature_ckhie3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckhie3.creature", Level=180, RingAccess="p4", Ecosystem="", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckhie3", entries.creature_ckhie3)
	entries.creature_ckjie3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjie3.creature", Level=180, RingAccess="p4", Ecosystem="", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckjie3", entries.creature_ckjie3)
	entries.creature_ckeie3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckeie3.creature", Level=180, RingAccess="p4", Ecosystem="", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckeie3", entries.creature_ckeie3)
	entries.creature_ckfie3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfie3.creature", Level=180, RingAccess="p4", Ecosystem="", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckfie3", entries.creature_ckfie3)
	entries.creature_ckcie3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcie3.creature", Level=180, RingAccess="p4", Ecosystem="", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckcie3", entries.creature_ckcie3)
	entries.creature_ckiie3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckiie3.creature", Level=180, RingAccess="p4", Ecosystem="", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckiie3", entries.creature_ckiie3)
	entries.creature_ckfre3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfre3.creature", Level=180, RingAccess="p4", Ecosystem="", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckfre3", entries.creature_ckfre3)
	entries.creature_ckgie2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckgie2.creature", Level=170, RingAccess="p4", Ecosystem="", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckgie2", entries.creature_ckgie2)
	entries.creature_ckaie2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckaie2.creature", Level=170, RingAccess="p4", Ecosystem="", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckaie2", entries.creature_ckaie2)
	entries.creature_ckdie2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdie2.creature", Level=170, RingAccess="p4", Ecosystem="", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckdie2", entries.creature_ckdie2)
	entries.creature_ckbie2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbie2.creature", Level=170, RingAccess="p4", Ecosystem="", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckbie2", entries.creature_ckbie2)
	entries.creature_ckhie2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckhie2.creature", Level=170, RingAccess="p4", Ecosystem="", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckhie2", entries.creature_ckhie2)
	entries.creature_ckjie2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjie2.creature", Level=170, RingAccess="p4", Ecosystem="", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckjie2", entries.creature_ckjie2)
	entries.creature_ckeie2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckeie2.creature", Level=170, RingAccess="p4", Ecosystem="", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckeie2", entries.creature_ckeie2)
	entries.creature_ckfie2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfie2.creature", Level=170, RingAccess="p4", Ecosystem="", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckfie2", entries.creature_ckfie2)
	entries.creature_ckcie2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcie2.creature", Level=170, RingAccess="p4", Ecosystem="", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckcie2", entries.creature_ckcie2)
	entries.creature_ckiie2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckiie2.creature", Level=170, RingAccess="p4", Ecosystem="", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckiie2", entries.creature_ckiie2)
	entries.creature_ckfre2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfre2.creature", Level=170, RingAccess="p4", Ecosystem="", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckfre2", entries.creature_ckfre2)
	entries.creature_ckgie1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckgie1.creature", Level=160, RingAccess="p4", Ecosystem="", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckgie1", entries.creature_ckgie1)
	entries.creature_ckaie1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckaie1.creature", Level=160, RingAccess="p4", Ecosystem="", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckaie1", entries.creature_ckaie1)
	entries.creature_ckdie1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdie1.creature", Level=160, RingAccess="p4", Ecosystem="", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckdie1", entries.creature_ckdie1)
	entries.creature_ckbie1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbie1.creature", Level=160, RingAccess="p4", Ecosystem="", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckbie1", entries.creature_ckbie1)
	entries.creature_ckhie1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckhie1.creature", Level=160, RingAccess="p4", Ecosystem="", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckhie1", entries.creature_ckhie1)
	entries.creature_ckjie1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjie1.creature", Level=160, RingAccess="p4", Ecosystem="", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckjie1", entries.creature_ckjie1)
	entries.creature_ckeie1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckeie1.creature", Level=160, RingAccess="p4", Ecosystem="", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckeie1", entries.creature_ckeie1)
	entries.creature_ckfie1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfie1.creature", Level=160, RingAccess="p4", Ecosystem="", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckfie1", entries.creature_ckfie1)
	entries.creature_ckcie1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcie1.creature", Level=160, RingAccess="p4", Ecosystem="", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckcie1", entries.creature_ckcie1)
	entries.creature_ckiie1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckiie1.creature", Level=160, RingAccess="p4", Ecosystem="", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckiie1", entries.creature_ckiie1)
	entries.creature_ckfre1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfre1.creature", Level=160, RingAccess="p4", Ecosystem="", Region="e" } r2.addPaletteElement("palette.entities.creatures.ckfre1", entries.creature_ckfre1)
	entries.creature_ckgid4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckgid4.creature", Level=140, RingAccess="p1", Ecosystem="", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckgid4", entries.creature_ckgid4)
	entries.creature_ckaid4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckaid4.creature", Level=140, RingAccess="p1", Ecosystem="", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckaid4", entries.creature_ckaid4)
	entries.creature_ckdid4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdid4.creature", Level=140, RingAccess="p1", Ecosystem="", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckdid4", entries.creature_ckdid4)
	entries.creature_ckbid4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbid4.creature", Level=140, RingAccess="p1", Ecosystem="", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckbid4", entries.creature_ckbid4)
	entries.creature_ckhid4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckhid4.creature", Level=140, RingAccess="p1", Ecosystem="", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckhid4", entries.creature_ckhid4)
	entries.creature_ckjid4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjid4.creature", Level=140, RingAccess="p1", Ecosystem="", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckjid4", entries.creature_ckjid4)
	entries.creature_ckeid4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckeid4.creature", Level=140, RingAccess="p1", Ecosystem="", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckeid4", entries.creature_ckeid4)
	entries.creature_ckfid4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfid4.creature", Level=140, RingAccess="p1", Ecosystem="", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckfid4", entries.creature_ckfid4)
	entries.creature_ckcid4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcid4.creature", Level=140, RingAccess="p1", Ecosystem="", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckcid4", entries.creature_ckcid4)
	entries.creature_ckiid4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckiid4.creature", Level=140, RingAccess="p1", Ecosystem="", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckiid4", entries.creature_ckiid4)
	entries.creature_ckfrd4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfrd4.creature", Level=140, RingAccess="p1", Ecosystem="", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckfrd4", entries.creature_ckfrd4)
	entries.creature_ckgid3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckgid3.creature", Level=130, RingAccess="p1", Ecosystem="", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckgid3", entries.creature_ckgid3)
	entries.creature_ckaid3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckaid3.creature", Level=130, RingAccess="p1", Ecosystem="", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckaid3", entries.creature_ckaid3)
	entries.creature_ckdid3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdid3.creature", Level=130, RingAccess="p1", Ecosystem="", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckdid3", entries.creature_ckdid3)
	entries.creature_ckbid3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbid3.creature", Level=130, RingAccess="p1", Ecosystem="", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckbid3", entries.creature_ckbid3)
	entries.creature_ckhid3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckhid3.creature", Level=130, RingAccess="p1", Ecosystem="", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckhid3", entries.creature_ckhid3)
	entries.creature_ckjid3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjid3.creature", Level=130, RingAccess="p1", Ecosystem="", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckjid3", entries.creature_ckjid3)
	entries.creature_ckeid3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckeid3.creature", Level=130, RingAccess="p1", Ecosystem="", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckeid3", entries.creature_ckeid3)
	entries.creature_ckfid3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfid3.creature", Level=130, RingAccess="p1", Ecosystem="", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckfid3", entries.creature_ckfid3)
	entries.creature_ckcid3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcid3.creature", Level=130, RingAccess="p1", Ecosystem="", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckcid3", entries.creature_ckcid3)
	entries.creature_ckiid3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckiid3.creature", Level=130, RingAccess="p1", Ecosystem="", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckiid3", entries.creature_ckiid3)
	entries.creature_ckfrd3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfrd3.creature", Level=130, RingAccess="p1", Ecosystem="", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckfrd3", entries.creature_ckfrd3)
	entries.creature_ckgid2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckgid2.creature", Level=120, RingAccess="p1", Ecosystem="", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckgid2", entries.creature_ckgid2)
	entries.creature_ckaid2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckaid2.creature", Level=120, RingAccess="p1", Ecosystem="", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckaid2", entries.creature_ckaid2)
	entries.creature_ckdid2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdid2.creature", Level=120, RingAccess="p1", Ecosystem="", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckdid2", entries.creature_ckdid2)
	entries.creature_ckbid2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbid2.creature", Level=120, RingAccess="p1", Ecosystem="", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckbid2", entries.creature_ckbid2)
	entries.creature_ckhid2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckhid2.creature", Level=120, RingAccess="p1", Ecosystem="", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckhid2", entries.creature_ckhid2)
	entries.creature_ckjid2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjid2.creature", Level=120, RingAccess="p1", Ecosystem="", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckjid2", entries.creature_ckjid2)
	entries.creature_ckeid2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckeid2.creature", Level=120, RingAccess="p1", Ecosystem="", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckeid2", entries.creature_ckeid2)
	entries.creature_ckfid2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfid2.creature", Level=120, RingAccess="p1", Ecosystem="", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckfid2", entries.creature_ckfid2)
	entries.creature_ckcid2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcid2.creature", Level=120, RingAccess="p1", Ecosystem="", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckcid2", entries.creature_ckcid2)
	entries.creature_ckiid2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckiid2.creature", Level=120, RingAccess="p1", Ecosystem="", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckiid2", entries.creature_ckiid2)
	entries.creature_ckfrd2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfrd2.creature", Level=120, RingAccess="p1", Ecosystem="", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckfrd2", entries.creature_ckfrd2)
	entries.creature_ckgid1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckgid1.creature", Level=110, RingAccess="p1", Ecosystem="", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckgid1", entries.creature_ckgid1)
	entries.creature_ckaid1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckaid1.creature", Level=110, RingAccess="p1", Ecosystem="", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckaid1", entries.creature_ckaid1)
	entries.creature_ckdid1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdid1.creature", Level=110, RingAccess="p1", Ecosystem="", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckdid1", entries.creature_ckdid1)
	entries.creature_ckbid1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbid1.creature", Level=110, RingAccess="p1", Ecosystem="", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckbid1", entries.creature_ckbid1)
	entries.creature_ckhid1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckhid1.creature", Level=110, RingAccess="p1", Ecosystem="", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckhid1", entries.creature_ckhid1)
	entries.creature_ckjid1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjid1.creature", Level=110, RingAccess="p1", Ecosystem="", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckjid1", entries.creature_ckjid1)
	entries.creature_ckeid1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckeid1.creature", Level=110, RingAccess="p1", Ecosystem="", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckeid1", entries.creature_ckeid1)
	entries.creature_ckfid1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfid1.creature", Level=110, RingAccess="p1", Ecosystem="", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckfid1", entries.creature_ckfid1)
	entries.creature_ckcid1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcid1.creature", Level=110, RingAccess="p1", Ecosystem="", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckcid1", entries.creature_ckcid1)
	entries.creature_ckiid1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckiid1.creature", Level=110, RingAccess="p1", Ecosystem="", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckiid1", entries.creature_ckiid1)
	entries.creature_ckfrd1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfrd1.creature", Level=110, RingAccess="p1", Ecosystem="", Region="d" } r2.addPaletteElement("palette.entities.creatures.ckfrd1", entries.creature_ckfrd1)
	entries.creature_ckgic4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckgic4.creature", Level=90, RingAccess="p1", Ecosystem="", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckgic4", entries.creature_ckgic4)
	entries.creature_ckaic4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckaic4.creature", Level=90, RingAccess="p1", Ecosystem="", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckaic4", entries.creature_ckaic4)
	entries.creature_ckdic4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdic4.creature", Level=90, RingAccess="p1", Ecosystem="", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckdic4", entries.creature_ckdic4)
	entries.creature_ckbic4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbic4.creature", Level=90, RingAccess="p1", Ecosystem="", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckbic4", entries.creature_ckbic4)
	entries.creature_ckhic4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckhic4.creature", Level=90, RingAccess="p1", Ecosystem="", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckhic4", entries.creature_ckhic4)
	entries.creature_ckjic4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjic4.creature", Level=90, RingAccess="p1", Ecosystem="", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckjic4", entries.creature_ckjic4)
	entries.creature_ckeic4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckeic4.creature", Level=90, RingAccess="p1", Ecosystem="", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckeic4", entries.creature_ckeic4)
	entries.creature_ckfic4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfic4.creature", Level=90, RingAccess="p1", Ecosystem="", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckfic4", entries.creature_ckfic4)
	entries.creature_ckcic4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcic4.creature", Level=90, RingAccess="p1", Ecosystem="", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckcic4", entries.creature_ckcic4)
	entries.creature_ckiic4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckiic4.creature", Level=90, RingAccess="p1", Ecosystem="", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckiic4", entries.creature_ckiic4)
	entries.creature_ckfrc4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfrc4.creature", Level=90, RingAccess="p1", Ecosystem="", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckfrc4", entries.creature_ckfrc4)
	entries.creature_ckgic3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckgic3.creature", Level=80, RingAccess="p1", Ecosystem="", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckgic3", entries.creature_ckgic3)
	entries.creature_ckaic3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckaic3.creature", Level=80, RingAccess="p1", Ecosystem="", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckaic3", entries.creature_ckaic3)
	entries.creature_ckdic3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdic3.creature", Level=80, RingAccess="p1", Ecosystem="", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckdic3", entries.creature_ckdic3)
	entries.creature_ckbic3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbic3.creature", Level=80, RingAccess="p1", Ecosystem="", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckbic3", entries.creature_ckbic3)
	entries.creature_ckhic3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckhic3.creature", Level=80, RingAccess="p1", Ecosystem="", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckhic3", entries.creature_ckhic3)
	entries.creature_ckjic3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjic3.creature", Level=80, RingAccess="p1", Ecosystem="", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckjic3", entries.creature_ckjic3)
	entries.creature_ckeic3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckeic3.creature", Level=80, RingAccess="p1", Ecosystem="", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckeic3", entries.creature_ckeic3)
	entries.creature_ckfic3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfic3.creature", Level=80, RingAccess="p1", Ecosystem="", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckfic3", entries.creature_ckfic3)
	entries.creature_ckcic3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcic3.creature", Level=80, RingAccess="p1", Ecosystem="", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckcic3", entries.creature_ckcic3)
	entries.creature_ckiic3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckiic3.creature", Level=80, RingAccess="p1", Ecosystem="", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckiic3", entries.creature_ckiic3)
	entries.creature_ckfrc3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfrc3.creature", Level=80, RingAccess="p1", Ecosystem="", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckfrc3", entries.creature_ckfrc3)
	entries.creature_ckgic2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckgic2.creature", Level=70, RingAccess="p1", Ecosystem="", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckgic2", entries.creature_ckgic2)
	entries.creature_ckaic2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckaic2.creature", Level=70, RingAccess="p1", Ecosystem="", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckaic2", entries.creature_ckaic2)
	entries.creature_ckdic2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdic2.creature", Level=70, RingAccess="p1", Ecosystem="", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckdic2", entries.creature_ckdic2)
	entries.creature_ckbic2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbic2.creature", Level=70, RingAccess="p1", Ecosystem="", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckbic2", entries.creature_ckbic2)
	entries.creature_ckhic2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckhic2.creature", Level=70, RingAccess="p1", Ecosystem="", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckhic2", entries.creature_ckhic2)
	entries.creature_ckjic2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjic2.creature", Level=70, RingAccess="p1", Ecosystem="", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckjic2", entries.creature_ckjic2)
	entries.creature_ckeic2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckeic2.creature", Level=70, RingAccess="p1", Ecosystem="", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckeic2", entries.creature_ckeic2)
	entries.creature_ckfic2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfic2.creature", Level=70, RingAccess="p1", Ecosystem="", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckfic2", entries.creature_ckfic2)
	entries.creature_ckcic2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcic2.creature", Level=70, RingAccess="p1", Ecosystem="", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckcic2", entries.creature_ckcic2)
	entries.creature_ckiic2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckiic2.creature", Level=70, RingAccess="p1", Ecosystem="", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckiic2", entries.creature_ckiic2)
	entries.creature_ckfrc2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfrc2.creature", Level=70, RingAccess="p1", Ecosystem="", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckfrc2", entries.creature_ckfrc2)
	entries.creature_ckgic1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckgic1.creature", Level=60, RingAccess="p1", Ecosystem="", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckgic1", entries.creature_ckgic1)
	entries.creature_ckaic1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckaic1.creature", Level=60, RingAccess="p1", Ecosystem="", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckaic1", entries.creature_ckaic1)
	entries.creature_ckdic1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdic1.creature", Level=60, RingAccess="p1", Ecosystem="", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckdic1", entries.creature_ckdic1)
	entries.creature_ckbic1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbic1.creature", Level=60, RingAccess="p1", Ecosystem="", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckbic1", entries.creature_ckbic1)
	entries.creature_ckhic1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckhic1.creature", Level=60, RingAccess="p1", Ecosystem="", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckhic1", entries.creature_ckhic1)
	entries.creature_ckjic1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjic1.creature", Level=60, RingAccess="p1", Ecosystem="", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckjic1", entries.creature_ckjic1)
	entries.creature_ckeic1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckeic1.creature", Level=60, RingAccess="p1", Ecosystem="", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckeic1", entries.creature_ckeic1)
	entries.creature_ckfic1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfic1.creature", Level=60, RingAccess="p1", Ecosystem="", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckfic1", entries.creature_ckfic1)
	entries.creature_ckcic1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcic1.creature", Level=60, RingAccess="p1", Ecosystem="", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckcic1", entries.creature_ckcic1)
	entries.creature_ckiic1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckiic1.creature", Level=60, RingAccess="p1", Ecosystem="", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckiic1", entries.creature_ckiic1)
	entries.creature_ckfrc1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfrc1.creature", Level=60, RingAccess="p1", Ecosystem="", Region="c" } r2.addPaletteElement("palette.entities.creatures.ckfrc1", entries.creature_ckfrc1)
	entries.creature_ckgib4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckgib4.creature", Level=40, RingAccess="p1", Ecosystem="", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckgib4", entries.creature_ckgib4)
	entries.creature_ckaib4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckaib4.creature", Level=40, RingAccess="p1", Ecosystem="", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckaib4", entries.creature_ckaib4)
	entries.creature_ckdib4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdib4.creature", Level=40, RingAccess="p1", Ecosystem="", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckdib4", entries.creature_ckdib4)
	entries.creature_ckbib4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbib4.creature", Level=40, RingAccess="p1", Ecosystem="", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckbib4", entries.creature_ckbib4)
	entries.creature_ckhib4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckhib4.creature", Level=40, RingAccess="p1", Ecosystem="", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckhib4", entries.creature_ckhib4)
	entries.creature_ckjib4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjib4.creature", Level=40, RingAccess="p1", Ecosystem="", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckjib4", entries.creature_ckjib4)
	entries.creature_ckeib4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckeib4.creature", Level=40, RingAccess="p1", Ecosystem="", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckeib4", entries.creature_ckeib4)
	entries.creature_ckfib4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfib4.creature", Level=40, RingAccess="p1", Ecosystem="", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckfib4", entries.creature_ckfib4)
	entries.creature_ckcib4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcib4.creature", Level=40, RingAccess="p1", Ecosystem="", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckcib4", entries.creature_ckcib4)
	entries.creature_ckiib4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckiib4.creature", Level=40, RingAccess="p1", Ecosystem="", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckiib4", entries.creature_ckiib4)
	entries.creature_ckfrb4 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfrb4.creature", Level=40, RingAccess="p1", Ecosystem="", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckfrb4", entries.creature_ckfrb4)
	entries.creature_ckgib3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckgib3.creature", Level=30, RingAccess="p1", Ecosystem="", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckgib3", entries.creature_ckgib3)
	entries.creature_ckaib3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckaib3.creature", Level=30, RingAccess="p1", Ecosystem="", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckaib3", entries.creature_ckaib3)
	entries.creature_ckdib3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdib3.creature", Level=30, RingAccess="p1", Ecosystem="", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckdib3", entries.creature_ckdib3)
	entries.creature_ckbib3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbib3.creature", Level=30, RingAccess="p1", Ecosystem="", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckbib3", entries.creature_ckbib3)
	entries.creature_ckhib3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckhib3.creature", Level=30, RingAccess="p1", Ecosystem="", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckhib3", entries.creature_ckhib3)
	entries.creature_ckjib3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjib3.creature", Level=30, RingAccess="p1", Ecosystem="", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckjib3", entries.creature_ckjib3)
	entries.creature_ckeib3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckeib3.creature", Level=30, RingAccess="p1", Ecosystem="", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckeib3", entries.creature_ckeib3)
	entries.creature_ckfib3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfib3.creature", Level=30, RingAccess="p1", Ecosystem="", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckfib3", entries.creature_ckfib3)
	entries.creature_ckcib3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcib3.creature", Level=30, RingAccess="p1", Ecosystem="", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckcib3", entries.creature_ckcib3)
	entries.creature_ckiib3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckiib3.creature", Level=30, RingAccess="p1", Ecosystem="", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckiib3", entries.creature_ckiib3)
	entries.creature_ckfrb3 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfrb3.creature", Level=30, RingAccess="p1", Ecosystem="", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckfrb3", entries.creature_ckfrb3)
	entries.creature_ckgib2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckgib2.creature", Level=20, RingAccess="p1", Ecosystem="", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckgib2", entries.creature_ckgib2)
	entries.creature_ckaib2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckaib2.creature", Level=20, RingAccess="p1", Ecosystem="", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckaib2", entries.creature_ckaib2)
	entries.creature_ckdib2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdib2.creature", Level=20, RingAccess="p1", Ecosystem="", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckdib2", entries.creature_ckdib2)
	entries.creature_ckbib2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbib2.creature", Level=20, RingAccess="p1", Ecosystem="", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckbib2", entries.creature_ckbib2)
	entries.creature_ckhib2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckhib2.creature", Level=20, RingAccess="p1", Ecosystem="", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckhib2", entries.creature_ckhib2)
	entries.creature_ckjib2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjib2.creature", Level=20, RingAccess="p1", Ecosystem="", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckjib2", entries.creature_ckjib2)
	entries.creature_ckeib2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckeib2.creature", Level=20, RingAccess="p1", Ecosystem="", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckeib2", entries.creature_ckeib2)
	entries.creature_ckfib2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfib2.creature", Level=20, RingAccess="p1", Ecosystem="", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckfib2", entries.creature_ckfib2)
	entries.creature_ckcib2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcib2.creature", Level=20, RingAccess="p1", Ecosystem="", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckcib2", entries.creature_ckcib2)
	entries.creature_ckiib2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckiib2.creature", Level=20, RingAccess="p1", Ecosystem="", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckiib2", entries.creature_ckiib2)
	entries.creature_ckfrb2 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfrb2.creature", Level=20, RingAccess="p1", Ecosystem="", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckfrb2", entries.creature_ckfrb2)
	entries.creature_ckgib1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckgib1.creature", Level=10, RingAccess="p1", Ecosystem="", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckgib1", entries.creature_ckgib1)
	entries.creature_ckaib1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckaib1.creature", Level=10, RingAccess="p1", Ecosystem="", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckaib1", entries.creature_ckaib1)
	entries.creature_ckdib1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckdib1.creature", Level=10, RingAccess="p1", Ecosystem="", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckdib1", entries.creature_ckdib1)
	entries.creature_ckbib1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckbib1.creature", Level=10, RingAccess="p1", Ecosystem="", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckbib1", entries.creature_ckbib1)
	entries.creature_ckhib1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckhib1.creature", Level=10, RingAccess="p1", Ecosystem="", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckhib1", entries.creature_ckhib1)
	entries.creature_ckjib1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckjib1.creature", Level=10, RingAccess="p1", Ecosystem="", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckjib1", entries.creature_ckjib1)
	entries.creature_ckeib1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckeib1.creature", Level=10, RingAccess="p1", Ecosystem="", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckeib1", entries.creature_ckeib1)
	entries.creature_ckfib1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfib1.creature", Level=10, RingAccess="p1", Ecosystem="", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckfib1", entries.creature_ckfib1)
	entries.creature_ckcib1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckcib1.creature", Level=10, RingAccess="p1", Ecosystem="", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckcib1", entries.creature_ckcib1)
	entries.creature_ckiib1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckiib1.creature", Level=10, RingAccess="p1", Ecosystem="", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckiib1", entries.creature_ckiib1)
	entries.creature_ckfrb1 = { Class="Npc", Base="palette.entities.creatures.kitin", SheetClient="ckfrb1.creature", Level=10, RingAccess="p1", Ecosystem="", Region="b" } r2.addPaletteElement("palette.entities.creatures.ckfrb1", entries.creature_ckfrb1)

end

--debugInfo(colorTag(0, 255, 0) .. "Building palette table")
-- palette hierarchy for the UI
r2.Palette = 
{
	UIPath="ui:interface:r2ed_palette:content:sbtree_entities:entity_enclosing:tree_list",
	BotObjectsUIPath="ui:interface:r2ed_palette:content:sbtree_objects:bot_enclosing:tree_list_objects",
	StrId ="uiR2EDentities",
	Entries = 
	{
		creature =
		{
		--	 Passive Creatures (birds & carnivores)
			creatures_passive =
			{
				instances = 
				{
					{Id="palette.entities.creatures.chdda1", Translation="uiR2EDcreature_chdda1"},
					{Id="palette.entities.creatures.chdda2", Translation="uiR2EDcreature_chdda2"},
					{Id="palette.entities.creatures.chcda1", Translation="uiR2EDcreature_chcda1"},
					{Id="palette.entities.creatures.chcda2", Translation="uiR2EDcreature_chcda2"},
					{Id="palette.entities.creatures.cbbda1", Translation="uiR2EDcreature_cbbda1"},
					{Id="palette.entities.creatures.cbbda2", Translation="uiR2EDcreature_cbbda2"},
					{Id="palette.entities.creatures.cbadc1", Translation="uiR2EDcreature_cbadc1"},
					{Id="palette.entities.creatures.cbadc2", Translation="uiR2EDcreature_cbadc2"},
					{Id="palette.entities.creatures.cbadc3", Translation="uiR2EDcreature_cbadc3"},
					{Id="palette.entities.creatures.cbadc4", Translation="uiR2EDcreature_cbadc4"},
					{Id="palette.entities.creatures.cbadd1", Translation="uiR2EDcreature_cbadd1"},
					{Id="palette.entities.creatures.cbadd2", Translation="uiR2EDcreature_cbadd2"},
					{Id="palette.entities.creatures.cbadd3", Translation="uiR2EDcreature_cbadd3"},
					{Id="palette.entities.creatures.cbadd4", Translation="uiR2EDcreature_cbadd4"},
				--	{id="palette.entities.creatures.cbagb1", translation="uir2edcreature_cbagb1"},
				--	{id="palette.entities.creatures.cbagb2", Translation="uiR2EDcreature_cbagb2"},
				--	{Id="palette.entities.creatures.cbagb3", Translation="uiR2EDcreature_cbagb3"},
				--	{Id="palette.entities.creatures.cbagb4", Translation="uiR2EDcreature_cbagb4"},
				--	{Id="palette.entities.creatures.cbagc1", Translation="uiR2EDcreature_cbagc1"},
				--	{Id="palette.entities.creatures.cbagc2", Translation="uiR2EDcreature_cbagc2"},
				--	{Id="palette.entities.creatures.cbagc3", Translation="uiR2EDcreature_cbagc3"},
				--	{Id="palette.entities.creatures.cbagc4", Translation="uiR2EDcreature_cbagc4"},
				--	{Id="palette.entities.creatures.cbagd1", Translation="uiR2EDcreature_cbagd1"},
				--	{Id="palette.entities.creatures.cbagd2", Translation="uiR2EDcreature_cbagd2"},
				--	{Id="palette.entities.creatures.cbagd3", Translation="uiR2EDcreature_cbagd3"},
				--	{Id="palette.entities.creatures.cbagd4", Translation="uiR2EDcreature_cbagd4"},
				--	{Id="palette.entities.creatures.cbage1", Translation="uiR2EDcreature_cbage1"},
				--	{Id="palette.entities.creatures.cbage2", Translation="uiR2EDcreature_cbage2"},
				--	{Id="palette.entities.creatures.cbage3", Translation="uiR2EDcreature_cbage3"},
				--	{Id="palette.entities.creatures.cbage4", Translation="uiR2EDcreature_cbage4"},
				--	{Id="palette.entities.creatures.cbagf1", Translation="uiR2EDcreature_cbagf1"},
				--	{Id="palette.entities.creatures.cbagf2", Translation="uiR2EDcreature_cbagf2"},
				--	{Id="palette.entities.creatures.cbagf3", Translation="uiR2EDcreature_cbagf3"},
				--	{Id="palette.entities.creatures.cbagf4", Translation="uiR2EDcreature_cbagf4"},
					{Id="palette.entities.creatures.cbajb4", Translation="uiR2EDcreature_cbajb4"},
					{Id="palette.entities.creatures.cbajd1", Translation="uiR2EDcreature_cbajd1"},
					{Id="palette.entities.creatures.cbajd2", Translation="uiR2EDcreature_cbajd2"},
					{Id="palette.entities.creatures.cbajd3", Translation="uiR2EDcreature_cbajd3"},
					{Id="palette.entities.creatures.cbajd4", Translation="uiR2EDcreature_cbajd4"},
					{Id="palette.entities.creatures.cbbdb1", Translation="uiR2EDcreature_cbbdb1"},
					{Id="palette.entities.creatures.cbbdb2", Translation="uiR2EDcreature_cbbdb2"},
					{Id="palette.entities.creatures.cbbdb3", Translation="uiR2EDcreature_cbbdb3"},
					{Id="palette.entities.creatures.cbbdb4", Translation="uiR2EDcreature_cbbdb4"},
					{Id="palette.entities.creatures.cbbdd4", Translation="uiR2EDcreature_cbbdd4"},
					{Id="palette.entities.creatures.cbbja1", Translation="uiR2EDcreature_cbbja1"},
					{Id="palette.entities.creatures.cbbja2", Translation="uiR2EDcreature_cbbja2"},
					{Id="palette.entities.creatures.cbbjb1", Translation="uiR2EDcreature_cbbjb1"},
					{Id="palette.entities.creatures.cbbjb2", Translation="uiR2EDcreature_cbbjb2"},
					{Id="palette.entities.creatures.cbbjb3", Translation="uiR2EDcreature_cbbjb3"},
					{Id="palette.entities.creatures.cbbjb4", Translation="uiR2EDcreature_cbbjb4"},
					{Id="palette.entities.creatures.cbbjc1", Translation="uiR2EDcreature_cbbjc1"},
					{Id="palette.entities.creatures.cbbjc2", Translation="uiR2EDcreature_cbbjc2"},
					{Id="palette.entities.creatures.cbbjc3", Translation="uiR2EDcreature_cbbjc3"},
					{Id="palette.entities.creatures.cbbjc4", Translation="uiR2EDcreature_cbbjc4"},
					{Id="palette.entities.creatures.cbblc1", Translation="uiR2EDcreature_cbblc1"},
					{Id="palette.entities.creatures.cbblc2", Translation="uiR2EDcreature_cbblc2"},
					{Id="palette.entities.creatures.cbblc3", Translation="uiR2EDcreature_cbblc3"},
					{Id="palette.entities.creatures.cbblc4", Translation="uiR2EDcreature_cbblc4"},
					{Id="palette.entities.creatures.cbbld1", Translation="uiR2EDcreature_cbbld1"},
					{Id="palette.entities.creatures.cbbld2", Translation="uiR2EDcreature_cbbld2"},
					{Id="palette.entities.creatures.cbbld3", Translation="uiR2EDcreature_cbbld3"},
					{Id="palette.entities.creatures.cbbld4", Translation="uiR2EDcreature_cbbld4"},
					{Id="palette.entities.creatures.cbbpd1", Translation="uiR2EDcreature_cbbpd1"},
					{Id="palette.entities.creatures.cbbpd2", Translation="uiR2EDcreature_cbbpd2"},
					{Id="palette.entities.creatures.cbbpd3", Translation="uiR2EDcreature_cbbpd3"},
					{Id="palette.entities.creatures.cbbpd4", Translation="uiR2EDcreature_cbbpd4"},
					{Id="palette.entities.creatures.cbbpe4", Translation="uiR2EDcreature_cbbpe4"},
				--	{Id="palette.entities.creatures.cbcgb1", Translation="uiR2EDcreature_cbcgb1"},
				--	{Id="palette.entities.creatures.cbcgb2", Translation="uiR2EDcreature_cbcgb2"},
				--	{Id="palette.entities.creatures.cbcgb3", Translation="uiR2EDcreature_cbcgb3"},
				--	{Id="palette.entities.creatures.cbcgb4", Translation="uiR2EDcreature_cbcgb4"},
				--	{Id="palette.entities.creatures.cbcgc1", Translation="uiR2EDcreature_cbcgc1"},
				--	{Id="palette.entities.creatures.cbcgc2", Translation="uiR2EDcreature_cbcgc2"},
				--	{Id="palette.entities.creatures.cbcgc3", Translation="uiR2EDcreature_cbcgc3"},
				--	{Id="palette.entities.creatures.cbcgc4", Translation="uiR2EDcreature_cbcgc4"},
				--	{Id="palette.entities.creatures.cbcgd1", Translation="uiR2EDcreature_cbcgd1"},
				--	{Id="palette.entities.creatures.cbcgd2", Translation="uiR2EDcreature_cbcgd2"},
				--	{Id="palette.entities.creatures.cbcgd3", Translation="uiR2EDcreature_cbcgd3"},
				--	{Id="palette.entities.creatures.cbcgd4", Translation="uiR2EDcreature_cbcgd4"},
				--	{Id="palette.entities.creatures.cbcge1", Translation="uiR2EDcreature_cbcge1"},
				--	{Id="palette.entities.creatures.cbcge2", Translation="uiR2EDcreature_cbcge2"},
				--	{Id="palette.entities.creatures.cbcge3", Translation="uiR2EDcreature_cbcge3"},
				--	{Id="palette.entities.creatures.cbcge4", Translation="uiR2EDcreature_cbcge4"},
				--	{Id="palette.entities.creatures.cbcgf1", Translation="uiR2EDcreature_cbcgf1"},
				--	{Id="palette.entities.creatures.cbcgf2", Translation="uiR2EDcreature_cbcgf2"},
				--	{Id="palette.entities.creatures.cbcgf3", Translation="uiR2EDcreature_cbcgf3"},
				--	{Id="palette.entities.creatures.cbcgf4", Translation="uiR2EDcreature_cbcgf4"},
					{Id="palette.entities.creatures.cbcjc1", Translation="uiR2EDcreature_cbcjc1"},
					{Id="palette.entities.creatures.cbcjc2", Translation="uiR2EDcreature_cbcjc2"},
					{Id="palette.entities.creatures.cbcjc3", Translation="uiR2EDcreature_cbcjc3"},
					{Id="palette.entities.creatures.cbcjc4", Translation="uiR2EDcreature_cbcjc4"},
					{Id="palette.entities.creatures.cbcla1", Translation="uiR2EDcreature_cbcla1"},
					{Id="palette.entities.creatures.cbcla2", Translation="uiR2EDcreature_cbcla2"},
					{Id="palette.entities.creatures.cbclb1", Translation="uiR2EDcreature_cbclb1"},
					{Id="palette.entities.creatures.cbclb2", Translation="uiR2EDcreature_cbclb2"},
					{Id="palette.entities.creatures.cbclb3", Translation="uiR2EDcreature_cbclb3"},
					{Id="palette.entities.creatures.cbclb4", Translation="uiR2EDcreature_cbclb4"},
					{Id="palette.entities.creatures.cbclc1", Translation="uiR2EDcreature_cbclc1"},
					{Id="palette.entities.creatures.cbclc2", Translation="uiR2EDcreature_cbclc2"},
					{Id="palette.entities.creatures.cbclc3", Translation="uiR2EDcreature_cbclc3"},
					{Id="palette.entities.creatures.cbclc4", Translation="uiR2EDcreature_cbclc4"},
					{Id="palette.entities.creatures.chadc1", Translation="uiR2EDcreature_chadc1"},
					{Id="palette.entities.creatures.chadc2", Translation="uiR2EDcreature_chadc2"},
					{Id="palette.entities.creatures.chadc3", Translation="uiR2EDcreature_chadc3"},
					{Id="palette.entities.creatures.chadc4", Translation="uiR2EDcreature_chadc4"},
					{Id="palette.entities.creatures.chafd1", Translation="uiR2EDcreature_chafd1"},
					{Id="palette.entities.creatures.chafd2", Translation="uiR2EDcreature_chafd2"},
					{Id="palette.entities.creatures.chafd3", Translation="uiR2EDcreature_chafd3"},
					{Id="palette.entities.creatures.chafd4", Translation="uiR2EDcreature_chafd4"},
					{Id="palette.entities.creatures.chafe1", Translation="uiR2EDcreature_chafe1"},
					{Id="palette.entities.creatures.chafe2", Translation="uiR2EDcreature_chafe2"},
					{Id="palette.entities.creatures.chafe3", Translation="uiR2EDcreature_chafe3"},
					{Id="palette.entities.creatures.chafe4", Translation="uiR2EDcreature_chafe4"},
					{Id="palette.entities.creatures.chajf1", Translation="uiR2EDcreature_chajf1"},
					{Id="palette.entities.creatures.chajf2", Translation="uiR2EDcreature_chajf2"},
					{Id="palette.entities.creatures.chajf3", Translation="uiR2EDcreature_chajf3"},
					{Id="palette.entities.creatures.chajf4", Translation="uiR2EDcreature_chajf4"},
					{Id="palette.entities.creatures.chale1", Translation="uiR2EDcreature_chale1"},
					{Id="palette.entities.creatures.chale2", Translation="uiR2EDcreature_chale2"},
					{Id="palette.entities.creatures.chale3", Translation="uiR2EDcreature_chale3"},
					{Id="palette.entities.creatures.chale4", Translation="uiR2EDcreature_chale4"},
					{Id="palette.entities.creatures.chalf1", Translation="uiR2EDcreature_chalf1"},
					{Id="palette.entities.creatures.chalf2", Translation="uiR2EDcreature_chalf2"},
					{Id="palette.entities.creatures.chalf3", Translation="uiR2EDcreature_chalf3"},
					{Id="palette.entities.creatures.chalf4", Translation="uiR2EDcreature_chalf4"},
					{Id="palette.entities.creatures.chapd1", Translation="uiR2EDcreature_chapd1"},
					{Id="palette.entities.creatures.chapd2", Translation="uiR2EDcreature_chapd2"},
					{Id="palette.entities.creatures.chapd3", Translation="uiR2EDcreature_chapd3"},
					{Id="palette.entities.creatures.chapd4", Translation="uiR2EDcreature_chapd4"},
					{Id="palette.entities.creatures.chape1", Translation="uiR2EDcreature_chape1"},
					{Id="palette.entities.creatures.chape2", Translation="uiR2EDcreature_chape2"},
					{Id="palette.entities.creatures.chape3", Translation="uiR2EDcreature_chape3"},
					{Id="palette.entities.creatures.chape4", Translation="uiR2EDcreature_chape4"},
					{Id="palette.entities.creatures.chbdc1", Translation="uiR2EDcreature_chbdc1"},
					{Id="palette.entities.creatures.chbdc2", Translation="uiR2EDcreature_chbdc2"},
					{Id="palette.entities.creatures.chbdc3", Translation="uiR2EDcreature_chbdc3"},
					{Id="palette.entities.creatures.chbdc4", Translation="uiR2EDcreature_chbdc4"},
					{Id="palette.entities.creatures.chbfa1", Translation="uiR2EDcreature_chbfa1"},
					{Id="palette.entities.creatures.chbfa2", Translation="uiR2EDcreature_chbfa2"},
					{Id="palette.entities.creatures.chbfb1", Translation="uiR2EDcreature_chbfb1"},
					{Id="palette.entities.creatures.chbfb2", Translation="uiR2EDcreature_chbfb2"},
					{Id="palette.entities.creatures.chbfb3", Translation="uiR2EDcreature_chbfb3"},
					{Id="palette.entities.creatures.chbfb4", Translation="uiR2EDcreature_chbfb4"},
					{Id="palette.entities.creatures.chbfc1", Translation="uiR2EDcreature_chbfc1"},
					{Id="palette.entities.creatures.chbfc2", Translation="uiR2EDcreature_chbfc2"},
					{Id="palette.entities.creatures.chbfc3", Translation="uiR2EDcreature_chbfc3"},
					{Id="palette.entities.creatures.chbfc4", Translation="uiR2EDcreature_chbfc4"},
					{Id="palette.entities.creatures.chbje1", Translation="uiR2EDcreature_chbje1"},
					{Id="palette.entities.creatures.chbje2", Translation="uiR2EDcreature_chbje2"},
					{Id="palette.entities.creatures.chbje3", Translation="uiR2EDcreature_chbje3"},
					{Id="palette.entities.creatures.chbje4", Translation="uiR2EDcreature_chbje4"},
					{Id="palette.entities.creatures.chbld1", Translation="uiR2EDcreature_chbld1"},
					{Id="palette.entities.creatures.chbld2", Translation="uiR2EDcreature_chbld2"},
					{Id="palette.entities.creatures.chbld3", Translation="uiR2EDcreature_chbld3"},
					{Id="palette.entities.creatures.chbld4", Translation="uiR2EDcreature_chbld4"},
					{Id="palette.entities.creatures.chbpd1", Translation="uiR2EDcreature_chbpd1"},
					{Id="palette.entities.creatures.chbpd2", Translation="uiR2EDcreature_chbpd2"},
					{Id="palette.entities.creatures.chbpd3", Translation="uiR2EDcreature_chbpd3"},
					{Id="palette.entities.creatures.chbpd4", Translation="uiR2EDcreature_chbpd4"},
					{Id="palette.entities.creatures.chbpe1", Translation="uiR2EDcreature_chbpe1"},
					{Id="palette.entities.creatures.chbpe2", Translation="uiR2EDcreature_chbpe2"},
					{Id="palette.entities.creatures.chbpe3", Translation="uiR2EDcreature_chbpe3"},
					{Id="palette.entities.creatures.chbpe4", Translation="uiR2EDcreature_chbpe4"},
					{Id="palette.entities.creatures.chcdb1", Translation="uiR2EDcreature_chcdb1"},
					{Id="palette.entities.creatures.chcdb2", Translation="uiR2EDcreature_chcdb2"},
					{Id="palette.entities.creatures.chcdb3", Translation="uiR2EDcreature_chcdb3"},
					{Id="palette.entities.creatures.chcdb4", Translation="uiR2EDcreature_chcdb4"},
					{Id="palette.entities.creatures.chcfa1", Translation="uiR2EDcreature_chcfa1"},
					{Id="palette.entities.creatures.chcfa2", Translation="uiR2EDcreature_chcfa2"},
					{Id="palette.entities.creatures.chcfb1", Translation="uiR2EDcreature_chcfb1"},
					{Id="palette.entities.creatures.chcfb2", Translation="uiR2EDcreature_chcfb2"},
					{Id="palette.entities.creatures.chcfb3", Translation="uiR2EDcreature_chcfb3"},
					{Id="palette.entities.creatures.chcfb4", Translation="uiR2EDcreature_chcfb4"},
					{Id="palette.entities.creatures.chcjd1", Translation="uiR2EDcreature_chcjd1"},
					{Id="palette.entities.creatures.chcjd2", Translation="uiR2EDcreature_chcjd2"},
					{Id="palette.entities.creatures.chcjd3", Translation="uiR2EDcreature_chcjd3"},
					{Id="palette.entities.creatures.chcjd4", Translation="uiR2EDcreature_chcjd4"},
					{Id="palette.entities.creatures.chclc1", Translation="uiR2EDcreature_chclc1"},
					{Id="palette.entities.creatures.chclc2", Translation="uiR2EDcreature_chclc2"},
					{Id="palette.entities.creatures.chclc3", Translation="uiR2EDcreature_chclc3"},
					{Id="palette.entities.creatures.chclc4", Translation="uiR2EDcreature_chclc4"},
					{Id="palette.entities.creatures.chcld4", Translation="uiR2EDcreature_chcld4"},
					{Id="palette.entities.creatures.chddb1", Translation="uiR2EDcreature_chddb1"},
					{Id="palette.entities.creatures.chddb2", Translation="uiR2EDcreature_chddb2"},
					{Id="palette.entities.creatures.chddb3", Translation="uiR2EDcreature_chddb3"},
					{Id="palette.entities.creatures.chddb4", Translation="uiR2EDcreature_chddb4"},
					{Id="palette.entities.creatures.chdfa1", Translation="uiR2EDcreature_chdfa1"},
					{Id="palette.entities.creatures.chdfa2", Translation="uiR2EDcreature_chdfa2"},
					{Id="palette.entities.creatures.chdfb1", Translation="uiR2EDcreature_chdfb1"},
					{Id="palette.entities.creatures.chdfb2", Translation="uiR2EDcreature_chdfb2"},
					{Id="palette.entities.creatures.chdfb3", Translation="uiR2EDcreature_chdfb3"},
					{Id="palette.entities.creatures.chdfb4", Translation="uiR2EDcreature_chdfb4"},
					{Id="palette.entities.creatures.chdja1", Translation="uiR2EDcreature_chdja1"},
					{Id="palette.entities.creatures.chdja2", Translation="uiR2EDcreature_chdja2"},
					{Id="palette.entities.creatures.chdjb1", Translation="uiR2EDcreature_chdjb1"},
					{Id="palette.entities.creatures.chdjb2", Translation="uiR2EDcreature_chdjb2"},
					{Id="palette.entities.creatures.chdjb3", Translation="uiR2EDcreature_chdjb3"},
					{Id="palette.entities.creatures.chdjb4", Translation="uiR2EDcreature_chdjb4"},
					{Id="palette.entities.creatures.chdla1", Translation="uiR2EDcreature_chdla1"},
					{Id="palette.entities.creatures.chdla2", Translation="uiR2EDcreature_chdla2"},
					{Id="palette.entities.creatures.chdlb1", Translation="uiR2EDcreature_chdlb1"},
					{Id="palette.entities.creatures.chdlb2", Translation="uiR2EDcreature_chdlb2"},
					{Id="palette.entities.creatures.chdlb3", Translation="uiR2EDcreature_chdlb3"},
					{Id="palette.entities.creatures.chdlb4", Translation="uiR2EDcreature_chdlb4"},
				--	{Id="palette.entities.creatures.chegb1", Translation="uiR2EDcreature_chegb1"},
				--	{Id="palette.entities.creatures.chegb2", Translation="uiR2EDcreature_chegb2"},
				--	{Id="palette.entities.creatures.chegb3", Translation="uiR2EDcreature_chegb3"},
				--	{Id="palette.entities.creatures.chegb4", Translation="uiR2EDcreature_chegb4"},
				--	{Id="palette.entities.creatures.chegc1", Translation="uiR2EDcreature_chegc1"},
				--	{Id="palette.entities.creatures.chegc2", Translation="uiR2EDcreature_chegc2"},
				--	{Id="palette.entities.creatures.chegc3", Translation="uiR2EDcreature_chegc3"},
				--	{Id="palette.entities.creatures.chegc4", Translation="uiR2EDcreature_chegc4"},
				--	{Id="palette.entities.creatures.chegd1", Translation="uiR2EDcreature_chegd1"},
				--	{Id="palette.entities.creatures.chegd2", Translation="uiR2EDcreature_chegd2"},
				--	{Id="palette.entities.creatures.chegd3", Translation="uiR2EDcreature_chegd3"},
				--	{Id="palette.entities.creatures.chegd4", Translation="uiR2EDcreature_chegd4"},
				--	{Id="palette.entities.creatures.chege1", Translation="uiR2EDcreature_chege1"},
				--	{Id="palette.entities.creatures.chege2", Translation="uiR2EDcreature_chege2"},
				--	{Id="palette.entities.creatures.chege3", Translation="uiR2EDcreature_chege3"},
				--	{Id="palette.entities.creatures.chege4", Translation="uiR2EDcreature_chege4"},
				--	{Id="palette.entities.creatures.chegf1", Translation="uiR2EDcreature_chegf1"},
				--	{Id="palette.entities.creatures.chegf2", Translation="uiR2EDcreature_chegf2"},
				--	{Id="palette.entities.creatures.chegf3", Translation="uiR2EDcreature_chegf3"},
				--	{Id="palette.entities.creatures.chegf4", Translation="uiR2EDcreature_chegf4"},
					{Id="palette.entities.creatures.cheld1", Translation="uiR2EDcreature_cheld1"},
					{Id="palette.entities.creatures.cheld2", Translation="uiR2EDcreature_cheld2"},
					{Id="palette.entities.creatures.cheld3", Translation="uiR2EDcreature_cheld3"},
					{Id="palette.entities.creatures.cheld4", Translation="uiR2EDcreature_cheld4"},
					{Id="palette.entities.creatures.chele4", Translation="uiR2EDcreature_chele4"},
				--	{Id="palette.entities.creatures.chfgb1", Translation="uiR2EDcreature_chfgb1"},
				--	{Id="palette.entities.creatures.chfgb2", Translation="uiR2EDcreature_chfgb2"},
				--	{Id="palette.entities.creatures.chfgb3", Translation="uiR2EDcreature_chfgb3"},
				--	{Id="palette.entities.creatures.chfgb4", Translation="uiR2EDcreature_chfgb4"},
				--	{Id="palette.entities.creatures.chfgc1", Translation="uiR2EDcreature_chfgc1"},
				--	{Id="palette.entities.creatures.chfgc2", Translation="uiR2EDcreature_chfgc2"},
				--	{Id="palette.entities.creatures.chfgc3", Translation="uiR2EDcreature_chfgc3"},
				--	{Id="palette.entities.creatures.chfgc4", Translation="uiR2EDcreature_chfgc4"},
				--	{Id="palette.entities.creatures.chfgd1", Translation="uiR2EDcreature_chfgd1"},
				--	{Id="palette.entities.creatures.chfgd2", Translation="uiR2EDcreature_chfgd2"},
				--	{Id="palette.entities.creatures.chfgd3", Translation="uiR2EDcreature_chfgd3"},
				--	{Id="palette.entities.creatures.chfgd4", Translation="uiR2EDcreature_chfgd4"},
				--	{Id="palette.entities.creatures.chfge1", Translation="uiR2EDcreature_chfge1"},
				--	{Id="palette.entities.creatures.chfge2", Translation="uiR2EDcreature_chfge2"},
				--	{Id="palette.entities.creatures.chfge3", Translation="uiR2EDcreature_chfge3"},
				--	{Id="palette.entities.creatures.chfge4", Translation="uiR2EDcreature_chfge4"},
				--	{Id="palette.entities.creatures.chfgf1", Translation="uiR2EDcreature_chfgf1"},
				--	{Id="palette.entities.creatures.chfgf2", Translation="uiR2EDcreature_chfgf2"},
				--	{Id="palette.entities.creatures.chfgf3", Translation="uiR2EDcreature_chfgf3"},
				--	{Id="palette.entities.creatures.chfgf4", Translation="uiR2EDcreature_chfgf4"},
					{Id="palette.entities.creatures.chfjc1", Translation="uiR2EDcreature_chfjc1"},
					{Id="palette.entities.creatures.chfjc2", Translation="uiR2EDcreature_chfjc2"},
					{Id="palette.entities.creatures.chfjc3", Translation="uiR2EDcreature_chfjc3"},
					{Id="palette.entities.creatures.chfjc4", Translation="uiR2EDcreature_chfjc4"},
					{Id="palette.entities.creatures.chfjd1", Translation="uiR2EDcreature_chfjd1"},
					{Id="palette.entities.creatures.chfjd2", Translation="uiR2EDcreature_chfjd2"},
					{Id="palette.entities.creatures.chfjd3", Translation="uiR2EDcreature_chfjd3"},
					{Id="palette.entities.creatures.chfjd4", Translation="uiR2EDcreature_chfjd4"},
					{Id="palette.entities.creatures.chfla1", Translation="uiR2EDcreature_chfla1"},
					{Id="palette.entities.creatures.chfla2", Translation="uiR2EDcreature_chfla2"},
					{Id="palette.entities.creatures.chflb1", Translation="uiR2EDcreature_chflb1"},
					{Id="palette.entities.creatures.chflb2", Translation="uiR2EDcreature_chflb2"},
					{Id="palette.entities.creatures.chflb3", Translation="uiR2EDcreature_chflb3"},
					{Id="palette.entities.creatures.chflb4", Translation="uiR2EDcreature_chflb4"},
					{Id="palette.entities.creatures.chgdd1", Translation="uiR2EDcreature_chgdd1"},
					{Id="palette.entities.creatures.chgdd2", Translation="uiR2EDcreature_chgdd2"},
					{Id="palette.entities.creatures.chgdd3", Translation="uiR2EDcreature_chgdd3"},
					{Id="palette.entities.creatures.chgdd4", Translation="uiR2EDcreature_chgdd4"},
					{Id="palette.entities.creatures.chgde1", Translation="uiR2EDcreature_chgde1"},
					{Id="palette.entities.creatures.chgde2", Translation="uiR2EDcreature_chgde2"},
					{Id="palette.entities.creatures.chgde3", Translation="uiR2EDcreature_chgde3"},
					{Id="palette.entities.creatures.chgde4", Translation="uiR2EDcreature_chgde4"},
				--	{Id="palette.entities.creatures.chggb1", Translation="uiR2EDcreature_chggb1"},
				--	{Id="palette.entities.creatures.chggb2", Translation="uiR2EDcreature_chggb2"},
				--	{Id="palette.entities.creatures.chggb3", Translation="uiR2EDcreature_chggb3"},
				--	{Id="palette.entities.creatures.chggb4", Translation="uiR2EDcreature_chggb4"},
				--	{Id="palette.entities.creatures.chggc1", Translation="uiR2EDcreature_chggc1"},
				--	{Id="palette.entities.creatures.chggc2", Translation="uiR2EDcreature_chggc2"},
				--	{Id="palette.entities.creatures.chggc3", Translation="uiR2EDcreature_chggc3"},
				--	{Id="palette.entities.creatures.chggc4", Translation="uiR2EDcreature_chggc4"},
				--	{Id="palette.entities.creatures.chggd1", Translation="uiR2EDcreature_chggd1"},
				--	{Id="palette.entities.creatures.chggd2", Translation="uiR2EDcreature_chggd2"},
				--	{Id="palette.entities.creatures.chggd3", Translation="uiR2EDcreature_chggd3"},
				--	{Id="palette.entities.creatures.chggd4", Translation="uiR2EDcreature_chggd4"},
				--	{Id="palette.entities.creatures.chgge1", Translation="uiR2EDcreature_chgge1"},
				--	{Id="palette.entities.creatures.chgge2", Translation="uiR2EDcreature_chgge2"},
				--	{Id="palette.entities.creatures.chgge3", Translation="uiR2EDcreature_chgge3"},
				--	{Id="palette.entities.creatures.chgge4", Translation="uiR2EDcreature_chgge4"},
				--	{Id="palette.entities.creatures.chggf1", Translation="uiR2EDcreature_chggf1"},
				--	{Id="palette.entities.creatures.chggf2", Translation="uiR2EDcreature_chggf2"},
				--	{Id="palette.entities.creatures.chggf3", Translation="uiR2EDcreature_chggf3"},
				--	{Id="palette.entities.creatures.chggf4", Translation="uiR2EDcreature_chggf4"},
					{Id="palette.entities.creatures.chgpd1", Translation="uiR2EDcreature_chgpd1"},
					{Id="palette.entities.creatures.chgpd2", Translation="uiR2EDcreature_chgpd2"},
					{Id="palette.entities.creatures.chgpd3", Translation="uiR2EDcreature_chgpd3"},
					{Id="palette.entities.creatures.chgpd4", Translation="uiR2EDcreature_chgpd4"},
					{Id="palette.entities.creatures.chgpf1", Translation="uiR2EDcreature_chgpf1"},
					{Id="palette.entities.creatures.chgpf2", Translation="uiR2EDcreature_chgpf2"},
					{Id="palette.entities.creatures.chgpf3", Translation="uiR2EDcreature_chgpf3"},
					{Id="palette.entities.creatures.chgpf4", Translation="uiR2EDcreature_chgpf4"},
					{Id="palette.entities.creatures.chhdd1", Translation="uiR2EDcreature_chhdd1"},
					{Id="palette.entities.creatures.chhdd2", Translation="uiR2EDcreature_chhdd2"},
					{Id="palette.entities.creatures.chhdd3", Translation="uiR2EDcreature_chhdd3"},
					{Id="palette.entities.creatures.chhdd4", Translation="uiR2EDcreature_chhdd4"},
					{Id="palette.entities.creatures.chhfc1", Translation="uiR2EDcreature_chhfc1"},
					{Id="palette.entities.creatures.chhfc2", Translation="uiR2EDcreature_chhfc2"},
					{Id="palette.entities.creatures.chhfc3", Translation="uiR2EDcreature_chhfc3"},
					{Id="palette.entities.creatures.chhfc4", Translation="uiR2EDcreature_chhfc4"},
					{Id="palette.entities.creatures.chhfd1", Translation="uiR2EDcreature_chhfd1"},
					{Id="palette.entities.creatures.chhfd2", Translation="uiR2EDcreature_chhfd2"},
					{Id="palette.entities.creatures.chhfd3", Translation="uiR2EDcreature_chhfd3"},
					{Id="palette.entities.creatures.chhfd4", Translation="uiR2EDcreature_chhfd4"},
					{Id="palette.entities.creatures.chhja1", Translation="uiR2EDcreature_chhja1"},
					{Id="palette.entities.creatures.chhja2", Translation="uiR2EDcreature_chhja2"},
					{Id="palette.entities.creatures.chhjb1", Translation="uiR2EDcreature_chhjb1"},
					{Id="palette.entities.creatures.chhjb2", Translation="uiR2EDcreature_chhjb2"},
					{Id="palette.entities.creatures.chhjb3", Translation="uiR2EDcreature_chhjb3"},
					{Id="palette.entities.creatures.chhjb4", Translation="uiR2EDcreature_chhjb4"},
					{Id="palette.entities.creatures.chhle1", Translation="uiR2EDcreature_chhle1"},
					{Id="palette.entities.creatures.chhle2", Translation="uiR2EDcreature_chhle2"},
					{Id="palette.entities.creatures.chhle3", Translation="uiR2EDcreature_chhle3"},
					{Id="palette.entities.creatures.chhle4", Translation="uiR2EDcreature_chhle4"},
					{Id="palette.entities.creatures.chhpf1", Translation="uiR2EDcreature_chhpf1"},
					{Id="palette.entities.creatures.chhpf2", Translation="uiR2EDcreature_chhpf2"},
					{Id="palette.entities.creatures.chhpf3", Translation="uiR2EDcreature_chhpf3"},
					{Id="palette.entities.creatures.chhpf4", Translation="uiR2EDcreature_chhpf4"},

-- sadge says don't list mek mounts and packers in fauna
-- sadge					{Id="palette.entities.creatures.chidb2", Translation="uiR2EDcreature_chidb2"},
-- sadge					{Id="palette.entities.creatures.chidc2", Translation="uiR2EDcreature_chidc2"},
-- sadge					{Id="palette.entities.creatures.chidd2", Translation="uiR2EDcreature_chidd2"},
-- sadge					{Id="palette.entities.creatures.chide2", Translation="uiR2EDcreature_chide2"},
-- sadge					{Id="palette.entities.creatures.chidf2", Translation="uiR2EDcreature_chidf2"},
-- sadge					{Id="palette.entities.creatures.chifb2", Translation="uiR2EDcreature_chifb2"},
-- sadge					{Id="palette.entities.creatures.chifc2", Translation="uiR2EDcreature_chifc2"},
-- sadge					{Id="palette.entities.creatures.chifd2", Translation="uiR2EDcreature_chifd2"},
-- sadge					{Id="palette.entities.creatures.chife2", Translation="uiR2EDcreature_chife2"},
-- sadge					{Id="palette.entities.creatures.chiff2", Translation="uiR2EDcreature_chiff2"},
-- sadge					{Id="palette.entities.creatures.chijb2", Translation="uiR2EDcreature_chijb2"},
-- sadge					{Id="palette.entities.creatures.chijc2", Translation="uiR2EDcreature_chijc2"},
-- sadge					{Id="palette.entities.creatures.chijd2", Translation="uiR2EDcreature_chijd2"},
-- sadge					{Id="palette.entities.creatures.chije2", Translation="uiR2EDcreature_chije2"},
-- sadge					{Id="palette.entities.creatures.chijf2", Translation="uiR2EDcreature_chijf2"},
-- sadge					{Id="palette.entities.creatures.chilb2", Translation="uiR2EDcreature_chilb2"},
-- sadge					{Id="palette.entities.creatures.chilc2", Translation="uiR2EDcreature_chilc2"},
-- sadge					{Id="palette.entities.creatures.child2", Translation="uiR2EDcreature_child2"},
-- sadge					{Id="palette.entities.creatures.chile2", Translation="uiR2EDcreature_chile2"},
-- sadge					{Id="palette.entities.creatures.chilf2", Translation="uiR2EDcreature_chilf2"},
-- sadge					{Id="palette.entities.creatures.chipd2", Translation="uiR2EDcreature_chipd2"},
-- sadge					{Id="palette.entities.creatures.chipe2", Translation="uiR2EDcreature_chipe2"},
-- sadge					{Id="palette.entities.creatures.chipf2", Translation="uiR2EDcreature_chipf2"},
-- sadge					{Id="palette.entities.creatures.chjdb2", Translation="uiR2EDcreature_chjdb2"},
-- sadge					{Id="palette.entities.creatures.chjdb3", Translation="uiR2EDcreature_chjdb3"},
-- sadge					{Id="palette.entities.creatures.chjdc2", Translation="uiR2EDcreature_chjdc2"},
-- sadge					{Id="palette.entities.creatures.chjdc3", Translation="uiR2EDcreature_chjdc3"},
-- sadge					{Id="palette.entities.creatures.chjdd2", Translation="uiR2EDcreature_chjdd2"},
-- sadge					{Id="palette.entities.creatures.chjdd3", Translation="uiR2EDcreature_chjdd3"},
-- sadge					{Id="palette.entities.creatures.chjde2", Translation="uiR2EDcreature_chjde2"},
-- sadge					{Id="palette.entities.creatures.chjde3", Translation="uiR2EDcreature_chjde3"},
-- sadge					{Id="palette.entities.creatures.chjdf2", Translation="uiR2EDcreature_chjdf2"},
-- sadge					{Id="palette.entities.creatures.chjdf3", Translation="uiR2EDcreature_chjdf3"},
-- sadge					{Id="palette.entities.creatures.chjfb2", Translation="uiR2EDcreature_chjfb2"},
-- sadge					{Id="palette.entities.creatures.chjfb3", Translation="uiR2EDcreature_chjfb3"},
-- sadge					{Id="palette.entities.creatures.chjfc2", Translation="uiR2EDcreature_chjfc2"},
-- sadge					{Id="palette.entities.creatures.chjfc3", Translation="uiR2EDcreature_chjfc3"},
-- sadge					{Id="palette.entities.creatures.chjfd2", Translation="uiR2EDcreature_chjfd2"},
-- sadge					{Id="palette.entities.creatures.chjfd3", Translation="uiR2EDcreature_chjfd3"},
-- sadge					{Id="palette.entities.creatures.chjfe2", Translation="uiR2EDcreature_chjfe2"},
-- sadge					{Id="palette.entities.creatures.chjfe3", Translation="uiR2EDcreature_chjfe3"},
-- sadge					{Id="palette.entities.creatures.chjff2", Translation="uiR2EDcreature_chjff2"},
-- sadge					{Id="palette.entities.creatures.chjff3", Translation="uiR2EDcreature_chjff3"},
-- sadge					{Id="palette.entities.creatures.chjjb2", Translation="uiR2EDcreature_chjjb2"},
-- sadge					{Id="palette.entities.creatures.chjjb3", Translation="uiR2EDcreature_chjjb3"},
-- sadge					{Id="palette.entities.creatures.chjjc2", Translation="uiR2EDcreature_chjjc2"},
-- sadge					{Id="palette.entities.creatures.chjjc3", Translation="uiR2EDcreature_chjjc3"},
-- sadge					{Id="palette.entities.creatures.chjjd2", Translation="uiR2EDcreature_chjjd2"},
-- sadge					{Id="palette.entities.creatures.chjjd3", Translation="uiR2EDcreature_chjjd3"},
-- sadge					{Id="palette.entities.creatures.chjje2", Translation="uiR2EDcreature_chjje2"},
-- sadge					{Id="palette.entities.creatures.chjje3", Translation="uiR2EDcreature_chjje3"},
-- sadge					{Id="palette.entities.creatures.chjjf2", Translation="uiR2EDcreature_chjjf2"},
-- sadge					{Id="palette.entities.creatures.chjjf3", Translation="uiR2EDcreature_chjjf3"},
-- sadge					{Id="palette.entities.creatures.chjlb2", Translation="uiR2EDcreature_chjlb2"},
-- sadge					{Id="palette.entities.creatures.chjlb3", Translation="uiR2EDcreature_chjlb3"},
-- sadge					{Id="palette.entities.creatures.chjlc2", Translation="uiR2EDcreature_chjlc2"},
-- sadge					{Id="palette.entities.creatures.chjlc3", Translation="uiR2EDcreature_chjlc3"},
-- sadge					{Id="palette.entities.creatures.chjld2", Translation="uiR2EDcreature_chjld2"},
-- sadge					{Id="palette.entities.creatures.chjld3", Translation="uiR2EDcreature_chjld3"},
-- sadge					{Id="palette.entities.creatures.chjle2", Translation="uiR2EDcreature_chjle2"},
-- sadge					{Id="palette.entities.creatures.chjle3", Translation="uiR2EDcreature_chjle3"},
-- sadge					{Id="palette.entities.creatures.chjlf2", Translation="uiR2EDcreature_chjlf2"},
-- sadge					{Id="palette.entities.creatures.chjlf3", Translation="uiR2EDcreature_chjlf3"},
-- sadge					{Id="palette.entities.creatures.chjpd2", Translation="uiR2EDcreature_chjpd2"},
-- sadge					{Id="palette.entities.creatures.chjpe2", Translation="uiR2EDcreature_chjpe2"},
-- sadge					{Id="palette.entities.creatures.chjpf2", Translation="uiR2EDcreature_chjpf2"},

					{Id="palette.entities.creatures.chkde1", Translation="uiR2EDcreature_chkde1"},
					{Id="palette.entities.creatures.chkde2", Translation="uiR2EDcreature_chkde2"},
					{Id="palette.entities.creatures.chkde3", Translation="uiR2EDcreature_chkde3"},
					{Id="palette.entities.creatures.chkde4", Translation="uiR2EDcreature_chkde4"},
					{Id="palette.entities.creatures.chkdf1", Translation="uiR2EDcreature_chkdf1"},
					{Id="palette.entities.creatures.chkdf2", Translation="uiR2EDcreature_chkdf2"},
					{Id="palette.entities.creatures.chkdf3", Translation="uiR2EDcreature_chkdf3"},
					{Id="palette.entities.creatures.chkdf4", Translation="uiR2EDcreature_chkdf4"},
				--	{Id="palette.entities.creatures.chkgb1", Translation="uiR2EDcreature_chkgb1"},
				--	{Id="palette.entities.creatures.chkgb2", Translation="uiR2EDcreature_chkgb2"},
				--	{Id="palette.entities.creatures.chkgb3", Translation="uiR2EDcreature_chkgb3"},
				--	{Id="palette.entities.creatures.chkgb4", Translation="uiR2EDcreature_chkgb4"},
				--	{Id="palette.entities.creatures.chkgc1", Translation="uiR2EDcreature_chkgc1"},
				--	{Id="palette.entities.creatures.chkgc2", Translation="uiR2EDcreature_chkgc2"},
				--	{Id="palette.entities.creatures.chkgc3", Translation="uiR2EDcreature_chkgc3"},
				--	{Id="palette.entities.creatures.chkgc4", Translation="uiR2EDcreature_chkgc4"},
				--	{Id="palette.entities.creatures.chkgd1", Translation="uiR2EDcreature_chkgd1"},
				--	{Id="palette.entities.creatures.chkgd2", Translation="uiR2EDcreature_chkgd2"},
				--	{Id="palette.entities.creatures.chkgd3", Translation="uiR2EDcreature_chkgd3"},
				--	{Id="palette.entities.creatures.chkgd4", Translation="uiR2EDcreature_chkgd4"},
				--	{Id="palette.entities.creatures.chkge1", Translation="uiR2EDcreature_chkge1"},
				--	{Id="palette.entities.creatures.chkge2", Translation="uiR2EDcreature_chkge2"},
				--	{Id="palette.entities.creatures.chkge3", Translation="uiR2EDcreature_chkge3"},
				--	{Id="palette.entities.creatures.chkge4", Translation="uiR2EDcreature_chkge4"},
				--	{Id="palette.entities.creatures.chkgf1", Translation="uiR2EDcreature_chkgf1"},
				--	{Id="palette.entities.creatures.chkgf2", Translation="uiR2EDcreature_chkgf2"},
				--	{Id="palette.entities.creatures.chkgf3", Translation="uiR2EDcreature_chkgf3"},
				--	{Id="palette.entities.creatures.chkgf4", Translation="uiR2EDcreature_chkgf4"},
					{Id="palette.entities.creatures.chkjd1", Translation="uiR2EDcreature_chkjd1"},
					{Id="palette.entities.creatures.chkjd2", Translation="uiR2EDcreature_chkjd2"},
					{Id="palette.entities.creatures.chkjd3", Translation="uiR2EDcreature_chkjd3"},
					{Id="palette.entities.creatures.chkjd4", Translation="uiR2EDcreature_chkjd4"},
					{Id="palette.entities.creatures.chkje1", Translation="uiR2EDcreature_chkje1"},
					{Id="palette.entities.creatures.chkje2", Translation="uiR2EDcreature_chkje2"},
					{Id="palette.entities.creatures.chkje3", Translation="uiR2EDcreature_chkje3"},
					{Id="palette.entities.creatures.chkje4", Translation="uiR2EDcreature_chkje4"},
					{Id="palette.entities.creatures.chldf1", Translation="uiR2EDcreature_chldf1"},
					{Id="palette.entities.creatures.chldf2", Translation="uiR2EDcreature_chldf2"},
					{Id="palette.entities.creatures.chldf3", Translation="uiR2EDcreature_chldf3"},
					{Id="palette.entities.creatures.chldf4", Translation="uiR2EDcreature_chldf4"},
					{Id="palette.entities.creatures.chlfe1", Translation="uiR2EDcreature_chlfe1"},
					{Id="palette.entities.creatures.chlfe2", Translation="uiR2EDcreature_chlfe2"},
					{Id="palette.entities.creatures.chlfe3", Translation="uiR2EDcreature_chlfe3"},
					{Id="palette.entities.creatures.chlfe4", Translation="uiR2EDcreature_chlfe4"},
					{Id="palette.entities.creatures.chlff1", Translation="uiR2EDcreature_chlff1"},
					{Id="palette.entities.creatures.chlff2", Translation="uiR2EDcreature_chlff2"},
					{Id="palette.entities.creatures.chlff3", Translation="uiR2EDcreature_chlff3"},
					{Id="palette.entities.creatures.chlff4", Translation="uiR2EDcreature_chlff4"},
				--	{Id="palette.entities.creatures.chlgb1", Translation="uiR2EDcreature_chlgb1"},
				--	{Id="palette.entities.creatures.chlgb2", Translation="uiR2EDcreature_chlgb2"},
				--	{Id="palette.entities.creatures.chlgb3", Translation="uiR2EDcreature_chlgb3"},
				--	{Id="palette.entities.creatures.chlgb4", Translation="uiR2EDcreature_chlgb4"},
				--	{Id="palette.entities.creatures.chlgc1", Translation="uiR2EDcreature_chlgc1"},
				--	{Id="palette.entities.creatures.chlgc2", Translation="uiR2EDcreature_chlgc2"},
				--	{Id="palette.entities.creatures.chlgc3", Translation="uiR2EDcreature_chlgc3"},
				--	{Id="palette.entities.creatures.chlgc4", Translation="uiR2EDcreature_chlgc4"},
				--	{Id="palette.entities.creatures.chlgd1", Translation="uiR2EDcreature_chlgd1"},
				--	{Id="palette.entities.creatures.chlgd2", Translation="uiR2EDcreature_chlgd2"},
				--	{Id="palette.entities.creatures.chlgd3", Translation="uiR2EDcreature_chlgd3"},
				--	{Id="palette.entities.creatures.chlgd4", Translation="uiR2EDcreature_chlgd4"},
				--	{Id="palette.entities.creatures.chlge1", Translation="uiR2EDcreature_chlge1"},
				--	{Id="palette.entities.creatures.chlge2", Translation="uiR2EDcreature_chlge2"},
				--	{Id="palette.entities.creatures.chlge3", Translation="uiR2EDcreature_chlge3"},
				--	{Id="palette.entities.creatures.chlge4", Translation="uiR2EDcreature_chlge4"},
				--	{Id="palette.entities.creatures.chlgf1", Translation="uiR2EDcreature_chlgf1"},
				--	{Id="palette.entities.creatures.chlgf2", Translation="uiR2EDcreature_chlgf2"},
				--	{Id="palette.entities.creatures.chlgf3", Translation="uiR2EDcreature_chlgf3"},
				--	{Id="palette.entities.creatures.chlgf4", Translation="uiR2EDcreature_chlgf4"},
					{Id="palette.entities.creatures.chlld1", Translation="uiR2EDcreature_chlld1"},
					{Id="palette.entities.creatures.chlld2", Translation="uiR2EDcreature_chlld2"},
					{Id="palette.entities.creatures.chlld3", Translation="uiR2EDcreature_chlld3"},
					{Id="palette.entities.creatures.chlld4", Translation="uiR2EDcreature_chlld4"},
					{Id="palette.entities.creatures.chlle1", Translation="uiR2EDcreature_chlle1"},
					{Id="palette.entities.creatures.chlle2", Translation="uiR2EDcreature_chlle2"},
					{Id="palette.entities.creatures.chlle3", Translation="uiR2EDcreature_chlle3"},
					{Id="palette.entities.creatures.chlle4", Translation="uiR2EDcreature_chlle4"},
					{Id="palette.entities.creatures.chlpe1", Translation="uiR2EDcreature_chlpe1"},
					{Id="palette.entities.creatures.chlpe2", Translation="uiR2EDcreature_chlpe2"},
					{Id="palette.entities.creatures.chlpe3", Translation="uiR2EDcreature_chlpe3"},
					{Id="palette.entities.creatures.chlpe4", Translation="uiR2EDcreature_chlpe4"},
					{Id="palette.entities.creatures.chlpf1", Translation="uiR2EDcreature_chlpf1"},
					{Id="palette.entities.creatures.chlpf2", Translation="uiR2EDcreature_chlpf2"},
					{Id="palette.entities.creatures.chlpf3", Translation="uiR2EDcreature_chlpf3"},
					{Id="palette.entities.creatures.chlpf4", Translation="uiR2EDcreature_chlpf4"},
					{Id="palette.entities.creatures.chmdd1", Translation="uiR2EDcreature_chmdd1"},
					{Id="palette.entities.creatures.chmdd2", Translation="uiR2EDcreature_chmdd2"},
					{Id="palette.entities.creatures.chmdd3", Translation="uiR2EDcreature_chmdd3"},
					{Id="palette.entities.creatures.chmdd4", Translation="uiR2EDcreature_chmdd4"},
					{Id="palette.entities.creatures.chmfc1", Translation="uiR2EDcreature_chmfc1"},
					{Id="palette.entities.creatures.chmfc2", Translation="uiR2EDcreature_chmfc2"},
					{Id="palette.entities.creatures.chmfc3", Translation="uiR2EDcreature_chmfc3"},
					{Id="palette.entities.creatures.chmfc4", Translation="uiR2EDcreature_chmfc4"},
					{Id="palette.entities.creatures.chnfd1", Translation="uiR2EDcreature_chnfd1"},
					{Id="palette.entities.creatures.chnfd2", Translation="uiR2EDcreature_chnfd2"},
					{Id="palette.entities.creatures.chnfd3", Translation="uiR2EDcreature_chnfd3"},
					{Id="palette.entities.creatures.chnfd4", Translation="uiR2EDcreature_chnfd4"},
					{Id="palette.entities.creatures.chnjc1", Translation="uiR2EDcreature_chnjc1"},
					{Id="palette.entities.creatures.chnjc2", Translation="uiR2EDcreature_chnjc2"},
					{Id="palette.entities.creatures.chnjc3", Translation="uiR2EDcreature_chnjc3"},
					{Id="palette.entities.creatures.chnjc4", Translation="uiR2EDcreature_chnjc4"},
					{Id="palette.entities.creatures.chofc1", Translation="uiR2EDcreature_chofc1"},
					{Id="palette.entities.creatures.chofc2", Translation="uiR2EDcreature_chofc2"},
					{Id="palette.entities.creatures.chofc3", Translation="uiR2EDcreature_chofc3"},
					{Id="palette.entities.creatures.chofc4", Translation="uiR2EDcreature_chofc4"},
				--	{Id="palette.entities.creatures.chogb1", Translation="uiR2EDcreature_chogb1"},
				--	{Id="palette.entities.creatures.chogb2", Translation="uiR2EDcreature_chogb2"},
				--	{Id="palette.entities.creatures.chogb3", Translation="uiR2EDcreature_chogb3"},
				--	{Id="palette.entities.creatures.chogb4", Translation="uiR2EDcreature_chogb4"},
				--	{Id="palette.entities.creatures.chogc1", Translation="uiR2EDcreature_chogc1"},
				--	{Id="palette.entities.creatures.chogc2", Translation="uiR2EDcreature_chogc2"},
				--	{Id="palette.entities.creatures.chogc3", Translation="uiR2EDcreature_chogc3"},
				--	{Id="palette.entities.creatures.chogc4", Translation="uiR2EDcreature_chogc4"},
				--	{Id="palette.entities.creatures.chogd1", Translation="uiR2EDcreature_chogd1"},
				--	{Id="palette.entities.creatures.chogd2", Translation="uiR2EDcreature_chogd2"},
				--	{Id="palette.entities.creatures.chogd3", Translation="uiR2EDcreature_chogd3"},
				--	{Id="palette.entities.creatures.chogd4", Translation="uiR2EDcreature_chogd4"},
				--	{Id="palette.entities.creatures.choge1", Translation="uiR2EDcreature_choge1"},
				--	{Id="palette.entities.creatures.choge2", Translation="uiR2EDcreature_choge2"},
				--	{Id="palette.entities.creatures.choge3", Translation="uiR2EDcreature_choge3"},
				--	{Id="palette.entities.creatures.choge4", Translation="uiR2EDcreature_choge4"},
				--	{Id="palette.entities.creatures.chogf1", Translation="uiR2EDcreature_chogf1"},
				--	{Id="palette.entities.creatures.chogf2", Translation="uiR2EDcreature_chogf2"},
				--	{Id="palette.entities.creatures.chogf3", Translation="uiR2EDcreature_chogf3"},
				--	{Id="palette.entities.creatures.chogf4", Translation="uiR2EDcreature_chogf4"},
					{Id="palette.entities.creatures.chpdc1", Translation="uiR2EDcreature_chpdc1"},
					{Id="palette.entities.creatures.chpdc2", Translation="uiR2EDcreature_chpdc2"},
					{Id="palette.entities.creatures.chpdc3", Translation="uiR2EDcreature_chpdc3"},
					{Id="palette.entities.creatures.chpdc4", Translation="uiR2EDcreature_chpdc4"},
					{Id="palette.entities.creatures.chpde4", Translation="uiR2EDcreature_chpde4"},
					{Id="palette.entities.creatures.chpfd1", Translation="uiR2EDcreature_chpfd1"},
					{Id="palette.entities.creatures.chpfd2", Translation="uiR2EDcreature_chpfd2"},
					{Id="palette.entities.creatures.chpfd3", Translation="uiR2EDcreature_chpfd3"},
					{Id="palette.entities.creatures.chpfd4", Translation="uiR2EDcreature_chpfd4"},
					{Id="palette.entities.creatures.chqfe1", Translation="uiR2EDcreature_chqfe1"},
					{Id="palette.entities.creatures.chqfe2", Translation="uiR2EDcreature_chqfe2"},
					{Id="palette.entities.creatures.chqfe3", Translation="uiR2EDcreature_chqfe3"},
					{Id="palette.entities.creatures.chqfe4", Translation="uiR2EDcreature_chqfe4"},
					{Id="palette.entities.creatures.chqlc1", Translation="uiR2EDcreature_chqlc1"},
					{Id="palette.entities.creatures.chqlc2", Translation="uiR2EDcreature_chqlc2"},
					{Id="palette.entities.creatures.chqlc3", Translation="uiR2EDcreature_chqlc3"},
					{Id="palette.entities.creatures.chqlc4", Translation="uiR2EDcreature_chqlc4"},
					{Id="palette.entities.creatures.chrfe1", Translation="uiR2EDcreature_chrfe1"},
					{Id="palette.entities.creatures.chrfe2", Translation="uiR2EDcreature_chrfe2"},
					{Id="palette.entities.creatures.chrfe3", Translation="uiR2EDcreature_chrfe3"},
					{Id="palette.entities.creatures.chrfe4", Translation="uiR2EDcreature_chrfe4"},
					{Id="palette.entities.creatures.chrlf1", Translation="uiR2EDcreature_chrlf1"},
					{Id="palette.entities.creatures.chrlf2", Translation="uiR2EDcreature_chrlf2"},
					{Id="palette.entities.creatures.chrlf3", Translation="uiR2EDcreature_chrlf3"},
					{Id="palette.entities.creatures.chrlf4", Translation="uiR2EDcreature_chrlf4"},
					{Id="palette.entities.creatures.chsdf1", Translation="uiR2EDcreature_chsdf1"},
					{Id="palette.entities.creatures.chsdf2", Translation="uiR2EDcreature_chsdf2"},
					{Id="palette.entities.creatures.chsdf3", Translation="uiR2EDcreature_chsdf3"},
					{Id="palette.entities.creatures.chsdf4", Translation="uiR2EDcreature_chsdf4"},
					{Id="palette.entities.creatures.chsle1", Translation="uiR2EDcreature_chsle1"},
					{Id="palette.entities.creatures.chsle2", Translation="uiR2EDcreature_chsle2"},
					{Id="palette.entities.creatures.chsle3", Translation="uiR2EDcreature_chsle3"},
					{Id="palette.entities.creatures.chsle4", Translation="uiR2EDcreature_chsle4"},
					{Id="palette.entities.creatures.chtde1", Translation="uiR2EDcreature_chtde1"},
					{Id="palette.entities.creatures.chtde2", Translation="uiR2EDcreature_chtde2"},
					{Id="palette.entities.creatures.chtde3", Translation="uiR2EDcreature_chtde3"},
					{Id="palette.entities.creatures.chtde4", Translation="uiR2EDcreature_chtde4"},
					{Id="palette.entities.creatures.chtjf1", Translation="uiR2EDcreature_chtjf1"},
					{Id="palette.entities.creatures.chtjf2", Translation="uiR2EDcreature_chtjf2"},
					{Id="palette.entities.creatures.chtjf3", Translation="uiR2EDcreature_chtjf3"},
					{Id="palette.entities.creatures.chtjf4", Translation="uiR2EDcreature_chtjf4"},
					{Id="palette.entities.creatures.chuje1", Translation="uiR2EDcreature_chuje1"},
					{Id="palette.entities.creatures.chuje2", Translation="uiR2EDcreature_chuje2"},
					{Id="palette.entities.creatures.chuje3", Translation="uiR2EDcreature_chuje3"},
					{Id="palette.entities.creatures.chuje4", Translation="uiR2EDcreature_chuje4"},
					{Id="palette.entities.creatures.chulf1", Translation="uiR2EDcreature_chulf1"},
					{Id="palette.entities.creatures.chulf2", Translation="uiR2EDcreature_chulf2"},
					{Id="palette.entities.creatures.chulf3", Translation="uiR2EDcreature_chulf3"},
					{Id="palette.entities.creatures.chulf4", Translation="uiR2EDcreature_chulf4"},
					{Id="palette.entities.creatures.chvfe4", Translation="uiR2EDcreature_chvfe4"},
					{Id="palette.entities.creatures.chvff1", Translation="uiR2EDcreature_chvff1"},
					{Id="palette.entities.creatures.chvff2", Translation="uiR2EDcreature_chvff2"},
					{Id="palette.entities.creatures.chvff3", Translation="uiR2EDcreature_chvff3"},
					{Id="palette.entities.creatures.chvff4", Translation="uiR2EDcreature_chvff4"},
					{Id="palette.entities.creatures.chvje1", Translation="uiR2EDcreature_chvje1"},
					{Id="palette.entities.creatures.chvje2", Translation="uiR2EDcreature_chvje2"},
					{Id="palette.entities.creatures.chvje3", Translation="uiR2EDcreature_chvje3"},

					{Id="palette.entities.creatures.chvje4", Translation="uiR2EDcreature_chvje4"},
					{Id="palette.entities.creatures.chvpf4", Translation="uiR2EDcreature_chvpf4"},
					{Id="palette.entities.creatures.chwde1", Translation="uiR2EDcreature_chwde1"},
					{Id="palette.entities.creatures.chwde2", Translation="uiR2EDcreature_chwde2"},
					{Id="palette.entities.creatures.chwde3", Translation="uiR2EDcreature_chwde3"},
					{Id="palette.entities.creatures.chwde4", Translation="uiR2EDcreature_chwde4"},
					{Id="palette.entities.creatures.chwff1", Translation="uiR2EDcreature_chwff1"},
					{Id="palette.entities.creatures.chwff2", Translation="uiR2EDcreature_chwff2"},
					{Id="palette.entities.creatures.chwff3", Translation="uiR2EDcreature_chwff3"},
					{Id="palette.entities.creatures.chwff4", Translation="uiR2EDcreature_chwff4"},
					{Id="palette.entities.creatures.chxjf1", Translation="uiR2EDcreature_chxjf1"},
					{Id="palette.entities.creatures.chxjf2", Translation="uiR2EDcreature_chxjf2"},
					{Id="palette.entities.creatures.chxjf3", Translation="uiR2EDcreature_chxjf3"},
					{Id="palette.entities.creatures.chxjf4", Translation="uiR2EDcreature_chxjf4"},
					{Id="palette.entities.creatures.chxpe1", Translation="uiR2EDcreature_chxpe1"},
					{Id="palette.entities.creatures.chxpe2", Translation="uiR2EDcreature_chxpe2"},
					{Id="palette.entities.creatures.chxpe3", Translation="uiR2EDcreature_chxpe3"},
					{Id="palette.entities.creatures.chxpe4", Translation="uiR2EDcreature_chxpe4"}
				}
			},


		--	 Predators (carnivores)
			creatures_predators =
			{
				instances = 
				{
					{Id="palette.entities.creatures.ccada1", Translation="uiR2EDcreature_ccada1"},
					{Id="palette.entities.creatures.ccada2", Translation="uiR2EDcreature_ccada2"},
					{Id="palette.entities.creatures.ccadb1", Translation="uiR2EDcreature_ccadb1"},
					{Id="palette.entities.creatures.ccadb2", Translation="uiR2EDcreature_ccadb2"},
					{Id="palette.entities.creatures.ccadb3", Translation="uiR2EDcreature_ccadb3"},
					{Id="palette.entities.creatures.ccadb4", Translation="uiR2EDcreature_ccadb4"},
					{Id="palette.entities.creatures.ccafa1", Translation="uiR2EDcreature_ccafa1"},
					{Id="palette.entities.creatures.ccafa2", Translation="uiR2EDcreature_ccafa2"},
					{Id="palette.entities.creatures.ccafb1", Translation="uiR2EDcreature_ccafb1"},
					{Id="palette.entities.creatures.ccafb2", Translation="uiR2EDcreature_ccafb2"},
					{Id="palette.entities.creatures.ccafb3", Translation="uiR2EDcreature_ccafb3"},
					{Id="palette.entities.creatures.ccafb4", Translation="uiR2EDcreature_ccafb4"},
					{Id="palette.entities.creatures.ccafc1", Translation="uiR2EDcreature_ccafc1"},
					{Id="palette.entities.creatures.ccafc2", Translation="uiR2EDcreature_ccafc2"},
					{Id="palette.entities.creatures.ccafc3", Translation="uiR2EDcreature_ccafc3"},
					{Id="palette.entities.creatures.ccafc4", Translation="uiR2EDcreature_ccafc4"},
					{Id="palette.entities.creatures.ccafe4", Translation="uiR2EDcreature_ccafe4"},
				--	{Id="palette.entities.creatures.ccagb1", Translation="uiR2EDcreature_ccagb1"},
				--	{Id="palette.entities.creatures.ccagb2", Translation="uiR2EDcreature_ccagb2"},
				--	{Id="palette.entities.creatures.ccagb3", Translation="uiR2EDcreature_ccagb3"},
				--	{Id="palette.entities.creatures.ccagb4", Translation="uiR2EDcreature_ccagb4"},
				--	{Id="palette.entities.creatures.ccagc1", Translation="uiR2EDcreature_ccagc1"},
				--	{Id="palette.entities.creatures.ccagc2", Translation="uiR2EDcreature_ccagc2"},
				--	{Id="palette.entities.creatures.ccagc3", Translation="uiR2EDcreature_ccagc3"},

				--	{Id="palette.entities.creatures.ccagc4", Translation="uiR2EDcreature_ccagc4"},
				--	{Id="palette.entities.creatures.ccagd1", Translation="uiR2EDcreature_ccagd1"},
				--	{Id="palette.entities.creatures.ccagd2", Translation="uiR2EDcreature_ccagd2"},
				--	{Id="palette.entities.creatures.ccagd3", Translation="uiR2EDcreature_ccagd3"},
				--	{Id="palette.entities.creatures.ccagd4", Translation="uiR2EDcreature_ccagd4"},
				--	{Id="palette.entities.creatures.ccage1", Translation="uiR2EDcreature_ccage1"},
				--	{Id="palette.entities.creatures.ccage2", Translation="uiR2EDcreature_ccage2"},
				--	{Id="palette.entities.creatures.ccage3", Translation="uiR2EDcreature_ccage3"},
				--	{Id="palette.entities.creatures.ccage4", Translation="uiR2EDcreature_ccage4"},
				--	{Id="palette.entities.creatures.ccagf1", Translation="uiR2EDcreature_ccagf1"},
				--	{Id="palette.entities.creatures.ccagf2", Translation="uiR2EDcreature_ccagf2"},
				--	{Id="palette.entities.creatures.ccagf3", Translation="uiR2EDcreature_ccagf3"},
				--	{Id="palette.entities.creatures.ccagf4", Translation="uiR2EDcreature_ccagf4"},
					{Id="palette.entities.creatures.ccajd1", Translation="uiR2EDcreature_ccajd1"},
					{Id="palette.entities.creatures.ccajd2", Translation="uiR2EDcreature_ccajd2"},
					{Id="palette.entities.creatures.ccajd3", Translation="uiR2EDcreature_ccajd3"},
					{Id="palette.entities.creatures.ccajd4", Translation="uiR2EDcreature_ccajd4"},
					{Id="palette.entities.creatures.ccaje1", Translation="uiR2EDcreature_ccaje1"},
					{Id="palette.entities.creatures.ccaje2", Translation="uiR2EDcreature_ccaje2"},
					{Id="palette.entities.creatures.ccaje3", Translation="uiR2EDcreature_ccaje3"},
					{Id="palette.entities.creatures.ccaje4", Translation="uiR2EDcreature_ccaje4"},
					{Id="palette.entities.creatures.ccbdc1", Translation="uiR2EDcreature_ccbdc1"},
					{Id="palette.entities.creatures.ccbdc2", Translation="uiR2EDcreature_ccbdc2"},
					{Id="palette.entities.creatures.ccbdc3", Translation="uiR2EDcreature_ccbdc3"},
					{Id="palette.entities.creatures.ccbdc4", Translation="uiR2EDcreature_ccbdc4"},
				--	{Id="palette.entities.creatures.ccbgb1", Translation="uiR2EDcreature_ccbgb1"},
				--	{Id="palette.entities.creatures.ccbgb2", Translation="uiR2EDcreature_ccbgb2"},
				--	{Id="palette.entities.creatures.ccbgb3", Translation="uiR2EDcreature_ccbgb3"},
				--	{Id="palette.entities.creatures.ccbgb4", Translation="uiR2EDcreature_ccbgb4"},
				--	{Id="palette.entities.creatures.ccbgc1", Translation="uiR2EDcreature_ccbgc1"},
				--	{Id="palette.entities.creatures.ccbgc2", Translation="uiR2EDcreature_ccbgc2"},
				--	{Id="palette.entities.creatures.ccbgc3", Translation="uiR2EDcreature_ccbgc3"},
				--	{Id="palette.entities.creatures.ccbgc4", Translation="uiR2EDcreature_ccbgc4"},
				--	{Id="palette.entities.creatures.ccbgd1", Translation="uiR2EDcreature_ccbgd1"},
				--	{Id="palette.entities.creatures.ccbgd2", Translation="uiR2EDcreature_ccbgd2"},
				--	{Id="palette.entities.creatures.ccbgd3", Translation="uiR2EDcreature_ccbgd3"},
				--	{Id="palette.entities.creatures.ccbgd4", Translation="uiR2EDcreature_ccbgd4"},
				--	{Id="palette.entities.creatures.ccbge1", Translation="uiR2EDcreature_ccbge1"},
				--	{Id="palette.entities.creatures.ccbge2", Translation="uiR2EDcreature_ccbge2"},
				--	{Id="palette.entities.creatures.ccbge3", Translation="uiR2EDcreature_ccbge3"},
				--	{Id="palette.entities.creatures.ccbge4", Translation="uiR2EDcreature_ccbge4"},
				--	{Id="palette.entities.creatures.ccbgf1", Translation="uiR2EDcreature_ccbgf1"},
				--	{Id="palette.entities.creatures.ccbgf2", Translation="uiR2EDcreature_ccbgf2"},
				--	{Id="palette.entities.creatures.ccbgf3", Translation="uiR2EDcreature_ccbgf3"},
				--	{Id="palette.entities.creatures.ccbgf4", Translation="uiR2EDcreature_ccbgf4"},
					{Id="palette.entities.creatures.ccbla1", Translation="uiR2EDcreature_ccbla1"},
					{Id="palette.entities.creatures.ccbla2", Translation="uiR2EDcreature_ccbla2"},
					{Id="palette.entities.creatures.ccblb1", Translation="uiR2EDcreature_ccblb1"},
					{Id="palette.entities.creatures.ccblb2", Translation="uiR2EDcreature_ccblb2"},
					{Id="palette.entities.creatures.ccblb3", Translation="uiR2EDcreature_ccblb3"},
					{Id="palette.entities.creatures.ccblb4", Translation="uiR2EDcreature_ccblb4"},
					{Id="palette.entities.creatures.ccblc1", Translation="uiR2EDcreature_ccblc1"},
					{Id="palette.entities.creatures.ccblc2", Translation="uiR2EDcreature_ccblc2"},
					{Id="palette.entities.creatures.ccblc3", Translation="uiR2EDcreature_ccblc3"},
					{Id="palette.entities.creatures.ccblc4", Translation="uiR2EDcreature_ccblc4"},
					{Id="palette.entities.creatures.cccda1", Translation="uiR2EDcreature_cccda1"},
					{Id="palette.entities.creatures.cccda2", Translation="uiR2EDcreature_cccda2"},
					{Id="palette.entities.creatures.cccdb1", Translation="uiR2EDcreature_cccdb1"},
					{Id="palette.entities.creatures.cccdb2", Translation="uiR2EDcreature_cccdb2"},
					{Id="palette.entities.creatures.cccdb3", Translation="uiR2EDcreature_cccdb3"},
					{Id="palette.entities.creatures.cccdb4", Translation="uiR2EDcreature_cccdb4"},
					{Id="palette.entities.creatures.cccdc1", Translation="uiR2EDcreature_cccdc1"},
					{Id="palette.entities.creatures.cccdc2", Translation="uiR2EDcreature_cccdc2"},
					{Id="palette.entities.creatures.cccdc3", Translation="uiR2EDcreature_cccdc3"},
					{Id="palette.entities.creatures.cccdc4", Translation="uiR2EDcreature_cccdc4"},
					{Id="palette.entities.creatures.cccdd4", Translation="uiR2EDcreature_cccdd4"},
				--	{Id="palette.entities.creatures.cccgb1", Translation="uiR2EDcreature_cccgb1"},
				--	{Id="palette.entities.creatures.cccgb2", Translation="uiR2EDcreature_cccgb2"},
				--	{Id="palette.entities.creatures.cccgb3", Translation="uiR2EDcreature_cccgb3"},
				--	{Id="palette.entities.creatures.cccgb4", Translation="uiR2EDcreature_cccgb4"},
				--	{Id="palette.entities.creatures.cccgc1", Translation="uiR2EDcreature_cccgc1"},
				--	{Id="palette.entities.creatures.cccgc2", Translation="uiR2EDcreature_cccgc2"},
				--	{Id="palette.entities.creatures.cccgc3", Translation="uiR2EDcreature_cccgc3"},
				--	{Id="palette.entities.creatures.cccgc4", Translation="uiR2EDcreature_cccgc4"},
				--	{Id="palette.entities.creatures.cccgd1", Translation="uiR2EDcreature_cccgd1"},
				--	{Id="palette.entities.creatures.cccgd2", Translation="uiR2EDcreature_cccgd2"},
				--	{Id="palette.entities.creatures.cccgd3", Translation="uiR2EDcreature_cccgd3"},
				--	{Id="palette.entities.creatures.cccgd4", Translation="uiR2EDcreature_cccgd4"},
				--	{Id="palette.entities.creatures.cccge1", Translation="uiR2EDcreature_cccge1"},
				--	{Id="palette.entities.creatures.cccge2", Translation="uiR2EDcreature_cccge2"},
				--	{Id="palette.entities.creatures.cccge3", Translation="uiR2EDcreature_cccge3"},
				--	{Id="palette.entities.creatures.cccge4", Translation="uiR2EDcreature_cccge4"},
				--	{Id="palette.entities.creatures.cccgf1", Translation="uiR2EDcreature_cccgf1"},
				--	{Id="palette.entities.creatures.cccgf2", Translation="uiR2EDcreature_cccgf2"},
				--	{Id="palette.entities.creatures.cccgf3", Translation="uiR2EDcreature_cccgf3"},
				--	{Id="palette.entities.creatures.cccgf4", Translation="uiR2EDcreature_cccgf4"},
					{Id="palette.entities.creatures.cccla1", Translation="uiR2EDcreature_cccla1"},
					{Id="palette.entities.creatures.cccla2", Translation="uiR2EDcreature_cccla2"},
					{Id="palette.entities.creatures.ccclb1", Translation="uiR2EDcreature_ccclb1"},
					{Id="palette.entities.creatures.ccclb2", Translation="uiR2EDcreature_ccclb2"},
					{Id="palette.entities.creatures.ccclb3", Translation="uiR2EDcreature_ccclb3"},
					{Id="palette.entities.creatures.ccclb4", Translation="uiR2EDcreature_ccclb4"},
					{Id="palette.entities.creatures.ccclf4", Translation="uiR2EDcreature_ccclf4"},
					{Id="palette.entities.creatures.ccdfd1", Translation="uiR2EDcreature_ccdfd1"},
					{Id="palette.entities.creatures.ccdfd2", Translation="uiR2EDcreature_ccdfd2"},
					{Id="palette.entities.creatures.ccdfd3", Translation="uiR2EDcreature_ccdfd3"},
					{Id="palette.entities.creatures.ccdfd4", Translation="uiR2EDcreature_ccdfd4"},
					{Id="palette.entities.creatures.ccdfe1", Translation="uiR2EDcreature_ccdfe1"},
					{Id="palette.entities.creatures.ccdfe2", Translation="uiR2EDcreature_ccdfe2"},
					{Id="palette.entities.creatures.ccdfe3", Translation="uiR2EDcreature_ccdfe3"},
					{Id="palette.entities.creatures.ccdfe4", Translation="uiR2EDcreature_ccdfe4"},
				--	{Id="palette.entities.creatures.ccdgb1", Translation="uiR2EDcreature_ccdgb1"},
				--	{Id="palette.entities.creatures.ccdgb2", Translation="uiR2EDcreature_ccdgb2"},
				--	{Id="palette.entities.creatures.ccdgb3", Translation="uiR2EDcreature_ccdgb3"},
				--	{Id="palette.entities.creatures.ccdgb4", Translation="uiR2EDcreature_ccdgb4"},
				--	{Id="palette.entities.creatures.ccdgc1", Translation="uiR2EDcreature_ccdgc1"},
				--	{Id="palette.entities.creatures.ccdgc2", Translation="uiR2EDcreature_ccdgc2"},
				--	{Id="palette.entities.creatures.ccdgc3", Translation="uiR2EDcreature_ccdgc3"},
				--	{Id="palette.entities.creatures.ccdgc4", Translation="uiR2EDcreature_ccdgc4"},
				--	{Id="palette.entities.creatures.ccdgd1", Translation="uiR2EDcreature_ccdgd1"},
				--	{Id="palette.entities.creatures.ccdgd2", Translation="uiR2EDcreature_ccdgd2"},
				--	{Id="palette.entities.creatures.ccdgd3", Translation="uiR2EDcreature_ccdgd3"},
				--	{Id="palette.entities.creatures.ccdgd4", Translation="uiR2EDcreature_ccdgd4"},
				--	{Id="palette.entities.creatures.ccdge1", Translation="uiR2EDcreature_ccdge1"},
				--	{Id="palette.entities.creatures.ccdge2", Translation="uiR2EDcreature_ccdge2"},
				--	{Id="palette.entities.creatures.ccdge3", Translation="uiR2EDcreature_ccdge3"},
				--	{Id="palette.entities.creatures.ccdge4", Translation="uiR2EDcreature_ccdge4"},
				--	{Id="palette.entities.creatures.ccdgf1", Translation="uiR2EDcreature_ccdgf1"},
				--	{Id="palette.entities.creatures.ccdgf2", Translation="uiR2EDcreature_ccdgf2"},
				--	{Id="palette.entities.creatures.ccdgf3", Translation="uiR2EDcreature_ccdgf3"},
				--	{Id="palette.entities.creatures.ccdgf4", Translation="uiR2EDcreature_ccdgf4"},
					{Id="palette.entities.creatures.ccdjc1", Translation="uiR2EDcreature_ccdjc1"},
					{Id="palette.entities.creatures.ccdjc2", Translation="uiR2EDcreature_ccdjc2"},
					{Id="palette.entities.creatures.ccdjc3", Translation="uiR2EDcreature_ccdjc3"},
					{Id="palette.entities.creatures.ccdjc4", Translation="uiR2EDcreature_ccdjc4"},
					{Id="palette.entities.creatures.ccdjd1", Translation="uiR2EDcreature_ccdjd1"},
					{Id="palette.entities.creatures.ccdjd2", Translation="uiR2EDcreature_ccdjd2"},
					{Id="palette.entities.creatures.ccdjd3", Translation="uiR2EDcreature_ccdjd3"},
					{Id="palette.entities.creatures.ccdjd4", Translation="uiR2EDcreature_ccdjd4"},
					{Id="palette.entities.creatures.ccdle1", Translation="uiR2EDcreature_ccdle1"},
					{Id="palette.entities.creatures.ccdle2", Translation="uiR2EDcreature_ccdle2"},
					{Id="palette.entities.creatures.ccdle3", Translation="uiR2EDcreature_ccdle3"},
					{Id="palette.entities.creatures.ccdle4", Translation="uiR2EDcreature_ccdle4"},
					{Id="palette.entities.creatures.ccdlf1", Translation="uiR2EDcreature_ccdlf1"},
					{Id="palette.entities.creatures.ccdlf2", Translation="uiR2EDcreature_ccdlf2"},
					{Id="palette.entities.creatures.ccdlf3", Translation="uiR2EDcreature_ccdlf3"},
					{Id="palette.entities.creatures.ccdlf4", Translation="uiR2EDcreature_ccdlf4"},
					{Id="palette.entities.creatures.ccefa1", Translation="uiR2EDcreature_ccefa1"},
					{Id="palette.entities.creatures.ccefa2", Translation="uiR2EDcreature_ccefa2"},
					{Id="palette.entities.creatures.ccefb1", Translation="uiR2EDcreature_ccefb1"},
					{Id="palette.entities.creatures.ccefb2", Translation="uiR2EDcreature_ccefb2"},
					{Id="palette.entities.creatures.ccefb3", Translation="uiR2EDcreature_ccefb3"},
					{Id="palette.entities.creatures.ccefb4", Translation="uiR2EDcreature_ccefb4"},
					{Id="palette.entities.creatures.cceff4", Translation="uiR2EDcreature_cceff4"},
				--	{Id="palette.entities.creatures.ccegb1", Translation="uiR2EDcreature_ccegb1"},
				--	{Id="palette.entities.creatures.ccegb2", Translation="uiR2EDcreature_ccegb2"},
				--	{Id="palette.entities.creatures.ccegb3", Translation="uiR2EDcreature_ccegb3"},
				--	{Id="palette.entities.creatures.ccegb4", Translation="uiR2EDcreature_ccegb4"},
				--	{Id="palette.entities.creatures.ccegc1", Translation="uiR2EDcreature_ccegc1"},
				--	{Id="palette.entities.creatures.ccegc2", Translation="uiR2EDcreature_ccegc2"},
				--	{Id="palette.entities.creatures.ccegc3", Translation="uiR2EDcreature_ccegc3"},
				--	{Id="palette.entities.creatures.ccegc4", Translation="uiR2EDcreature_ccegc4"},
				--	{Id="palette.entities.creatures.ccegd1", Translation="uiR2EDcreature_ccegd1"},
				--	{Id="palette.entities.creatures.ccegd2", Translation="uiR2EDcreature_ccegd2"},
				--	{Id="palette.entities.creatures.ccegd3", Translation="uiR2EDcreature_ccegd3"},
				--	{Id="palette.entities.creatures.ccegd4", Translation="uiR2EDcreature_ccegd4"},
				--	{Id="palette.entities.creatures.ccege1", Translation="uiR2EDcreature_ccege1"},
				--	{Id="palette.entities.creatures.ccege2", Translation="uiR2EDcreature_ccege2"},
				--	{Id="palette.entities.creatures.ccege3", Translation="uiR2EDcreature_ccege3"},
				--	{Id="palette.entities.creatures.ccege4", Translation="uiR2EDcreature_ccege4"},
				--	{Id="palette.entities.creatures.ccegf1", Translation="uiR2EDcreature_ccegf1"},
				--	{Id="palette.entities.creatures.ccegf2", Translation="uiR2EDcreature_ccegf2"},
				--	{Id="palette.entities.creatures.ccegf3", Translation="uiR2EDcreature_ccegf3"},
				--	{Id="palette.entities.creatures.ccegf4", Translation="uiR2EDcreature_ccegf4"},
					{Id="palette.entities.creatures.cceja1", Translation="uiR2EDcreature_cceja1"},
					{Id="palette.entities.creatures.cceja2", Translation="uiR2EDcreature_cceja2"},
					{Id="palette.entities.creatures.ccejb1", Translation="uiR2EDcreature_ccejb1"},
					{Id="palette.entities.creatures.ccejb2", Translation="uiR2EDcreature_ccejb2"},
					{Id="palette.entities.creatures.ccejb3", Translation="uiR2EDcreature_ccejb3"},
					{Id="palette.entities.creatures.ccejb4", Translation="uiR2EDcreature_ccejb4"},
					{Id="palette.entities.creatures.ccejc1", Translation="uiR2EDcreature_ccejc1"},
					{Id="palette.entities.creatures.ccejc2", Translation="uiR2EDcreature_ccejc2"},
					{Id="palette.entities.creatures.ccejc3", Translation="uiR2EDcreature_ccejc3"},
					{Id="palette.entities.creatures.ccejc4", Translation="uiR2EDcreature_ccejc4"},
					{Id="palette.entities.creatures.ccelc1", Translation="uiR2EDcreature_ccelc1"},
					{Id="palette.entities.creatures.ccelc2", Translation="uiR2EDcreature_ccelc2"},
					{Id="palette.entities.creatures.ccelc3", Translation="uiR2EDcreature_ccelc3"},
					{Id="palette.entities.creatures.ccelc4", Translation="uiR2EDcreature_ccelc4"},
					{Id="palette.entities.creatures.cceld1", Translation="uiR2EDcreature_cceld1"},
					{Id="palette.entities.creatures.cceld2", Translation="uiR2EDcreature_cceld2"},
					{Id="palette.entities.creatures.cceld3", Translation="uiR2EDcreature_cceld3"},
					{Id="palette.entities.creatures.cceld4", Translation="uiR2EDcreature_cceld4"},
					{Id="palette.entities.creatures.ccepf4", Translation="uiR2EDcreature_ccepf4"},
				--	{Id="palette.entities.creatures.ccfgb1", Translation="uiR2EDcreature_ccfgb1"},
				--	{Id="palette.entities.creatures.ccfgb2", Translation="uiR2EDcreature_ccfgb2"},
				--	{Id="palette.entities.creatures.ccfgb3", Translation="uiR2EDcreature_ccfgb3"},
				--	{Id="palette.entities.creatures.ccfgb4", Translation="uiR2EDcreature_ccfgb4"},
				--	{Id="palette.entities.creatures.ccfgc1", Translation="uiR2EDcreature_ccfgc1"},
				--	{Id="palette.entities.creatures.ccfgc2", Translation="uiR2EDcreature_ccfgc2"},
				--	{Id="palette.entities.creatures.ccfgc3", Translation="uiR2EDcreature_ccfgc3"},
				--	{Id="palette.entities.creatures.ccfgc4", Translation="uiR2EDcreature_ccfgc4"},
				--	{Id="palette.entities.creatures.ccfgd1", Translation="uiR2EDcreature_ccfgd1"},
				--	{Id="palette.entities.creatures.ccfgd2", Translation="uiR2EDcreature_ccfgd2"},
				--	{Id="palette.entities.creatures.ccfgd3", Translation="uiR2EDcreature_ccfgd3"},
				--	{Id="palette.entities.creatures.ccfgd4", Translation="uiR2EDcreature_ccfgd4"},
				--	{Id="palette.entities.creatures.ccfge1", Translation="uiR2EDcreature_ccfge1"},
				--	{Id="palette.entities.creatures.ccfge2", Translation="uiR2EDcreature_ccfge2"},
				--	{Id="palette.entities.creatures.ccfge3", Translation="uiR2EDcreature_ccfge3"},
				--	{Id="palette.entities.creatures.ccfge4", Translation="uiR2EDcreature_ccfge4"},
				--	{Id="palette.entities.creatures.ccfgf1", Translation="uiR2EDcreature_ccfgf1"},
				--	{Id="palette.entities.creatures.ccfgf2", Translation="uiR2EDcreature_ccfgf2"},
				--	{Id="palette.entities.creatures.ccfgf3", Translation="uiR2EDcreature_ccfgf3"},
				--	{Id="palette.entities.creatures.ccfgf4", Translation="uiR2EDcreature_ccfgf4"},
					{Id="palette.entities.creatures.ccfjd4", Translation="uiR2EDcreature_ccfjd4"},
					{Id="palette.entities.creatures.ccfje1", Translation="uiR2EDcreature_ccfje1"},
					{Id="palette.entities.creatures.ccfje2", Translation="uiR2EDcreature_ccfje2"},
					{Id="palette.entities.creatures.ccfje3", Translation="uiR2EDcreature_ccfje3"},
					{Id="palette.entities.creatures.ccfje4", Translation="uiR2EDcreature_ccfje4"},
					{Id="palette.entities.creatures.ccfjf1", Translation="uiR2EDcreature_ccfjf1"},
					{Id="palette.entities.creatures.ccfjf2", Translation="uiR2EDcreature_ccfjf2"},
					{Id="palette.entities.creatures.ccfjf3", Translation="uiR2EDcreature_ccfjf3"},
					{Id="palette.entities.creatures.ccfjf4", Translation="uiR2EDcreature_ccfjf4"},
					{Id="palette.entities.creatures.ccflf1", Translation="uiR2EDcreature_ccflf1"},
					{Id="palette.entities.creatures.ccflf2", Translation="uiR2EDcreature_ccflf2"},
					{Id="palette.entities.creatures.ccflf3", Translation="uiR2EDcreature_ccflf3"},
					{Id="palette.entities.creatures.ccflf4", Translation="uiR2EDcreature_ccflf4"},
					{Id="palette.entities.creatures.ccfpe4", Translation="uiR2EDcreature_ccfpe4"},
				--	{Id="palette.entities.creatures.ccggf1", Translation="uiR2EDcreature_ccggf1"},
				--	{Id="palette.entities.creatures.ccggf2", Translation="uiR2EDcreature_ccggf2"},
				--	{Id="palette.entities.creatures.ccggf3", Translation="uiR2EDcreature_ccggf3"},
				--	{Id="palette.entities.creatures.ccggf4", Translation="uiR2EDcreature_ccggf4"},
					{Id="palette.entities.creatures.ccgpf1", Translation="uiR2EDcreature_ccgpf1"},
					{Id="palette.entities.creatures.ccgpf2", Translation="uiR2EDcreature_ccgpf2"},
					{Id="palette.entities.creatures.ccgpf3", Translation="uiR2EDcreature_ccgpf3"},
					{Id="palette.entities.creatures.ccgpf4", Translation="uiR2EDcreature_ccgpf4"},
					{Id="palette.entities.creatures.cchdd1", Translation="uiR2EDcreature_cchdd1"},
					{Id="palette.entities.creatures.cchdd2", Translation="uiR2EDcreature_cchdd2"},
					{Id="palette.entities.creatures.cchdd3", Translation="uiR2EDcreature_cchdd3"},
					{Id="palette.entities.creatures.cchdd4", Translation="uiR2EDcreature_cchdd4"},
					{Id="palette.entities.creatures.cchde1", Translation="uiR2EDcreature_cchde1"},
					{Id="palette.entities.creatures.cchde2", Translation="uiR2EDcreature_cchde2"},
					{Id="palette.entities.creatures.cchde3", Translation="uiR2EDcreature_cchde3"},
					{Id="palette.entities.creatures.cchde4", Translation="uiR2EDcreature_cchde4"},
				--	{Id="palette.entities.creatures.cchgb1", Translation="uiR2EDcreature_cchgb1"},
				--	{Id="palette.entities.creatures.cchgb2", Translation="uiR2EDcreature_cchgb2"},
				--	{Id="palette.entities.creatures.cchgb3", Translation="uiR2EDcreature_cchgb3"},
				--	{Id="palette.entities.creatures.cchgb4", Translation="uiR2EDcreature_cchgb4"},
				--	{Id="palette.entities.creatures.cchgc1", Translation="uiR2EDcreature_cchgc1"},
				--	{Id="palette.entities.creatures.cchgc2", Translation="uiR2EDcreature_cchgc2"},
				--	{Id="palette.entities.creatures.cchgc3", Translation="uiR2EDcreature_cchgc3"},
				--	{Id="palette.entities.creatures.cchgc4", Translation="uiR2EDcreature_cchgc4"},
				--	{Id="palette.entities.creatures.cchgd1", Translation="uiR2EDcreature_cchgd1"},
				--	{Id="palette.entities.creatures.cchgd2", Translation="uiR2EDcreature_cchgd2"},
				--	{Id="palette.entities.creatures.cchgd3", Translation="uiR2EDcreature_cchgd3"},
				--	{Id="palette.entities.creatures.cchgd4", Translation="uiR2EDcreature_cchgd4"},
				--	{Id="palette.entities.creatures.cchge1", Translation="uiR2EDcreature_cchge1"},
				--	{Id="palette.entities.creatures.cchge2", Translation="uiR2EDcreature_cchge2"},
				--	{Id="palette.entities.creatures.cchge3", Translation="uiR2EDcreature_cchge3"},
				--	{Id="palette.entities.creatures.cchge4", Translation="uiR2EDcreature_cchge4"},
				--	{Id="palette.entities.creatures.cchgf1", Translation="uiR2EDcreature_cchgf1"},
				--	{Id="palette.entities.creatures.cchgf2", Translation="uiR2EDcreature_cchgf2"},
				--	{Id="palette.entities.creatures.cchgf3", Translation="uiR2EDcreature_cchgf3"},
				--	{Id="palette.entities.creatures.cchgf4", Translation="uiR2EDcreature_cchgf4"},
					{Id="palette.entities.creatures.cchpe1", Translation="uiR2EDcreature_cchpe1"},
					{Id="palette.entities.creatures.cchpe2", Translation="uiR2EDcreature_cchpe2"},
					{Id="palette.entities.creatures.cchpe3", Translation="uiR2EDcreature_cchpe3"},
					{Id="palette.entities.creatures.cchpe4", Translation="uiR2EDcreature_cchpe4"},
					{Id="palette.entities.creatures.ccidd1", Translation="uiR2EDcreature_ccidd1"},
					{Id="palette.entities.creatures.ccidd2", Translation="uiR2EDcreature_ccidd2"},
					{Id="palette.entities.creatures.ccidd3", Translation="uiR2EDcreature_ccidd3"},
					{Id="palette.entities.creatures.ccidd4", Translation="uiR2EDcreature_ccidd4"},
					{Id="palette.entities.creatures.ccidf1", Translation="uiR2EDcreature_ccidf1"},
					{Id="palette.entities.creatures.ccidf2", Translation="uiR2EDcreature_ccidf2"},
					{Id="palette.entities.creatures.ccidf3", Translation="uiR2EDcreature_ccidf3"},
					{Id="palette.entities.creatures.ccidf4", Translation="uiR2EDcreature_ccidf4"},
					{Id="palette.entities.creatures.ccijf1", Translation="uiR2EDcreature_ccijf1"},
					{Id="palette.entities.creatures.ccijf2", Translation="uiR2EDcreature_ccijf2"},
					{Id="palette.entities.creatures.ccijf3", Translation="uiR2EDcreature_ccijf3"},
					{Id="palette.entities.creatures.ccijf4", Translation="uiR2EDcreature_ccijf4"},
					{Id="palette.entities.creatures.ccild1", Translation="uiR2EDcreature_ccild1"},
					{Id="palette.entities.creatures.ccild2", Translation="uiR2EDcreature_ccild2"},
					{Id="palette.entities.creatures.ccild3", Translation="uiR2EDcreature_ccild3"},
					{Id="palette.entities.creatures.ccild4", Translation="uiR2EDcreature_ccild4"},
					{Id="palette.entities.creatures.ccile1", Translation="uiR2EDcreature_ccile1"},
					{Id="palette.entities.creatures.ccile2", Translation="uiR2EDcreature_ccile2"},
					{Id="palette.entities.creatures.ccile3", Translation="uiR2EDcreature_ccile3"},
					{Id="palette.entities.creatures.ccile4", Translation="uiR2EDcreature_ccile4"},
					{Id="palette.entities.creatures.ccipd1", Translation="uiR2EDcreature_ccipd1"},
					{Id="palette.entities.creatures.ccipd2", Translation="uiR2EDcreature_ccipd2"},
					{Id="palette.entities.creatures.ccipd3", Translation="uiR2EDcreature_ccipd3"},
					{Id="palette.entities.creatures.ccipd4", Translation="uiR2EDcreature_ccipd4"},
					{Id="palette.entities.creatures.ccjfc1", Translation="uiR2EDcreature_ccjfc1"},
					{Id="palette.entities.creatures.ccjfc2", Translation="uiR2EDcreature_ccjfc2"},
					{Id="palette.entities.creatures.ccjfc3", Translation="uiR2EDcreature_ccjfc3"},
					{Id="palette.entities.creatures.ccjfc4", Translation="uiR2EDcreature_ccjfc4"},
					{Id="palette.entities.creatures.ccjfd1", Translation="uiR2EDcreature_ccjfd1"},
					{Id="palette.entities.creatures.ccjfd2", Translation="uiR2EDcreature_ccjfd2"},
					{Id="palette.entities.creatures.ccjfd3", Translation="uiR2EDcreature_ccjfd3"},
					{Id="palette.entities.creatures.ccjfd4", Translation="uiR2EDcreature_ccjfd4"},
					{Id="palette.entities.creatures.ccjja1", Translation="uiR2EDcreature_ccjja1"},
					{Id="palette.entities.creatures.ccjja2", Translation="uiR2EDcreature_ccjja2"},
					{Id="palette.entities.creatures.ccjjb1", Translation="uiR2EDcreature_ccjjb1"},
					{Id="palette.entities.creatures.ccjjb2", Translation="uiR2EDcreature_ccjjb2"},
					{Id="palette.entities.creatures.ccjjb3", Translation="uiR2EDcreature_ccjjb3"},
					{Id="palette.entities.creatures.ccjjb4", Translation="uiR2EDcreature_ccjjb4"},
					{Id="palette.entities.creatures.cckdf1", Translation="uiR2EDcreature_cckdf1"},
					{Id="palette.entities.creatures.cckdf2", Translation="uiR2EDcreature_cckdf2"},
					{Id="palette.entities.creatures.cckdf3", Translation="uiR2EDcreature_cckdf3"},
					{Id="palette.entities.creatures.cckdf4", Translation="uiR2EDcreature_cckdf4"},
					{Id="palette.entities.creatures.cckfe1", Translation="uiR2EDcreature_cckfe1"},
					{Id="palette.entities.creatures.cckfe2", Translation="uiR2EDcreature_cckfe2"},
					{Id="palette.entities.creatures.cckfe3", Translation="uiR2EDcreature_cckfe3"},
					{Id="palette.entities.creatures.cckfe4", Translation="uiR2EDcreature_cckfe4"},
					{Id="palette.entities.creatures.cckff1", Translation="uiR2EDcreature_cckff1"},
					{Id="palette.entities.creatures.cckff2", Translation="uiR2EDcreature_cckff2"},
					{Id="palette.entities.creatures.cckff3", Translation="uiR2EDcreature_cckff3"},
					{Id="palette.entities.creatures.cckff4", Translation="uiR2EDcreature_cckff4"},
					{Id="palette.entities.creatures.cclde1", Translation="uiR2EDcreature_cclde1"},
					{Id="palette.entities.creatures.cclde2", Translation="uiR2EDcreature_cclde2"},
					{Id="palette.entities.creatures.cclde3", Translation="uiR2EDcreature_cclde3"},
					{Id="palette.entities.creatures.cclde4", Translation="uiR2EDcreature_cclde4"},
					{Id="palette.entities.creatures.cclff1", Translation="uiR2EDcreature_cclff1"},
					{Id="palette.entities.creatures.cclff2", Translation="uiR2EDcreature_cclff2"},
					{Id="palette.entities.creatures.cclff3", Translation="uiR2EDcreature_cclff3"},
					{Id="palette.entities.creatures.cclff4", Translation="uiR2EDcreature_cclff4"},
					{Id="palette.entities.creatures.ccmff1", Translation="uiR2EDcreature_ccmff1"},
					{Id="palette.entities.creatures.ccmff2", Translation="uiR2EDcreature_ccmff2"},
					{Id="palette.entities.creatures.ccmff3", Translation="uiR2EDcreature_ccmff3"},
					{Id="palette.entities.creatures.ccmff4", Translation="uiR2EDcreature_ccmff4"},
				--	{Id="palette.entities.creatures.ccmgb1", Translation="uiR2EDcreature_ccmgb1"},
				--	{Id="palette.entities.creatures.ccmgb2", Translation="uiR2EDcreature_ccmgb2"},
				--	{Id="palette.entities.creatures.ccmgb3", Translation="uiR2EDcreature_ccmgb3"},
				--	{Id="palette.entities.creatures.ccmgb4", Translation="uiR2EDcreature_ccmgb4"},
				--	{Id="palette.entities.creatures.ccmgc1", Translation="uiR2EDcreature_ccmgc1"},
				--	{Id="palette.entities.creatures.ccmgc2", Translation="uiR2EDcreature_ccmgc2"},
				--	{Id="palette.entities.creatures.ccmgc3", Translation="uiR2EDcreature_ccmgc3"},
				--	{Id="palette.entities.creatures.ccmgc4", Translation="uiR2EDcreature_ccmgc4"},
				--	{Id="palette.entities.creatures.ccmgd1", Translation="uiR2EDcreature_ccmgd1"},
				--	{Id="palette.entities.creatures.ccmgd2", Translation="uiR2EDcreature_ccmgd2"},
				--	{Id="palette.entities.creatures.ccmgd3", Translation="uiR2EDcreature_ccmgd3"},
				--	{Id="palette.entities.creatures.ccmgd4", Translation="uiR2EDcreature_ccmgd4"},
				--	{Id="palette.entities.creatures.ccmge1", Translation="uiR2EDcreature_ccmge1"},
				--	{Id="palette.entities.creatures.ccmge2", Translation="uiR2EDcreature_ccmge2"},
				--	{Id="palette.entities.creatures.ccmge3", Translation="uiR2EDcreature_ccmge3"},
				--	{Id="palette.entities.creatures.ccmge4", Translation="uiR2EDcreature_ccmge4"},
				--	{Id="palette.entities.creatures.ccmgf1", Translation="uiR2EDcreature_ccmgf1"},
				--	{Id="palette.entities.creatures.ccmgf2", Translation="uiR2EDcreature_ccmgf2"},
				--	{Id="palette.entities.creatures.ccmgf3", Translation="uiR2EDcreature_ccmgf3"},
				--	{Id="palette.entities.creatures.ccmgf4", Translation="uiR2EDcreature_ccmgf4"},
					{Id="palette.entities.creatures.ccmpf1", Translation="uiR2EDcreature_ccmpf1"},
					{Id="palette.entities.creatures.ccmpf2", Translation="uiR2EDcreature_ccmpf2"},
					{Id="palette.entities.creatures.ccmpf3", Translation="uiR2EDcreature_ccmpf3"},
					{Id="palette.entities.creatures.ccmpf4", Translation="uiR2EDcreature_ccmpf4"},
					{Id="palette.entities.creatures.ccnlf1", Translation="uiR2EDcreature_ccnlf1"},
					{Id="palette.entities.creatures.ccnlf2", Translation="uiR2EDcreature_ccnlf2"},
					{Id="palette.entities.creatures.ccnlf3", Translation="uiR2EDcreature_ccnlf3"},
					{Id="palette.entities.creatures.ccnlf4", Translation="uiR2EDcreature_ccnlf4"},
					{Id="palette.entities.creatures.ccnpd1", Translation="uiR2EDcreature_ccnpd1"},
					{Id="palette.entities.creatures.ccnpd2", Translation="uiR2EDcreature_ccnpd2"},
					{Id="palette.entities.creatures.ccnpd3", Translation="uiR2EDcreature_ccnpd3"},
					{Id="palette.entities.creatures.ccnpd4", Translation="uiR2EDcreature_ccnpd4"},
					{Id="palette.entities.creatures.ccodf1", Translation="uiR2EDcreature_ccodf1"},
					{Id="palette.entities.creatures.ccodf2", Translation="uiR2EDcreature_ccodf2"},
					{Id="palette.entities.creatures.ccodf3", Translation="uiR2EDcreature_ccodf3"},
					{Id="palette.entities.creatures.ccodf4", Translation="uiR2EDcreature_ccodf4"},
					{Id="palette.entities.creatures.ccope1", Translation="uiR2EDcreature_ccope1"},
					{Id="palette.entities.creatures.ccope2", Translation="uiR2EDcreature_ccope2"},
					{Id="palette.entities.creatures.ccope3", Translation="uiR2EDcreature_ccope3"},
					{Id="palette.entities.creatures.ccope4", Translation="uiR2EDcreature_ccope4"},
					{Id="palette.entities.creatures.ccopf1", Translation="uiR2EDcreature_ccopf1"},
					{Id="palette.entities.creatures.ccopf2", Translation="uiR2EDcreature_ccopf2"},
					{Id="palette.entities.creatures.ccopf3", Translation="uiR2EDcreature_ccopf3"},
					{Id="palette.entities.creatures.ccopf4", Translation="uiR2EDcreature_ccopf4"},
					{Id="palette.entities.creatures.ccpjf1", Translation="uiR2EDcreature_ccpjf1"},
					{Id="palette.entities.creatures.ccpjf2", Translation="uiR2EDcreature_ccpjf2"},
					{Id="palette.entities.creatures.ccpjf3", Translation="uiR2EDcreature_ccpjf3"},
					{Id="palette.entities.creatures.ccpjf4", Translation="uiR2EDcreature_ccpjf4"}
				}
			},


		--	 Plants
			creatures_plants=
			{
				instances = 
				{
				--	{Id="palette.entities.creatures.cpagb1", Translation="uiR2EDcreature_cpagb1"},
				--	{Id="palette.entities.creatures.cpagb2", Translation="uiR2EDcreature_cpagb2"},
				--	{Id="palette.entities.creatures.cpagb3", Translation="uiR2EDcreature_cpagb3"},
				--	{Id="palette.entities.creatures.cpagb4", Translation="uiR2EDcreature_cpagb4"},
				--	{Id="palette.entities.creatures.cpagc1", Translation="uiR2EDcreature_cpagc1"},
				--	{Id="palette.entities.creatures.cpagc2", Translation="uiR2EDcreature_cpagc2"},
				--	{Id="palette.entities.creatures.cpagc3", Translation="uiR2EDcreature_cpagc3"},
				--	{Id="palette.entities.creatures.cpagc4", Translation="uiR2EDcreature_cpagc4"},
				--	{Id="palette.entities.creatures.cpagd1", Translation="uiR2EDcreature_cpagd1"},
				--	{Id="palette.entities.creatures.cpagd2", Translation="uiR2EDcreature_cpagd2"},
				--	{Id="palette.entities.creatures.cpagd3", Translation="uiR2EDcreature_cpagd3"},
				--	{Id="palette.entities.creatures.cpagd4", Translation="uiR2EDcreature_cpagd4"},
				--	{Id="palette.entities.creatures.cpage1", Translation="uiR2EDcreature_cpage1"},
				--	{Id="palette.entities.creatures.cpage2", Translation="uiR2EDcreature_cpage2"},
				--	{Id="palette.entities.creatures.cpage3", Translation="uiR2EDcreature_cpage3"},
				--	{Id="palette.entities.creatures.cpage4", Translation="uiR2EDcreature_cpage4"},
				--	{Id="palette.entities.creatures.cpagf1", Translation="uiR2EDcreature_cpagf1"},
				--	{Id="palette.entities.creatures.cpagf2", Translation="uiR2EDcreature_cpagf2"},
				--	{Id="palette.entities.creatures.cpagf3", Translation="uiR2EDcreature_cpagf3"},
				--	{Id="palette.entities.creatures.cpagf4", Translation="uiR2EDcreature_cpagf4"},
					{Id="palette.entities.creatures.cpapd1", Translation="uiR2EDcreature_cpapd1"},
					{Id="palette.entities.creatures.cpapd2", Translation="uiR2EDcreature_cpapd2"},
					{Id="palette.entities.creatures.cpapd3", Translation="uiR2EDcreature_cpapd3"},
					{Id="palette.entities.creatures.cpapd4", Translation="uiR2EDcreature_cpapd4"},
					{Id="palette.entities.creatures.cpape1", Translation="uiR2EDcreature_cpape1"},
					{Id="palette.entities.creatures.cpape2", Translation="uiR2EDcreature_cpape2"},
					{Id="palette.entities.creatures.cpape3", Translation="uiR2EDcreature_cpape3"},
					{Id="palette.entities.creatures.cpape4", Translation="uiR2EDcreature_cpape4"},
					{Id="palette.entities.creatures.cpapf1", Translation="uiR2EDcreature_cpapf1"},
					{Id="palette.entities.creatures.cpapf2", Translation="uiR2EDcreature_cpapf2"},
					{Id="palette.entities.creatures.cpapf3", Translation="uiR2EDcreature_cpapf3"},
					{Id="palette.entities.creatures.cpapf4", Translation="uiR2EDcreature_cpapf4"},
				--	{Id="palette.entities.creatures.cpbgb1", Translation="uiR2EDcreature_cpbgb1"},
				--	{Id="palette.entities.creatures.cpbgb2", Translation="uiR2EDcreature_cpbgb2"},
				--	{Id="palette.entities.creatures.cpbgb3", Translation="uiR2EDcreature_cpbgb3"},
				--	{Id="palette.entities.creatures.cpbgb4", Translation="uiR2EDcreature_cpbgb4"},
				--	{Id="palette.entities.creatures.cpbgc1", Translation="uiR2EDcreature_cpbgc1"},
				--	{Id="palette.entities.creatures.cpbgc2", Translation="uiR2EDcreature_cpbgc2"},
				--	{Id="palette.entities.creatures.cpbgc3", Translation="uiR2EDcreature_cpbgc3"},
				--	{Id="palette.entities.creatures.cpbgc4", Translation="uiR2EDcreature_cpbgc4"},
				--	{Id="palette.entities.creatures.cpbgd1", Translation="uiR2EDcreature_cpbgd1"},
				--	{Id="palette.entities.creatures.cpbgd2", Translation="uiR2EDcreature_cpbgd2"},
				--	{Id="palette.entities.creatures.cpbgd3", Translation="uiR2EDcreature_cpbgd3"},
				--	{Id="palette.entities.creatures.cpbgd4", Translation="uiR2EDcreature_cpbgd4"},
				--	{Id="palette.entities.creatures.cpbge1", Translation="uiR2EDcreature_cpbge1"},
				--	{Id="palette.entities.creatures.cpbge2", Translation="uiR2EDcreature_cpbge2"},
				--	{Id="palette.entities.creatures.cpbge3", Translation="uiR2EDcreature_cpbge3"},
				--	{Id="palette.entities.creatures.cpbge4", Translation="uiR2EDcreature_cpbge4"},
				--	{Id="palette.entities.creatures.cpbgf1", Translation="uiR2EDcreature_cpbgf1"},
				--	{Id="palette.entities.creatures.cpbgf2", Translation="uiR2EDcreature_cpbgf2"},
				--	{Id="palette.entities.creatures.cpbgf3", Translation="uiR2EDcreature_cpbgf3"},
				--	{Id="palette.entities.creatures.cpbgf4", Translation="uiR2EDcreature_cpbgf4"},
					{Id="palette.entities.creatures.cpblb1", Translation="uiR2EDcreature_cpblb1"},
					{Id="palette.entities.creatures.cpblb2", Translation="uiR2EDcreature_cpblb2"},
					{Id="palette.entities.creatures.cpblb3", Translation="uiR2EDcreature_cpblb3"},
					{Id="palette.entities.creatures.cpblb4", Translation="uiR2EDcreature_cpblb4"},
					{Id="palette.entities.creatures.cpblc1", Translation="uiR2EDcreature_cpblc1"},
					{Id="palette.entities.creatures.cpblc2", Translation="uiR2EDcreature_cpblc2"},
					{Id="palette.entities.creatures.cpblc3", Translation="uiR2EDcreature_cpblc3"},
					{Id="palette.entities.creatures.cpblc4", Translation="uiR2EDcreature_cpblc4"},
					{Id="palette.entities.creatures.cpbld1", Translation="uiR2EDcreature_cpbld1"},
					{Id="palette.entities.creatures.cpbld2", Translation="uiR2EDcreature_cpbld2"},
					{Id="palette.entities.creatures.cpbld3", Translation="uiR2EDcreature_cpbld3"},
					{Id="palette.entities.creatures.cpbld4", Translation="uiR2EDcreature_cpbld4"},
					{Id="palette.entities.creatures.cpblf4", Translation="uiR2EDcreature_cpblf4"},
					{Id="palette.entities.creatures.cpcfb1", Translation="uiR2EDcreature_cpcfb1"},
					{Id="palette.entities.creatures.cpcfb2", Translation="uiR2EDcreature_cpcfb2"},
					{Id="palette.entities.creatures.cpcfb3", Translation="uiR2EDcreature_cpcfb3"},
					{Id="palette.entities.creatures.cpcfb4", Translation="uiR2EDcreature_cpcfb4"},
					{Id="palette.entities.creatures.cpcfc1", Translation="uiR2EDcreature_cpcfc1"},
					{Id="palette.entities.creatures.cpcfc2", Translation="uiR2EDcreature_cpcfc2"},
					{Id="palette.entities.creatures.cpcfc3", Translation="uiR2EDcreature_cpcfc3"},
					{Id="palette.entities.creatures.cpcfc4", Translation="uiR2EDcreature_cpcfc4"},
				--	{Id="palette.entities.creatures.cpcgb1", Translation="uiR2EDcreature_cpcgb1"},
				--	{Id="palette.entities.creatures.cpcgb2", Translation="uiR2EDcreature_cpcgb2"},
				--	{Id="palette.entities.creatures.cpcgb3", Translation="uiR2EDcreature_cpcgb3"},
				--	{Id="palette.entities.creatures.cpcgb4", Translation="uiR2EDcreature_cpcgb4"},
				--	{Id="palette.entities.creatures.cpcgc1", Translation="uiR2EDcreature_cpcgc1"},
				--	{Id="palette.entities.creatures.cpcgc2", Translation="uiR2EDcreature_cpcgc2"},
				--	{Id="palette.entities.creatures.cpcgc3", Translation="uiR2EDcreature_cpcgc3"},
				--	{Id="palette.entities.creatures.cpcgc4", Translation="uiR2EDcreature_cpcgc4"},
				--	{Id="palette.entities.creatures.cpcgd1", Translation="uiR2EDcreature_cpcgd1"},
				--	{Id="palette.entities.creatures.cpcgd2", Translation="uiR2EDcreature_cpcgd2"},
				--	{Id="palette.entities.creatures.cpcgd3", Translation="uiR2EDcreature_cpcgd3"},
				--	{Id="palette.entities.creatures.cpcgd4", Translation="uiR2EDcreature_cpcgd4"},
				--	{Id="palette.entities.creatures.cpcge1", Translation="uiR2EDcreature_cpcge1"},
				--	{Id="palette.entities.creatures.cpcge2", Translation="uiR2EDcreature_cpcge2"},
				--	{Id="palette.entities.creatures.cpcge3", Translation="uiR2EDcreature_cpcge3"},
				--	{Id="palette.entities.creatures.cpcge4", Translation="uiR2EDcreature_cpcge4"},
				--	{Id="palette.entities.creatures.cpcgf1", Translation="uiR2EDcreature_cpcgf1"},
				--	{Id="palette.entities.creatures.cpcgf2", Translation="uiR2EDcreature_cpcgf2"},
				--	{Id="palette.entities.creatures.cpcgf3", Translation="uiR2EDcreature_cpcgf3"},
				--	{Id="palette.entities.creatures.cpcgf4", Translation="uiR2EDcreature_cpcgf4"},
					{Id="palette.entities.creatures.cpcjd1", Translation="uiR2EDcreature_cpcjd1"},
					{Id="palette.entities.creatures.cpcjd2", Translation="uiR2EDcreature_cpcjd2"},
					{Id="palette.entities.creatures.cpcjd3", Translation="uiR2EDcreature_cpcjd3"},
					{Id="palette.entities.creatures.cpcjd4", Translation="uiR2EDcreature_cpcjd4"},
					{Id="palette.entities.creatures.cpcje1", Translation="uiR2EDcreature_cpcje1"},
					{Id="palette.entities.creatures.cpcje2", Translation="uiR2EDcreature_cpcje2"},
					{Id="palette.entities.creatures.cpcje3", Translation="uiR2EDcreature_cpcje3"},
					{Id="palette.entities.creatures.cpcje4", Translation="uiR2EDcreature_cpcje4"},
					{Id="palette.entities.creatures.cpcpf4", Translation="uiR2EDcreature_cpcpf4"},
					{Id="palette.entities.creatures.cpdfe1", Translation="uiR2EDcreature_cpdfe1"},
					{Id="palette.entities.creatures.cpdfe2", Translation="uiR2EDcreature_cpdfe2"},
					{Id="palette.entities.creatures.cpdfe3", Translation="uiR2EDcreature_cpdfe3"},
					{Id="palette.entities.creatures.cpdfe4", Translation="uiR2EDcreature_cpdfe4"},
					{Id="palette.entities.creatures.cpdff1", Translation="uiR2EDcreature_cpdff1"},
					{Id="palette.entities.creatures.cpdff2", Translation="uiR2EDcreature_cpdff2"},
					{Id="palette.entities.creatures.cpdff3", Translation="uiR2EDcreature_cpdff3"},
					{Id="palette.entities.creatures.cpdff4", Translation="uiR2EDcreature_cpdff4"},
				--	{Id="palette.entities.creatures.cpdgb1", Translation="uiR2EDcreature_cpdgb1"},
				--	{Id="palette.entities.creatures.cpdgb2", Translation="uiR2EDcreature_cpdgb2"},
				--	{Id="palette.entities.creatures.cpdgb3", Translation="uiR2EDcreature_cpdgb3"},
				--	{Id="palette.entities.creatures.cpdgb4", Translation="uiR2EDcreature_cpdgb4"},
				--	{Id="palette.entities.creatures.cpdgc1", Translation="uiR2EDcreature_cpdgc1"},
				--	{Id="palette.entities.creatures.cpdgc2", Translation="uiR2EDcreature_cpdgc2"},
				--	{Id="palette.entities.creatures.cpdgc3", Translation="uiR2EDcreature_cpdgc3"},
				--	{Id="palette.entities.creatures.cpdgc4", Translation="uiR2EDcreature_cpdgc4"},
				--	{Id="palette.entities.creatures.cpdgd1", Translation="uiR2EDcreature_cpdgd1"},
				--	{Id="palette.entities.creatures.cpdgd2", Translation="uiR2EDcreature_cpdgd2"},
				--	{Id="palette.entities.creatures.cpdgd3", Translation="uiR2EDcreature_cpdgd3"},
				--	{Id="palette.entities.creatures.cpdgd4", Translation="uiR2EDcreature_cpdgd4"},
				--	{Id="palette.entities.creatures.cpdge1", Translation="uiR2EDcreature_cpdge1"},
				--	{Id="palette.entities.creatures.cpdge2", Translation="uiR2EDcreature_cpdge2"},
				--	{Id="palette.entities.creatures.cpdge3", Translation="uiR2EDcreature_cpdge3"},
				--	{Id="palette.entities.creatures.cpdge4", Translation="uiR2EDcreature_cpdge4"},
				--	{Id="palette.entities.creatures.cpdgf1", Translation="uiR2EDcreature_cpdgf1"},
				--	{Id="palette.entities.creatures.cpdgf2", Translation="uiR2EDcreature_cpdgf2"},
				--	{Id="palette.entities.creatures.cpdgf3", Translation="uiR2EDcreature_cpdgf3"},
				--	{Id="palette.entities.creatures.cpdgf4", Translation="uiR2EDcreature_cpdgf4"},
					{Id="palette.entities.creatures.cpdjb1", Translation="uiR2EDcreature_cpdjb1"},
					{Id="palette.entities.creatures.cpdjb2", Translation="uiR2EDcreature_cpdjb2"},
					{Id="palette.entities.creatures.cpdjb3", Translation="uiR2EDcreature_cpdjb3"},
					{Id="palette.entities.creatures.cpdjb4", Translation="uiR2EDcreature_cpdjb4"},
					{Id="palette.entities.creatures.cpdjc1", Translation="uiR2EDcreature_cpdjc1"},
					{Id="palette.entities.creatures.cpdjc2", Translation="uiR2EDcreature_cpdjc2"},
					{Id="palette.entities.creatures.cpdjc3", Translation="uiR2EDcreature_cpdjc3"},
					{Id="palette.entities.creatures.cpdjc4", Translation="uiR2EDcreature_cpdjc4"},
					{Id="palette.entities.creatures.cpdje4", Translation="uiR2EDcreature_cpdje4"},
					{Id="palette.entities.creatures.cpefd1", Translation="uiR2EDcreature_cpefd1"},
					{Id="palette.entities.creatures.cpefd2", Translation="uiR2EDcreature_cpefd2"},
					{Id="palette.entities.creatures.cpefd3", Translation="uiR2EDcreature_cpefd3"},
					{Id="palette.entities.creatures.cpefd4", Translation="uiR2EDcreature_cpefd4"},
					{Id="palette.entities.creatures.cpefe1", Translation="uiR2EDcreature_cpefe1"},
					{Id="palette.entities.creatures.cpefe2", Translation="uiR2EDcreature_cpefe2"},
					{Id="palette.entities.creatures.cpefe3", Translation="uiR2EDcreature_cpefe3"},
					{Id="palette.entities.creatures.cpefe4", Translation="uiR2EDcreature_cpefe4"},
				--	{Id="palette.entities.creatures.cpegb1", Translation="uiR2EDcreature_cpegb1"},
				--	{Id="palette.entities.creatures.cpegb2", Translation="uiR2EDcreature_cpegb2"},
				--	{Id="palette.entities.creatures.cpegb3", Translation="uiR2EDcreature_cpegb3"},
				--	{Id="palette.entities.creatures.cpegb4", Translation="uiR2EDcreature_cpegb4"},
				--	{Id="palette.entities.creatures.cpegc1", Translation="uiR2EDcreature_cpegc1"},
				--	{Id="palette.entities.creatures.cpegc2", Translation="uiR2EDcreature_cpegc2"},
				--	{Id="palette.entities.creatures.cpegc3", Translation="uiR2EDcreature_cpegc3"},
				--	{Id="palette.entities.creatures.cpegc4", Translation="uiR2EDcreature_cpegc4"},
				--	{Id="palette.entities.creatures.cpegd1", Translation="uiR2EDcreature_cpegd1"},
				--	{Id="palette.entities.creatures.cpegd2", Translation="uiR2EDcreature_cpegd2"},
				--	{Id="palette.entities.creatures.cpegd3", Translation="uiR2EDcreature_cpegd3"},
				--	{Id="palette.entities.creatures.cpegd4", Translation="uiR2EDcreature_cpegd4"},
				--	{Id="palette.entities.creatures.cpege1", Translation="uiR2EDcreature_cpege1"},
				--	{Id="palette.entities.creatures.cpege2", Translation="uiR2EDcreature_cpege2"},
				--	{Id="palette.entities.creatures.cpege3", Translation="uiR2EDcreature_cpege3"},
				--	{Id="palette.entities.creatures.cpege4", Translation="uiR2EDcreature_cpege4"},
				--	{Id="palette.entities.creatures.cpegf1", Translation="uiR2EDcreature_cpegf1"},
				--	{Id="palette.entities.creatures.cpegf2", Translation="uiR2EDcreature_cpegf2"},
				--	{Id="palette.entities.creatures.cpegf3", Translation="uiR2EDcreature_cpegf3"},
				--	{Id="palette.entities.creatures.cpegf4", Translation="uiR2EDcreature_cpegf4"},
					{Id="palette.entities.creatures.cpejf1", Translation="uiR2EDcreature_cpejf1"},
					{Id="palette.entities.creatures.cpejf2", Translation="uiR2EDcreature_cpejf2"},
					{Id="palette.entities.creatures.cpejf3", Translation="uiR2EDcreature_cpejf3"},
					{Id="palette.entities.creatures.cpejf4", Translation="uiR2EDcreature_cpejf4"},
					{Id="palette.entities.creatures.cpfdb1", Translation="uiR2EDcreature_cpfdb1"},
					{Id="palette.entities.creatures.cpfdb2", Translation="uiR2EDcreature_cpfdb2"},
					{Id="palette.entities.creatures.cpfdb3", Translation="uiR2EDcreature_cpfdb3"},
					{Id="palette.entities.creatures.cpfdb4", Translation="uiR2EDcreature_cpfdb4"},
					{Id="palette.entities.creatures.cpfdc1", Translation="uiR2EDcreature_cpfdc1"},
					{Id="palette.entities.creatures.cpfdc2", Translation="uiR2EDcreature_cpfdc2"},
					{Id="palette.entities.creatures.cpfdc3", Translation="uiR2EDcreature_cpfdc3"},
					{Id="palette.entities.creatures.cpfdc4", Translation="uiR2EDcreature_cpfdc4"},
					{Id="palette.entities.creatures.cpfdd1", Translation="uiR2EDcreature_cpfdd1"},
					{Id="palette.entities.creatures.cpfdd2", Translation="uiR2EDcreature_cpfdd2"},
					{Id="palette.entities.creatures.cpfdd3", Translation="uiR2EDcreature_cpfdd3"},
					{Id="palette.entities.creatures.cpfdd4", Translation="uiR2EDcreature_cpfdd4"},
					{Id="palette.entities.creatures.cpfdf4", Translation="uiR2EDcreature_cpfdf4"},
				--	{Id="palette.entities.creatures.cpfgb1", Translation="uiR2EDcreature_cpfgb1"},
				--	{Id="palette.entities.creatures.cpfgb2", Translation="uiR2EDcreature_cpfgb2"},
				--	{Id="palette.entities.creatures.cpfgb3", Translation="uiR2EDcreature_cpfgb3"},
				--	{Id="palette.entities.creatures.cpfgb4", Translation="uiR2EDcreature_cpfgb4"},
				--	{Id="palette.entities.creatures.cpfgc1", Translation="uiR2EDcreature_cpfgc1"},
				--	{Id="palette.entities.creatures.cpfgc2", Translation="uiR2EDcreature_cpfgc2"},
				--	{Id="palette.entities.creatures.cpfgc3", Translation="uiR2EDcreature_cpfgc3"},
				--	{Id="palette.entities.creatures.cpfgc4", Translation="uiR2EDcreature_cpfgc4"},
				--	{Id="palette.entities.creatures.cpfgd1", Translation="uiR2EDcreature_cpfgd1"},
				--	{Id="palette.entities.creatures.cpfgd2", Translation="uiR2EDcreature_cpfgd2"},
				--	{Id="palette.entities.creatures.cpfgd3", Translation="uiR2EDcreature_cpfgd3"},
				--	{Id="palette.entities.creatures.cpfgd4", Translation="uiR2EDcreature_cpfgd4"},
				--	{Id="palette.entities.creatures.cpfge1", Translation="uiR2EDcreature_cpfge1"},
				--	{Id="palette.entities.creatures.cpfge2", Translation="uiR2EDcreature_cpfge2"},
				--	{Id="palette.entities.creatures.cpfge3", Translation="uiR2EDcreature_cpfge3"},
				--	{Id="palette.entities.creatures.cpfge4", Translation="uiR2EDcreature_cpfge4"},
				--	{Id="palette.entities.creatures.cpfgf1", Translation="uiR2EDcreature_cpfgf1"},
				--	{Id="palette.entities.creatures.cpfgf2", Translation="uiR2EDcreature_cpfgf2"},
				--	{Id="palette.entities.creatures.cpfgf3", Translation="uiR2EDcreature_cpfgf3"},
				--	{Id="palette.entities.creatures.cpfgf4", Translation="uiR2EDcreature_cpfgf4"}
				}
			},


		--	 Degens (primitive tribes)
			creatures_degens =
			{
				instances = 
				{
				--	{Id="palette.entities.creatures.cdagb1", Translation="uiR2EDcreature_cdagb1"},
				--	{Id="palette.entities.creatures.cdagb2", Translation="uiR2EDcreature_cdagb2"},
				--	{Id="palette.entities.creatures.cdagb3", Translation="uiR2EDcreature_cdagb3"},
				--	{Id="palette.entities.creatures.cdagb4", Translation="uiR2EDcreature_cdagb4"},
				--	{Id="palette.entities.creatures.cdagc1", Translation="uiR2EDcreature_cdagc1"},

				--	{Id="palette.entities.creatures.cdagc2", Translation="uiR2EDcreature_cdagc2"},
				--	{Id="palette.entities.creatures.cdagc3", Translation="uiR2EDcreature_cdagc3"},
				--	{Id="palette.entities.creatures.cdagc4", Translation="uiR2EDcreature_cdagc4"},
				--	{Id="palette.entities.creatures.cdagd1", Translation="uiR2EDcreature_cdagd1"},
				--	{Id="palette.entities.creatures.cdagd2", Translation="uiR2EDcreature_cdagd2"},
				--	{Id="palette.entities.creatures.cdagd3", Translation="uiR2EDcreature_cdagd3"},
				--	{Id="palette.entities.creatures.cdagd4", Translation="uiR2EDcreature_cdagd4"},
				--	{Id="palette.entities.creatures.cdage1", Translation="uiR2EDcreature_cdage1"},
				--	{Id="palette.entities.creatures.cdage2", Translation="uiR2EDcreature_cdage2"},
				--	{Id="palette.entities.creatures.cdage3", Translation="uiR2EDcreature_cdage3"},
				--	{Id="palette.entities.creatures.cdage4", Translation="uiR2EDcreature_cdage4"},
				--	{Id="palette.entities.creatures.cdagf1", Translation="uiR2EDcreature_cdagf1"},
				--	{Id="palette.entities.creatures.cdagf2", Translation="uiR2EDcreature_cdagf2"},
				--	{Id="palette.entities.creatures.cdagf3", Translation="uiR2EDcreature_cdagf3"},
				--	{Id="palette.entities.creatures.cdagf4", Translation="uiR2EDcreature_cdagf4"},
					{Id="palette.entities.creatures.cdald1", Translation="uiR2EDcreature_cdald1"},
					{Id="palette.entities.creatures.cdald2", Translation="uiR2EDcreature_cdald2"},
					{Id="palette.entities.creatures.cdald3", Translation="uiR2EDcreature_cdald3"},
					{Id="palette.entities.creatures.cdald4", Translation="uiR2EDcreature_cdald4"},
					{Id="palette.entities.creatures.cdale1", Translation="uiR2EDcreature_cdale1"},
					{Id="palette.entities.creatures.cdale2", Translation="uiR2EDcreature_cdale2"},
					{Id="palette.entities.creatures.cdale3", Translation="uiR2EDcreature_cdale3"},
					{Id="palette.entities.creatures.cdale4", Translation="uiR2EDcreature_cdale4"},
					{Id="palette.entities.creatures.cdapd1", Translation="uiR2EDcreature_cdapd1"},
					{Id="palette.entities.creatures.cdapd2", Translation="uiR2EDcreature_cdapd2"},
					{Id="palette.entities.creatures.cdapd3", Translation="uiR2EDcreature_cdapd3"},
					{Id="palette.entities.creatures.cdapd4", Translation="uiR2EDcreature_cdapd4"},
					{Id="palette.entities.creatures.cdape1", Translation="uiR2EDcreature_cdape1"},
					{Id="palette.entities.creatures.cdape2", Translation="uiR2EDcreature_cdape2"},
					{Id="palette.entities.creatures.cdape3", Translation="uiR2EDcreature_cdape3"},
					{Id="palette.entities.creatures.cdape4", Translation="uiR2EDcreature_cdape4"},
					{Id="palette.entities.creatures.cdbfd1", Translation="uiR2EDcreature_cdbfd1"},
					{Id="palette.entities.creatures.cdbfd2", Translation="uiR2EDcreature_cdbfd2"},
					{Id="palette.entities.creatures.cdbfd3", Translation="uiR2EDcreature_cdbfd3"},
					{Id="palette.entities.creatures.cdbfd4", Translation="uiR2EDcreature_cdbfd4"},
					{Id="palette.entities.creatures.cdbfe1", Translation="uiR2EDcreature_cdbfe1"},
					{Id="palette.entities.creatures.cdbfe2", Translation="uiR2EDcreature_cdbfe2"},
					{Id="palette.entities.creatures.cdbfe3", Translation="uiR2EDcreature_cdbfe3"},
					{Id="palette.entities.creatures.cdbfe4", Translation="uiR2EDcreature_cdbfe4"},
				--	{Id="palette.entities.creatures.cdbgb1", Translation="uiR2EDcreature_cdbgb1"},
				--	{Id="palette.entities.creatures.cdbgb2", Translation="uiR2EDcreature_cdbgb2"},
				--	{Id="palette.entities.creatures.cdbgb3", Translation="uiR2EDcreature_cdbgb3"},
				--	{Id="palette.entities.creatures.cdbgb4", Translation="uiR2EDcreature_cdbgb4"},
				--	{Id="palette.entities.creatures.cdbgc1", Translation="uiR2EDcreature_cdbgc1"},
				--	{Id="palette.entities.creatures.cdbgc2", Translation="uiR2EDcreature_cdbgc2"},
				--	{Id="palette.entities.creatures.cdbgc3", Translation="uiR2EDcreature_cdbgc3"},
				--	{Id="palette.entities.creatures.cdbgc4", Translation="uiR2EDcreature_cdbgc4"},
				--	{Id="palette.entities.creatures.cdbgd1", Translation="uiR2EDcreature_cdbgd1"},
				--	{Id="palette.entities.creatures.cdbgd2", Translation="uiR2EDcreature_cdbgd2"},
				--	{Id="palette.entities.creatures.cdbgd3", Translation="uiR2EDcreature_cdbgd3"},
				--	{Id="palette.entities.creatures.cdbgd4", Translation="uiR2EDcreature_cdbgd4"},
				--	{Id="palette.entities.creatures.cdbge1", Translation="uiR2EDcreature_cdbge1"},
				--	{Id="palette.entities.creatures.cdbge2", Translation="uiR2EDcreature_cdbge2"},
				--	{Id="palette.entities.creatures.cdbge3", Translation="uiR2EDcreature_cdbge3"},
				--	{Id="palette.entities.creatures.cdbge4", Translation="uiR2EDcreature_cdbge4"},
				--	{Id="palette.entities.creatures.cdbgf1", Translation="uiR2EDcreature_cdbgf1"},
				--	{Id="palette.entities.creatures.cdbgf2", Translation="uiR2EDcreature_cdbgf2"},
				--	{Id="palette.entities.creatures.cdbgf3", Translation="uiR2EDcreature_cdbgf3"},
				--	{Id="palette.entities.creatures.cdbgf4", Translation="uiR2EDcreature_cdbgf4"},
					{Id="palette.entities.creatures.cdbjd1", Translation="uiR2EDcreature_cdbjd1"},
					{Id="palette.entities.creatures.cdbjd2", Translation="uiR2EDcreature_cdbjd2"},
					{Id="palette.entities.creatures.cdbjd3", Translation="uiR2EDcreature_cdbjd3"},
					{Id="palette.entities.creatures.cdbjd4", Translation="uiR2EDcreature_cdbjd4"},
					{Id="palette.entities.creatures.cdbje1", Translation="uiR2EDcreature_cdbje1"},
					{Id="palette.entities.creatures.cdbje2", Translation="uiR2EDcreature_cdbje2"},
					{Id="palette.entities.creatures.cdbje3", Translation="uiR2EDcreature_cdbje3"},
					{Id="palette.entities.creatures.cdbje4", Translation="uiR2EDcreature_cdbje4"},
					{Id="palette.entities.creatures.cdcdd1", Translation="uiR2EDcreature_cdcdd1"},
					{Id="palette.entities.creatures.cdcdd2", Translation="uiR2EDcreature_cdcdd2"},
					{Id="palette.entities.creatures.cdcdd3", Translation="uiR2EDcreature_cdcdd3"},
					{Id="palette.entities.creatures.cdcdd4", Translation="uiR2EDcreature_cdcdd4"},
					{Id="palette.entities.creatures.cdcde1", Translation="uiR2EDcreature_cdcde1"},
					{Id="palette.entities.creatures.cdcde2", Translation="uiR2EDcreature_cdcde2"},
					{Id="palette.entities.creatures.cdcde3", Translation="uiR2EDcreature_cdcde3"},
					{Id="palette.entities.creatures.cdcde4", Translation="uiR2EDcreature_cdcde4"},
				--	{Id="palette.entities.creatures.cdcgb1", Translation="uiR2EDcreature_cdcgb1"},
				--	{Id="palette.entities.creatures.cdcgb2", Translation="uiR2EDcreature_cdcgb2"},
				--	{Id="palette.entities.creatures.cdcgb3", Translation="uiR2EDcreature_cdcgb3"},
				--	{Id="palette.entities.creatures.cdcgb4", Translation="uiR2EDcreature_cdcgb4"},
				--	{Id="palette.entities.creatures.cdcgc1", Translation="uiR2EDcreature_cdcgc1"},
				--	{Id="palette.entities.creatures.cdcgc2", Translation="uiR2EDcreature_cdcgc2"},
				--	{Id="palette.entities.creatures.cdcgc3", Translation="uiR2EDcreature_cdcgc3"},
				--	{Id="palette.entities.creatures.cdcgc4", Translation="uiR2EDcreature_cdcgc4"},
				--	{Id="palette.entities.creatures.cdcgd1", Translation="uiR2EDcreature_cdcgd1"},
				--	{Id="palette.entities.creatures.cdcgd2", Translation="uiR2EDcreature_cdcgd2"},
				--	{Id="palette.entities.creatures.cdcgd3", Translation="uiR2EDcreature_cdcgd3"},
				--	{Id="palette.entities.creatures.cdcgd4", Translation="uiR2EDcreature_cdcgd4"},
				--	{Id="palette.entities.creatures.cdcge1", Translation="uiR2EDcreature_cdcge1"},
				--	{Id="palette.entities.creatures.cdcge2", Translation="uiR2EDcreature_cdcge2"},
				--	{Id="palette.entities.creatures.cdcge3", Translation="uiR2EDcreature_cdcge3"},
				--	{Id="palette.entities.creatures.cdcge4", Translation="uiR2EDcreature_cdcge4"},
				--	{Id="palette.entities.creatures.cdcgf1", Translation="uiR2EDcreature_cdcgf1"},
				--	{Id="palette.entities.creatures.cdcgf2", Translation="uiR2EDcreature_cdcgf2"},
				--	{Id="palette.entities.creatures.cdcgf3", Translation="uiR2EDcreature_cdcgf3"},
				--	{Id="palette.entities.creatures.cdcgf4", Translation="uiR2EDcreature_cdcgf4"}
				}
			},


		--	 Kitins
		creatures_kitins_passive=
			{
				instances = 
				{
					{Id="palette.entities.creatures.ckhda1", Translation="uiR2EDcreature_ckhda1"},
					{Id="palette.entities.creatures.ckhdb1", Translation="uiR2EDcreature_ckhdb1"},
					{Id="palette.entities.creatures.ckhdb2", Translation="uiR2EDcreature_ckhdb2"},
					{Id="palette.entities.creatures.ckhdb3", Translation="uiR2EDcreature_ckhdb3"},
					{Id="palette.entities.creatures.ckhdb4", Translation="uiR2EDcreature_ckhdb4"},
					{Id="palette.entities.creatures.ckhdc1", Translation="uiR2EDcreature_ckhdc1"},
					{Id="palette.entities.creatures.ckhdc2", Translation="uiR2EDcreature_ckhdc2"},
					{Id="palette.entities.creatures.ckhdc3", Translation="uiR2EDcreature_ckhdc3"},
					{Id="palette.entities.creatures.ckhdc4", Translation="uiR2EDcreature_ckhdc4"},
					{Id="palette.entities.creatures.ckhdd1", Translation="uiR2EDcreature_ckhdd1"},
					{Id="palette.entities.creatures.ckhdd2", Translation="uiR2EDcreature_ckhdd2"},
					{Id="palette.entities.creatures.ckhdd3", Translation="uiR2EDcreature_ckhdd3"},
					{Id="palette.entities.creatures.ckhdd4", Translation="uiR2EDcreature_ckhdd4"},
					{Id="palette.entities.creatures.ckhde1", Translation="uiR2EDcreature_ckhde1"},
					{Id="palette.entities.creatures.ckhde2", Translation="uiR2EDcreature_ckhde2"},
					{Id="palette.entities.creatures.ckhde3", Translation="uiR2EDcreature_ckhde3"},
					{Id="palette.entities.creatures.ckhde4", Translation="uiR2EDcreature_ckhde4"},
					{Id="palette.entities.creatures.ckhdf1", Translation="uiR2EDcreature_ckhdf1"},
					{Id="palette.entities.creatures.ckhdf2", Translation="uiR2EDcreature_ckhdf2"},
					{Id="palette.entities.creatures.ckhdf3", Translation="uiR2EDcreature_ckhdf3"},
					{Id="palette.entities.creatures.ckhdf4", Translation="uiR2EDcreature_ckhdf4"},
					{Id="palette.entities.creatures.ckhfa1", Translation="uiR2EDcreature_ckhfa1"},
					{Id="palette.entities.creatures.ckhfb1", Translation="uiR2EDcreature_ckhfb1"},
					{Id="palette.entities.creatures.ckhfb2", Translation="uiR2EDcreature_ckhfb2"},
					{Id="palette.entities.creatures.ckhfb3", Translation="uiR2EDcreature_ckhfb3"},
					{Id="palette.entities.creatures.ckhfb4", Translation="uiR2EDcreature_ckhfb4"},
					{Id="palette.entities.creatures.ckhfc1", Translation="uiR2EDcreature_ckhfc1"},
					{Id="palette.entities.creatures.ckhfc2", Translation="uiR2EDcreature_ckhfc2"},
					{Id="palette.entities.creatures.ckhfc3", Translation="uiR2EDcreature_ckhfc3"},
					{Id="palette.entities.creatures.ckhfc4", Translation="uiR2EDcreature_ckhfc4"},
					{Id="palette.entities.creatures.ckhfd1", Translation="uiR2EDcreature_ckhfd1"},
					{Id="palette.entities.creatures.ckhfd2", Translation="uiR2EDcreature_ckhfd2"},
					{Id="palette.entities.creatures.ckhfd3", Translation="uiR2EDcreature_ckhfd3"},
					{Id="palette.entities.creatures.ckhfd4", Translation="uiR2EDcreature_ckhfd4"},
					{Id="palette.entities.creatures.ckhfe1", Translation="uiR2EDcreature_ckhfe1"},
					{Id="palette.entities.creatures.ckhfe2", Translation="uiR2EDcreature_ckhfe2"},
					{Id="palette.entities.creatures.ckhfe3", Translation="uiR2EDcreature_ckhfe3"},
					{Id="palette.entities.creatures.ckhfe4", Translation="uiR2EDcreature_ckhfe4"},
					{Id="palette.entities.creatures.ckhff1", Translation="uiR2EDcreature_ckhff1"},
					{Id="palette.entities.creatures.ckhff2", Translation="uiR2EDcreature_ckhff2"},
					{Id="palette.entities.creatures.ckhff3", Translation="uiR2EDcreature_ckhff3"},
					{Id="palette.entities.creatures.ckhff4", Translation="uiR2EDcreature_ckhff4"},
					{Id="palette.entities.creatures.ckhja1", Translation="uiR2EDcreature_ckhja1"},
					{Id="palette.entities.creatures.ckhjb1", Translation="uiR2EDcreature_ckhjb1"},
					{Id="palette.entities.creatures.ckhjb2", Translation="uiR2EDcreature_ckhjb2"},
					{Id="palette.entities.creatures.ckhjb3", Translation="uiR2EDcreature_ckhjb3"},
					{Id="palette.entities.creatures.ckhjb4", Translation="uiR2EDcreature_ckhjb4"},
					{Id="palette.entities.creatures.ckhjc1", Translation="uiR2EDcreature_ckhjc1"},
					{Id="palette.entities.creatures.ckhjc2", Translation="uiR2EDcreature_ckhjc2"},
					{Id="palette.entities.creatures.ckhjc3", Translation="uiR2EDcreature_ckhjc3"},
					{Id="palette.entities.creatures.ckhjc4", Translation="uiR2EDcreature_ckhjc4"},
					{Id="palette.entities.creatures.ckhjd1", Translation="uiR2EDcreature_ckhjd1"},
					{Id="palette.entities.creatures.ckhjd2", Translation="uiR2EDcreature_ckhjd2"},
					{Id="palette.entities.creatures.ckhjd3", Translation="uiR2EDcreature_ckhjd3"},
					{Id="palette.entities.creatures.ckhjd4", Translation="uiR2EDcreature_ckhjd4"},
					{Id="palette.entities.creatures.ckhje1", Translation="uiR2EDcreature_ckhje1"},
					{Id="palette.entities.creatures.ckhje2", Translation="uiR2EDcreature_ckhje2"},
					{Id="palette.entities.creatures.ckhje3", Translation="uiR2EDcreature_ckhje3"},
					{Id="palette.entities.creatures.ckhje4", Translation="uiR2EDcreature_ckhje4"},
					{Id="palette.entities.creatures.ckhjf1", Translation="uiR2EDcreature_ckhjf1"},
					{Id="palette.entities.creatures.ckhjf2", Translation="uiR2EDcreature_ckhjf2"},
					{Id="palette.entities.creatures.ckhjf3", Translation="uiR2EDcreature_ckhjf3"},
					{Id="palette.entities.creatures.ckhjf4", Translation="uiR2EDcreature_ckhjf4"},
					{Id="palette.entities.creatures.ckhla1", Translation="uiR2EDcreature_ckhla1"},
					{Id="palette.entities.creatures.ckhlb1", Translation="uiR2EDcreature_ckhlb1"},
					{Id="palette.entities.creatures.ckhlb2", Translation="uiR2EDcreature_ckhlb2"},
					{Id="palette.entities.creatures.ckhlb3", Translation="uiR2EDcreature_ckhlb3"},
					{Id="palette.entities.creatures.ckhlb4", Translation="uiR2EDcreature_ckhlb4"},
					{Id="palette.entities.creatures.ckhlc1", Translation="uiR2EDcreature_ckhlc1"},
					{Id="palette.entities.creatures.ckhlc2", Translation="uiR2EDcreature_ckhlc2"},
					{Id="palette.entities.creatures.ckhlc3", Translation="uiR2EDcreature_ckhlc3"},
					{Id="palette.entities.creatures.ckhlc4", Translation="uiR2EDcreature_ckhlc4"},
					{Id="palette.entities.creatures.ckhld1", Translation="uiR2EDcreature_ckhld1"},
					{Id="palette.entities.creatures.ckhld2", Translation="uiR2EDcreature_ckhld2"},
					{Id="palette.entities.creatures.ckhld3", Translation="uiR2EDcreature_ckhld3"},
					{Id="palette.entities.creatures.ckhld4", Translation="uiR2EDcreature_ckhld4"},
					{Id="palette.entities.creatures.ckhle1", Translation="uiR2EDcreature_ckhle1"},
					{Id="palette.entities.creatures.ckhle2", Translation="uiR2EDcreature_ckhle2"},
					{Id="palette.entities.creatures.ckhle3", Translation="uiR2EDcreature_ckhle3"},
					{Id="palette.entities.creatures.ckhle4", Translation="uiR2EDcreature_ckhle4"},
					{Id="palette.entities.creatures.ckhlf1", Translation="uiR2EDcreature_ckhlf1"},
					{Id="palette.entities.creatures.ckhlf2", Translation="uiR2EDcreature_ckhlf2"},
					{Id="palette.entities.creatures.ckhlf3", Translation="uiR2EDcreature_ckhlf3"},
					{Id="palette.entities.creatures.ckhlf4", Translation="uiR2EDcreature_ckhlf4"},
					{Id="palette.entities.creatures.ckhpd1", Translation="uiR2EDcreature_ckhpd1"},
					{Id="palette.entities.creatures.ckhpd2", Translation="uiR2EDcreature_ckhpd2"},
					{Id="palette.entities.creatures.ckhpd3", Translation="uiR2EDcreature_ckhpd3"},
					{Id="palette.entities.creatures.ckhpd4", Translation="uiR2EDcreature_ckhpd4"},
					{Id="palette.entities.creatures.ckhpe1", Translation="uiR2EDcreature_ckhpe1"},
					{Id="palette.entities.creatures.ckhpe2", Translation="uiR2EDcreature_ckhpe2"},
					{Id="palette.entities.creatures.ckhpe3", Translation="uiR2EDcreature_ckhpe3"},
					{Id="palette.entities.creatures.ckhpe4", Translation="uiR2EDcreature_ckhpe4"},
					{Id="palette.entities.creatures.ckhpf1", Translation="uiR2EDcreature_ckhpf1"},
					{Id="palette.entities.creatures.ckhpf2", Translation="uiR2EDcreature_ckhpf2"},
					{Id="palette.entities.creatures.ckhpf3", Translation="uiR2EDcreature_ckhpf3"},
					{Id="palette.entities.creatures.ckhpf4", Translation="uiR2EDcreature_ckhpf4"},
					{Id="palette.entities.creatures.ckgde1", Translation="uiR2EDcreature_ckgde1"},
					{Id="palette.entities.creatures.ckgde2", Translation="uiR2EDcreature_ckgde2"},
					{Id="palette.entities.creatures.ckgde3", Translation="uiR2EDcreature_ckgde3"},
					{Id="palette.entities.creatures.ckgde4", Translation="uiR2EDcreature_ckgde4"},
					{Id="palette.entities.creatures.ckgdf1", Translation="uiR2EDcreature_ckgdf1"},
					{Id="palette.entities.creatures.ckgdf2", Translation="uiR2EDcreature_ckgdf2"},
					{Id="palette.entities.creatures.ckgdf3", Translation="uiR2EDcreature_ckgdf3"},
					{Id="palette.entities.creatures.ckgdf4", Translation="uiR2EDcreature_ckgdf4"},
					{Id="palette.entities.creatures.ckgfe1", Translation="uiR2EDcreature_ckgfe1"},
					{Id="palette.entities.creatures.ckgfe2", Translation="uiR2EDcreature_ckgfe2"},
					{Id="palette.entities.creatures.ckgfe3", Translation="uiR2EDcreature_ckgfe3"},
					{Id="palette.entities.creatures.ckgfe4", Translation="uiR2EDcreature_ckgfe4"},
					{Id="palette.entities.creatures.ckgff1", Translation="uiR2EDcreature_ckgff1"},
					{Id="palette.entities.creatures.ckgff2", Translation="uiR2EDcreature_ckgff2"},
					{Id="palette.entities.creatures.ckgff3", Translation="uiR2EDcreature_ckgff3"},
					{Id="palette.entities.creatures.ckgff4", Translation="uiR2EDcreature_ckgff4"},
				--	{Id="palette.entities.creatures.ckggb1", Translation="uiR2EDcreature_ckggb1"},
				--	{Id="palette.entities.creatures.ckggb2", Translation="uiR2EDcreature_ckggb2"},
				--	{Id="palette.entities.creatures.ckggb3", Translation="uiR2EDcreature_ckggb3"},
				--	{Id="palette.entities.creatures.ckggb4", Translation="uiR2EDcreature_ckggb4"},
				--	{Id="palette.entities.creatures.ckggc1", Translation="uiR2EDcreature_ckggc1"},
				--	{Id="palette.entities.creatures.ckggc2", Translation="uiR2EDcreature_ckggc2"},
				--	{Id="palette.entities.creatures.ckggc3", Translation="uiR2EDcreature_ckggc3"},
				--	{Id="palette.entities.creatures.ckggc4", Translation="uiR2EDcreature_ckggc4"},
				--	{Id="palette.entities.creatures.ckggd1", Translation="uiR2EDcreature_ckggd1"},
				--	{Id="palette.entities.creatures.ckggd2", Translation="uiR2EDcreature_ckggd2"},
				--	{Id="palette.entities.creatures.ckggd3", Translation="uiR2EDcreature_ckggd3"},
				--	{Id="palette.entities.creatures.ckggd4", Translation="uiR2EDcreature_ckggd4"},
				--	{Id="palette.entities.creatures.ckgge1", Translation="uiR2EDcreature_ckgge1"},
				--	{Id="palette.entities.creatures.ckgge2", Translation="uiR2EDcreature_ckgge2"},
				--	{Id="palette.entities.creatures.ckgge3", Translation="uiR2EDcreature_ckgge3"},
				--	{Id="palette.entities.creatures.ckgge4", Translation="uiR2EDcreature_ckgge4"},
				--	{Id="palette.entities.creatures.ckggf1", Translation="uiR2EDcreature_ckggf1"},
				--	{Id="palette.entities.creatures.ckggf2", Translation="uiR2EDcreature_ckggf2"},
				--	{Id="palette.entities.creatures.ckggf3", Translation="uiR2EDcreature_ckggf3"},
				--	{Id="palette.entities.creatures.ckggf4", Translation="uiR2EDcreature_ckggf4"},
					{Id="palette.entities.creatures.ckgje1", Translation="uiR2EDcreature_ckgje1"},
					{Id="palette.entities.creatures.ckgje2", Translation="uiR2EDcreature_ckgje2"},
					{Id="palette.entities.creatures.ckgje3", Translation="uiR2EDcreature_ckgje3"},
					{Id="palette.entities.creatures.ckgje4", Translation="uiR2EDcreature_ckgje4"},
					{Id="palette.entities.creatures.ckgjf1", Translation="uiR2EDcreature_ckgjf1"},
					{Id="palette.entities.creatures.ckgjf2", Translation="uiR2EDcreature_ckgjf2"},
					{Id="palette.entities.creatures.ckgjf3", Translation="uiR2EDcreature_ckgjf3"},
					{Id="palette.entities.creatures.ckgjf4", Translation="uiR2EDcreature_ckgjf4"},
					{Id="palette.entities.creatures.ckgle1", Translation="uiR2EDcreature_ckgle1"},
					{Id="palette.entities.creatures.ckgle2", Translation="uiR2EDcreature_ckgle2"},
					{Id="palette.entities.creatures.ckgle3", Translation="uiR2EDcreature_ckgle3"},
					{Id="palette.entities.creatures.ckgle4", Translation="uiR2EDcreature_ckgle4"},
					{Id="palette.entities.creatures.ckglf1", Translation="uiR2EDcreature_ckglf1"},
					{Id="palette.entities.creatures.ckglf2", Translation="uiR2EDcreature_ckglf2"},
					{Id="palette.entities.creatures.ckglf3", Translation="uiR2EDcreature_ckglf3"},
					{Id="palette.entities.creatures.ckglf4", Translation="uiR2EDcreature_ckglf4"},
					{Id="palette.entities.creatures.ckgpe1", Translation="uiR2EDcreature_ckgpe1"},
					{Id="palette.entities.creatures.ckgpe2", Translation="uiR2EDcreature_ckgpe2"},
					{Id="palette.entities.creatures.ckgpe3", Translation="uiR2EDcreature_ckgpe3"},
					{Id="palette.entities.creatures.ckgpe4", Translation="uiR2EDcreature_ckgpe4"},
					{Id="palette.entities.creatures.ckgpf1", Translation="uiR2EDcreature_ckgpf1"},
					{Id="palette.entities.creatures.ckgpf2", Translation="uiR2EDcreature_ckgpf2"},
					{Id="palette.entities.creatures.ckgpf3", Translation="uiR2EDcreature_ckgpf3"},
					{Id="palette.entities.creatures.ckgpf4", Translation="uiR2EDcreature_ckgpf4"},
					{Id="palette.entities.creatures.ckidc1", Translation="uiR2EDcreature_ckidc1"},
					{Id="palette.entities.creatures.ckidc2", Translation="uiR2EDcreature_ckidc2"},
					{Id="palette.entities.creatures.ckidc3", Translation="uiR2EDcreature_ckidc3"},
					{Id="palette.entities.creatures.ckidc4", Translation="uiR2EDcreature_ckidc4"},
					{Id="palette.entities.creatures.ckidd1", Translation="uiR2EDcreature_ckidd1"},
					{Id="palette.entities.creatures.ckidd2", Translation="uiR2EDcreature_ckidd2"},
					{Id="palette.entities.creatures.ckidd3", Translation="uiR2EDcreature_ckidd3"},
					{Id="palette.entities.creatures.ckidd4", Translation="uiR2EDcreature_ckidd4"},
					{Id="palette.entities.creatures.ckide1", Translation="uiR2EDcreature_ckide1"},
					{Id="palette.entities.creatures.ckide2", Translation="uiR2EDcreature_ckide2"},
					{Id="palette.entities.creatures.ckide3", Translation="uiR2EDcreature_ckide3"},
					{Id="palette.entities.creatures.ckide4", Translation="uiR2EDcreature_ckide4"},
					{Id="palette.entities.creatures.ckidf1", Translation="uiR2EDcreature_ckidf1"},
					{Id="palette.entities.creatures.ckidf2", Translation="uiR2EDcreature_ckidf2"},
					{Id="palette.entities.creatures.ckidf3", Translation="uiR2EDcreature_ckidf3"},
					{Id="palette.entities.creatures.ckidf4", Translation="uiR2EDcreature_ckidf4"},
					{Id="palette.entities.creatures.ckifc1", Translation="uiR2EDcreature_ckifc1"},
					{Id="palette.entities.creatures.ckifc2", Translation="uiR2EDcreature_ckifc2"},
					{Id="palette.entities.creatures.ckifc3", Translation="uiR2EDcreature_ckifc3"},
					{Id="palette.entities.creatures.ckifc4", Translation="uiR2EDcreature_ckifc4"},
					{Id="palette.entities.creatures.ckifd1", Translation="uiR2EDcreature_ckifd1"},
					{Id="palette.entities.creatures.ckifd2", Translation="uiR2EDcreature_ckifd2"},
					{Id="palette.entities.creatures.ckifd3", Translation="uiR2EDcreature_ckifd3"},
					{Id="palette.entities.creatures.ckifd4", Translation="uiR2EDcreature_ckifd4"},
					{Id="palette.entities.creatures.ckife1", Translation="uiR2EDcreature_ckife1"},
					{Id="palette.entities.creatures.ckife2", Translation="uiR2EDcreature_ckife2"},
					{Id="palette.entities.creatures.ckife3", Translation="uiR2EDcreature_ckife3"},
					{Id="palette.entities.creatures.ckife4", Translation="uiR2EDcreature_ckife4"},
					{Id="palette.entities.creatures.ckiff1", Translation="uiR2EDcreature_ckiff1"},
					{Id="palette.entities.creatures.ckiff2", Translation="uiR2EDcreature_ckiff2"},
					{Id="palette.entities.creatures.ckiff3", Translation="uiR2EDcreature_ckiff3"},
					{Id="palette.entities.creatures.ckiff4", Translation="uiR2EDcreature_ckiff4"},
				--	{Id="palette.entities.creatures.ckigb1", Translation="uiR2EDcreature_ckigb1"},
				--	{Id="palette.entities.creatures.ckigb2", Translation="uiR2EDcreature_ckigb2"},
				--	{Id="palette.entities.creatures.ckigb3", Translation="uiR2EDcreature_ckigb3"},
				--	{Id="palette.entities.creatures.ckigb4", Translation="uiR2EDcreature_ckigb4"},
				--	{Id="palette.entities.creatures.ckigc1", Translation="uiR2EDcreature_ckigc1"},
				--	{Id="palette.entities.creatures.ckigc2", Translation="uiR2EDcreature_ckigc2"},
				--	{Id="palette.entities.creatures.ckigc3", Translation="uiR2EDcreature_ckigc3"},
				--	{Id="palette.entities.creatures.ckigc4", Translation="uiR2EDcreature_ckigc4"},
				--	{Id="palette.entities.creatures.ckigd1", Translation="uiR2EDcreature_ckigd1"},
				--	{Id="palette.entities.creatures.ckigd2", Translation="uiR2EDcreature_ckigd2"},
				--	{Id="palette.entities.creatures.ckigd3", Translation="uiR2EDcreature_ckigd3"},
				--	{Id="palette.entities.creatures.ckigd4", Translation="uiR2EDcreature_ckigd4"},
				--	{Id="palette.entities.creatures.ckige1", Translation="uiR2EDcreature_ckige1"},
				--	{Id="palette.entities.creatures.ckige2", Translation="uiR2EDcreature_ckige2"},
				--	{Id="palette.entities.creatures.ckige3", Translation="uiR2EDcreature_ckige3"},
				--	{Id="palette.entities.creatures.ckige4", Translation="uiR2EDcreature_ckige4"},
				--	{Id="palette.entities.creatures.ckigf1", Translation="uiR2EDcreature_ckigf1"},
				--	{Id="palette.entities.creatures.ckigf2", Translation="uiR2EDcreature_ckigf2"},
				--	{Id="palette.entities.creatures.ckigf3", Translation="uiR2EDcreature_ckigf3"},
				--	{Id="palette.entities.creatures.ckigf4", Translation="uiR2EDcreature_ckigf4"},
					{Id="palette.entities.creatures.ckijc1", Translation="uiR2EDcreature_ckijc1"},
					{Id="palette.entities.creatures.ckijc2", Translation="uiR2EDcreature_ckijc2"},
					{Id="palette.entities.creatures.ckijc3", Translation="uiR2EDcreature_ckijc3"},
					{Id="palette.entities.creatures.ckijc4", Translation="uiR2EDcreature_ckijc4"},
					{Id="palette.entities.creatures.ckijd1", Translation="uiR2EDcreature_ckijd1"},
					{Id="palette.entities.creatures.ckijd2", Translation="uiR2EDcreature_ckijd2"},
					{Id="palette.entities.creatures.ckijd3", Translation="uiR2EDcreature_ckijd3"},
					{Id="palette.entities.creatures.ckijd4", Translation="uiR2EDcreature_ckijd4"},
					{Id="palette.entities.creatures.ckije1", Translation="uiR2EDcreature_ckije1"},
					{Id="palette.entities.creatures.ckije2", Translation="uiR2EDcreature_ckije2"},
					{Id="palette.entities.creatures.ckije3", Translation="uiR2EDcreature_ckije3"},
					{Id="palette.entities.creatures.ckije4", Translation="uiR2EDcreature_ckije4"},
					{Id="palette.entities.creatures.ckijf1", Translation="uiR2EDcreature_ckijf1"},
					{Id="palette.entities.creatures.ckijf2", Translation="uiR2EDcreature_ckijf2"},
					{Id="palette.entities.creatures.ckijf3", Translation="uiR2EDcreature_ckijf3"},
					{Id="palette.entities.creatures.ckijf4", Translation="uiR2EDcreature_ckijf4"},
					{Id="palette.entities.creatures.ckilc1", Translation="uiR2EDcreature_ckilc1"},
					{Id="palette.entities.creatures.ckilc2", Translation="uiR2EDcreature_ckilc2"},
					{Id="palette.entities.creatures.ckilc3", Translation="uiR2EDcreature_ckilc3"},
					{Id="palette.entities.creatures.ckilc4", Translation="uiR2EDcreature_ckilc4"},
					{Id="palette.entities.creatures.ckild1", Translation="uiR2EDcreature_ckild1"},
					{Id="palette.entities.creatures.ckild2", Translation="uiR2EDcreature_ckild2"},
					{Id="palette.entities.creatures.ckild3", Translation="uiR2EDcreature_ckild3"},
					{Id="palette.entities.creatures.ckild4", Translation="uiR2EDcreature_ckild4"},
					{Id="palette.entities.creatures.ckile1", Translation="uiR2EDcreature_ckile1"},
					{Id="palette.entities.creatures.ckile2", Translation="uiR2EDcreature_ckile2"},
					{Id="palette.entities.creatures.ckile3", Translation="uiR2EDcreature_ckile3"},
					{Id="palette.entities.creatures.ckile4", Translation="uiR2EDcreature_ckile4"},
					{Id="palette.entities.creatures.ckilf1", Translation="uiR2EDcreature_ckilf1"},
					{Id="palette.entities.creatures.ckilf2", Translation="uiR2EDcreature_ckilf2"},
					{Id="palette.entities.creatures.ckilf3", Translation="uiR2EDcreature_ckilf3"},
					{Id="palette.entities.creatures.ckilf4", Translation="uiR2EDcreature_ckilf4"},
					{Id="palette.entities.creatures.ckipd1", Translation="uiR2EDcreature_ckipd1"},
					{Id="palette.entities.creatures.ckipd2", Translation="uiR2EDcreature_ckipd2"},
					{Id="palette.entities.creatures.ckipd3", Translation="uiR2EDcreature_ckipd3"},
					{Id="palette.entities.creatures.ckipd4", Translation="uiR2EDcreature_ckipd4"},
					{Id="palette.entities.creatures.ckipe1", Translation="uiR2EDcreature_ckipe1"},
					{Id="palette.entities.creatures.ckipe2", Translation="uiR2EDcreature_ckipe2"},
					{Id="palette.entities.creatures.ckipe3", Translation="uiR2EDcreature_ckipe3"},
					{Id="palette.entities.creatures.ckipe4", Translation="uiR2EDcreature_ckipe4"},
					{Id="palette.entities.creatures.ckipf1", Translation="uiR2EDcreature_ckipf1"},
					{Id="palette.entities.creatures.ckipf2", Translation="uiR2EDcreature_ckipf2"},
					{Id="palette.entities.creatures.ckipf3", Translation="uiR2EDcreature_ckipf3"},
					{Id="palette.entities.creatures.ckipf4", Translation="uiR2EDcreature_ckipf4"},
				}
		},
		
			creatures_kitins=
			{
				instances = 
				{
					{Id="palette.entities.creatures.ckade1", Translation="uiR2EDcreature_ckade1"},
					{Id="palette.entities.creatures.ckade2", Translation="uiR2EDcreature_ckade2"},
					{Id="palette.entities.creatures.ckade3", Translation="uiR2EDcreature_ckade3"},
					{Id="palette.entities.creatures.ckade4", Translation="uiR2EDcreature_ckade4"},
					{Id="palette.entities.creatures.ckadf1", Translation="uiR2EDcreature_ckadf1"},
					{Id="palette.entities.creatures.ckadf2", Translation="uiR2EDcreature_ckadf2"},
					{Id="palette.entities.creatures.ckadf3", Translation="uiR2EDcreature_ckadf3"},
					{Id="palette.entities.creatures.ckadf4", Translation="uiR2EDcreature_ckadf4"},
					{Id="palette.entities.creatures.ckafe1", Translation="uiR2EDcreature_ckafe1"},
					{Id="palette.entities.creatures.ckafe2", Translation="uiR2EDcreature_ckafe2"},
					{Id="palette.entities.creatures.ckafe3", Translation="uiR2EDcreature_ckafe3"},
					{Id="palette.entities.creatures.ckafe4", Translation="uiR2EDcreature_ckafe4"},
					{Id="palette.entities.creatures.ckaff1", Translation="uiR2EDcreature_ckaff1"},
					{Id="palette.entities.creatures.ckaff2", Translation="uiR2EDcreature_ckaff2"},
					{Id="palette.entities.creatures.ckaff3", Translation="uiR2EDcreature_ckaff3"},
					{Id="palette.entities.creatures.ckaff4", Translation="uiR2EDcreature_ckaff4"},
				--	{Id="palette.entities.creatures.ckagb1", Translation="uiR2EDcreature_ckagb1"},
				--	{Id="palette.entities.creatures.ckagb2", Translation="uiR2EDcreature_ckagb2"},
				--	{Id="palette.entities.creatures.ckagb3", Translation="uiR2EDcreature_ckagb3"},
				--	{Id="palette.entities.creatures.ckagb4", Translation="uiR2EDcreature_ckagb4"},
				--	{Id="palette.entities.creatures.ckagc1", Translation="uiR2EDcreature_ckagc1"},
				--	{Id="palette.entities.creatures.ckagc2", Translation="uiR2EDcreature_ckagc2"},
				--	{Id="palette.entities.creatures.ckagc3", Translation="uiR2EDcreature_ckagc3"},
				--	{Id="palette.entities.creatures.ckagc4", Translation="uiR2EDcreature_ckagc4"},
				--	{Id="palette.entities.creatures.ckagd1", Translation="uiR2EDcreature_ckagd1"},
				--	{Id="palette.entities.creatures.ckagd2", Translation="uiR2EDcreature_ckagd2"},
				--	{Id="palette.entities.creatures.ckagd3", Translation="uiR2EDcreature_ckagd3"},
				--	{Id="palette.entities.creatures.ckagd4", Translation="uiR2EDcreature_ckagd4"},
				--	{Id="palette.entities.creatures.ckage1", Translation="uiR2EDcreature_ckage1"},
				--	{Id="palette.entities.creatures.ckage2", Translation="uiR2EDcreature_ckage2"},
				--	{Id="palette.entities.creatures.ckage3", Translation="uiR2EDcreature_ckage3"},
				--	{Id="palette.entities.creatures.ckage4", Translation="uiR2EDcreature_ckage4"},
				--	{Id="palette.entities.creatures.ckagf1", Translation="uiR2EDcreature_ckagf1"},
				--	{Id="palette.entities.creatures.ckagf2", Translation="uiR2EDcreature_ckagf2"},
				--	{Id="palette.entities.creatures.ckagf3", Translation="uiR2EDcreature_ckagf3"},
				--	{Id="palette.entities.creatures.ckagf4", Translation="uiR2EDcreature_ckagf4"},
					{Id="palette.entities.creatures.ckaje1", Translation="uiR2EDcreature_ckaje1"},
					{Id="palette.entities.creatures.ckaje2", Translation="uiR2EDcreature_ckaje2"},
					{Id="palette.entities.creatures.ckaje3", Translation="uiR2EDcreature_ckaje3"},
					{Id="palette.entities.creatures.ckaje4", Translation="uiR2EDcreature_ckaje4"},
					{Id="palette.entities.creatures.ckajf1", Translation="uiR2EDcreature_ckajf1"},
					{Id="palette.entities.creatures.ckajf2", Translation="uiR2EDcreature_ckajf2"},
					{Id="palette.entities.creatures.ckajf3", Translation="uiR2EDcreature_ckajf3"},
					{Id="palette.entities.creatures.ckajf4", Translation="uiR2EDcreature_ckajf4"},
					{Id="palette.entities.creatures.ckale1", Translation="uiR2EDcreature_ckale1"},
					{Id="palette.entities.creatures.ckale2", Translation="uiR2EDcreature_ckale2"},
					{Id="palette.entities.creatures.ckale3", Translation="uiR2EDcreature_ckale3"},
					{Id="palette.entities.creatures.ckale4", Translation="uiR2EDcreature_ckale4"},
					{Id="palette.entities.creatures.ckalf1", Translation="uiR2EDcreature_ckalf1"},
					{Id="palette.entities.creatures.ckalf2", Translation="uiR2EDcreature_ckalf2"},
					{Id="palette.entities.creatures.ckalf3", Translation="uiR2EDcreature_ckalf3"},
					{Id="palette.entities.creatures.ckalf4", Translation="uiR2EDcreature_ckalf4"},
					{Id="palette.entities.creatures.ckape1", Translation="uiR2EDcreature_ckape1"},
					{Id="palette.entities.creatures.ckape2", Translation="uiR2EDcreature_ckape2"},
					{Id="palette.entities.creatures.ckape3", Translation="uiR2EDcreature_ckape3"},
					{Id="palette.entities.creatures.ckape4", Translation="uiR2EDcreature_ckape4"},
					{Id="palette.entities.creatures.ckapf1", Translation="uiR2EDcreature_ckapf1"},
					{Id="palette.entities.creatures.ckapf2", Translation="uiR2EDcreature_ckapf2"},
					{Id="palette.entities.creatures.ckapf3", Translation="uiR2EDcreature_ckapf3"},
					{Id="palette.entities.creatures.ckapf4", Translation="uiR2EDcreature_ckapf4"},
					{Id="palette.entities.creatures.ckbde1", Translation="uiR2EDcreature_ckbde1"},
					{Id="palette.entities.creatures.ckbde2", Translation="uiR2EDcreature_ckbde2"},
					{Id="palette.entities.creatures.ckbde3", Translation="uiR2EDcreature_ckbde3"},
					{Id="palette.entities.creatures.ckbde4", Translation="uiR2EDcreature_ckbde4"},
					{Id="palette.entities.creatures.ckbdf1", Translation="uiR2EDcreature_ckbdf1"},
					{Id="palette.entities.creatures.ckbdf2", Translation="uiR2EDcreature_ckbdf2"},
					{Id="palette.entities.creatures.ckbdf3", Translation="uiR2EDcreature_ckbdf3"},
					{Id="palette.entities.creatures.ckbdf4", Translation="uiR2EDcreature_ckbdf4"},
					{Id="palette.entities.creatures.ckbfe1", Translation="uiR2EDcreature_ckbfe1"},
					{Id="palette.entities.creatures.ckbfe2", Translation="uiR2EDcreature_ckbfe2"},
					{Id="palette.entities.creatures.ckbfe3", Translation="uiR2EDcreature_ckbfe3"},
					{Id="palette.entities.creatures.ckbfe4", Translation="uiR2EDcreature_ckbfe4"},
					{Id="palette.entities.creatures.ckbff1", Translation="uiR2EDcreature_ckbff1"},
					{Id="palette.entities.creatures.ckbff2", Translation="uiR2EDcreature_ckbff2"},
					{Id="palette.entities.creatures.ckbff3", Translation="uiR2EDcreature_ckbff3"},
					{Id="palette.entities.creatures.ckbff4", Translation="uiR2EDcreature_ckbff4"},
				--	{Id="palette.entities.creatures.ckbgb1", Translation="uiR2EDcreature_ckbgb1"},
				--	{Id="palette.entities.creatures.ckbgb2", Translation="uiR2EDcreature_ckbgb2"},
				--	{Id="palette.entities.creatures.ckbgb3", Translation="uiR2EDcreature_ckbgb3"},
				--	{Id="palette.entities.creatures.ckbgb4", Translation="uiR2EDcreature_ckbgb4"},
				--	{Id="palette.entities.creatures.ckbgc1", Translation="uiR2EDcreature_ckbgc1"},
				--	{Id="palette.entities.creatures.ckbgc2", Translation="uiR2EDcreature_ckbgc2"},
				--	{Id="palette.entities.creatures.ckbgc3", Translation="uiR2EDcreature_ckbgc3"},
				--	{Id="palette.entities.creatures.ckbgc4", Translation="uiR2EDcreature_ckbgc4"},
				--	{Id="palette.entities.creatures.ckbgd1", Translation="uiR2EDcreature_ckbgd1"},
				--	{Id="palette.entities.creatures.ckbgd2", Translation="uiR2EDcreature_ckbgd2"},
				--	{Id="palette.entities.creatures.ckbgd3", Translation="uiR2EDcreature_ckbgd3"},
				--	{Id="palette.entities.creatures.ckbgd4", Translation="uiR2EDcreature_ckbgd4"},
				--	{Id="palette.entities.creatures.ckbge1", Translation="uiR2EDcreature_ckbge1"},
				--	{Id="palette.entities.creatures.ckbge2", Translation="uiR2EDcreature_ckbge2"},
				--	{Id="palette.entities.creatures.ckbge3", Translation="uiR2EDcreature_ckbge3"},
				--	{Id="palette.entities.creatures.ckbge4", Translation="uiR2EDcreature_ckbge4"},
				--	{Id="palette.entities.creatures.ckbgf1", Translation="uiR2EDcreature_ckbgf1"},
				--	{Id="palette.entities.creatures.ckbgf2", Translation="uiR2EDcreature_ckbgf2"},
				--	{Id="palette.entities.creatures.ckbgf3", Translation="uiR2EDcreature_ckbgf3"},
				--	{Id="palette.entities.creatures.ckbgf4", Translation="uiR2EDcreature_ckbgf4"},
					{Id="palette.entities.creatures.ckbje1", Translation="uiR2EDcreature_ckbje1"},
					{Id="palette.entities.creatures.ckbje2", Translation="uiR2EDcreature_ckbje2"},
					{Id="palette.entities.creatures.ckbje3", Translation="uiR2EDcreature_ckbje3"},
					{Id="palette.entities.creatures.ckbje4", Translation="uiR2EDcreature_ckbje4"},
					{Id="palette.entities.creatures.ckbjf1", Translation="uiR2EDcreature_ckbjf1"},
					{Id="palette.entities.creatures.ckbjf2", Translation="uiR2EDcreature_ckbjf2"},
					{Id="palette.entities.creatures.ckbjf3", Translation="uiR2EDcreature_ckbjf3"},
					{Id="palette.entities.creatures.ckbjf4", Translation="uiR2EDcreature_ckbjf4"},
					{Id="palette.entities.creatures.ckble1", Translation="uiR2EDcreature_ckble1"},
					{Id="palette.entities.creatures.ckble2", Translation="uiR2EDcreature_ckble2"},
					{Id="palette.entities.creatures.ckble3", Translation="uiR2EDcreature_ckble3"},
					{Id="palette.entities.creatures.ckble4", Translation="uiR2EDcreature_ckble4"},
					{Id="palette.entities.creatures.ckblf1", Translation="uiR2EDcreature_ckblf1"},
					{Id="palette.entities.creatures.ckblf2", Translation="uiR2EDcreature_ckblf2"},
					{Id="palette.entities.creatures.ckblf3", Translation="uiR2EDcreature_ckblf3"},
					{Id="palette.entities.creatures.ckblf4", Translation="uiR2EDcreature_ckblf4"},
					{Id="palette.entities.creatures.ckbpe1", Translation="uiR2EDcreature_ckbpe1"},
					{Id="palette.entities.creatures.ckbpe2", Translation="uiR2EDcreature_ckbpe2"},
					{Id="palette.entities.creatures.ckbpe3", Translation="uiR2EDcreature_ckbpe3"},
					{Id="palette.entities.creatures.ckbpe4", Translation="uiR2EDcreature_ckbpe4"},
					{Id="palette.entities.creatures.ckbpf1", Translation="uiR2EDcreature_ckbpf1"},
					{Id="palette.entities.creatures.ckbpf2", Translation="uiR2EDcreature_ckbpf2"},
					{Id="palette.entities.creatures.ckbpf3", Translation="uiR2EDcreature_ckbpf3"},
					{Id="palette.entities.creatures.ckbpf4", Translation="uiR2EDcreature_ckbpf4"},
					{Id="palette.entities.creatures.ckcde1", Translation="uiR2EDcreature_ckcde1"},
					{Id="palette.entities.creatures.ckcde2", Translation="uiR2EDcreature_ckcde2"},
					{Id="palette.entities.creatures.ckcde3", Translation="uiR2EDcreature_ckcde3"},
					{Id="palette.entities.creatures.ckcde4", Translation="uiR2EDcreature_ckcde4"},
					{Id="palette.entities.creatures.ckcdf1", Translation="uiR2EDcreature_ckcdf1"},
					{Id="palette.entities.creatures.ckcdf2", Translation="uiR2EDcreature_ckcdf2"},
					{Id="palette.entities.creatures.ckcdf3", Translation="uiR2EDcreature_ckcdf3"},
					{Id="palette.entities.creatures.ckcdf4", Translation="uiR2EDcreature_ckcdf4"},
					{Id="palette.entities.creatures.ckcfe1", Translation="uiR2EDcreature_ckcfe1"},
					{Id="palette.entities.creatures.ckcfe2", Translation="uiR2EDcreature_ckcfe2"},
					{Id="palette.entities.creatures.ckcfe3", Translation="uiR2EDcreature_ckcfe3"},
					{Id="palette.entities.creatures.ckcfe4", Translation="uiR2EDcreature_ckcfe4"},
					{Id="palette.entities.creatures.ckcff1", Translation="uiR2EDcreature_ckcff1"},
					{Id="palette.entities.creatures.ckcff2", Translation="uiR2EDcreature_ckcff2"},
					{Id="palette.entities.creatures.ckcff3", Translation="uiR2EDcreature_ckcff3"},
					{Id="palette.entities.creatures.ckcff4", Translation="uiR2EDcreature_ckcff4"},
				--	{Id="palette.entities.creatures.ckcgb1", Translation="uiR2EDcreature_ckcgb1"},
				--	{Id="palette.entities.creatures.ckcgb2", Translation="uiR2EDcreature_ckcgb2"},
				--	{Id="palette.entities.creatures.ckcgb3", Translation="uiR2EDcreature_ckcgb3"},
				--	{Id="palette.entities.creatures.ckcgb4", Translation="uiR2EDcreature_ckcgb4"},
				--	{Id="palette.entities.creatures.ckcgc1", Translation="uiR2EDcreature_ckcgc1"},
				--	{Id="palette.entities.creatures.ckcgc2", Translation="uiR2EDcreature_ckcgc2"},
				--	{Id="palette.entities.creatures.ckcgc3", Translation="uiR2EDcreature_ckcgc3"},
				--	{Id="palette.entities.creatures.ckcgc4", Translation="uiR2EDcreature_ckcgc4"},
				--	{Id="palette.entities.creatures.ckcgd1", Translation="uiR2EDcreature_ckcgd1"},
				--	{Id="palette.entities.creatures.ckcgd2", Translation="uiR2EDcreature_ckcgd2"},
				--	{Id="palette.entities.creatures.ckcgd3", Translation="uiR2EDcreature_ckcgd3"},
				--	{Id="palette.entities.creatures.ckcgd4", Translation="uiR2EDcreature_ckcgd4"},
				--	{Id="palette.entities.creatures.ckcge1", Translation="uiR2EDcreature_ckcge1"},
				--	{Id="palette.entities.creatures.ckcge2", Translation="uiR2EDcreature_ckcge2"},
				--	{Id="palette.entities.creatures.ckcge3", Translation="uiR2EDcreature_ckcge3"},
				--	{Id="palette.entities.creatures.ckcge4", Translation="uiR2EDcreature_ckcge4"},
				--	{Id="palette.entities.creatures.ckcgf1", Translation="uiR2EDcreature_ckcgf1"},
				--	{Id="palette.entities.creatures.ckcgf2", Translation="uiR2EDcreature_ckcgf2"},
				--	{Id="palette.entities.creatures.ckcgf3", Translation="uiR2EDcreature_ckcgf3"},
				--	{Id="palette.entities.creatures.ckcgf4", Translation="uiR2EDcreature_ckcgf4"},
					{Id="palette.entities.creatures.ckcje1", Translation="uiR2EDcreature_ckcje1"},
					{Id="palette.entities.creatures.ckcje2", Translation="uiR2EDcreature_ckcje2"},
					{Id="palette.entities.creatures.ckcje3", Translation="uiR2EDcreature_ckcje3"},
					{Id="palette.entities.creatures.ckcje4", Translation="uiR2EDcreature_ckcje4"},
					{Id="palette.entities.creatures.ckcjf1", Translation="uiR2EDcreature_ckcjf1"},
					{Id="palette.entities.creatures.ckcjf2", Translation="uiR2EDcreature_ckcjf2"},
					{Id="palette.entities.creatures.ckcjf3", Translation="uiR2EDcreature_ckcjf3"},
					{Id="palette.entities.creatures.ckcjf4", Translation="uiR2EDcreature_ckcjf4"},
					{Id="palette.entities.creatures.ckcle1", Translation="uiR2EDcreature_ckcle1"},
					{Id="palette.entities.creatures.ckcle2", Translation="uiR2EDcreature_ckcle2"},
					{Id="palette.entities.creatures.ckcle3", Translation="uiR2EDcreature_ckcle3"},
					{Id="palette.entities.creatures.ckcle4", Translation="uiR2EDcreature_ckcle4"},
					{Id="palette.entities.creatures.ckclf1", Translation="uiR2EDcreature_ckclf1"},
					{Id="palette.entities.creatures.ckclf2", Translation="uiR2EDcreature_ckclf2"},
					{Id="palette.entities.creatures.ckclf3", Translation="uiR2EDcreature_ckclf3"},
					{Id="palette.entities.creatures.ckclf4", Translation="uiR2EDcreature_ckclf4"},
					{Id="palette.entities.creatures.ckcpe1", Translation="uiR2EDcreature_ckcpe1"},
					{Id="palette.entities.creatures.ckcpe2", Translation="uiR2EDcreature_ckcpe2"},
					{Id="palette.entities.creatures.ckcpe3", Translation="uiR2EDcreature_ckcpe3"},
					{Id="palette.entities.creatures.ckcpe4", Translation="uiR2EDcreature_ckcpe4"},
					{Id="palette.entities.creatures.ckcpf1", Translation="uiR2EDcreature_ckcpf1"},
					{Id="palette.entities.creatures.ckcpf2", Translation="uiR2EDcreature_ckcpf2"},
					{Id="palette.entities.creatures.ckcpf3", Translation="uiR2EDcreature_ckcpf3"},
					{Id="palette.entities.creatures.ckcpf4", Translation="uiR2EDcreature_ckcpf4"},
					{Id="palette.entities.creatures.ckddd1", Translation="uiR2EDcreature_ckddd1"},
					{Id="palette.entities.creatures.ckddd2", Translation="uiR2EDcreature_ckddd2"},
					{Id="palette.entities.creatures.ckddd3", Translation="uiR2EDcreature_ckddd3"},
					{Id="palette.entities.creatures.ckddd4", Translation="uiR2EDcreature_ckddd4"},
					{Id="palette.entities.creatures.ckdde1", Translation="uiR2EDcreature_ckdde1"},
					{Id="palette.entities.creatures.ckdde2", Translation="uiR2EDcreature_ckdde2"},
					{Id="palette.entities.creatures.ckdde3", Translation="uiR2EDcreature_ckdde3"},
					{Id="palette.entities.creatures.ckdde4", Translation="uiR2EDcreature_ckdde4"},
					{Id="palette.entities.creatures.ckddf1", Translation="uiR2EDcreature_ckddf1"},
					{Id="palette.entities.creatures.ckddf2", Translation="uiR2EDcreature_ckddf2"},
					{Id="palette.entities.creatures.ckddf3", Translation="uiR2EDcreature_ckddf3"},
					{Id="palette.entities.creatures.ckddf4", Translation="uiR2EDcreature_ckddf4"},
					{Id="palette.entities.creatures.ckdfd1", Translation="uiR2EDcreature_ckdfd1"},
					{Id="palette.entities.creatures.ckdfd2", Translation="uiR2EDcreature_ckdfd2"},
					{Id="palette.entities.creatures.ckdfd3", Translation="uiR2EDcreature_ckdfd3"},
					{Id="palette.entities.creatures.ckdfd4", Translation="uiR2EDcreature_ckdfd4"},
					{Id="palette.entities.creatures.ckdfe1", Translation="uiR2EDcreature_ckdfe1"},
					{Id="palette.entities.creatures.ckdfe2", Translation="uiR2EDcreature_ckdfe2"},
					{Id="palette.entities.creatures.ckdfe3", Translation="uiR2EDcreature_ckdfe3"},
					{Id="palette.entities.creatures.ckdfe4", Translation="uiR2EDcreature_ckdfe4"},
					{Id="palette.entities.creatures.ckdff1", Translation="uiR2EDcreature_ckdff1"},
					{Id="palette.entities.creatures.ckdff2", Translation="uiR2EDcreature_ckdff2"},
					{Id="palette.entities.creatures.ckdff3", Translation="uiR2EDcreature_ckdff3"},
					{Id="palette.entities.creatures.ckdff4", Translation="uiR2EDcreature_ckdff4"},
				--	{Id="palette.entities.creatures.ckdgb1", Translation="uiR2EDcreature_ckdgb1"},
				--	{Id="palette.entities.creatures.ckdgb2", Translation="uiR2EDcreature_ckdgb2"},
				--	{Id="palette.entities.creatures.ckdgb3", Translation="uiR2EDcreature_ckdgb3"},
				--	{Id="palette.entities.creatures.ckdgb4", Translation="uiR2EDcreature_ckdgb4"},
				--	{Id="palette.entities.creatures.ckdgc1", Translation="uiR2EDcreature_ckdgc1"},
				--	{Id="palette.entities.creatures.ckdgc2", Translation="uiR2EDcreature_ckdgc2"},
				--	{Id="palette.entities.creatures.ckdgc3", Translation="uiR2EDcreature_ckdgc3"},
				--	{Id="palette.entities.creatures.ckdgc4", Translation="uiR2EDcreature_ckdgc4"},
				--	{Id="palette.entities.creatures.ckdgd1", Translation="uiR2EDcreature_ckdgd1"},
				--	{Id="palette.entities.creatures.ckdgd2", Translation="uiR2EDcreature_ckdgd2"},
				--	{Id="palette.entities.creatures.ckdgd3", Translation="uiR2EDcreature_ckdgd3"},
				--	{Id="palette.entities.creatures.ckdgd4", Translation="uiR2EDcreature_ckdgd4"},
				--	{Id="palette.entities.creatures.ckdge1", Translation="uiR2EDcreature_ckdge1"},
				--	{Id="palette.entities.creatures.ckdge2", Translation="uiR2EDcreature_ckdge2"},
				--	{Id="palette.entities.creatures.ckdge3", Translation="uiR2EDcreature_ckdge3"},
				--	{Id="palette.entities.creatures.ckdge4", Translation="uiR2EDcreature_ckdge4"},
				--	{Id="palette.entities.creatures.ckdgf1", Translation="uiR2EDcreature_ckdgf1"},
				--	{Id="palette.entities.creatures.ckdgf2", Translation="uiR2EDcreature_ckdgf2"},
				--	{Id="palette.entities.creatures.ckdgf3", Translation="uiR2EDcreature_ckdgf3"},
				--	{Id="palette.entities.creatures.ckdgf4", Translation="uiR2EDcreature_ckdgf4"},
					{Id="palette.entities.creatures.ckdjd1", Translation="uiR2EDcreature_ckdjd1"},
					{Id="palette.entities.creatures.ckdjd2", Translation="uiR2EDcreature_ckdjd2"},
					{Id="palette.entities.creatures.ckdjd3", Translation="uiR2EDcreature_ckdjd3"},
					{Id="palette.entities.creatures.ckdjd4", Translation="uiR2EDcreature_ckdjd4"},
					{Id="palette.entities.creatures.ckdje1", Translation="uiR2EDcreature_ckdje1"},
					{Id="palette.entities.creatures.ckdje2", Translation="uiR2EDcreature_ckdje2"},
					{Id="palette.entities.creatures.ckdje3", Translation="uiR2EDcreature_ckdje3"},
					{Id="palette.entities.creatures.ckdje4", Translation="uiR2EDcreature_ckdje4"},
					{Id="palette.entities.creatures.ckdjf1", Translation="uiR2EDcreature_ckdjf1"},
					{Id="palette.entities.creatures.ckdjf2", Translation="uiR2EDcreature_ckdjf2"},
					{Id="palette.entities.creatures.ckdjf3", Translation="uiR2EDcreature_ckdjf3"},
					{Id="palette.entities.creatures.ckdjf4", Translation="uiR2EDcreature_ckdjf4"},
					{Id="palette.entities.creatures.ckdld1", Translation="uiR2EDcreature_ckdld1"},
					{Id="palette.entities.creatures.ckdld2", Translation="uiR2EDcreature_ckdld2"},
					{Id="palette.entities.creatures.ckdld3", Translation="uiR2EDcreature_ckdld3"},
					{Id="palette.entities.creatures.ckdld4", Translation="uiR2EDcreature_ckdld4"},
					{Id="palette.entities.creatures.ckdle1", Translation="uiR2EDcreature_ckdle1"},
					{Id="palette.entities.creatures.ckdle2", Translation="uiR2EDcreature_ckdle2"},
					{Id="palette.entities.creatures.ckdle3", Translation="uiR2EDcreature_ckdle3"},
					{Id="palette.entities.creatures.ckdle4", Translation="uiR2EDcreature_ckdle4"},
					{Id="palette.entities.creatures.ckdlf1", Translation="uiR2EDcreature_ckdlf1"},
					{Id="palette.entities.creatures.ckdlf2", Translation="uiR2EDcreature_ckdlf2"},
					{Id="palette.entities.creatures.ckdlf3", Translation="uiR2EDcreature_ckdlf3"},
					{Id="palette.entities.creatures.ckdlf4", Translation="uiR2EDcreature_ckdlf4"},
					{Id="palette.entities.creatures.ckdpd1", Translation="uiR2EDcreature_ckdpd1"},
					{Id="palette.entities.creatures.ckdpd2", Translation="uiR2EDcreature_ckdpd2"},
					{Id="palette.entities.creatures.ckdpd3", Translation="uiR2EDcreature_ckdpd3"},
					{Id="palette.entities.creatures.ckdpd4", Translation="uiR2EDcreature_ckdpd4"},
					{Id="palette.entities.creatures.ckdpe1", Translation="uiR2EDcreature_ckdpe1"},
					{Id="palette.entities.creatures.ckdpe2", Translation="uiR2EDcreature_ckdpe2"},
					{Id="palette.entities.creatures.ckdpe3", Translation="uiR2EDcreature_ckdpe3"},
					{Id="palette.entities.creatures.ckdpe4", Translation="uiR2EDcreature_ckdpe4"},
					{Id="palette.entities.creatures.ckdpf1", Translation="uiR2EDcreature_ckdpf1"},
					{Id="palette.entities.creatures.ckdpf2", Translation="uiR2EDcreature_ckdpf2"},
					{Id="palette.entities.creatures.ckdpf3", Translation="uiR2EDcreature_ckdpf3"},
					{Id="palette.entities.creatures.ckdpf4", Translation="uiR2EDcreature_ckdpf4"},
					{Id="palette.entities.creatures.ckede1", Translation="uiR2EDcreature_ckede1"},
					{Id="palette.entities.creatures.ckede2", Translation="uiR2EDcreature_ckede2"},
					{Id="palette.entities.creatures.ckede3", Translation="uiR2EDcreature_ckede3"},
					{Id="palette.entities.creatures.ckede4", Translation="uiR2EDcreature_ckede4"},
					{Id="palette.entities.creatures.ckedf1", Translation="uiR2EDcreature_ckedf1"},
					{Id="palette.entities.creatures.ckedf2", Translation="uiR2EDcreature_ckedf2"},
					{Id="palette.entities.creatures.ckedf3", Translation="uiR2EDcreature_ckedf3"},
					{Id="palette.entities.creatures.ckedf4", Translation="uiR2EDcreature_ckedf4"},
					{Id="palette.entities.creatures.ckefe1", Translation="uiR2EDcreature_ckefe1"},
					{Id="palette.entities.creatures.ckefe2", Translation="uiR2EDcreature_ckefe2"},
					{Id="palette.entities.creatures.ckefe3", Translation="uiR2EDcreature_ckefe3"},
					{Id="palette.entities.creatures.ckefe4", Translation="uiR2EDcreature_ckefe4"},
					{Id="palette.entities.creatures.ckeff1", Translation="uiR2EDcreature_ckeff1"},
					{Id="palette.entities.creatures.ckeff2", Translation="uiR2EDcreature_ckeff2"},
					{Id="palette.entities.creatures.ckeff3", Translation="uiR2EDcreature_ckeff3"},
					{Id="palette.entities.creatures.ckeff4", Translation="uiR2EDcreature_ckeff4"},
				--	{Id="palette.entities.creatures.ckegb1", Translation="uiR2EDcreature_ckegb1"},
				--	{Id="palette.entities.creatures.ckegb2", Translation="uiR2EDcreature_ckegb2"},
				--	{Id="palette.entities.creatures.ckegb3", Translation="uiR2EDcreature_ckegb3"},
				--	{Id="palette.entities.creatures.ckegb4", Translation="uiR2EDcreature_ckegb4"},
				--	{Id="palette.entities.creatures.ckegc1", Translation="uiR2EDcreature_ckegc1"},
				--	{Id="palette.entities.creatures.ckegc2", Translation="uiR2EDcreature_ckegc2"},
				--	{Id="palette.entities.creatures.ckegc3", Translation="uiR2EDcreature_ckegc3"},
				--	{Id="palette.entities.creatures.ckegc4", Translation="uiR2EDcreature_ckegc4"},
				--	{Id="palette.entities.creatures.ckegd1", Translation="uiR2EDcreature_ckegd1"},
				--	{Id="palette.entities.creatures.ckegd2", Translation="uiR2EDcreature_ckegd2"},
				--	{Id="palette.entities.creatures.ckegd3", Translation="uiR2EDcreature_ckegd3"},
				--	{Id="palette.entities.creatures.ckegd4", Translation="uiR2EDcreature_ckegd4"},
				--	{Id="palette.entities.creatures.ckege1", Translation="uiR2EDcreature_ckege1"},
				--	{Id="palette.entities.creatures.ckege2", Translation="uiR2EDcreature_ckege2"},
				--	{Id="palette.entities.creatures.ckege3", Translation="uiR2EDcreature_ckege3"},
				--	{Id="palette.entities.creatures.ckege4", Translation="uiR2EDcreature_ckege4"},
				--	{Id="palette.entities.creatures.ckegf1", Translation="uiR2EDcreature_ckegf1"},
				--	{Id="palette.entities.creatures.ckegf2", Translation="uiR2EDcreature_ckegf2"},
				--	{Id="palette.entities.creatures.ckegf3", Translation="uiR2EDcreature_ckegf3"},
				--	{Id="palette.entities.creatures.ckegf4", Translation="uiR2EDcreature_ckegf4"},
					{Id="palette.entities.creatures.ckeje1", Translation="uiR2EDcreature_ckeje1"},
					{Id="palette.entities.creatures.ckeje2", Translation="uiR2EDcreature_ckeje2"},
					{Id="palette.entities.creatures.ckeje3", Translation="uiR2EDcreature_ckeje3"},
					{Id="palette.entities.creatures.ckeje4", Translation="uiR2EDcreature_ckeje4"},
					{Id="palette.entities.creatures.ckejf1", Translation="uiR2EDcreature_ckejf1"},
					{Id="palette.entities.creatures.ckejf2", Translation="uiR2EDcreature_ckejf2"},
					{Id="palette.entities.creatures.ckejf3", Translation="uiR2EDcreature_ckejf3"},
					{Id="palette.entities.creatures.ckejf4", Translation="uiR2EDcreature_ckejf4"},
					{Id="palette.entities.creatures.ckele1", Translation="uiR2EDcreature_ckele1"},
					{Id="palette.entities.creatures.ckele2", Translation="uiR2EDcreature_ckele2"},
					{Id="palette.entities.creatures.ckele3", Translation="uiR2EDcreature_ckele3"},
					{Id="palette.entities.creatures.ckele4", Translation="uiR2EDcreature_ckele4"},
					{Id="palette.entities.creatures.ckelf1", Translation="uiR2EDcreature_ckelf1"},
					{Id="palette.entities.creatures.ckelf2", Translation="uiR2EDcreature_ckelf2"},
					{Id="palette.entities.creatures.ckelf3", Translation="uiR2EDcreature_ckelf3"},
					{Id="palette.entities.creatures.ckelf4", Translation="uiR2EDcreature_ckelf4"},
					{Id="palette.entities.creatures.ckepe1", Translation="uiR2EDcreature_ckepe1"},
					{Id="palette.entities.creatures.ckepe2", Translation="uiR2EDcreature_ckepe2"},
					{Id="palette.entities.creatures.ckepe3", Translation="uiR2EDcreature_ckepe3"},
					{Id="palette.entities.creatures.ckepe4", Translation="uiR2EDcreature_ckepe4"},
					{Id="palette.entities.creatures.ckepf1", Translation="uiR2EDcreature_ckepf1"},
					{Id="palette.entities.creatures.ckepf2", Translation="uiR2EDcreature_ckepf2"},
					{Id="palette.entities.creatures.ckepf3", Translation="uiR2EDcreature_ckepf3"},
					{Id="palette.entities.creatures.ckepf4", Translation="uiR2EDcreature_ckepf4"},
					{Id="palette.entities.creatures.ckfde1", Translation="uiR2EDcreature_ckfde1"},
					{Id="palette.entities.creatures.ckfde2", Translation="uiR2EDcreature_ckfde2"},
					{Id="palette.entities.creatures.ckfde3", Translation="uiR2EDcreature_ckfde3"},
					{Id="palette.entities.creatures.ckfde4", Translation="uiR2EDcreature_ckfde4"},
					{Id="palette.entities.creatures.ckfdf1", Translation="uiR2EDcreature_ckfdf1"},
					{Id="palette.entities.creatures.ckfdf2", Translation="uiR2EDcreature_ckfdf2"},
					{Id="palette.entities.creatures.ckfdf3", Translation="uiR2EDcreature_ckfdf3"},
					{Id="palette.entities.creatures.ckfdf4", Translation="uiR2EDcreature_ckfdf4"},
					{Id="palette.entities.creatures.ckffe1", Translation="uiR2EDcreature_ckffe1"},
					{Id="palette.entities.creatures.ckffe2", Translation="uiR2EDcreature_ckffe2"},
					{Id="palette.entities.creatures.ckffe3", Translation="uiR2EDcreature_ckffe3"},
					{Id="palette.entities.creatures.ckffe4", Translation="uiR2EDcreature_ckffe4"},
					{Id="palette.entities.creatures.ckfff1", Translation="uiR2EDcreature_ckfff1"},
					{Id="palette.entities.creatures.ckfff2", Translation="uiR2EDcreature_ckfff2"},
					{Id="palette.entities.creatures.ckfff3", Translation="uiR2EDcreature_ckfff3"},
					{Id="palette.entities.creatures.ckfff4", Translation="uiR2EDcreature_ckfff4"},
					{Id="palette.entities.creatures.ckfje1", Translation="uiR2EDcreature_ckfje1"},
					{Id="palette.entities.creatures.ckfje2", Translation="uiR2EDcreature_ckfje2"},
					{Id="palette.entities.creatures.ckfje3", Translation="uiR2EDcreature_ckfje3"},
					{Id="palette.entities.creatures.ckfje4", Translation="uiR2EDcreature_ckfje4"},
					{Id="palette.entities.creatures.ckfjf1", Translation="uiR2EDcreature_ckfjf1"},
					{Id="palette.entities.creatures.ckfjf2", Translation="uiR2EDcreature_ckfjf2"},
					{Id="palette.entities.creatures.ckfjf3", Translation="uiR2EDcreature_ckfjf3"},
					{Id="palette.entities.creatures.ckfjf4", Translation="uiR2EDcreature_ckfjf4"},
					{Id="palette.entities.creatures.ckfle1", Translation="uiR2EDcreature_ckfle1"},
					{Id="palette.entities.creatures.ckfle2", Translation="uiR2EDcreature_ckfle2"},
					{Id="palette.entities.creatures.ckfle3", Translation="uiR2EDcreature_ckfle3"},
					{Id="palette.entities.creatures.ckfle4", Translation="uiR2EDcreature_ckfle4"},
					{Id="palette.entities.creatures.ckflf1", Translation="uiR2EDcreature_ckflf1"},
					{Id="palette.entities.creatures.ckflf2", Translation="uiR2EDcreature_ckflf2"},
					{Id="palette.entities.creatures.ckflf3", Translation="uiR2EDcreature_ckflf3"},
					{Id="palette.entities.creatures.ckflf4", Translation="uiR2EDcreature_ckflf4"},
					{Id="palette.entities.creatures.ckfpe1", Translation="uiR2EDcreature_ckfpe1"},
					{Id="palette.entities.creatures.ckfpe2", Translation="uiR2EDcreature_ckfpe2"},
					{Id="palette.entities.creatures.ckfpe3", Translation="uiR2EDcreature_ckfpe3"},
					{Id="palette.entities.creatures.ckfpe4", Translation="uiR2EDcreature_ckfpe4"},
					{Id="palette.entities.creatures.ckfpf1", Translation="uiR2EDcreature_ckfpf1"},
					{Id="palette.entities.creatures.ckfpf2", Translation="uiR2EDcreature_ckfpf2"},
					{Id="palette.entities.creatures.ckfpf3", Translation="uiR2EDcreature_ckfpf3"},
					{Id="palette.entities.creatures.ckfpf4", Translation="uiR2EDcreature_ckfpf4"},
					{Id="palette.entities.creatures.ckjdd1", Translation="uiR2EDcreature_ckjdd1"},
					{Id="palette.entities.creatures.ckjdd2", Translation="uiR2EDcreature_ckjdd2"},
					{Id="palette.entities.creatures.ckjdd3", Translation="uiR2EDcreature_ckjdd3"},
					{Id="palette.entities.creatures.ckjdd4", Translation="uiR2EDcreature_ckjdd4"},
					{Id="palette.entities.creatures.ckjde1", Translation="uiR2EDcreature_ckjde1"},
					{Id="palette.entities.creatures.ckjde2", Translation="uiR2EDcreature_ckjde2"},
					{Id="palette.entities.creatures.ckjde3", Translation="uiR2EDcreature_ckjde3"},
					{Id="palette.entities.creatures.ckjde4", Translation="uiR2EDcreature_ckjde4"},
					{Id="palette.entities.creatures.ckjdf1", Translation="uiR2EDcreature_ckjdf1"},
					{Id="palette.entities.creatures.ckjdf2", Translation="uiR2EDcreature_ckjdf2"},
					{Id="palette.entities.creatures.ckjdf3", Translation="uiR2EDcreature_ckjdf3"},
					{Id="palette.entities.creatures.ckjdf4", Translation="uiR2EDcreature_ckjdf4"},
					{Id="palette.entities.creatures.ckjfd1", Translation="uiR2EDcreature_ckjfd1"},
					{Id="palette.entities.creatures.ckjfd2", Translation="uiR2EDcreature_ckjfd2"},
					{Id="palette.entities.creatures.ckjfd3", Translation="uiR2EDcreature_ckjfd3"},
					{Id="palette.entities.creatures.ckjfd4", Translation="uiR2EDcreature_ckjfd4"},
					{Id="palette.entities.creatures.ckjfe1", Translation="uiR2EDcreature_ckjfe1"},
					{Id="palette.entities.creatures.ckjfe2", Translation="uiR2EDcreature_ckjfe2"},
					{Id="palette.entities.creatures.ckjfe3", Translation="uiR2EDcreature_ckjfe3"},
					{Id="palette.entities.creatures.ckjfe4", Translation="uiR2EDcreature_ckjfe4"},
					{Id="palette.entities.creatures.ckjff1", Translation="uiR2EDcreature_ckjff1"},
					{Id="palette.entities.creatures.ckjff2", Translation="uiR2EDcreature_ckjff2"},
					{Id="palette.entities.creatures.ckjff3", Translation="uiR2EDcreature_ckjff3"},
					{Id="palette.entities.creatures.ckjff4", Translation="uiR2EDcreature_ckjff4"},
				--	{Id="palette.entities.creatures.ckjgb1", Translation="uiR2EDcreature_ckjgb1"},
				--	{Id="palette.entities.creatures.ckjgb2", Translation="uiR2EDcreature_ckjgb2"},
				--	{Id="palette.entities.creatures.ckjgb3", Translation="uiR2EDcreature_ckjgb3"},
				--	{Id="palette.entities.creatures.ckjgb4", Translation="uiR2EDcreature_ckjgb4"},
				--	{Id="palette.entities.creatures.ckjgc1", Translation="uiR2EDcreature_ckjgc1"},
				--	{Id="palette.entities.creatures.ckjgc2", Translation="uiR2EDcreature_ckjgc2"},
				--	{Id="palette.entities.creatures.ckjgc3", Translation="uiR2EDcreature_ckjgc3"},
				--	{Id="palette.entities.creatures.ckjgc4", Translation="uiR2EDcreature_ckjgc4"},
				--	{Id="palette.entities.creatures.ckjgd1", Translation="uiR2EDcreature_ckjgd1"},
				--	{Id="palette.entities.creatures.ckjgd2", Translation="uiR2EDcreature_ckjgd2"},
				--	{Id="palette.entities.creatures.ckjgd3", Translation="uiR2EDcreature_ckjgd3"},
				--	{Id="palette.entities.creatures.ckjgd4", Translation="uiR2EDcreature_ckjgd4"},
				--	{Id="palette.entities.creatures.ckjge1", Translation="uiR2EDcreature_ckjge1"},
				--	{Id="palette.entities.creatures.ckjge2", Translation="uiR2EDcreature_ckjge2"},
				--	{Id="palette.entities.creatures.ckjge3", Translation="uiR2EDcreature_ckjge3"},
				--	{Id="palette.entities.creatures.ckjge4", Translation="uiR2EDcreature_ckjge4"},
				--	{Id="palette.entities.creatures.ckjgf1", Translation="uiR2EDcreature_ckjgf1"},
				--	{Id="palette.entities.creatures.ckjgf2", Translation="uiR2EDcreature_ckjgf2"},
				--	{Id="palette.entities.creatures.ckjgf3", Translation="uiR2EDcreature_ckjgf3"},
				--	{Id="palette.entities.creatures.ckjgf4", Translation="uiR2EDcreature_ckjgf4"},
					{Id="palette.entities.creatures.ckjjd1", Translation="uiR2EDcreature_ckjjd1"},
					{Id="palette.entities.creatures.ckjjd2", Translation="uiR2EDcreature_ckjjd2"},
					{Id="palette.entities.creatures.ckjjd3", Translation="uiR2EDcreature_ckjjd3"},
					{Id="palette.entities.creatures.ckjjd4", Translation="uiR2EDcreature_ckjjd4"},
					{Id="palette.entities.creatures.ckjje1", Translation="uiR2EDcreature_ckjje1"},
					{Id="palette.entities.creatures.ckjje2", Translation="uiR2EDcreature_ckjje2"},
					{Id="palette.entities.creatures.ckjje3", Translation="uiR2EDcreature_ckjje3"},
					{Id="palette.entities.creatures.ckjje4", Translation="uiR2EDcreature_ckjje4"},
					{Id="palette.entities.creatures.ckjjf1", Translation="uiR2EDcreature_ckjjf1"},
					{Id="palette.entities.creatures.ckjjf2", Translation="uiR2EDcreature_ckjjf2"},
					{Id="palette.entities.creatures.ckjjf3", Translation="uiR2EDcreature_ckjjf3"},
					{Id="palette.entities.creatures.ckjjf4", Translation="uiR2EDcreature_ckjjf4"},
					{Id="palette.entities.creatures.ckjld1", Translation="uiR2EDcreature_ckjld1"},
					{Id="palette.entities.creatures.ckjld2", Translation="uiR2EDcreature_ckjld2"},
					{Id="palette.entities.creatures.ckjld3", Translation="uiR2EDcreature_ckjld3"},
					{Id="palette.entities.creatures.ckjld4", Translation="uiR2EDcreature_ckjld4"},
					{Id="palette.entities.creatures.ckjle1", Translation="uiR2EDcreature_ckjle1"},
					{Id="palette.entities.creatures.ckjle2", Translation="uiR2EDcreature_ckjle2"},
					{Id="palette.entities.creatures.ckjle3", Translation="uiR2EDcreature_ckjle3"},
					{Id="palette.entities.creatures.ckjle4", Translation="uiR2EDcreature_ckjle4"},
					{Id="palette.entities.creatures.ckjlf1", Translation="uiR2EDcreature_ckjlf1"},
					{Id="palette.entities.creatures.ckjlf2", Translation="uiR2EDcreature_ckjlf2"},
					{Id="palette.entities.creatures.ckjlf3", Translation="uiR2EDcreature_ckjlf3"},
					{Id="palette.entities.creatures.ckjlf4", Translation="uiR2EDcreature_ckjlf4"},
					{Id="palette.entities.creatures.ckjpd1", Translation="uiR2EDcreature_ckjpd1"},
					{Id="palette.entities.creatures.ckjpd2", Translation="uiR2EDcreature_ckjpd2"},
					{Id="palette.entities.creatures.ckjpd3", Translation="uiR2EDcreature_ckjpd3"},
					{Id="palette.entities.creatures.ckjpd4", Translation="uiR2EDcreature_ckjpd4"},
					{Id="palette.entities.creatures.ckjpe1", Translation="uiR2EDcreature_ckjpe1"},
					{Id="palette.entities.creatures.ckjpe2", Translation="uiR2EDcreature_ckjpe2"},
					{Id="palette.entities.creatures.ckjpe3", Translation="uiR2EDcreature_ckjpe3"},
					{Id="palette.entities.creatures.ckjpe4", Translation="uiR2EDcreature_ckjpe4"},
					{Id="palette.entities.creatures.ckjpf1", Translation="uiR2EDcreature_ckjpf1"},
					{Id="palette.entities.creatures.ckjpf2", Translation="uiR2EDcreature_ckjpf2"},
					{Id="palette.entities.creatures.ckjpf3", Translation="uiR2EDcreature_ckjpf3"},
					{Id="palette.entities.creatures.ckjpf4", Translation="uiR2EDcreature_ckjpf4"}
				}
			},


		--	 Named Passives
			creatures_named_passives =
			{
				instances = 
				{
					{Id="palette.entities.creatures.cbajf5", Translation="uiR2EDcreature_cbajf5"},
					{Id="palette.entities.creatures.cbbpe7", Translation="uiR2EDcreature_cbbpe7"},
					{Id="palette.entities.creatures.cbbde5", Translation="uiR2EDcreature_cbbde5"},
					{Id="palette.entities.creatures.cbbdd7", Translation="uiR2EDcreature_cbbdd7"},
					{Id="palette.entities.creatures.cbcld5", Translation="uiR2EDcreature_cbcld5"},
					{Id="palette.entities.creatures.cbclc7", Translation="uiR2EDcreature_cbclc7"},
					{Id="palette.entities.creatures.cbajb7", Translation="uiR2EDcreature_cbajb7"},
					{Id="palette.entities.creatures.chldf7", Translation="uiR2EDcreature_chldf7"},
					{Id="palette.entities.creatures.chsdf7", Translation="uiR2EDcreature_chsdf7"},
					{Id="palette.entities.creatures.chwff7", Translation="uiR2EDcreature_chwff7"},
					{Id="palette.entities.creatures.chxjf7", Translation="uiR2EDcreature_chxjf7"},
					{Id="palette.entities.creatures.chtjf7", Translation="uiR2EDcreature_chtjf7"},
					{Id="palette.entities.creatures.chulf7", Translation="uiR2EDcreature_chulf7"},
					{Id="palette.entities.creatures.chgpf7", Translation="uiR2EDcreature_chgpf7"},
					{Id="palette.entities.creatures.chlpf7", Translation="uiR2EDcreature_chlpf7"},
					{Id="palette.entities.creatures.chhpf7", Translation="uiR2EDcreature_chhpf7"},
					{Id="palette.entities.creatures.chvpf7", Translation="uiR2EDcreature_chvpf7"},
					{Id="palette.entities.creatures.chldf5", Translation="uiR2EDcreature_chldf5"},
					{Id="palette.entities.creatures.chsdf5", Translation="uiR2EDcreature_chsdf5"},
					{Id="palette.entities.creatures.chlff5", Translation="uiR2EDcreature_chlff5"},
					{Id="palette.entities.creatures.chvff5", Translation="uiR2EDcreature_chvff5"},
					{Id="palette.entities.creatures.chajf5", Translation="uiR2EDcreature_chajf5"},
					{Id="palette.entities.creatures.chtjf5", Translation="uiR2EDcreature_chtjf5"},
					{Id="palette.entities.creatures.chrlf5", Translation="uiR2EDcreature_chrlf5"},
					{Id="palette.entities.creatures.chhpf5", Translation="uiR2EDcreature_chhpf5"},
					{Id="palette.entities.creatures.chlpf5", Translation="uiR2EDcreature_chlpf5"},
					{Id="palette.entities.creatures.chgpf5", Translation="uiR2EDcreature_chgpf5"},
					{Id="palette.entities.creatures.chtde7", Translation="uiR2EDcreature_chtde7"},
					{Id="palette.entities.creatures.chwde7", Translation="uiR2EDcreature_chwde7"},
					{Id="palette.entities.creatures.chpde7", Translation="uiR2EDcreature_chpde7"},
					{Id="palette.entities.creatures.chlfe7", Translation="uiR2EDcreature_chlfe7"},
					{Id="palette.entities.creatures.chqfe7", Translation="uiR2EDcreature_chqfe7"},
					{Id="palette.entities.creatures.chrfe7", Translation="uiR2EDcreature_chrfe7"},
					{Id="palette.entities.creatures.chvfe7", Translation="uiR2EDcreature_chvfe7"},
					{Id="palette.entities.creatures.chvje7", Translation="uiR2EDcreature_chvje7"},
					{Id="palette.entities.creatures.chuje7", Translation="uiR2EDcreature_chuje7"},
					{Id="palette.entities.creatures.chsle7", Translation="uiR2EDcreature_chsle7"},
					{Id="palette.entities.creatures.chale7", Translation="uiR2EDcreature_chale7"},
					{Id="palette.entities.creatures.chele7", Translation="uiR2EDcreature_chele7"},
					{Id="palette.entities.creatures.chlpe7", Translation="uiR2EDcreature_chlpe7"},
					{Id="palette.entities.creatures.chxpe7", Translation="uiR2EDcreature_chxpe7"},
					{Id="palette.entities.creatures.chape7", Translation="uiR2EDcreature_chape7"},
					{Id="palette.entities.creatures.chgde5", Translation="uiR2EDcreature_chgde5"},
					{Id="palette.entities.creatures.chkde5", Translation="uiR2EDcreature_chkde5"},
					{Id="palette.entities.creatures.chwde5", Translation="uiR2EDcreature_chwde5"},
					{Id="palette.entities.creatures.chafe5", Translation="uiR2EDcreature_chafe5"},
					{Id="palette.entities.creatures.chlfe5", Translation="uiR2EDcreature_chlfe5"},
					{Id="palette.entities.creatures.chqfe5", Translation="uiR2EDcreature_chqfe5"},
					{Id="palette.entities.creatures.chrfe5", Translation="uiR2EDcreature_chrfe5"},
					{Id="palette.entities.creatures.cheje5", Translation="uiR2EDcreature_cheje5"},
					{Id="palette.entities.creatures.chuje5", Translation="uiR2EDcreature_chuje5"},
					{Id="palette.entities.creatures.chale5", Translation="uiR2EDcreature_chale5"},
					{Id="palette.entities.creatures.chsle5", Translation="uiR2EDcreature_chsle5"},
					{Id="palette.entities.creatures.chhle5", Translation="uiR2EDcreature_chhle5"},
					{Id="palette.entities.creatures.chlpe5", Translation="uiR2EDcreature_chlpe5"},
					{Id="palette.entities.creatures.chxpe5", Translation="uiR2EDcreature_chxpe5"},
					{Id="palette.entities.creatures.chape5", Translation="uiR2EDcreature_chape5"},
					{Id="palette.entities.creatures.chbpe5", Translation="uiR2EDcreature_chbpe5"},
					{Id="palette.entities.creatures.chmdd7", Translation="uiR2EDcreature_chmdd7"},
					{Id="palette.entities.creatures.chpfd7", Translation="uiR2EDcreature_chpfd7"},
					{Id="palette.entities.creatures.chkjd7", Translation="uiR2EDcreature_chkjd7"},
					{Id="palette.entities.creatures.chcld7", Translation="uiR2EDcreature_chcld7"},
					{Id="palette.entities.creatures.chgpd7", Translation="uiR2EDcreature_chgpd7"},
					{Id="palette.entities.creatures.chhdd5", Translation="uiR2EDcreature_chhdd5"},
					{Id="palette.entities.creatures.chmdd5", Translation="uiR2EDcreature_chmdd5"},
					{Id="palette.entities.creatures.chnfd5", Translation="uiR2EDcreature_chnfd5"},
					{Id="palette.entities.creatures.chcjd5", Translation="uiR2EDcreature_chcjd5"},
					{Id="palette.entities.creatures.cheld5", Translation="uiR2EDcreature_cheld5"},
					{Id="palette.entities.creatures.chgpd5", Translation="uiR2EDcreature_chgpd5"},
					{Id="palette.entities.creatures.chbpd5", Translation="uiR2EDcreature_chbpd5"},
					{Id="palette.entities.creatures.chnjc7", Translation="uiR2EDcreature_chnjc7"},
					{Id="palette.entities.creatures.chhdc5", Translation="uiR2EDcreature_chhdc5"},
					{Id="palette.entities.creatures.chpdc5", Translation="uiR2EDcreature_chpdc5"},
					{Id="palette.entities.creatures.chafc5", Translation="uiR2EDcreature_chafc5"},
					{Id="palette.entities.creatures.chclc5", Translation="uiR2EDcreature_chclc5"},
					{Id="palette.entities.creatures.chblc5", Translation="uiR2EDcreature_chblc5"},
					{Id="palette.entities.creatures.chcdb7", Translation="uiR2EDcreature_chcdb7"},
					{Id="palette.entities.creatures.chbfb7", Translation="uiR2EDcreature_chbfb7"},
					{Id="palette.entities.creatures.chflb7", Translation="uiR2EDcreature_chflb7"},
					{Id="palette.entities.creatures.chgdb5", Translation="uiR2EDcreature_chgdb5"},
					{Id="palette.entities.creatures.chdfb5", Translation="uiR2EDcreature_chdfb5"},
					{Id="palette.entities.creatures.chfjb5", Translation="uiR2EDcreature_chfjb5"}
				}
			},


		--	 Named Predators
			creatures_named_predators =
			{
				instances = 
				{
					{Id="palette.entities.creatures.cckdf7", Translation="uiR2EDcreature_cckdf7"},
					{Id="palette.entities.creatures.ccmff7", Translation="uiR2EDcreature_ccmff7"},
					{Id="palette.entities.creatures.cceff7", Translation="uiR2EDcreature_cceff7"},
					{Id="palette.entities.creatures.ccijf7", Translation="uiR2EDcreature_ccijf7"},
					{Id="palette.entities.creatures.ccpjf7", Translation="uiR2EDcreature_ccpjf7"},
					{Id="palette.entities.creatures.ccnlf7", Translation="uiR2EDcreature_ccnlf7"},
					{Id="palette.entities.creatures.ccclf7", Translation="uiR2EDcreature_ccclf7"},
					{Id="palette.entities.creatures.ccgpf7", Translation="uiR2EDcreature_ccgpf7"},
					{Id="palette.entities.creatures.ccmpf7", Translation="uiR2EDcreature_ccmpf7"},
					{Id="palette.entities.creatures.ccopf7", Translation="uiR2EDcreature_ccopf7"},
					{Id="palette.entities.creatures.ccepf7", Translation="uiR2EDcreature_ccepf7"},
					{Id="palette.entities.creatures.ccidf5", Translation="uiR2EDcreature_ccidf5"},
					{Id="palette.entities.creatures.ccdff5", Translation="uiR2EDcreature_ccdff5"},
					{Id="palette.entities.creatures.cckff5", Translation="uiR2EDcreature_cckff5"},
					{Id="palette.entities.creatures.ccfjf5", Translation="uiR2EDcreature_ccfjf5"},
					{Id="palette.entities.creatures.ccdlf5", Translation="uiR2EDcreature_ccdlf5"},
					{Id="palette.entities.creatures.ccflf5", Translation="uiR2EDcreature_ccflf5"},
					{Id="palette.entities.creatures.ccmpf5", Translation="uiR2EDcreature_ccmpf5"},
					{Id="palette.entities.creatures.ccopf5", Translation="uiR2EDcreature_ccopf5"},
					{Id="palette.entities.creatures.ccgpf5", Translation="uiR2EDcreature_ccgpf5"},
					{Id="palette.entities.creatures.cchde7", Translation="uiR2EDcreature_cchde7"},
					{Id="palette.entities.creatures.cclde7", Translation="uiR2EDcreature_cclde7"},
					{Id="palette.entities.creatures.ccdfe7", Translation="uiR2EDcreature_ccdfe7"},
					{Id="palette.entities.creatures.cckfe7", Translation="uiR2EDcreature_cckfe7"},
					{Id="palette.entities.creatures.ccafe7", Translation="uiR2EDcreature_ccafe7"},
					{Id="palette.entities.creatures.ccdle7", Translation="uiR2EDcreature_ccdle7"},
					{Id="palette.entities.creatures.ccope7", Translation="uiR2EDcreature_ccope7"},
					{Id="palette.entities.creatures.ccfpe7", Translation="uiR2EDcreature_ccfpe7"},
					{Id="palette.entities.creatures.cchpe7", Translation="uiR2EDcreature_cchpe7"},
					{Id="palette.entities.creatures.ccbde5", Translation="uiR2EDcreature_ccbde5"},
					{Id="palette.entities.creatures.cchde5", Translation="uiR2EDcreature_cchde5"},
					{Id="palette.entities.creatures.cclde5", Translation="uiR2EDcreature_cclde5"},
					{Id="palette.entities.creatures.ccdfe5", Translation="uiR2EDcreature_ccdfe5"},
					{Id="palette.entities.creatures.cckfe5", Translation="uiR2EDcreature_cckfe5"},
					{Id="palette.entities.creatures.ccaje5", Translation="uiR2EDcreature_ccaje5"},
					{Id="palette.entities.creatures.ccdje5", Translation="uiR2EDcreature_ccdje5"},
					{Id="palette.entities.creatures.ccele5", Translation="uiR2EDcreature_ccele5"},
					{Id="palette.entities.creatures.ccdle5", Translation="uiR2EDcreature_ccdle5"},
					{Id="palette.entities.creatures.ccope5", Translation="uiR2EDcreature_ccope5"},
					{Id="palette.entities.creatures.cchpe5", Translation="uiR2EDcreature_cchpe5"},
					{Id="palette.entities.creatures.ccidd7", Translation="uiR2EDcreature_ccidd7"},
					{Id="palette.entities.creatures.cccdd7", Translation="uiR2EDcreature_cccdd7"},
					{Id="palette.entities.creatures.ccjfd7", Translation="uiR2EDcreature_ccjfd7"},
					{Id="palette.entities.creatures.ccfjd7", Translation="uiR2EDcreature_ccfjd7"},
					{Id="palette.entities.creatures.ccnpd7", Translation="uiR2EDcreature_ccnpd7"},
					{Id="palette.entities.creatures.ccipd7", Translation="uiR2EDcreature_ccipd7"},
					{Id="palette.entities.creatures.cchdd5", Translation="uiR2EDcreature_cchdd5"},
					{Id="palette.entities.creatures.ccidd5", Translation="uiR2EDcreature_ccidd5"},
					{Id="palette.entities.creatures.ccafd5", Translation="uiR2EDcreature_ccafd5"},
					{Id="palette.entities.creatures.ccjfd5", Translation="uiR2EDcreature_ccjfd5"},
					{Id="palette.entities.creatures.ccijd5", Translation="uiR2EDcreature_ccijd5"},
					{Id="palette.entities.creatures.ccajd5", Translation="uiR2EDcreature_ccajd5"},
					{Id="palette.entities.creatures.ccfld5", Translation="uiR2EDcreature_ccfld5"},
					{Id="palette.entities.creatures.ccipd5", Translation="uiR2EDcreature_ccipd5"},
					{Id="palette.entities.creatures.ccbdc7", Translation="uiR2EDcreature_ccbdc7"},
					{Id="palette.entities.creatures.ccelc7", Translation="uiR2EDcreature_ccelc7"},
					{Id="palette.entities.creatures.ccafc5", Translation="uiR2EDcreature_ccafc5"},
					{Id="palette.entities.creatures.ccdjc5", Translation="uiR2EDcreature_ccdjc5"},
					{Id="palette.entities.creatures.cccdb7", Translation="uiR2EDcreature_cccdb7"},
					{Id="palette.entities.creatures.ccejb7", Translation="uiR2EDcreature_ccejb7"}
				}
			},


		--	 Named Plants
			creatures_named_plants =
			{
				instances = 
				{
					{Id="palette.entities.creatures.cpfdf7", Translation="uiR2EDcreature_cpfdf7"},
					{Id="palette.entities.creatures.cpblf7", Translation="uiR2EDcreature_cpblf7"},
					-- {Id="palette.entities.creatures.cpapf7", Translation="uiR2EDcreature_cpapf7"},
					{Id="palette.entities.creatures.cpcpf7", Translation="uiR2EDcreature_cpcpf7"},
					{Id="palette.entities.creatures.cpefe7", Translation="uiR2EDcreature_cpefe7"},
					{Id="palette.entities.creatures.cpdje7", Translation="uiR2EDcreature_cpdje7"},
					-- {Id="palette.entities.creatures.cpapd7", Translation="uiR2EDcreature_cpapd7"},
					{Id="palette.entities.creatures.cpcfc7", Translation="uiR2EDcreature_cpcfc7"}
				}
			},


		--	 Named Degens
			creatures_named_degens =
			{
				instances = 
				{
					{Id="palette.entities.creatures.cdbfe7", Translation="uiR2EDcreature_cdbfe7"},
					{Id="palette.entities.creatures.cdbje7", Translation="uiR2EDcreature_cdbje7"},
					{Id="palette.entities.creatures.cdale7", Translation="uiR2EDcreature_cdale7"},
					{Id="palette.entities.creatures.cdcde5", Translation="uiR2EDcreature_cdcde5"},
					{Id="palette.entities.creatures.cdbfe5", Translation="uiR2EDcreature_cdbfe5"},
					{Id="palette.entities.creatures.cdbje5", Translation="uiR2EDcreature_cdbje5"},
					{Id="palette.entities.creatures.cdcdd7", Translation="uiR2EDcreature_cdcdd7"},
					{Id="palette.entities.creatures.cdapd7", Translation="uiR2EDcreature_cdapd7"},
					{Id="palette.entities.creatures.cdcdd5", Translation="uiR2EDcreature_cdcdd5"},
					{Id="palette.entities.creatures.cdapd5", Translation="uiR2EDcreature_cdapd5"},
					{Id="palette.entities.creatures.cdalc5", Translation="uiR2EDcreature_cdalc5"}
				}
			},


		--	 Named Kitins
			creatures_named_kitins =
			{
				instances = 
				{
					{Id="palette.entities.creatures.ckddf7", Translation="uiR2EDcreature_ckddf7"},
					{Id="palette.entities.creatures.ckhdf7", Translation="uiR2EDcreature_ckhdf7"},
					{Id="palette.entities.creatures.ckiff7", Translation="uiR2EDcreature_ckiff7"},
					{Id="palette.entities.creatures.ckfjf7", Translation="uiR2EDcreature_ckfjf7"},
					{Id="palette.entities.creatures.ckglf7", Translation="uiR2EDcreature_ckglf7"},
					{Id="palette.entities.creatures.ckdpf7", Translation="uiR2EDcreature_ckdpf7"},
					{Id="palette.entities.creatures.ckfpf7", Translation="uiR2EDcreature_ckfpf7"},
					{Id="palette.entities.creatures.ckipf7", Translation="uiR2EDcreature_ckipf7"},
					{Id="palette.entities.creatures.ckepf7", Translation="uiR2EDcreature_ckepf7"},
					{Id="palette.entities.creatures.ckgpf7", Translation="uiR2EDcreature_ckgpf7"},
					{Id="palette.entities.creatures.ckbpf7", Translation="uiR2EDcreature_ckbpf7"},
					{Id="palette.entities.creatures.ckjpf7", Translation="uiR2EDcreature_ckjpf7"},
					{Id="palette.entities.creatures.ckfdf5", Translation="uiR2EDcreature_ckfdf5"},
					{Id="palette.entities.creatures.ckedf5", Translation="uiR2EDcreature_ckedf5"},
					{Id="palette.entities.creatures.ckgff5", Translation="uiR2EDcreature_ckgff5"},
					{Id="palette.entities.creatures.ckdjf5", Translation="uiR2EDcreature_ckdjf5"},
					{Id="palette.entities.creatures.ckdlf5", Translation="uiR2EDcreature_ckdlf5"},
					{Id="palette.entities.creatures.ckglf5", Translation="uiR2EDcreature_ckglf5"},
					{Id="palette.entities.creatures.ckhpf5", Translation="uiR2EDcreature_ckhpf5"},
					{Id="palette.entities.creatures.ckgpf5", Translation="uiR2EDcreature_ckgpf5"},
					{Id="palette.entities.creatures.ckepf5", Translation="uiR2EDcreature_ckepf5"},
					{Id="palette.entities.creatures.ckjpf5", Translation="uiR2EDcreature_ckjpf5"},
					{Id="palette.entities.creatures.ckipf5", Translation="uiR2EDcreature_ckipf5"},
					{Id="palette.entities.creatures.ckfpf5", Translation="uiR2EDcreature_ckfpf5"},
					{Id="palette.entities.creatures.ckdpf5", Translation="uiR2EDcreature_ckdpf5"},
					{Id="palette.entities.creatures.ckede7", Translation="uiR2EDcreature_ckede7"},
					{Id="palette.entities.creatures.ckjde7", Translation="uiR2EDcreature_ckjde7"},
					{Id="palette.entities.creatures.ckdfe7", Translation="uiR2EDcreature_ckdfe7"},
					{Id="palette.entities.creatures.ckdje7", Translation="uiR2EDcreature_ckdje7"},
					{Id="palette.entities.creatures.ckeje7", Translation="uiR2EDcreature_ckeje7"},
					{Id="palette.entities.creatures.ckfje7", Translation="uiR2EDcreature_ckfje7"},
					{Id="palette.entities.creatures.ckele7", Translation="uiR2EDcreature_ckele7"},
					{Id="palette.entities.creatures.ckhpe7", Translation="uiR2EDcreature_ckhpe7"},
					{Id="palette.entities.creatures.ckfpe7", Translation="uiR2EDcreature_ckfpe7"},
					{Id="palette.entities.creatures.ckape7", Translation="uiR2EDcreature_ckape7"},
					{Id="palette.entities.creatures.ckhde5", Translation="uiR2EDcreature_ckhde5"},
					{Id="palette.entities.creatures.ckdde5", Translation="uiR2EDcreature_ckdde5"},
					{Id="palette.entities.creatures.ckede5", Translation="uiR2EDcreature_ckede5"},
					{Id="palette.entities.creatures.ckide5", Translation="uiR2EDcreature_ckide5"},
					{Id="palette.entities.creatures.ckefe5", Translation="uiR2EDcreature_ckefe5"},
					{Id="palette.entities.creatures.ckffe5", Translation="uiR2EDcreature_ckffe5"},
					{Id="palette.entities.creatures.ckdfe5", Translation="uiR2EDcreature_ckdfe5"},
					{Id="palette.entities.creatures.ckgfe5", Translation="uiR2EDcreature_ckgfe5"},
					{Id="palette.entities.creatures.ckhfe5", Translation="uiR2EDcreature_ckhfe5"},
					{Id="palette.entities.creatures.ckife5", Translation="uiR2EDcreature_ckife5"},
					{Id="palette.entities.creatures.ckjfe5", Translation="uiR2EDcreature_ckjfe5"},
					{Id="palette.entities.creatures.ckeje5", Translation="uiR2EDcreature_ckeje5"},
					{Id="palette.entities.creatures.ckfje5", Translation="uiR2EDcreature_ckfje5"},
					{Id="palette.entities.creatures.ckije5", Translation="uiR2EDcreature_ckije5"},
--					{Id="palette.entities.creatures.ckdje5", Translation="uiR2EDcreature_ckdje5"},
					{Id="palette.entities.creatures.ckgle5", Translation="uiR2EDcreature_ckgle5"},
					{Id="palette.entities.creatures.ckhle5", Translation="uiR2EDcreature_ckhle5"},
					{Id="palette.entities.creatures.ckdle5", Translation="uiR2EDcreature_ckdle5"},
					{Id="palette.entities.creatures.ckepe5", Translation="uiR2EDcreature_ckepe5"},
					{Id="palette.entities.creatures.ckdpe5", Translation="uiR2EDcreature_ckdpe5"},
					{Id="palette.entities.creatures.ckipe5", Translation="uiR2EDcreature_ckipe5"},
					{Id="palette.entities.creatures.ckfpe5", Translation="uiR2EDcreature_ckfpe5"},
					{Id="palette.entities.creatures.ckgpe5", Translation="uiR2EDcreature_ckgpe5"},
					{Id="palette.entities.creatures.ckhdd7", Translation="uiR2EDcreature_ckhdd7"},
					{Id="palette.entities.creatures.ckhfd7", Translation="uiR2EDcreature_ckhfd7"},
					{Id="palette.entities.creatures.ckdjd7", Translation="uiR2EDcreature_ckdjd7"},
					{Id="palette.entities.creatures.ckdld7", Translation="uiR2EDcreature_ckdld7"},
					{Id="palette.entities.creatures.ckjld7", Translation="uiR2EDcreature_ckjld7"},
					{Id="palette.entities.creatures.ckdpd7", Translation="uiR2EDcreature_ckdpd7"},
					{Id="palette.entities.creatures.ckhdd5", Translation="uiR2EDcreature_ckhdd5"},
					{Id="palette.entities.creatures.ckjpd5", Translation="uiR2EDcreature_ckjpd5"},
					{Id="palette.entities.creatures.ckhpd5", Translation="uiR2EDcreature_ckhpd5"},
					{Id="palette.entities.creatures.ckijc5", Translation="uiR2EDcreature_ckijc5"}
				}
			},


		--	 Invasion Kitins
			creatures_invasion_kitins =
			{
				instances = 
				{
					{Id="palette.entities.creatures.ckgif4", Translation="uiR2EDcreature_ckgif4"},
					{Id="palette.entities.creatures.ckaif4", Translation="uiR2EDcreature_ckaif4"},
					{Id="palette.entities.creatures.ckdif4", Translation="uiR2EDcreature_ckdif4"},
					{Id="palette.entities.creatures.ckbif4", Translation="uiR2EDcreature_ckbif4"},
					{Id="palette.entities.creatures.ckhif4", Translation="uiR2EDcreature_ckhif4"},
					{Id="palette.entities.creatures.ckjif4", Translation="uiR2EDcreature_ckjif4"},
					{Id="palette.entities.creatures.ckeif4", Translation="uiR2EDcreature_ckeif4"},
					{Id="palette.entities.creatures.ckfif4", Translation="uiR2EDcreature_ckfif4"},
					{Id="palette.entities.creatures.ckcif4", Translation="uiR2EDcreature_ckcif4"},
					{Id="palette.entities.creatures.ckiif4", Translation="uiR2EDcreature_ckiif4"},
					{Id="palette.entities.creatures.ckfrf4", Translation="uiR2EDcreature_ckfrf4"},
					{Id="palette.entities.creatures.ckgif3", Translation="uiR2EDcreature_ckgif3"},
					{Id="palette.entities.creatures.ckaif3", Translation="uiR2EDcreature_ckaif3"},
					{Id="palette.entities.creatures.ckdif3", Translation="uiR2EDcreature_ckdif3"},
					{Id="palette.entities.creatures.ckbif3", Translation="uiR2EDcreature_ckbif3"},
					{Id="palette.entities.creatures.ckhif3", Translation="uiR2EDcreature_ckhif3"},
					{Id="palette.entities.creatures.ckjif3", Translation="uiR2EDcreature_ckjif3"},
					{Id="palette.entities.creatures.ckeif3", Translation="uiR2EDcreature_ckeif3"},
					{Id="palette.entities.creatures.ckfif3", Translation="uiR2EDcreature_ckfif3"},
					{Id="palette.entities.creatures.ckcif3", Translation="uiR2EDcreature_ckcif3"},
					{Id="palette.entities.creatures.ckiif3", Translation="uiR2EDcreature_ckiif3"},
					{Id="palette.entities.creatures.ckfrf3", Translation="uiR2EDcreature_ckfrf3"},
					{Id="palette.entities.creatures.ckgif2", Translation="uiR2EDcreature_ckgif2"},
					{Id="palette.entities.creatures.ckaif2", Translation="uiR2EDcreature_ckaif2"},
					{Id="palette.entities.creatures.ckdif2", Translation="uiR2EDcreature_ckdif2"},
					{Id="palette.entities.creatures.ckbif2", Translation="uiR2EDcreature_ckbif2"},
					{Id="palette.entities.creatures.ckhif2", Translation="uiR2EDcreature_ckhif2"},

					{Id="palette.entities.creatures.ckjif2", Translation="uiR2EDcreature_ckjif2"},
					{Id="palette.entities.creatures.ckeif2", Translation="uiR2EDcreature_ckeif2"},
					{Id="palette.entities.creatures.ckfif2", Translation="uiR2EDcreature_ckfif2"},
					{Id="palette.entities.creatures.ckcif2", Translation="uiR2EDcreature_ckcif2"},
					{Id="palette.entities.creatures.ckiif2", Translation="uiR2EDcreature_ckiif2"},
					{Id="palette.entities.creatures.ckfrf2", Translation="uiR2EDcreature_ckfrf2"},
					{Id="palette.entities.creatures.ckgif1", Translation="uiR2EDcreature_ckgif1"},
					{Id="palette.entities.creatures.ckaif1", Translation="uiR2EDcreature_ckaif1"},
					{Id="palette.entities.creatures.ckdif1", Translation="uiR2EDcreature_ckdif1"},
					{Id="palette.entities.creatures.ckbif1", Translation="uiR2EDcreature_ckbif1"},
					{Id="palette.entities.creatures.ckhif1", Translation="uiR2EDcreature_ckhif1"},
					{Id="palette.entities.creatures.ckjif1", Translation="uiR2EDcreature_ckjif1"},
					{Id="palette.entities.creatures.ckeif1", Translation="uiR2EDcreature_ckeif1"},
					{Id="palette.entities.creatures.ckfif1", Translation="uiR2EDcreature_ckfif1"},
					{Id="palette.entities.creatures.ckcif1", Translation="uiR2EDcreature_ckcif1"},
					{Id="palette.entities.creatures.ckiif1", Translation="uiR2EDcreature_ckiif1"},
					{Id="palette.entities.creatures.ckfrf1", Translation="uiR2EDcreature_ckfrf1"},
					{Id="palette.entities.creatures.ckgie4", Translation="uiR2EDcreature_ckgie4"},
					{Id="palette.entities.creatures.ckaie4", Translation="uiR2EDcreature_ckaie4"},
					{Id="palette.entities.creatures.ckdie4", Translation="uiR2EDcreature_ckdie4"},
					{Id="palette.entities.creatures.ckbie4", Translation="uiR2EDcreature_ckbie4"},
					{Id="palette.entities.creatures.ckhie4", Translation="uiR2EDcreature_ckhie4"},
					{Id="palette.entities.creatures.ckjie4", Translation="uiR2EDcreature_ckjie4"},
					{Id="palette.entities.creatures.ckeie4", Translation="uiR2EDcreature_ckeie4"},
					{Id="palette.entities.creatures.ckfie4", Translation="uiR2EDcreature_ckfie4"},
					{Id="palette.entities.creatures.ckcie4", Translation="uiR2EDcreature_ckcie4"},
					{Id="palette.entities.creatures.ckiie4", Translation="uiR2EDcreature_ckiie4"},
					{Id="palette.entities.creatures.ckfre4", Translation="uiR2EDcreature_ckfre4"},
					{Id="palette.entities.creatures.ckgie3", Translation="uiR2EDcreature_ckgie3"},
					{Id="palette.entities.creatures.ckaie3", Translation="uiR2EDcreature_ckaie3"},
					{Id="palette.entities.creatures.ckdie3", Translation="uiR2EDcreature_ckdie3"},
					{Id="palette.entities.creatures.ckbie3", Translation="uiR2EDcreature_ckbie3"},
					{Id="palette.entities.creatures.ckhie3", Translation="uiR2EDcreature_ckhie3"},
					{Id="palette.entities.creatures.ckjie3", Translation="uiR2EDcreature_ckjie3"},
					{Id="palette.entities.creatures.ckeie3", Translation="uiR2EDcreature_ckeie3"},
					{Id="palette.entities.creatures.ckfie3", Translation="uiR2EDcreature_ckfie3"},
					{Id="palette.entities.creatures.ckcie3", Translation="uiR2EDcreature_ckcie3"},
					{Id="palette.entities.creatures.ckiie3", Translation="uiR2EDcreature_ckiie3"},
					{Id="palette.entities.creatures.ckfre3", Translation="uiR2EDcreature_ckfre3"},
					{Id="palette.entities.creatures.ckgie2", Translation="uiR2EDcreature_ckgie2"},
					{Id="palette.entities.creatures.ckaie2", Translation="uiR2EDcreature_ckaie2"},
					{Id="palette.entities.creatures.ckdie2", Translation="uiR2EDcreature_ckdie2"},
					{Id="palette.entities.creatures.ckbie2", Translation="uiR2EDcreature_ckbie2"},
					{Id="palette.entities.creatures.ckhie2", Translation="uiR2EDcreature_ckhie2"},
					{Id="palette.entities.creatures.ckjie2", Translation="uiR2EDcreature_ckjie2"},
					{Id="palette.entities.creatures.ckeie2", Translation="uiR2EDcreature_ckeie2"},
					{Id="palette.entities.creatures.ckfie2", Translation="uiR2EDcreature_ckfie2"},
					{Id="palette.entities.creatures.ckcie2", Translation="uiR2EDcreature_ckcie2"},
					{Id="palette.entities.creatures.ckiie2", Translation="uiR2EDcreature_ckiie2"},
					{Id="palette.entities.creatures.ckfre2", Translation="uiR2EDcreature_ckfre2"},
					{Id="palette.entities.creatures.ckgie1", Translation="uiR2EDcreature_ckgie1"},
					{Id="palette.entities.creatures.ckaie1", Translation="uiR2EDcreature_ckaie1"},
					{Id="palette.entities.creatures.ckdie1", Translation="uiR2EDcreature_ckdie1"},
					{Id="palette.entities.creatures.ckbie1", Translation="uiR2EDcreature_ckbie1"},
					{Id="palette.entities.creatures.ckhie1", Translation="uiR2EDcreature_ckhie1"},
					{Id="palette.entities.creatures.ckjie1", Translation="uiR2EDcreature_ckjie1"},
					{Id="palette.entities.creatures.ckeie1", Translation="uiR2EDcreature_ckeie1"},
					{Id="palette.entities.creatures.ckfie1", Translation="uiR2EDcreature_ckfie1"},
					{Id="palette.entities.creatures.ckcie1", Translation="uiR2EDcreature_ckcie1"},
					{Id="palette.entities.creatures.ckiie1", Translation="uiR2EDcreature_ckiie1"},
					{Id="palette.entities.creatures.ckfre1", Translation="uiR2EDcreature_ckfre1"},
					{Id="palette.entities.creatures.ckgid4", Translation="uiR2EDcreature_ckgid4"},
					{Id="palette.entities.creatures.ckaid4", Translation="uiR2EDcreature_ckaid4"},
					{Id="palette.entities.creatures.ckdid4", Translation="uiR2EDcreature_ckdid4"},
					{Id="palette.entities.creatures.ckbid4", Translation="uiR2EDcreature_ckbid4"},
					{Id="palette.entities.creatures.ckhid4", Translation="uiR2EDcreature_ckhid4"},
					{Id="palette.entities.creatures.ckjid4", Translation="uiR2EDcreature_ckjid4"},
					{Id="palette.entities.creatures.ckeid4", Translation="uiR2EDcreature_ckeid4"},
					{Id="palette.entities.creatures.ckfid4", Translation="uiR2EDcreature_ckfid4"},
					{Id="palette.entities.creatures.ckcid4", Translation="uiR2EDcreature_ckcid4"},
					{Id="palette.entities.creatures.ckiid4", Translation="uiR2EDcreature_ckiid4"},
					{Id="palette.entities.creatures.ckfrd4", Translation="uiR2EDcreature_ckfrd4"},
					{Id="palette.entities.creatures.ckgid3", Translation="uiR2EDcreature_ckgid3"},
					{Id="palette.entities.creatures.ckaid3", Translation="uiR2EDcreature_ckaid3"},
					{Id="palette.entities.creatures.ckdid3", Translation="uiR2EDcreature_ckdid3"},
					{Id="palette.entities.creatures.ckbid3", Translation="uiR2EDcreature_ckbid3"},
					{Id="palette.entities.creatures.ckhid3", Translation="uiR2EDcreature_ckhid3"},
					{Id="palette.entities.creatures.ckjid3", Translation="uiR2EDcreature_ckjid3"},
					{Id="palette.entities.creatures.ckeid3", Translation="uiR2EDcreature_ckeid3"},
					{Id="palette.entities.creatures.ckfid3", Translation="uiR2EDcreature_ckfid3"},

					{Id="palette.entities.creatures.ckcid3", Translation="uiR2EDcreature_ckcid3"},
					{Id="palette.entities.creatures.ckiid3", Translation="uiR2EDcreature_ckiid3"},
					{Id="palette.entities.creatures.ckfrd3", Translation="uiR2EDcreature_ckfrd3"},
					{Id="palette.entities.creatures.ckgid2", Translation="uiR2EDcreature_ckgid2"},
					{Id="palette.entities.creatures.ckaid2", Translation="uiR2EDcreature_ckaid2"},
					{Id="palette.entities.creatures.ckdid2", Translation="uiR2EDcreature_ckdid2"},
					{Id="palette.entities.creatures.ckbid2", Translation="uiR2EDcreature_ckbid2"},
					{Id="palette.entities.creatures.ckhid2", Translation="uiR2EDcreature_ckhid2"},
					{Id="palette.entities.creatures.ckjid2", Translation="uiR2EDcreature_ckjid2"},
					{Id="palette.entities.creatures.ckeid2", Translation="uiR2EDcreature_ckeid2"},
					{Id="palette.entities.creatures.ckfid2", Translation="uiR2EDcreature_ckfid2"},
					{Id="palette.entities.creatures.ckcid2", Translation="uiR2EDcreature_ckcid2"},
					{Id="palette.entities.creatures.ckiid2", Translation="uiR2EDcreature_ckiid2"},
					{Id="palette.entities.creatures.ckfrd2", Translation="uiR2EDcreature_ckfrd2"},
					{Id="palette.entities.creatures.ckgid1", Translation="uiR2EDcreature_ckgid1"},
					{Id="palette.entities.creatures.ckaid1", Translation="uiR2EDcreature_ckaid1"},
					{Id="palette.entities.creatures.ckdid1", Translation="uiR2EDcreature_ckdid1"},
					{Id="palette.entities.creatures.ckbid1", Translation="uiR2EDcreature_ckbid1"},
					{Id="palette.entities.creatures.ckhid1", Translation="uiR2EDcreature_ckhid1"},
					{Id="palette.entities.creatures.ckjid1", Translation="uiR2EDcreature_ckjid1"},
					{Id="palette.entities.creatures.ckeid1", Translation="uiR2EDcreature_ckeid1"},
					{Id="palette.entities.creatures.ckfid1", Translation="uiR2EDcreature_ckfid1"},
					{Id="palette.entities.creatures.ckcid1", Translation="uiR2EDcreature_ckcid1"},
					{Id="palette.entities.creatures.ckiid1", Translation="uiR2EDcreature_ckiid1"},
					{Id="palette.entities.creatures.ckfrd1", Translation="uiR2EDcreature_ckfrd1"},
					{Id="palette.entities.creatures.ckgic4", Translation="uiR2EDcreature_ckgic4"},
					{Id="palette.entities.creatures.ckaic4", Translation="uiR2EDcreature_ckaic4"},
					{Id="palette.entities.creatures.ckdic4", Translation="uiR2EDcreature_ckdic4"},
					{Id="palette.entities.creatures.ckbic4", Translation="uiR2EDcreature_ckbic4"},
					{Id="palette.entities.creatures.ckhic4", Translation="uiR2EDcreature_ckhic4"},
					{Id="palette.entities.creatures.ckjic4", Translation="uiR2EDcreature_ckjic4"},
					{Id="palette.entities.creatures.ckeic4", Translation="uiR2EDcreature_ckeic4"},
					{Id="palette.entities.creatures.ckfic4", Translation="uiR2EDcreature_ckfic4"},
					{Id="palette.entities.creatures.ckcic4", Translation="uiR2EDcreature_ckcic4"},
					{Id="palette.entities.creatures.ckiic4", Translation="uiR2EDcreature_ckiic4"},
					{Id="palette.entities.creatures.ckfrc4", Translation="uiR2EDcreature_ckfrc4"},
					{Id="palette.entities.creatures.ckgic3", Translation="uiR2EDcreature_ckgic3"},
					{Id="palette.entities.creatures.ckaic3", Translation="uiR2EDcreature_ckaic3"},
					{Id="palette.entities.creatures.ckdic3", Translation="uiR2EDcreature_ckdic3"},
					{Id="palette.entities.creatures.ckbic3", Translation="uiR2EDcreature_ckbic3"},
					{Id="palette.entities.creatures.ckhic3", Translation="uiR2EDcreature_ckhic3"},
					{Id="palette.entities.creatures.ckjic3", Translation="uiR2EDcreature_ckjic3"},
					{Id="palette.entities.creatures.ckeic3", Translation="uiR2EDcreature_ckeic3"},
					{Id="palette.entities.creatures.ckfic3", Translation="uiR2EDcreature_ckfic3"},
					{Id="palette.entities.creatures.ckcic3", Translation="uiR2EDcreature_ckcic3"},
					{Id="palette.entities.creatures.ckiic3", Translation="uiR2EDcreature_ckiic3"},
					{Id="palette.entities.creatures.ckfrc3", Translation="uiR2EDcreature_ckfrc3"},
					{Id="palette.entities.creatures.ckgic2", Translation="uiR2EDcreature_ckgic2"},
					{Id="palette.entities.creatures.ckaic2", Translation="uiR2EDcreature_ckaic2"},
					{Id="palette.entities.creatures.ckdic2", Translation="uiR2EDcreature_ckdic2"},
					{Id="palette.entities.creatures.ckbic2", Translation="uiR2EDcreature_ckbic2"},
					{Id="palette.entities.creatures.ckhic2", Translation="uiR2EDcreature_ckhic2"},
					{Id="palette.entities.creatures.ckjic2", Translation="uiR2EDcreature_ckjic2"},
					{Id="palette.entities.creatures.ckeic2", Translation="uiR2EDcreature_ckeic2"},
					{Id="palette.entities.creatures.ckfic2", Translation="uiR2EDcreature_ckfic2"},
					{Id="palette.entities.creatures.ckcic2", Translation="uiR2EDcreature_ckcic2"},
					{Id="palette.entities.creatures.ckiic2", Translation="uiR2EDcreature_ckiic2"},
					{Id="palette.entities.creatures.ckfrc2", Translation="uiR2EDcreature_ckfrc2"},
					{Id="palette.entities.creatures.ckgic1", Translation="uiR2EDcreature_ckgic1"},
					{Id="palette.entities.creatures.ckaic1", Translation="uiR2EDcreature_ckaic1"},
					{Id="palette.entities.creatures.ckdic1", Translation="uiR2EDcreature_ckdic1"},
					{Id="palette.entities.creatures.ckbic1", Translation="uiR2EDcreature_ckbic1"},
					{Id="palette.entities.creatures.ckhic1", Translation="uiR2EDcreature_ckhic1"},
					{Id="palette.entities.creatures.ckjic1", Translation="uiR2EDcreature_ckjic1"},
					{Id="palette.entities.creatures.ckeic1", Translation="uiR2EDcreature_ckeic1"},
					{Id="palette.entities.creatures.ckfic1", Translation="uiR2EDcreature_ckfic1"},
					{Id="palette.entities.creatures.ckcic1", Translation="uiR2EDcreature_ckcic1"},
					{Id="palette.entities.creatures.ckiic1", Translation="uiR2EDcreature_ckiic1"},
					{Id="palette.entities.creatures.ckfrc1", Translation="uiR2EDcreature_ckfrc1"},
					{Id="palette.entities.creatures.ckgib4", Translation="uiR2EDcreature_ckgib4"},
					{Id="palette.entities.creatures.ckaib4", Translation="uiR2EDcreature_ckaib4"},
					{Id="palette.entities.creatures.ckdib4", Translation="uiR2EDcreature_ckdib4"},
					{Id="palette.entities.creatures.ckbib4", Translation="uiR2EDcreature_ckbib4"},
					{Id="palette.entities.creatures.ckhib4", Translation="uiR2EDcreature_ckhib4"},
					{Id="palette.entities.creatures.ckjib4", Translation="uiR2EDcreature_ckjib4"},
					{Id="palette.entities.creatures.ckeib4", Translation="uiR2EDcreature_ckeib4"},
					{Id="palette.entities.creatures.ckfib4", Translation="uiR2EDcreature_ckfib4"},
					{Id="palette.entities.creatures.ckcib4", Translation="uiR2EDcreature_ckcib4"},
					{Id="palette.entities.creatures.ckiib4", Translation="uiR2EDcreature_ckiib4"},
					{Id="palette.entities.creatures.ckfrb4", Translation="uiR2EDcreature_ckfrb4"},
					{Id="palette.entities.creatures.ckgib3", Translation="uiR2EDcreature_ckgib3"},
					{Id="palette.entities.creatures.ckaib3", Translation="uiR2EDcreature_ckaib3"},
					{Id="palette.entities.creatures.ckdib3", Translation="uiR2EDcreature_ckdib3"},
					{Id="palette.entities.creatures.ckbib3", Translation="uiR2EDcreature_ckbib3"},
					{Id="palette.entities.creatures.ckhib3", Translation="uiR2EDcreature_ckhib3"},
					{Id="palette.entities.creatures.ckjib3", Translation="uiR2EDcreature_ckjib3"},
					{Id="palette.entities.creatures.ckeib3", Translation="uiR2EDcreature_ckeib3"},
					{Id="palette.entities.creatures.ckfib3", Translation="uiR2EDcreature_ckfib3"},
					{Id="palette.entities.creatures.ckcib3", Translation="uiR2EDcreature_ckcib3"},
					{Id="palette.entities.creatures.ckiib3", Translation="uiR2EDcreature_ckiib3"},
					{Id="palette.entities.creatures.ckfrb3", Translation="uiR2EDcreature_ckfrb3"},
					{Id="palette.entities.creatures.ckgib2", Translation="uiR2EDcreature_ckgib2"},
					{Id="palette.entities.creatures.ckaib2", Translation="uiR2EDcreature_ckaib2"},
					{Id="palette.entities.creatures.ckdib2", Translation="uiR2EDcreature_ckdib2"},
					{Id="palette.entities.creatures.ckbib2", Translation="uiR2EDcreature_ckbib2"},
					{Id="palette.entities.creatures.ckhib2", Translation="uiR2EDcreature_ckhib2"},
					{Id="palette.entities.creatures.ckjib2", Translation="uiR2EDcreature_ckjib2"},
					{Id="palette.entities.creatures.ckeib2", Translation="uiR2EDcreature_ckeib2"},
					{Id="palette.entities.creatures.ckfib2", Translation="uiR2EDcreature_ckfib2"},
					{Id="palette.entities.creatures.ckcib2", Translation="uiR2EDcreature_ckcib2"},
					{Id="palette.entities.creatures.ckiib2", Translation="uiR2EDcreature_ckiib2"},
					{Id="palette.entities.creatures.ckfrb2", Translation="uiR2EDcreature_ckfrb2"},
					{Id="palette.entities.creatures.ckgib1", Translation="uiR2EDcreature_ckgib1"},
					{Id="palette.entities.creatures.ckaib1", Translation="uiR2EDcreature_ckaib1"},
					{Id="palette.entities.creatures.ckdib1", Translation="uiR2EDcreature_ckdib1"},
					{Id="palette.entities.creatures.ckbib1", Translation="uiR2EDcreature_ckbib1"},
					{Id="palette.entities.creatures.ckhib1", Translation="uiR2EDcreature_ckhib1"},
					{Id="palette.entities.creatures.ckjib1", Translation="uiR2EDcreature_ckjib1"},
					{Id="palette.entities.creatures.ckeib1", Translation="uiR2EDcreature_ckeib1"},
					{Id="palette.entities.creatures.ckfib1", Translation="uiR2EDcreature_ckfib1"},
					{Id="palette.entities.creatures.ckcib1", Translation="uiR2EDcreature_ckcib1"},
					{Id="palette.entities.creatures.ckiib1", Translation="uiR2EDcreature_ckiib1"},
					{Id="palette.entities.creatures.ckfrb1", Translation="uiR2EDcreature_ckfrb1"}
				}
			}
		},

		npc = 
		{
-- sadge			cuthroats = 
-- sadge			{
-- sadge				fyros_cutthroats = 
-- sadge				{
-- sadge					instances =
-- sadge					{
-- sadge						{Id="palette.entities.npcs.cuthroats.cuthroat_b_melee_a_f_f", Translation="uiR2EDnpc_cuthroat_b_melee_a_f_f"},
-- sadge						{Id="palette.entities.npcs.cuthroats.cuthroat_b_melee_b_f_f", Translation="uiR2EDnpc_cuthroat_b_melee_b_f_f"},
-- sadge						{Id="palette.entities.npcs.cuthroats.cuthroat_b_melee_c_f_f", Translation="uiR2EDnpc_cuthroat_b_melee_c_f_f"},
-- sadge						{Id="palette.entities.npcs.cuthroats.cuthroat_b_range_a_f_f", Translation="uiR2EDnpc_cuthroat_b_range_a_f_f"},
-- sadge						{Id="palette.entities.npcs.cuthroats.cuthroat_b_range_b_f_f", Translation="uiR2EDnpc_cuthroat_b_range_b_f_f"},
-- sadge						{Id="palette.entities.npcs.cuthroats.cuthroat_b_range_c_f_f", Translation="uiR2EDnpc_cuthroat_b_range_c_f_f"},
-- sadge						{Id="palette.entities.npcs.cuthroats.cuthroat_b_range_c_f_h", Translation="uiR2EDnpc_cuthroat_b_range_c_f_h"},
-- sadge						{Id="palette.entities.npcs.cuthroats.cuthroat_b_melee_b_f_h", Translation="uiR2EDnpc_cuthroat_b_melee_b_f_h"},
-- sadge						{Id="palette.entities.npcs.cuthroats.cuthroat_b_melee_c_f_h", Translation="uiR2EDnpc_cuthroat_b_melee_c_f_h"},
-- sadge						{Id="palette.entities.npcs.cuthroats.cuthroat_b_melee_a_f_h", Translation="uiR2EDnpc_cuthroat_b_melee_a_f_h"},
-- sadge						{Id="palette.entities.npcs.cuthroats.cuthroat_b_range_a_f_h", Translation="uiR2EDnpc_cuthroat_b_range_a_f_h"},
-- sadge
-- sadge						{Id="palette.entities.npcs.cuthroats.cuthroat_b_range_b_f_h", Translation="uiR2EDnpc_cuthroat_b_range_b_f_h"},
-- sadge					}
-- sadge				},
-- sadge				matis_cutthroats = 
-- sadge				{
-- sadge					instances =
-- sadge					{
-- sadge						{Id="palette.entities.npcs.cuthroats.cuthroat_b_melee_c_m_f", Translation="uiR2EDnpc_cuthroat_b_melee_c_m_f"},
-- sadge						{Id="palette.entities.npcs.cuthroats.cuthroat_b_range_b_m_f", Translation="uiR2EDnpc_cuthroat_b_range_b_m_f"},
-- sadge						{Id="palette.entities.npcs.cuthroats.cuthroat_b_melee_a_m_f", Translation="uiR2EDnpc_cuthroat_b_melee_a_m_f"},
-- sadge						{Id="palette.entities.npcs.cuthroats.cuthroat_b_melee_b_m_f", Translation="uiR2EDnpc_cuthroat_b_melee_b_m_f"},
-- sadge						{Id="palette.entities.npcs.cuthroats.cuthroat_b_range_c_m_f", Translation="uiR2EDnpc_cuthroat_b_range_c_m_f"},
-- sadge						{Id="palette.entities.npcs.cuthroats.cuthroat_b_range_a_m_f", Translation="uiR2EDnpc_cuthroat_b_range_a_m_f"},
-- sadge						{Id="palette.entities.npcs.cuthroats.cuthroat_b_melee_b_m_h", Translation="uiR2EDnpc_cuthroat_b_melee_b_m_h"},
-- sadge						{Id="palette.entities.npcs.cuthroats.cuthroat_b_range_a_m_h", Translation="uiR2EDnpc_cuthroat_b_range_a_m_h"},
-- sadge						{Id="palette.entities.npcs.cuthroats.cuthroat_b_range_c_m_h", Translation="uiR2EDnpc_cuthroat_b_range_c_m_h"},
-- sadge						{Id="palette.entities.npcs.cuthroats.cuthroat_b_melee_a_m_h", Translation="uiR2EDnpc_cuthroat_b_melee_a_m_h"},
-- sadge						{Id="palette.entities.npcs.cuthroats.cuthroat_b_range_b_m_h", Translation="uiR2EDnpc_cuthroat_b_range_b_m_h"},
-- sadge						{Id="palette.entities.npcs.cuthroats.cuthroat_b_melee_c_m_h", Translation="uiR2EDnpc_cuthroat_b_melee_c_m_h"},
-- sadge					}
-- sadge				},
-- sadge				tryker_cutthroats = 
-- sadge				{
-- sadge					instances =
-- sadge					{
-- sadge						{Id="palette.entities.npcs.cuthroats.cuthroat_b_melee_b_t_f", Translation="uiR2EDnpc_cuthroat_b_melee_b_t_f"},
-- sadge						{Id="palette.entities.npcs.cuthroats.cuthroat_b_range_b_t_f", Translation="uiR2EDnpc_cuthroat_b_range_b_t_f"},
-- sadge						{Id="palette.entities.npcs.cuthroats.cuthroat_b_melee_a_t_f", Translation="uiR2EDnpc_cuthroat_b_melee_a_t_f"},
-- sadge						{Id="palette.entities.npcs.cuthroats.cuthroat_b_melee_c_t_f", Translation="uiR2EDnpc_cuthroat_b_melee_c_t_f"},
-- sadge						{Id="palette.entities.npcs.cuthroats.cuthroat_b_range_c_t_f", Translation="uiR2EDnpc_cuthroat_b_range_c_t_f"},
-- sadge						{Id="palette.entities.npcs.cuthroats.cuthroat_b_range_a_t_f", Translation="uiR2EDnpc_cuthroat_b_range_a_t_f"},
-- sadge						{Id="palette.entities.npcs.cuthroats.cuthroat_b_range_c_t_h", Translation="uiR2EDnpc_cuthroat_b_range_c_t_h"},
-- sadge						{Id="palette.entities.npcs.cuthroats.cuthroat_b_range_a_t_h", Translation="uiR2EDnpc_cuthroat_b_range_a_t_h"},
-- sadge						{Id="palette.entities.npcs.cuthroats.cuthroat_b_range_b_t_h", Translation="uiR2EDnpc_cuthroat_b_range_b_t_h"},
-- sadge						{Id="palette.entities.npcs.cuthroats.cuthroat_b_melee_a_t_h", Translation="uiR2EDnpc_cuthroat_b_melee_a_t_h"},
-- sadge						{Id="palette.entities.npcs.cuthroats.cuthroat_b_melee_b_t_h", Translation="uiR2EDnpc_cuthroat_b_melee_b_t_h"},
-- sadge						{Id="palette.entities.npcs.cuthroats.cuthroat_b_melee_c_t_h", Translation="uiR2EDnpc_cuthroat_b_melee_c_t_h"},
-- sadge					}
-- sadge				},
-- sadge				zorai_cutthroats = 
-- sadge				{
-- sadge					instances =
-- sadge					{
-- sadge						{Id="palette.entities.npcs.cuthroats.cuthroat_b_melee_b_z_f", Translation="uiR2EDnpc_cuthroat_b_melee_b_z_f"},
-- sadge						{Id="palette.entities.npcs.cuthroats.cuthroat_b_melee_c_z_f", Translation="uiR2EDnpc_cuthroat_b_melee_c_z_f"},
-- sadge						{Id="palette.entities.npcs.cuthroats.cuthroat_b_range_a_z_f", Translation="uiR2EDnpc_cuthroat_b_range_a_z_f"},
-- sadge						{Id="palette.entities.npcs.cuthroats.cuthroat_b_range_c_z_f", Translation="uiR2EDnpc_cuthroat_b_range_c_z_f"},
-- sadge						{Id="palette.entities.npcs.cuthroats.cuthroat_b_range_b_z_f", Translation="uiR2EDnpc_cuthroat_b_range_b_z_f"},
-- sadge						{Id="palette.entities.npcs.cuthroats.cuthroat_b_melee_a_z_f", Translation="uiR2EDnpc_cuthroat_b_melee_a_z_f"},
-- sadge						{Id="palette.entities.npcs.cuthroats.cuthroat_b_melee_a_z_h", Translation="uiR2EDnpc_cuthroat_b_melee_a_z_h"},
-- sadge						{Id="palette.entities.npcs.cuthroats.cuthroat_b_range_a_z_h", Translation="uiR2EDnpc_cuthroat_b_range_a_z_h"},
-- sadge						{Id="palette.entities.npcs.cuthroats.cuthroat_b_melee_b_z_h", Translation="uiR2EDnpc_cuthroat_b_melee_b_z_h"},
-- sadge						{Id="palette.entities.npcs.cuthroats.cuthroat_b_melee_c_z_h", Translation="uiR2EDnpc_cuthroat_b_melee_c_z_h"},
-- sadge						{Id="palette.entities.npcs.cuthroats.cuthroat_b_range_b_z_h", Translation="uiR2EDnpc_cuthroat_b_range_b_z_h"},
-- sadge						{Id="palette.entities.npcs.cuthroats.cuthroat_b_range_c_z_h", Translation="uiR2EDnpc_cuthroat_b_range_c_z_h"},
-- sadge					}
-- sadge				}
-- sadge			},


-- sadge			guards = 
-- sadge			{
-- sadge				fyros_guards = 
-- sadge				{
-- sadge					instances =
-- sadge					{
-- sadge						{Id="palette.entities.npcs.guards.fyros_guard_l_b_f", Translation="uiR2EDnpc_fyros_guard_l_b_f"},
-- sadge						{Id="palette.entities.npcs.guards.fyros_guard_l_b_h", Translation="uiR2EDnpc_fyros_guard_l_b_h"},
-- sadge						{Id="palette.entities.npcs.guards.fyros_guard_l_c_f", Translation="uiR2EDnpc_fyros_guard_l_c_f"},
-- sadge						{Id="palette.entities.npcs.guards.fyros_guard_l_c_h", Translation="uiR2EDnpc_fyros_guard_l_c_h"},
-- sadge						{Id="palette.entities.npcs.guards.fyros_guard_l_d_f", Translation="uiR2EDnpc_fyros_guard_l_d_f"},
-- sadge						{Id="palette.entities.npcs.guards.fyros_guard_l_d_h", Translation="uiR2EDnpc_fyros_guard_l_d_h"},
-- sadge						{Id="palette.entities.npcs.guards.fyros_guard_l_e_f", Translation="uiR2EDnpc_fyros_guard_l_e_f"},
-- sadge						{Id="palette.entities.npcs.guards.fyros_guard_l_e_h", Translation="uiR2EDnpc_fyros_guard_l_e_h"},
-- sadge						{Id="palette.entities.npcs.guards.fyros_guard_l_f_f", Translation="uiR2EDnpc_fyros_guard_l_f_f"},
-- sadge						{Id="palette.entities.npcs.guards.fyros_guard_l_f_h", Translation="uiR2EDnpc_fyros_guard_l_f_h"},
-- sadge					}
-- sadge				},
-- sadge				matis_guards = 
-- sadge				{
-- sadge					instances =
-- sadge					{
-- sadge						{Id="palette.entities.npcs.guards.matis_guard_l_b_f", Translation="uiR2EDnpc_matis_guard_l_b_f"},
-- sadge						{Id="palette.entities.npcs.guards.matis_guard_l_b_h", Translation="uiR2EDnpc_matis_guard_l_b_h"},
-- sadge						{Id="palette.entities.npcs.guards.matis_guard_l_c_f", Translation="uiR2EDnpc_matis_guard_l_c_f"},
-- sadge						{Id="palette.entities.npcs.guards.matis_guard_l_c_h", Translation="uiR2EDnpc_matis_guard_l_c_h"},
-- sadge						{Id="palette.entities.npcs.guards.matis_guard_l_d_f", Translation="uiR2EDnpc_matis_guard_l_d_f"},
-- sadge						{Id="palette.entities.npcs.guards.matis_guard_l_d_h", Translation="uiR2EDnpc_matis_guard_l_d_h"},
-- sadge						{Id="palette.entities.npcs.guards.matis_guard_l_e_f", Translation="uiR2EDnpc_matis_guard_l_e_f"},
-- sadge						{Id="palette.entities.npcs.guards.matis_guard_l_e_h", Translation="uiR2EDnpc_matis_guard_l_e_h"},
-- sadge						{Id="palette.entities.npcs.guards.matis_guard_l_f_f", Translation="uiR2EDnpc_matis_guard_l_f_f"},
-- sadge						{Id="palette.entities.npcs.guards.matis_guard_l_f_h", Translation="uiR2EDnpc_matis_guard_l_f_h"},
-- sadge					}
-- sadge				},
-- sadge				tryker_guards = 
-- sadge				{
-- sadge					instances =
-- sadge					{
-- sadge						{Id="palette.entities.npcs.guards.tryker_guard_l_b_f", Translation="uiR2EDnpc_tryker_guard_l_b_f"},
-- sadge						{Id="palette.entities.npcs.guards.tryker_guard_l_b_h", Translation="uiR2EDnpc_tryker_guard_l_b_h"},
-- sadge						{Id="palette.entities.npcs.guards.tryker_guard_l_c_f", Translation="uiR2EDnpc_tryker_guard_l_c_f"},
-- sadge						{Id="palette.entities.npcs.guards.tryker_guard_l_c_h", Translation="uiR2EDnpc_tryker_guard_l_c_h"},
-- sadge						{Id="palette.entities.npcs.guards.tryker_guard_l_d_f", Translation="uiR2EDnpc_tryker_guard_l_d_f"},
-- sadge						{Id="palette.entities.npcs.guards.tryker_guard_l_d_h", Translation="uiR2EDnpc_tryker_guard_l_d_h"},
-- sadge						{Id="palette.entities.npcs.guards.tryker_guard_l_e_f", Translation="uiR2EDnpc_tryker_guard_l_e_f"},
-- sadge						{Id="palette.entities.npcs.guards.tryker_guard_l_e_h", Translation="uiR2EDnpc_tryker_guard_l_e_h"},
-- sadge						{Id="palette.entities.npcs.guards.tryker_guard_l_f_f", Translation="uiR2EDnpc_tryker_guard_l_f_f"},
-- sadge						{Id="palette.entities.npcs.guards.tryker_guard_l_f_h", Translation="uiR2EDnpc_tryker_guard_l_f_h"},
-- sadge					}
-- sadge				},
-- sadge				zorai_guards = 
-- sadge				{
-- sadge					instances =
-- sadge					{
-- sadge						{Id="palette.entities.npcs.guards.zorai_guard_l_b_f", Translation="uiR2EDnpc_zorai_guard_l_b_f"},
-- sadge						{Id="palette.entities.npcs.guards.zorai_guard_l_b_h", Translation="uiR2EDnpc_zorai_guard_l_b_h"},
-- sadge						{Id="palette.entities.npcs.guards.zorai_guard_l_c_f", Translation="uiR2EDnpc_zorai_guard_l_c_f"},
-- sadge						{Id="palette.entities.npcs.guards.zorai_guard_l_c_h", Translation="uiR2EDnpc_zorai_guard_l_c_h"},
-- sadge						{Id="palette.entities.npcs.guards.zorai_guard_l_d_f", Translation="uiR2EDnpc_zorai_guard_l_d_f"},
-- sadge						{Id="palette.entities.npcs.guards.zorai_guard_l_d_h", Translation="uiR2EDnpc_zorai_guard_l_d_h"},
-- sadge						{Id="palette.entities.npcs.guards.zorai_guard_l_e_f", Translation="uiR2EDnpc_zorai_guard_l_e_f"},
-- sadge						{Id="palette.entities.npcs.guards.zorai_guard_l_e_h", Translation="uiR2EDnpc_zorai_guard_l_e_h"},
-- sadge						{Id="palette.entities.npcs.guards.zorai_guard_l_f_f", Translation="uiR2EDnpc_zorai_guard_l_f_f"},
-- sadge						{Id="palette.entities.npcs.guards.zorai_guard_l_f_h", Translation="uiR2EDnpc_zorai_guard_l_f_h"},
-- sadge					}
-- sadge				}
-- sadge			},


-- sadge			primitives = 
-- sadge			{
-- sadge				cute = 
-- sadge				{
-- sadge					instances =
-- sadge					{
-- sadge						{Id="palette.entities.npcs.cute.npc_cute_mature_b", Translation="uiR2EDnpc_npc_cute_mature_b"},
-- sadge						{Id="palette.entities.npcs.cute.npc_cute_mature_c", Translation="uiR2EDnpc_npc_cute_mature_c"},
-- sadge						{Id="palette.entities.npcs.cute.npc_cute_mature_d", Translation="uiR2EDnpc_npc_cute_mature_d"},
-- sadge						{Id="palette.entities.npcs.cute.npc_cute_mature_e", Translation="uiR2EDnpc_npc_cute_mature_e"},
-- sadge						{Id="palette.entities.npcs.cute.npc_cute_mature_f", Translation="uiR2EDnpc_npc_cute_mature_f"},
-- sadge						{Id="palette.entities.npcs.cute.npc_cute_venerable_b", Translation="uiR2EDnpc_npc_cute_venerable_b"},
-- sadge						{Id="palette.entities.npcs.cute.npc_cute_venerable_c", Translation="uiR2EDnpc_npc_cute_venerable_c"},
-- sadge						{Id="palette.entities.npcs.cute.npc_cute_venerable_d", Translation="uiR2EDnpc_npc_cute_venerable_d"},
-- sadge						{Id="palette.entities.npcs.cute.npc_cute_venerable_e", Translation="uiR2EDnpc_npc_cute_venerable_e"},
-- sadge						{Id="palette.entities.npcs.cute.npc_cute_venerable_f", Translation="uiR2EDnpc_npc_cute_venerable_f"},
-- sadge						{Id="palette.entities.npcs.cute.npc_cute_weapon_b", Translation="uiR2EDnpc_npc_cute_weapon_b"},
-- sadge						{Id="palette.entities.npcs.cute.npc_cute_weapon_c", Translation="uiR2EDnpc_npc_cute_weapon_c"},
-- sadge						{Id="palette.entities.npcs.cute.npc_cute_weapon_d", Translation="uiR2EDnpc_npc_cute_weapon_d"},
-- sadge						{Id="palette.entities.npcs.cute.npc_cute_weapon_e", Translation="uiR2EDnpc_npc_cute_weapon_e"},
-- sadge						{Id="palette.entities.npcs.cute.npc_cute_weapon_f", Translation="uiR2EDnpc_npc_cute_weapon_f"},
-- sadge					}
-- sadge				},
-- sadge				frahar = 
-- sadge				{
-- sadge					instances =
-- sadge					{
-- sadge						{Id="palette.entities.npcs.frahar.npc_frahar_ancient_b", Translation="uiR2EDnpc_npc_frahar_ancient_b"},
-- sadge						{Id="palette.entities.npcs.frahar.npc_frahar_ancient_c", Translation="uiR2EDnpc_npc_frahar_ancient_c"},
-- sadge						{Id="palette.entities.npcs.frahar.npc_frahar_ancient_d", Translation="uiR2EDnpc_npc_frahar_ancient_d"},
-- sadge						{Id="palette.entities.npcs.frahar.npc_frahar_ancient_e", Translation="uiR2EDnpc_npc_frahar_ancient_e"},
-- sadge						{Id="palette.entities.npcs.frahar.npc_frahar_ancient_f", Translation="uiR2EDnpc_npc_frahar_ancient_f"},
-- sadge						{Id="palette.entities.npcs.frahar.npc_frahar_patriarchal_b", Translation="uiR2EDnpc_npc_frahar_patriarchal_b"},
-- sadge						{Id="palette.entities.npcs.frahar.npc_frahar_patriarchal_c", Translation="uiR2EDnpc_npc_frahar_patriarchal_c"},
-- sadge						{Id="palette.entities.npcs.frahar.npc_frahar_patriarchal_d", Translation="uiR2EDnpc_npc_frahar_patriarchal_d"},
-- sadge						{Id="palette.entities.npcs.frahar.npc_frahar_patriarchal_e", Translation="uiR2EDnpc_npc_frahar_patriarchal_e"},
-- sadge						{Id="palette.entities.npcs.frahar.npc_frahar_patriarchal_f", Translation="uiR2EDnpc_npc_frahar_patriarchal_f"},
-- sadge						{Id="palette.entities.npcs.frahar.npc_frahar_weapon_b", Translation="uiR2EDnpc_npc_frahar_weapon_b"},
-- sadge						{Id="palette.entities.npcs.frahar.npc_frahar_weapon_c", Translation="uiR2EDnpc_npc_frahar_weapon_c"},
-- sadge						{Id="palette.entities.npcs.frahar.npc_frahar_weapon_d", Translation="uiR2EDnpc_npc_frahar_weapon_d"},
-- sadge						{Id="palette.entities.npcs.frahar.npc_frahar_weapon_e", Translation="uiR2EDnpc_npc_frahar_weapon_e"},
-- sadge						{Id="palette.entities.npcs.frahar.npc_frahar_weapon_f", Translation="uiR2EDnpc_npc_frahar_weapon_f"},
-- sadge					}
-- sadge				},
-- sadge				gibbai = 
-- sadge				{
-- sadge					instances =
-- sadge					{
-- sadge						{Id="palette.entities.npcs.gibbai.npc_gibbay_old_b", Translation="uiR2EDnpc_npc_gibbay_old_b"},
-- sadge						{Id="palette.entities.npcs.gibbai.npc_gibbay_old_c", Translation="uiR2EDnpc_npc_gibbay_old_c"},
-- sadge						{Id="palette.entities.npcs.gibbai.npc_gibbay_old_d", Translation="uiR2EDnpc_npc_gibbay_old_d"},
-- sadge						{Id="palette.entities.npcs.gibbai.npc_gibbay_old_e", Translation="uiR2EDnpc_npc_gibbay_old_e"},
-- sadge						{Id="palette.entities.npcs.gibbai.npc_gibbay_old_f", Translation="uiR2EDnpc_npc_gibbay_old_f"},
-- sadge						{Id="palette.entities.npcs.gibbai.npc_gibbay_weapon_b", Translation="uiR2EDnpc_npc_gibbay_weapon_b"},
-- sadge						{Id="palette.entities.npcs.gibbai.npc_gibbay_weapon_c", Translation="uiR2EDnpc_npc_gibbay_weapon_c"},
-- sadge						{Id="palette.entities.npcs.gibbai.npc_gibbay_weapon_d", Translation="uiR2EDnpc_npc_gibbay_weapon_d"},
-- sadge						{Id="palette.entities.npcs.gibbai.npc_gibbay_weapon_e", Translation="uiR2EDnpc_npc_gibbay_weapon_e"},
-- sadge						{Id="palette.entities.npcs.gibbai.npc_gibbay_weapon_f", Translation="uiR2EDnpc_npc_gibbay_weapon_f"},
-- sadge						{Id="palette.entities.npcs.gibbai.npc_gibbay_wise_b", Translation="uiR2EDnpc_npc_gibbay_wise_b"},
-- sadge						{Id="palette.entities.npcs.gibbai.npc_gibbay_wise_c", Translation="uiR2EDnpc_npc_gibbay_wise_c"},
-- sadge						{Id="palette.entities.npcs.gibbai.npc_gibbay_wise_d", Translation="uiR2EDnpc_npc_gibbay_wise_d"},
-- sadge						{Id="palette.entities.npcs.gibbai.npc_gibbay_wise_e", Translation="uiR2EDnpc_npc_gibbay_wise_e"},
-- sadge						{Id="palette.entities.npcs.gibbai.npc_gibbay_wise_f", Translation="uiR2EDnpc_npc_gibbay_wise_f"}
-- sadge					}
-- sadge				}
-- sadge			},


			kami = 
			{
				instances =
				{
--					{Id="palette.entities.npcs.kami.kami_guardian_k_g", Translation="uiR2EDnpc_kami_guardian_k_g"},
--					{Id="palette.entities.npcs.kami.kami_guide_k_g", Translation="uiR2EDnpc_kami_guide_k_g"},

					{Id="palette.entities.npcs.kami.kami_guardian_b", Translation="uiR2EDnpc_kami_guardian_b"},
					{Id="palette.entities.npcs.kami.kami_guardian_c", Translation="uiR2EDnpc_kami_guardian_c"},
					{Id="palette.entities.npcs.kami.kami_guardian_d", Translation="uiR2EDnpc_kami_guardian_d"},
					{Id="palette.entities.npcs.kami.kami_guardian_e", Translation="uiR2EDnpc_kami_guardian_e"},
					{Id="palette.entities.npcs.kami.kami_guardian_f", Translation="uiR2EDnpc_kami_guardian_f"},
					{Id="palette.entities.npcs.kami.kami_preacher_b", Translation="uiR2EDnpc_kami_preacher_b"},
					{Id="palette.entities.npcs.kami.kami_preacher_c", Translation="uiR2EDnpc_kami_preacher_c"},
					{Id="palette.entities.npcs.kami.kami_preacher_d", Translation="uiR2EDnpc_kami_preacher_d"},
					{Id="palette.entities.npcs.kami.kami_preacher_e", Translation="uiR2EDnpc_kami_preacher_e"},
					{Id="palette.entities.npcs.kami.kami_preacher_f", Translation="uiR2EDnpc_kami_preacher_f"},

					{Id="palette.entities.npcs.kami.kami_guardian_2_b", Translation="uiR2EDnpc_kami_guardian_2_b"},
					{Id="palette.entities.npcs.kami.kami_guardian_2_c", Translation="uiR2EDnpc_kami_guardian_2_c"},
					{Id="palette.entities.npcs.kami.kami_guardian_2_d", Translation="uiR2EDnpc_kami_guardian_2_d"},
					{Id="palette.entities.npcs.kami.kami_guardian_2_e", Translation="uiR2EDnpc_kami_guardian_2_e"},
					{Id="palette.entities.npcs.kami.kami_guardian_2_f", Translation="uiR2EDnpc_kami_guardian_2_f"},
--					{Id="palette.entities.npcs.kami.kami_guardian_2_g", Translation="uiR2EDnpc_kami_guardian_2_g"},
					{Id="palette.entities.npcs.kami.kami_preacher_2_b", Translation="uiR2EDnpc_kami_preacher_2_b"},
					{Id="palette.entities.npcs.kami.kami_preacher_2_c", Translation="uiR2EDnpc_kami_preacher_2_c"},
					{Id="palette.entities.npcs.kami.kami_preacher_2_d", Translation="uiR2EDnpc_kami_preacher_2_d"},
					{Id="palette.entities.npcs.kami.kami_preacher_2_e", Translation="uiR2EDnpc_kami_preacher_2_e"},
					{Id="palette.entities.npcs.kami.kami_preacher_2_f", Translation="uiR2EDnpc_kami_preacher_2_f"},
--					{Id="palette.entities.npcs.kami.kami_preacher_2_g", Translation="uiR2EDnpc_kami_preacher_2_g"},

					{Id="palette.entities.npcs.kami.kami_guardian_3_b", Translation="uiR2EDnpc_kami_guardian_3_b"},
					{Id="palette.entities.npcs.kami.kami_guardian_3_c", Translation="uiR2EDnpc_kami_guardian_3_c"},
					{Id="palette.entities.npcs.kami.kami_guardian_3_d", Translation="uiR2EDnpc_kami_guardian_3_d"},
					{Id="palette.entities.npcs.kami.kami_guardian_3_e", Translation="uiR2EDnpc_kami_guardian_3_e"},
					{Id="palette.entities.npcs.kami.kami_guardian_3_f", Translation="uiR2EDnpc_kami_guardian_3_f"},
--					{Id="palette.entities.npcs.kami.kami_guardian_3_g", Translation="uiR2EDnpc_kami_guardian_3_g"},
					{Id="palette.entities.npcs.kami.kami_preacher_3_b", Translation="uiR2EDnpc_kami_preacher_3_b"},
					{Id="palette.entities.npcs.kami.kami_preacher_3_c", Translation="uiR2EDnpc_kami_preacher_3_c"},
					{Id="palette.entities.npcs.kami.kami_preacher_3_d", Translation="uiR2EDnpc_kami_preacher_3_d"},
					{Id="palette.entities.npcs.kami.kami_preacher_3_e", Translation="uiR2EDnpc_kami_preacher_3_e"},
					{Id="palette.entities.npcs.kami.kami_preacher_3_f", Translation="uiR2EDnpc_kami_preacher_3_f"},
--					{Id="palette.entities.npcs.kami.kami_preacher_3_g", Translation="uiR2EDnpc_kami_preacher_3_g"},

					{Id="palette.entities.npcs.kami.kami_guardian_4_b", Translation="uiR2EDnpc_kami_guardian_4_b"},
					{Id="palette.entities.npcs.kami.kami_guardian_4_c", Translation="uiR2EDnpc_kami_guardian_4_c"},
					{Id="palette.entities.npcs.kami.kami_guardian_4_d", Translation="uiR2EDnpc_kami_guardian_4_d"},
					{Id="palette.entities.npcs.kami.kami_guardian_4_e", Translation="uiR2EDnpc_kami_guardian_4_e"},
					{Id="palette.entities.npcs.kami.kami_guardian_4_f", Translation="uiR2EDnpc_kami_guardian_4_f"},
--					{Id="palette.entities.npcs.kami.kami_guardian_4_g", Translation="uiR2EDnpc_kami_guardian_4_g"},
					{Id="palette.entities.npcs.kami.kami_preacher_4_b", Translation="uiR2EDnpc_kami_preacher_4_b"},
					{Id="palette.entities.npcs.kami.kami_preacher_4_c", Translation="uiR2EDnpc_kami_preacher_4_c"},
					{Id="palette.entities.npcs.kami.kami_preacher_4_d", Translation="uiR2EDnpc_kami_preacher_4_d"},
					{Id="palette.entities.npcs.kami.kami_preacher_4_e", Translation="uiR2EDnpc_kami_preacher_4_e"},
					{Id="palette.entities.npcs.kami.kami_preacher_4_f", Translation="uiR2EDnpc_kami_preacher_4_f"},
--					{Id="palette.entities.npcs.kami.kami_preacher_4_g", Translation="uiR2EDnpc_kami_preacher_4_g"},
				}
			},

			karavan = 
			{
				instances =
				{
					{Id="palette.entities.npcs.karavan.karavan_guard_k_f_b", Translation="uiR2EDnpc_karavan_guard_k_f_b"},
					{Id="palette.entities.npcs.karavan.karavan_guard_k_h_b", Translation="uiR2EDnpc_karavan_guard_k_h_b"},
					{Id="palette.entities.npcs.karavan.karavan_emissary_f_b", Translation="uiR2EDnpc_karavan_emissary_f_b"},
					{Id="palette.entities.npcs.karavan.karavan_emissary_h_b", Translation="uiR2EDnpc_karavan_emissary_h_b"},

					{Id="palette.entities.npcs.karavan.karavan_guard_k_f_c", Translation="uiR2EDnpc_karavan_guard_k_f_c"},
					{Id="palette.entities.npcs.karavan.karavan_guard_k_h_c", Translation="uiR2EDnpc_karavan_guard_k_h_c"},
					{Id="palette.entities.npcs.karavan.karavan_emissary_f_c", Translation="uiR2EDnpc_karavan_emissary_f_c"},
					{Id="palette.entities.npcs.karavan.karavan_emissary_h_c", Translation="uiR2EDnpc_karavan_emissary_h_c"},

					{Id="palette.entities.npcs.karavan.karavan_guard_k_f_d", Translation="uiR2EDnpc_karavan_guard_k_f_d"},
					{Id="palette.entities.npcs.karavan.karavan_guard_k_h_d", Translation="uiR2EDnpc_karavan_guard_k_h_d"},
					{Id="palette.entities.npcs.karavan.karavan_emissary_f_d", Translation="uiR2EDnpc_karavan_emissary_f_d"},
					{Id="palette.entities.npcs.karavan.karavan_emissary_h_d", Translation="uiR2EDnpc_karavan_emissary_h_d"},

					{Id="palette.entities.npcs.karavan.karavan_guard_k_f_e", Translation="uiR2EDnpc_karavan_guard_k_f_e"},
					{Id="palette.entities.npcs.karavan.karavan_guard_k_h_e", Translation="uiR2EDnpc_karavan_guard_k_h_e"},
					{Id="palette.entities.npcs.karavan.karavan_emissary_f_e", Translation="uiR2EDnpc_karavan_emissary_f_e"},
					{Id="palette.entities.npcs.karavan.karavan_emissary_h_e", Translation="uiR2EDnpc_karavan_emissary_h_e"},

					{Id="palette.entities.npcs.karavan.karavan_guard_k_f_f", Translation="uiR2EDnpc_karavan_guard_k_f_f"},
					{Id="palette.entities.npcs.karavan.karavan_guard_k_h_f", Translation="uiR2EDnpc_karavan_guard_k_h_f"},
					{Id="palette.entities.npcs.karavan.karavan_emissary_f_f", Translation="uiR2EDnpc_karavan_emissary_f_f"},
					{Id="palette.entities.npcs.karavan.karavan_emissary_h_f", Translation="uiR2EDnpc_karavan_emissary_h_f"},
				}
			},

			genericNpcs = 
			{
				instances =
				{
--					{Id="palette.entities.players.fyros_male", Translation="uiR2EDnpc_fyros_h"},
-- sadge					{Id="palette.entities.players.fyros_female", Translation="uiR2EDnpc_fyros_f"},
--					{Id="palette.entities.players.matis_male", Translation="uiR2EDnpc_matis_h"},
-- sadge					{Id="palette.entities.players.matis_female", Translation="uiR2EDnpc_matis_f"},
--					{Id="palette.entities.players.tryker_male", Translation="uiR2EDnpc_tryker_h"},
-- sadge					{Id="palette.entities.players.tryker_female", Translation="uiR2EDnpc_tryker_f"},
--					{Id="palette.entities.players.zorai_male", Translation="uiR2EDnpc_zorai_h"},
-- sadge					{Id="palette.entities.players.zorai_female", Translation="uiR2EDnpc_zorai_f"},
			
					{Id="palette.entities.npcs.civils.f_civil_20", Translation="uiR2EDnpc_fyros_h"},
					{Id="palette.entities.npcs.civils.m_civil_20", Translation="uiR2EDnpc_matis_h"},
					{Id="palette.entities.npcs.civils.t_civil_20", Translation="uiR2EDnpc_tryker_h"},
					{Id="palette.entities.npcs.civils.z_civil_20", Translation="uiR2EDnpc_zorai_h"},
					
					{Id="palette.entities.npcs.civils.f_civil_70", Translation="uiR2EDnpc_fyros_h"},
					{Id="palette.entities.npcs.civils.m_civil_70", Translation="uiR2EDnpc_matis_h"},
					{Id="palette.entities.npcs.civils.t_civil_70", Translation="uiR2EDnpc_tryker_h"},
					{Id="palette.entities.npcs.civils.z_civil_70", Translation="uiR2EDnpc_zorai_h"},
					
					{Id="palette.entities.npcs.civils.f_civil_120", Translation="uiR2EDnpc_fyros_h"},
					{Id="palette.entities.npcs.civils.m_civil_120", Translation="uiR2EDnpc_matis_h"},
					{Id="palette.entities.npcs.civils.t_civil_120", Translation="uiR2EDnpc_tryker_h"},
					{Id="palette.entities.npcs.civils.z_civil_120", Translation="uiR2EDnpc_zorai_h"},
					
					{Id="palette.entities.npcs.civils.f_civil_170", Translation="uiR2EDnpc_fyros_h"},
					{Id="palette.entities.npcs.civils.m_civil_170", Translation="uiR2EDnpc_matis_h"},
					{Id="palette.entities.npcs.civils.t_civil_170", Translation="uiR2EDnpc_tryker_h"},
					{Id="palette.entities.npcs.civils.z_civil_170", Translation="uiR2EDnpc_zorai_h"},
					
					{Id="palette.entities.npcs.civils.f_civil_220", Translation="uiR2EDnpc_fyros_h"},
					{Id="palette.entities.npcs.civils.m_civil_220", Translation="uiR2EDnpc_matis_h"},
					{Id="palette.entities.npcs.civils.t_civil_220", Translation="uiR2EDnpc_tryker_h"},
					{Id="palette.entities.npcs.civils.z_civil_220", Translation="uiR2EDnpc_zorai_h"},
				}
			},
			guards =
			{
				instances =
				{
					{Id="palette.entities.npcs.guards.f_guard_45", Translation="uiR2EDnpc_f_guard"},
					{Id="palette.entities.npcs.guards.m_guard_45", Translation="uiR2EDnpc_m_guard"},
					{Id="palette.entities.npcs.guards.t_guard_45", Translation="uiR2EDnpc_t_guard"},
					{Id="palette.entities.npcs.guards.z_guard_45", Translation="uiR2EDnpc_z_guard"},
					
					{Id="palette.entities.npcs.guards.f_guard_95", Translation="uiR2EDnpc_f_guard"},
					{Id="palette.entities.npcs.guards.m_guard_95", Translation="uiR2EDnpc_m_guard"},
					{Id="palette.entities.npcs.guards.t_guard_95", Translation="uiR2EDnpc_t_guard"},
					{Id="palette.entities.npcs.guards.z_guard_95", Translation="uiR2EDnpc_z_guard"},
					
					{Id="palette.entities.npcs.guards.f_guard_145", Translation="uiR2EDnpc_f_guard"},
					{Id="palette.entities.npcs.guards.m_guard_145", Translation="uiR2EDnpc_m_guard"},
					{Id="palette.entities.npcs.guards.t_guard_145", Translation="uiR2EDnpc_t_guard"},
					{Id="palette.entities.npcs.guards.z_guard_145", Translation="uiR2EDnpc_z_guard"},
					
					{Id="palette.entities.npcs.guards.f_guard_195", Translation="uiR2EDnpc_f_guard"},
					{Id="palette.entities.npcs.guards.m_guard_195", Translation="uiR2EDnpc_m_guard"},
					{Id="palette.entities.npcs.guards.t_guard_195", Translation="uiR2EDnpc_t_guard"},
					{Id="palette.entities.npcs.guards.z_guard_195", Translation="uiR2EDnpc_z_guard"},
					
					{Id="palette.entities.npcs.guards.f_guard_245", Translation="uiR2EDnpc_f_guard"},
					{Id="palette.entities.npcs.guards.m_guard_245", Translation="uiR2EDnpc_m_guard"},
					{Id="palette.entities.npcs.guards.t_guard_245", Translation="uiR2EDnpc_t_guard"},
					{Id="palette.entities.npcs.guards.z_guard_245", Translation="uiR2EDnpc_z_guard"},
				}
			},
			cuthroats =
			{
				instances =
				{
					{Id="palette.entities.npcs.bandits.f_melee_dd_20", Translation="uiR2EDnpc_f_melee_dd"},
					{Id="palette.entities.npcs.bandits.m_melee_dd_20", Translation="uiR2EDnpc_m_melee_dd"},
					{Id="palette.entities.npcs.bandits.t_melee_dd_20", Translation="uiR2EDnpc_t_melee_dd"},
					{Id="palette.entities.npcs.bandits.z_melee_dd_20", Translation="uiR2EDnpc_z_melee_dd"},

					{Id="palette.entities.npcs.bandits.f_melee_dd_70", Translation="uiR2EDnpc_f_melee_dd"},
					{Id="palette.entities.npcs.bandits.m_melee_dd_70", Translation="uiR2EDnpc_m_melee_dd"},
					{Id="palette.entities.npcs.bandits.t_melee_dd_70", Translation="uiR2EDnpc_t_melee_dd"},
					{Id="palette.entities.npcs.bandits.z_melee_dd_70", Translation="uiR2EDnpc_z_melee_dd"},

					{Id="palette.entities.npcs.bandits.f_melee_dd_120", Translation="uiR2EDnpc_f_melee_dd"},
					{Id="palette.entities.npcs.bandits.m_melee_dd_120", Translation="uiR2EDnpc_m_melee_dd"},
					{Id="palette.entities.npcs.bandits.t_melee_dd_120", Translation="uiR2EDnpc_t_melee_dd"},
					{Id="palette.entities.npcs.bandits.z_melee_dd_120", Translation="uiR2EDnpc_z_melee_dd"},

					{Id="palette.entities.npcs.bandits.f_melee_dd_170", Translation="uiR2EDnpc_f_melee_dd"},
					{Id="palette.entities.npcs.bandits.m_melee_dd_170", Translation="uiR2EDnpc_m_melee_dd"},
					{Id="palette.entities.npcs.bandits.t_melee_dd_170", Translation="uiR2EDnpc_t_melee_dd"},
					{Id="palette.entities.npcs.bandits.z_melee_dd_170", Translation="uiR2EDnpc_z_melee_dd"},

					{Id="palette.entities.npcs.bandits.f_melee_dd_220", Translation="uiR2EDnpc_f_melee_dd"},
					{Id="palette.entities.npcs.bandits.m_melee_dd_220", Translation="uiR2EDnpc_m_melee_dd"},
					{Id="palette.entities.npcs.bandits.t_melee_dd_220", Translation="uiR2EDnpc_t_melee_dd"},
					{Id="palette.entities.npcs.bandits.z_melee_dd_220", Translation="uiR2EDnpc_z_melee_dd"},


					{Id="palette.entities.npcs.bandits.f_melee_tank_20", Translation="uiR2EDnpc_f_melee_tank"},
					{Id="palette.entities.npcs.bandits.m_melee_tank_20", Translation="uiR2EDnpc_m_melee_tank"},
					{Id="palette.entities.npcs.bandits.t_melee_tank_20", Translation="uiR2EDnpc_t_melee_tank"},
					{Id="palette.entities.npcs.bandits.z_melee_tank_20", Translation="uiR2EDnpc_z_melee_tank"},

					{Id="palette.entities.npcs.bandits.f_melee_tank_70", Translation="uiR2EDnpc_f_melee_tank"},
					{Id="palette.entities.npcs.bandits.m_melee_tank_70", Translation="uiR2EDnpc_m_melee_tank"},
					{Id="palette.entities.npcs.bandits.t_melee_tank_70", Translation="uiR2EDnpc_t_melee_tank"},
					{Id="palette.entities.npcs.bandits.z_melee_tank_70", Translation="uiR2EDnpc_z_melee_tank"},

					{Id="palette.entities.npcs.bandits.f_melee_tank_120", Translation="uiR2EDnpc_f_melee_tank"},
					{Id="palette.entities.npcs.bandits.m_melee_tank_120", Translation="uiR2EDnpc_m_melee_tank"},
					{Id="palette.entities.npcs.bandits.t_melee_tank_120", Translation="uiR2EDnpc_t_melee_tank"},
					{Id="palette.entities.npcs.bandits.z_melee_tank_120", Translation="uiR2EDnpc_z_melee_tank"},

					{Id="palette.entities.npcs.bandits.f_melee_tank_170", Translation="uiR2EDnpc_f_melee_tank"},
					{Id="palette.entities.npcs.bandits.m_melee_tank_170", Translation="uiR2EDnpc_m_melee_tank"},
					{Id="palette.entities.npcs.bandits.t_melee_tank_170", Translation="uiR2EDnpc_t_melee_tank"},
					{Id="palette.entities.npcs.bandits.z_melee_tank_170", Translation="uiR2EDnpc_z_melee_tank"},

					{Id="palette.entities.npcs.bandits.f_melee_tank_220", Translation="uiR2EDnpc_f_melee_tank"},
					{Id="palette.entities.npcs.bandits.m_melee_tank_220", Translation="uiR2EDnpc_m_melee_tank"},
					{Id="palette.entities.npcs.bandits.t_melee_tank_220", Translation="uiR2EDnpc_t_melee_tank"},
					{Id="palette.entities.npcs.bandits.z_melee_tank_220", Translation="uiR2EDnpc_z_melee_tank"},


					{Id="palette.entities.npcs.bandits.f_light_melee_20", Translation="uiR2EDnpc_f_light_melee"},
					{Id="palette.entities.npcs.bandits.m_light_melee_20", Translation="uiR2EDnpc_m_light_melee"},
					{Id="palette.entities.npcs.bandits.t_light_melee_20", Translation="uiR2EDnpc_t_light_melee"},
					{Id="palette.entities.npcs.bandits.z_light_melee_20", Translation="uiR2EDnpc_z_light_melee"},

					{Id="palette.entities.npcs.bandits.f_light_melee_70", Translation="uiR2EDnpc_f_light_melee"},
					{Id="palette.entities.npcs.bandits.m_light_melee_70", Translation="uiR2EDnpc_m_light_melee"},
					{Id="palette.entities.npcs.bandits.t_light_melee_70", Translation="uiR2EDnpc_t_light_melee"},
					{Id="palette.entities.npcs.bandits.z_light_melee_70", Translation="uiR2EDnpc_z_light_melee"},

					{Id="palette.entities.npcs.bandits.f_light_melee_120", Translation="uiR2EDnpc_f_light_melee"},
					{Id="palette.entities.npcs.bandits.m_light_melee_120", Translation="uiR2EDnpc_m_light_melee"},
					{Id="palette.entities.npcs.bandits.t_light_melee_120", Translation="uiR2EDnpc_t_light_melee"},
					{Id="palette.entities.npcs.bandits.z_light_melee_120", Translation="uiR2EDnpc_z_light_melee"},

					{Id="palette.entities.npcs.bandits.f_light_melee_170", Translation="uiR2EDnpc_f_light_melee"},
					{Id="palette.entities.npcs.bandits.m_light_melee_170", Translation="uiR2EDnpc_m_light_melee"},
					{Id="palette.entities.npcs.bandits.t_light_melee_170", Translation="uiR2EDnpc_t_light_melee"},
					{Id="palette.entities.npcs.bandits.z_light_melee_170", Translation="uiR2EDnpc_z_light_melee"},

					{Id="palette.entities.npcs.bandits.f_light_melee_220", Translation="uiR2EDnpc_f_light_melee"},
					{Id="palette.entities.npcs.bandits.m_light_melee_220", Translation="uiR2EDnpc_m_light_melee"},
					{Id="palette.entities.npcs.bandits.t_light_melee_220", Translation="uiR2EDnpc_t_light_melee"},
					{Id="palette.entities.npcs.bandits.z_light_melee_220", Translation="uiR2EDnpc_z_light_melee"},


-- sadge					{Id="palette.entities.npcs.bandits.f_healer_20", Translation="uiR2EDnpc_f_healer"},
-- sadge					{Id="palette.entities.npcs.bandits.m_healer_20", Translation="uiR2EDnpc_m_healer"},
-- sadge					{Id="palette.entities.npcs.bandits.t_healer_20", Translation="uiR2EDnpc_t_healer"},
-- sadge					{Id="palette.entities.npcs.bandits.z_healer_20", Translation="uiR2EDnpc_z_healer"},
-- sadge
-- sadge					{Id="palette.entities.npcs.bandits.f_healer_70", Translation="uiR2EDnpc_f_healer"},
-- sadge					{Id="palette.entities.npcs.bandits.m_healer_70", Translation="uiR2EDnpc_m_healer"},
-- sadge					{Id="palette.entities.npcs.bandits.t_healer_70", Translation="uiR2EDnpc_t_healer"},
-- sadge					{Id="palette.entities.npcs.bandits.z_healer_70", Translation="uiR2EDnpc_z_healer"},
-- sadge
-- sadge					{Id="palette.entities.npcs.bandits.f_healer_120", Translation="uiR2EDnpc_f_healer"},
-- sadge					{Id="palette.entities.npcs.bandits.m_healer_120", Translation="uiR2EDnpc_m_healer"},
-- sadge					{Id="palette.entities.npcs.bandits.t_healer_120", Translation="uiR2EDnpc_t_healer"},
-- sadge					{Id="palette.entities.npcs.bandits.z_healer_120", Translation="uiR2EDnpc_z_healer"},
-- sadge
-- sadge					{Id="palette.entities.npcs.bandits.f_healer_170", Translation="uiR2EDnpc_f_healer"},
-- sadge					{Id="palette.entities.npcs.bandits.m_healer_170", Translation="uiR2EDnpc_m_healer"},
-- sadge					{Id="palette.entities.npcs.bandits.t_healer_170", Translation="uiR2EDnpc_t_healer"},
-- sadge					{Id="palette.entities.npcs.bandits.z_healer_170", Translation="uiR2EDnpc_z_healer"},
-- sadge
-- sadge					{Id="palette.entities.npcs.bandits.f_healer_220", Translation="uiR2EDnpc_f_healer"},
-- sadge					{Id="palette.entities.npcs.bandits.m_healer_220", Translation="uiR2EDnpc_m_healer"},
-- sadge					{Id="palette.entities.npcs.bandits.t_healer_220", Translation="uiR2EDnpc_t_healer"},
-- sadge					{Id="palette.entities.npcs.bandits.z_healer_220", Translation="uiR2EDnpc_z_healer"},


					{Id="palette.entities.npcs.bandits.f_mage_damage_dealer_20", Translation="uiR2EDnpc_f_mage_damage_dealer"},
					{Id="palette.entities.npcs.bandits.m_mage_damage_dealer_20", Translation="uiR2EDnpc_m_mage_damage_dealer"},
					{Id="palette.entities.npcs.bandits.t_mage_damage_dealer_20", Translation="uiR2EDnpc_t_mage_damage_dealer"},
					{Id="palette.entities.npcs.bandits.z_mage_damage_dealer_20", Translation="uiR2EDnpc_z_mage_damage_dealer"},

					{Id="palette.entities.npcs.bandits.f_mage_damage_dealer_70", Translation="uiR2EDnpc_f_mage_damage_dealer"},
					{Id="palette.entities.npcs.bandits.m_mage_damage_dealer_70", Translation="uiR2EDnpc_m_mage_damage_dealer"},
					{Id="palette.entities.npcs.bandits.t_mage_damage_dealer_70", Translation="uiR2EDnpc_t_mage_damage_dealer"},
					{Id="palette.entities.npcs.bandits.z_mage_damage_dealer_70", Translation="uiR2EDnpc_z_mage_damage_dealer"},

					{Id="palette.entities.npcs.bandits.f_mage_damage_dealer_120", Translation="uiR2EDnpc_f_mage_damage_dealer"},
					{Id="palette.entities.npcs.bandits.m_mage_damage_dealer_120", Translation="uiR2EDnpc_m_mage_damage_dealer"},
					{Id="palette.entities.npcs.bandits.t_mage_damage_dealer_120", Translation="uiR2EDnpc_t_mage_damage_dealer"},
					{Id="palette.entities.npcs.bandits.z_mage_damage_dealer_120", Translation="uiR2EDnpc_z_mage_damage_dealer"},

					{Id="palette.entities.npcs.bandits.f_mage_damage_dealer_170", Translation="uiR2EDnpc_f_mage_damage_dealer"},
					{Id="palette.entities.npcs.bandits.m_mage_damage_dealer_170", Translation="uiR2EDnpc_m_mage_damage_dealer"},
					{Id="palette.entities.npcs.bandits.t_mage_damage_dealer_170", Translation="uiR2EDnpc_t_mage_damage_dealer"},
					{Id="palette.entities.npcs.bandits.z_mage_damage_dealer_170", Translation="uiR2EDnpc_z_mage_damage_dealer"},

					{Id="palette.entities.npcs.bandits.f_mage_damage_dealer_220", Translation="uiR2EDnpc_f_mage_damage_dealer"},
					{Id="palette.entities.npcs.bandits.m_mage_damage_dealer_220", Translation="uiR2EDnpc_m_mage_damage_dealer"},
					{Id="palette.entities.npcs.bandits.t_mage_damage_dealer_220", Translation="uiR2EDnpc_t_mage_damage_dealer"},
					{Id="palette.entities.npcs.bandits.z_mage_damage_dealer_220", Translation="uiR2EDnpc_z_mage_damage_dealer"},


					{Id="palette.entities.npcs.bandits.f_mage_aoe_20", Translation="uiR2EDnpc_f_mage_aoe"},
					{Id="palette.entities.npcs.bandits.m_mage_aoe_20", Translation="uiR2EDnpc_m_mage_aoe"},
					{Id="palette.entities.npcs.bandits.t_mage_aoe_20", Translation="uiR2EDnpc_t_mage_aoe"},
					{Id="palette.entities.npcs.bandits.z_mage_aoe_20", Translation="uiR2EDnpc_z_mage_aoe"},

					{Id="palette.entities.npcs.bandits.f_mage_aoe_70", Translation="uiR2EDnpc_f_mage_aoe"},
					{Id="palette.entities.npcs.bandits.m_mage_aoe_70", Translation="uiR2EDnpc_m_mage_aoe"},
					{Id="palette.entities.npcs.bandits.t_mage_aoe_70", Translation="uiR2EDnpc_t_mage_aoe"},
					{Id="palette.entities.npcs.bandits.z_mage_aoe_70", Translation="uiR2EDnpc_z_mage_aoe"},

					{Id="palette.entities.npcs.bandits.f_mage_aoe_120", Translation="uiR2EDnpc_f_mage_aoe"},
					{Id="palette.entities.npcs.bandits.m_mage_aoe_120", Translation="uiR2EDnpc_m_mage_aoe"},
					{Id="palette.entities.npcs.bandits.t_mage_aoe_120", Translation="uiR2EDnpc_t_mage_aoe"},
					{Id="palette.entities.npcs.bandits.z_mage_aoe_120", Translation="uiR2EDnpc_z_mage_aoe"},

					{Id="palette.entities.npcs.bandits.f_mage_aoe_170", Translation="uiR2EDnpc_f_mage_aoe"},
					{Id="palette.entities.npcs.bandits.m_mage_aoe_170", Translation="uiR2EDnpc_m_mage_aoe"},
					{Id="palette.entities.npcs.bandits.t_mage_aoe_170", Translation="uiR2EDnpc_t_mage_aoe"},
					{Id="palette.entities.npcs.bandits.z_mage_aoe_170", Translation="uiR2EDnpc_z_mage_aoe"},

					{Id="palette.entities.npcs.bandits.f_mage_aoe_220", Translation="uiR2EDnpc_f_mage_aoe"},
					{Id="palette.entities.npcs.bandits.m_mage_aoe_220", Translation="uiR2EDnpc_m_mage_aoe"},
					{Id="palette.entities.npcs.bandits.t_mage_aoe_220", Translation="uiR2EDnpc_t_mage_aoe"},
					{Id="palette.entities.npcs.bandits.z_mage_aoe_220", Translation="uiR2EDnpc_z_mage_aoe"},


					{Id="palette.entities.npcs.bandits.f_mage_atysian_curser_20", Translation="uiR2EDnpc_f_mage_atysian_curser"},
					{Id="palette.entities.npcs.bandits.m_mage_atysian_curser_20", Translation="uiR2EDnpc_m_mage_atysian_curser"},
					{Id="palette.entities.npcs.bandits.t_mage_atysian_curser_20", Translation="uiR2EDnpc_t_mage_atysian_curser"},
					{Id="palette.entities.npcs.bandits.z_mage_atysian_curser_20", Translation="uiR2EDnpc_z_mage_atysian_curser"},

					{Id="palette.entities.npcs.bandits.f_mage_atysian_curser_70", Translation="uiR2EDnpc_f_mage_atysian_curser"},
					{Id="palette.entities.npcs.bandits.m_mage_atysian_curser_70", Translation="uiR2EDnpc_m_mage_atysian_curser"},
					{Id="palette.entities.npcs.bandits.t_mage_atysian_curser_70", Translation="uiR2EDnpc_t_mage_atysian_curser"},
					{Id="palette.entities.npcs.bandits.z_mage_atysian_curser_70", Translation="uiR2EDnpc_z_mage_atysian_curser"},

					{Id="palette.entities.npcs.bandits.f_mage_atysian_curser_120", Translation="uiR2EDnpc_f_mage_atysian_curser"},
					{Id="palette.entities.npcs.bandits.m_mage_atysian_curser_120", Translation="uiR2EDnpc_m_mage_atysian_curser"},
					{Id="palette.entities.npcs.bandits.t_mage_atysian_curser_120", Translation="uiR2EDnpc_t_mage_atysian_curser"},
					{Id="palette.entities.npcs.bandits.z_mage_atysian_curser_120", Translation="uiR2EDnpc_z_mage_atysian_curser"},

					{Id="palette.entities.npcs.bandits.f_mage_atysian_curser_170", Translation="uiR2EDnpc_f_mage_atysian_curser"},
					{Id="palette.entities.npcs.bandits.m_mage_atysian_curser_170", Translation="uiR2EDnpc_m_mage_atysian_curser"},
					{Id="palette.entities.npcs.bandits.t_mage_atysian_curser_170", Translation="uiR2EDnpc_t_mage_atysian_curser"},
					{Id="palette.entities.npcs.bandits.z_mage_atysian_curser_170", Translation="uiR2EDnpc_z_mage_atysian_curser"},

					{Id="palette.entities.npcs.bandits.f_mage_atysian_curser_220", Translation="uiR2EDnpc_f_mage_atysian_curser"},
					{Id="palette.entities.npcs.bandits.m_mage_atysian_curser_220", Translation="uiR2EDnpc_m_mage_atysian_curser"},
					{Id="palette.entities.npcs.bandits.t_mage_atysian_curser_220", Translation="uiR2EDnpc_t_mage_atysian_curser"},
					{Id="palette.entities.npcs.bandits.z_mage_atysian_curser_220", Translation="uiR2EDnpc_z_mage_atysian_curser"},


					{Id="palette.entities.npcs.bandits.f_mage_celestial_curser_20", Translation="uiR2EDnpc_f_mage_celestial_curser"},
					{Id="palette.entities.npcs.bandits.m_mage_celestial_curser_20", Translation="uiR2EDnpc_m_mage_celestial_curser"},
					{Id="palette.entities.npcs.bandits.t_mage_celestial_curser_20", Translation="uiR2EDnpc_t_mage_celestial_curser"},
					{Id="palette.entities.npcs.bandits.z_mage_celestial_curser_20", Translation="uiR2EDnpc_z_mage_celestial_curser"},

					{Id="palette.entities.npcs.bandits.f_mage_celestial_curser_70", Translation="uiR2EDnpc_f_mage_celestial_curser"},
					{Id="palette.entities.npcs.bandits.m_mage_celestial_curser_70", Translation="uiR2EDnpc_m_mage_celestial_curser"},
					{Id="palette.entities.npcs.bandits.t_mage_celestial_curser_70", Translation="uiR2EDnpc_t_mage_celestial_curser"},
					{Id="palette.entities.npcs.bandits.z_mage_celestial_curser_70", Translation="uiR2EDnpc_z_mage_celestial_curser"},

					{Id="palette.entities.npcs.bandits.f_mage_celestial_curser_120", Translation="uiR2EDnpc_f_mage_celestial_curser"},
					{Id="palette.entities.npcs.bandits.m_mage_celestial_curser_120", Translation="uiR2EDnpc_m_mage_celestial_curser"},
					{Id="palette.entities.npcs.bandits.t_mage_celestial_curser_120", Translation="uiR2EDnpc_t_mage_celestial_curser"},
					{Id="palette.entities.npcs.bandits.z_mage_celestial_curser_120", Translation="uiR2EDnpc_z_mage_celestial_curser"},

					{Id="palette.entities.npcs.bandits.f_mage_celestial_curser_170", Translation="uiR2EDnpc_f_mage_celestial_curser"},
					{Id="palette.entities.npcs.bandits.m_mage_celestial_curser_170", Translation="uiR2EDnpc_m_mage_celestial_curser"},
					{Id="palette.entities.npcs.bandits.t_mage_celestial_curser_170", Translation="uiR2EDnpc_t_mage_celestial_curser"},
					{Id="palette.entities.npcs.bandits.z_mage_celestial_curser_170", Translation="uiR2EDnpc_z_mage_celestial_curser"},

					{Id="palette.entities.npcs.bandits.f_mage_celestial_curser_220", Translation="uiR2EDnpc_f_mage_celestial_curser"},
					{Id="palette.entities.npcs.bandits.m_mage_celestial_curser_220", Translation="uiR2EDnpc_m_mage_celestial_curser"},
					{Id="palette.entities.npcs.bandits.t_mage_celestial_curser_220", Translation="uiR2EDnpc_t_mage_celestial_curser"},
					{Id="palette.entities.npcs.bandits.z_mage_celestial_curser_220", Translation="uiR2EDnpc_z_mage_celestial_curser"},

				},
--			
--				civillight =
--				{
--				    instances =
--				    {
--						{Id="palette.entities.npcs.bandits.ring_civil_light_melee_blunt_b1", Translation="uiR2EDnpc_ring_civil_light_melee_blunt_b1"},
--						{Id="palette.entities.npcs.bandits.ring_civil_light_melee_blunt_b2", Translation="uiR2EDnpc_ring_civil_light_melee_blunt_b2"},
--						{Id="palette.entities.npcs.bandits.ring_civil_light_melee_blunt_b3", Translation="uiR2EDnpc_ring_civil_light_melee_blunt_b3"},
--						{Id="palette.entities.npcs.bandits.ring_civil_light_melee_blunt_b4", Translation="uiR2EDnpc_ring_civil_light_melee_blunt_b4"},
--						{Id="palette.entities.npcs.bandits.ring_civil_light_melee_blunt_c1", Translation="uiR2EDnpc_ring_civil_light_melee_blunt_c1"},
--						{Id="palette.entities.npcs.bandits.ring_civil_light_melee_blunt_c2", Translation="uiR2EDnpc_ring_civil_light_melee_blunt_c2"},
--						{Id="palette.entities.npcs.bandits.ring_civil_light_melee_blunt_c3", Translation="uiR2EDnpc_ring_civil_light_melee_blunt_c3"},
--						{Id="palette.entities.npcs.bandits.ring_civil_light_melee_blunt_c4", Translation="uiR2EDnpc_ring_civil_light_melee_blunt_c4"},
--						{Id="palette.entities.npcs.bandits.ring_civil_light_melee_blunt_d1", Translation="uiR2EDnpc_ring_civil_light_melee_blunt_d1"},
--						{Id="palette.entities.npcs.bandits.ring_civil_light_melee_blunt_d2", Translation="uiR2EDnpc_ring_civil_light_melee_blunt_d2"},
--						{Id="palette.entities.npcs.bandits.ring_civil_light_melee_blunt_d3", Translation="uiR2EDnpc_ring_civil_light_melee_blunt_d3"},
--						{Id="palette.entities.npcs.bandits.ring_civil_light_melee_blunt_d4", Translation="uiR2EDnpc_ring_civil_light_melee_blunt_d4"},
--						{Id="palette.entities.npcs.bandits.ring_civil_light_melee_blunt_e1", Translation="uiR2EDnpc_ring_civil_light_melee_blunt_e1"},
--						{Id="palette.entities.npcs.bandits.ring_civil_light_melee_blunt_e2", Translation="uiR2EDnpc_ring_civil_light_melee_blunt_e2"},
--						{Id="palette.entities.npcs.bandits.ring_civil_light_melee_blunt_e3", Translation="uiR2EDnpc_ring_civil_light_melee_blunt_e3"},
--						{Id="palette.entities.npcs.bandits.ring_civil_light_melee_blunt_e4", Translation="uiR2EDnpc_ring_civil_light_melee_blunt_e4"},
--						{Id="palette.entities.npcs.bandits.ring_civil_light_melee_blunt_f1", Translation="uiR2EDnpc_ring_civil_light_melee_blunt_f1"},
--						{Id="palette.entities.npcs.bandits.ring_civil_light_melee_blunt_f2", Translation="uiR2EDnpc_ring_civil_light_melee_blunt_f2"},
--						{Id="palette.entities.npcs.bandits.ring_civil_light_melee_blunt_f3", Translation="uiR2EDnpc_ring_civil_light_melee_blunt_f3"},
--						{Id="palette.entities.npcs.bandits.ring_civil_light_melee_blunt_f4", Translation="uiR2EDnpc_ring_civil_light_melee_blunt_f4"},
--						{Id="palette.entities.npcs.bandits.ring_civil_light_melee_pierce_b1", Translation="uiR2EDnpc_ring_civil_light_melee_pierce_b1"},
--						{Id="palette.entities.npcs.bandits.ring_civil_light_melee_pierce_b2", Translation="uiR2EDnpc_ring_civil_light_melee_pierce_b2"},
--						{Id="palette.entities.npcs.bandits.ring_civil_light_melee_pierce_b3", Translation="uiR2EDnpc_ring_civil_light_melee_pierce_b3"},
--						{Id="palette.entities.npcs.bandits.ring_civil_light_melee_pierce_b4", Translation="uiR2EDnpc_ring_civil_light_melee_pierce_b4"},
--						{Id="palette.entities.npcs.bandits.ring_civil_light_melee_pierce_c1", Translation="uiR2EDnpc_ring_civil_light_melee_pierce_c1"},
--						{Id="palette.entities.npcs.bandits.ring_civil_light_melee_pierce_c2", Translation="uiR2EDnpc_ring_civil_light_melee_pierce_c2"},
--						{Id="palette.entities.npcs.bandits.ring_civil_light_melee_pierce_c3", Translation="uiR2EDnpc_ring_civil_light_melee_pierce_c3"},
--						{Id="palette.entities.npcs.bandits.ring_civil_light_melee_pierce_c4", Translation="uiR2EDnpc_ring_civil_light_melee_pierce_c4"},
--						{Id="palette.entities.npcs.bandits.ring_civil_light_melee_pierce_d1", Translation="uiR2EDnpc_ring_civil_light_melee_pierce_d1"},
--						{Id="palette.entities.npcs.bandits.ring_civil_light_melee_pierce_d2", Translation="uiR2EDnpc_ring_civil_light_melee_pierce_d2"},
--						{Id="palette.entities.npcs.bandits.ring_civil_light_melee_pierce_d3", Translation="uiR2EDnpc_ring_civil_light_melee_pierce_d3"},
--						{Id="palette.entities.npcs.bandits.ring_civil_light_melee_pierce_d4", Translation="uiR2EDnpc_ring_civil_light_melee_pierce_d4"},
--						{Id="palette.entities.npcs.bandits.ring_civil_light_melee_pierce_e1", Translation="uiR2EDnpc_ring_civil_light_melee_pierce_e1"},
--						{Id="palette.entities.npcs.bandits.ring_civil_light_melee_pierce_e2", Translation="uiR2EDnpc_ring_civil_light_melee_pierce_e2"},
--						{Id="palette.entities.npcs.bandits.ring_civil_light_melee_pierce_e3", Translation="uiR2EDnpc_ring_civil_light_melee_pierce_e3"},
--						{Id="palette.entities.npcs.bandits.ring_civil_light_melee_pierce_e4", Translation="uiR2EDnpc_ring_civil_light_melee_pierce_e4"},
--						{Id="palette.entities.npcs.bandits.ring_civil_light_melee_pierce_f1", Translation="uiR2EDnpc_ring_civil_light_melee_pierce_f1"},
--						{Id="palette.entities.npcs.bandits.ring_civil_light_melee_pierce_f2", Translation="uiR2EDnpc_ring_civil_light_melee_pierce_f2"},
--						{Id="palette.entities.npcs.bandits.ring_civil_light_melee_pierce_f3", Translation="uiR2EDnpc_ring_civil_light_melee_pierce_f3"},
--						{Id="palette.entities.npcs.bandits.ring_civil_light_melee_pierce_f4", Translation="uiR2EDnpc_ring_civil_light_melee_pierce_f4"},
--						{Id="palette.entities.npcs.bandits.ring_civil_light_melee_slash_b1", Translation="uiR2EDnpc_ring_civil_light_melee_slash_b1"},
--						{Id="palette.entities.npcs.bandits.ring_civil_light_melee_slash_b2", Translation="uiR2EDnpc_ring_civil_light_melee_slash_b2"},
--						{Id="palette.entities.npcs.bandits.ring_civil_light_melee_slash_b3", Translation="uiR2EDnpc_ring_civil_light_melee_slash_b3"},

--						{Id="palette.entities.npcs.bandits.ring_civil_light_melee_slash_b4", Translation="uiR2EDnpc_ring_civil_light_melee_slash_b4"},
--						{Id="palette.entities.npcs.bandits.ring_civil_light_melee_slash_c1", Translation="uiR2EDnpc_ring_civil_light_melee_slash_c1"},
--						{Id="palette.entities.npcs.bandits.ring_civil_light_melee_slash_c2", Translation="uiR2EDnpc_ring_civil_light_melee_slash_c2"},
--						{Id="palette.entities.npcs.bandits.ring_civil_light_melee_slash_c3", Translation="uiR2EDnpc_ring_civil_light_melee_slash_c3"},
--						{Id="palette.entities.npcs.bandits.ring_civil_light_melee_slash_c4", Translation="uiR2EDnpc_ring_civil_light_melee_slash_c4"},
--						{Id="palette.entities.npcs.bandits.ring_civil_light_melee_slash_d1", Translation="uiR2EDnpc_ring_civil_light_melee_slash_d1"},
--						{Id="palette.entities.npcs.bandits.ring_civil_light_melee_slash_d2", Translation="uiR2EDnpc_ring_civil_light_melee_slash_d2"},
--						{Id="palette.entities.npcs.bandits.ring_civil_light_melee_slash_d3", Translation="uiR2EDnpc_ring_civil_light_melee_slash_d3"},
--						{Id="palette.entities.npcs.bandits.ring_civil_light_melee_slash_d4", Translation="uiR2EDnpc_ring_civil_light_melee_slash_d4"},
--						{Id="palette.entities.npcs.bandits.ring_civil_light_melee_slash_e1", Translation="uiR2EDnpc_ring_civil_light_melee_slash_e1"},
--						{Id="palette.entities.npcs.bandits.ring_civil_light_melee_slash_e2", Translation="uiR2EDnpc_ring_civil_light_melee_slash_e2"},
--						{Id="palette.entities.npcs.bandits.ring_civil_light_melee_slash_e3", Translation="uiR2EDnpc_ring_civil_light_melee_slash_e3"},
--						{Id="palette.entities.npcs.bandits.ring_civil_light_melee_slash_e4", Translation="uiR2EDnpc_ring_civil_light_melee_slash_e4"},
--						{Id="palette.entities.npcs.bandits.ring_civil_light_melee_slash_f1", Translation="uiR2EDnpc_ring_civil_light_melee_slash_f1"},
--						{Id="palette.entities.npcs.bandits.ring_civil_light_melee_slash_f2", Translation="uiR2EDnpc_ring_civil_light_melee_slash_f2"},
--						{Id="palette.entities.npcs.bandits.ring_civil_light_melee_slash_f3", Translation="uiR2EDnpc_ring_civil_light_melee_slash_f3"},
--						{Id="palette.entities.npcs.bandits.ring_civil_light_melee_slash_f4", Translation="uiR2EDnpc_ring_civil_light_melee_slash_f4"}
--					}
--				},
--				
--				guard =
--				{
--				    guardmelee =
--				    {
--					    instances =
--					    {
--							{Id="palette.entities.npcs.bandits.ring_guard_melee_tank_blunt_b1", Translation="uiR2EDnpc_ring_guard_melee_tank_blunt_b1"},
--							{Id="palette.entities.npcs.bandits.ring_guard_melee_tank_blunt_b2", Translation="uiR2EDnpc_ring_guard_melee_tank_blunt_b2"},
--							{Id="palette.entities.npcs.bandits.ring_guard_melee_tank_blunt_b3", Translation="uiR2EDnpc_ring_guard_melee_tank_blunt_b3"},
--							{Id="palette.entities.npcs.bandits.ring_guard_melee_tank_blunt_b4", Translation="uiR2EDnpc_ring_guard_melee_tank_blunt_b4"},
--							{Id="palette.entities.npcs.bandits.ring_guard_melee_tank_blunt_c1", Translation="uiR2EDnpc_ring_guard_melee_tank_blunt_c1"},
--							{Id="palette.entities.npcs.bandits.ring_guard_melee_tank_blunt_c2", Translation="uiR2EDnpc_ring_guard_melee_tank_blunt_c2"},
--							{Id="palette.entities.npcs.bandits.ring_guard_melee_tank_blunt_c3", Translation="uiR2EDnpc_ring_guard_melee_tank_blunt_c3"},
--							{Id="palette.entities.npcs.bandits.ring_guard_melee_tank_blunt_c4", Translation="uiR2EDnpc_ring_guard_melee_tank_blunt_c4"},
--							{Id="palette.entities.npcs.bandits.ring_guard_melee_tank_blunt_d1", Translation="uiR2EDnpc_ring_guard_melee_tank_blunt_d1"},
--							{Id="palette.entities.npcs.bandits.ring_guard_melee_tank_blunt_d2", Translation="uiR2EDnpc_ring_guard_melee_tank_blunt_d2"},
--							{Id="palette.entities.npcs.bandits.ring_guard_melee_tank_blunt_d3", Translation="uiR2EDnpc_ring_guard_melee_tank_blunt_d3"},
--							{Id="palette.entities.npcs.bandits.ring_guard_melee_tank_blunt_d4", Translation="uiR2EDnpc_ring_guard_melee_tank_blunt_d4"},
--							{Id="palette.entities.npcs.bandits.ring_guard_melee_tank_blunt_e1", Translation="uiR2EDnpc_ring_guard_melee_tank_blunt_e1"},
--							{Id="palette.entities.npcs.bandits.ring_guard_melee_tank_blunt_e2", Translation="uiR2EDnpc_ring_guard_melee_tank_blunt_e2"},
--							{Id="palette.entities.npcs.bandits.ring_guard_melee_tank_blunt_e3", Translation="uiR2EDnpc_ring_guard_melee_tank_blunt_e3"},
--							{Id="palette.entities.npcs.bandits.ring_guard_melee_tank_blunt_e4", Translation="uiR2EDnpc_ring_guard_melee_tank_blunt_e4"},
--							{Id="palette.entities.npcs.bandits.ring_guard_melee_tank_blunt_f1", Translation="uiR2EDnpc_ring_guard_melee_tank_blunt_f1"},
--							{Id="palette.entities.npcs.bandits.ring_guard_melee_tank_blunt_f2", Translation="uiR2EDnpc_ring_guard_melee_tank_blunt_f2"},
--							{Id="palette.entities.npcs.bandits.ring_guard_melee_tank_blunt_f3", Translation="uiR2EDnpc_ring_guard_melee_tank_blunt_f3"},
--							{Id="palette.entities.npcs.bandits.ring_guard_melee_tank_blunt_f4", Translation="uiR2EDnpc_ring_guard_melee_tank_blunt_f4"},
--							{Id="palette.entities.npcs.bandits.ring_guard_melee_tank_pierce_b1", Translation="uiR2EDnpc_ring_guard_melee_tank_pierce_b1"},
--							{Id="palette.entities.npcs.bandits.ring_guard_melee_tank_pierce_b2", Translation="uiR2EDnpc_ring_guard_melee_tank_pierce_b2"},
--							{Id="palette.entities.npcs.bandits.ring_guard_melee_tank_pierce_b3", Translation="uiR2EDnpc_ring_guard_melee_tank_pierce_b3"},
--							{Id="palette.entities.npcs.bandits.ring_guard_melee_tank_pierce_b4", Translation="uiR2EDnpc_ring_guard_melee_tank_pierce_b4"},
--							{Id="palette.entities.npcs.bandits.ring_guard_melee_tank_pierce_c1", Translation="uiR2EDnpc_ring_guard_melee_tank_pierce_c1"},
--							{Id="palette.entities.npcs.bandits.ring_guard_melee_tank_pierce_c2", Translation="uiR2EDnpc_ring_guard_melee_tank_pierce_c2"},
--							{Id="palette.entities.npcs.bandits.ring_guard_melee_tank_pierce_c3", Translation="uiR2EDnpc_ring_guard_melee_tank_pierce_c3"},
--							{Id="palette.entities.npcs.bandits.ring_guard_melee_tank_pierce_c4", Translation="uiR2EDnpc_ring_guard_melee_tank_pierce_c4"},
--							{Id="palette.entities.npcs.bandits.ring_guard_melee_tank_pierce_d1", Translation="uiR2EDnpc_ring_guard_melee_tank_pierce_d1"},
--							{Id="palette.entities.npcs.bandits.ring_guard_melee_tank_pierce_d2", Translation="uiR2EDnpc_ring_guard_melee_tank_pierce_d2"},
--							{Id="palette.entities.npcs.bandits.ring_guard_melee_tank_pierce_d3", Translation="uiR2EDnpc_ring_guard_melee_tank_pierce_d3"},
--							{Id="palette.entities.npcs.bandits.ring_guard_melee_tank_pierce_d4", Translation="uiR2EDnpc_ring_guard_melee_tank_pierce_d4"},
--							{Id="palette.entities.npcs.bandits.ring_guard_melee_tank_pierce_e1", Translation="uiR2EDnpc_ring_guard_melee_tank_pierce_e1"},
--							{Id="palette.entities.npcs.bandits.ring_guard_melee_tank_pierce_e2", Translation="uiR2EDnpc_ring_guard_melee_tank_pierce_e2"},
--							{Id="palette.entities.npcs.bandits.ring_guard_melee_tank_pierce_e3", Translation="uiR2EDnpc_ring_guard_melee_tank_pierce_e3"},
--							{Id="palette.entities.npcs.bandits.ring_guard_melee_tank_pierce_e4", Translation="uiR2EDnpc_ring_guard_melee_tank_pierce_e4"},
--							{Id="palette.entities.npcs.bandits.ring_guard_melee_tank_pierce_f1", Translation="uiR2EDnpc_ring_guard_melee_tank_pierce_f1"},
--							{Id="palette.entities.npcs.bandits.ring_guard_melee_tank_pierce_f2", Translation="uiR2EDnpc_ring_guard_melee_tank_pierce_f2"},
--							{Id="palette.entities.npcs.bandits.ring_guard_melee_tank_pierce_f3", Translation="uiR2EDnpc_ring_guard_melee_tank_pierce_f3"},
--							{Id="palette.entities.npcs.bandits.ring_guard_melee_tank_pierce_f4", Translation="uiR2EDnpc_ring_guard_melee_tank_pierce_f4"},
--							{Id="palette.entities.npcs.bandits.ring_guard_melee_tank_slash_b1", Translation="uiR2EDnpc_ring_guard_melee_tank_slash_b1"},
--							{Id="palette.entities.npcs.bandits.ring_guard_melee_tank_slash_b2", Translation="uiR2EDnpc_ring_guard_melee_tank_slash_b2"},
--							{Id="palette.entities.npcs.bandits.ring_guard_melee_tank_slash_b3", Translation="uiR2EDnpc_ring_guard_melee_tank_slash_b3"},
--							{Id="palette.entities.npcs.bandits.ring_guard_melee_tank_slash_b4", Translation="uiR2EDnpc_ring_guard_melee_tank_slash_b4"},
--							{Id="palette.entities.npcs.bandits.ring_guard_melee_tank_slash_c1", Translation="uiR2EDnpc_ring_guard_melee_tank_slash_c1"},
--							{Id="palette.entities.npcs.bandits.ring_guard_melee_tank_slash_c2", Translation="uiR2EDnpc_ring_guard_melee_tank_slash_c2"},
--							{Id="palette.entities.npcs.bandits.ring_guard_melee_tank_slash_c3", Translation="uiR2EDnpc_ring_guard_melee_tank_slash_c3"},
--							{Id="palette.entities.npcs.bandits.ring_guard_melee_tank_slash_c4", Translation="uiR2EDnpc_ring_guard_melee_tank_slash_c4"},
--							{Id="palette.entities.npcs.bandits.ring_guard_melee_tank_slash_d1", Translation="uiR2EDnpc_ring_guard_melee_tank_slash_d1"},
--							{Id="palette.entities.npcs.bandits.ring_guard_melee_tank_slash_d2", Translation="uiR2EDnpc_ring_guard_melee_tank_slash_d2"},
--							{Id="palette.entities.npcs.bandits.ring_guard_melee_tank_slash_d3", Translation="uiR2EDnpc_ring_guard_melee_tank_slash_d3"},
--							{Id="palette.entities.npcs.bandits.ring_guard_melee_tank_slash_d4", Translation="uiR2EDnpc_ring_guard_melee_tank_slash_d4"},
--							{Id="palette.entities.npcs.bandits.ring_guard_melee_tank_slash_e1", Translation="uiR2EDnpc_ring_guard_melee_tank_slash_e1"},
--							{Id="palette.entities.npcs.bandits.ring_guard_melee_tank_slash_e2", Translation="uiR2EDnpc_ring_guard_melee_tank_slash_e2"},
--							{Id="palette.entities.npcs.bandits.ring_guard_melee_tank_slash_e3", Translation="uiR2EDnpc_ring_guard_melee_tank_slash_e3"},
--							{Id="palette.entities.npcs.bandits.ring_guard_melee_tank_slash_e4", Translation="uiR2EDnpc_ring_guard_melee_tank_slash_e4"},
--							{Id="palette.entities.npcs.bandits.ring_guard_melee_tank_slash_f1", Translation="uiR2EDnpc_ring_guard_melee_tank_slash_f1"},
--							{Id="palette.entities.npcs.bandits.ring_guard_melee_tank_slash_f2", Translation="uiR2EDnpc_ring_guard_melee_tank_slash_f2"},
--							{Id="palette.entities.npcs.bandits.ring_guard_melee_tank_slash_f3", Translation="uiR2EDnpc_ring_guard_melee_tank_slash_f3"},
--							{Id="palette.entities.npcs.bandits.ring_guard_melee_tank_slash_f4", Translation="uiR2EDnpc_ring_guard_melee_tank_slash_f4"}
--						}
--					},
--					guardranged =
--					{
--						instances =
--						{
--							{Id="palette.entities.npcs.bandits.ring_guard_ranged_tank_blunt_b1", Translation="uiR2EDnpc_ring_guard_ranged_tank_blunt_b1"},
--							{Id="palette.entities.npcs.bandits.ring_guard_ranged_tank_blunt_b2", Translation="uiR2EDnpc_ring_guard_ranged_tank_blunt_b2"},
--							{Id="palette.entities.npcs.bandits.ring_guard_ranged_tank_blunt_b3", Translation="uiR2EDnpc_ring_guard_ranged_tank_blunt_b3"},
--							{Id="palette.entities.npcs.bandits.ring_guard_ranged_tank_blunt_b4", Translation="uiR2EDnpc_ring_guard_ranged_tank_blunt_b4"},
--							{Id="palette.entities.npcs.bandits.ring_guard_ranged_tank_blunt_c1", Translation="uiR2EDnpc_ring_guard_ranged_tank_blunt_c1"},
--							{Id="palette.entities.npcs.bandits.ring_guard_ranged_tank_blunt_c2", Translation="uiR2EDnpc_ring_guard_ranged_tank_blunt_c2"},
--							{Id="palette.entities.npcs.bandits.ring_guard_ranged_tank_blunt_c3", Translation="uiR2EDnpc_ring_guard_ranged_tank_blunt_c3"},
--							{Id="palette.entities.npcs.bandits.ring_guard_ranged_tank_blunt_c4", Translation="uiR2EDnpc_ring_guard_ranged_tank_blunt_c4"},
--							{Id="palette.entities.npcs.bandits.ring_guard_ranged_tank_blunt_d1", Translation="uiR2EDnpc_ring_guard_ranged_tank_blunt_d1"},
--							{Id="palette.entities.npcs.bandits.ring_guard_ranged_tank_blunt_d2", Translation="uiR2EDnpc_ring_guard_ranged_tank_blunt_d2"},
--							{Id="palette.entities.npcs.bandits.ring_guard_ranged_tank_blunt_d3", Translation="uiR2EDnpc_ring_guard_ranged_tank_blunt_d3"},
--							{Id="palette.entities.npcs.bandits.ring_guard_ranged_tank_blunt_d4", Translation="uiR2EDnpc_ring_guard_ranged_tank_blunt_d4"},
--							{Id="palette.entities.npcs.bandits.ring_guard_ranged_tank_blunt_e1", Translation="uiR2EDnpc_ring_guard_ranged_tank_blunt_e1"},
--							{Id="palette.entities.npcs.bandits.ring_guard_ranged_tank_blunt_e2", Translation="uiR2EDnpc_ring_guard_ranged_tank_blunt_e2"},
--							{Id="palette.entities.npcs.bandits.ring_guard_ranged_tank_blunt_e3", Translation="uiR2EDnpc_ring_guard_ranged_tank_blunt_e3"},
--							{Id="palette.entities.npcs.bandits.ring_guard_ranged_tank_blunt_e4", Translation="uiR2EDnpc_ring_guard_ranged_tank_blunt_e4"},
--							{Id="palette.entities.npcs.bandits.ring_guard_ranged_tank_blunt_f1", Translation="uiR2EDnpc_ring_guard_ranged_tank_blunt_f1"},
--							{Id="palette.entities.npcs.bandits.ring_guard_ranged_tank_blunt_f2", Translation="uiR2EDnpc_ring_guard_ranged_tank_blunt_f2"},
--							{Id="palette.entities.npcs.bandits.ring_guard_ranged_tank_blunt_f3", Translation="uiR2EDnpc_ring_guard_ranged_tank_blunt_f3"},
--							{Id="palette.entities.npcs.bandits.ring_guard_ranged_tank_blunt_f4", Translation="uiR2EDnpc_ring_guard_ranged_tank_blunt_f4"},
--							{Id="palette.entities.npcs.bandits.ring_guard_ranged_tank_pierce_b1", Translation="uiR2EDnpc_ring_guard_ranged_tank_pierce_b1"},
--							{Id="palette.entities.npcs.bandits.ring_guard_ranged_tank_pierce_b2", Translation="uiR2EDnpc_ring_guard_ranged_tank_pierce_b2"},
--							{Id="palette.entities.npcs.bandits.ring_guard_ranged_tank_pierce_b3", Translation="uiR2EDnpc_ring_guard_ranged_tank_pierce_b3"},
--							{Id="palette.entities.npcs.bandits.ring_guard_ranged_tank_pierce_b4", Translation="uiR2EDnpc_ring_guard_ranged_tank_pierce_b4"},
--							{Id="palette.entities.npcs.bandits.ring_guard_ranged_tank_pierce_c1", Translation="uiR2EDnpc_ring_guard_ranged_tank_pierce_c1"},
--							{Id="palette.entities.npcs.bandits.ring_guard_ranged_tank_pierce_c2", Translation="uiR2EDnpc_ring_guard_ranged_tank_pierce_c2"},
--							{Id="palette.entities.npcs.bandits.ring_guard_ranged_tank_pierce_c3", Translation="uiR2EDnpc_ring_guard_ranged_tank_pierce_c3"},
--							{Id="palette.entities.npcs.bandits.ring_guard_ranged_tank_pierce_c4", Translation="uiR2EDnpc_ring_guard_ranged_tank_pierce_c4"},
--							{Id="palette.entities.npcs.bandits.ring_guard_ranged_tank_pierce_d1", Translation="uiR2EDnpc_ring_guard_ranged_tank_pierce_d1"},
--							{Id="palette.entities.npcs.bandits.ring_guard_ranged_tank_pierce_d2", Translation="uiR2EDnpc_ring_guard_ranged_tank_pierce_d2"},
--							{Id="palette.entities.npcs.bandits.ring_guard_ranged_tank_pierce_d3", Translation="uiR2EDnpc_ring_guard_ranged_tank_pierce_d3"},
--							{Id="palette.entities.npcs.bandits.ring_guard_ranged_tank_pierce_d4", Translation="uiR2EDnpc_ring_guard_ranged_tank_pierce_d4"},
--							{Id="palette.entities.npcs.bandits.ring_guard_ranged_tank_pierce_e1", Translation="uiR2EDnpc_ring_guard_ranged_tank_pierce_e1"},
--							{Id="palette.entities.npcs.bandits.ring_guard_ranged_tank_pierce_e2", Translation="uiR2EDnpc_ring_guard_ranged_tank_pierce_e2"},
--							{Id="palette.entities.npcs.bandits.ring_guard_ranged_tank_pierce_e3", Translation="uiR2EDnpc_ring_guard_ranged_tank_pierce_e3"},
--							{Id="palette.entities.npcs.bandits.ring_guard_ranged_tank_pierce_e4", Translation="uiR2EDnpc_ring_guard_ranged_tank_pierce_e4"},
--							{Id="palette.entities.npcs.bandits.ring_guard_ranged_tank_pierce_f1", Translation="uiR2EDnpc_ring_guard_ranged_tank_pierce_f1"},
--							{Id="palette.entities.npcs.bandits.ring_guard_ranged_tank_pierce_f2", Translation="uiR2EDnpc_ring_guard_ranged_tank_pierce_f2"},
--							{Id="palette.entities.npcs.bandits.ring_guard_ranged_tank_pierce_f3", Translation="uiR2EDnpc_ring_guard_ranged_tank_pierce_f3"},
--							{Id="palette.entities.npcs.bandits.ring_guard_ranged_tank_pierce_f4", Translation="uiR2EDnpc_ring_guard_ranged_tank_pierce_f4"},
--							{Id="palette.entities.npcs.bandits.ring_guard_ranged_tank_slash_b1", Translation="uiR2EDnpc_ring_guard_ranged_tank_slash_b1"},
--							{Id="palette.entities.npcs.bandits.ring_guard_ranged_tank_slash_b2", Translation="uiR2EDnpc_ring_guard_ranged_tank_slash_b2"},
--							{Id="palette.entities.npcs.bandits.ring_guard_ranged_tank_slash_b3", Translation="uiR2EDnpc_ring_guard_ranged_tank_slash_b3"},
--							{Id="palette.entities.npcs.bandits.ring_guard_ranged_tank_slash_b4", Translation="uiR2EDnpc_ring_guard_ranged_tank_slash_b4"},
--							{Id="palette.entities.npcs.bandits.ring_guard_ranged_tank_slash_c1", Translation="uiR2EDnpc_ring_guard_ranged_tank_slash_c1"},
--							{Id="palette.entities.npcs.bandits.ring_guard_ranged_tank_slash_c2", Translation="uiR2EDnpc_ring_guard_ranged_tank_slash_c2"},
--							{Id="palette.entities.npcs.bandits.ring_guard_ranged_tank_slash_c3", Translation="uiR2EDnpc_ring_guard_ranged_tank_slash_c3"},
--							{Id="palette.entities.npcs.bandits.ring_guard_ranged_tank_slash_c4", Translation="uiR2EDnpc_ring_guard_ranged_tank_slash_c4"},
--							{Id="palette.entities.npcs.bandits.ring_guard_ranged_tank_slash_d1", Translation="uiR2EDnpc_ring_guard_ranged_tank_slash_d1"},
--							{Id="palette.entities.npcs.bandits.ring_guard_ranged_tank_slash_d2", Translation="uiR2EDnpc_ring_guard_ranged_tank_slash_d2"},
--							{Id="palette.entities.npcs.bandits.ring_guard_ranged_tank_slash_d3", Translation="uiR2EDnpc_ring_guard_ranged_tank_slash_d3"},
--							{Id="palette.entities.npcs.bandits.ring_guard_ranged_tank_slash_d4", Translation="uiR2EDnpc_ring_guard_ranged_tank_slash_d4"},
--							{Id="palette.entities.npcs.bandits.ring_guard_ranged_tank_slash_e1", Translation="uiR2EDnpc_ring_guard_ranged_tank_slash_e1"},
--							{Id="palette.entities.npcs.bandits.ring_guard_ranged_tank_slash_e2", Translation="uiR2EDnpc_ring_guard_ranged_tank_slash_e2"},
--							{Id="palette.entities.npcs.bandits.ring_guard_ranged_tank_slash_e3", Translation="uiR2EDnpc_ring_guard_ranged_tank_slash_e3"},
--							{Id="palette.entities.npcs.bandits.ring_guard_ranged_tank_slash_e4", Translation="uiR2EDnpc_ring_guard_ranged_tank_slash_e4"},
--							{Id="palette.entities.npcs.bandits.ring_guard_ranged_tank_slash_f1", Translation="uiR2EDnpc_ring_guard_ranged_tank_slash_f1"},
--							{Id="palette.entities.npcs.bandits.ring_guard_ranged_tank_slash_f2", Translation="uiR2EDnpc_ring_guard_ranged_tank_slash_f2"},
--							{Id="palette.entities.npcs.bandits.ring_guard_ranged_tank_slash_f3", Translation="uiR2EDnpc_ring_guard_ranged_tank_slash_f3"},
--							{Id="palette.entities.npcs.bandits.ring_guard_ranged_tank_slash_f4", Translation="uiR2EDnpc_ring_guard_ranged_tank_slash_f4"}
--		  				}
--					}
--				},
--	
--				healer =
--				{
--				    instances =
--				    {
--						{Id="palette.entities.npcs.bandits.ring_healer_b1", Translation="uiR2EDnpc_ring_healer_b1"},
--						{Id="palette.entities.npcs.bandits.ring_healer_b2", Translation="uiR2EDnpc_ring_healer_b2"},
--						{Id="palette.entities.npcs.bandits.ring_healer_b3", Translation="uiR2EDnpc_ring_healer_b3"},
--						{Id="palette.entities.npcs.bandits.ring_healer_b4", Translation="uiR2EDnpc_ring_healer_b4"},
--						{Id="palette.entities.npcs.bandits.ring_healer_c1", Translation="uiR2EDnpc_ring_healer_c1"},
--						{Id="palette.entities.npcs.bandits.ring_healer_c2", Translation="uiR2EDnpc_ring_healer_c2"},
--						{Id="palette.entities.npcs.bandits.ring_healer_c3", Translation="uiR2EDnpc_ring_healer_c3"},
--						{Id="palette.entities.npcs.bandits.ring_healer_c4", Translation="uiR2EDnpc_ring_healer_c4"},
--						{Id="palette.entities.npcs.bandits.ring_healer_d1", Translation="uiR2EDnpc_ring_healer_d1"},
--						{Id="palette.entities.npcs.bandits.ring_healer_d2", Translation="uiR2EDnpc_ring_healer_d2"},
--						{Id="palette.entities.npcs.bandits.ring_healer_d3", Translation="uiR2EDnpc_ring_healer_d3"},
--						{Id="palette.entities.npcs.bandits.ring_healer_d4", Translation="uiR2EDnpc_ring_healer_d4"},
--						{Id="palette.entities.npcs.bandits.ring_healer_e1", Translation="uiR2EDnpc_ring_healer_e1"},
--						{Id="palette.entities.npcs.bandits.ring_healer_e2", Translation="uiR2EDnpc_ring_healer_e2"},
--						{Id="palette.entities.npcs.bandits.ring_healer_e3", Translation="uiR2EDnpc_ring_healer_e3"},
--						{Id="palette.entities.npcs.bandits.ring_healer_e4", Translation="uiR2EDnpc_ring_healer_e4"},
--						{Id="palette.entities.npcs.bandits.ring_healer_f1", Translation="uiR2EDnpc_ring_healer_f1"},
--						{Id="palette.entities.npcs.bandits.ring_healer_f2", Translation="uiR2EDnpc_ring_healer_f2"},
--						{Id="palette.entities.npcs.bandits.ring_healer_f3", Translation="uiR2EDnpc_ring_healer_f3"},
--						{Id="palette.entities.npcs.bandits.ring_healer_f4", Translation="uiR2EDnpc_ring_healer_f4"},
--						{Id="palette.entities.npcs.bandits.ring_healer_ot_b1", Translation="uiR2EDnpc_ring_healer_ot_b1"},
--						{Id="palette.entities.npcs.bandits.ring_healer_ot_b2", Translation="uiR2EDnpc_ring_healer_ot_b2"},
--						{Id="palette.entities.npcs.bandits.ring_healer_ot_b3", Translation="uiR2EDnpc_ring_healer_ot_b3"},
--						{Id="palette.entities.npcs.bandits.ring_healer_ot_b4", Translation="uiR2EDnpc_ring_healer_ot_b4"},
--						{Id="palette.entities.npcs.bandits.ring_healer_ot_c1", Translation="uiR2EDnpc_ring_healer_ot_c1"},
--						{Id="palette.entities.npcs.bandits.ring_healer_ot_c2", Translation="uiR2EDnpc_ring_healer_ot_c2"},
--						{Id="palette.entities.npcs.bandits.ring_healer_ot_c3", Translation="uiR2EDnpc_ring_healer_ot_c3"},
--						{Id="palette.entities.npcs.bandits.ring_healer_ot_c4", Translation="uiR2EDnpc_ring_healer_ot_c4"},
--						{Id="palette.entities.npcs.bandits.ring_healer_ot_d1", Translation="uiR2EDnpc_ring_healer_ot_d1"},
--						{Id="palette.entities.npcs.bandits.ring_healer_ot_d2", Translation="uiR2EDnpc_ring_healer_ot_d2"},
--						{Id="palette.entities.npcs.bandits.ring_healer_ot_d3", Translation="uiR2EDnpc_ring_healer_ot_d3"},
--						{Id="palette.entities.npcs.bandits.ring_healer_ot_d4", Translation="uiR2EDnpc_ring_healer_ot_d4"},
--						{Id="palette.entities.npcs.bandits.ring_healer_ot_e1", Translation="uiR2EDnpc_ring_healer_ot_e1"},
--						{Id="palette.entities.npcs.bandits.ring_healer_ot_e2", Translation="uiR2EDnpc_ring_healer_ot_e2"},
--						{Id="palette.entities.npcs.bandits.ring_healer_ot_e3", Translation="uiR2EDnpc_ring_healer_ot_e3"},
--						{Id="palette.entities.npcs.bandits.ring_healer_ot_e4", Translation="uiR2EDnpc_ring_healer_ot_e4"},
--						{Id="palette.entities.npcs.bandits.ring_healer_ot_f1", Translation="uiR2EDnpc_ring_healer_ot_f1"},
--						{Id="palette.entities.npcs.bandits.ring_healer_ot_f2", Translation="uiR2EDnpc_ring_healer_ot_f2"},
--						{Id="palette.entities.npcs.bandits.ring_healer_ot_f3", Translation="uiR2EDnpc_ring_healer_ot_f3"},
--						{Id="palette.entities.npcs.bandits.ring_healer_ot_f4", Translation="uiR2EDnpc_ring_healer_ot_f4"}
--					}
--				},
--	
--				lightmelee =
--				{
--				    instances =
--				    {
--						{Id="palette.entities.npcs.bandits.ring_light_melee_blunt_b1", Translation="uiR2EDnpc_ring_light_melee_blunt_b1"},
--						{Id="palette.entities.npcs.bandits.ring_light_melee_blunt_b2", Translation="uiR2EDnpc_ring_light_melee_blunt_b2"},
--						{Id="palette.entities.npcs.bandits.ring_light_melee_blunt_b3", Translation="uiR2EDnpc_ring_light_melee_blunt_b3"},
--						{Id="palette.entities.npcs.bandits.ring_light_melee_blunt_b4", Translation="uiR2EDnpc_ring_light_melee_blunt_b4"},
--						{Id="palette.entities.npcs.bandits.ring_light_melee_blunt_c1", Translation="uiR2EDnpc_ring_light_melee_blunt_c1"},
--						{Id="palette.entities.npcs.bandits.ring_light_melee_blunt_c2", Translation="uiR2EDnpc_ring_light_melee_blunt_c2"},
--						{Id="palette.entities.npcs.bandits.ring_light_melee_blunt_c3", Translation="uiR2EDnpc_ring_light_melee_blunt_c3"},
--						{Id="palette.entities.npcs.bandits.ring_light_melee_blunt_c4", Translation="uiR2EDnpc_ring_light_melee_blunt_c4"},
--						{Id="palette.entities.npcs.bandits.ring_light_melee_blunt_d1", Translation="uiR2EDnpc_ring_light_melee_blunt_d1"},
--						{Id="palette.entities.npcs.bandits.ring_light_melee_blunt_d2", Translation="uiR2EDnpc_ring_light_melee_blunt_d2"},
--						{Id="palette.entities.npcs.bandits.ring_light_melee_blunt_d3", Translation="uiR2EDnpc_ring_light_melee_blunt_d3"},
--						{Id="palette.entities.npcs.bandits.ring_light_melee_blunt_d4", Translation="uiR2EDnpc_ring_light_melee_blunt_d4"},
--						{Id="palette.entities.npcs.bandits.ring_light_melee_blunt_e1", Translation="uiR2EDnpc_ring_light_melee_blunt_e1"},
--						{Id="palette.entities.npcs.bandits.ring_light_melee_blunt_e2", Translation="uiR2EDnpc_ring_light_melee_blunt_e2"},
--						{Id="palette.entities.npcs.bandits.ring_light_melee_blunt_e3", Translation="uiR2EDnpc_ring_light_melee_blunt_e3"},
--						{Id="palette.entities.npcs.bandits.ring_light_melee_blunt_e4", Translation="uiR2EDnpc_ring_light_melee_blunt_e4"},
--						{Id="palette.entities.npcs.bandits.ring_light_melee_blunt_f1", Translation="uiR2EDnpc_ring_light_melee_blunt_f1"},
--						{Id="palette.entities.npcs.bandits.ring_light_melee_blunt_f2", Translation="uiR2EDnpc_ring_light_melee_blunt_f2"},
--						{Id="palette.entities.npcs.bandits.ring_light_melee_blunt_f3", Translation="uiR2EDnpc_ring_light_melee_blunt_f3"},
--						{Id="palette.entities.npcs.bandits.ring_light_melee_blunt_f4", Translation="uiR2EDnpc_ring_light_melee_blunt_f4"},
--						{Id="palette.entities.npcs.bandits.ring_light_melee_pierce_b1", Translation="uiR2EDnpc_ring_light_melee_pierce_b1"},
--						{Id="palette.entities.npcs.bandits.ring_light_melee_pierce_b2", Translation="uiR2EDnpc_ring_light_melee_pierce_b2"},
--						{Id="palette.entities.npcs.bandits.ring_light_melee_pierce_b3", Translation="uiR2EDnpc_ring_light_melee_pierce_b3"},
--						{Id="palette.entities.npcs.bandits.ring_light_melee_pierce_b4", Translation="uiR2EDnpc_ring_light_melee_pierce_b4"},
--						{Id="palette.entities.npcs.bandits.ring_light_melee_pierce_c1", Translation="uiR2EDnpc_ring_light_melee_pierce_c1"},
--						{Id="palette.entities.npcs.bandits.ring_light_melee_pierce_c2", Translation="uiR2EDnpc_ring_light_melee_pierce_c2"},
--						{Id="palette.entities.npcs.bandits.ring_light_melee_pierce_c3", Translation="uiR2EDnpc_ring_light_melee_pierce_c3"},
--						{Id="palette.entities.npcs.bandits.ring_light_melee_pierce_c4", Translation="uiR2EDnpc_ring_light_melee_pierce_c4"},
--						{Id="palette.entities.npcs.bandits.ring_light_melee_pierce_d1", Translation="uiR2EDnpc_ring_light_melee_pierce_d1"},
--						{Id="palette.entities.npcs.bandits.ring_light_melee_pierce_d2", Translation="uiR2EDnpc_ring_light_melee_pierce_d2"},
--						{Id="palette.entities.npcs.bandits.ring_light_melee_pierce_d3", Translation="uiR2EDnpc_ring_light_melee_pierce_d3"},
--						{Id="palette.entities.npcs.bandits.ring_light_melee_pierce_d4", Translation="uiR2EDnpc_ring_light_melee_pierce_d4"},
--						{Id="palette.entities.npcs.bandits.ring_light_melee_pierce_e1", Translation="uiR2EDnpc_ring_light_melee_pierce_e1"},
--						{Id="palette.entities.npcs.bandits.ring_light_melee_pierce_e2", Translation="uiR2EDnpc_ring_light_melee_pierce_e2"},
--						{Id="palette.entities.npcs.bandits.ring_light_melee_pierce_e3", Translation="uiR2EDnpc_ring_light_melee_pierce_e3"},
--						{Id="palette.entities.npcs.bandits.ring_light_melee_pierce_e4", Translation="uiR2EDnpc_ring_light_melee_pierce_e4"},
--						{Id="palette.entities.npcs.bandits.ring_light_melee_pierce_f1", Translation="uiR2EDnpc_ring_light_melee_pierce_f1"},
--						{Id="palette.entities.npcs.bandits.ring_light_melee_pierce_f2", Translation="uiR2EDnpc_ring_light_melee_pierce_f2"},
--						{Id="palette.entities.npcs.bandits.ring_light_melee_pierce_f3", Translation="uiR2EDnpc_ring_light_melee_pierce_f3"},
--						{Id="palette.entities.npcs.bandits.ring_light_melee_pierce_f4", Translation="uiR2EDnpc_ring_light_melee_pierce_f4"},
--						{Id="palette.entities.npcs.bandits.ring_light_melee_slash_b1", Translation="uiR2EDnpc_ring_light_melee_slash_b1"},
--						{Id="palette.entities.npcs.bandits.ring_light_melee_slash_b2", Translation="uiR2EDnpc_ring_light_melee_slash_b2"},
--						{Id="palette.entities.npcs.bandits.ring_light_melee_slash_b3", Translation="uiR2EDnpc_ring_light_melee_slash_b3"},
--						{Id="palette.entities.npcs.bandits.ring_light_melee_slash_b4", Translation="uiR2EDnpc_ring_light_melee_slash_b4"},
--						{Id="palette.entities.npcs.bandits.ring_light_melee_slash_c1", Translation="uiR2EDnpc_ring_light_melee_slash_c1"},
--						{Id="palette.entities.npcs.bandits.ring_light_melee_slash_c2", Translation="uiR2EDnpc_ring_light_melee_slash_c2"},
--						{Id="palette.entities.npcs.bandits.ring_light_melee_slash_c3", Translation="uiR2EDnpc_ring_light_melee_slash_c3"},
--						{Id="palette.entities.npcs.bandits.ring_light_melee_slash_c4", Translation="uiR2EDnpc_ring_light_melee_slash_c4"},
--						{Id="palette.entities.npcs.bandits.ring_light_melee_slash_d1", Translation="uiR2EDnpc_ring_light_melee_slash_d1"},
--						{Id="palette.entities.npcs.bandits.ring_light_melee_slash_d2", Translation="uiR2EDnpc_ring_light_melee_slash_d2"},
--						{Id="palette.entities.npcs.bandits.ring_light_melee_slash_d3", Translation="uiR2EDnpc_ring_light_melee_slash_d3"},
--						{Id="palette.entities.npcs.bandits.ring_light_melee_slash_d4", Translation="uiR2EDnpc_ring_light_melee_slash_d4"},
--						{Id="palette.entities.npcs.bandits.ring_light_melee_slash_e1", Translation="uiR2EDnpc_ring_light_melee_slash_e1"},
--						{Id="palette.entities.npcs.bandits.ring_light_melee_slash_e2", Translation="uiR2EDnpc_ring_light_melee_slash_e2"},
--						{Id="palette.entities.npcs.bandits.ring_light_melee_slash_e3", Translation="uiR2EDnpc_ring_light_melee_slash_e3"},
--						{Id="palette.entities.npcs.bandits.ring_light_melee_slash_e4", Translation="uiR2EDnpc_ring_light_melee_slash_e4"},
--						{Id="palette.entities.npcs.bandits.ring_light_melee_slash_f1", Translation="uiR2EDnpc_ring_light_melee_slash_f1"},
--						{Id="palette.entities.npcs.bandits.ring_light_melee_slash_f2", Translation="uiR2EDnpc_ring_light_melee_slash_f2"},
--						{Id="palette.entities.npcs.bandits.ring_light_melee_slash_f3", Translation="uiR2EDnpc_ring_light_melee_slash_f3"},
--						{Id="palette.entities.npcs.bandits.ring_light_melee_slash_f4", Translation="uiR2EDnpc_ring_light_melee_slash_f4"}
--					}
--				},
--	
--				lightranged =
--				{
--				    instances =
--				    {
--						{Id="palette.entities.npcs.bandits.ring_light_ranged_blunt_b1", Translation="uiR2EDnpc_ring_light_ranged_blunt_b1"},
--						{Id="palette.entities.npcs.bandits.ring_light_ranged_blunt_b2", Translation="uiR2EDnpc_ring_light_ranged_blunt_b2"},
--						{Id="palette.entities.npcs.bandits.ring_light_ranged_blunt_b3", Translation="uiR2EDnpc_ring_light_ranged_blunt_b3"},
--						{Id="palette.entities.npcs.bandits.ring_light_ranged_blunt_b4", Translation="uiR2EDnpc_ring_light_ranged_blunt_b4"},
--						{Id="palette.entities.npcs.bandits.ring_light_ranged_blunt_c1", Translation="uiR2EDnpc_ring_light_ranged_blunt_c1"},
--						{Id="palette.entities.npcs.bandits.ring_light_ranged_blunt_c2", Translation="uiR2EDnpc_ring_light_ranged_blunt_c2"},
--						{Id="palette.entities.npcs.bandits.ring_light_ranged_blunt_c3", Translation="uiR2EDnpc_ring_light_ranged_blunt_c3"},
--						{Id="palette.entities.npcs.bandits.ring_light_ranged_blunt_c4", Translation="uiR2EDnpc_ring_light_ranged_blunt_c4"},
--						{Id="palette.entities.npcs.bandits.ring_light_ranged_blunt_d1", Translation="uiR2EDnpc_ring_light_ranged_blunt_d1"},
--						{Id="palette.entities.npcs.bandits.ring_light_ranged_blunt_d2", Translation="uiR2EDnpc_ring_light_ranged_blunt_d2"},
--						{Id="palette.entities.npcs.bandits.ring_light_ranged_blunt_d3", Translation="uiR2EDnpc_ring_light_ranged_blunt_d3"},
--						{Id="palette.entities.npcs.bandits.ring_light_ranged_blunt_d4", Translation="uiR2EDnpc_ring_light_ranged_blunt_d4"},
--						{Id="palette.entities.npcs.bandits.ring_light_ranged_blunt_e1", Translation="uiR2EDnpc_ring_light_ranged_blunt_e1"},
--						{Id="palette.entities.npcs.bandits.ring_light_ranged_blunt_e2", Translation="uiR2EDnpc_ring_light_ranged_blunt_e2"},
--						{Id="palette.entities.npcs.bandits.ring_light_ranged_blunt_e3", Translation="uiR2EDnpc_ring_light_ranged_blunt_e3"},
--						{Id="palette.entities.npcs.bandits.ring_light_ranged_blunt_e4", Translation="uiR2EDnpc_ring_light_ranged_blunt_e4"},
--						{Id="palette.entities.npcs.bandits.ring_light_ranged_blunt_f1", Translation="uiR2EDnpc_ring_light_ranged_blunt_f1"},
--						{Id="palette.entities.npcs.bandits.ring_light_ranged_blunt_f2", Translation="uiR2EDnpc_ring_light_ranged_blunt_f2"},
--						{Id="palette.entities.npcs.bandits.ring_light_ranged_blunt_f3", Translation="uiR2EDnpc_ring_light_ranged_blunt_f3"},
--						{Id="palette.entities.npcs.bandits.ring_light_ranged_blunt_f4", Translation="uiR2EDnpc_ring_light_ranged_blunt_f4"},
--						{Id="palette.entities.npcs.bandits.ring_light_ranged_pierce_b1", Translation="uiR2EDnpc_ring_light_ranged_pierce_b1"},
--						{Id="palette.entities.npcs.bandits.ring_light_ranged_pierce_b2", Translation="uiR2EDnpc_ring_light_ranged_pierce_b2"},
--						{Id="palette.entities.npcs.bandits.ring_light_ranged_pierce_b3", Translation="uiR2EDnpc_ring_light_ranged_pierce_b3"},
--						{Id="palette.entities.npcs.bandits.ring_light_ranged_pierce_b4", Translation="uiR2EDnpc_ring_light_ranged_pierce_b4"},
--						{Id="palette.entities.npcs.bandits.ring_light_ranged_pierce_c1", Translation="uiR2EDnpc_ring_light_ranged_pierce_c1"},
--						{Id="palette.entities.npcs.bandits.ring_light_ranged_pierce_c2", Translation="uiR2EDnpc_ring_light_ranged_pierce_c2"},
--						{Id="palette.entities.npcs.bandits.ring_light_ranged_pierce_c3", Translation="uiR2EDnpc_ring_light_ranged_pierce_c3"},
--						{Id="palette.entities.npcs.bandits.ring_light_ranged_pierce_c4", Translation="uiR2EDnpc_ring_light_ranged_pierce_c4"},
--						{Id="palette.entities.npcs.bandits.ring_light_ranged_pierce_d1", Translation="uiR2EDnpc_ring_light_ranged_pierce_d1"},
--						{Id="palette.entities.npcs.bandits.ring_light_ranged_pierce_d2", Translation="uiR2EDnpc_ring_light_ranged_pierce_d2"},
--						{Id="palette.entities.npcs.bandits.ring_light_ranged_pierce_d3", Translation="uiR2EDnpc_ring_light_ranged_pierce_d3"},
--						{Id="palette.entities.npcs.bandits.ring_light_ranged_pierce_d4", Translation="uiR2EDnpc_ring_light_ranged_pierce_d4"},
--						{Id="palette.entities.npcs.bandits.ring_light_ranged_pierce_e1", Translation="uiR2EDnpc_ring_light_ranged_pierce_e1"},
--						{Id="palette.entities.npcs.bandits.ring_light_ranged_pierce_e2", Translation="uiR2EDnpc_ring_light_ranged_pierce_e2"},
--						{Id="palette.entities.npcs.bandits.ring_light_ranged_pierce_e3", Translation="uiR2EDnpc_ring_light_ranged_pierce_e3"},
--						{Id="palette.entities.npcs.bandits.ring_light_ranged_pierce_e4", Translation="uiR2EDnpc_ring_light_ranged_pierce_e4"},
--						{Id="palette.entities.npcs.bandits.ring_light_ranged_pierce_f1", Translation="uiR2EDnpc_ring_light_ranged_pierce_f1"},
--						{Id="palette.entities.npcs.bandits.ring_light_ranged_pierce_f2", Translation="uiR2EDnpc_ring_light_ranged_pierce_f2"},
--						{Id="palette.entities.npcs.bandits.ring_light_ranged_pierce_f3", Translation="uiR2EDnpc_ring_light_ranged_pierce_f3"},
--						{Id="palette.entities.npcs.bandits.ring_light_ranged_pierce_f4", Translation="uiR2EDnpc_ring_light_ranged_pierce_f4"},
--						{Id="palette.entities.npcs.bandits.ring_light_ranged_slash_b1", Translation="uiR2EDnpc_ring_light_ranged_slash_b1"},
--						{Id="palette.entities.npcs.bandits.ring_light_ranged_slash_b2", Translation="uiR2EDnpc_ring_light_ranged_slash_b2"},
--						{Id="palette.entities.npcs.bandits.ring_light_ranged_slash_b3", Translation="uiR2EDnpc_ring_light_ranged_slash_b3"},
--						{Id="palette.entities.npcs.bandits.ring_light_ranged_slash_b4", Translation="uiR2EDnpc_ring_light_ranged_slash_b4"},
--						{Id="palette.entities.npcs.bandits.ring_light_ranged_slash_c1", Translation="uiR2EDnpc_ring_light_ranged_slash_c1"},
--						{Id="palette.entities.npcs.bandits.ring_light_ranged_slash_c2", Translation="uiR2EDnpc_ring_light_ranged_slash_c2"},
--						{Id="palette.entities.npcs.bandits.ring_light_ranged_slash_c3", Translation="uiR2EDnpc_ring_light_ranged_slash_c3"},
--						{Id="palette.entities.npcs.bandits.ring_light_ranged_slash_c4", Translation="uiR2EDnpc_ring_light_ranged_slash_c4"},
--						{Id="palette.entities.npcs.bandits.ring_light_ranged_slash_d1", Translation="uiR2EDnpc_ring_light_ranged_slash_d1"},
--						{Id="palette.entities.npcs.bandits.ring_light_ranged_slash_d2", Translation="uiR2EDnpc_ring_light_ranged_slash_d2"},
--						{Id="palette.entities.npcs.bandits.ring_light_ranged_slash_d3", Translation="uiR2EDnpc_ring_light_ranged_slash_d3"},
--						{Id="palette.entities.npcs.bandits.ring_light_ranged_slash_d4", Translation="uiR2EDnpc_ring_light_ranged_slash_d4"},
--						{Id="palette.entities.npcs.bandits.ring_light_ranged_slash_e1", Translation="uiR2EDnpc_ring_light_ranged_slash_e1"},
--						{Id="palette.entities.npcs.bandits.ring_light_ranged_slash_e2", Translation="uiR2EDnpc_ring_light_ranged_slash_e2"},
--						{Id="palette.entities.npcs.bandits.ring_light_ranged_slash_e3", Translation="uiR2EDnpc_ring_light_ranged_slash_e3"},
--						{Id="palette.entities.npcs.bandits.ring_light_ranged_slash_e4", Translation="uiR2EDnpc_ring_light_ranged_slash_e4"},
--						{Id="palette.entities.npcs.bandits.ring_light_ranged_slash_f1", Translation="uiR2EDnpc_ring_light_ranged_slash_f1"},
--						{Id="palette.entities.npcs.bandits.ring_light_ranged_slash_f2", Translation="uiR2EDnpc_ring_light_ranged_slash_f2"},
--						{Id="palette.entities.npcs.bandits.ring_light_ranged_slash_f3", Translation="uiR2EDnpc_ring_light_ranged_slash_f3"},
--						{Id="palette.entities.npcs.bandits.ring_light_ranged_slash_f4", Translation="uiR2EDnpc_ring_light_ranged_slash_f4"}
--					}
--				},
--	
--				magicaoe =
--				{
--				    magicaoebasic =
--				    {
--					    instances =
--					    {
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_acid_b1", Translation="uiR2EDnpc_ring_magic_aoe_acid_b1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_acid_b2", Translation="uiR2EDnpc_ring_magic_aoe_acid_b2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_acid_b3", Translation="uiR2EDnpc_ring_magic_aoe_acid_b3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_acid_b4", Translation="uiR2EDnpc_ring_magic_aoe_acid_b4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_acid_c1", Translation="uiR2EDnpc_ring_magic_aoe_acid_c1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_acid_c2", Translation="uiR2EDnpc_ring_magic_aoe_acid_c2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_acid_c3", Translation="uiR2EDnpc_ring_magic_aoe_acid_c3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_acid_c4", Translation="uiR2EDnpc_ring_magic_aoe_acid_c4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_acid_d1", Translation="uiR2EDnpc_ring_magic_aoe_acid_d1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_acid_d2", Translation="uiR2EDnpc_ring_magic_aoe_acid_d2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_acid_d3", Translation="uiR2EDnpc_ring_magic_aoe_acid_d3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_acid_d4", Translation="uiR2EDnpc_ring_magic_aoe_acid_d4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_acid_e1", Translation="uiR2EDnpc_ring_magic_aoe_acid_e1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_acid_e2", Translation="uiR2EDnpc_ring_magic_aoe_acid_e2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_acid_e3", Translation="uiR2EDnpc_ring_magic_aoe_acid_e3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_acid_e4", Translation="uiR2EDnpc_ring_magic_aoe_acid_e4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_acid_f1", Translation="uiR2EDnpc_ring_magic_aoe_acid_f1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_acid_f2", Translation="uiR2EDnpc_ring_magic_aoe_acid_f2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_acid_f3", Translation="uiR2EDnpc_ring_magic_aoe_acid_f3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_acid_f4", Translation="uiR2EDnpc_ring_magic_aoe_acid_f4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_cold_b1", Translation="uiR2EDnpc_ring_magic_aoe_cold_b1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_cold_b2", Translation="uiR2EDnpc_ring_magic_aoe_cold_b2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_cold_b3", Translation="uiR2EDnpc_ring_magic_aoe_cold_b3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_cold_b4", Translation="uiR2EDnpc_ring_magic_aoe_cold_b4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_cold_c1", Translation="uiR2EDnpc_ring_magic_aoe_cold_c1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_cold_c2", Translation="uiR2EDnpc_ring_magic_aoe_cold_c2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_cold_c3", Translation="uiR2EDnpc_ring_magic_aoe_cold_c3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_cold_c4", Translation="uiR2EDnpc_ring_magic_aoe_cold_c4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_cold_d1", Translation="uiR2EDnpc_ring_magic_aoe_cold_d1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_cold_d2", Translation="uiR2EDnpc_ring_magic_aoe_cold_d2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_cold_d3", Translation="uiR2EDnpc_ring_magic_aoe_cold_d3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_cold_d4", Translation="uiR2EDnpc_ring_magic_aoe_cold_d4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_cold_e1", Translation="uiR2EDnpc_ring_magic_aoe_cold_e1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_cold_e2", Translation="uiR2EDnpc_ring_magic_aoe_cold_e2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_cold_e3", Translation="uiR2EDnpc_ring_magic_aoe_cold_e3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_cold_e4", Translation="uiR2EDnpc_ring_magic_aoe_cold_e4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_cold_f1", Translation="uiR2EDnpc_ring_magic_aoe_cold_f1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_cold_f2", Translation="uiR2EDnpc_ring_magic_aoe_cold_f2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_cold_f3", Translation="uiR2EDnpc_ring_magic_aoe_cold_f3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_cold_f4", Translation="uiR2EDnpc_ring_magic_aoe_cold_f4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_rot_b1", Translation="uiR2EDnpc_ring_magic_aoe_rot_b1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_rot_b2", Translation="uiR2EDnpc_ring_magic_aoe_rot_b2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_rot_b3", Translation="uiR2EDnpc_ring_magic_aoe_rot_b3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_rot_b4", Translation="uiR2EDnpc_ring_magic_aoe_rot_b4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_rot_c1", Translation="uiR2EDnpc_ring_magic_aoe_rot_c1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_rot_c2", Translation="uiR2EDnpc_ring_magic_aoe_rot_c2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_rot_c3", Translation="uiR2EDnpc_ring_magic_aoe_rot_c3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_rot_c4", Translation="uiR2EDnpc_ring_magic_aoe_rot_c4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_rot_d1", Translation="uiR2EDnpc_ring_magic_aoe_rot_d1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_rot_d2", Translation="uiR2EDnpc_ring_magic_aoe_rot_d2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_rot_d3", Translation="uiR2EDnpc_ring_magic_aoe_rot_d3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_rot_d4", Translation="uiR2EDnpc_ring_magic_aoe_rot_d4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_rot_e1", Translation="uiR2EDnpc_ring_magic_aoe_rot_e1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_rot_e2", Translation="uiR2EDnpc_ring_magic_aoe_rot_e2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_rot_e3", Translation="uiR2EDnpc_ring_magic_aoe_rot_e3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_rot_e4", Translation="uiR2EDnpc_ring_magic_aoe_rot_e4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_rot_f1", Translation="uiR2EDnpc_ring_magic_aoe_rot_f1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_rot_f2", Translation="uiR2EDnpc_ring_magic_aoe_rot_f2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_rot_f3", Translation="uiR2EDnpc_ring_magic_aoe_rot_f3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_rot_f4", Translation="uiR2EDnpc_ring_magic_aoe_rot_f4"}
--						}
--					},
--	   				magicaoeracial =
--					{
--					    instances =
--					    {
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_electricity_b1", Translation="uiR2EDnpc_ring_magic_aoe_electricity_b1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_electricity_b2", Translation="uiR2EDnpc_ring_magic_aoe_electricity_b2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_electricity_b3", Translation="uiR2EDnpc_ring_magic_aoe_electricity_b3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_electricity_b4", Translation="uiR2EDnpc_ring_magic_aoe_electricity_b4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_electricity_c1", Translation="uiR2EDnpc_ring_magic_aoe_electricity_c1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_electricity_c2", Translation="uiR2EDnpc_ring_magic_aoe_electricity_c2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_electricity_c3", Translation="uiR2EDnpc_ring_magic_aoe_electricity_c3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_electricity_c4", Translation="uiR2EDnpc_ring_magic_aoe_electricity_c4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_electricity_d1", Translation="uiR2EDnpc_ring_magic_aoe_electricity_d1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_electricity_d2", Translation="uiR2EDnpc_ring_magic_aoe_electricity_d2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_electricity_d3", Translation="uiR2EDnpc_ring_magic_aoe_electricity_d3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_electricity_d4", Translation="uiR2EDnpc_ring_magic_aoe_electricity_d4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_electricity_e1", Translation="uiR2EDnpc_ring_magic_aoe_electricity_e1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_electricity_e2", Translation="uiR2EDnpc_ring_magic_aoe_electricity_e2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_electricity_e3", Translation="uiR2EDnpc_ring_magic_aoe_electricity_e3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_electricity_e4", Translation="uiR2EDnpc_ring_magic_aoe_electricity_e4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_electricity_f1", Translation="uiR2EDnpc_ring_magic_aoe_electricity_f1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_electricity_f2", Translation="uiR2EDnpc_ring_magic_aoe_electricity_f2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_electricity_f3", Translation="uiR2EDnpc_ring_magic_aoe_electricity_f3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_electricity_f4", Translation="uiR2EDnpc_ring_magic_aoe_electricity_f4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_fire_b1", Translation="uiR2EDnpc_ring_magic_aoe_fire_b1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_fire_b2", Translation="uiR2EDnpc_ring_magic_aoe_fire_b2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_fire_b3", Translation="uiR2EDnpc_ring_magic_aoe_fire_b3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_fire_b4", Translation="uiR2EDnpc_ring_magic_aoe_fire_b4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_fire_c1", Translation="uiR2EDnpc_ring_magic_aoe_fire_c1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_fire_c2", Translation="uiR2EDnpc_ring_magic_aoe_fire_c2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_fire_c3", Translation="uiR2EDnpc_ring_magic_aoe_fire_c3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_fire_c4", Translation="uiR2EDnpc_ring_magic_aoe_fire_c4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_fire_d1", Translation="uiR2EDnpc_ring_magic_aoe_fire_d1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_fire_d2", Translation="uiR2EDnpc_ring_magic_aoe_fire_d2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_fire_d3", Translation="uiR2EDnpc_ring_magic_aoe_fire_d3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_fire_d4", Translation="uiR2EDnpc_ring_magic_aoe_fire_d4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_fire_e1", Translation="uiR2EDnpc_ring_magic_aoe_fire_e1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_fire_e2", Translation="uiR2EDnpc_ring_magic_aoe_fire_e2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_fire_e3", Translation="uiR2EDnpc_ring_magic_aoe_fire_e3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_fire_e4", Translation="uiR2EDnpc_ring_magic_aoe_fire_e4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_fire_f1", Translation="uiR2EDnpc_ring_magic_aoe_fire_f1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_fire_f2", Translation="uiR2EDnpc_ring_magic_aoe_fire_f2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_fire_f3", Translation="uiR2EDnpc_ring_magic_aoe_fire_f3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_fire_f4", Translation="uiR2EDnpc_ring_magic_aoe_fire_f4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_poison_b1", Translation="uiR2EDnpc_ring_magic_aoe_poison_b1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_poison_b2", Translation="uiR2EDnpc_ring_magic_aoe_poison_b2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_poison_b3", Translation="uiR2EDnpc_ring_magic_aoe_poison_b3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_poison_b4", Translation="uiR2EDnpc_ring_magic_aoe_poison_b4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_poison_c1", Translation="uiR2EDnpc_ring_magic_aoe_poison_c1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_poison_c2", Translation="uiR2EDnpc_ring_magic_aoe_poison_c2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_poison_c3", Translation="uiR2EDnpc_ring_magic_aoe_poison_c3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_poison_c4", Translation="uiR2EDnpc_ring_magic_aoe_poison_c4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_poison_d1", Translation="uiR2EDnpc_ring_magic_aoe_poison_d1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_poison_d2", Translation="uiR2EDnpc_ring_magic_aoe_poison_d2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_poison_d3", Translation="uiR2EDnpc_ring_magic_aoe_poison_d3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_poison_d4", Translation="uiR2EDnpc_ring_magic_aoe_poison_d4"},
--	
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_poison_e1", Translation="uiR2EDnpc_ring_magic_aoe_poison_e1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_poison_e2", Translation="uiR2EDnpc_ring_magic_aoe_poison_e2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_poison_e3", Translation="uiR2EDnpc_ring_magic_aoe_poison_e3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_poison_e4", Translation="uiR2EDnpc_ring_magic_aoe_poison_e4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_poison_f1", Translation="uiR2EDnpc_ring_magic_aoe_poison_f1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_poison_f2", Translation="uiR2EDnpc_ring_magic_aoe_poison_f2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_poison_f3", Translation="uiR2EDnpc_ring_magic_aoe_poison_f3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_poison_f4", Translation="uiR2EDnpc_ring_magic_aoe_poison_f4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_shockwave_b1", Translation="uiR2EDnpc_ring_magic_aoe_shockwave_b1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_shockwave_b2", Translation="uiR2EDnpc_ring_magic_aoe_shockwave_b2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_shockwave_b3", Translation="uiR2EDnpc_ring_magic_aoe_shockwave_b3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_shockwave_b4", Translation="uiR2EDnpc_ring_magic_aoe_shockwave_b4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_shockwave_c1", Translation="uiR2EDnpc_ring_magic_aoe_shockwave_c1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_shockwave_c2", Translation="uiR2EDnpc_ring_magic_aoe_shockwave_c2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_shockwave_c3", Translation="uiR2EDnpc_ring_magic_aoe_shockwave_c3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_shockwave_c4", Translation="uiR2EDnpc_ring_magic_aoe_shockwave_c4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_shockwave_d1", Translation="uiR2EDnpc_ring_magic_aoe_shockwave_d1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_shockwave_d2", Translation="uiR2EDnpc_ring_magic_aoe_shockwave_d2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_shockwave_d3", Translation="uiR2EDnpc_ring_magic_aoe_shockwave_d3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_shockwave_d4", Translation="uiR2EDnpc_ring_magic_aoe_shockwave_d4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_shockwave_e1", Translation="uiR2EDnpc_ring_magic_aoe_shockwave_e1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_shockwave_e2", Translation="uiR2EDnpc_ring_magic_aoe_shockwave_e2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_shockwave_e3", Translation="uiR2EDnpc_ring_magic_aoe_shockwave_e3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_shockwave_e4", Translation="uiR2EDnpc_ring_magic_aoe_shockwave_e4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_shockwave_f1", Translation="uiR2EDnpc_ring_magic_aoe_shockwave_f1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_shockwave_f2", Translation="uiR2EDnpc_ring_magic_aoe_shockwave_f2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_shockwave_f3", Translation="uiR2EDnpc_ring_magic_aoe_shockwave_f3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_aoe_shockwave_f4", Translation="uiR2EDnpc_ring_magic_aoe_shockwave_f4"}
--						}
--					}
--				},
--	
--				magiccurser =
--				{
--				    magiccurseratysianaffliction =
--				    {
--					    instances =
--					    {
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_blind_b1", Translation="uiR2EDnpc_ring_magic_curser_blind_b1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_blind_b2", Translation="uiR2EDnpc_ring_magic_curser_blind_b2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_blind_b3", Translation="uiR2EDnpc_ring_magic_curser_blind_b3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_blind_b4", Translation="uiR2EDnpc_ring_magic_curser_blind_b4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_blind_c1", Translation="uiR2EDnpc_ring_magic_curser_blind_c1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_blind_c2", Translation="uiR2EDnpc_ring_magic_curser_blind_c2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_blind_c3", Translation="uiR2EDnpc_ring_magic_curser_blind_c3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_blind_c4", Translation="uiR2EDnpc_ring_magic_curser_blind_c4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_blind_d1", Translation="uiR2EDnpc_ring_magic_curser_blind_d1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_blind_d2", Translation="uiR2EDnpc_ring_magic_curser_blind_d2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_blind_d3", Translation="uiR2EDnpc_ring_magic_curser_blind_d3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_blind_d4", Translation="uiR2EDnpc_ring_magic_curser_blind_d4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_blind_e1", Translation="uiR2EDnpc_ring_magic_curser_blind_e1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_blind_e2", Translation="uiR2EDnpc_ring_magic_curser_blind_e2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_blind_e3", Translation="uiR2EDnpc_ring_magic_curser_blind_e3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_blind_e4", Translation="uiR2EDnpc_ring_magic_curser_blind_e4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_blind_f1", Translation="uiR2EDnpc_ring_magic_curser_blind_f1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_blind_f2", Translation="uiR2EDnpc_ring_magic_curser_blind_f2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_blind_f3", Translation="uiR2EDnpc_ring_magic_curser_blind_f3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_blind_f4", Translation="uiR2EDnpc_ring_magic_curser_blind_f4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_madness_b1", Translation="uiR2EDnpc_ring_magic_curser_madness_b1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_madness_b2", Translation="uiR2EDnpc_ring_magic_curser_madness_b2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_madness_b3", Translation="uiR2EDnpc_ring_magic_curser_madness_b3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_madness_b4", Translation="uiR2EDnpc_ring_magic_curser_madness_b4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_madness_c1", Translation="uiR2EDnpc_ring_magic_curser_madness_c1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_madness_c2", Translation="uiR2EDnpc_ring_magic_curser_madness_c2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_madness_c3", Translation="uiR2EDnpc_ring_magic_curser_madness_c3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_madness_c4", Translation="uiR2EDnpc_ring_magic_curser_madness_c4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_madness_d1", Translation="uiR2EDnpc_ring_magic_curser_madness_d1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_madness_d2", Translation="uiR2EDnpc_ring_magic_curser_madness_d2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_madness_d3", Translation="uiR2EDnpc_ring_magic_curser_madness_d3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_madness_d4", Translation="uiR2EDnpc_ring_magic_curser_madness_d4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_madness_e1", Translation="uiR2EDnpc_ring_magic_curser_madness_e1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_madness_e2", Translation="uiR2EDnpc_ring_magic_curser_madness_e2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_madness_e3", Translation="uiR2EDnpc_ring_magic_curser_madness_e3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_madness_e4", Translation="uiR2EDnpc_ring_magic_curser_madness_e4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_madness_f1", Translation="uiR2EDnpc_ring_magic_curser_madness_f1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_madness_f2", Translation="uiR2EDnpc_ring_magic_curser_madness_f2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_madness_f3", Translation="uiR2EDnpc_ring_magic_curser_madness_f3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_madness_f4", Translation="uiR2EDnpc_ring_magic_curser_madness_f4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_root_b1", Translation="uiR2EDnpc_ring_magic_curser_root_b1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_root_b2", Translation="uiR2EDnpc_ring_magic_curser_root_b2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_root_b3", Translation="uiR2EDnpc_ring_magic_curser_root_b3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_root_b4", Translation="uiR2EDnpc_ring_magic_curser_root_b4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_root_c1", Translation="uiR2EDnpc_ring_magic_curser_root_c1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_root_c2", Translation="uiR2EDnpc_ring_magic_curser_root_c2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_root_c3", Translation="uiR2EDnpc_ring_magic_curser_root_c3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_root_c4", Translation="uiR2EDnpc_ring_magic_curser_root_c4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_root_d1", Translation="uiR2EDnpc_ring_magic_curser_root_d1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_root_d2", Translation="uiR2EDnpc_ring_magic_curser_root_d2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_root_d3", Translation="uiR2EDnpc_ring_magic_curser_root_d3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_root_d4", Translation="uiR2EDnpc_ring_magic_curser_root_d4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_root_e1", Translation="uiR2EDnpc_ring_magic_curser_root_e1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_root_e2", Translation="uiR2EDnpc_ring_magic_curser_root_e2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_root_e3", Translation="uiR2EDnpc_ring_magic_curser_root_e3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_root_e4", Translation="uiR2EDnpc_ring_magic_curser_root_e4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_root_f1", Translation="uiR2EDnpc_ring_magic_curser_root_f1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_root_f2", Translation="uiR2EDnpc_ring_magic_curser_root_f2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_root_f3", Translation="uiR2EDnpc_ring_magic_curser_root_f3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_root_f4", Translation="uiR2EDnpc_ring_magic_curser_root_f4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_slow_b1", Translation="uiR2EDnpc_ring_magic_curser_slow_b1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_slow_b2", Translation="uiR2EDnpc_ring_magic_curser_slow_b2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_slow_b3", Translation="uiR2EDnpc_ring_magic_curser_slow_b3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_slow_b4", Translation="uiR2EDnpc_ring_magic_curser_slow_b4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_slow_c1", Translation="uiR2EDnpc_ring_magic_curser_slow_c1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_slow_c2", Translation="uiR2EDnpc_ring_magic_curser_slow_c2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_slow_c3", Translation="uiR2EDnpc_ring_magic_curser_slow_c3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_slow_c4", Translation="uiR2EDnpc_ring_magic_curser_slow_c4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_slow_d1", Translation="uiR2EDnpc_ring_magic_curser_slow_d1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_slow_d2", Translation="uiR2EDnpc_ring_magic_curser_slow_d2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_slow_d3", Translation="uiR2EDnpc_ring_magic_curser_slow_d3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_slow_d4", Translation="uiR2EDnpc_ring_magic_curser_slow_d4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_slow_e1", Translation="uiR2EDnpc_ring_magic_curser_slow_e1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_slow_e2", Translation="uiR2EDnpc_ring_magic_curser_slow_e2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_slow_e3", Translation="uiR2EDnpc_ring_magic_curser_slow_e3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_slow_e4", Translation="uiR2EDnpc_ring_magic_curser_slow_e4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_slow_f1", Translation="uiR2EDnpc_ring_magic_curser_slow_f1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_slow_f2", Translation="uiR2EDnpc_ring_magic_curser_slow_f2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_slow_f3", Translation="uiR2EDnpc_ring_magic_curser_slow_f3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_slow_f4", Translation="uiR2EDnpc_ring_magic_curser_slow_f4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_snare_b1", Translation="uiR2EDnpc_ring_magic_curser_snare_b1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_snare_b2", Translation="uiR2EDnpc_ring_magic_curser_snare_b2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_snare_b3", Translation="uiR2EDnpc_ring_magic_curser_snare_b3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_snare_b4", Translation="uiR2EDnpc_ring_magic_curser_snare_b4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_snare_c1", Translation="uiR2EDnpc_ring_magic_curser_snare_c1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_snare_c2", Translation="uiR2EDnpc_ring_magic_curser_snare_c2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_snare_c3", Translation="uiR2EDnpc_ring_magic_curser_snare_c3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_snare_c4", Translation="uiR2EDnpc_ring_magic_curser_snare_c4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_snare_d1", Translation="uiR2EDnpc_ring_magic_curser_snare_d1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_snare_d2", Translation="uiR2EDnpc_ring_magic_curser_snare_d2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_snare_d3", Translation="uiR2EDnpc_ring_magic_curser_snare_d3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_snare_d4", Translation="uiR2EDnpc_ring_magic_curser_snare_d4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_snare_e1", Translation="uiR2EDnpc_ring_magic_curser_snare_e1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_snare_e2", Translation="uiR2EDnpc_ring_magic_curser_snare_e2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_snare_e3", Translation="uiR2EDnpc_ring_magic_curser_snare_e3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_snare_e4", Translation="uiR2EDnpc_ring_magic_curser_snare_e4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_snare_f1", Translation="uiR2EDnpc_ring_magic_curser_snare_f1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_snare_f2", Translation="uiR2EDnpc_ring_magic_curser_snare_f2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_snare_f3", Translation="uiR2EDnpc_ring_magic_curser_snare_f3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_snare_f4", Translation="uiR2EDnpc_ring_magic_curser_snare_f4"}
--						}
--					},
--					magiccursercelestialaffliction =
--				    {
--					    instances =
--					    {
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_fear_b1", Translation="uiR2EDnpc_ring_magic_curser_fear_b1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_fear_b2", Translation="uiR2EDnpc_ring_magic_curser_fear_b2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_fear_b3", Translation="uiR2EDnpc_ring_magic_curser_fear_b3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_fear_b4", Translation="uiR2EDnpc_ring_magic_curser_fear_b4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_fear_c1", Translation="uiR2EDnpc_ring_magic_curser_fear_c1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_fear_c2", Translation="uiR2EDnpc_ring_magic_curser_fear_c2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_fear_c3", Translation="uiR2EDnpc_ring_magic_curser_fear_c3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_fear_c4", Translation="uiR2EDnpc_ring_magic_curser_fear_c4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_fear_d1", Translation="uiR2EDnpc_ring_magic_curser_fear_d1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_fear_d2", Translation="uiR2EDnpc_ring_magic_curser_fear_d2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_fear_d3", Translation="uiR2EDnpc_ring_magic_curser_fear_d3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_fear_d4", Translation="uiR2EDnpc_ring_magic_curser_fear_d4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_fear_e1", Translation="uiR2EDnpc_ring_magic_curser_fear_e1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_fear_e2", Translation="uiR2EDnpc_ring_magic_curser_fear_e2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_fear_e3", Translation="uiR2EDnpc_ring_magic_curser_fear_e3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_fear_e4", Translation="uiR2EDnpc_ring_magic_curser_fear_e4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_fear_f1", Translation="uiR2EDnpc_ring_magic_curser_fear_f1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_fear_f2", Translation="uiR2EDnpc_ring_magic_curser_fear_f2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_fear_f3", Translation="uiR2EDnpc_ring_magic_curser_fear_f3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_fear_f4", Translation="uiR2EDnpc_ring_magic_curser_fear_f4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_sleep_b1", Translation="uiR2EDnpc_ring_magic_curser_sleep_b1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_sleep_b2", Translation="uiR2EDnpc_ring_magic_curser_sleep_b2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_sleep_b3", Translation="uiR2EDnpc_ring_magic_curser_sleep_b3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_sleep_b4", Translation="uiR2EDnpc_ring_magic_curser_sleep_b4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_sleep_c1", Translation="uiR2EDnpc_ring_magic_curser_sleep_c1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_sleep_c2", Translation="uiR2EDnpc_ring_magic_curser_sleep_c2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_sleep_c3", Translation="uiR2EDnpc_ring_magic_curser_sleep_c3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_sleep_c4", Translation="uiR2EDnpc_ring_magic_curser_sleep_c4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_sleep_d1", Translation="uiR2EDnpc_ring_magic_curser_sleep_d1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_sleep_d2", Translation="uiR2EDnpc_ring_magic_curser_sleep_d2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_sleep_d3", Translation="uiR2EDnpc_ring_magic_curser_sleep_d3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_sleep_d4", Translation="uiR2EDnpc_ring_magic_curser_sleep_d4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_sleep_e1", Translation="uiR2EDnpc_ring_magic_curser_sleep_e1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_sleep_e2", Translation="uiR2EDnpc_ring_magic_curser_sleep_e2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_sleep_e3", Translation="uiR2EDnpc_ring_magic_curser_sleep_e3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_sleep_e4", Translation="uiR2EDnpc_ring_magic_curser_sleep_e4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_sleep_f1", Translation="uiR2EDnpc_ring_magic_curser_sleep_f1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_sleep_f2", Translation="uiR2EDnpc_ring_magic_curser_sleep_f2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_sleep_f3", Translation="uiR2EDnpc_ring_magic_curser_sleep_f3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_sleep_f4", Translation="uiR2EDnpc_ring_magic_curser_sleep_f4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_stun_b1", Translation="uiR2EDnpc_ring_magic_curser_stun_b1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_stun_b2", Translation="uiR2EDnpc_ring_magic_curser_stun_b2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_stun_b3", Translation="uiR2EDnpc_ring_magic_curser_stun_b3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_stun_b4", Translation="uiR2EDnpc_ring_magic_curser_stun_b4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_stun_c1", Translation="uiR2EDnpc_ring_magic_curser_stun_c1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_stun_c2", Translation="uiR2EDnpc_ring_magic_curser_stun_c2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_stun_c3", Translation="uiR2EDnpc_ring_magic_curser_stun_c3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_stun_c4", Translation="uiR2EDnpc_ring_magic_curser_stun_c4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_stun_d1", Translation="uiR2EDnpc_ring_magic_curser_stun_d1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_stun_d2", Translation="uiR2EDnpc_ring_magic_curser_stun_d2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_stun_d3", Translation="uiR2EDnpc_ring_magic_curser_stun_d3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_stun_d4", Translation="uiR2EDnpc_ring_magic_curser_stun_d4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_stun_e1", Translation="uiR2EDnpc_ring_magic_curser_stun_e1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_stun_e2", Translation="uiR2EDnpc_ring_magic_curser_stun_e2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_stun_e3", Translation="uiR2EDnpc_ring_magic_curser_stun_e3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_stun_e4", Translation="uiR2EDnpc_ring_magic_curser_stun_e4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_stun_f1", Translation="uiR2EDnpc_ring_magic_curser_stun_f1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_stun_f2", Translation="uiR2EDnpc_ring_magic_curser_stun_f2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_stun_f3", Translation="uiR2EDnpc_ring_magic_curser_stun_f3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_curser_stun_f4", Translation="uiR2EDnpc_ring_magic_curser_stun_f4"}
--	
--						}
--					}
--				},
--	
--				magicdamagedealer =
--				{
--					magicdamagedealerbasic =
--					{
--					    instances =
--					    {
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_acid_b1", Translation="uiR2EDnpc_ring_magic_damage_dealer_acid_b1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_acid_b2", Translation="uiR2EDnpc_ring_magic_damage_dealer_acid_b2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_acid_b3", Translation="uiR2EDnpc_ring_magic_damage_dealer_acid_b3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_acid_b4", Translation="uiR2EDnpc_ring_magic_damage_dealer_acid_b4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_acid_c1", Translation="uiR2EDnpc_ring_magic_damage_dealer_acid_c1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_acid_c2", Translation="uiR2EDnpc_ring_magic_damage_dealer_acid_c2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_acid_c3", Translation="uiR2EDnpc_ring_magic_damage_dealer_acid_c3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_acid_c4", Translation="uiR2EDnpc_ring_magic_damage_dealer_acid_c4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_acid_d1", Translation="uiR2EDnpc_ring_magic_damage_dealer_acid_d1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_acid_d2", Translation="uiR2EDnpc_ring_magic_damage_dealer_acid_d2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_acid_d3", Translation="uiR2EDnpc_ring_magic_damage_dealer_acid_d3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_acid_d4", Translation="uiR2EDnpc_ring_magic_damage_dealer_acid_d4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_acid_e1", Translation="uiR2EDnpc_ring_magic_damage_dealer_acid_e1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_acid_e2", Translation="uiR2EDnpc_ring_magic_damage_dealer_acid_e2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_acid_e3", Translation="uiR2EDnpc_ring_magic_damage_dealer_acid_e3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_acid_e4", Translation="uiR2EDnpc_ring_magic_damage_dealer_acid_e4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_acid_f1", Translation="uiR2EDnpc_ring_magic_damage_dealer_acid_f1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_acid_f2", Translation="uiR2EDnpc_ring_magic_damage_dealer_acid_f2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_acid_f3", Translation="uiR2EDnpc_ring_magic_damage_dealer_acid_f3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_acid_f4", Translation="uiR2EDnpc_ring_magic_damage_dealer_acid_f4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_cold_b1", Translation="uiR2EDnpc_ring_magic_damage_dealer_cold_b1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_cold_b2", Translation="uiR2EDnpc_ring_magic_damage_dealer_cold_b2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_cold_b3", Translation="uiR2EDnpc_ring_magic_damage_dealer_cold_b3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_cold_b4", Translation="uiR2EDnpc_ring_magic_damage_dealer_cold_b4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_cold_c1", Translation="uiR2EDnpc_ring_magic_damage_dealer_cold_c1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_cold_c2", Translation="uiR2EDnpc_ring_magic_damage_dealer_cold_c2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_cold_c3", Translation="uiR2EDnpc_ring_magic_damage_dealer_cold_c3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_cold_c4", Translation="uiR2EDnpc_ring_magic_damage_dealer_cold_c4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_cold_d1", Translation="uiR2EDnpc_ring_magic_damage_dealer_cold_d1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_cold_d2", Translation="uiR2EDnpc_ring_magic_damage_dealer_cold_d2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_cold_d3", Translation="uiR2EDnpc_ring_magic_damage_dealer_cold_d3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_cold_d4", Translation="uiR2EDnpc_ring_magic_damage_dealer_cold_d4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_cold_e1", Translation="uiR2EDnpc_ring_magic_damage_dealer_cold_e1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_cold_e2", Translation="uiR2EDnpc_ring_magic_damage_dealer_cold_e2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_cold_e3", Translation="uiR2EDnpc_ring_magic_damage_dealer_cold_e3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_cold_e4", Translation="uiR2EDnpc_ring_magic_damage_dealer_cold_e4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_cold_f1", Translation="uiR2EDnpc_ring_magic_damage_dealer_cold_f1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_cold_f2", Translation="uiR2EDnpc_ring_magic_damage_dealer_cold_f2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_cold_f3", Translation="uiR2EDnpc_ring_magic_damage_dealer_cold_f3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_cold_f4", Translation="uiR2EDnpc_ring_magic_damage_dealer_cold_f4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_rot_b1", Translation="uiR2EDnpc_ring_magic_damage_dealer_rot_b1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_rot_b2", Translation="uiR2EDnpc_ring_magic_damage_dealer_rot_b2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_rot_b3", Translation="uiR2EDnpc_ring_magic_damage_dealer_rot_b3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_rot_b4", Translation="uiR2EDnpc_ring_magic_damage_dealer_rot_b4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_rot_c1", Translation="uiR2EDnpc_ring_magic_damage_dealer_rot_c1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_rot_c2", Translation="uiR2EDnpc_ring_magic_damage_dealer_rot_c2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_rot_c3", Translation="uiR2EDnpc_ring_magic_damage_dealer_rot_c3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_rot_c4", Translation="uiR2EDnpc_ring_magic_damage_dealer_rot_c4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_rot_d1", Translation="uiR2EDnpc_ring_magic_damage_dealer_rot_d1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_rot_d2", Translation="uiR2EDnpc_ring_magic_damage_dealer_rot_d2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_rot_d3", Translation="uiR2EDnpc_ring_magic_damage_dealer_rot_d3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_rot_d4", Translation="uiR2EDnpc_ring_magic_damage_dealer_rot_d4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_rot_e1", Translation="uiR2EDnpc_ring_magic_damage_dealer_rot_e1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_rot_e2", Translation="uiR2EDnpc_ring_magic_damage_dealer_rot_e2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_rot_e3", Translation="uiR2EDnpc_ring_magic_damage_dealer_rot_e3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_rot_e4", Translation="uiR2EDnpc_ring_magic_damage_dealer_rot_e4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_rot_f1", Translation="uiR2EDnpc_ring_magic_damage_dealer_rot_f1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_rot_f2", Translation="uiR2EDnpc_ring_magic_damage_dealer_rot_f2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_rot_f3", Translation="uiR2EDnpc_ring_magic_damage_dealer_rot_f3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_rot_f4", Translation="uiR2EDnpc_ring_magic_damage_dealer_rot_f4"}
--	 	   				}
--					},
--					magicdamagedealerracial =
--					{
--					    instances =
--					    {
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_electricity_b1", Translation="uiR2EDnpc_ring_magic_damage_dealer_electricity_b1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_electricity_b2", Translation="uiR2EDnpc_ring_magic_damage_dealer_electricity_b2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_electricity_b3", Translation="uiR2EDnpc_ring_magic_damage_dealer_electricity_b3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_electricity_b4", Translation="uiR2EDnpc_ring_magic_damage_dealer_electricity_b4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_electricity_c1", Translation="uiR2EDnpc_ring_magic_damage_dealer_electricity_c1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_electricity_c2", Translation="uiR2EDnpc_ring_magic_damage_dealer_electricity_c2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_electricity_c3", Translation="uiR2EDnpc_ring_magic_damage_dealer_electricity_c3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_electricity_c4", Translation="uiR2EDnpc_ring_magic_damage_dealer_electricity_c4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_electricity_d1", Translation="uiR2EDnpc_ring_magic_damage_dealer_electricity_d1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_electricity_d2", Translation="uiR2EDnpc_ring_magic_damage_dealer_electricity_d2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_electricity_d3", Translation="uiR2EDnpc_ring_magic_damage_dealer_electricity_d3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_electricity_d4", Translation="uiR2EDnpc_ring_magic_damage_dealer_electricity_d4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_electricity_e1", Translation="uiR2EDnpc_ring_magic_damage_dealer_electricity_e1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_electricity_e2", Translation="uiR2EDnpc_ring_magic_damage_dealer_electricity_e2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_electricity_e3", Translation="uiR2EDnpc_ring_magic_damage_dealer_electricity_e3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_electricity_e4", Translation="uiR2EDnpc_ring_magic_damage_dealer_electricity_e4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_electricity_f1", Translation="uiR2EDnpc_ring_magic_damage_dealer_electricity_f1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_electricity_f2", Translation="uiR2EDnpc_ring_magic_damage_dealer_electricity_f2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_electricity_f3", Translation="uiR2EDnpc_ring_magic_damage_dealer_electricity_f3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_electricity_f4", Translation="uiR2EDnpc_ring_magic_damage_dealer_electricity_f4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_fire_b1", Translation="uiR2EDnpc_ring_magic_damage_dealer_fire_b1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_fire_b2", Translation="uiR2EDnpc_ring_magic_damage_dealer_fire_b2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_fire_b3", Translation="uiR2EDnpc_ring_magic_damage_dealer_fire_b3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_fire_b4", Translation="uiR2EDnpc_ring_magic_damage_dealer_fire_b4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_fire_c1", Translation="uiR2EDnpc_ring_magic_damage_dealer_fire_c1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_fire_c2", Translation="uiR2EDnpc_ring_magic_damage_dealer_fire_c2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_fire_c3", Translation="uiR2EDnpc_ring_magic_damage_dealer_fire_c3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_fire_c4", Translation="uiR2EDnpc_ring_magic_damage_dealer_fire_c4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_fire_d1", Translation="uiR2EDnpc_ring_magic_damage_dealer_fire_d1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_fire_d2", Translation="uiR2EDnpc_ring_magic_damage_dealer_fire_d2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_fire_d3", Translation="uiR2EDnpc_ring_magic_damage_dealer_fire_d3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_fire_d4", Translation="uiR2EDnpc_ring_magic_damage_dealer_fire_d4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_fire_e1", Translation="uiR2EDnpc_ring_magic_damage_dealer_fire_e1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_fire_e2", Translation="uiR2EDnpc_ring_magic_damage_dealer_fire_e2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_fire_e3", Translation="uiR2EDnpc_ring_magic_damage_dealer_fire_e3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_fire_e4", Translation="uiR2EDnpc_ring_magic_damage_dealer_fire_e4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_fire_f1", Translation="uiR2EDnpc_ring_magic_damage_dealer_fire_f1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_fire_f2", Translation="uiR2EDnpc_ring_magic_damage_dealer_fire_f2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_fire_f3", Translation="uiR2EDnpc_ring_magic_damage_dealer_fire_f3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_fire_f4", Translation="uiR2EDnpc_ring_magic_damage_dealer_fire_f4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_poison_b1", Translation="uiR2EDnpc_ring_magic_damage_dealer_poison_b1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_poison_b2", Translation="uiR2EDnpc_ring_magic_damage_dealer_poison_b2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_poison_b3", Translation="uiR2EDnpc_ring_magic_damage_dealer_poison_b3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_poison_b4", Translation="uiR2EDnpc_ring_magic_damage_dealer_poison_b4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_poison_c1", Translation="uiR2EDnpc_ring_magic_damage_dealer_poison_c1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_poison_c2", Translation="uiR2EDnpc_ring_magic_damage_dealer_poison_c2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_poison_c3", Translation="uiR2EDnpc_ring_magic_damage_dealer_poison_c3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_poison_c4", Translation="uiR2EDnpc_ring_magic_damage_dealer_poison_c4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_poison_d1", Translation="uiR2EDnpc_ring_magic_damage_dealer_poison_d1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_poison_d2", Translation="uiR2EDnpc_ring_magic_damage_dealer_poison_d2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_poison_d3", Translation="uiR2EDnpc_ring_magic_damage_dealer_poison_d3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_poison_d4", Translation="uiR2EDnpc_ring_magic_damage_dealer_poison_d4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_poison_e1", Translation="uiR2EDnpc_ring_magic_damage_dealer_poison_e1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_poison_e2", Translation="uiR2EDnpc_ring_magic_damage_dealer_poison_e2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_poison_e3", Translation="uiR2EDnpc_ring_magic_damage_dealer_poison_e3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_poison_e4", Translation="uiR2EDnpc_ring_magic_damage_dealer_poison_e4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_poison_f1", Translation="uiR2EDnpc_ring_magic_damage_dealer_poison_f1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_poison_f2", Translation="uiR2EDnpc_ring_magic_damage_dealer_poison_f2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_poison_f3", Translation="uiR2EDnpc_ring_magic_damage_dealer_poison_f3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_poison_f4", Translation="uiR2EDnpc_ring_magic_damage_dealer_poison_f4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_shockwave_b1", Translation="uiR2EDnpc_ring_magic_damage_dealer_shockwave_b1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_shockwave_b2", Translation="uiR2EDnpc_ring_magic_damage_dealer_shockwave_b2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_shockwave_b3", Translation="uiR2EDnpc_ring_magic_damage_dealer_shockwave_b3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_shockwave_b4", Translation="uiR2EDnpc_ring_magic_damage_dealer_shockwave_b4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_shockwave_c1", Translation="uiR2EDnpc_ring_magic_damage_dealer_shockwave_c1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_shockwave_c2", Translation="uiR2EDnpc_ring_magic_damage_dealer_shockwave_c2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_shockwave_c3", Translation="uiR2EDnpc_ring_magic_damage_dealer_shockwave_c3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_shockwave_c4", Translation="uiR2EDnpc_ring_magic_damage_dealer_shockwave_c4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_shockwave_d1", Translation="uiR2EDnpc_ring_magic_damage_dealer_shockwave_d1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_shockwave_d2", Translation="uiR2EDnpc_ring_magic_damage_dealer_shockwave_d2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_shockwave_d3", Translation="uiR2EDnpc_ring_magic_damage_dealer_shockwave_d3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_shockwave_d4", Translation="uiR2EDnpc_ring_magic_damage_dealer_shockwave_d4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_shockwave_e1", Translation="uiR2EDnpc_ring_magic_damage_dealer_shockwave_e1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_shockwave_e2", Translation="uiR2EDnpc_ring_magic_damage_dealer_shockwave_e2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_shockwave_e3", Translation="uiR2EDnpc_ring_magic_damage_dealer_shockwave_e3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_shockwave_e4", Translation="uiR2EDnpc_ring_magic_damage_dealer_shockwave_e4"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_shockwave_f1", Translation="uiR2EDnpc_ring_magic_damage_dealer_shockwave_f1"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_shockwave_f2", Translation="uiR2EDnpc_ring_magic_damage_dealer_shockwave_f2"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_shockwave_f3", Translation="uiR2EDnpc_ring_magic_damage_dealer_shockwave_f3"},
--							{Id="palette.entities.npcs.bandits.ring_magic_damage_dealer_shockwave_f4", Translation="uiR2EDnpc_ring_magic_damage_dealer_shockwave_f4"},
--	
--					    }
--					}
--				},
--	
--				meleedamagedealer =
--				{
--				    instances =
--				    {
--						{Id="palette.entities.npcs.bandits.ring_melee_damage_dealer_blunt_b1", Translation="uiR2EDnpc_ring_melee_damage_dealer_blunt_b1"},
--						{Id="palette.entities.npcs.bandits.ring_melee_damage_dealer_blunt_b2", Translation="uiR2EDnpc_ring_melee_damage_dealer_blunt_b2"},
--						{Id="palette.entities.npcs.bandits.ring_melee_damage_dealer_blunt_b3", Translation="uiR2EDnpc_ring_melee_damage_dealer_blunt_b3"},
--						{Id="palette.entities.npcs.bandits.ring_melee_damage_dealer_blunt_b4", Translation="uiR2EDnpc_ring_melee_damage_dealer_blunt_b4"},
--						{Id="palette.entities.npcs.bandits.ring_melee_damage_dealer_blunt_c1", Translation="uiR2EDnpc_ring_melee_damage_dealer_blunt_c1"},
--						{Id="palette.entities.npcs.bandits.ring_melee_damage_dealer_blunt_c2", Translation="uiR2EDnpc_ring_melee_damage_dealer_blunt_c2"},
--						{Id="palette.entities.npcs.bandits.ring_melee_damage_dealer_blunt_c3", Translation="uiR2EDnpc_ring_melee_damage_dealer_blunt_c3"},
--						{Id="palette.entities.npcs.bandits.ring_melee_damage_dealer_blunt_c4", Translation="uiR2EDnpc_ring_melee_damage_dealer_blunt_c4"},
--						{Id="palette.entities.npcs.bandits.ring_melee_damage_dealer_blunt_d1", Translation="uiR2EDnpc_ring_melee_damage_dealer_blunt_d1"},
--						{Id="palette.entities.npcs.bandits.ring_melee_damage_dealer_blunt_d2", Translation="uiR2EDnpc_ring_melee_damage_dealer_blunt_d2"},
--						{Id="palette.entities.npcs.bandits.ring_melee_damage_dealer_blunt_d3", Translation="uiR2EDnpc_ring_melee_damage_dealer_blunt_d3"},
--						{Id="palette.entities.npcs.bandits.ring_melee_damage_dealer_blunt_d4", Translation="uiR2EDnpc_ring_melee_damage_dealer_blunt_d4"},
--						{Id="palette.entities.npcs.bandits.ring_melee_damage_dealer_blunt_e1", Translation="uiR2EDnpc_ring_melee_damage_dealer_blunt_e1"},
--						{Id="palette.entities.npcs.bandits.ring_melee_damage_dealer_blunt_e2", Translation="uiR2EDnpc_ring_melee_damage_dealer_blunt_e2"},
--						{Id="palette.entities.npcs.bandits.ring_melee_damage_dealer_blunt_e3", Translation="uiR2EDnpc_ring_melee_damage_dealer_blunt_e3"},
--						{Id="palette.entities.npcs.bandits.ring_melee_damage_dealer_blunt_e4", Translation="uiR2EDnpc_ring_melee_damage_dealer_blunt_e4"},
--						{Id="palette.entities.npcs.bandits.ring_melee_damage_dealer_blunt_f1", Translation="uiR2EDnpc_ring_melee_damage_dealer_blunt_f1"},
--						{Id="palette.entities.npcs.bandits.ring_melee_damage_dealer_blunt_f2", Translation="uiR2EDnpc_ring_melee_damage_dealer_blunt_f2"},
--						{Id="palette.entities.npcs.bandits.ring_melee_damage_dealer_blunt_f3", Translation="uiR2EDnpc_ring_melee_damage_dealer_blunt_f3"},
--						{Id="palette.entities.npcs.bandits.ring_melee_damage_dealer_blunt_f4", Translation="uiR2EDnpc_ring_melee_damage_dealer_blunt_f4"},
--						{Id="palette.entities.npcs.bandits.ring_melee_damage_dealer_pierce_b1", Translation="uiR2EDnpc_ring_melee_damage_dealer_pierce_b1"},
--						{Id="palette.entities.npcs.bandits.ring_melee_damage_dealer_pierce_b2", Translation="uiR2EDnpc_ring_melee_damage_dealer_pierce_b2"},
--						{Id="palette.entities.npcs.bandits.ring_melee_damage_dealer_pierce_b3", Translation="uiR2EDnpc_ring_melee_damage_dealer_pierce_b3"},
--						{Id="palette.entities.npcs.bandits.ring_melee_damage_dealer_pierce_b4", Translation="uiR2EDnpc_ring_melee_damage_dealer_pierce_b4"},
--						{Id="palette.entities.npcs.bandits.ring_melee_damage_dealer_pierce_c1", Translation="uiR2EDnpc_ring_melee_damage_dealer_pierce_c1"},
--						{Id="palette.entities.npcs.bandits.ring_melee_damage_dealer_pierce_c2", Translation="uiR2EDnpc_ring_melee_damage_dealer_pierce_c2"},
--						{Id="palette.entities.npcs.bandits.ring_melee_damage_dealer_pierce_c3", Translation="uiR2EDnpc_ring_melee_damage_dealer_pierce_c3"},
--						{Id="palette.entities.npcs.bandits.ring_melee_damage_dealer_pierce_c4", Translation="uiR2EDnpc_ring_melee_damage_dealer_pierce_c4"},
--						{Id="palette.entities.npcs.bandits.ring_melee_damage_dealer_pierce_d1", Translation="uiR2EDnpc_ring_melee_damage_dealer_pierce_d1"},
--						{Id="palette.entities.npcs.bandits.ring_melee_damage_dealer_pierce_d2", Translation="uiR2EDnpc_ring_melee_damage_dealer_pierce_d2"},
--						{Id="palette.entities.npcs.bandits.ring_melee_damage_dealer_pierce_d3", Translation="uiR2EDnpc_ring_melee_damage_dealer_pierce_d3"},
--						{Id="palette.entities.npcs.bandits.ring_melee_damage_dealer_pierce_d4", Translation="uiR2EDnpc_ring_melee_damage_dealer_pierce_d4"},
--						{Id="palette.entities.npcs.bandits.ring_melee_damage_dealer_pierce_e1", Translation="uiR2EDnpc_ring_melee_damage_dealer_pierce_e1"},
--						{Id="palette.entities.npcs.bandits.ring_melee_damage_dealer_pierce_e2", Translation="uiR2EDnpc_ring_melee_damage_dealer_pierce_e2"},
--						{Id="palette.entities.npcs.bandits.ring_melee_damage_dealer_pierce_e3", Translation="uiR2EDnpc_ring_melee_damage_dealer_pierce_e3"},
--						{Id="palette.entities.npcs.bandits.ring_melee_damage_dealer_pierce_e4", Translation="uiR2EDnpc_ring_melee_damage_dealer_pierce_e4"},
--						{Id="palette.entities.npcs.bandits.ring_melee_damage_dealer_pierce_f1", Translation="uiR2EDnpc_ring_melee_damage_dealer_pierce_f1"},
--						{Id="palette.entities.npcs.bandits.ring_melee_damage_dealer_pierce_f2", Translation="uiR2EDnpc_ring_melee_damage_dealer_pierce_f2"},
--						{Id="palette.entities.npcs.bandits.ring_melee_damage_dealer_pierce_f3", Translation="uiR2EDnpc_ring_melee_damage_dealer_pierce_f3"},
--						{Id="palette.entities.npcs.bandits.ring_melee_damage_dealer_pierce_f4", Translation="uiR2EDnpc_ring_melee_damage_dealer_pierce_f4"},
--						{Id="palette.entities.npcs.bandits.ring_melee_damage_dealer_slash_b1", Translation="uiR2EDnpc_ring_melee_damage_dealer_slash_b1"},
--						{Id="palette.entities.npcs.bandits.ring_melee_damage_dealer_slash_b2", Translation="uiR2EDnpc_ring_melee_damage_dealer_slash_b2"},
--						{Id="palette.entities.npcs.bandits.ring_melee_damage_dealer_slash_b3", Translation="uiR2EDnpc_ring_melee_damage_dealer_slash_b3"},
--						{Id="palette.entities.npcs.bandits.ring_melee_damage_dealer_slash_b4", Translation="uiR2EDnpc_ring_melee_damage_dealer_slash_b4"},
--						{Id="palette.entities.npcs.bandits.ring_melee_damage_dealer_slash_c1", Translation="uiR2EDnpc_ring_melee_damage_dealer_slash_c1"},
--						{Id="palette.entities.npcs.bandits.ring_melee_damage_dealer_slash_c2", Translation="uiR2EDnpc_ring_melee_damage_dealer_slash_c2"},
--						{Id="palette.entities.npcs.bandits.ring_melee_damage_dealer_slash_c3", Translation="uiR2EDnpc_ring_melee_damage_dealer_slash_c3"},
--						{Id="palette.entities.npcs.bandits.ring_melee_damage_dealer_slash_c4", Translation="uiR2EDnpc_ring_melee_damage_dealer_slash_c4"},
--						{Id="palette.entities.npcs.bandits.ring_melee_damage_dealer_slash_d1", Translation="uiR2EDnpc_ring_melee_damage_dealer_slash_d1"},
--						{Id="palette.entities.npcs.bandits.ring_melee_damage_dealer_slash_d2", Translation="uiR2EDnpc_ring_melee_damage_dealer_slash_d2"},
--						{Id="palette.entities.npcs.bandits.ring_melee_damage_dealer_slash_d3", Translation="uiR2EDnpc_ring_melee_damage_dealer_slash_d3"},
--						{Id="palette.entities.npcs.bandits.ring_melee_damage_dealer_slash_d4", Translation="uiR2EDnpc_ring_melee_damage_dealer_slash_d4"},
--						{Id="palette.entities.npcs.bandits.ring_melee_damage_dealer_slash_e1", Translation="uiR2EDnpc_ring_melee_damage_dealer_slash_e1"},
--						{Id="palette.entities.npcs.bandits.ring_melee_damage_dealer_slash_e2", Translation="uiR2EDnpc_ring_melee_damage_dealer_slash_e2"},
--						{Id="palette.entities.npcs.bandits.ring_melee_damage_dealer_slash_e3", Translation="uiR2EDnpc_ring_melee_damage_dealer_slash_e3"},
--						{Id="palette.entities.npcs.bandits.ring_melee_damage_dealer_slash_e4", Translation="uiR2EDnpc_ring_melee_damage_dealer_slash_e4"},
--						{Id="palette.entities.npcs.bandits.ring_melee_damage_dealer_slash_f1", Translation="uiR2EDnpc_ring_melee_damage_dealer_slash_f1"},
--						{Id="palette.entities.npcs.bandits.ring_melee_damage_dealer_slash_f2", Translation="uiR2EDnpc_ring_melee_damage_dealer_slash_f2"},
--						{Id="palette.entities.npcs.bandits.ring_melee_damage_dealer_slash_f3", Translation="uiR2EDnpc_ring_melee_damage_dealer_slash_f3"},
--						{Id="palette.entities.npcs.bandits.ring_melee_damage_dealer_slash_f4", Translation="uiR2EDnpc_ring_melee_damage_dealer_slash_f4"}
--					}
--				},
--	
--				meleetank =
--				{
--				    instances =
--				    {
--						{Id="palette.entities.npcs.bandits.ring_melee_tank_blunt_b1", Translation="uiR2EDnpc_ring_melee_tank_blunt_b1"},
--						{Id="palette.entities.npcs.bandits.ring_melee_tank_blunt_b2", Translation="uiR2EDnpc_ring_melee_tank_blunt_b2"},
--						{Id="palette.entities.npcs.bandits.ring_melee_tank_blunt_b3", Translation="uiR2EDnpc_ring_melee_tank_blunt_b3"},
--						{Id="palette.entities.npcs.bandits.ring_melee_tank_blunt_b4", Translation="uiR2EDnpc_ring_melee_tank_blunt_b4"},
--						{Id="palette.entities.npcs.bandits.ring_melee_tank_blunt_c1", Translation="uiR2EDnpc_ring_melee_tank_blunt_c1"},
--						{Id="palette.entities.npcs.bandits.ring_melee_tank_blunt_c2", Translation="uiR2EDnpc_ring_melee_tank_blunt_c2"},
--						{Id="palette.entities.npcs.bandits.ring_melee_tank_blunt_c3", Translation="uiR2EDnpc_ring_melee_tank_blunt_c3"},
--						{Id="palette.entities.npcs.bandits.ring_melee_tank_blunt_c4", Translation="uiR2EDnpc_ring_melee_tank_blunt_c4"},
--						{Id="palette.entities.npcs.bandits.ring_melee_tank_blunt_d1", Translation="uiR2EDnpc_ring_melee_tank_blunt_d1"},
--						{Id="palette.entities.npcs.bandits.ring_melee_tank_blunt_d2", Translation="uiR2EDnpc_ring_melee_tank_blunt_d2"},
--						{Id="palette.entities.npcs.bandits.ring_melee_tank_blunt_d3", Translation="uiR2EDnpc_ring_melee_tank_blunt_d3"},
--						{Id="palette.entities.npcs.bandits.ring_melee_tank_blunt_d4", Translation="uiR2EDnpc_ring_melee_tank_blunt_d4"},
--						{Id="palette.entities.npcs.bandits.ring_melee_tank_blunt_e1", Translation="uiR2EDnpc_ring_melee_tank_blunt_e1"},
--						{Id="palette.entities.npcs.bandits.ring_melee_tank_blunt_e2", Translation="uiR2EDnpc_ring_melee_tank_blunt_e2"},
--						{Id="palette.entities.npcs.bandits.ring_melee_tank_blunt_e3", Translation="uiR2EDnpc_ring_melee_tank_blunt_e3"},
--						{Id="palette.entities.npcs.bandits.ring_melee_tank_blunt_e4", Translation="uiR2EDnpc_ring_melee_tank_blunt_e4"},
--						{Id="palette.entities.npcs.bandits.ring_melee_tank_blunt_f1", Translation="uiR2EDnpc_ring_melee_tank_blunt_f1"},
--						{Id="palette.entities.npcs.bandits.ring_melee_tank_blunt_f2", Translation="uiR2EDnpc_ring_melee_tank_blunt_f2"},
--						{Id="palette.entities.npcs.bandits.ring_melee_tank_blunt_f3", Translation="uiR2EDnpc_ring_melee_tank_blunt_f3"},
--						{Id="palette.entities.npcs.bandits.ring_melee_tank_blunt_f4", Translation="uiR2EDnpc_ring_melee_tank_blunt_f4"},
--						{Id="palette.entities.npcs.bandits.ring_melee_tank_pierce_b1", Translation="uiR2EDnpc_ring_melee_tank_pierce_b1"},
--						{Id="palette.entities.npcs.bandits.ring_melee_tank_pierce_b2", Translation="uiR2EDnpc_ring_melee_tank_pierce_b2"},
--						{Id="palette.entities.npcs.bandits.ring_melee_tank_pierce_b3", Translation="uiR2EDnpc_ring_melee_tank_pierce_b3"},
--						{Id="palette.entities.npcs.bandits.ring_melee_tank_pierce_b4", Translation="uiR2EDnpc_ring_melee_tank_pierce_b4"},
--						{Id="palette.entities.npcs.bandits.ring_melee_tank_pierce_c1", Translation="uiR2EDnpc_ring_melee_tank_pierce_c1"},
--						{Id="palette.entities.npcs.bandits.ring_melee_tank_pierce_c2", Translation="uiR2EDnpc_ring_melee_tank_pierce_c2"},
--						{Id="palette.entities.npcs.bandits.ring_melee_tank_pierce_c3", Translation="uiR2EDnpc_ring_melee_tank_pierce_c3"},
--						{Id="palette.entities.npcs.bandits.ring_melee_tank_pierce_c4", Translation="uiR2EDnpc_ring_melee_tank_pierce_c4"},
--						{Id="palette.entities.npcs.bandits.ring_melee_tank_pierce_d1", Translation="uiR2EDnpc_ring_melee_tank_pierce_d1"},
--						{Id="palette.entities.npcs.bandits.ring_melee_tank_pierce_d2", Translation="uiR2EDnpc_ring_melee_tank_pierce_d2"},
--						{Id="palette.entities.npcs.bandits.ring_melee_tank_pierce_d3", Translation="uiR2EDnpc_ring_melee_tank_pierce_d3"},
--						{Id="palette.entities.npcs.bandits.ring_melee_tank_pierce_d4", Translation="uiR2EDnpc_ring_melee_tank_pierce_d4"},
--						{Id="palette.entities.npcs.bandits.ring_melee_tank_pierce_e1", Translation="uiR2EDnpc_ring_melee_tank_pierce_e1"},
--						{Id="palette.entities.npcs.bandits.ring_melee_tank_pierce_e2", Translation="uiR2EDnpc_ring_melee_tank_pierce_e2"},
--						{Id="palette.entities.npcs.bandits.ring_melee_tank_pierce_e3", Translation="uiR2EDnpc_ring_melee_tank_pierce_e3"},
--						{Id="palette.entities.npcs.bandits.ring_melee_tank_pierce_e4", Translation="uiR2EDnpc_ring_melee_tank_pierce_e4"},
--						{Id="palette.entities.npcs.bandits.ring_melee_tank_pierce_f1", Translation="uiR2EDnpc_ring_melee_tank_pierce_f1"},
--						{Id="palette.entities.npcs.bandits.ring_melee_tank_pierce_f2", Translation="uiR2EDnpc_ring_melee_tank_pierce_f2"},
--						{Id="palette.entities.npcs.bandits.ring_melee_tank_pierce_f3", Translation="uiR2EDnpc_ring_melee_tank_pierce_f3"},
--						{Id="palette.entities.npcs.bandits.ring_melee_tank_pierce_f4", Translation="uiR2EDnpc_ring_melee_tank_pierce_f4"},
--						{Id="palette.entities.npcs.bandits.ring_melee_tank_slash_b1", Translation="uiR2EDnpc_ring_melee_tank_slash_b1"},
--						{Id="palette.entities.npcs.bandits.ring_melee_tank_slash_b2", Translation="uiR2EDnpc_ring_melee_tank_slash_b2"},
--						{Id="palette.entities.npcs.bandits.ring_melee_tank_slash_b3", Translation="uiR2EDnpc_ring_melee_tank_slash_b3"},
--						{Id="palette.entities.npcs.bandits.ring_melee_tank_slash_b4", Translation="uiR2EDnpc_ring_melee_tank_slash_b4"},
--						{Id="palette.entities.npcs.bandits.ring_melee_tank_slash_c1", Translation="uiR2EDnpc_ring_melee_tank_slash_c1"},
--						{Id="palette.entities.npcs.bandits.ring_melee_tank_slash_c2", Translation="uiR2EDnpc_ring_melee_tank_slash_c2"},
--						{Id="palette.entities.npcs.bandits.ring_melee_tank_slash_c3", Translation="uiR2EDnpc_ring_melee_tank_slash_c3"},
--						{Id="palette.entities.npcs.bandits.ring_melee_tank_slash_c4", Translation="uiR2EDnpc_ring_melee_tank_slash_c4"},
--						{Id="palette.entities.npcs.bandits.ring_melee_tank_slash_d1", Translation="uiR2EDnpc_ring_melee_tank_slash_d1"},
--						{Id="palette.entities.npcs.bandits.ring_melee_tank_slash_d2", Translation="uiR2EDnpc_ring_melee_tank_slash_d2"},
--						{Id="palette.entities.npcs.bandits.ring_melee_tank_slash_d3", Translation="uiR2EDnpc_ring_melee_tank_slash_d3"},
--						{Id="palette.entities.npcs.bandits.ring_melee_tank_slash_d4", Translation="uiR2EDnpc_ring_melee_tank_slash_d4"},
--						{Id="palette.entities.npcs.bandits.ring_melee_tank_slash_e1", Translation="uiR2EDnpc_ring_melee_tank_slash_e1"},
--						{Id="palette.entities.npcs.bandits.ring_melee_tank_slash_e2", Translation="uiR2EDnpc_ring_melee_tank_slash_e2"},
--						{Id="palette.entities.npcs.bandits.ring_melee_tank_slash_e3", Translation="uiR2EDnpc_ring_melee_tank_slash_e3"},
--						{Id="palette.entities.npcs.bandits.ring_melee_tank_slash_e4", Translation="uiR2EDnpc_ring_melee_tank_slash_e4"},
--						{Id="palette.entities.npcs.bandits.ring_melee_tank_slash_f1", Translation="uiR2EDnpc_ring_melee_tank_slash_f1"},
--						{Id="palette.entities.npcs.bandits.ring_melee_tank_slash_f2", Translation="uiR2EDnpc_ring_melee_tank_slash_f2"},
--						{Id="palette.entities.npcs.bandits.ring_melee_tank_slash_f3", Translation="uiR2EDnpc_ring_melee_tank_slash_f3"},
--						{Id="palette.entities.npcs.bandits.ring_melee_tank_slash_f4", Translation="uiR2EDnpc_ring_melee_tank_slash_f4"}
--	 				}
--				},
--	
--				rangeddamagedealer =
--				{
--				    instances =
--				    {
--						{Id="palette.entities.npcs.bandits.ring_ranged_damage_dealer_blunt_b1", Translation="uiR2EDnpc_ring_ranged_damage_dealer_blunt_b1"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_damage_dealer_blunt_b2", Translation="uiR2EDnpc_ring_ranged_damage_dealer_blunt_b2"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_damage_dealer_blunt_b3", Translation="uiR2EDnpc_ring_ranged_damage_dealer_blunt_b3"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_damage_dealer_blunt_b4", Translation="uiR2EDnpc_ring_ranged_damage_dealer_blunt_b4"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_damage_dealer_blunt_c1", Translation="uiR2EDnpc_ring_ranged_damage_dealer_blunt_c1"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_damage_dealer_blunt_c2", Translation="uiR2EDnpc_ring_ranged_damage_dealer_blunt_c2"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_damage_dealer_blunt_c3", Translation="uiR2EDnpc_ring_ranged_damage_dealer_blunt_c3"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_damage_dealer_blunt_c4", Translation="uiR2EDnpc_ring_ranged_damage_dealer_blunt_c4"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_damage_dealer_blunt_d1", Translation="uiR2EDnpc_ring_ranged_damage_dealer_blunt_d1"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_damage_dealer_blunt_d2", Translation="uiR2EDnpc_ring_ranged_damage_dealer_blunt_d2"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_damage_dealer_blunt_d3", Translation="uiR2EDnpc_ring_ranged_damage_dealer_blunt_d3"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_damage_dealer_blunt_d4", Translation="uiR2EDnpc_ring_ranged_damage_dealer_blunt_d4"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_damage_dealer_blunt_e1", Translation="uiR2EDnpc_ring_ranged_damage_dealer_blunt_e1"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_damage_dealer_blunt_e2", Translation="uiR2EDnpc_ring_ranged_damage_dealer_blunt_e2"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_damage_dealer_blunt_e3", Translation="uiR2EDnpc_ring_ranged_damage_dealer_blunt_e3"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_damage_dealer_blunt_e4", Translation="uiR2EDnpc_ring_ranged_damage_dealer_blunt_e4"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_damage_dealer_blunt_f1", Translation="uiR2EDnpc_ring_ranged_damage_dealer_blunt_f1"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_damage_dealer_blunt_f2", Translation="uiR2EDnpc_ring_ranged_damage_dealer_blunt_f2"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_damage_dealer_blunt_f3", Translation="uiR2EDnpc_ring_ranged_damage_dealer_blunt_f3"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_damage_dealer_blunt_f4", Translation="uiR2EDnpc_ring_ranged_damage_dealer_blunt_f4"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_damage_dealer_pierce_b1", Translation="uiR2EDnpc_ring_ranged_damage_dealer_pierce_b1"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_damage_dealer_pierce_b2", Translation="uiR2EDnpc_ring_ranged_damage_dealer_pierce_b2"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_damage_dealer_pierce_b3", Translation="uiR2EDnpc_ring_ranged_damage_dealer_pierce_b3"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_damage_dealer_pierce_b4", Translation="uiR2EDnpc_ring_ranged_damage_dealer_pierce_b4"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_damage_dealer_pierce_c1", Translation="uiR2EDnpc_ring_ranged_damage_dealer_pierce_c1"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_damage_dealer_pierce_c2", Translation="uiR2EDnpc_ring_ranged_damage_dealer_pierce_c2"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_damage_dealer_pierce_c3", Translation="uiR2EDnpc_ring_ranged_damage_dealer_pierce_c3"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_damage_dealer_pierce_c4", Translation="uiR2EDnpc_ring_ranged_damage_dealer_pierce_c4"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_damage_dealer_pierce_d1", Translation="uiR2EDnpc_ring_ranged_damage_dealer_pierce_d1"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_damage_dealer_pierce_d2", Translation="uiR2EDnpc_ring_ranged_damage_dealer_pierce_d2"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_damage_dealer_pierce_d3", Translation="uiR2EDnpc_ring_ranged_damage_dealer_pierce_d3"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_damage_dealer_pierce_d4", Translation="uiR2EDnpc_ring_ranged_damage_dealer_pierce_d4"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_damage_dealer_pierce_e1", Translation="uiR2EDnpc_ring_ranged_damage_dealer_pierce_e1"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_damage_dealer_pierce_e2", Translation="uiR2EDnpc_ring_ranged_damage_dealer_pierce_e2"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_damage_dealer_pierce_e3", Translation="uiR2EDnpc_ring_ranged_damage_dealer_pierce_e3"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_damage_dealer_pierce_e4", Translation="uiR2EDnpc_ring_ranged_damage_dealer_pierce_e4"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_damage_dealer_pierce_f1", Translation="uiR2EDnpc_ring_ranged_damage_dealer_pierce_f1"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_damage_dealer_pierce_f2", Translation="uiR2EDnpc_ring_ranged_damage_dealer_pierce_f2"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_damage_dealer_pierce_f3", Translation="uiR2EDnpc_ring_ranged_damage_dealer_pierce_f3"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_damage_dealer_pierce_f4", Translation="uiR2EDnpc_ring_ranged_damage_dealer_pierce_f4"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_damage_dealer_slash_b1", Translation="uiR2EDnpc_ring_ranged_damage_dealer_slash_b1"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_damage_dealer_slash_b2", Translation="uiR2EDnpc_ring_ranged_damage_dealer_slash_b2"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_damage_dealer_slash_b3", Translation="uiR2EDnpc_ring_ranged_damage_dealer_slash_b3"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_damage_dealer_slash_b4", Translation="uiR2EDnpc_ring_ranged_damage_dealer_slash_b4"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_damage_dealer_slash_c1", Translation="uiR2EDnpc_ring_ranged_damage_dealer_slash_c1"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_damage_dealer_slash_c2", Translation="uiR2EDnpc_ring_ranged_damage_dealer_slash_c2"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_damage_dealer_slash_c3", Translation="uiR2EDnpc_ring_ranged_damage_dealer_slash_c3"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_damage_dealer_slash_c4", Translation="uiR2EDnpc_ring_ranged_damage_dealer_slash_c4"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_damage_dealer_slash_d1", Translation="uiR2EDnpc_ring_ranged_damage_dealer_slash_d1"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_damage_dealer_slash_d2", Translation="uiR2EDnpc_ring_ranged_damage_dealer_slash_d2"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_damage_dealer_slash_d3", Translation="uiR2EDnpc_ring_ranged_damage_dealer_slash_d3"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_damage_dealer_slash_d4", Translation="uiR2EDnpc_ring_ranged_damage_dealer_slash_d4"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_damage_dealer_slash_e1", Translation="uiR2EDnpc_ring_ranged_damage_dealer_slash_e1"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_damage_dealer_slash_e2", Translation="uiR2EDnpc_ring_ranged_damage_dealer_slash_e2"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_damage_dealer_slash_e3", Translation="uiR2EDnpc_ring_ranged_damage_dealer_slash_e3"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_damage_dealer_slash_e4", Translation="uiR2EDnpc_ring_ranged_damage_dealer_slash_e4"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_damage_dealer_slash_f1", Translation="uiR2EDnpc_ring_ranged_damage_dealer_slash_f1"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_damage_dealer_slash_f2", Translation="uiR2EDnpc_ring_ranged_damage_dealer_slash_f2"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_damage_dealer_slash_f3", Translation="uiR2EDnpc_ring_ranged_damage_dealer_slash_f3"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_damage_dealer_slash_f4", Translation="uiR2EDnpc_ring_ranged_damage_dealer_slash_f4"}
--					}
--				},
--	
--				rangedtank =
--				{
--				    instances =
--				    {
--						{Id="palette.entities.npcs.bandits.ring_ranged_tank_blunt_b1", Translation="uiR2EDnpc_ring_ranged_tank_blunt_b1"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_tank_blunt_b2", Translation="uiR2EDnpc_ring_ranged_tank_blunt_b2"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_tank_blunt_b3", Translation="uiR2EDnpc_ring_ranged_tank_blunt_b3"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_tank_blunt_b4", Translation="uiR2EDnpc_ring_ranged_tank_blunt_b4"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_tank_blunt_c1", Translation="uiR2EDnpc_ring_ranged_tank_blunt_c1"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_tank_blunt_c2", Translation="uiR2EDnpc_ring_ranged_tank_blunt_c2"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_tank_blunt_c3", Translation="uiR2EDnpc_ring_ranged_tank_blunt_c3"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_tank_blunt_c4", Translation="uiR2EDnpc_ring_ranged_tank_blunt_c4"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_tank_blunt_d1", Translation="uiR2EDnpc_ring_ranged_tank_blunt_d1"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_tank_blunt_d2", Translation="uiR2EDnpc_ring_ranged_tank_blunt_d2"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_tank_blunt_d3", Translation="uiR2EDnpc_ring_ranged_tank_blunt_d3"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_tank_blunt_d4", Translation="uiR2EDnpc_ring_ranged_tank_blunt_d4"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_tank_blunt_e1", Translation="uiR2EDnpc_ring_ranged_tank_blunt_e1"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_tank_blunt_e2", Translation="uiR2EDnpc_ring_ranged_tank_blunt_e2"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_tank_blunt_e3", Translation="uiR2EDnpc_ring_ranged_tank_blunt_e3"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_tank_blunt_e4", Translation="uiR2EDnpc_ring_ranged_tank_blunt_e4"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_tank_blunt_f1", Translation="uiR2EDnpc_ring_ranged_tank_blunt_f1"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_tank_blunt_f2", Translation="uiR2EDnpc_ring_ranged_tank_blunt_f2"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_tank_blunt_f3", Translation="uiR2EDnpc_ring_ranged_tank_blunt_f3"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_tank_blunt_f4", Translation="uiR2EDnpc_ring_ranged_tank_blunt_f4"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_tank_pierce_b1", Translation="uiR2EDnpc_ring_ranged_tank_pierce_b1"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_tank_pierce_b2", Translation="uiR2EDnpc_ring_ranged_tank_pierce_b2"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_tank_pierce_b3", Translation="uiR2EDnpc_ring_ranged_tank_pierce_b3"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_tank_pierce_b4", Translation="uiR2EDnpc_ring_ranged_tank_pierce_b4"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_tank_pierce_c1", Translation="uiR2EDnpc_ring_ranged_tank_pierce_c1"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_tank_pierce_c2", Translation="uiR2EDnpc_ring_ranged_tank_pierce_c2"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_tank_pierce_c3", Translation="uiR2EDnpc_ring_ranged_tank_pierce_c3"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_tank_pierce_c4", Translation="uiR2EDnpc_ring_ranged_tank_pierce_c4"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_tank_pierce_d1", Translation="uiR2EDnpc_ring_ranged_tank_pierce_d1"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_tank_pierce_d2", Translation="uiR2EDnpc_ring_ranged_tank_pierce_d2"},

--						{Id="palette.entities.npcs.bandits.ring_ranged_tank_pierce_d3", Translation="uiR2EDnpc_ring_ranged_tank_pierce_d3"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_tank_pierce_d4", Translation="uiR2EDnpc_ring_ranged_tank_pierce_d4"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_tank_pierce_e1", Translation="uiR2EDnpc_ring_ranged_tank_pierce_e1"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_tank_pierce_e2", Translation="uiR2EDnpc_ring_ranged_tank_pierce_e2"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_tank_pierce_e3", Translation="uiR2EDnpc_ring_ranged_tank_pierce_e3"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_tank_pierce_e4", Translation="uiR2EDnpc_ring_ranged_tank_pierce_e4"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_tank_pierce_f1", Translation="uiR2EDnpc_ring_ranged_tank_pierce_f1"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_tank_pierce_f2", Translation="uiR2EDnpc_ring_ranged_tank_pierce_f2"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_tank_pierce_f3", Translation="uiR2EDnpc_ring_ranged_tank_pierce_f3"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_tank_pierce_f4", Translation="uiR2EDnpc_ring_ranged_tank_pierce_f4"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_tank_slash_b1", Translation="uiR2EDnpc_ring_ranged_tank_slash_b1"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_tank_slash_b2", Translation="uiR2EDnpc_ring_ranged_tank_slash_b2"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_tank_slash_b3", Translation="uiR2EDnpc_ring_ranged_tank_slash_b3"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_tank_slash_b4", Translation="uiR2EDnpc_ring_ranged_tank_slash_b4"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_tank_slash_c1", Translation="uiR2EDnpc_ring_ranged_tank_slash_c1"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_tank_slash_c2", Translation="uiR2EDnpc_ring_ranged_tank_slash_c2"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_tank_slash_c3", Translation="uiR2EDnpc_ring_ranged_tank_slash_c3"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_tank_slash_c4", Translation="uiR2EDnpc_ring_ranged_tank_slash_c4"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_tank_slash_d1", Translation="uiR2EDnpc_ring_ranged_tank_slash_d1"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_tank_slash_d2", Translation="uiR2EDnpc_ring_ranged_tank_slash_d2"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_tank_slash_d3", Translation="uiR2EDnpc_ring_ranged_tank_slash_d3"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_tank_slash_d4", Translation="uiR2EDnpc_ring_ranged_tank_slash_d4"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_tank_slash_e1", Translation="uiR2EDnpc_ring_ranged_tank_slash_e1"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_tank_slash_e2", Translation="uiR2EDnpc_ring_ranged_tank_slash_e2"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_tank_slash_e3", Translation="uiR2EDnpc_ring_ranged_tank_slash_e3"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_tank_slash_e4", Translation="uiR2EDnpc_ring_ranged_tank_slash_e4"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_tank_slash_f1", Translation="uiR2EDnpc_ring_ranged_tank_slash_f1"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_tank_slash_f2", Translation="uiR2EDnpc_ring_ranged_tank_slash_f2"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_tank_slash_f3", Translation="uiR2EDnpc_ring_ranged_tank_slash_f3"},
--						{Id="palette.entities.npcs.bandits.ring_ranged_tank_slash_f4", Translation="uiR2EDnpc_ring_ranged_tank_slash_f4"}
--					}
--				}
			}
		},
	},
	
	BotEntries = 
	{	
		--botObjects =
		--{
			civilian_clutter =
			{
				instances = 
				{
					{Id="palette.entities.botobjects.jar", Translation="uiR2EDbotObjJar"},
					{Id="palette.entities.botobjects.jar_3", Translation="uiR2EDbotObjJar3"},
					{Id="palette.entities.botobjects.jar_fallen", Translation="uiR2EDbotObjJarFallen"},
					{Id="palette.entities.botobjects.barrel1", Translation="uiR2EDbotObjBarrel1"},
					{Id="palette.entities.botobjects.barrels_3", Translation="uiR2EDbotObjBarrels3"},
					{Id="palette.entities.botobjects.crate1", Translation="uiR2EDbotObjCrate1"},
					{Id="palette.entities.botobjects.crate2", Translation="uiR2EDbotObjCrate3"},
					{Id="palette.entities.botobjects.barrel_broken_1", Translation="uiR2EDbotObjBarrelBroken1"},
					{Id="palette.entities.botobjects.chest", Translation="uiR2EDbotObjChest"},
					{Id="palette.entities.botobjects.chest_old", Translation="uiR2EDbotObjChestOld"},
					{Id="palette.entities.botobjects.chariot", Translation="uiR2EDbotObjChariot"},
					{Id="palette.entities.botobjects.chariot_working", Translation="uiR2EDbotObjChariotWorking"},
					{Id="palette.entities.botobjects.campfire", Translation="uiR2EDbotObjCampFire"},
					{Id="palette.entities.botobjects.campfire_out", Translation="uiR2EDbotObjCampfireOut"},
					--{Id="palette.entities.botobjects.campfire_off", Translation="uiR2EDbotObjCampfireOff"},
					{Id="palette.entities.botobjects.counter", Translation="uiR2EDbotObjCounter"},
					{Id="palette.entities.botobjects.street_lamp", Translation="uiR2EDbotObjStreetLamp"},
					{Id="palette.entities.botobjects.street_lamp_off", Translation="uiR2EDbotObjStreetLampOff"},
					{Id="palette.entities.botobjects.fire_base", Translation="uiR2EDbotObjFireBase"},
					{Id="palette.entities.botobjects.flame_courage", Translation="uiR2EDbotObjflameCourage"},
					{Id="palette.entities.botobjects.flame_justice", Translation="uiR2EDbotObjflameJustice"},
					{Id="palette.entities.botobjects.flame_discipline", Translation="uiR2EDbotObjflameDiscipline"},
					{Id="palette.entities.botobjects.flame_verite", Translation="uiR2EDbotObjflameTruth"}
				}
			},

			graveyard_clutter =
			{
				instances = 
				{
					{Id="palette.entities.botobjects.tomb_1", Translation="uiR2EDbotObjTomb1"},
					{Id="palette.entities.botobjects.tomb_2", Translation="uiR2EDbotObjTomb2"},
					{Id="palette.entities.botobjects.tomb_3", Translation="uiR2EDbotObjTomb3"},
					{Id="palette.entities.botobjects.tomb_4", Translation="uiR2EDbotObjTomb4"},
					{Id="palette.entities.botobjects.tomb_5", Translation="uiR2EDbotObjTomb5"},
				}
			},

			bags_and_packs =
			{
				instances = 
				{
					{Id="palette.entities.botobjects.bag_a", Translation="uiR2EDbotObjBagA"},
					{Id="palette.entities.botobjects.bag_b", Translation="uiR2EDbotObjBagB"},
					{Id="palette.entities.botobjects.pack_1", Translation="uiR2EDbotObjPack1"},
					{Id="palette.entities.botobjects.pack_2", Translation="uiR2EDbotObjPack2"},
					{Id="palette.entities.botobjects.pack_3", Translation="uiR2EDbotObjPack3"},
					{Id="palette.entities.botobjects.pack_4", Translation="uiR2EDbotObjPack4"},
					{Id="palette.entities.botobjects.pack_5", Translation="uiR2EDbotObjPack5"}
				}
			},

			road_signs =
			{
				road_signs_fyros =
				{
					instances = 
					{
						{Id="palette.entities.botobjects.merchant_melee_fyros", Translation="uiR2EDbotObjMerchantMeleeFyros"},
						{Id="palette.entities.botobjects.merchant_range_fyros", Translation="uiR2EDbotObjMerchantRangeFyros"},
						{Id="palette.entities.botobjects.merchant_armor_fyros", Translation="uiR2EDbotObjMerchantArmorFyros"},
						{Id="palette.entities.botobjects.merchant_RM_fyros", Translation="uiR2EDbotObjMerchantRMFyros"},
						{Id="palette.entities.botobjects.merchant_tool_fyros", Translation="uiR2EDbotObjMerchantToolFyros"},
						{Id="palette.entities.botobjects.merchant_focus_fyros", Translation="uiR2EDbotObjMerchantFocusFyros"},
						{Id="palette.entities.botobjects.merchant_haircut_fyros", Translation="uiR2EDbotObjMerchantHaircutFyros"},
						{Id="palette.entities.botobjects.merchant_tatoo_fyros", Translation="uiR2EDbotObjMerchantTatooFyros"},
						{Id="palette.entities.botobjects.merchant_bijoux_fyros", Translation="uiR2EDbotObjMerchantBijouxFyros"},
					}
				},

				road_signs_matis =
				{
					instances = 
					{
						{Id="palette.entities.botobjects.merchant_melee_matis", Translation="uiR2EDbotObjMerchantMeleeMatis"},
						{Id="palette.entities.botobjects.merchant_range_matis", Translation="uiR2EDbotObjMerchantRangeMatis"},
						{Id="palette.entities.botobjects.merchant_armor_matis", Translation="uiR2EDbotObjMerchantArmorMatis"},
						{Id="palette.entities.botobjects.merchant_RM_matis", Translation="uiR2EDbotObjMerchantRMMatis"},
						{Id="palette.entities.botobjects.merchant_tool_matis", Translation="uiR2EDbotObjMerchantToolMatis"},
						{Id="palette.entities.botobjects.merchant_focus_matis", Translation="uiR2EDbotObjMerchantFocusMatis"},
						{Id="palette.entities.botobjects.merchant_haircut_matis", Translation="uiR2EDbotObjMerchantHaircutMatis"},
						{Id="palette.entities.botobjects.merchant_tatoo_matis", Translation="uiR2EDbotObjMerchantTatooMatis"},
						{Id="palette.entities.botobjects.merchant_bijoux_matis", Translation="uiR2EDbotObjMerchantBijouxMatis"},
						{Id="palette.entities.botobjects.merchant_bar_matis", Translation="uiR2EDbotObjMerchantBarMatis"},
						{Id="palette.entities.botobjects.fo_milestone", Translation="uiR2EDbotObjFoMilestone"},
					}
				},

				road_signs_tryker =
				{
					instances = 
					{
						{Id="palette.entities.botobjects.merchant_melee_tryker", Translation="uiR2EDbotObjMerchantMeleeTryker"},
						{Id="palette.entities.botobjects.merchant_range_tryker", Translation="uiR2EDbotObjMerchantRangeTryker"},
						{Id="palette.entities.botobjects.merchant_armor_tryker", Translation="uiR2EDbotObjMerchantArmorTryker"},
						{Id="palette.entities.botobjects.merchant_RM_tryker", Translation="uiR2EDbotObjMerchantRMTryker"},
						{Id="palette.entities.botobjects.merchant_tool_tryker", Translation="uiR2EDbotObjMerchantToolTryker"},
						{Id="palette.entities.botobjects.merchant_focus_tryker", Translation="uiR2EDbotObjMerchantFocusTryker"},
						{Id="palette.entities.botobjects.merchant_haircut_tryker", Translation="uiR2EDbotObjMerchantHaircutTryker"},
						{Id="palette.entities.botobjects.merchant_tatoo_tryker", Translation="uiR2EDbotObjMerchantTatooTryker"},
						{Id="palette.entities.botobjects.merchant_bijoux_tryker", Translation="uiR2EDbotObjMerchantBijouxTryker"},
					}
				},

				road_signs_zorai =
				{
					instances = 
					{
						{Id="palette.entities.botobjects.merchant_melee_zorai", Translation="uiR2EDbotObjMerchantMeleeZorai"},
						{Id="palette.entities.botobjects.merchant_range_zorai", Translation="uiR2EDbotObjMerchantRangeZorai"},
						{Id="palette.entities.botobjects.merchant_armor_zorai", Translation="uiR2EDbotObjMerchantArmorZorai"},
						{Id="palette.entities.botobjects.merchant_RM_zorai", Translation="uiR2EDbotObjMerchantRMZorai"},
						{Id="palette.entities.botobjects.merchant_tool_zorai", Translation="uiR2EDbotObjMerchantToolZorai"},
						{Id="palette.entities.botobjects.merchant_focus_zorai", Translation="uiR2EDbotObjMerchantFocusZorai"},
						{Id="palette.entities.botobjects.merchant_haircut_zorai", Translation="uiR2EDbotObjMerchantHaircutZorai"},
						{Id="palette.entities.botobjects.merchant_tatoo_zorai", Translation="uiR2EDbotObjMerchantTatooZorai"},
						{Id="palette.entities.botobjects.merchant_bijoux_zorai", Translation="uiR2EDbotObjMerchantBijouxZorai"},
						{Id="palette.entities.botobjects.merchant_bar_zorai", Translation="uiR2EDbotObjMerchantBarZorai"},
					}
				},

				road_signs_others =
				{
					instances = 
					{
						{Id="palette.entities.botobjects.roadsign", Translation="uiR2EDbotObjRoadsign"},
--						{Id="palette.entities.botobjects.roadsign_fyros", Translation="uiR2EDbotObjRoadsignFyros"},
--						{Id="palette.entities.botobjects.roadsign_zorai", Translation="uiR2EDbotObjRoadsignZorai"},
--						{Id="palette.entities.botobjects.roadsign_tryker", Translation="uiR2EDbotObjRoadsignTryker"},
						{Id="palette.entities.botobjects.milestone", Translation="uiR2EDbotObjMilestone"}
					}
				}
			},

			totems =
			{
				instances = 
				{
					{Id="palette.entities.botobjects.totem_pachyderm", Translation="uiR2EDbotObjTotemPachyderm"},
					{Id="palette.entities.botobjects.totem_kitin", Translation="uiR2EDbotObjTotemKitin"},
					{Id="palette.entities.botobjects.totem_bird", Translation="uiR2EDbotObjTotemBird"},
					{Id="palette.entities.botobjects.runic_circle", Translation="uiR2EDbotObjRunicCircle"}
				}
			},

			tents =
			{
				instances = 
				{
					{Id="palette.entities.botobjects.tent", Translation="uiR2EDbotObjTent"},
					{Id="palette.entities.botobjects.tent_fyros", Translation="uiR2EDbotObjTentFyros"},
					{Id="palette.entities.botobjects.tent_matis", Translation="uiR2EDbotObjTentMatis"},
					{Id="palette.entities.botobjects.tent_tryker", Translation="uiR2EDbotObjTentTryker"},
					{Id="palette.entities.botobjects.tent_zorai", Translation="uiR2EDbotObjTentZorai"},
					{Id="palette.entities.botobjects.tent_cosmetics", Translation="uiR2EDbotObjTentCosmetics"}
				}
			},

			buildings =
			{
				instances = 
				{
					{Id="palette.entities.botobjects.hut", Translation="uiR2EDbotObjHut"},
					{Id="palette.entities.botobjects.paddock", Translation="uiR2EDbotObjPaddock"},
					{Id="palette.entities.botobjects.stele", Translation="uiR2EDbotObjStele"},
					{Id="palette.entities.botobjects.wind_turbine", Translation="uiR2EDbotObjWindTurbine"},
					{Id="palette.entities.botobjects.watch_tower", Translation="uiR2EDbotObjWatchTower"},
					{Id="palette.entities.botobjects.hall_of_fame", Translation="uiR2EDbotObjHallOfFame"},
					{Id="palette.entities.botobjects.construction_site", Translation="uiR2EDbotObjConstructionSite"},
					{Id="palette.entities.botobjects.generic_hall", Translation="uiR2EDbotObjGenericHall"}
				}
			},

			ruins =
			{
				instances = 
				{
					{Id="palette.entities.botobjects.tower_ruin", Translation="uiR2EDbotObjTowerRuin"},
					{Id="palette.entities.botobjects.ruin_wall", Translation="uiR2EDbotObjRuinWall"},
					{Id="palette.entities.botobjects.ruin_wall_b", Translation="uiR2EDbotObjRuinWallB"},
					{Id="palette.entities.botobjects.house_ruin", Translation="uiR2EDbotObjHouseRuin"}
				}
			},

			kami =
			{
				instances = 
				{
					{Id="palette.entities.botobjects.banner_kami", Translation="uiR2EDbotObjBannerKami"},
					{Id="palette.entities.botobjects.totem_kami", Translation="uiR2EDbotObjTotemKami"},
					{Id="palette.entities.botobjects.kami_standard", Translation="uiR2EDbotObjKamiStandard"},
					{Id="palette.entities.botobjects.kami_hut", Translation="uiR2EDbotObjKamiHut"},
					{Id="palette.entities.botobjects.kami_watchtower", Translation="uiR2EDbotObjKamiWatchtower"},
					{Id="palette.entities.botobjects.vegetable_wall", Translation="uiR2EDbotObjVegetableWall"},
					{Id="palette.entities.botobjects.vegetable_gateway", Translation="uiR2EDbotObjVegetableGateway"},
--					{Id="palette.entities.botobjects.statue_maduk", Translation="uiR2EDbotObjStatueMaduk"},
					{Id="palette.entities.botobjects.kami_watchtower_off", Translation="uiR2EDbotObjKamiWatchtowerOff"},
--					{Id="palette.entities.botobjects.kami_altar", Translation="uiR2EDbotObjKamiAltar"}
				}
			},

			karavan =
			{
				instances = 
				{
					{Id="palette.entities.botobjects.banner_karavan", Translation="uiR2EDbotObjBannerKaravan"},
					{Id="palette.entities.botobjects.karavan_standard", Translation="uiR2EDbotObjKaravanStandard"},
					{Id="palette.entities.botobjects.karavan_tent", Translation="uiR2EDbotObjKaravanTent"},
					{Id="palette.entities.botobjects.karavan_big_wall", Translation="uiR2EDbotObjKaravanBigWall"},
					{Id="palette.entities.botobjects.karavan_wall", Translation="uiR2EDbotObjKaravanWall"},
--					{Id="palette.entities.botobjects.statue_jena", Translation="uiR2EDbotObjStatueJena"},
					{Id="palette.entities.botobjects.karavan_mirador", Translation="uiR2EDbotObjKaravanMirador"},
					{Id="palette.entities.botobjects.karavan_gateway", Translation="uiR2EDbotObjKaravanGateway"},
					{Id="palette.entities.botobjects.karavan_device", Translation="uiR2EDbotObjKaravanDevice"},
					{Id="palette.entities.botobjects.karavan_watchtower_off", Translation="uiR2EDbotObjKaravanWatchtowerOff"},
--					{Id="palette.entities.botobjects.karavan_altar", Translation="uiR2EDbotObjKaravanAltar"}
				}
			},

			kitin =
			{
				instances = 
				{
					{Id="palette.entities.botobjects.kitin_egg", Translation="uiR2EDbotObjKitinEgg"},
					{Id="palette.entities.botobjects.spot_kitin", Translation="uiR2EDbotObjSpotKitin"}
				}
			},

			goo =
			{
				instances = 
				{
					{Id="palette.entities.botobjects.spot_goo", Translation="uiR2EDbotObjSpotGoo"},
					{Id="palette.entities.botobjects.spot_goo_off", Translation="uiR2EDbotObjSpotGooOff"},
					{Id="palette.entities.botobjects.fx_goo_insect", Translation="uiR2EDbotObjFxGooInsect"},
					{Id="palette.entities.botobjects.fx_goo_mamal", Translation="uiR2EDbotObjFxGooMamal"},
					{Id="palette.entities.botobjects.fx_goo_smoke", Translation="uiR2EDbotObjFxGooSmoke"},
				}
			},

			obstacles =
			{
				instances = 
				{
					{Id="palette.entities.botobjects.stump", Translation="uiR2EDbotObjStump"},
					{Id="palette.entities.botobjects.landslide_desert", Translation="uiR2EDbotObjLandslideDesert"},
					{Id="palette.entities.botobjects.landslide_jungle", Translation="uiR2EDbotObjLandslideJungle"},
					{Id="palette.entities.botobjects.landslide_lake", Translation="uiR2EDbotObjLandslideLake"},
					{Id="palette.entities.botobjects.barrier", Translation="uiR2EDbotObjBarrier"},
					{Id="palette.entities.botobjects.barrier_T", Translation="uiR2EDbotObjBarrierT"}
				}
			},

			carcasses =
			{
				instances = 
				{
					{Id="palette.entities.botobjects.carrion_mammal", Translation="uiR2EDbotObjCarrionMammal"},
					{Id="palette.entities.botobjects.carrion_insect", Translation="uiR2EDbotObjCarrionInsect"},
					{Id="palette.entities.botobjects.giant_skull", Translation="uiR2EDbotObjGiantSkull"},
					{Id="palette.entities.botobjects.carapace_bul", Translation="uiR2EDbotObjCarapaceBul"},
					{Id="palette.entities.botobjects.carapace_2", Translation="uiR2EDbotObjCarapace2"},
					{Id="palette.entities.botobjects.bones", Translation="uiR2EDbotObjBones"},
					{Id="palette.entities.botobjects.bones_b", Translation="uiR2EDbotObjBonesB"}
				}
			},

			fytrees =
			{
				instances =
				{
					{Id="palette.entities.botobjects.fy_s1_baobab_a", Translation="uiR2EDbotObjTreeFyBaobabA"},
					{Id="palette.entities.botobjects.fy_s1_baobab_b", Translation="uiR2EDbotObjTreeFyBaobabB"},
					{Id="palette.entities.botobjects.fy_s1_baobab_c", Translation="uiR2EDbotObjTreeFyBaobabC"},
					{Id="palette.entities.botobjects.fy_s1_burnedtree_a", Translation="uiR2EDbotObjTreeFyBurnedTreeA"},
					{Id="palette.entities.botobjects.fy_s1_burnedtree_b", Translation="uiR2EDbotObjTreeFyBurnedTreeB"},
					{Id="palette.entities.botobjects.fy_s1_burnedtree_c", Translation="uiR2EDbotObjTreeFyBurnedTreeC"},
					{Id="palette.entities.botobjects.fy_s1_burnedtree_d", Translation="uiR2EDbotObjTreeFyBurnedTreeD"},
					{Id="palette.entities.botobjects.fy_s1_burnedtree_growth_a", Translation="uiR2EDbotObjTreeFyBurnedTreeGrowthA"},
					{Id="palette.entities.botobjects.fy_s1_burnedtree_growth_b", Translation="uiR2EDbotObjTreeFyBurnedTreeGrowthB"},
					{Id="palette.entities.botobjects.fy_s2_coconuts_a", Translation="uiR2EDbotObjTreeFyCoconutsA"},
					{Id="palette.entities.botobjects.fy_s2_coconuts_b", Translation="uiR2EDbotObjTreeFyCoconutsB"},
					{Id="palette.entities.botobjects.fy_s2_lovejail_a", Translation="uiR2EDbotObjTreeFyLoveJailA"},
					{Id="palette.entities.botobjects.fy_s2_lovejail_b", Translation="uiR2EDbotObjTreeFyLoveJailB"},
					{Id="palette.entities.botobjects.fy_s2_lovejail_c", Translation="uiR2EDbotObjTreeFyLoveJailC"},
					{Id="palette.entities.botobjects.fy_s2_palmtree_a", Translation="uiR2EDbotObjTreeFyPalmTreeA"},
					{Id="palette.entities.botobjects.fy_s2_palmtree_b", Translation="uiR2EDbotObjTreeFyPalmTreeB"},
					{Id="palette.entities.botobjects.fy_s2_palmtree_c", Translation="uiR2EDbotObjTreeFyPalmTreeC"},
					{Id="palette.entities.botobjects.fy_s2_palmtree_d", Translation="uiR2EDbotObjTreeFyPalmTreeD"},
					{Id="palette.entities.botobjects.fy_s2_palmtree_e", Translation="uiR2EDbotObjTreeFyPalmTreeE"},
					{Id="palette.entities.botobjects.fy_s2_papaleaf_a", Translation="uiR2EDbotObjTreeFyPapaLeafA"},
					{Id="palette.entities.botobjects.fy_s2_papaleaf_b", Translation="uiR2EDbotObjTreeFyPapaLeafB"},
					{Id="palette.entities.botobjects.fy_s2_savantree_a", Translation="uiR2EDbotObjTreeFySavanTreeA"},
					{Id="palette.entities.botobjects.fy_s2_savantree_b", Translation="uiR2EDbotObjTreeFySavanTreeB"},
					{Id="palette.entities.botobjects.fy_s2_savantree_c", Translation="uiR2EDbotObjTreeFySavanTreeC"},
					{Id="palette.entities.botobjects.fy_s3_termitiere_a", Translation="uiR2EDbotObjTreeFyTermitiereA"},
					{Id="palette.entities.botobjects.fy_s3_termitiere_b", Translation="uiR2EDbotObjTreeFyTermitiereB"},
					{Id="palette.entities.botobjects.fy_s3_termitiere_c", Translation="uiR2EDbotObjTreeFyTermitiereC"},
					{Id="palette.entities.botobjects.fy_s3_termitiere_d", Translation="uiR2EDbotObjTreeFyTermitiereD"}
				}
			},

			fotrees =
			{
				instances =
				{
					{Id="palette.entities.botobjects.fo_s1_arbragrelot", Translation="uiR2EDbotObjTreeFoArbraGrelotA"},
					{Id="palette.entities.botobjects.fo_s1_arbreagrelot", Translation="uiR2EDbotObjTreeFoArbraGrelotB"},
					{Id="palette.entities.botobjects.fo_s1_giant_tree", Translation="uiR2EDbotObjTreeFoGiantTree"},
					{Id="palette.entities.botobjects.fo_s1_giant_trunk", Translation="uiR2EDbotObjTreeFoGiantTrunk"},
					{Id="palette.entities.botobjects.fo_s2_arbragrelot", Translation="uiR2EDbotObjTreeFoArbraGrelotC"},
					{Id="palette.entities.botobjects.fo_s2_bigroot_a", Translation="uiR2EDbotObjTreeFoBigRootA"},
					{Id="palette.entities.botobjects.fo_s2_bigroot_b", Translation="uiR2EDbotObjTreeFoBigRootB"},
					{Id="palette.entities.botobjects.fo_s2_bigroot_c", Translation="uiR2EDbotObjTreeFoBigRootC"},
					{Id="palette.entities.botobjects.fo_s2_big_tree", Translation="uiR2EDbotObjTreeFoBigTree"},
					{Id="palette.entities.botobjects.fo_s2_birch", Translation="uiR2EDbotObjTreeFoBirchA"},
					{Id="palette.entities.botobjects.fo_s2_spiketree", Translation="uiR2EDbotObjTreeFoSpikeTree"},
					{Id="palette.entities.botobjects.fo_s3_birch", Translation="uiR2EDbotObjTreeFoBirchB"},
					{Id="palette.entities.botobjects.fo_s3_buissonaepine", Translation="uiR2EDbotObjTreeFoThornBush"},
					{Id="palette.entities.botobjects.fo_s3_champignou_a", Translation="uiR2EDbotObjTreeFoMushroomA"},
					{Id="palette.entities.botobjects.fo_s3_champignou_b", Translation="uiR2EDbotObjTreeFoMushroomB"},
					{Id="palette.entities.botobjects.fo_s3_fougere", Translation="uiR2EDbotObjTreeFoFern"},
--					{Id="palette.entities.botobjects.fo_s3_tree", Translation="uiR2EDbotObjTreeFoTree"}
				}
			},

			jutrees =
			{
				instances =
				{
					{Id="palette.entities.botobjects.ju_s1_bamboo", Translation="uiR2EDbotObjTreeJuBambooA"},
					{Id="palette.entities.botobjects.ju_s1_canopy_tree", Translation="uiR2EDbotObjTreeJuCanopyTree"},
					{Id="palette.entities.botobjects.ju_s2_big_tree", Translation="uiR2EDbotObjTreeJuBigTree"},
					{Id="palette.entities.botobjects.ju_s2_young_tree", Translation="uiR2EDbotObjTreeJuYoungTree"},
					{Id="palette.entities.botobjects.ju_s3_bamboo", Translation="uiR2EDbotObjTreeJuBambooB"},
					{Id="palette.entities.botobjects.ju_s3_banana_tree", Translation="uiR2EDbotObjTreeJuBananaTree"},
					{Id="palette.entities.botobjects.ju_s3_bush_tree", Translation="uiR2EDbotObjTreeJuBushTree"},
					{Id="palette.entities.botobjects.ju_s3_dead_tree", Translation="uiR2EDbotObjTreeJuDeadTree"},
					{Id="palette.entities.botobjects.ju_s3_fantree", Translation="uiR2EDbotObjTreeJuFanTree"},
					{Id="palette.entities.botobjects.ju_s3_fougere", Translation="uiR2EDbotObjTreeJuFern"},
					{Id="palette.entities.botobjects.ju_s3_plante", Translation="uiR2EDbotObjTreeJuPlant"},
					{Id="palette.entities.botobjects.ju_s3_plantegrasse", Translation="uiR2EDbotObjTreeJuFatPlant"},
					{Id="palette.entities.botobjects.ju_s3_tree", Translation="uiR2EDbotObjTreeJuTree"}
				}
			},

			trtrees =
			{
				instances =
				{
					{Id="palette.entities.botobjects.tr_s1_bamboo_a", Translation="uiR2EDbotObjTreeTrBambooA"},
--					{Id="palette.entities.botobjects.tr_s1_kelp_a", Translation="uiR2EDbotObjTreeTrKelpA"},
--					{Id="palette.entities.botobjects.tr_s1_kelp_b", Translation="uiR2EDbotObjTreeTrKelpB"},
					{Id="palette.entities.botobjects.tr_s2_bamboo_a", Translation="uiR2EDbotObjTreeTrBambooB"},
--					{Id="palette.entities.botobjects.tr_s2_champiflot_a", Translation="uiR2EDbotObjTreeTrFloatMush"},
					{Id="palette.entities.botobjects.tr_s2_lokness_a", Translation="uiR2EDbotObjTreeTrLoknessA"},
					{Id="palette.entities.botobjects.tr_s2_lokness_b", Translation="uiR2EDbotObjTreeTrLoknessB"},
					{Id="palette.entities.botobjects.tr_s2_lokness_c", Translation="uiR2EDbotObjTreeTrLoknessC"},
					{Id="palette.entities.botobjects.tr_s2_mangrove_a", Translation="uiR2EDbotObjTreeTrMangroveA"},
					{Id="palette.entities.botobjects.tr_s2_mangrove_b", Translation="uiR2EDbotObjTreeTrMangroveB"},
					{Id="palette.entities.botobjects.tr_s2_nenufly_a", Translation="uiR2EDbotObjTreeTrNenuflyA"},
					{Id="palette.entities.botobjects.tr_s2_palmtree_a", Translation="uiR2EDbotObjTreeTrPalmTreeA"},
					{Id="palette.entities.botobjects.tr_s2_palmtree_b", Translation="uiR2EDbotObjTreeTrPalmTreeB"},
					{Id="palette.entities.botobjects.tr_s2_palmtree_c", Translation="uiR2EDbotObjTreeTrPalmTreeC"},
					{Id="palette.entities.botobjects.tr_s2_palmtree_d", Translation="uiR2EDbotObjTreeTrPalmTreeD"},
					{Id="palette.entities.botobjects.tr_s2_palmtree_e", Translation="uiR2EDbotObjTreeTrPalmTreeE"},
					{Id="palette.entities.botobjects.tr_s2_palmtree_f", Translation="uiR2EDbotObjTreeTrPalmTreeF"},
--					{Id="palette.entities.botobjects.tr_s2_sailtree_a", Translation="uiR2EDbotObjTreeTrSailTree"},
--					{Id="palette.entities.botobjects.tr_s2_wigweed_a", Translation="uiR2EDbotObjTreeTrWigWeed"},
--					{Id="palette.entities.botobjects.tr_s3_aquabole_a", Translation="uiR2EDbotObjTreeTrAquaBoleA"},
--					{Id="palette.entities.botobjects.tr_s3_aquabole_b", Translation="uiR2EDbotObjTreeTrAquaBoleB"},
--					{Id="palette.entities.botobjects.tr_s3_aquafeather_a", Translation="uiR2EDbotObjTreeTrAquaFeatherA"},
--					{Id="palette.entities.botobjects.tr_s3_aquafeather_b", Translation="uiR2EDbotObjTreeTrAquaFeatherB"},
--					{Id="palette.entities.botobjects.tr_s3_aquafeather_c", Translation="uiR2EDbotObjTreeTrAquaFeatherC"},
--					{Id="palette.entities.botobjects.tr_s3_flower_a", Translation="uiR2EDbotObjTreeTrFlowerA"},
--					{Id="palette.entities.botobjects.tr_s3_flower_b", Translation="uiR2EDbotObjTreeTrFlowerB"},
--					{Id="palette.entities.botobjects.tr_s3_flower_c", Translation="uiR2EDbotObjTreeTrFlowerC"},
					{Id="palette.entities.botobjects.tr_s3_nenufly_b", Translation="uiR2EDbotObjTreeTrNenuflyB"},
					{Id="palette.entities.botobjects.tr_s3_trumpet_a", Translation="uiR2EDbotObjTreeTrTrumpetA"},
					{Id="palette.entities.botobjects.tr_s3_trumpet_b", Translation="uiR2EDbotObjTreeTrTrumpetB"},
					{Id="palette.entities.botobjects.tr_s3_trumpet_c", Translation="uiR2EDbotObjTreeTrTrumpetC"},
					{Id="palette.entities.botobjects.tr_s3_trumpet_d", Translation="uiR2EDbotObjTreeTrTrumpetD"}
				}
			},

			prtrees =
			{
				instances =
				{
					{Id="palette.entities.botobjects.pr_s1_lumiseed_a", Translation="uiR2EDbotObjTreePrLumiseedA"},
					{Id="palette.entities.botobjects.pr_s1_lumiseed_b", Translation="uiR2EDbotObjTreePrLumiseedB"},
					{Id="palette.entities.botobjects.pr_s1_lumiseed_c", Translation="uiR2EDbotObjTreePrLumiseedC"},
					{Id="palette.entities.botobjects.pr_s1_lumiseed_d", Translation="uiR2EDbotObjTreePrLumiseedD"},
					{Id="palette.entities.botobjects.pr_s1_rotaflore_a", Translation="uiR2EDbotObjTreePrRotaFloreA"},
					{Id="palette.entities.botobjects.pr_s1_rotaflore_b", Translation="uiR2EDbotObjTreePrRotaFloreB"},
					{Id="palette.entities.botobjects.pr_s1_rotaflore_c", Translation="uiR2EDbotObjTreePrRotaFloreC"},
					{Id="palette.entities.botobjects.pr_s2_mycotree_a", Translation="uiR2EDbotObjTreePrMycotreeA"},
					{Id="palette.entities.botobjects.pr_s2_mycotree_b", Translation="uiR2EDbotObjTreePrMycotreeB"},
					{Id="palette.entities.botobjects.pr_s2_planipushes_a", Translation="uiR2EDbotObjTreePrPlanipushesA"},
					{Id="palette.entities.botobjects.pr_s2_planipushes_b", Translation="uiR2EDbotObjTreePrPlanipushesB"},
					{Id="palette.entities.botobjects.pr_s2_planipushes_c", Translation="uiR2EDbotObjTreePrPlanipushesC"},
					{Id="palette.entities.botobjects.pr_s2_planipushes_d", Translation="uiR2EDbotObjTreePrPlanipushesD"},
					{Id="palette.entities.botobjects.pr_s2_toopetz_a", Translation="uiR2EDbotObjTreePrToopetzA"},
					{Id="palette.entities.botobjects.pr_s2_toopetz_b", Translation="uiR2EDbotObjTreePrToopetzB"},
					{Id="palette.entities.botobjects.pr_s2_toopetz_c", Translation="uiR2EDbotObjTreePrToopetzC"},
					{Id="palette.entities.botobjects.pr_s3_amoeba_a", Translation="uiR2EDbotObjTreePrAmoebaA"},
					{Id="palette.entities.botobjects.pr_s3_amoeba_b", Translation="uiR2EDbotObjTreePrAmoebaB"},
					{Id="palette.entities.botobjects.pr_s3_amoeba_c", Translation="uiR2EDbotObjTreePrAmoebaC"},
					{Id="palette.entities.botobjects.pr_s3_cokamool_a", Translation="uiR2EDbotObjTreePrCokamoolA"},
					{Id="palette.entities.botobjects.pr_s3_cokamool_b", Translation="uiR2EDbotObjTreePrCokamoolB"},
					{Id="palette.entities.botobjects.pr_s3_cokamool_c", Translation="uiR2EDbotObjTreePrCokamoolC"},
					{Id="palette.entities.botobjects.pr_s3_ploomweed_a", Translation="uiR2EDbotObjTreePrPloomWeedA"},
					{Id="palette.entities.botobjects.pr_s3_ploomweed_b", Translation="uiR2EDbotObjTreePrPloomWeedB"},
					{Id="palette.entities.botobjects.pr_s3_small_lumiseed_a", Translation="uiR2EDbotObjTreePrSmallLumiseedA"},
					{Id="palette.entities.botobjects.pr_s3_small_lumiseed_b", Translation="uiR2EDbotObjTreePrSmallLumiseedB"}
				}
			},

			enveffects =
			{
				instances =
				{
--					{Id="palette.entities.botobjects.fxy_canyon", Translation="uiR2EDbotObjFxCanyon"},
--					{Id="palette.entities.botobjects.fx_desert_sandblasta", Translation="uiR2EDbotObjFxSandblastA"},
--					{Id="palette.entities.botobjects.fx_desert_sandblastb", Translation="uiR2EDbotObjFxSandblastB"},
--					{Id="palette.entities.botobjects.fx_de_firewave", Translation="uiR2EDbotObjFxFirewave"},
--					{Id="palette.entities.botobjects.fx_de_geyser", Translation="uiR2EDbotObjFxGeyser"},
--					{Id="palette.entities.botobjects.fx_de_geyser_fumee", Translation="uiR2EDbotObjFxGeyserFumee"},
					{Id="palette.entities.botobjects.fx_de_vapeurs", Translation="uiR2EDbotObjFxVapeurs"},
					{Id="palette.entities.botobjects.fx_fo_pollen", Translation="uiR2EDbotObjFxPollen"},
					{Id="palette.entities.botobjects.fx_fo_solbirtha", Translation="uiR2EDbotObjFxFoSolbirthA"},
					{Id="palette.entities.botobjects.fx_fo_solbirthb", Translation="uiR2EDbotObjFxFoSolbirthB"},
					{Id="palette.entities.botobjects.fx_fo_solbirthc", Translation="uiR2EDbotObjFxFoSolbirthC"},
--					{Id="palette.entities.botobjects.fx_fo_treefalla", Translation="uiR2EDbotObjFxFoTreeFallA"},
--					{Id="palette.entities.botobjects.fx_fo_treefallb", Translation="uiR2EDbotObjFxFoTreeFallB"},
--					{Id="palette.entities.botobjects.fx_fo_treefallc", Translation="uiR2EDbotObjFxFoTreeFallC"},
--					{Id="palette.entities.botobjects.fx_fo_treefalld", Translation="uiR2EDbotObjFxFoTreeFallD"},
--					{Id="palette.entities.botobjects.fx_fo_treefalle", Translation="uiR2EDbotObjFxFoTreeFallE"},
--					{Id="palette.entities.botobjects.fx_fo_flower", Translation="uiR2EDbotObjFxFoFlower"},
					{Id="palette.entities.botobjects.fx_fo_pollen2", Translation="uiR2EDbotObjFxPollen2"},
--					{Id="palette.entities.botobjects.fx_fy_sandblastadesert", Translation="uiR2EDbotObjFxSandblastaDesert"},
--					{Id="palette.entities.botobjects.fx_fy_sandblastdesert", Translation="uiR2EDbotObjFxSandblastDesert"},
					{Id="palette.entities.botobjects.fx_fy_feu_foret", Translation="uiR2EDbotObjFxFeuForet"},
--					{Id="palette.entities.botobjects.fx_fy_flower", Translation="uiR2EDbotObjFxDeFlower"},
--					{Id="palette.entities.botobjects.fx_ju_ghosta", Translation="uiR2EDbotObjFxGhostA"},
--					{Id="palette.entities.botobjects.fx_ju_ghostb", Translation="uiR2EDbotObjFxGhostB"},
					{Id="palette.entities.botobjects.fx_ju_solbirtha", Translation="uiR2EDbotObjFxJuSolbirthA"},
					{Id="palette.entities.botobjects.fx_ju_solbirthb", Translation="uiR2EDbotObjFxJuSolbirthB"},
					{Id="palette.entities.botobjects.fx_ju_solbirthc", Translation="uiR2EDbotObjFxJuSolbirthC"},
					{Id="palette.entities.botobjects.fx_ju_solbirthd", Translation="uiR2EDbotObjFxJuSolbirthD"},
--					{Id="palette.entities.botobjects.fx_ju_treefalla", Translation="uiR2EDbotObjFxJuTreeFallA"},
--					{Id="palette.entities.botobjects.fx_ju_treefallb", Translation="uiR2EDbotObjFxJuTreeFallB"},
--					{Id="palette.entities.botobjects.fx_ju_treefallc", Translation="uiR2EDbotObjFxJuTreeFallC"},
--					{Id="palette.entities.botobjects.fx_ju_treefalld", Translation="uiR2EDbotObjFxJuTreeFallD"},
					{Id="palette.entities.botobjects.fx_ju_brumes", Translation="uiR2EDbotObjFxBrumes"},
					{Id="palette.entities.botobjects.fx_fo_brumes", Translation="uiR2EDbotObjFxBrumes"},
					{Id="palette.entities.botobjects.fx_ju_brumesb", Translation="uiR2EDbotObjFxBrumesB"},
					{Id="palette.entities.botobjects.fx_fo_brumesb", Translation="uiR2EDbotObjFxBrumesB"},
--					{Id="palette.entities.botobjects.fx_ju_geyser4a", Translation="uiR2EDbotObjFxGeyser4A"},
--					{Id="palette.entities.botobjects.fx_fo_geyser4a", Translation="uiR2EDbotObjFxGeyser4A"},
--					{Id="palette.entities.botobjects.fx_ju_geyser4b", Translation="uiR2EDbotObjFxGeyser4B"},
--					{Id="palette.entities.botobjects.fx_fo_geyser4b", Translation="uiR2EDbotObjFxGeyser4B"},
--					{Id="palette.entities.botobjects.fx_ju_geyser4c", Translation="uiR2EDbotObjFxGeyser4C"},
--					{Id="palette.entities.botobjects.fx_fo_geyser4c", Translation="uiR2EDbotObjFxGeyser4C"},
--					{Id="palette.entities.botobjects.fx_ju_vent", Translation="uiR2EDbotObjFxJuFoVent"},
--					{Id="palette.entities.botobjects.fx_fo_vent", Translation="uiR2EDbotObjFxJuFoVent"},
--					{Id="palette.entities.botobjects.fx_la_vent", Translation="uiR2EDbotObjFxLaVent"},
					{Id="palette.entities.botobjects.fx_tr_pollen", Translation="uiR2EDbotObjFxTrPollen"}
				}
			},
			
			minilife =
			{
				instances =
				{
--					{Id="palette.entities.botobjects.fx_fishe", Translation="uiR2EDbotObjFxFishe"},
             		{Id="palette.entities.botobjects.fxy_cricketa", Translation="uiR2EDbotObjFxCricketA"},
             		{Id="palette.entities.botobjects.fx_de_birda", Translation="uiR2EDbotObjFxBirdA"},
--					{Id="palette.entities.botobjects.fx_de_fishes", Translation="uiR2EDbotObjFxDeFishes"},
--					{Id="palette.entities.botobjects.fx_de_krevette", Translation="uiR2EDbotObjFxKrevette"},
--					{Id="palette.entities.botobjects.fx_de_scorpion2", Translation="uiR2EDbotObjFxDeScorpion2"},
--					{Id="palette.entities.botobjects.fx_de_serpent", Translation="uiR2EDbotObjFxDeSerpent"},
--					{Id="palette.entities.botobjects.fx_de_ver", Translation="uiR2EDbotObjFxVer"},
--					{Id="palette.entities.botobjects.fx_de_waterserpent", Translation="uiR2EDbotObjFxWaterSerpent"},
					{Id="palette.entities.botobjects.fx_fo_bugsa", Translation="uiR2EDbotObjFxFoBugsA"},
					{Id="palette.entities.botobjects.fx_fo_bugsb", Translation="uiR2EDbotObjFxFoBugsB"},
					{Id="palette.entities.botobjects.fx_fo_bugsc", Translation="uiR2EDbotObjFxFoBugsC"},
					{Id="palette.entities.botobjects.fx_fo_colibrisb", Translation="uiR2EDbotObjFxColibrisB"},
					{Id="palette.entities.botobjects.fx_ju_colibrisb", Translation="uiR2EDbotObjFxColibrisB"},
--					{Id="palette.entities.botobjects.fx_fo_fishes", Translation="uiR2EDbotObjFxFoFishes"},
--					{Id="palette.entities.botobjects.fx_fo_serpent", Translation="uiR2EDbotObjFxFoJuSerpent"},
--					{Id="palette.entities.botobjects.fx_ju_serpent", Translation="uiR2EDbotObjFxFoJuSerpent"},
--					{Id="palette.entities.botobjects.fx_fyros_de_scorpion", Translation="uiR2EDbotObjFxScorpion"},
					{Id="palette.entities.botobjects.fx_ju_bata", Translation="uiR2EDbotObjFxBatA"},
					{Id="palette.entities.botobjects.fx_ju_bugsa", Translation="uiR2EDbotObjFxJuBugsA"},
					{Id="palette.entities.botobjects.fx_ju_bugsb", Translation="uiR2EDbotObjFxJuBugsB"},
					{Id="palette.entities.botobjects.fx_ju_dragonflya", Translation="uiR2EDbotObjFxDragonfly"},
--					{Id="palette.entities.botobjects.fx_ju_bibubirdb", Translation="uiR2EDbotObjFxBibubirdB"},
--					{Id="palette.entities.botobjects.fx_fo_bibubirdb", Translation="uiR2EDbotObjFxBibubirdB"},
					{Id="palette.entities.botobjects.fx_ju_birds", Translation="uiR2EDbotObjFxBirds"},
					{Id="palette.entities.botobjects.fx_fo_birds", Translation="uiR2EDbotObjFxBirds"},
--					{Id="palette.entities.botobjects.fx_ju_birdsb", Translation="uiR2EDbotObjFxBirdsB"},
--					{Id="palette.entities.botobjects.fx_fo_birdsb", Translation="uiR2EDbotObjFxBirdsB"},
--					{Id="palette.entities.botobjects.fx_ju_birdsc", Translation="uiR2EDbotObjFxBirdsC"},
--					{Id="palette.entities.botobjects.fx_fo_birdsc", Translation="uiR2EDbotObjFxBirdsC"},
--					{Id="palette.entities.botobjects.fx_ju_fee", Translation="uiR2EDbotObjFxFee"},
--					{Id="palette.entities.botobjects.fx_fo_fee", Translation="uiR2EDbotObjFxFee"},
--					{Id="palette.entities.botobjects.fx_ju_grenouille3", Translation="uiR2EDbotObjFxGrenouille3"},
--					{Id="palette.entities.botobjects.fx_fo_grenouille3", Translation="uiR2EDbotObjFxGrenouille3"},
--					{Id="palette.entities.botobjects.fx_ju_grenouilleb3", Translation="uiR2EDbotObjFxGrenouille3B"},
--					{Id="palette.entities.botobjects.fx_fo_grenouilleb3", Translation="uiR2EDbotObjFxGrenouille3B"},
					{Id="palette.entities.botobjects.fx_ju_grenouillec3", Translation="uiR2EDbotObjFxGrenouille3C"},
					{Id="palette.entities.botobjects.fx_fo_grenouillec3", Translation="uiR2EDbotObjFxGrenouille3C"},
--					{Id="palette.entities.botobjects.fx_ju_ratsc", Translation="uiR2EDbotObjFxRatsC"},
--					{Id="palette.entities.botobjects.fx_fo_ratsc", Translation="uiR2EDbotObjFxRatsC"},
					{Id="palette.entities.botobjects.fx_ju_rotasecte", Translation="uiR2EDbotObjFxRotasecte"},
					{Id="palette.entities.botobjects.fx_fo_rotasecte", Translation="uiR2EDbotObjFxRotasecte"},
					{Id="palette.entities.botobjects.fx_ju_rotasecteb", Translation="uiR2EDbotObjFxRotasecteB"},
					{Id="palette.entities.botobjects.fx_fo_rotasecteb", Translation="uiR2EDbotObjFxRotasecteB"},
--					{Id="palette.entities.botobjects.fx_ju_scorpion2", Translation="uiR2EDbotObjFxJuFoScorpion2"},
--					{Id="palette.entities.botobjects.fx_fo_scorpion2", Translation="uiR2EDbotObjFxJuFoScorpion2"},
--					{Id="palette.entities.botobjects.fx_ju_taupe", Translation="uiR2EDbotObjFxFoTaupe"},
--					{Id="palette.entities.botobjects.fx_fo_taupe", Translation="uiR2EDbotObjFxFoTaupe"},
--					{Id="palette.entities.botobjects.fx_la_birds", Translation="uiR2EDbotObjFxLaBirds"},
--					{Id="palette.entities.botobjects.fx_la_birdsb", Translation="uiR2EDbotObjFxLaBirdsB"},
--					{Id="palette.entities.botobjects.fx_la_serpent", Translation="uiR2EDbotObjFxLaSerpent"},
--					{Id="palette.entities.botobjects.fx_la_serpent_sub", Translation="uiR2EDbotObjFxLaSerpentSub"},
--					{Id="palette.entities.botobjects.fx_la_taupe", Translation="uiR2EDbotObjFxLaTaupe"},
--					{Id="palette.entities.botobjects.fx_ju_bibubirdb", Translation="uiR2EDbotObjFxBibubirdB2"},
--					{Id="palette.entities.botobjects.fx_fo_bibubirdb", Translation="uiR2EDbotObjFxBibubirdB2"},
-- same				{Id="palette.entities.botobjects.fx_matis_ju_fo_grenouillec3", Translation="uiR2EDbotObjFxGrenouilleC3"},
					{Id="palette.entities.botobjects.fx_tr_colibris", Translation="uiR2EDbotObjFxTrColibris"},
					{Id="palette.entities.botobjects.fx_tr_cricket_aqua", Translation="uiR2EDbotObjFxCricketAqua"},
					{Id="palette.entities.botobjects.fx_tr_dragonflya", Translation="uiR2EDbotObjFxTrDragonflyA"},
					{Id="palette.entities.botobjects.fx_tr_dragonflyb", Translation="uiR2EDbotObjFxTrDragonflyB"},
--					{Id="palette.entities.botobjects.fx_tr_fishes", Translation="uiR2EDbotObjFxTrFishes"},
--					{Id="palette.entities.botobjects.fx_tr_fishesb", Translation="uiR2EDbotObjFxTrFishesB"},
--					{Id="palette.entities.botobjects.fx_tr_fishesc", Translation="uiR2EDbotObjFxTrFishesC"},
--					{Id="palette.entities.botobjects.fx_tr_serpent", Translation="uiR2EDbotObjFxTrSerpent"},
				}
			}
		--}
	}
}


r2.PaletteIdToTranslation = {} -- maps each palette id to its translation, filled at build time by r2_ui_palette.lua
							   -- this table may be access by C++ to give a name to newinstances created by user
r2.PaletteIdToGroupTranslation = {}  -- the same thing for group of NPC

r2.PaletteIdToType = {}

-- add test entries for levels

if r2.Config.TestPaletteSelection then
--	 TMP for nico test
	r2.Palette.Entries.selection_test = 
	{
		instances = {}
	}
	for ecosystem = 1, 4 do
		for level = 1, 250, levelStep do
			table.insert(r2.Palette.Entries.selection_test.instances, { Id=formatSelectionTextName(level, ecosystem), DirectName="fyros level " .. formatLevel(level) .. ", ecosystem = " ..  ecosystemTable[ecosystem]})
		end
	end
end



